/* server.c generated by valac 0.56.14, the Vala compiler
 * generated from server.vala, do not modify */

/* server.vala
 *
 * Copyright 2017-2019 Ben Iofel <ben@iofel.me>
 * Copyright 2017-2020 Princeton Ferro <princetonferro@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#if !defined VALA_STRICT_C && defined __GNUC__ && __GNUC__ >= 14
#pragma GCC diagnostic warning "-Wimplicit-function-declaration"
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#pragma GCC diagnostic warning "-Wint-conversion"
#pragma GCC diagnostic warning "-Wreturn-mismatch"
#endif

#include <jsonrpc-glib.h>
#include <glib-object.h>
#include <glib.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <unistd.h>
#include <gio/gunixinputstream.h>
#include <gio/gunixoutputstream.h>
#include <glib-unix.h>
#include <stdarg.h>
#include <vala.h>
#include <valagee.h>
#include <json-glib/json-glib.h>
#include <signal.h>
#include <stdio.h>

#define VLS_SERVER_check_update_context_period_ms ((guint) 100)
#define VLS_SERVER_update_context_delay_inc_us ((gint64) (500 * 1000))
#define VLS_SERVER_update_context_delay_max_us ((gint64) (1000 * 1000))
#define VLS_SERVER_wait_for_context_update_delay_ms ((guint) 200)
#define CONFIG_PROJECT_VERSION "0.48.7"
#define CONFIG_PROJECT_BUGSITE "https://github.com/vala-lang/vala-language-server/issues"
#define CONFIG_PROJECT_NAME "vala-language-server"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define VLS_TYPE_SERVER (vls_server_get_type ())
#define VLS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SERVER, VlsServer))
#define VLS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SERVER, VlsServerClass))
#define VLS_IS_SERVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SERVER))
#define VLS_IS_SERVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SERVER))
#define VLS_SERVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SERVER, VlsServerClass))

typedef struct _VlsServer VlsServer;
typedef struct _VlsServerClass VlsServerClass;
typedef struct _VlsServerPrivate VlsServerPrivate;

#define LSP_TYPE_INITIALIZE_PARAMS (lsp_initialize_params_get_type ())
#define LSP_INITIALIZE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParams))
#define LSP_INITIALIZE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParamsClass))
#define LSP_IS_INITIALIZE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INITIALIZE_PARAMS))
#define LSP_IS_INITIALIZE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INITIALIZE_PARAMS))
#define LSP_INITIALIZE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INITIALIZE_PARAMS, LspInitializeParamsClass))

typedef struct _LspInitializeParams LspInitializeParams;
typedef struct _LspInitializeParamsClass LspInitializeParamsClass;

#define VLS_TYPE_GIR_DOCUMENTATION (vls_gir_documentation_get_type ())
#define VLS_GIR_DOCUMENTATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentation))
#define VLS_GIR_DOCUMENTATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentationClass))
#define VLS_IS_GIR_DOCUMENTATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_GIR_DOCUMENTATION))
#define VLS_IS_GIR_DOCUMENTATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_GIR_DOCUMENTATION))
#define VLS_GIR_DOCUMENTATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_GIR_DOCUMENTATION, VlsGirDocumentationClass))

typedef struct _VlsGirDocumentation VlsGirDocumentation;
typedef struct _VlsGirDocumentationClass VlsGirDocumentationClass;

#define VLS_TYPE_REQUEST (vls_request_get_type ())
#define VLS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_REQUEST, VlsRequest))
#define VLS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_REQUEST, VlsRequestClass))
#define VLS_IS_REQUEST(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_REQUEST))
#define VLS_IS_REQUEST_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_REQUEST))
#define VLS_REQUEST_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_REQUEST, VlsRequestClass))

typedef struct _VlsRequest VlsRequest;
typedef struct _VlsRequestClass VlsRequestClass;

#define VLS_TYPE_PROJECT (vls_project_get_type ())
#define VLS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_PROJECT, VlsProject))
#define VLS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_PROJECT, VlsProjectClass))
#define VLS_IS_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_PROJECT))
#define VLS_IS_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_PROJECT))
#define VLS_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_PROJECT, VlsProjectClass))

typedef struct _VlsProject VlsProject;
typedef struct _VlsProjectClass VlsProjectClass;

#define VLS_TYPE_DEFAULT_PROJECT (vls_default_project_get_type ())
#define VLS_DEFAULT_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProject))
#define VLS_DEFAULT_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProjectClass))
#define VLS_IS_DEFAULT_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_DEFAULT_PROJECT))
#define VLS_IS_DEFAULT_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_DEFAULT_PROJECT))
#define VLS_DEFAULT_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_DEFAULT_PROJECT, VlsDefaultProjectClass))

typedef struct _VlsDefaultProject VlsDefaultProject;
typedef struct _VlsDefaultProjectClass VlsDefaultProjectClass;

#define VLS_TYPE_FILE_CACHE (vls_file_cache_get_type ())
#define VLS_FILE_CACHE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_FILE_CACHE, VlsFileCache))
#define VLS_FILE_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_FILE_CACHE, VlsFileCacheClass))
#define VLS_IS_FILE_CACHE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_FILE_CACHE))
#define VLS_IS_FILE_CACHE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_FILE_CACHE))
#define VLS_FILE_CACHE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_FILE_CACHE, VlsFileCacheClass))

typedef struct _VlsFileCache VlsFileCache;
typedef struct _VlsFileCacheClass VlsFileCacheClass;
enum  {
	VLS_SERVER_0_PROPERTY,
	VLS_SERVER_NUM_PROPERTIES
};
static GParamSpec* vls_server_properties[VLS_SERVER_NUM_PROPERTIES];
#define _g_main_loop_unref0(var) ((var == NULL) ? NULL : (var = (g_main_loop_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _vls_gir_documentation_unref0(var) ((var == NULL) ? NULL : (var = (vls_gir_documentation_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))

#define VLS_TYPE_BUILD_TARGET (vls_build_target_get_type ())
#define VLS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTarget))
#define VLS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))
#define VLS_IS_BUILD_TARGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_BUILD_TARGET))
#define VLS_IS_BUILD_TARGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_BUILD_TARGET))
#define VLS_BUILD_TARGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_BUILD_TARGET, VlsBuildTargetClass))

typedef struct _VlsBuildTarget VlsBuildTarget;
typedef struct _VlsBuildTargetClass VlsBuildTargetClass;

#define VLS_TYPE_COMPILATION (vls_compilation_get_type ())
#define VLS_COMPILATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_COMPILATION, VlsCompilation))
#define VLS_COMPILATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_COMPILATION, VlsCompilationClass))
#define VLS_IS_COMPILATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_COMPILATION))
#define VLS_IS_COMPILATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_COMPILATION))
#define VLS_COMPILATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_COMPILATION, VlsCompilationClass))

typedef struct _VlsCompilation VlsCompilation;
typedef struct _VlsCompilationClass VlsCompilationClass;

#define VLS_TYPE_PAIR (vls_pair_get_type ())
#define VLS_PAIR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_PAIR, VlsPair))
#define VLS_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_PAIR, VlsPairClass))
#define VLS_IS_PAIR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_PAIR))
#define VLS_IS_PAIR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_PAIR))
#define VLS_PAIR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_PAIR, VlsPairClass))

typedef struct _VlsPair VlsPair;
typedef struct _VlsPairClass VlsPairClass;
typedef enum  {
	LSP_MESSAGE_TYPE_Error = 1,
	LSP_MESSAGE_TYPE_Warning = 2,
	LSP_MESSAGE_TYPE_Info = 3,
	LSP_MESSAGE_TYPE_Log = 4
} LspMessageType;

#define LSP_TYPE_MESSAGE_TYPE (lsp_message_type_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef enum  {
	LSP_TEXT_DOCUMENT_SYNC_KIND_Unset = -1,
	LSP_TEXT_DOCUMENT_SYNC_KIND_None = 0,
	LSP_TEXT_DOCUMENT_SYNC_KIND_Full = 1,
	LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental = 2
} LspTextDocumentSyncKind;

#define LSP_TYPE_TEXT_DOCUMENT_SYNC_KIND (lsp_text_document_sync_kind_get_type ())

#define VLS_TYPE_MESON_PROJECT (vls_meson_project_get_type ())
#define VLS_MESON_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_MESON_PROJECT, VlsMesonProject))
#define VLS_MESON_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_MESON_PROJECT, VlsMesonProjectClass))
#define VLS_IS_MESON_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_MESON_PROJECT))
#define VLS_IS_MESON_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_MESON_PROJECT))
#define VLS_MESON_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_MESON_PROJECT, VlsMesonProjectClass))

typedef struct _VlsMesonProject VlsMesonProject;
typedef struct _VlsMesonProjectClass VlsMesonProjectClass;

#define VLS_TYPE_PROJECT_ERROR (vls_project_error_get_type ())

#define VLS_TYPE_CC_PROJECT (vls_cc_project_get_type ())
#define VLS_CC_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_CC_PROJECT, VlsCcProject))
#define VLS_CC_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_CC_PROJECT, VlsCcProjectClass))
#define VLS_IS_CC_PROJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_CC_PROJECT))
#define VLS_IS_CC_PROJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_CC_PROJECT))
#define VLS_CC_PROJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_CC_PROJECT, VlsCcProjectClass))

typedef struct _VlsCcProject VlsCcProject;
typedef struct _VlsCcProjectClass VlsCcProjectClass;
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))

#define VLS_TYPE_TEXT_DOCUMENT (vls_text_document_get_type ())
#define VLS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument))
#define VLS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))
#define VLS_IS_TEXT_DOCUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_IS_TEXT_DOCUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_TEXT_DOCUMENT))
#define VLS_TEXT_DOCUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_TEXT_DOCUMENT, VlsTextDocumentClass))

typedef struct _VlsTextDocument VlsTextDocument;
typedef struct _VlsTextDocumentClass VlsTextDocumentClass;

#define LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT (lsp_text_document_content_change_event_get_type ())
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEvent))
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEventClass))
#define LSP_IS_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT))
#define LSP_IS_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT))
#define LSP_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, LspTextDocumentContentChangeEventClass))

typedef struct _LspTextDocumentContentChangeEvent LspTextDocumentContentChangeEvent;
typedef struct _LspTextDocumentContentChangeEventClass LspTextDocumentContentChangeEventClass;

#define LSP_TYPE_RANGE (lsp_range_get_type ())
#define LSP_RANGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_RANGE, LspRange))
#define LSP_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_RANGE, LspRangeClass))
#define LSP_IS_RANGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_RANGE))
#define LSP_IS_RANGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_RANGE))
#define LSP_RANGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_RANGE, LspRangeClass))

typedef struct _LspRange LspRange;
typedef struct _LspRangeClass LspRangeClass;

#define LSP_TYPE_POSITION (lsp_position_get_type ())
#define LSP_POSITION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_POSITION, LspPosition))
#define LSP_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_POSITION, LspPositionClass))
#define LSP_IS_POSITION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_POSITION))
#define LSP_IS_POSITION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_POSITION))
#define LSP_POSITION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_POSITION, LspPositionClass))

typedef struct _LspPosition LspPosition;
typedef struct _LspPositionClass LspPositionClass;
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_time_zone_unref0(var) ((var == NULL) ? NULL : (var = (g_time_zone_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_variant_iter_free0(var) ((var == NULL) ? NULL : (var = (g_variant_iter_free (var), NULL)))
typedef void (*VlsServerOnContextUpdatedFunc) (gboolean request_cancelled, gpointer user_data);
typedef struct _Block29Data Block29Data;
typedef struct _Block30Data Block30Data;
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))

#define VLS_TYPE_REPORTER (vls_reporter_get_type ())
#define VLS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_REPORTER, VlsReporter))
#define VLS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_REPORTER, VlsReporterClass))
#define VLS_IS_REPORTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_REPORTER))
#define VLS_IS_REPORTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_REPORTER))
#define VLS_REPORTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_REPORTER, VlsReporterClass))

typedef struct _VlsReporter VlsReporter;
typedef struct _VlsReporterClass VlsReporterClass;
typedef struct _VlsReporterPrivate VlsReporterPrivate;

#define VLS_TYPE_SOURCE_MESSAGE (vls_source_message_get_type ())
#define VLS_SOURCE_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessage))
#define VLS_SOURCE_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessageClass))
#define VLS_IS_SOURCE_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SOURCE_MESSAGE))
#define VLS_IS_SOURCE_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SOURCE_MESSAGE))
#define VLS_SOURCE_MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SOURCE_MESSAGE, VlsSourceMessageClass))

typedef struct _VlsSourceMessage VlsSourceMessage;
typedef struct _VlsSourceMessageClass VlsSourceMessageClass;
typedef struct _VlsSourceMessagePrivate VlsSourceMessagePrivate;
typedef enum  {
	LSP_DIAGNOSTIC_SEVERITY_Unset = 0,
	LSP_DIAGNOSTIC_SEVERITY_Error = 1,
	LSP_DIAGNOSTIC_SEVERITY_Warning = 2,
	LSP_DIAGNOSTIC_SEVERITY_Information = 3,
	LSP_DIAGNOSTIC_SEVERITY_Hint = 4
} LspDiagnosticSeverity;

#define LSP_TYPE_DIAGNOSTIC_SEVERITY (lsp_diagnostic_severity_get_type ())

#define LSP_TYPE_DIAGNOSTIC (lsp_diagnostic_get_type ())
#define LSP_DIAGNOSTIC(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DIAGNOSTIC, LspDiagnostic))
#define LSP_DIAGNOSTIC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DIAGNOSTIC, LspDiagnosticClass))
#define LSP_IS_DIAGNOSTIC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DIAGNOSTIC))
#define LSP_IS_DIAGNOSTIC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DIAGNOSTIC))
#define LSP_DIAGNOSTIC_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DIAGNOSTIC, LspDiagnosticClass))

typedef struct _LspDiagnostic LspDiagnostic;
typedef struct _LspDiagnosticClass LspDiagnosticClass;
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))

#define VLS_TYPE_NODE_SEARCH (vls_node_search_get_type ())
#define VLS_NODE_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_NODE_SEARCH, VlsNodeSearch))
#define VLS_NODE_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_NODE_SEARCH, VlsNodeSearchClass))
#define VLS_IS_NODE_SEARCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_NODE_SEARCH))
#define VLS_IS_NODE_SEARCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_NODE_SEARCH))
#define VLS_NODE_SEARCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_NODE_SEARCH, VlsNodeSearchClass))

typedef struct _VlsNodeSearch VlsNodeSearch;
typedef struct _VlsNodeSearchClass VlsNodeSearchClass;
typedef struct _VlsNodeSearchPrivate VlsNodeSearchPrivate;
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))

#define LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS (lsp_text_document_position_params_get_type ())
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParams))
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParamsClass))
#define LSP_IS_TEXT_DOCUMENT_POSITION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS))
#define LSP_IS_TEXT_DOCUMENT_POSITION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS))
#define LSP_TEXT_DOCUMENT_POSITION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, LspTextDocumentPositionParamsClass))

typedef struct _LspTextDocumentPositionParams LspTextDocumentPositionParams;
typedef struct _LspTextDocumentPositionParamsClass LspTextDocumentPositionParamsClass;
typedef struct _Block31Data Block31Data;

#define LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER (lsp_text_document_identifier_get_type ())
#define LSP_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifier))
#define LSP_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifierClass))
#define LSP_IS_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_IS_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_TEXT_DOCUMENT_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_IDENTIFIER, LspTextDocumentIdentifierClass))

typedef struct _LspTextDocumentIdentifier LspTextDocumentIdentifier;
typedef struct _LspTextDocumentIdentifierClass LspTextDocumentIdentifierClass;
#define _vala_code_visitor_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_visitor_unref (var), NULL)))

#define LSP_TYPE_LOCATION (lsp_location_get_type ())
#define LSP_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_LOCATION, LspLocation))
#define LSP_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_LOCATION, LspLocationClass))
#define LSP_IS_LOCATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_LOCATION))
#define LSP_IS_LOCATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_LOCATION))
#define LSP_LOCATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_LOCATION, LspLocationClass))

typedef struct _LspLocation LspLocation;
typedef struct _LspLocationClass LspLocationClass;
typedef struct _Block32Data Block32Data;

#define VLS_TYPE_SYMBOL_ENUMERATOR (vls_symbol_enumerator_get_type ())
#define VLS_SYMBOL_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumerator))
#define VLS_SYMBOL_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumeratorClass))
#define VLS_IS_SYMBOL_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_SYMBOL_ENUMERATOR))
#define VLS_IS_SYMBOL_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_SYMBOL_ENUMERATOR))
#define VLS_SYMBOL_ENUMERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_SYMBOL_ENUMERATOR, VlsSymbolEnumeratorClass))

typedef struct _VlsSymbolEnumerator VlsSymbolEnumerator;
typedef struct _VlsSymbolEnumeratorClass VlsSymbolEnumeratorClass;

#define LSP_TYPE_CLIENT_CAPABILITIES (lsp_client_capabilities_get_type ())
#define LSP_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilities))
#define LSP_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilitiesClass))
#define LSP_IS_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CLIENT_CAPABILITIES))
#define LSP_IS_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CLIENT_CAPABILITIES))
#define LSP_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CLIENT_CAPABILITIES, LspClientCapabilitiesClass))

typedef struct _LspClientCapabilities LspClientCapabilities;
typedef struct _LspClientCapabilitiesClass LspClientCapabilitiesClass;

#define LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES (lsp_text_document_client_capabilities_get_type ())
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilities))
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilitiesClass))
#define LSP_IS_TEXT_DOCUMENT_CLIENT_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES))
#define LSP_IS_TEXT_DOCUMENT_CLIENT_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES))
#define LSP_TEXT_DOCUMENT_CLIENT_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_CLIENT_CAPABILITIES, LspTextDocumentClientCapabilitiesClass))

typedef struct _LspTextDocumentClientCapabilities LspTextDocumentClientCapabilities;
typedef struct _LspTextDocumentClientCapabilitiesClass LspTextDocumentClientCapabilitiesClass;

#define LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES (lsp_document_symbol_capabilities_get_type ())
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilities))
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilitiesClass))
#define LSP_IS_DOCUMENT_SYMBOL_CAPABILITIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES))
#define LSP_IS_DOCUMENT_SYMBOL_CAPABILITIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES))
#define LSP_DOCUMENT_SYMBOL_CAPABILITIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL_CAPABILITIES, LspDocumentSymbolCapabilitiesClass))

typedef struct _LspDocumentSymbolCapabilities LspDocumentSymbolCapabilities;
typedef struct _LspDocumentSymbolCapabilitiesClass LspDocumentSymbolCapabilitiesClass;

#define LSP_TYPE_DOCUMENT_SYMBOL (lsp_document_symbol_get_type ())
#define LSP_DOCUMENT_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbol))
#define LSP_DOCUMENT_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbolClass))
#define LSP_IS_DOCUMENT_SYMBOL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_SYMBOL))
#define LSP_IS_DOCUMENT_SYMBOL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_SYMBOL))
#define LSP_DOCUMENT_SYMBOL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_SYMBOL, LspDocumentSymbolClass))

typedef struct _LspDocumentSymbol LspDocumentSymbol;
typedef struct _LspDocumentSymbolClass LspDocumentSymbolClass;

#define LSP_TYPE_SYMBOL_INFORMATION (lsp_symbol_information_get_type ())
#define LSP_SYMBOL_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformation))
#define LSP_SYMBOL_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformationClass))
#define LSP_IS_SYMBOL_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_SYMBOL_INFORMATION))
#define LSP_IS_SYMBOL_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_SYMBOL_INFORMATION))
#define LSP_SYMBOL_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_SYMBOL_INFORMATION, LspSymbolInformationClass))

typedef struct _LspSymbolInformation LspSymbolInformation;
typedef struct _LspSymbolInformationClass LspSymbolInformationClass;

#define VLS_TYPE_DOC_COMMENT (vls_doc_comment_get_type ())
#define VLS_DOC_COMMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_DOC_COMMENT, VlsDocComment))
#define VLS_DOC_COMMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_DOC_COMMENT, VlsDocCommentClass))
#define VLS_IS_DOC_COMMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_DOC_COMMENT))
#define VLS_IS_DOC_COMMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_DOC_COMMENT))
#define VLS_DOC_COMMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_DOC_COMMENT, VlsDocCommentClass))

typedef struct _VlsDocComment VlsDocComment;
typedef struct _VlsDocCommentClass VlsDocCommentClass;
#define _vala_comment_unref0(var) ((var == NULL) ? NULL : (var = (vala_comment_unref (var), NULL)))
#define _vls_doc_comment_unref0(var) ((var == NULL) ? NULL : (var = (vls_doc_comment_unref (var), NULL)))

#define LSP_TYPE_COMPLETION_PARAMS (lsp_completion_params_get_type ())
#define LSP_COMPLETION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParams))
#define LSP_COMPLETION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParamsClass))
#define LSP_IS_COMPLETION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_PARAMS))
#define LSP_IS_COMPLETION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_PARAMS))
#define LSP_COMPLETION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_PARAMS, LspCompletionParamsClass))

typedef struct _LspCompletionParams LspCompletionParams;
typedef struct _LspCompletionParamsClass LspCompletionParamsClass;

#define LSP_TYPE_COMPLETION_CONTEXT (lsp_completion_context_get_type ())
#define LSP_COMPLETION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContext))
#define LSP_COMPLETION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContextClass))
#define LSP_IS_COMPLETION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_COMPLETION_CONTEXT))
#define LSP_IS_COMPLETION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_COMPLETION_CONTEXT))
#define LSP_COMPLETION_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_COMPLETION_CONTEXT, LspCompletionContextClass))

typedef struct _LspCompletionContext LspCompletionContext;
typedef struct _LspCompletionContextClass LspCompletionContextClass;
typedef struct _Block33Data Block33Data;

#define VLS_TYPE_FIND_SCOPE (vls_find_scope_get_type ())
#define VLS_FIND_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_FIND_SCOPE, VlsFindScope))
#define VLS_FIND_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_FIND_SCOPE, VlsFindScopeClass))
#define VLS_IS_FIND_SCOPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_FIND_SCOPE))
#define VLS_IS_FIND_SCOPE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_FIND_SCOPE))
#define VLS_FIND_SCOPE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_FIND_SCOPE, VlsFindScopeClass))

typedef struct _VlsFindScope VlsFindScope;
typedef struct _VlsFindScopeClass VlsFindScopeClass;
#define _vala_scope_unref0(var) ((var == NULL) ? NULL : (var = (vala_scope_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))

#define LSP_TYPE_HOVER (lsp_hover_get_type ())
#define LSP_HOVER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_HOVER, LspHover))
#define LSP_HOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_HOVER, LspHoverClass))
#define LSP_IS_HOVER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_HOVER))
#define LSP_IS_HOVER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_HOVER))
#define LSP_HOVER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_HOVER, LspHoverClass))

typedef struct _LspHover LspHover;
typedef struct _LspHoverClass LspHoverClass;

#define LSP_TYPE_MARKED_STRING (lsp_marked_string_get_type ())
#define LSP_MARKED_STRING(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_MARKED_STRING, LspMarkedString))
#define LSP_MARKED_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_MARKED_STRING, LspMarkedStringClass))
#define LSP_IS_MARKED_STRING(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_MARKED_STRING))
#define LSP_IS_MARKED_STRING_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_MARKED_STRING))
#define LSP_MARKED_STRING_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_MARKED_STRING, LspMarkedStringClass))

typedef struct _LspMarkedString LspMarkedString;
typedef struct _LspMarkedStringClass LspMarkedStringClass;
typedef enum  {
	LSP_DOCUMENT_HIGHLIGHT_KIND_Text = 1,
	LSP_DOCUMENT_HIGHLIGHT_KIND_Read = 2,
	LSP_DOCUMENT_HIGHLIGHT_KIND_Write = 3
} LspDocumentHighlightKind;

#define LSP_TYPE_DOCUMENT_HIGHLIGHT_KIND (lsp_document_highlight_kind_get_type ())

#define LSP_TYPE_REFERENCE_PARAMS (lsp_reference_params_get_type ())
#define LSP_REFERENCE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParams))
#define LSP_REFERENCE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParamsClass))
#define LSP_IS_REFERENCE_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_REFERENCE_PARAMS))
#define LSP_IS_REFERENCE_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_REFERENCE_PARAMS))
#define LSP_REFERENCE_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_REFERENCE_PARAMS, LspReferenceParamsClass))

typedef struct _LspReferenceParams LspReferenceParams;
typedef struct _LspReferenceParamsClass LspReferenceParamsClass;
typedef struct _Block34Data Block34Data;

#define LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT (lsp_reference_params_reference_context_get_type ())
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContext))
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContextClass))
#define LSP_REFERENCE_PARAMS_IS_REFERENCE_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT))
#define LSP_REFERENCE_PARAMS_IS_REFERENCE_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT))
#define LSP_REFERENCE_PARAMS_REFERENCE_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_REFERENCE_PARAMS_TYPE_REFERENCE_CONTEXT, LspReferenceParamsReferenceContextClass))

typedef struct _LspReferenceParamsReferenceContext LspReferenceParamsReferenceContext;
typedef struct _LspReferenceParamsReferenceContextClass LspReferenceParamsReferenceContextClass;

#define LSP_TYPE_DOCUMENT_HIGHLIGHT (lsp_document_highlight_get_type ())
#define LSP_DOCUMENT_HIGHLIGHT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlight))
#define LSP_DOCUMENT_HIGHLIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlightClass))
#define LSP_IS_DOCUMENT_HIGHLIGHT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT))
#define LSP_IS_DOCUMENT_HIGHLIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_HIGHLIGHT))
#define LSP_DOCUMENT_HIGHLIGHT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_HIGHLIGHT, LspDocumentHighlightClass))

typedef struct _LspDocumentHighlight LspDocumentHighlight;
typedef struct _LspDocumentHighlightClass LspDocumentHighlightClass;
typedef struct _Block35Data Block35Data;
typedef gboolean (*VlsNodeSearchFilter) (ValaCodeNode* needle, ValaCodeNode* hay_node);

#define LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS (lsp_document_range_formatting_params_get_type ())
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParams))
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParamsClass))
#define LSP_IS_DOCUMENT_RANGE_FORMATTING_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS))
#define LSP_IS_DOCUMENT_RANGE_FORMATTING_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS))
#define LSP_DOCUMENT_RANGE_FORMATTING_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, LspDocumentRangeFormattingParamsClass))

typedef struct _LspDocumentRangeFormattingParams LspDocumentRangeFormattingParams;
typedef struct _LspDocumentRangeFormattingParamsClass LspDocumentRangeFormattingParamsClass;

#define LSP_TYPE_TEXT_EDIT (lsp_text_edit_get_type ())
#define LSP_TEXT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_EDIT, LspTextEdit))
#define LSP_TEXT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_EDIT, LspTextEditClass))
#define LSP_IS_TEXT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_EDIT))
#define LSP_IS_TEXT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_EDIT))
#define LSP_TEXT_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_EDIT, LspTextEditClass))

typedef struct _LspTextEdit LspTextEdit;
typedef struct _LspTextEditClass LspTextEditClass;

#define VLS_TYPE_CODE_STYLE_ANALYZER (vls_code_style_analyzer_get_type ())
#define VLS_CODE_STYLE_ANALYZER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VLS_TYPE_CODE_STYLE_ANALYZER, VlsCodeStyleAnalyzer))
#define VLS_CODE_STYLE_ANALYZER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VLS_TYPE_CODE_STYLE_ANALYZER, VlsCodeStyleAnalyzerClass))
#define VLS_IS_CODE_STYLE_ANALYZER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VLS_TYPE_CODE_STYLE_ANALYZER))
#define VLS_IS_CODE_STYLE_ANALYZER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VLS_TYPE_CODE_STYLE_ANALYZER))
#define VLS_CODE_STYLE_ANALYZER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VLS_TYPE_CODE_STYLE_ANALYZER, VlsCodeStyleAnalyzerClass))

typedef struct _VlsCodeStyleAnalyzer VlsCodeStyleAnalyzer;
typedef struct _VlsCodeStyleAnalyzerClass VlsCodeStyleAnalyzerClass;

#define LSP_TYPE_FORMATTING_OPTIONS (lsp_formatting_options_get_type ())
#define LSP_FORMATTING_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptions))
#define LSP_FORMATTING_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptionsClass))
#define LSP_IS_FORMATTING_OPTIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_FORMATTING_OPTIONS))
#define LSP_IS_FORMATTING_OPTIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_FORMATTING_OPTIONS))
#define LSP_FORMATTING_OPTIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_FORMATTING_OPTIONS, LspFormattingOptionsClass))

typedef struct _LspFormattingOptions LspFormattingOptions;
typedef struct _LspFormattingOptionsClass LspFormattingOptionsClass;

#define TYPE_FORMATTING_ERROR (formatting_error_get_type ())

#define LSP_TYPE_CODE_ACTION_PARAMS (lsp_code_action_params_get_type ())
#define LSP_CODE_ACTION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParams))
#define LSP_CODE_ACTION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParamsClass))
#define LSP_IS_CODE_ACTION_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION_PARAMS))
#define LSP_IS_CODE_ACTION_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION_PARAMS))
#define LSP_CODE_ACTION_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION_PARAMS, LspCodeActionParamsClass))

typedef struct _LspCodeActionParams LspCodeActionParams;
typedef struct _LspCodeActionParamsClass LspCodeActionParamsClass;

#define LSP_TYPE_CODE_ACTION (lsp_code_action_get_type ())
#define LSP_CODE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION, LspCodeAction))
#define LSP_CODE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION, LspCodeActionClass))
#define LSP_IS_CODE_ACTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION))
#define LSP_IS_CODE_ACTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION))
#define LSP_CODE_ACTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION, LspCodeActionClass))

typedef struct _LspCodeAction LspCodeAction;
typedef struct _LspCodeActionClass LspCodeActionClass;

#define LSP_TYPE_CODE_ACTION_CONTEXT (lsp_code_action_context_get_type ())
#define LSP_CODE_ACTION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContext))
#define LSP_CODE_ACTION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContextClass))
#define LSP_IS_CODE_ACTION_CONTEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CODE_ACTION_CONTEXT))
#define LSP_IS_CODE_ACTION_CONTEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CODE_ACTION_CONTEXT))
#define LSP_CODE_ACTION_CONTEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CODE_ACTION_CONTEXT, LspCodeActionContextClass))

typedef struct _LspCodeActionContext LspCodeActionContext;
typedef struct _LspCodeActionContextClass LspCodeActionContextClass;
#define _vala_iterator_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterator_unref (var), NULL)))
typedef struct _Block36Data Block36Data;
typedef struct _Block37Data Block37Data;
typedef struct _Block38Data Block38Data;

#define LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER (lsp_versioned_text_document_identifier_get_type ())
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifier))
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifierClass))
#define LSP_IS_VERSIONED_TEXT_DOCUMENT_IDENTIFIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_IS_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER))
#define LSP_VERSIONED_TEXT_DOCUMENT_IDENTIFIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_VERSIONED_TEXT_DOCUMENT_IDENTIFIER, LspVersionedTextDocumentIdentifierClass))

typedef struct _LspVersionedTextDocumentIdentifier LspVersionedTextDocumentIdentifier;
typedef struct _LspVersionedTextDocumentIdentifierClass LspVersionedTextDocumentIdentifierClass;

#define LSP_TYPE_TEXT_DOCUMENT_EDIT (lsp_text_document_edit_get_type ())
#define LSP_TEXT_DOCUMENT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEdit))
#define LSP_TEXT_DOCUMENT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEditClass))
#define LSP_IS_TEXT_DOCUMENT_EDIT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT))
#define LSP_IS_TEXT_DOCUMENT_EDIT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TEXT_DOCUMENT_EDIT))
#define LSP_TEXT_DOCUMENT_EDIT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TEXT_DOCUMENT_EDIT, LspTextDocumentEditClass))

typedef struct _LspTextDocumentEdit LspTextDocumentEdit;
typedef struct _LspTextDocumentEditClass LspTextDocumentEditClass;
typedef struct _Block39Data Block39Data;

#define LSP_TYPE_CALL_HIERARCHY_ITEM (lsp_call_hierarchy_item_get_type ())
#define LSP_CALL_HIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItem))
#define LSP_CALL_HIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItemClass))
#define LSP_IS_CALL_HIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM))
#define LSP_IS_CALL_HIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_ITEM))
#define LSP_CALL_HIERARCHY_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_ITEM, LspCallHierarchyItemClass))

typedef struct _LspCallHierarchyItem LspCallHierarchyItem;
typedef struct _LspCallHierarchyItemClass LspCallHierarchyItemClass;

#define LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL (lsp_call_hierarchy_incoming_call_get_type ())
#define LSP_CALL_HIERARCHY_INCOMING_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCall))
#define LSP_CALL_HIERARCHY_INCOMING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCallClass))
#define LSP_IS_CALL_HIERARCHY_INCOMING_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL))
#define LSP_IS_CALL_HIERARCHY_INCOMING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL))
#define LSP_CALL_HIERARCHY_INCOMING_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_INCOMING_CALL, LspCallHierarchyIncomingCallClass))

typedef struct _LspCallHierarchyIncomingCall LspCallHierarchyIncomingCall;
typedef struct _LspCallHierarchyIncomingCallClass LspCallHierarchyIncomingCallClass;

#define LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL (lsp_call_hierarchy_outgoing_call_get_type ())
#define LSP_CALL_HIERARCHY_OUTGOING_CALL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCall))
#define LSP_CALL_HIERARCHY_OUTGOING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCallClass))
#define LSP_IS_CALL_HIERARCHY_OUTGOING_CALL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL))
#define LSP_IS_CALL_HIERARCHY_OUTGOING_CALL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL))
#define LSP_CALL_HIERARCHY_OUTGOING_CALL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_CALL_HIERARCHY_OUTGOING_CALL, LspCallHierarchyOutgoingCallClass))

typedef struct _LspCallHierarchyOutgoingCall LspCallHierarchyOutgoingCall;
typedef struct _LspCallHierarchyOutgoingCallClass LspCallHierarchyOutgoingCallClass;

#define LSP_TYPE_INLAY_HINT_PARAMS (lsp_inlay_hint_params_get_type ())
#define LSP_INLAY_HINT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParams))
#define LSP_INLAY_HINT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParamsClass))
#define LSP_IS_INLAY_HINT_PARAMS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INLAY_HINT_PARAMS))
#define LSP_IS_INLAY_HINT_PARAMS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INLAY_HINT_PARAMS))
#define LSP_INLAY_HINT_PARAMS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INLAY_HINT_PARAMS, LspInlayHintParamsClass))

typedef struct _LspInlayHintParams LspInlayHintParams;
typedef struct _LspInlayHintParamsClass LspInlayHintParamsClass;

#define LSP_TYPE_INLAY_HINT (lsp_inlay_hint_get_type ())
#define LSP_INLAY_HINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_INLAY_HINT, LspInlayHint))
#define LSP_INLAY_HINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_INLAY_HINT, LspInlayHintClass))
#define LSP_IS_INLAY_HINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_INLAY_HINT))
#define LSP_IS_INLAY_HINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_INLAY_HINT))
#define LSP_INLAY_HINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_INLAY_HINT, LspInlayHintClass))

typedef struct _LspInlayHint LspInlayHint;
typedef struct _LspInlayHintClass LspInlayHintClass;
typedef enum  {
	LSP_INLAY_HINT_KIND_UNSET,
	LSP_INLAY_HINT_KIND_TYPE,
	LSP_INLAY_HINT_KIND_PARAMETER
} LspInlayHintKind;

#define LSP_TYPE_INLAY_HINT_KIND (lsp_inlay_hint_kind_get_type ())
#define _g_match_info_unref0(var) ((var == NULL) ? NULL : (var = (g_match_info_unref (var), NULL)))

#define LSP_TYPE_TYPEHIERARCHY_ITEM (lsp_typehierarchy_item_get_type ())
#define LSP_TYPEHIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItem))
#define LSP_TYPEHIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItemClass))
#define LSP_IS_TYPEHIERARCHY_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM))
#define LSP_IS_TYPEHIERARCHY_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LSP_TYPE_TYPEHIERARCHY_ITEM))
#define LSP_TYPEHIERARCHY_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LSP_TYPE_TYPEHIERARCHY_ITEM, LspTypeHierarchyItemClass))

typedef struct _LspTypeHierarchyItem LspTypeHierarchyItem;
typedef struct _LspTypeHierarchyItemClass LspTypeHierarchyItemClass;
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _VlsServer {
	JsonrpcServer parent_instance;
	VlsServerPrivate * priv;
};

struct _VlsServerClass {
	JsonrpcServerClass parent_class;
};

struct _VlsServerPrivate {
	GMainLoop* loop;
	LspInitializeParams* init_params;
	VlsGirDocumentation* documentation;
	GeeHashSet* pending_requests;
	gboolean shutting_down;
	guint* g_sources;
	gint g_sources_length1;
	gint _g_sources_size_;
	gulong client_closed_event_id;
	GHashTable* projects;
	VlsDefaultProject* default_project;
	GeeHashSet* discarded_files;
	GeeHashSet* open_files;
	VlsFileCache* file_cache;
	JsonrpcClient* update_context_client;
	gint64 update_context_requests;
	gint64 update_context_time_us;
};

typedef enum  {
	VLS_PROJECT_ERROR_VERSION_UNSUPPORTED,
	VLS_PROJECT_ERROR_INTROSPECTION,
	VLS_PROJECT_ERROR_CONFIGURATION,
	VLS_PROJECT_ERROR_TASK_FAILED,
	VLS_PROJECT_ERROR_NOT_FOUND
} VlsProjectError;
#define VLS_PROJECT_ERROR vls_project_error_quark ()

struct _Block29Data {
	int _ref_count_;
	VlsServer* self;
	VlsRequest* req;
	VlsServerOnContextUpdatedFunc on_context_updated_func;
	gpointer on_context_updated_func_target;
	GDestroyNotify on_context_updated_func_target_destroy_notify;
};

struct _Block30Data {
	int _ref_count_;
	VlsServer* self;
	JsonArray* diags_without_source;
	GeeHashMap* doc_diags;
	VlsCompilation* target;
};

struct _VlsReporter {
	ValaReport parent_instance;
	VlsReporterPrivate * priv;
	GPtrArray* messages;
};

struct _VlsReporterClass {
	ValaReportClass parent_class;
};

struct _VlsSourceMessage {
	GTypeInstance parent_instance;
	volatile int ref_count;
	VlsSourceMessagePrivate * priv;
	ValaSourceReference* loc;
	gchar* message;
	LspDiagnosticSeverity severity;
};

struct _VlsSourceMessageClass {
	GTypeClass parent_class;
	void (*finalize) (VlsSourceMessage *self);
};

struct _VlsNodeSearch {
	ValaCodeVisitor parent_instance;
	VlsNodeSearchPrivate * priv;
	GeeList* result;
};

struct _VlsNodeSearchClass {
	ValaCodeVisitorClass parent_class;
};

struct _Block31Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block32Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block33Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block34Data {
	int _ref_count_;
	VlsServer* self;
	LspReferenceParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block35Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

typedef enum  {
	FORMATTING_ERROR_FORMAT,
	FORMATTING_ERROR_READ
} FormattingError;
#define FORMATTING_ERROR formatting_error_quark ()

struct _Block36Data {
	int _ref_count_;
	VlsServer* self;
	gchar* query;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block37Data {
	int _ref_count_;
	Block36Data * _data36_;
	JsonArray* json_array;
};

struct _Block38Data {
	int _ref_count_;
	VlsServer* self;
	gchar* new_name;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

struct _Block39Data {
	int _ref_count_;
	VlsServer* self;
	LspTextDocumentPositionParams* p;
	JsonrpcClient* client;
	gchar* method;
	GVariant* id;
};

static gint VlsServer_private_offset;
static gpointer vls_server_parent_class = NULL;
static gboolean vls_server_received_signal;
static gboolean vls_server_received_signal = FALSE;
VALA_EXTERN GCancellable* vls_server_cancellable;
GCancellable* vls_server_cancellable = NULL;
VALA_EXTERN gboolean opt_version;
gboolean opt_version = FALSE;

VALA_EXTERN GType vls_server_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsServer, g_object_unref)
VALA_EXTERN GType lsp_initialize_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInitializeParams, g_object_unref)
VALA_EXTERN gpointer vls_gir_documentation_ref (gpointer instance);
VALA_EXTERN void vls_gir_documentation_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_gir_documentation (const gchar* name,
                                              const gchar* nick,
                                              const gchar* blurb,
                                              GType object_type,
                                              GParamFlags flags);
VALA_EXTERN void vls_value_set_gir_documentation (GValue* value,
                                      gpointer v_object);
VALA_EXTERN void vls_value_take_gir_documentation (GValue* value,
                                       gpointer v_object);
VALA_EXTERN gpointer vls_value_get_gir_documentation (const GValue* value);
VALA_EXTERN GType vls_gir_documentation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsGirDocumentation, vls_gir_documentation_unref)
VALA_EXTERN GType vls_request_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsRequest, g_object_unref)
VALA_EXTERN GType vls_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsProject, g_object_unref)
VALA_EXTERN GType vls_default_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsDefaultProject, g_object_unref)
VALA_EXTERN GType vls_file_cache_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsFileCache, g_object_unref)
VALA_EXTERN VlsFileCache* vls_file_cache_new (void);
VALA_EXTERN VlsFileCache* vls_file_cache_construct (GType object_type);
VALA_EXTERN VlsServer* vls_server_new (GMainLoop* loop);
VALA_EXTERN VlsServer* vls_server_construct (GType object_type,
                                 GMainLoop* loop);
static gboolean vls_server_check_signal (VlsServer* self);
static gboolean _vls_server_check_signal_gsource_func (gpointer self);
static void _vala_array_add23 (guint* * array,
                        gint* length,
                        gint* size,
                        guint value);
VALA_EXTERN guint vls_request_hash (VlsRequest* req);
static guint _vls_request_hash_gee_hash_data_func (gconstpointer v,
                                            gpointer self);
VALA_EXTERN gboolean vls_request_equal (VlsRequest* reqA,
                            VlsRequest* reqB);
static gboolean _vls_request_equal_gee_equal_data_func (gconstpointer a,
                                                 gconstpointer b,
                                                 gpointer self);
static void _g_object_unref0_ (gpointer var);
static void vls_server_real_notification (JsonrpcServer* base,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* parameters);
static void vls_server_exit (VlsServer* self);
static void vls_server_cancel_request (VlsServer* self,
                                JsonrpcClient* client,
                                GVariant* params);
static void vls_server_text_document_did_open (VlsServer* self,
                                        JsonrpcClient* client,
                                        GVariant* params);
static void vls_server_text_document_did_save (VlsServer* self,
                                        JsonrpcClient* client,
                                        GVariant* params);
static void vls_server_text_document_did_close (VlsServer* self,
                                         JsonrpcClient* client,
                                         GVariant* params);
static void vls_server_text_document_did_change (VlsServer* self,
                                          JsonrpcClient* client,
                                          GVariant* params);
static gboolean vls_server_real_handle_call (JsonrpcServer* base,
                                      JsonrpcClient* client,
                                      const gchar* method,
                                      GVariant* id,
                                      GVariant* parameters);
static void vls_server_initialize (VlsServer* self,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params);
static void vls_server_shutdown (VlsServer* self);
VALA_EXTERN void vls_server_reply_null (GVariant* id,
                            JsonrpcClient* client,
                            const gchar* method);
static void vls_server_goto_definition (VlsServer* self,
                                 JsonrpcClient* client,
                                 const gchar* method,
                                 GVariant* id,
                                 GVariant* params);
static void vls_server_document_symbol_outline (VlsServer* self,
                                         JsonrpcClient* client,
                                         const gchar* method,
                                         GVariant* id,
                                         GVariant* params);
static void vls_server_show_completion (VlsServer* self,
                                 JsonrpcClient* client,
                                 const gchar* method,
                                 GVariant* id,
                                 GVariant* params);
static void vls_server_show_signature_help (VlsServer* self,
                                     JsonrpcClient* client,
                                     const gchar* method,
                                     GVariant* id,
                                     GVariant* params);
static void vls_server_hover (VlsServer* self,
                       JsonrpcClient* client,
                       const gchar* method,
                       GVariant* id,
                       GVariant* params);
static void vls_server_format (VlsServer* self,
                        JsonrpcClient* client,
                        const gchar* method,
                        GVariant* id,
                        GVariant* params);
static void vls_server_code_action (VlsServer* self,
                             JsonrpcClient* client,
                             const gchar* method,
                             GVariant* id,
                             GVariant* params);
static void vls_server_show_references (VlsServer* self,
                                 JsonrpcClient* client,
                                 const gchar* method,
                                 GVariant* id,
                                 GVariant* params);
static void vls_server_show_implementations (VlsServer* self,
                                      JsonrpcClient* client,
                                      const gchar* method,
                                      GVariant* id,
                                      GVariant* params);
static void vls_server_search_workspace_symbols (VlsServer* self,
                                          JsonrpcClient* client,
                                          const gchar* method,
                                          GVariant* id,
                                          GVariant* params);
static void vls_server_rename_symbol (VlsServer* self,
                               JsonrpcClient* client,
                               const gchar* method,
                               GVariant* id,
                               GVariant* params);
static void vls_server_prepare_rename_symbol (VlsServer* self,
                                       JsonrpcClient* client,
                                       const gchar* method,
                                       GVariant* id,
                                       GVariant* params);
static void vls_server_code_lens (VlsServer* self,
                           JsonrpcClient* client,
                           const gchar* method,
                           GVariant* id,
                           GVariant* params);
static void vls_server_prepare_call_hierarchy (VlsServer* self,
                                        JsonrpcClient* client,
                                        const gchar* method,
                                        GVariant* id,
                                        GVariant* params);
static void vls_server_call_hierarchy_incoming_calls (VlsServer* self,
                                               JsonrpcClient* client,
                                               const gchar* method,
                                               GVariant* id,
                                               GVariant* params);
static void vls_server_call_hierarchy_outgoing_calls (VlsServer* self,
                                               JsonrpcClient* client,
                                               const gchar* method,
                                               GVariant* id,
                                               GVariant* params);
static void vls_server_show_inlay_hints (VlsServer* self,
                                  JsonrpcClient* client,
                                  const gchar* method,
                                  GVariant* id,
                                  GVariant* params);
static void vls_server_prepare_type_hierarchy (VlsServer* self,
                                        JsonrpcClient* client,
                                        const gchar* method,
                                        GVariant* id,
                                        GVariant* params);
static void vls_server_show_type_hierarchy (VlsServer* self,
                                     JsonrpcClient* client,
                                     const gchar* method,
                                     GVariant* id,
                                     GVariant* params,
                                     gboolean supertypes);
static void vls_server_real_client_closed (JsonrpcServer* base,
                                    JsonrpcClient* client);
VALA_EXTERN GVariant* vls_server_build_dict (VlsServer* self,
                                 ...);
VALA_EXTERN GType vls_build_target_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsBuildTarget, g_object_unref)
VALA_EXTERN GType vls_compilation_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsCompilation, g_object_unref)
static ValaSourceFile* vls_server_find_file (VlsServer* self,
                                      const gchar* uri,
                                      VlsCompilation** compilation,
                                      VlsProject** project);
VALA_EXTERN GType vls_pair_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsPair, g_object_unref)
VALA_EXTERN GeeArrayList* vls_project_lookup_compile_input_source_file (VlsProject* self,
                                                            const gchar* escaped_uri);
VALA_EXTERN gconstpointer vls_pair_get_second (VlsPair* self);
VALA_EXTERN gconstpointer vls_pair_get_first (VlsPair* self);
VALA_EXTERN GType lsp_message_type_get_type (void) G_GNUC_CONST ;
static void vls_server_show_message (VlsServer* self,
                              JsonrpcClient* client,
                              const gchar* message,
                              LspMessageType type);
VALA_EXTERN gpointer vls_util_parse_variant (GType t_type,
                                 GBoxedCopyFunc t_dup_func,
                                 GDestroyNotify t_destroy_func,
                                 GVariant* variant);
VALA_EXTERN const gchar* lsp_initialize_params_get_rootUri (LspInitializeParams* self);
VALA_EXTERN const gchar* lsp_initialize_params_get_rootPath (LspInitializeParams* self);
VALA_EXTERN gchar* vls_util_realpath (const gchar* name,
                          const gchar* cwd);
VALA_EXTERN GType lsp_text_document_sync_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GeeArrayList* vls_util_find_files (GFile* dir,
                                   GRegex* basename_pattern,
                                   guint max_depth,
                                   GCancellable* cancellable,
                                   GeeArrayList* found,
                                   GError** error);
VALA_EXTERN GType vls_meson_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsMesonProject, g_object_unref)
VALA_EXTERN VlsMesonProject* vls_meson_project_new (const gchar* root_path,
                                        VlsFileCache* file_cache,
                                        GCancellable* cancellable,
                                        GError** error);
VALA_EXTERN VlsMesonProject* vls_meson_project_construct (GType object_type,
                                              const gchar* root_path,
                                              VlsFileCache* file_cache,
                                              GCancellable* cancellable,
                                              GError** error);
VALA_EXTERN GQuark vls_project_error_quark (void);
VALA_EXTERN GType vls_project_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType vls_cc_project_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsCcProject, g_object_unref)
VALA_EXTERN VlsCcProject* vls_cc_project_new (const gchar* root_path,
                                  const gchar* cc_location,
                                  VlsFileCache* file_cache,
                                  GCancellable* cancellable,
                                  GError** error);
VALA_EXTERN VlsCcProject* vls_cc_project_construct (GType object_type,
                                        const gchar* root_path,
                                        const gchar* cc_location,
                                        VlsFileCache* file_cache,
                                        GCancellable* cancellable,
                                        GError** error);
VALA_EXTERN VlsDefaultProject* vls_default_project_new (const gchar* root_path,
                                            VlsFileCache* file_cache);
VALA_EXTERN VlsDefaultProject* vls_default_project_construct (GType object_type,
                                                  const gchar* root_path,
                                                  VlsFileCache* file_cache);
VALA_EXTERN void vls_project_build_if_stale (VlsProject* self,
                                 GCancellable* cancellable,
                                 GError** error);
VALA_EXTERN GeeArrayList* vls_project_get_compilations (VlsProject* self);
static void vls_server_publish_diagnostics (VlsServer* self,
                                     VlsProject* project,
                                     VlsCompilation* target,
                                     JsonrpcClient* client);
VALA_EXTERN guint vls_util_file_hash (GFile* file);
static guint _vls_util_file_hash_gee_hash_data_func (gconstpointer v,
                                              gpointer self);
VALA_EXTERN gboolean vls_util_file_equal (GFile* file1,
                              GFile* file2);
static gboolean _vls_util_file_equal_gee_equal_data_func (gconstpointer a,
                                                   gconstpointer b,
                                                   gpointer self);
VALA_EXTERN GeeCollection* vls_project_get_packages (VlsProject* self);
VALA_EXTERN GeeCollection* vls_project_get_custom_gir_dirs (VlsProject* self);
VALA_EXTERN VlsGirDocumentation* vls_gir_documentation_new (GeeCollection* vala_packages,
                                                GeeCollection* custom_gir_dirs);
VALA_EXTERN VlsGirDocumentation* vls_gir_documentation_construct (GType object_type,
                                                      GeeCollection* vala_packages,
                                                      GeeCollection* custom_gir_dirs);
static gboolean vls_server_check_update_context (VlsServer* self);
static gboolean _vls_server_check_update_context_gsource_func (gpointer self);
static void _vala_array_add24 (guint* * array,
                        gint* length,
                        gint* size,
                        guint value);
static void vls_server_project_changed_event (VlsServer* self);
static void _vls_server_project_changed_event_vls_project_changed (VlsProject* _sender,
                                                            gpointer self);
static void vls_server_request_context_update (VlsServer* self,
                                        JsonrpcClient* client);
VALA_EXTERN VlsRequest* vls_request_new (GVariant* id,
                             const gchar* method);
VALA_EXTERN VlsRequest* vls_request_construct (GType object_type,
                                   GVariant* id,
                                   const gchar* method);
static gchar* _variant_get3 (GVariant* value);
static gchar* _variant_get4 (GVariant* value);
static gchar* _variant_get5 (GVariant* value);
VALA_EXTERN GeeArrayList* vls_project_open (VlsProject* self,
                                const gchar* escaped_uri,
                                const gchar* content,
                                GCancellable* cancellable,
                                GError** error);
VALA_EXTERN void vls_gir_documentation_add_package_from_source_file (VlsGirDocumentation* self,
                                                         ValaSourceFile* vapi_pkg);
VALA_EXTERN GType vls_text_document_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsTextDocument, vala_source_file_unref)
VALA_EXTERN void vls_text_document_set_last_saved_content (VlsTextDocument* self,
                                               const gchar* value);
static gchar* _variant_get6 (GVariant* value);
static VlsProject** _vala_array_dup13 (VlsProject** self,
                                gssize length);
static void _vala_array_add25 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gint vls_text_document_get_last_saved_version (VlsTextDocument* self);
static gchar* _variant_get7 (GVariant* value);
static VlsProject** _vala_array_dup14 (VlsProject** self,
                                gssize length);
static void _vala_array_add26 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gboolean vls_project_close (VlsProject* self,
                            const gchar* escaped_uri,
                            GError** error);
static gchar* _variant_get8 (GVariant* value);
static gint64 _variant_get9 (GVariant* value);
static VlsProject** _vala_array_dup15 (VlsProject** self,
                                gssize length);
static void _vala_array_add27 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gint vls_text_document_get_version (VlsTextDocument* self);
VALA_EXTERN GType lsp_text_document_content_change_event_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentContentChangeEvent, g_object_unref)
VALA_EXTERN GType lsp_range_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspRange, g_object_unref)
VALA_EXTERN LspRange* lsp_text_document_content_change_event_get_range (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN const gchar* lsp_text_document_content_change_event_get_text (LspTextDocumentContentChangeEvent* self);
VALA_EXTERN GType lsp_position_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspPosition, g_object_unref)
VALA_EXTERN LspPosition* lsp_range_get_start (LspRange* self);
VALA_EXTERN LspPosition* lsp_range_get_end (LspRange* self);
VALA_EXTERN gsize vls_util_get_string_pos (const gchar* str,
                               guint lineno,
                               guint charno);
VALA_EXTERN guint lsp_position_get_line (LspPosition* self);
VALA_EXTERN guint lsp_position_get_character (LspPosition* self);
VALA_EXTERN void vls_text_document_set_last_updated (VlsTextDocument* self,
                                         GDateTime* value);
VALA_EXTERN void vls_text_document_set_version (VlsTextDocument* self,
                                    gint value);
static VlsProject** _vala_array_dup16 (VlsProject** self,
                                gssize length);
static void _vala_array_add28 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN gboolean vls_project_reconfigure_if_stale (VlsProject* self,
                                           GCancellable* cancellable,
                                           GError** error);
VALA_EXTERN GeeCollection* vls_compilation_get_project_files (VlsCompilation* self);
static gchar* _________lambda49_ (VlsServer* self,
                           ValaSourceFile* f);
static gpointer __________lambda49__gee_map_func (gpointer g,
                                           gpointer self);
VALA_EXTERN ValaCodeContext* vls_compilation_get_code_context (VlsCompilation* self);
VALA_EXTERN void vls_gir_documentation_rebuild_if_stale (VlsGirDocumentation* self);
VALA_EXTERN void vls_server_wait_for_context_update (VlsServer* self,
                                         GVariant* id,
                                         VlsServerOnContextUpdatedFunc on_context_updated_func,
                                         gpointer on_context_updated_func_target,
                                         GDestroyNotify on_context_updated_func_target_destroy_notify);
VALA_EXTERN gchar* vls_request_to_string (VlsRequest* self);
static void vls_server_wait_for_context_update_aux (VlsServer* self,
                                             VlsRequest* req,
                                             VlsServerOnContextUpdatedFunc on_context_updated_func,
                                             gpointer on_context_updated_func_target,
                                             GDestroyNotify on_context_updated_func_target_destroy_notify);
static Block29Data* block29_data_ref (Block29Data* _data29_);
static void block29_data_unref (void * _userdata_);
static gboolean ___lambda50_ (Block29Data* _data29_);
static gboolean ____lambda50__gsource_func (gpointer self);
static Block30Data* block30_data_ref (Block30Data* _data30_);
static void block30_data_unref (void * _userdata_);
VALA_EXTERN const gchar* vls_build_target_get_id (VlsBuildTarget* self);
VALA_EXTERN GType vls_reporter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsReporter, vala_report_unref)
VALA_EXTERN VlsReporter* vls_compilation_get_reporter (VlsCompilation* self);
VALA_EXTERN gpointer vls_source_message_ref (gpointer instance);
VALA_EXTERN void vls_source_message_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_source_message (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags);
VALA_EXTERN void vls_value_set_source_message (GValue* value,
                                   gpointer v_object);
VALA_EXTERN void vls_value_take_source_message (GValue* value,
                                    gpointer v_object);
VALA_EXTERN gpointer vls_value_get_source_message (const GValue* value);
VALA_EXTERN GType vls_source_message_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsSourceMessage, vls_source_message_unref)
static void __lambda48_ (Block30Data* _data30_,
                  VlsSourceMessage* err);
VALA_EXTERN GType lsp_diagnostic_severity_get_type (void) G_GNUC_CONST ;
VALA_EXTERN LspPosition* lsp_position_new (void);
VALA_EXTERN LspPosition* lsp_position_construct (GType object_type);
VALA_EXTERN void lsp_position_set_line (LspPosition* self,
                            guint value);
VALA_EXTERN void lsp_position_set_character (LspPosition* self,
                                 guint value);
VALA_EXTERN LspRange* lsp_range_new (void);
VALA_EXTERN LspRange* lsp_range_construct (GType object_type);
VALA_EXTERN void lsp_range_set_start (LspRange* self,
                          LspPosition* value);
VALA_EXTERN void lsp_range_set_end (LspRange* self,
                        LspPosition* value);
VALA_EXTERN GType lsp_diagnostic_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDiagnostic, g_object_unref)
VALA_EXTERN LspDiagnostic* lsp_diagnostic_new (void);
VALA_EXTERN LspDiagnostic* lsp_diagnostic_construct (GType object_type);
VALA_EXTERN void lsp_diagnostic_set_range (LspDiagnostic* self,
                               LspRange* value);
VALA_EXTERN void lsp_diagnostic_set_severity (LspDiagnostic* self,
                                  LspDiagnosticSeverity value);
VALA_EXTERN void lsp_diagnostic_set_message (LspDiagnostic* self,
                                 const gchar* value);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void _vala_JsonNode_free (JsonNode* self);
static void ___lambda48__gfunc (gconstpointer data,
                         gpointer self);
VALA_EXTERN const gchar* vls_project_get_root_path (VlsProject* self);
VALA_EXTERN GType vls_node_search_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsNodeSearch, vala_code_visitor_unref)
VALA_EXTERN ValaCodeNode* vls_server_get_best (VlsNodeSearch* fs,
                                   ValaSourceFile* file);
VALA_EXTERN LspPosition* lsp_position_new_from_libvala (ValaSourceLocation* sloc);
VALA_EXTERN LspPosition* lsp_position_construct_from_libvala (GType object_type,
                                                  ValaSourceLocation* sloc);
VALA_EXTERN GType lsp_text_document_position_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentPositionParams, g_object_unref)
static Block31Data* block31_data_ref (Block31Data* _data31_);
static void block31_data_unref (void * _userdata_);
static void __lambda51_ (Block31Data* _data31_,
                  gboolean request_cancelled);
VALA_EXTERN GType lsp_text_document_identifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentIdentifier, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_text_document_position_params_get_textDocument (LspTextDocumentPositionParams* self);
VALA_EXTERN const gchar* lsp_text_document_identifier_get_uri (LspTextDocumentIdentifier* self);
VALA_EXTERN LspPosition* lsp_text_document_position_params_get_position (LspTextDocumentPositionParams* self);
VALA_EXTERN VlsNodeSearch* vls_node_search_new (ValaSourceFile* file,
                                    LspPosition* pos,
                                    gboolean search_multiline,
                                    LspPosition* end_pos,
                                    gboolean must_be_symbol);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct (GType object_type,
                                          ValaSourceFile* file,
                                          LspPosition* pos,
                                          gboolean search_multiline,
                                          LspPosition* end_pos,
                                          gboolean must_be_symbol);
VALA_EXTERN ValaSymbol* vls_symbol_references_get_symbol_data_type_refers_to (ValaDataType* data_type);
VALA_EXTERN ValaSymbol* vls_symbol_references_find_real_symbol (VlsProject* project,
                                                    ValaSymbol* symbol);
VALA_EXTERN GType lsp_location_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspLocation, g_object_unref)
VALA_EXTERN LspLocation* lsp_location_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspLocation* lsp_location_construct_from_sourceref (GType object_type,
                                                    ValaSourceReference* sref);
VALA_EXTERN const gchar* lsp_location_get_uri (LspLocation* self);
VALA_EXTERN GVariant* vls_util_object_to_variant (GObject* object,
                                      GError** error);
static void ___lambda51__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block32Data* block32_data_ref (Block32Data* _data32_);
static void block32_data_unref (void * _userdata_);
static void __lambda52_ (Block32Data* _data32_,
                  gboolean request_cancelled);
VALA_EXTERN GType vls_symbol_enumerator_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsSymbolEnumerator, vala_code_visitor_unref)
VALA_EXTERN gpointer vls_compilation_get_analysis_for_file (VlsCompilation* self,
                                                GType t_type,
                                                GBoxedCopyFunc t_dup_func,
                                                GDestroyNotify t_destroy_func,
                                                ValaSourceFile* source);
VALA_EXTERN GType lsp_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspClientCapabilities, g_object_unref)
VALA_EXTERN LspClientCapabilities* lsp_initialize_params_get_capabilities (LspInitializeParams* self);
VALA_EXTERN GType lsp_text_document_client_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentClientCapabilities, g_object_unref)
VALA_EXTERN LspTextDocumentClientCapabilities* lsp_client_capabilities_get_textDocument (LspClientCapabilities* self);
VALA_EXTERN GType lsp_document_symbol_capabilities_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbolCapabilities, g_object_unref)
VALA_EXTERN LspDocumentSymbolCapabilities* lsp_text_document_client_capabilities_get_documentSymbol (LspTextDocumentClientCapabilities* self);
VALA_EXTERN gboolean lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (LspDocumentSymbolCapabilities* self);
VALA_EXTERN GType lsp_document_symbol_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentSymbol, g_object_unref)
VALA_EXTERN GeeIterator* vls_symbol_enumerator_iterator (VlsSymbolEnumerator* self);
VALA_EXTERN GType lsp_symbol_information_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspSymbolInformation, g_object_unref)
VALA_EXTERN GeeIterable* vls_symbol_enumerator_flattened (VlsSymbolEnumerator* self);
static void ___lambda52__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
VALA_EXTERN gpointer vls_doc_comment_ref (gpointer instance);
VALA_EXTERN void vls_doc_comment_unref (gpointer instance);
VALA_EXTERN GParamSpec* vls_param_spec_doc_comment (const gchar* name,
                                        const gchar* nick,
                                        const gchar* blurb,
                                        GType object_type,
                                        GParamFlags flags);
VALA_EXTERN void vls_value_set_doc_comment (GValue* value,
                                gpointer v_object);
VALA_EXTERN void vls_value_take_doc_comment (GValue* value,
                                 gpointer v_object);
VALA_EXTERN gpointer vls_value_get_doc_comment (const GValue* value);
VALA_EXTERN GType vls_doc_comment_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsDocComment, vls_doc_comment_unref)
VALA_EXTERN VlsDocComment* vls_server_get_symbol_documentation (VlsServer* self,
                                                    VlsProject* project,
                                                    ValaSymbol* sym);
VALA_EXTERN ValaSymbol* vls_gir_documentation_find_gir_symbol (VlsGirDocumentation* self,
                                                   ValaSymbol* sym);
VALA_EXTERN VlsDocComment* vls_doc_comment_new_from_gir_comment (ValaComment* comment,
                                                     VlsGirDocumentation* documentation,
                                                     VlsCompilation* compilation,
                                                     GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct_from_gir_comment (GType object_type,
                                                           ValaComment* comment,
                                                           VlsGirDocumentation* documentation,
                                                           VlsCompilation* compilation,
                                                           GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_new_from_valadoc_comment (ValaComment* comment,
                                                         ValaSymbol* symbol,
                                                         VlsCompilation* compilation,
                                                         GError** error);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct_from_valadoc_comment (GType object_type,
                                                               ValaComment* comment,
                                                               ValaSymbol* symbol,
                                                               VlsCompilation* compilation,
                                                               GError** error);
VALA_EXTERN GeeHashMap* vls_doc_comment_get_parameters (VlsDocComment* self);
VALA_EXTERN VlsDocComment* vls_doc_comment_new (const gchar* markdown_doc);
VALA_EXTERN VlsDocComment* vls_doc_comment_construct (GType object_type,
                                          const gchar* markdown_doc);
VALA_EXTERN GType lsp_completion_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionParams, g_object_unref)
VALA_EXTERN GType lsp_completion_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCompletionContext, g_object_unref)
VALA_EXTERN void vls_completion_engine_begin_response (VlsServer* lang_serv,
                                           VlsProject* project,
                                           JsonrpcClient* client,
                                           GVariant* id,
                                           const gchar* method,
                                           ValaSourceFile* doc,
                                           VlsCompilation* compilation,
                                           LspPosition* pos,
                                           LspCompletionContext* completion_context);
VALA_EXTERN LspCompletionContext* lsp_completion_params_get_context (LspCompletionParams* self);
VALA_EXTERN void vls_signature_help_engine_begin_response (VlsServer* lang_serv,
                                               VlsProject* project,
                                               JsonrpcClient* client,
                                               GVariant* id,
                                               const gchar* method,
                                               ValaSourceFile* doc,
                                               VlsCompilation* compilation,
                                               LspPosition* pos);
static Block33Data* block33_data_ref (Block33Data* _data33_);
static void block33_data_unref (void * _userdata_);
static void __lambda65_ (Block33Data* _data33_,
                  gboolean request_cancelled);
VALA_EXTERN VlsFindScope* vls_find_scope_new (ValaSourceFile* file,
                                  LspPosition* pos,
                                  gboolean before_context_update);
VALA_EXTERN VlsFindScope* vls_find_scope_construct (GType object_type,
                                        ValaSourceFile* file,
                                        LspPosition* pos,
                                        gboolean before_context_update);
VALA_EXTERN GType vls_find_scope_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsFindScope, vala_code_visitor_unref)
VALA_EXTERN ValaSymbol* vls_find_scope_get_best_block (VlsFindScope* self);
VALA_EXTERN GType lsp_hover_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspHover, g_object_unref)
VALA_EXTERN LspHover* lsp_hover_new (void);
VALA_EXTERN LspHover* lsp_hover_construct (GType object_type);
VALA_EXTERN LspRange* vls_symbol_references_get_replacement_range (ValaCodeNode* code_node,
                                                       ValaSymbol* symbol);
VALA_EXTERN gboolean lsp_range_contains (LspRange* self,
                             LspPosition* pos);
VALA_EXTERN GeeCollection* vls_symbol_references_get_visible_components_of_code_node (ValaCodeNode* code_node);
VALA_EXTERN void lsp_hover_set_range (LspHover* self,
                          LspRange* value);
VALA_EXTERN LspRange* lsp_range_new_from_sourceref (ValaSourceReference* sref);
VALA_EXTERN LspRange* lsp_range_construct_from_sourceref (GType object_type,
                                              ValaSourceReference* sref);
VALA_EXTERN gchar* vls_code_help_get_symbol_representation (ValaDataType* data_type,
                                                ValaSymbol* sym,
                                                ValaScope* scope,
                                                gboolean allow_show_parent_member,
                                                ValaList* method_type_arguments,
                                                const gchar* override_name,
                                                gboolean show_initializers,
                                                gboolean is_parent_symbol,
                                                ValaList* ellipsis_overrides,
                                                gboolean show_parameter_direction);
VALA_EXTERN GType lsp_marked_string_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspMarkedString, g_object_unref)
VALA_EXTERN GeeList* lsp_hover_get_contents (LspHover* self);
VALA_EXTERN LspMarkedString* lsp_marked_string_new (void);
VALA_EXTERN LspMarkedString* lsp_marked_string_construct (GType object_type);
VALA_EXTERN void lsp_marked_string_set_language (LspMarkedString* self,
                                     const gchar* value);
VALA_EXTERN void lsp_marked_string_set_value (LspMarkedString* self,
                                  const gchar* value);
VALA_EXTERN const gchar* vls_doc_comment_get_body (VlsDocComment* self);
static void ___lambda65__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
VALA_EXTERN GType lsp_document_highlight_kind_get_type (void) G_GNUC_CONST ;
static LspDocumentHighlightKind vls_server_determine_node_highlight_kind (VlsServer* self,
                                                                   ValaCodeNode* node);
VALA_EXTERN GType lsp_reference_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspReferenceParams, g_object_unref)
static Block34Data* block34_data_ref (Block34Data* _data34_);
static void block34_data_unref (void * _userdata_);
static void __lambda66_ (Block34Data* _data34_,
                  gboolean request_cancelled);
VALA_EXTERN GType lsp_reference_params_reference_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspReferenceParamsReferenceContext, g_object_unref)
VALA_EXTERN LspReferenceParamsReferenceContext* lsp_reference_params_get_context (LspReferenceParams* self);
VALA_EXTERN gboolean lsp_reference_params_reference_context_get_includeDeclaration (LspReferenceParamsReferenceContext* self);
VALA_EXTERN void vls_symbol_references_list_in_file (ValaSourceFile* file,
                                         ValaSymbol* symbol,
                                         gboolean include_declaration,
                                         gboolean include_invisible,
                                         GeeHashMap* references);
VALA_EXTERN GeeArrayList* vls_build_target_get_output (VlsBuildTarget* self);
VALA_EXTERN GeeCollection* vls_symbol_references_get_compilations_using_symbol (VlsProject* project,
                                                                    ValaSymbol* symbol);
VALA_EXTERN GType lsp_document_highlight_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentHighlight, g_object_unref)
VALA_EXTERN LspDocumentHighlight* lsp_document_highlight_new (void);
VALA_EXTERN LspDocumentHighlight* lsp_document_highlight_construct (GType object_type);
VALA_EXTERN void lsp_document_highlight_set_range (LspDocumentHighlight* self,
                                       LspRange* value);
VALA_EXTERN void lsp_document_highlight_set_kind (LspDocumentHighlight* self,
                                      LspDocumentHighlightKind value);
VALA_EXTERN LspLocation* lsp_location_new (const gchar* filename,
                               LspRange* range);
VALA_EXTERN LspLocation* lsp_location_construct (GType object_type,
                                     const gchar* filename,
                                     LspRange* range);
static void ___lambda66__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block35Data* block35_data_ref (Block35Data* _data35_);
static void block35_data_unref (void * _userdata_);
static void __lambda67_ (Block35Data* _data35_,
                  gboolean request_cancelled);
static gboolean _______lambda68_ (ValaCodeNode* needle,
                           ValaCodeNode* node);
static gboolean ________lambda68__vls_node_search_filter (ValaCodeNode* needle,
                                                   ValaCodeNode* hay_node);
VALA_EXTERN VlsNodeSearch* vls_node_search_new_with_filter (ValaSourceFile* file,
                                                ValaCodeNode* needle,
                                                VlsNodeSearchFilter filter_func,
                                                gboolean include_declaration);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct_with_filter (GType object_type,
                                                      ValaSourceFile* file,
                                                      ValaCodeNode* needle,
                                                      VlsNodeSearchFilter filter_func,
                                                      gboolean include_declaration);
static gboolean ________lambda69_ (ValaCodeNode* needle,
                            ValaCodeNode* node);
static gboolean _________lambda69__vls_node_search_filter (ValaCodeNode* needle,
                                                    ValaCodeNode* hay_node);
static gboolean ________lambda70_ (ValaCodeNode* needle,
                            ValaCodeNode* node);
static gboolean _________lambda70__vls_node_search_filter (ValaCodeNode* needle,
                                                    ValaCodeNode* hay_node);
static void ___lambda67__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
VALA_EXTERN GType lsp_document_range_formatting_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspDocumentRangeFormattingParams, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_document_range_formatting_params_get_textDocument (LspDocumentRangeFormattingParams* self);
VALA_EXTERN GType lsp_text_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextEdit, g_object_unref)
VALA_EXTERN GType vls_code_style_analyzer_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (VlsCodeStyleAnalyzer, vala_code_visitor_unref)
VALA_EXTERN GType lsp_formatting_options_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspFormattingOptions, g_object_unref)
VALA_EXTERN GQuark formatting_error_quark (void);
VALA_EXTERN GType formatting_error_get_type (void) G_GNUC_CONST ;
VALA_EXTERN LspTextEdit* vls_formatter_format (LspFormattingOptions* options,
                                   VlsCodeStyleAnalyzer* analyzed_style,
                                   ValaSourceFile* source,
                                   LspRange* range,
                                   GCancellable* cancellable,
                                   GError** error);
VALA_EXTERN LspFormattingOptions* lsp_document_range_formatting_params_get_options (LspDocumentRangeFormattingParams* self);
VALA_EXTERN LspRange* lsp_document_range_formatting_params_get_range (LspDocumentRangeFormattingParams* self);
VALA_EXTERN GType lsp_code_action_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeActionParams, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_code_action_params_get_textDocument (LspCodeActionParams* self);
VALA_EXTERN GType lsp_code_action_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeAction, g_object_unref)
VALA_EXTERN GType lsp_code_action_context_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCodeActionContext, g_object_unref)
VALA_EXTERN ValaCollection* vls_code_actions_extract (LspCodeActionContext* context,
                                          VlsCompilation* compilation,
                                          VlsTextDocument* file,
                                          LspRange* range,
                                          const gchar* uri);
VALA_EXTERN LspCodeActionContext* lsp_code_action_params_get_context (LspCodeActionParams* self);
VALA_EXTERN LspRange* lsp_code_action_params_get_range (LspCodeActionParams* self);
static Block36Data* block36_data_ref (Block36Data* _data36_);
static void block36_data_unref (void * _userdata_);
static gchar* _variant_get10 (GVariant* value);
static void __lambda71_ (Block36Data* _data36_,
                  gboolean request_cancelled);
static Block37Data* block37_data_ref (Block37Data* _data37_);
static void block37_data_unref (void * _userdata_);
static VlsProject** _vala_array_dup17 (VlsProject** self,
                                gssize length);
static void _vala_array_add29 (VlsProject** * array,
                        gint* length,
                        gint* size,
                        VlsProject* value);
VALA_EXTERN GeeIterable* vls_project_get_project_source_files (VlsProject* self);
static gboolean _______lambda72_ (Block37Data* _data37_,
                           LspSymbolInformation* dsym);
VALA_EXTERN const gchar* lsp_symbol_information_get_name (LspSymbolInformation* self);
static gboolean ________lambda72__gee_predicate (gconstpointer g,
                                          gpointer self);
static gboolean _______lambda73_ (Block37Data* _data37_,
                           LspSymbolInformation* dsym);
static gboolean ________lambda73__gee_forall_func (gpointer g,
                                            gpointer self);
static void ___lambda71__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block38Data* block38_data_ref (Block38Data* _data38_);
static void block38_data_unref (void * _userdata_);
static gchar* _variant_get11 (GVariant* value);
static void __lambda74_ (Block38Data* _data38_,
                  gboolean request_cancelled);
VALA_EXTERN void vls_symbol_references_list_implementations_of_virtual_symbol (ValaSourceFile* file,
                                                                   ValaSymbol* symbol,
                                                                   GeeHashMap* references);
VALA_EXTERN gchar* vls_code_help_get_code_node_source (ValaCodeNode* node);
VALA_EXTERN LspTextEdit* lsp_text_edit_new (LspRange* range,
                                const gchar* new_text);
VALA_EXTERN LspTextEdit* lsp_text_edit_construct (GType object_type,
                                      LspRange* range,
                                      const gchar* new_text);
VALA_EXTERN GType lsp_versioned_text_document_identifier_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspVersionedTextDocumentIdentifier, g_object_unref)
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_versioned_text_document_identifier_new (void);
VALA_EXTERN LspVersionedTextDocumentIdentifier* lsp_versioned_text_document_identifier_construct (GType object_type);
VALA_EXTERN void lsp_versioned_text_document_identifier_set_version (LspVersionedTextDocumentIdentifier* self,
                                                         gint value);
VALA_EXTERN void lsp_text_document_identifier_set_uri (LspTextDocumentIdentifier* self,
                                           const gchar* value);
VALA_EXTERN GType lsp_text_document_edit_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTextDocumentEdit, g_object_unref)
VALA_EXTERN LspTextDocumentEdit* lsp_text_document_edit_new (LspVersionedTextDocumentIdentifier* text_document);
VALA_EXTERN LspTextDocumentEdit* lsp_text_document_edit_construct (GType object_type,
                                                       LspVersionedTextDocumentIdentifier* text_document);
VALA_EXTERN void lsp_text_document_edit_set_edits (LspTextDocumentEdit* self,
                                       GeeArrayList* value);
static void ___lambda74__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static Block39Data* block39_data_ref (Block39Data* _data39_);
static void block39_data_unref (void * _userdata_);
static void __lambda75_ (Block39Data* _data39_,
                  gboolean request_cancelled);
static void ___lambda75__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                      gpointer self);
static gchar* _variant_get12 (GVariant* value);
VALA_EXTERN void vls_code_lens_engine_begin_response (VlsServer* lang_serv,
                                          VlsProject* project,
                                          JsonrpcClient* client,
                                          GVariant* id,
                                          const gchar* method,
                                          ValaSourceFile* doc,
                                          VlsCompilation* compilation);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_item_new_from_symbol (ValaSymbol* symbol);
VALA_EXTERN LspCallHierarchyItem* lsp_call_hierarchy_item_construct_from_symbol (GType object_type,
                                                                     ValaSymbol* symbol);
VALA_EXTERN GType lsp_call_hierarchy_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyItem, g_object_unref)
VALA_EXTERN const gchar* lsp_call_hierarchy_item_get_uri (LspCallHierarchyItem* self);
VALA_EXTERN ValaSymbol* vls_code_help_lookup_symbol_full_name (const gchar* full_name,
                                                   ValaScope* scope,
                                                   GeeArrayList** components);
VALA_EXTERN const gchar* lsp_call_hierarchy_item_get_name (LspCallHierarchyItem* self);
VALA_EXTERN GType lsp_call_hierarchy_incoming_call_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyIncomingCall, g_object_unref)
VALA_EXTERN LspCallHierarchyIncomingCall** vls_call_hierarchy_get_incoming_calls (VlsProject* project,
                                                                      ValaSymbol* callable,
                                                                      gint* result_length1);
static void _vala_array_add30 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
VALA_EXTERN GType lsp_call_hierarchy_outgoing_call_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspCallHierarchyOutgoingCall, g_object_unref)
VALA_EXTERN LspCallHierarchyOutgoingCall** vls_call_hierarchy_get_outgoing_calls (VlsProject* project,
                                                                      ValaSubroutine* subroutine,
                                                                      gint* result_length1);
static void _vala_array_add31 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
VALA_EXTERN GType lsp_inlay_hint_params_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInlayHintParams, g_object_unref)
VALA_EXTERN LspTextDocumentIdentifier* lsp_inlay_hint_params_get_textDocument (LspInlayHintParams* self);
VALA_EXTERN LspRange* lsp_inlay_hint_params_get_range (LspInlayHintParams* self);
VALA_EXTERN VlsNodeSearch* vls_node_search_new_within (ValaSourceFile* file,
                                           LspRange* range,
                                           gboolean must_be_symbol);
VALA_EXTERN VlsNodeSearch* vls_node_search_construct_within (GType object_type,
                                                 ValaSourceFile* file,
                                                 LspRange* range,
                                                 gboolean must_be_symbol);
VALA_EXTERN gchar* lsp_range_to_string (LspRange* self);
VALA_EXTERN GType lsp_inlay_hint_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspInlayHint, g_object_unref)
VALA_EXTERN GeeHashSet* vls_compilation_get_var_decls (VlsCompilation* self);
VALA_EXTERN gchar* vls_code_help_get_data_type_representation (ValaDataType* data_type,
                                                   ValaScope* scope,
                                                   gboolean hide_imported_namespace_parent);
VALA_EXTERN GType lsp_inlay_hint_kind_get_type (void) G_GNUC_CONST ;
VALA_EXTERN LspInlayHint* lsp_inlay_hint_new (void);
VALA_EXTERN LspInlayHint* lsp_inlay_hint_construct (GType object_type);
VALA_EXTERN void lsp_inlay_hint_set_position (LspInlayHint* self,
                                  LspPosition* value);
VALA_EXTERN void lsp_inlay_hint_set_label (LspInlayHint* self,
                               const gchar* value);
VALA_EXTERN void lsp_inlay_hint_set_kind (LspInlayHint* self,
                              LspInlayHintKind value);
VALA_EXTERN void lsp_inlay_hint_set_paddingLeft (LspInlayHint* self,
                                     gboolean value);
static void _vala_array_add32 (LspInlayHint** * array,
                        gint* length,
                        gint* size,
                        LspInlayHint* value);
VALA_EXTERN LspRange* vls_symbol_references_get_narrowed_source_reference (ValaSourceReference* source_reference,
                                                               const gchar* representation,
                                                               gint start,
                                                               gint end);
static void _vala_array_add33 (LspInlayHint** * array,
                        gint* length,
                        gint* size,
                        LspInlayHint* value);
VALA_EXTERN void lsp_inlay_hint_set_paddingRight (LspInlayHint* self,
                                      gboolean value);
static void _vala_array_add34 (LspInlayHint** * array,
                        gint* length,
                        gint* size,
                        LspInlayHint* value);
VALA_EXTERN GeeHashMap* vls_compilation_get_method_calls (VlsCompilation* self);
static void _vala_array_add35 (LspInlayHint** * array,
                        gint* length,
                        gint* size,
                        LspInlayHint* value);
static void _vala_array_add36 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
VALA_EXTERN LspTypeHierarchyItem* lsp_typehierarchy_item_new_from_symbol (ValaTypeSymbol* symbol);
VALA_EXTERN LspTypeHierarchyItem* lsp_typehierarchy_item_construct_from_symbol (GType object_type,
                                                                    ValaTypeSymbol* symbol);
VALA_EXTERN GType lsp_typehierarchy_item_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (LspTypeHierarchyItem, g_object_unref)
VALA_EXTERN const gchar* lsp_typehierarchy_item_get_uri (LspTypeHierarchyItem* self);
VALA_EXTERN const gchar* lsp_typehierarchy_item_get_name (LspTypeHierarchyItem* self);
VALA_EXTERN LspTypeHierarchyItem** vls_type_hierarchy_get_supertypes (VlsProject* project,
                                                          ValaTypeSymbol* symbol,
                                                          gint* result_length1);
static void _vala_array_add37 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
VALA_EXTERN LspTypeHierarchyItem** vls_type_hierarchy_get_subtypes (VlsProject* project,
                                                        ValaTypeSymbol* symbol,
                                                        gint* result_length1);
static void _vala_array_add38 (GVariant** * array,
                        gint* length,
                        gint* size,
                        GVariant* value);
static GVariant* _variant_new1 (GVariant** value,
                         gint value_length1);
static void _vls_server___lambda77_ (void);
static void __vls_server___lambda77____sighandler_t (gint signum);
static void _vls_server___lambda78_ (void);
static void __vls_server___lambda78____sighandler_t (gint signum);
static void vls_server_finalize (GObject * obj);
static GType vls_server_get_type_once (void);
static gint _vala_main (gchar** args,
                 gint args_length1);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static GRegex* _tmp_regex_0 = NULL;
static GRegex* _tmp_regex_1 = NULL;
static GRegex* _tmp_regex_2 = NULL;
const GOptionEntry entries[2] = {{"version", 'v', (gint) G_OPTION_FLAG_NONE, G_OPTION_ARG_NONE, &opt_version, "Print the version and commit info", NULL}, {0}};

static inline gpointer
vls_server_get_instance_private (VlsServer* self)
{
	return G_STRUCT_MEMBER_P (self, VlsServer_private_offset);
}

static gpointer
_g_main_loop_ref0 (gpointer self)
{
#line 81 "../src/server.vala"
	return self ? g_main_loop_ref (self) : NULL;
#line 1785 "server.c"
}

static gboolean
_vls_server_check_signal_gsource_func (gpointer self)
{
	gboolean result;
	result = vls_server_check_signal ((VlsServer*) self);
#line 117 "../src/server.vala"
	return result;
#line 1795 "server.c"
}

static void
_vala_array_add23 (guint* * array,
                   gint* length,
                   gint* size,
                   guint value)
{
#line 117 "../src/server.vala"
	if ((*length) == (*size)) {
#line 117 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 117 "../src/server.vala"
		*array = g_renew (guint, *array, *size);
#line 1810 "server.c"
	}
#line 117 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 1814 "server.c"
}

static guint
_vls_request_hash_gee_hash_data_func (gconstpointer v,
                                      gpointer self)
{
	guint result;
	result = vls_request_hash ((VlsRequest*) v);
#line 121 "../src/server.vala"
	return result;
#line 1825 "server.c"
}

static gboolean
_vls_request_equal_gee_equal_data_func (gconstpointer a,
                                        gconstpointer b,
                                        gpointer self)
{
	gboolean result;
	result = vls_request_equal ((VlsRequest*) a, (VlsRequest*) b);
#line 121 "../src/server.vala"
	return result;
#line 1837 "server.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 123 "../src/server.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1845 "server.c"
}

VlsServer*
vls_server_construct (GType object_type,
                      GMainLoop* loop)
{
	VlsServer * self = NULL;
	GMainLoop* _tmp0_;
	gint new_stdout_fd = 0;
	GUnixInputStream* input_stream = NULL;
	GUnixInputStream* _tmp1_;
	GUnixOutputStream* output_stream = NULL;
	GUnixOutputStream* _tmp2_;
	GUnixInputStream* _tmp6_;
	GUnixOutputStream* _tmp7_;
	GSimpleIOStream* _tmp8_;
	GSimpleIOStream* _tmp9_;
	GeeHashSet* _tmp10_;
	GHashFunc _tmp11_;
	GEqualFunc _tmp12_;
	GHashTable* _tmp13_;
	GError* _inner_error0_ = NULL;
#line 80 "../src/server.vala"
	g_return_val_if_fail (loop != NULL, NULL);
#line 80 "../src/server.vala"
	self = (VlsServer*) g_object_new (object_type, NULL);
#line 81 "../src/server.vala"
	_tmp0_ = _g_main_loop_ref0 (loop);
#line 81 "../src/server.vala"
	_g_main_loop_unref0 (self->priv->loop);
#line 81 "../src/server.vala"
	self->priv->loop = _tmp0_;
#line 97 "../src/server.vala"
	new_stdout_fd = dup (STDOUT_FILENO);
#line 98 "../src/server.vala"
	close (STDOUT_FILENO);
#line 99 "../src/server.vala"
	dup2 (STDERR_FILENO, STDOUT_FILENO);
#line 101 "../src/server.vala"
	_tmp1_ = (GUnixInputStream*) g_unix_input_stream_new (STDIN_FILENO, FALSE);
#line 101 "../src/server.vala"
	if (_tmp1_) {
#line 101 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "Vls.Server.new");
#line 1890 "server.c"
	}
#line 101 "../src/server.vala"
	input_stream = _tmp1_;
#line 102 "../src/server.vala"
	_tmp2_ = (GUnixOutputStream*) g_unix_output_stream_new (new_stdout_fd, FALSE);
#line 102 "../src/server.vala"
	if (_tmp2_) {
#line 102 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "Vls.Server.new");
#line 1900 "server.c"
	}
#line 102 "../src/server.vala"
	output_stream = _tmp2_;
#line 1904 "server.c"
	{
		gboolean _tmp3_ = FALSE;
		gboolean _tmp4_ = FALSE;
#line 106 "../src/server.vala"
		_tmp4_ = g_unix_set_fd_nonblocking (STDIN_FILENO, TRUE, &_inner_error0_);
#line 106 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1912 "server.c"
			goto __catch0_g_error;
		}
#line 106 "../src/server.vala"
		if (!_tmp4_) {
#line 106 "../src/server.vala"
			_tmp3_ = TRUE;
#line 1919 "server.c"
		} else {
			gboolean _tmp5_ = FALSE;
#line 107 "../src/server.vala"
			_tmp5_ = g_unix_set_fd_nonblocking (new_stdout_fd, TRUE, &_inner_error0_);
#line 107 "../src/server.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1926 "server.c"
				goto __catch0_g_error;
			}
#line 107 "../src/server.vala"
			_tmp3_ = !_tmp5_;
#line 1931 "server.c"
		}
#line 106 "../src/server.vala"
		if (_tmp3_) {
#line 108 "../src/server.vala"
			g_error ("server.vala:108: could not set pipes to nonblocking.\n");
#line 1937 "server.c"
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
#line 105 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 110 "../src/server.vala"
		g_warning ("server.vala:110: failed to set FDs to nonblocking");
#line 111 "../src/server.vala"
		g_main_loop_quit (loop);
#line 112 "../src/server.vala"
		_g_object_unref0 (output_stream);
#line 112 "../src/server.vala"
		_g_object_unref0 (input_stream);
#line 112 "../src/server.vala"
		return self;
#line 1955 "server.c"
	}
	__finally0:
#line 105 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 105 "../src/server.vala"
		_g_object_unref0 (output_stream);
#line 105 "../src/server.vala"
		_g_object_unref0 (input_stream);
#line 105 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 105 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 105 "../src/server.vala"
		return NULL;
#line 1970 "server.c"
	}
#line 117 "../src/server.vala"
	_vala_array_add23 (&self->priv->g_sources, &self->priv->g_sources_length1, &self->priv->_g_sources_size_, g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 1000, _vls_server_check_signal_gsource_func, g_object_ref (self), g_object_unref));
#line 119 "../src/server.vala"
	_tmp6_ = input_stream;
#line 119 "../src/server.vala"
	_tmp7_ = output_stream;
#line 119 "../src/server.vala"
	_tmp8_ = (GSimpleIOStream*) g_simple_io_stream_new ((GInputStream*) _tmp6_, (GOutputStream*) _tmp7_);
#line 119 "../src/server.vala"
	if (_tmp8_) {
#line 119 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp8_, "vala-creation-function", "Vls.Server.new");
#line 1984 "server.c"
	}
#line 119 "../src/server.vala"
	_tmp9_ = _tmp8_;
#line 119 "../src/server.vala"
	jsonrpc_server_accept_io_stream ((JsonrpcServer*) self, (GIOStream*) _tmp9_);
#line 119 "../src/server.vala"
	_g_object_unref0 (_tmp9_);
#line 121 "../src/server.vala"
	_tmp10_ = gee_hash_set_new (VLS_TYPE_REQUEST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_request_hash_gee_hash_data_func, NULL, NULL, _vls_request_equal_gee_equal_data_func, NULL, NULL);
#line 121 "../src/server.vala"
	if (_tmp10_) {
#line 121 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp10_, "vala-creation-function", "Vls.Server.new");
#line 1998 "server.c"
	}
#line 121 "../src/server.vala"
	_g_object_unref0 (self->priv->pending_requests);
#line 121 "../src/server.vala"
	self->priv->pending_requests = _tmp10_;
#line 123 "../src/server.vala"
	_tmp11_ = g_direct_hash;
#line 123 "../src/server.vala"
	_tmp12_ = g_direct_equal;
#line 123 "../src/server.vala"
	_tmp13_ = g_hash_table_new_full (_tmp11_, _tmp12_, _g_object_unref0_, NULL);
#line 123 "../src/server.vala"
	_g_hash_table_unref0 (self->priv->projects);
#line 123 "../src/server.vala"
	self->priv->projects = _tmp13_;
#line 125 "../src/server.vala"
	g_debug ("server.vala:125: Finished constructing");
#line 80 "../src/server.vala"
	_g_object_unref0 (output_stream);
#line 80 "../src/server.vala"
	_g_object_unref0 (input_stream);
#line 80 "../src/server.vala"
	return self;
#line 2022 "server.c"
}

VlsServer*
vls_server_new (GMainLoop* loop)
{
#line 80 "../src/server.vala"
	return vls_server_construct (VLS_TYPE_SERVER, loop);
#line 2030 "server.c"
}

static void
vls_server_real_notification (JsonrpcServer* base,
                              JsonrpcClient* client,
                              const gchar* method,
                              GVariant* parameters)
{
	VlsServer * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 129 "../src/server.vala"
	static GQuark _tmp1_label0 = 0;
#line 129 "../src/server.vala"
	static GQuark _tmp1_label1 = 0;
#line 129 "../src/server.vala"
	static GQuark _tmp1_label2 = 0;
#line 129 "../src/server.vala"
	static GQuark _tmp1_label3 = 0;
#line 129 "../src/server.vala"
	static GQuark _tmp1_label4 = 0;
#line 129 "../src/server.vala"
	static GQuark _tmp1_label5 = 0;
#line 128 "../src/server.vala"
	self = (VlsServer*) base;
#line 128 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 128 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 128 "../src/server.vala"
	g_return_if_fail (parameters != NULL);
#line 129 "../src/server.vala"
	_tmp0_ = method;
#line 129 "../src/server.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 129 "../src/server.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("exit")))) {
#line 129 "../src/server.vala"
		switch (0) {
#line 2070 "server.c"
			default:
			{
#line 131 "../src/server.vala"
				vls_server_exit (self);
#line 132 "../src/server.vala"
				break;
#line 2077 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("$/cancelRequest")))) {
#line 129 "../src/server.vala"
		switch (0) {
#line 2083 "server.c"
			default:
			{
#line 135 "../src/server.vala"
				vls_server_cancel_request (self, client, parameters);
#line 136 "../src/server.vala"
				break;
#line 2090 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("textDocument/didOpen")))) {
#line 129 "../src/server.vala"
		switch (0) {
#line 2096 "server.c"
			default:
			{
#line 139 "../src/server.vala"
				vls_server_text_document_did_open (self, client, parameters);
#line 140 "../src/server.vala"
				break;
#line 2103 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("textDocument/didSave")))) {
#line 129 "../src/server.vala"
		switch (0) {
#line 2109 "server.c"
			default:
			{
#line 143 "../src/server.vala"
				vls_server_text_document_did_save (self, client, parameters);
#line 144 "../src/server.vala"
				break;
#line 2116 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("textDocument/didClose")))) {
#line 129 "../src/server.vala"
		switch (0) {
#line 2122 "server.c"
			default:
			{
#line 147 "../src/server.vala"
				vls_server_text_document_did_close (self, client, parameters);
#line 148 "../src/server.vala"
				break;
#line 2129 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("textDocument/didChange")))) {
#line 129 "../src/server.vala"
		switch (0) {
#line 2135 "server.c"
			default:
			{
#line 151 "../src/server.vala"
				vls_server_text_document_did_change (self, client, parameters);
#line 152 "../src/server.vala"
				break;
#line 2142 "server.c"
			}
		}
	} else {
#line 129 "../src/server.vala"
		switch (0) {
#line 2148 "server.c"
			default:
			{
#line 155 "../src/server.vala"
				g_warning ("server.vala:155: unhandled notification `%s'", method);
#line 156 "../src/server.vala"
				break;
#line 2155 "server.c"
			}
		}
	}
}

static gboolean
vls_server_real_handle_call (JsonrpcServer* base,
                             JsonrpcClient* client,
                             const gchar* method,
                             GVariant* id,
                             GVariant* parameters)
{
	VlsServer * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label0 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label1 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label2 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label3 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label4 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label5 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label6 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label7 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label8 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label9 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label10 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label11 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label12 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label13 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label14 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label15 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label16 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label17 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label18 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label19 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label20 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label21 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label22 = 0;
#line 161 "../src/server.vala"
	static GQuark _tmp1_label23 = 0;
#line 2219 "server.c"
	gboolean result;
#line 160 "../src/server.vala"
	self = (VlsServer*) base;
#line 160 "../src/server.vala"
	g_return_val_if_fail (client != NULL, FALSE);
#line 160 "../src/server.vala"
	g_return_val_if_fail (method != NULL, FALSE);
#line 160 "../src/server.vala"
	g_return_val_if_fail (id != NULL, FALSE);
#line 160 "../src/server.vala"
	g_return_val_if_fail (parameters != NULL, FALSE);
#line 161 "../src/server.vala"
	_tmp0_ = method;
#line 161 "../src/server.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 161 "../src/server.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("initialize")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2239 "server.c"
			default:
			{
#line 163 "../src/server.vala"
				vls_server_initialize (self, client, method, id, parameters);
#line 164 "../src/server.vala"
				break;
#line 2246 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label1) ? _tmp1_label1 : (_tmp1_label1 = g_quark_from_static_string ("shutdown")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2252 "server.c"
			default:
			{
#line 167 "../src/server.vala"
				vls_server_shutdown (self);
#line 168 "../src/server.vala"
				vls_server_reply_null (id, client, method);
#line 169 "../src/server.vala"
				break;
#line 2261 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label2) ? _tmp1_label2 : (_tmp1_label2 = g_quark_from_static_string ("textDocument/definition")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2267 "server.c"
			default:
			{
#line 172 "../src/server.vala"
				vls_server_goto_definition (self, client, method, id, parameters);
#line 173 "../src/server.vala"
				break;
#line 2274 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label3) ? _tmp1_label3 : (_tmp1_label3 = g_quark_from_static_string ("textDocument/documentSymbol")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2280 "server.c"
			default:
			{
#line 176 "../src/server.vala"
				vls_server_document_symbol_outline (self, client, method, id, parameters);
#line 177 "../src/server.vala"
				break;
#line 2287 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label4) ? _tmp1_label4 : (_tmp1_label4 = g_quark_from_static_string ("textDocument/completion")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2293 "server.c"
			default:
			{
#line 180 "../src/server.vala"
				vls_server_show_completion (self, client, method, id, parameters);
#line 181 "../src/server.vala"
				break;
#line 2300 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label5) ? _tmp1_label5 : (_tmp1_label5 = g_quark_from_static_string ("textDocument/signatureHelp")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2306 "server.c"
			default:
			{
#line 184 "../src/server.vala"
				vls_server_show_signature_help (self, client, method, id, parameters);
#line 185 "../src/server.vala"
				break;
#line 2313 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label6) ? _tmp1_label6 : (_tmp1_label6 = g_quark_from_static_string ("textDocument/hover")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2319 "server.c"
			default:
			{
#line 188 "../src/server.vala"
				vls_server_hover (self, client, method, id, parameters);
#line 189 "../src/server.vala"
				break;
#line 2326 "server.c"
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label7) ? _tmp1_label7 : (_tmp1_label7 = g_quark_from_static_string ("textDocument/formatting")))) || (_tmp2_ == ((0 != _tmp1_label8) ? _tmp1_label8 : (_tmp1_label8 = g_quark_from_static_string ("textDocument/rangeFormatting"))))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2332 "server.c"
			default:
			{
#line 193 "../src/server.vala"
				vls_server_format (self, client, method, id, parameters);
#line 194 "../src/server.vala"
				break;
#line 2339 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label9) ? _tmp1_label9 : (_tmp1_label9 = g_quark_from_static_string ("textDocument/codeAction")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2345 "server.c"
			default:
			{
#line 197 "../src/server.vala"
				vls_server_code_action (self, client, method, id, parameters);
#line 198 "../src/server.vala"
				break;
#line 2352 "server.c"
			}
		}
	} else if ((_tmp2_ == ((0 != _tmp1_label10) ? _tmp1_label10 : (_tmp1_label10 = g_quark_from_static_string ("textDocument/references")))) || (_tmp2_ == ((0 != _tmp1_label11) ? _tmp1_label11 : (_tmp1_label11 = g_quark_from_static_string ("textDocument/documentHighlight"))))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2358 "server.c"
			default:
			{
#line 202 "../src/server.vala"
				vls_server_show_references (self, client, method, id, parameters);
#line 203 "../src/server.vala"
				break;
#line 2365 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label12) ? _tmp1_label12 : (_tmp1_label12 = g_quark_from_static_string ("textDocument/implementation")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2371 "server.c"
			default:
			{
#line 206 "../src/server.vala"
				vls_server_show_implementations (self, client, method, id, parameters);
#line 207 "../src/server.vala"
				break;
#line 2378 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label13) ? _tmp1_label13 : (_tmp1_label13 = g_quark_from_static_string ("workspace/symbol")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2384 "server.c"
			default:
			{
#line 210 "../src/server.vala"
				vls_server_search_workspace_symbols (self, client, method, id, parameters);
#line 211 "../src/server.vala"
				break;
#line 2391 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label14) ? _tmp1_label14 : (_tmp1_label14 = g_quark_from_static_string ("textDocument/rename")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2397 "server.c"
			default:
			{
#line 214 "../src/server.vala"
				vls_server_rename_symbol (self, client, method, id, parameters);
#line 215 "../src/server.vala"
				break;
#line 2404 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label15) ? _tmp1_label15 : (_tmp1_label15 = g_quark_from_static_string ("textDocument/prepareRename")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2410 "server.c"
			default:
			{
#line 218 "../src/server.vala"
				vls_server_prepare_rename_symbol (self, client, method, id, parameters);
#line 219 "../src/server.vala"
				break;
#line 2417 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label16) ? _tmp1_label16 : (_tmp1_label16 = g_quark_from_static_string ("textDocument/codeLens")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2423 "server.c"
			default:
			{
#line 222 "../src/server.vala"
				vls_server_code_lens (self, client, method, id, parameters);
#line 223 "../src/server.vala"
				break;
#line 2430 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label17) ? _tmp1_label17 : (_tmp1_label17 = g_quark_from_static_string ("textDocument/prepareCallHierarchy")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2436 "server.c"
			default:
			{
#line 226 "../src/server.vala"
				vls_server_prepare_call_hierarchy (self, client, method, id, parameters);
#line 227 "../src/server.vala"
				break;
#line 2443 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label18) ? _tmp1_label18 : (_tmp1_label18 = g_quark_from_static_string ("callHierarchy/incomingCalls")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2449 "server.c"
			default:
			{
#line 230 "../src/server.vala"
				vls_server_call_hierarchy_incoming_calls (self, client, method, id, parameters);
#line 231 "../src/server.vala"
				break;
#line 2456 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label19) ? _tmp1_label19 : (_tmp1_label19 = g_quark_from_static_string ("callHierarchy/outgoingCalls")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2462 "server.c"
			default:
			{
#line 234 "../src/server.vala"
				vls_server_call_hierarchy_outgoing_calls (self, client, method, id, parameters);
#line 235 "../src/server.vala"
				break;
#line 2469 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label20) ? _tmp1_label20 : (_tmp1_label20 = g_quark_from_static_string ("textDocument/inlayHint")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2475 "server.c"
			default:
			{
#line 238 "../src/server.vala"
				vls_server_show_inlay_hints (self, client, method, id, parameters);
#line 239 "../src/server.vala"
				break;
#line 2482 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label21) ? _tmp1_label21 : (_tmp1_label21 = g_quark_from_static_string ("textDocument/prepareTypeHierarchy")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2488 "server.c"
			default:
			{
#line 242 "../src/server.vala"
				vls_server_prepare_type_hierarchy (self, client, method, id, parameters);
#line 243 "../src/server.vala"
				break;
#line 2495 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label22) ? _tmp1_label22 : (_tmp1_label22 = g_quark_from_static_string ("typeHierarchy/supertypes")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2501 "server.c"
			default:
			{
#line 246 "../src/server.vala"
				vls_server_show_type_hierarchy (self, client, method, id, parameters, TRUE);
#line 247 "../src/server.vala"
				break;
#line 2508 "server.c"
			}
		}
	} else if (_tmp2_ == ((0 != _tmp1_label23) ? _tmp1_label23 : (_tmp1_label23 = g_quark_from_static_string ("typeHierarchy/subtypes")))) {
#line 161 "../src/server.vala"
		switch (0) {
#line 2514 "server.c"
			default:
			{
#line 250 "../src/server.vala"
				vls_server_show_type_hierarchy (self, client, method, id, parameters, FALSE);
#line 251 "../src/server.vala"
				break;
#line 2521 "server.c"
			}
		}
	} else {
#line 161 "../src/server.vala"
		switch (0) {
#line 2527 "server.c"
			default:
			{
#line 254 "../src/server.vala"
				g_warning ("server.vala:254: unhandled call `%s'", method);
#line 255 "../src/server.vala"
				result = FALSE;
#line 255 "../src/server.vala"
				return result;
#line 2536 "server.c"
			}
		}
	}
#line 257 "../src/server.vala"
	result = TRUE;
#line 257 "../src/server.vala"
	return result;
#line 2544 "server.c"
}

static void
vls_server_real_client_closed (JsonrpcServer* base,
                               JsonrpcClient* client)
{
	VlsServer * self;
#line 261 "../src/server.vala"
	self = (VlsServer*) base;
#line 261 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 262 "../src/server.vala"
	vls_server_shutdown (self);
#line 263 "../src/server.vala"
	vls_server_exit (self);
#line 2560 "server.c"
}

static gboolean
vls_server_check_signal (VlsServer* self)
{
	gboolean result;
#line 267 "../src/server.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 268 "../src/server.vala"
	if (vls_server_received_signal) {
#line 269 "../src/server.vala"
		vls_server_shutdown (self);
#line 270 "../src/server.vala"
		vls_server_exit (self);
#line 271 "../src/server.vala"
		result = G_SOURCE_REMOVE;
#line 271 "../src/server.vala"
		return result;
#line 2579 "server.c"
	}
#line 273 "../src/server.vala"
	result = !self->priv->shutting_down;
#line 273 "../src/server.vala"
	return result;
#line 2585 "server.c"
}

static gpointer
_g_variant_ref0 (gpointer self)
{
#line 285 "../src/server.vala"
	return self ? g_variant_ref (self) : NULL;
#line 2593 "server.c"
}

GVariant*
vls_server_build_dict (VlsServer* self,
                       ...)
{
	GVariantBuilder* builder = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariantBuilder* _tmp2_;
	GVariantBuilder* _tmp3_;
	va_list l = {0};
	GVariantBuilder* _tmp12_;
	GVariant* _tmp13_;
	GVariant* result;
#line 277 "../src/server.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 278 "../src/server.vala"
	_tmp0_ = g_variant_type_new ("a{sv}");
#line 278 "../src/server.vala"
	_tmp1_ = _tmp0_;
#line 278 "../src/server.vala"
	_tmp2_ = g_variant_builder_new (_tmp1_);
#line 278 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 278 "../src/server.vala"
	_g_variant_type_free0 (_tmp1_);
#line 278 "../src/server.vala"
	builder = _tmp3_;
#line 279 "../src/server.vala"
	va_start (l, self);
#line 280 "../src/server.vala"
	while (TRUE) {
#line 2627 "server.c"
		gchar* key = NULL;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		const gchar* _tmp6_;
		GVariant* val = NULL;
		GVariant* _tmp7_;
		GVariant* _tmp8_;
		GVariantBuilder* _tmp9_;
		const gchar* _tmp10_;
		GVariant* _tmp11_;
#line 281 "../src/server.vala"
		_tmp4_ = va_arg (l, gchar*);
#line 281 "../src/server.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 281 "../src/server.vala"
		key = _tmp5_;
#line 282 "../src/server.vala"
		_tmp6_ = key;
#line 282 "../src/server.vala"
		if (_tmp6_ == NULL) {
#line 283 "../src/server.vala"
			_g_free0 (key);
#line 283 "../src/server.vala"
			break;
#line 2652 "server.c"
		}
#line 285 "../src/server.vala"
		_tmp7_ = va_arg (l, GVariant*);
#line 285 "../src/server.vala"
		_tmp8_ = _g_variant_ref0 (_tmp7_);
#line 285 "../src/server.vala"
		val = _tmp8_;
#line 286 "../src/server.vala"
		_tmp9_ = builder;
#line 286 "../src/server.vala"
		_tmp10_ = key;
#line 286 "../src/server.vala"
		_tmp11_ = val;
#line 286 "../src/server.vala"
		g_variant_builder_add (_tmp9_, "{sv}", _tmp10_, _tmp11_, NULL);
#line 280 "../src/server.vala"
		_g_variant_unref0 (val);
#line 280 "../src/server.vala"
		_g_free0 (key);
#line 2672 "server.c"
	}
#line 288 "../src/server.vala"
	_tmp12_ = builder;
#line 288 "../src/server.vala"
	_tmp13_ = g_variant_builder_end (_tmp12_);
#line 288 "../src/server.vala"
	g_variant_ref_sink (_tmp13_);
#line 288 "../src/server.vala"
	result = _tmp13_;
#line 288 "../src/server.vala"
	va_end (l);
#line 288 "../src/server.vala"
	_g_variant_builder_unref0 (builder);
#line 288 "../src/server.vala"
	return result;
#line 2688 "server.c"
}

/**
     * Find a file with a URI. Will pick the first match.
     *
     * @param uri the URI of the file. may contain escape characters
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 302 "../src/server.vala"
	return self ? g_object_ref (self) : NULL;
#line 2701 "server.c"
}

static gpointer
_vala_source_file_ref0 (gpointer self)
{
#line 316 "../src/server.vala"
	return self ? vala_source_file_ref (self) : NULL;
#line 2709 "server.c"
}

static ValaSourceFile*
vls_server_find_file (VlsServer* self,
                      const gchar* uri,
                      VlsCompilation** compilation,
                      VlsProject** project)
{
	VlsCompilation* _vala_compilation = NULL;
	VlsProject* _vala_project = NULL;
	GeeArrayList* results = NULL;
	GeeArrayList* _tmp0_;
	VlsProject* selected_project = NULL;
	GHashTable* _tmp1_;
	guint _tmp2_ = 0;
	gconstpointer* _tmp3_;
	VlsProject* _tmp11_;
	VlsProject* _tmp19_;
	ValaSourceFile* result;
#line 296 "../src/server.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 296 "../src/server.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 297 "../src/server.vala"
	_tmp0_ = gee_array_list_new (VLS_TYPE_PAIR, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 297 "../src/server.vala"
	if (_tmp0_) {
#line 297 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "Vls.Server.find_file");
#line 2739 "server.c"
	}
#line 297 "../src/server.vala"
	results = _tmp0_;
#line 298 "../src/server.vala"
	selected_project = NULL;
#line 299 "../src/server.vala"
	_tmp1_ = self->priv->projects;
#line 299 "../src/server.vala"
	_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
#line 2749 "server.c"
	{
		VlsProject** p_collection = NULL;
		gint p_collection_length1 = 0;
		gint _p_collection_size_ = 0;
		gint p_it = 0;
#line 299 "../src/server.vala"
		p_collection = _tmp3_;
#line 299 "../src/server.vala"
		p_collection_length1 = _tmp2_;
#line 299 "../src/server.vala"
		for (p_it = 0; p_it < p_collection_length1; p_it = p_it + 1) {
#line 2761 "server.c"
			VlsProject* p = NULL;
#line 299 "../src/server.vala"
			p = p_collection[p_it];
#line 2765 "server.c"
			{
				VlsProject* _tmp4_;
				GeeArrayList* _tmp5_;
				GeeArrayList* _tmp6_;
				gboolean _tmp7_;
				gboolean _tmp8_;
#line 300 "../src/server.vala"
				_tmp4_ = p;
#line 300 "../src/server.vala"
				_tmp5_ = vls_project_lookup_compile_input_source_file (_tmp4_, uri);
#line 300 "../src/server.vala"
				_g_object_unref0 (results);
#line 300 "../src/server.vala"
				results = _tmp5_;
#line 301 "../src/server.vala"
				_tmp6_ = results;
#line 301 "../src/server.vala"
				_tmp7_ = gee_collection_get_is_empty ((GeeCollection*) _tmp6_);
#line 301 "../src/server.vala"
				_tmp8_ = _tmp7_;
#line 301 "../src/server.vala"
				if (!_tmp8_) {
#line 2788 "server.c"
					VlsProject* _tmp9_;
					VlsProject* _tmp10_;
#line 302 "../src/server.vala"
					_tmp9_ = p;
#line 302 "../src/server.vala"
					_tmp10_ = _g_object_ref0 (_tmp9_);
#line 302 "../src/server.vala"
					_g_object_unref0 (selected_project);
#line 302 "../src/server.vala"
					selected_project = _tmp10_;
#line 303 "../src/server.vala"
					break;
#line 2801 "server.c"
				}
			}
		}
#line 299 "../src/server.vala"
		p_collection = (g_free (p_collection), NULL);
#line 2807 "server.c"
	}
#line 307 "../src/server.vala"
	_tmp11_ = selected_project;
#line 307 "../src/server.vala"
	if (_tmp11_ == NULL) {
#line 2813 "server.c"
		VlsDefaultProject* _tmp12_;
		GeeArrayList* _tmp13_;
		GeeArrayList* _tmp14_;
		gboolean _tmp15_;
		gboolean _tmp16_;
#line 308 "../src/server.vala"
		_tmp12_ = self->priv->default_project;
#line 308 "../src/server.vala"
		_tmp13_ = vls_project_lookup_compile_input_source_file ((VlsProject*) _tmp12_, uri);
#line 308 "../src/server.vala"
		_g_object_unref0 (results);
#line 308 "../src/server.vala"
		results = _tmp13_;
#line 309 "../src/server.vala"
		_tmp14_ = results;
#line 309 "../src/server.vala"
		_tmp15_ = gee_collection_get_is_empty ((GeeCollection*) _tmp14_);
#line 309 "../src/server.vala"
		_tmp16_ = _tmp15_;
#line 309 "../src/server.vala"
		if (!_tmp16_) {
#line 2835 "server.c"
			VlsDefaultProject* _tmp17_;
			VlsProject* _tmp18_;
#line 310 "../src/server.vala"
			_tmp17_ = self->priv->default_project;
#line 310 "../src/server.vala"
			_tmp18_ = _g_object_ref0 ((VlsProject*) _tmp17_);
#line 310 "../src/server.vala"
			_g_object_unref0 (selected_project);
#line 310 "../src/server.vala"
			selected_project = _tmp18_;
#line 2846 "server.c"
		}
	}
#line 313 "../src/server.vala"
	_tmp19_ = selected_project;
#line 313 "../src/server.vala"
	if (_tmp19_ != NULL) {
#line 2853 "server.c"
		VlsProject* _tmp20_;
		VlsProject* _tmp21_;
		GeeArrayList* _tmp22_;
		gpointer _tmp23_;
		VlsPair* _tmp24_;
		gconstpointer _tmp25_;
		gconstpointer _tmp26_;
		VlsCompilation* _tmp27_;
		GeeArrayList* _tmp28_;
		gpointer _tmp29_;
		VlsPair* _tmp30_;
		gconstpointer _tmp31_;
		gconstpointer _tmp32_;
		ValaSourceFile* _tmp33_;
		ValaSourceFile* _tmp34_;
#line 314 "../src/server.vala"
		_tmp20_ = selected_project;
#line 314 "../src/server.vala"
		_tmp21_ = _g_object_ref0 (_tmp20_);
#line 314 "../src/server.vala"
		_g_object_unref0 (_vala_project);
#line 314 "../src/server.vala"
		_vala_project = _tmp21_;
#line 315 "../src/server.vala"
		_tmp22_ = results;
#line 315 "../src/server.vala"
		_tmp23_ = gee_abstract_list_get ((GeeAbstractList*) _tmp22_, 0);
#line 315 "../src/server.vala"
		_tmp24_ = (VlsPair*) _tmp23_;
#line 315 "../src/server.vala"
		_tmp25_ = vls_pair_get_second (_tmp24_);
#line 315 "../src/server.vala"
		_tmp26_ = _tmp25_;
#line 315 "../src/server.vala"
		_tmp27_ = _g_object_ref0 ((VlsCompilation*) _tmp26_);
#line 315 "../src/server.vala"
		_g_object_unref0 (_vala_compilation);
#line 315 "../src/server.vala"
		_vala_compilation = _tmp27_;
#line 315 "../src/server.vala"
		_g_object_unref0 (_tmp24_);
#line 316 "../src/server.vala"
		_tmp28_ = results;
#line 316 "../src/server.vala"
		_tmp29_ = gee_abstract_list_get ((GeeAbstractList*) _tmp28_, 0);
#line 316 "../src/server.vala"
		_tmp30_ = (VlsPair*) _tmp29_;
#line 316 "../src/server.vala"
		_tmp31_ = vls_pair_get_first (_tmp30_);
#line 316 "../src/server.vala"
		_tmp32_ = _tmp31_;
#line 316 "../src/server.vala"
		_tmp33_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp32_);
#line 316 "../src/server.vala"
		_tmp34_ = _tmp33_;
#line 316 "../src/server.vala"
		_g_object_unref0 (_tmp30_);
#line 316 "../src/server.vala"
		result = _tmp34_;
#line 316 "../src/server.vala"
		_g_object_unref0 (selected_project);
#line 316 "../src/server.vala"
		_g_object_unref0 (results);
#line 316 "../src/server.vala"
		if (compilation) {
#line 316 "../src/server.vala"
			*compilation = _vala_compilation;
#line 2921 "server.c"
		} else {
#line 316 "../src/server.vala"
			_g_object_unref0 (_vala_compilation);
#line 2925 "server.c"
		}
#line 316 "../src/server.vala"
		if (project) {
#line 316 "../src/server.vala"
			*project = _vala_project;
#line 2931 "server.c"
		} else {
#line 316 "../src/server.vala"
			_g_object_unref0 (_vala_project);
#line 2935 "server.c"
		}
#line 316 "../src/server.vala"
		return result;
#line 2939 "server.c"
	}
#line 319 "../src/server.vala"
	_g_object_unref0 (_vala_project);
#line 319 "../src/server.vala"
	_vala_project = NULL;
#line 320 "../src/server.vala"
	_g_object_unref0 (_vala_compilation);
#line 320 "../src/server.vala"
	_vala_compilation = NULL;
#line 321 "../src/server.vala"
	result = NULL;
#line 321 "../src/server.vala"
	_g_object_unref0 (selected_project);
#line 321 "../src/server.vala"
	_g_object_unref0 (results);
#line 321 "../src/server.vala"
	if (compilation) {
#line 321 "../src/server.vala"
		*compilation = _vala_compilation;
#line 2959 "server.c"
	} else {
#line 321 "../src/server.vala"
		_g_object_unref0 (_vala_compilation);
#line 2963 "server.c"
	}
#line 321 "../src/server.vala"
	if (project) {
#line 321 "../src/server.vala"
		*project = _vala_project;
#line 2969 "server.c"
	} else {
#line 321 "../src/server.vala"
		_g_object_unref0 (_vala_project);
#line 2973 "server.c"
	}
#line 321 "../src/server.vala"
	return result;
#line 2977 "server.c"
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
#line 1581 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1582 "glib-2.0.vapi"
	result = self;
#line 1582 "glib-2.0.vapi"
	return result;
#line 2990 "server.c"
}

static void
vls_server_show_message (VlsServer* self,
                         JsonrpcClient* client,
                         const gchar* message,
                         LspMessageType type)
{
	GError* _inner_error0_ = NULL;
#line 324 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 324 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 324 "../src/server.vala"
	g_return_if_fail (message != NULL);
#line 325 "../src/server.vala"
	if (type == LSP_MESSAGE_TYPE_Error) {
#line 326 "../src/server.vala"
		g_warning ("server.vala:326: %s", message);
#line 3010 "server.c"
	}
	{
		GVariant* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
		GVariant* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GCancellable* _tmp6_;
#line 328 "../src/server.vala"
		_tmp0_ = g_variant_new_int16 ((gint16) type);
#line 328 "../src/server.vala"
		g_variant_ref_sink (_tmp0_);
#line 328 "../src/server.vala"
		_tmp1_ = _tmp0_;
#line 328 "../src/server.vala"
		_tmp2_ = g_variant_new_string (message);
#line 328 "../src/server.vala"
		g_variant_ref_sink (_tmp2_);
#line 328 "../src/server.vala"
		_tmp3_ = _tmp2_;
#line 328 "../src/server.vala"
		_tmp4_ = vls_server_build_dict (self, "type", _tmp1_, "message", _tmp3_, NULL);
#line 328 "../src/server.vala"
		_tmp5_ = _tmp4_;
#line 328 "../src/server.vala"
		_tmp6_ = vls_server_cancellable;
#line 328 "../src/server.vala"
		jsonrpc_client_send_notification (client, "window/showMessage", _tmp5_, _tmp6_, &_inner_error0_);
#line 328 "../src/server.vala"
		_g_variant_unref0 (_tmp5_);
#line 328 "../src/server.vala"
		_g_variant_unref0 (_tmp3_);
#line 328 "../src/server.vala"
		_g_variant_unref0 (_tmp1_);
#line 328 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3048 "server.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
#line 327 "../src/server.vala"
		e = _inner_error0_;
#line 327 "../src/server.vala"
		_inner_error0_ = NULL;
#line 333 "../src/server.vala"
		_tmp7_ = e;
#line 333 "../src/server.vala"
		_tmp8_ = _tmp7_->message;
#line 333 "../src/server.vala"
		_tmp9_ = string_to_string (_tmp8_);
#line 333 "../src/server.vala"
		_tmp10_ = g_strconcat ("showMessage: failed to notify client: ", _tmp9_, NULL);
#line 333 "../src/server.vala"
		_tmp11_ = _tmp10_;
#line 333 "../src/server.vala"
		g_debug ("server.vala:333: %s", _tmp11_);
#line 333 "../src/server.vala"
		_g_free0 (_tmp11_);
#line 327 "../src/server.vala"
		_g_error_free0 (e);
#line 3081 "server.c"
	}
	__finally0:
#line 327 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 327 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 327 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 327 "../src/server.vala"
		return;
#line 3092 "server.c"
	}
}

static inline GRegex*
_thread_safe_regex_init (GRegex** re,
                         const gchar * pattern,
                         GRegexCompileFlags compile_flags)
{
#line 393 "../src/server.vala"
	if (g_once_init_enter ((gsize*) re)) {
#line 393 "../src/server.vala"
		GRegex* val = g_regex_new (pattern, compile_flags, 0, NULL);
#line 393 "../src/server.vala"
		g_once_init_leave ((gsize*) re, (gsize) val);
#line 3107 "server.c"
	}
#line 393 "../src/server.vala"
	return *re;
#line 3111 "server.c"
}

static guint
_vls_util_file_hash_gee_hash_data_func (gconstpointer v,
                                        gpointer self)
{
	guint result;
	result = vls_util_file_hash ((GFile*) v);
#line 457 "../src/server.vala"
	return result;
#line 3122 "server.c"
}

static gboolean
_vls_util_file_equal_gee_equal_data_func (gconstpointer a,
                                          gconstpointer b,
                                          gpointer self)
{
	gboolean result;
	result = vls_util_file_equal ((GFile*) a, (GFile*) b);
#line 457 "../src/server.vala"
	return result;
#line 3134 "server.c"
}

static gboolean
_vls_server_check_update_context_gsource_func (gpointer self)
{
	gboolean result;
	result = vls_server_check_update_context ((VlsServer*) self);
#line 466 "../src/server.vala"
	return result;
#line 3144 "server.c"
}

static void
_vala_array_add24 (guint* * array,
                   gint* length,
                   gint* size,
                   guint value)
{
#line 466 "../src/server.vala"
	if ((*length) == (*size)) {
#line 466 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 466 "../src/server.vala"
		*array = g_renew (guint, *array, *size);
#line 3159 "server.c"
	}
#line 466 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 3163 "server.c"
}

static void
_vls_server_project_changed_event_vls_project_changed (VlsProject* _sender,
                                                       gpointer self)
{
#line 470 "../src/server.vala"
	vls_server_project_changed_event ((VlsServer*) self);
#line 3172 "server.c"
}

static void
vls_server_initialize (VlsServer* self,
                       JsonrpcClient* client,
                       const gchar* method,
                       GVariant* id,
                       GVariant* params)
{
	gpointer _tmp0_;
	GFile* root_dir = NULL;
	LspInitializeParams* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GFile* _tmp18_;
	gchar* root_path = NULL;
	GFile* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	GFile* meson_file = NULL;
	GFile* _tmp96_;
	GFile* _tmp97_;
	GeeArrayList* cc_files = NULL;
	GeeArrayList* _tmp98_;
	GeeArrayList* new_projects = NULL;
	GeeArrayList* _tmp108_;
	VlsProject* backend_project = NULL;
	GFile* _tmp109_;
	GCancellable* _tmp110_;
	gboolean _tmp123_ = FALSE;
	VlsProject* _tmp124_;
	VlsProject* _tmp152_;
	const gchar* _tmp163_;
	VlsFileCache* _tmp164_;
	VlsDefaultProject* _tmp165_;
	GeeHashSet* packages = NULL;
	GeeHashSet* _tmp191_;
	GeeHashSet* custom_gir_dirs = NULL;
	GeeHashSet* _tmp192_;
	GeeHashSet* _tmp209_;
	GeeHashSet* _tmp210_;
	VlsGirDocumentation* _tmp211_;
	JsonrpcClient* _tmp212_;
	GError* _inner_error0_ = NULL;
#line 337 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 337 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 337 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 337 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 337 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 338 "../src/server.vala"
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_INITIALIZE_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 338 "../src/server.vala"
	_g_object_unref0 (self->priv->init_params);
#line 338 "../src/server.vala"
	self->priv->init_params = (LspInitializeParams*) _tmp0_;
#line 341 "../src/server.vala"
	_tmp1_ = self->priv->init_params;
#line 341 "../src/server.vala"
	_tmp2_ = lsp_initialize_params_get_rootUri (_tmp1_);
#line 341 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 341 "../src/server.vala"
	if (_tmp3_ != NULL) {
#line 3247 "server.c"
		LspInitializeParams* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		GFile* _tmp7_;
#line 342 "../src/server.vala"
		_tmp4_ = self->priv->init_params;
#line 342 "../src/server.vala"
		_tmp5_ = lsp_initialize_params_get_rootUri (_tmp4_);
#line 342 "../src/server.vala"
		_tmp6_ = _tmp5_;
#line 342 "../src/server.vala"
		_tmp7_ = g_file_new_for_uri (_tmp6_);
#line 342 "../src/server.vala"
		_g_object_unref0 (root_dir);
#line 342 "../src/server.vala"
		root_dir = _tmp7_;
#line 3264 "server.c"
	} else {
		LspInitializeParams* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 343 "../src/server.vala"
		_tmp8_ = self->priv->init_params;
#line 343 "../src/server.vala"
		_tmp9_ = lsp_initialize_params_get_rootPath (_tmp8_);
#line 343 "../src/server.vala"
		_tmp10_ = _tmp9_;
#line 343 "../src/server.vala"
		if (_tmp10_ != NULL) {
#line 3277 "server.c"
			LspInitializeParams* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
			GFile* _tmp14_;
#line 344 "../src/server.vala"
			_tmp11_ = self->priv->init_params;
#line 344 "../src/server.vala"
			_tmp12_ = lsp_initialize_params_get_rootPath (_tmp11_);
#line 344 "../src/server.vala"
			_tmp13_ = _tmp12_;
#line 344 "../src/server.vala"
			_tmp14_ = g_file_new_for_path (_tmp13_);
#line 344 "../src/server.vala"
			_g_object_unref0 (root_dir);
#line 344 "../src/server.vala"
			root_dir = _tmp14_;
#line 3294 "server.c"
		} else {
			gchar* _tmp15_;
			gchar* _tmp16_;
			GFile* _tmp17_;
#line 346 "../src/server.vala"
			_tmp15_ = g_get_current_dir ();
#line 346 "../src/server.vala"
			_tmp16_ = _tmp15_;
#line 346 "../src/server.vala"
			_tmp17_ = g_file_new_for_path (_tmp16_);
#line 346 "../src/server.vala"
			_g_object_unref0 (root_dir);
#line 346 "../src/server.vala"
			root_dir = _tmp17_;
#line 346 "../src/server.vala"
			_g_free0 (_tmp16_);
#line 3311 "server.c"
		}
	}
#line 347 "../src/server.vala"
	_tmp18_ = root_dir;
#line 347 "../src/server.vala"
	if (!g_file_is_native (_tmp18_)) {
#line 348 "../src/server.vala"
		vls_server_show_message (self, client, "Non-native files not supported", LSP_MESSAGE_TYPE_Error);
#line 349 "../src/server.vala"
		g_error ("server.vala:349: Non-native files not supported");
#line 3322 "server.c"
	}
#line 351 "../src/server.vala"
	_tmp19_ = root_dir;
#line 351 "../src/server.vala"
	_tmp20_ = g_file_get_path (_tmp19_);
#line 351 "../src/server.vala"
	_tmp21_ = (gchar*) _tmp20_;
#line 351 "../src/server.vala"
	_tmp22_ = vls_util_realpath (_tmp21_, NULL);
#line 351 "../src/server.vala"
	_tmp23_ = _tmp22_;
#line 351 "../src/server.vala"
	_g_free0 (_tmp21_);
#line 351 "../src/server.vala"
	root_path = _tmp23_;
#line 352 "../src/server.vala"
	_tmp24_ = root_path;
#line 352 "../src/server.vala"
	_tmp25_ = string_to_string (_tmp24_);
#line 352 "../src/server.vala"
	_tmp26_ = g_strconcat ("[initialize] root path is ", _tmp25_, NULL);
#line 352 "../src/server.vala"
	_tmp27_ = _tmp26_;
#line 352 "../src/server.vala"
	g_debug ("server.vala:352: %s", _tmp27_);
#line 352 "../src/server.vala"
	_g_free0 (_tmp27_);
#line 3350 "server.c"
	{
		GVariant* _tmp28_;
		GVariant* _tmp29_;
		GVariant* _tmp30_;
		GVariant* _tmp31_;
		GVariant* _tmp32_;
		GVariant* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		gchar** _tmp36_;
		gchar** _tmp37_;
		gint _tmp37__length1;
		GVariant* _tmp38_;
		GVariant* _tmp39_;
		GVariant* _tmp40_;
		GVariant* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		gchar** _tmp45_;
		gchar** _tmp46_;
		gint _tmp46__length1;
		GVariant* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		GVariant* _tmp51_;
		GVariant* _tmp52_;
		GVariant* _tmp53_;
		GVariant* _tmp54_;
		GVariant* _tmp55_;
		GVariant* _tmp56_;
		GVariant* _tmp57_;
		GVariant* _tmp58_;
		GVariant* _tmp59_;
		GVariant* _tmp60_;
		GVariant* _tmp61_;
		GVariant* _tmp62_;
		GVariant* _tmp63_;
		GVariant* _tmp64_;
		GVariant* _tmp65_;
		GVariant* _tmp66_;
		GVariant* _tmp67_;
		GVariant* _tmp68_;
		GVariant* _tmp69_;
		GVariant* _tmp70_;
		GVariant* _tmp71_;
		GVariant* _tmp72_;
		GVariant* _tmp73_;
		GVariant* _tmp74_;
		GVariant* _tmp75_;
		GVariant* _tmp76_;
		GVariant* _tmp77_;
		GVariant* _tmp78_;
		GVariant* _tmp79_;
		GVariant* _tmp80_;
		GVariant* _tmp81_;
		GVariant* _tmp82_;
		GVariant* _tmp83_;
		GVariant* _tmp84_;
		GVariant* _tmp85_;
		GVariant* _tmp86_;
		GVariant* _tmp87_;
		GVariant* _tmp88_;
		GVariant* _tmp89_;
		GVariant* _tmp90_;
		GCancellable* _tmp91_;
#line 356 "../src/server.vala"
		_tmp28_ = g_variant_new_int16 ((gint16) LSP_TEXT_DOCUMENT_SYNC_KIND_Incremental);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp28_);
#line 356 "../src/server.vala"
		_tmp29_ = _tmp28_;
#line 356 "../src/server.vala"
		_tmp30_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp30_);
#line 356 "../src/server.vala"
		_tmp31_ = _tmp30_;
#line 356 "../src/server.vala"
		_tmp32_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp32_);
#line 356 "../src/server.vala"
		_tmp33_ = _tmp32_;
#line 356 "../src/server.vala"
		_tmp34_ = g_strdup (".");
#line 356 "../src/server.vala"
		_tmp35_ = g_strdup (">");
#line 356 "../src/server.vala"
		_tmp36_ = g_new0 (gchar*, 2 + 1);
#line 356 "../src/server.vala"
		_tmp36_[0] = _tmp34_;
#line 356 "../src/server.vala"
		_tmp36_[1] = _tmp35_;
#line 356 "../src/server.vala"
		_tmp37_ = _tmp36_;
#line 356 "../src/server.vala"
		_tmp37__length1 = 2;
#line 356 "../src/server.vala"
		_tmp38_ = g_variant_new_strv (_tmp37_, 2);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp38_);
#line 356 "../src/server.vala"
		_tmp39_ = _tmp38_;
#line 356 "../src/server.vala"
		_tmp40_ = vls_server_build_dict (self, "triggerCharacters", _tmp39_, NULL);
#line 356 "../src/server.vala"
		_tmp41_ = _tmp40_;
#line 356 "../src/server.vala"
		_tmp42_ = g_strdup ("(");
#line 356 "../src/server.vala"
		_tmp43_ = g_strdup ("[");
#line 356 "../src/server.vala"
		_tmp44_ = g_strdup (",");
#line 356 "../src/server.vala"
		_tmp45_ = g_new0 (gchar*, 3 + 1);
#line 356 "../src/server.vala"
		_tmp45_[0] = _tmp42_;
#line 356 "../src/server.vala"
		_tmp45_[1] = _tmp43_;
#line 356 "../src/server.vala"
		_tmp45_[2] = _tmp44_;
#line 356 "../src/server.vala"
		_tmp46_ = _tmp45_;
#line 356 "../src/server.vala"
		_tmp46__length1 = 3;
#line 356 "../src/server.vala"
		_tmp47_ = g_variant_new_strv (_tmp46_, 3);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp47_);
#line 356 "../src/server.vala"
		_tmp48_ = _tmp47_;
#line 356 "../src/server.vala"
		_tmp49_ = vls_server_build_dict (self, "triggerCharacters", _tmp48_, NULL);
#line 356 "../src/server.vala"
		_tmp50_ = _tmp49_;
#line 356 "../src/server.vala"
		_tmp51_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp51_);
#line 356 "../src/server.vala"
		_tmp52_ = _tmp51_;
#line 356 "../src/server.vala"
		_tmp53_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp53_);
#line 356 "../src/server.vala"
		_tmp54_ = _tmp53_;
#line 356 "../src/server.vala"
		_tmp55_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp55_);
#line 356 "../src/server.vala"
		_tmp56_ = _tmp55_;
#line 356 "../src/server.vala"
		_tmp57_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp57_);
#line 356 "../src/server.vala"
		_tmp58_ = _tmp57_;
#line 356 "../src/server.vala"
		_tmp59_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp59_);
#line 356 "../src/server.vala"
		_tmp60_ = _tmp59_;
#line 356 "../src/server.vala"
		_tmp61_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp61_);
#line 356 "../src/server.vala"
		_tmp62_ = _tmp61_;
#line 356 "../src/server.vala"
		_tmp63_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp63_);
#line 356 "../src/server.vala"
		_tmp64_ = _tmp63_;
#line 356 "../src/server.vala"
		_tmp65_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp65_);
#line 356 "../src/server.vala"
		_tmp66_ = _tmp65_;
#line 356 "../src/server.vala"
		_tmp67_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp67_);
#line 356 "../src/server.vala"
		_tmp68_ = _tmp67_;
#line 356 "../src/server.vala"
		_tmp69_ = vls_server_build_dict (self, "prepareProvider", _tmp68_, NULL);
#line 356 "../src/server.vala"
		_tmp70_ = _tmp69_;
#line 356 "../src/server.vala"
		_tmp71_ = g_variant_new_boolean (FALSE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp71_);
#line 356 "../src/server.vala"
		_tmp72_ = _tmp71_;
#line 356 "../src/server.vala"
		_tmp73_ = vls_server_build_dict (self, "resolveProvider", _tmp72_, NULL);
#line 356 "../src/server.vala"
		_tmp74_ = _tmp73_;
#line 356 "../src/server.vala"
		_tmp75_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp75_);
#line 356 "../src/server.vala"
		_tmp76_ = _tmp75_;
#line 356 "../src/server.vala"
		_tmp77_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp77_);
#line 356 "../src/server.vala"
		_tmp78_ = _tmp77_;
#line 356 "../src/server.vala"
		_tmp79_ = g_variant_new_boolean (TRUE);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp79_);
#line 356 "../src/server.vala"
		_tmp80_ = _tmp79_;
#line 356 "../src/server.vala"
		_tmp81_ = vls_server_build_dict (self, "textDocumentSync", _tmp29_, "definitionProvider", _tmp31_, "documentSymbolProvider", _tmp33_, "completionProvider", _tmp41_, "signatureHelpProvider", _tmp50_, "codeActionProvider", _tmp52_, "hoverProvider", _tmp54_, "referencesProvider", _tmp56_, "documentHighlightProvider", _tmp58_, "documentFormattingProvider", _tmp60_, "documentRangeFormattingProvider", _tmp62_, "implementationProvider", _tmp64_, "workspaceSymbolProvider", _tmp66_, "renameProvider", _tmp70_, "codeLensProvider", _tmp74_, "callHierarchyProvider", _tmp76_, "inlayHintProvider", _tmp78_, "typeHierarchyProvider", _tmp80_, NULL);
#line 356 "../src/server.vala"
		_tmp82_ = _tmp81_;
#line 356 "../src/server.vala"
		_tmp83_ = g_variant_new_string ("Vala Language Server");
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp83_);
#line 356 "../src/server.vala"
		_tmp84_ = _tmp83_;
#line 356 "../src/server.vala"
		_tmp85_ = g_variant_new_string (CONFIG_PROJECT_VERSION);
#line 356 "../src/server.vala"
		g_variant_ref_sink (_tmp85_);
#line 356 "../src/server.vala"
		_tmp86_ = _tmp85_;
#line 356 "../src/server.vala"
		_tmp87_ = vls_server_build_dict (self, "name", _tmp84_, "version", _tmp86_, NULL);
#line 356 "../src/server.vala"
		_tmp88_ = _tmp87_;
#line 356 "../src/server.vala"
		_tmp89_ = vls_server_build_dict (self, "capabilities", _tmp82_, "serverInfo", _tmp88_, NULL);
#line 356 "../src/server.vala"
		_tmp90_ = _tmp89_;
#line 356 "../src/server.vala"
		_tmp91_ = vls_server_cancellable;
#line 356 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp90_, _tmp91_, &_inner_error0_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp90_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp88_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp86_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp84_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp82_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp80_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp78_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp76_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp74_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp72_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp70_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp68_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp66_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp64_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp62_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp60_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp58_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp56_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp54_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp52_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp50_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp48_);
#line 356 "../src/server.vala"
		_tmp46_ = (_vala_array_free (_tmp46_, _tmp46__length1, (GDestroyNotify) g_free), NULL);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp41_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp39_);
#line 356 "../src/server.vala"
		_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp33_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp31_);
#line 356 "../src/server.vala"
		_g_variant_unref0 (_tmp29_);
#line 356 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3662 "server.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp92_;
		const gchar* _tmp93_;
		gchar* _tmp94_;
		gchar* _tmp95_;
#line 355 "../src/server.vala"
		e = _inner_error0_;
#line 355 "../src/server.vala"
		_inner_error0_ = NULL;
#line 387 "../src/server.vala"
		_tmp92_ = e->message;
#line 387 "../src/server.vala"
		_tmp93_ = string_to_string (_tmp92_);
#line 387 "../src/server.vala"
		_tmp94_ = g_strconcat ("[initialize] failed to reply to client: ", _tmp93_, NULL);
#line 387 "../src/server.vala"
		_tmp95_ = _tmp94_;
#line 387 "../src/server.vala"
		g_error ("server.vala:387: %s", _tmp95_);
#line 387 "../src/server.vala"
		_g_free0 (_tmp95_);
#line 355 "../src/server.vala"
		_g_error_free0 (e);
#line 3692 "server.c"
	}
	__finally0:
#line 355 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 355 "../src/server.vala"
		_g_free0 (root_path);
#line 355 "../src/server.vala"
		_g_object_unref0 (root_dir);
#line 355 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 355 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 355 "../src/server.vala"
		return;
#line 3707 "server.c"
	}
#line 390 "../src/server.vala"
	_tmp96_ = root_dir;
#line 390 "../src/server.vala"
	_tmp97_ = g_file_get_child (_tmp96_, "meson.build");
#line 390 "../src/server.vala"
	meson_file = _tmp97_;
#line 391 "../src/server.vala"
	_tmp98_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 391 "../src/server.vala"
	if (_tmp98_) {
#line 391 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp98_, "vala-creation-function", "Vls.Server.initialize");
#line 3721 "server.c"
	}
#line 391 "../src/server.vala"
	cc_files = _tmp98_;
#line 3725 "server.c"
	{
		GeeArrayList* _tmp99_ = NULL;
		GFile* _tmp100_;
		GeeArrayList* _tmp101_;
		GeeArrayList* _tmp102_;
		GeeArrayList* _tmp103_;
		GeeArrayList* _tmp104_;
		GeeArrayList* _tmp105_;
#line 393 "../src/server.vala"
		_tmp100_ = root_dir;
#line 393 "../src/server.vala"
		_tmp101_ = gee_array_list_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 393 "../src/server.vala"
		if (_tmp101_) {
#line 393 "../src/server.vala"
			g_object_set_data ((GObject *) _tmp101_, "vala-creation-function", "Vls.Server.initialize");
#line 3742 "server.c"
		}
#line 393 "../src/server.vala"
		_tmp102_ = _tmp101_;
#line 393 "../src/server.vala"
		_tmp103_ = vls_util_find_files (_tmp100_, _thread_safe_regex_init (&_tmp_regex_0, "compile_commands\\.json", 0), (guint) 2, NULL, _tmp102_, &_inner_error0_);
#line 393 "../src/server.vala"
		_tmp104_ = _tmp103_;
#line 393 "../src/server.vala"
		_g_object_unref0 (_tmp102_);
#line 393 "../src/server.vala"
		_tmp99_ = _tmp104_;
#line 393 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3756 "server.c"
			goto __catch1_g_error;
		}
#line 393 "../src/server.vala"
		_tmp105_ = _tmp99_;
#line 393 "../src/server.vala"
		_tmp99_ = NULL;
#line 393 "../src/server.vala"
		_g_object_unref0 (cc_files);
#line 393 "../src/server.vala"
		cc_files = _tmp105_;
#line 392 "../src/server.vala"
		_g_object_unref0 (_tmp99_);
#line 3769 "server.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp106_;
		const gchar* _tmp107_;
#line 392 "../src/server.vala"
		e = _inner_error0_;
#line 392 "../src/server.vala"
		_inner_error0_ = NULL;
#line 395 "../src/server.vala"
		_tmp106_ = e;
#line 395 "../src/server.vala"
		_tmp107_ = _tmp106_->message;
#line 395 "../src/server.vala"
		g_warning ("server.vala:395: could not enumerate root dir - %s", _tmp107_);
#line 392 "../src/server.vala"
		_g_error_free0 (e);
#line 3789 "server.c"
	}
	__finally1:
#line 392 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 392 "../src/server.vala"
		_g_object_unref0 (cc_files);
#line 392 "../src/server.vala"
		_g_object_unref0 (meson_file);
#line 392 "../src/server.vala"
		_g_free0 (root_path);
#line 392 "../src/server.vala"
		_g_object_unref0 (root_dir);
#line 392 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 392 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 392 "../src/server.vala"
		return;
#line 3808 "server.c"
	}
#line 398 "../src/server.vala"
	_tmp108_ = gee_array_list_new (VLS_TYPE_PROJECT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 398 "../src/server.vala"
	if (_tmp108_) {
#line 398 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp108_, "vala-creation-function", "Vls.Server.initialize");
#line 3816 "server.c"
	}
#line 398 "../src/server.vala"
	new_projects = _tmp108_;
#line 399 "../src/server.vala"
	backend_project = NULL;
#line 401 "../src/server.vala"
	_tmp109_ = meson_file;
#line 401 "../src/server.vala"
	_tmp110_ = vls_server_cancellable;
#line 401 "../src/server.vala"
	if (g_file_query_exists (_tmp109_, _tmp110_)) {
#line 3828 "server.c"
		{
			VlsMesonProject* _tmp111_ = NULL;
			const gchar* _tmp112_;
			VlsFileCache* _tmp113_;
			GCancellable* _tmp114_;
			VlsMesonProject* _tmp115_;
			VlsMesonProject* _tmp116_;
#line 403 "../src/server.vala"
			_tmp112_ = root_path;
#line 403 "../src/server.vala"
			_tmp113_ = self->priv->file_cache;
#line 403 "../src/server.vala"
			_tmp114_ = vls_server_cancellable;
#line 403 "../src/server.vala"
			_tmp115_ = vls_meson_project_new (_tmp112_, _tmp113_, _tmp114_, &_inner_error0_);
#line 403 "../src/server.vala"
			if (_tmp115_) {
#line 403 "../src/server.vala"
				g_object_set_data ((GObject *) _tmp115_, "vala-creation-function", "Vls.Server.initialize");
#line 3848 "server.c"
			}
#line 403 "../src/server.vala"
			_tmp111_ = _tmp115_;
#line 403 "../src/server.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 3854 "server.c"
				goto __catch2_g_error;
			}
#line 403 "../src/server.vala"
			_tmp116_ = _tmp111_;
#line 403 "../src/server.vala"
			_tmp111_ = NULL;
#line 403 "../src/server.vala"
			_g_object_unref0 (backend_project);
#line 403 "../src/server.vala"
			backend_project = (VlsProject*) _tmp116_;
#line 402 "../src/server.vala"
			_g_object_unref0 (_tmp111_);
#line 3867 "server.c"
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError* e = NULL;
			GError* _tmp117_;
#line 402 "../src/server.vala"
			e = _inner_error0_;
#line 402 "../src/server.vala"
			_inner_error0_ = NULL;
#line 405 "../src/server.vala"
			_tmp117_ = e;
#line 405 "../src/server.vala"
			if (!g_error_matches (_tmp117_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_VERSION_UNSUPPORTED)) {
#line 3882 "server.c"
				GError* _tmp118_;
				const gchar* _tmp119_;
				const gchar* _tmp120_;
				gchar* _tmp121_;
				gchar* _tmp122_;
#line 406 "../src/server.vala"
				_tmp118_ = e;
#line 406 "../src/server.vala"
				_tmp119_ = _tmp118_->message;
#line 406 "../src/server.vala"
				_tmp120_ = string_to_string (_tmp119_);
#line 406 "../src/server.vala"
				_tmp121_ = g_strconcat ("Failed to initialize Meson project - ", _tmp120_, NULL);
#line 406 "../src/server.vala"
				_tmp122_ = _tmp121_;
#line 406 "../src/server.vala"
				vls_server_show_message (self, client, _tmp122_, LSP_MESSAGE_TYPE_Error);
#line 406 "../src/server.vala"
				_g_free0 (_tmp122_);
#line 3902 "server.c"
			}
#line 402 "../src/server.vala"
			_g_error_free0 (e);
#line 3906 "server.c"
		}
		__finally2:
#line 402 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 402 "../src/server.vala"
			_g_object_unref0 (backend_project);
#line 402 "../src/server.vala"
			_g_object_unref0 (new_projects);
#line 402 "../src/server.vala"
			_g_object_unref0 (cc_files);
#line 402 "../src/server.vala"
			_g_object_unref0 (meson_file);
#line 402 "../src/server.vala"
			_g_free0 (root_path);
#line 402 "../src/server.vala"
			_g_object_unref0 (root_dir);
#line 402 "../src/server.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 402 "../src/server.vala"
			g_clear_error (&_inner_error0_);
#line 402 "../src/server.vala"
			return;
#line 3929 "server.c"
		}
	}
#line 412 "../src/server.vala"
	_tmp124_ = backend_project;
#line 412 "../src/server.vala"
	if (_tmp124_ == NULL) {
#line 3936 "server.c"
		GeeArrayList* _tmp125_;
		gboolean _tmp126_;
		gboolean _tmp127_;
#line 412 "../src/server.vala"
		_tmp125_ = cc_files;
#line 412 "../src/server.vala"
		_tmp126_ = gee_collection_get_is_empty ((GeeCollection*) _tmp125_);
#line 412 "../src/server.vala"
		_tmp127_ = _tmp126_;
#line 412 "../src/server.vala"
		_tmp123_ = !_tmp127_;
#line 3948 "server.c"
	} else {
#line 412 "../src/server.vala"
		_tmp123_ = FALSE;
#line 3952 "server.c"
	}
#line 412 "../src/server.vala"
	if (_tmp123_) {
#line 3956 "server.c"
		{
			GeeArrayList* _cc_file_list = NULL;
			GeeArrayList* _tmp128_;
			gint _cc_file_size = 0;
			GeeArrayList* _tmp129_;
			gint _tmp130_;
			gint _tmp131_;
			gint _cc_file_index = 0;
#line 413 "../src/server.vala"
			_tmp128_ = cc_files;
#line 413 "../src/server.vala"
			_cc_file_list = _tmp128_;
#line 413 "../src/server.vala"
			_tmp129_ = _cc_file_list;
#line 413 "../src/server.vala"
			_tmp130_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp129_);
#line 413 "../src/server.vala"
			_tmp131_ = _tmp130_;
#line 413 "../src/server.vala"
			_cc_file_size = _tmp131_;
#line 413 "../src/server.vala"
			_cc_file_index = -1;
#line 413 "../src/server.vala"
			while (TRUE) {
#line 3981 "server.c"
				gint _tmp132_;
				gint _tmp133_;
				GFile* cc_file = NULL;
				GeeArrayList* _tmp134_;
				gpointer _tmp135_;
				gchar* cc_file_path = NULL;
				GFile* _tmp136_;
				gchar* _tmp137_;
				gchar* _tmp138_;
				gchar* _tmp139_;
				gchar* _tmp140_;
#line 413 "../src/server.vala"
				_cc_file_index = _cc_file_index + 1;
#line 413 "../src/server.vala"
				_tmp132_ = _cc_file_index;
#line 413 "../src/server.vala"
				_tmp133_ = _cc_file_size;
#line 413 "../src/server.vala"
				if (!(_tmp132_ < _tmp133_)) {
#line 413 "../src/server.vala"
					break;
#line 4003 "server.c"
				}
#line 413 "../src/server.vala"
				_tmp134_ = _cc_file_list;
#line 413 "../src/server.vala"
				_tmp135_ = gee_abstract_list_get ((GeeAbstractList*) _tmp134_, _cc_file_index);
#line 413 "../src/server.vala"
				cc_file = (GFile*) _tmp135_;
#line 414 "../src/server.vala"
				_tmp136_ = cc_file;
#line 414 "../src/server.vala"
				_tmp137_ = g_file_get_path (_tmp136_);
#line 414 "../src/server.vala"
				_tmp138_ = _tmp137_;
#line 414 "../src/server.vala"
				_tmp139_ = vls_util_realpath (_tmp138_, NULL);
#line 414 "../src/server.vala"
				_tmp140_ = _tmp139_;
#line 414 "../src/server.vala"
				_g_free0 (_tmp138_);
#line 414 "../src/server.vala"
				cc_file_path = _tmp140_;
#line 4025 "server.c"
				{
					VlsCcProject* _tmp141_ = NULL;
					const gchar* _tmp142_;
					const gchar* _tmp143_;
					VlsFileCache* _tmp144_;
					GCancellable* _tmp145_;
					VlsCcProject* _tmp146_;
					VlsCcProject* _tmp147_;
					const gchar* _tmp148_;
#line 416 "../src/server.vala"
					_tmp142_ = root_path;
#line 416 "../src/server.vala"
					_tmp143_ = cc_file_path;
#line 416 "../src/server.vala"
					_tmp144_ = self->priv->file_cache;
#line 416 "../src/server.vala"
					_tmp145_ = vls_server_cancellable;
#line 416 "../src/server.vala"
					_tmp146_ = vls_cc_project_new (_tmp142_, _tmp143_, _tmp144_, _tmp145_, &_inner_error0_);
#line 416 "../src/server.vala"
					if (_tmp146_) {
#line 416 "../src/server.vala"
						g_object_set_data ((GObject *) _tmp146_, "vala-creation-function", "Vls.Server.initialize");
#line 4049 "server.c"
					}
#line 416 "../src/server.vala"
					_tmp141_ = _tmp146_;
#line 416 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4055 "server.c"
						goto __catch3_g_error;
					}
#line 416 "../src/server.vala"
					_tmp147_ = _tmp141_;
#line 416 "../src/server.vala"
					_tmp141_ = NULL;
#line 416 "../src/server.vala"
					_g_object_unref0 (backend_project);
#line 416 "../src/server.vala"
					backend_project = (VlsProject*) _tmp147_;
#line 417 "../src/server.vala"
					_tmp148_ = cc_file_path;
#line 417 "../src/server.vala"
					g_debug ("server.vala:417: [initialize] initialized CcProject with %s", _tmp148_);
#line 418 "../src/server.vala"
					_g_object_unref0 (_tmp141_);
#line 418 "../src/server.vala"
					_g_free0 (cc_file_path);
#line 418 "../src/server.vala"
					_g_object_unref0 (cc_file);
#line 418 "../src/server.vala"
					break;
#line 4078 "server.c"
				}
				goto __finally3;
				__catch3_g_error:
				{
					GError* e = NULL;
					const gchar* _tmp149_;
					GError* _tmp150_;
					const gchar* _tmp151_;
#line 415 "../src/server.vala"
					e = _inner_error0_;
#line 415 "../src/server.vala"
					_inner_error0_ = NULL;
#line 420 "../src/server.vala"
					_tmp149_ = cc_file_path;
#line 420 "../src/server.vala"
					_tmp150_ = e;
#line 420 "../src/server.vala"
					_tmp151_ = _tmp150_->message;
#line 420 "../src/server.vala"
					g_debug ("server.vala:420: [initialize] CcProject failed with %s - %s", _tmp149_, _tmp151_);
#line 421 "../src/server.vala"
					_g_error_free0 (e);
#line 421 "../src/server.vala"
					_g_free0 (cc_file_path);
#line 421 "../src/server.vala"
					_g_object_unref0 (cc_file);
#line 421 "../src/server.vala"
					continue;
#line 4107 "server.c"
				}
				__finally3:
#line 415 "../src/server.vala"
				_g_free0 (cc_file_path);
#line 415 "../src/server.vala"
				_g_object_unref0 (cc_file);
#line 415 "../src/server.vala"
				_g_object_unref0 (backend_project);
#line 415 "../src/server.vala"
				_g_object_unref0 (new_projects);
#line 415 "../src/server.vala"
				_g_object_unref0 (cc_files);
#line 415 "../src/server.vala"
				_g_object_unref0 (meson_file);
#line 415 "../src/server.vala"
				_g_free0 (root_path);
#line 415 "../src/server.vala"
				_g_object_unref0 (root_dir);
#line 415 "../src/server.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 415 "../src/server.vala"
				g_clear_error (&_inner_error0_);
#line 415 "../src/server.vala"
				return;
#line 4132 "server.c"
			}
		}
	}
#line 427 "../src/server.vala"
	_tmp152_ = backend_project;
#line 427 "../src/server.vala"
	if (_tmp152_ == NULL) {
#line 4140 "server.c"
		GFile* cmake_file = NULL;
		GFile* _tmp153_;
		GFile* _tmp154_;
		GFile* autogen_sh = NULL;
		GFile* _tmp155_;
		GFile* _tmp156_;
		GFile* _tmp157_;
		GCancellable* _tmp158_;
		GFile* _tmp159_;
		GCancellable* _tmp160_;
#line 428 "../src/server.vala"
		_tmp153_ = root_dir;
#line 428 "../src/server.vala"
		_tmp154_ = g_file_get_child (_tmp153_, "CMakeLists.txt");
#line 428 "../src/server.vala"
		cmake_file = _tmp154_;
#line 429 "../src/server.vala"
		_tmp155_ = root_dir;
#line 429 "../src/server.vala"
		_tmp156_ = g_file_get_child (_tmp155_, "autogen.sh");
#line 429 "../src/server.vala"
		autogen_sh = _tmp156_;
#line 431 "../src/server.vala"
		_tmp157_ = cmake_file;
#line 431 "../src/server.vala"
		_tmp158_ = vls_server_cancellable;
#line 431 "../src/server.vala"
		if (g_file_query_exists (_tmp157_, _tmp158_)) {
#line 432 "../src/server.vala"
			vls_server_show_message (self, client, "CMake build system is not currently supported. Only Meson is. See http" \
"s://github.com/vala-lang/vala-language-server/issues/73", LSP_MESSAGE_TYPE_Warning);
#line 4171 "server.c"
		}
#line 433 "../src/server.vala"
		_tmp159_ = autogen_sh;
#line 433 "../src/server.vala"
		_tmp160_ = vls_server_cancellable;
#line 433 "../src/server.vala"
		if (g_file_query_exists (_tmp159_, _tmp160_)) {
#line 434 "../src/server.vala"
			vls_server_show_message (self, client, "Autotools build system is not currently supported. Consider switching " \
"to Meson.", LSP_MESSAGE_TYPE_Warning);
#line 4181 "server.c"
		}
#line 427 "../src/server.vala"
		_g_object_unref0 (autogen_sh);
#line 427 "../src/server.vala"
		_g_object_unref0 (cmake_file);
#line 4187 "server.c"
	} else {
		GeeArrayList* _tmp161_;
		VlsProject* _tmp162_;
#line 436 "../src/server.vala"
		_tmp161_ = new_projects;
#line 436 "../src/server.vala"
		_tmp162_ = backend_project;
#line 436 "../src/server.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp161_, _tmp162_);
#line 4197 "server.c"
	}
#line 440 "../src/server.vala"
	_tmp163_ = root_path;
#line 440 "../src/server.vala"
	_tmp164_ = self->priv->file_cache;
#line 440 "../src/server.vala"
	_tmp165_ = vls_default_project_new (_tmp163_, _tmp164_);
#line 440 "../src/server.vala"
	if (_tmp165_) {
#line 440 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp165_, "vala-creation-function", "Vls.Server.initialize");
#line 4209 "server.c"
	}
#line 440 "../src/server.vala"
	_g_object_unref0 (self->priv->default_project);
#line 440 "../src/server.vala"
	self->priv->default_project = _tmp165_;
#line 4215 "server.c"
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp166_;
		gint _project_size = 0;
		GeeArrayList* _tmp167_;
		gint _tmp168_;
		gint _tmp169_;
		gint _project_index = 0;
#line 443 "../src/server.vala"
		_tmp166_ = new_projects;
#line 443 "../src/server.vala"
		_project_list = _tmp166_;
#line 443 "../src/server.vala"
		_tmp167_ = _project_list;
#line 443 "../src/server.vala"
		_tmp168_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp167_);
#line 443 "../src/server.vala"
		_tmp169_ = _tmp168_;
#line 443 "../src/server.vala"
		_project_size = _tmp169_;
#line 443 "../src/server.vala"
		_project_index = -1;
#line 443 "../src/server.vala"
		while (TRUE) {
#line 4240 "server.c"
			gint _tmp170_;
			gint _tmp171_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp172_;
			gpointer _tmp173_;
#line 443 "../src/server.vala"
			_project_index = _project_index + 1;
#line 443 "../src/server.vala"
			_tmp170_ = _project_index;
#line 443 "../src/server.vala"
			_tmp171_ = _project_size;
#line 443 "../src/server.vala"
			if (!(_tmp170_ < _tmp171_)) {
#line 443 "../src/server.vala"
				break;
#line 4256 "server.c"
			}
#line 443 "../src/server.vala"
			_tmp172_ = _project_list;
#line 443 "../src/server.vala"
			_tmp173_ = gee_abstract_list_get ((GeeAbstractList*) _tmp172_, _project_index);
#line 443 "../src/server.vala"
			project = (VlsProject*) _tmp173_;
#line 4264 "server.c"
			{
				VlsProject* _tmp174_;
#line 445 "../src/server.vala"
				g_debug ("server.vala:445: Building project ...");
#line 446 "../src/server.vala"
				_tmp174_ = project;
#line 446 "../src/server.vala"
				vls_project_build_if_stale (_tmp174_, NULL, &_inner_error0_);
#line 446 "../src/server.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4275 "server.c"
					goto __catch4_g_error;
				}
#line 447 "../src/server.vala"
				g_debug ("server.vala:447: Publishing diagnostics ...");
#line 4280 "server.c"
				{
					GeeArrayList* _compilation_list = NULL;
					VlsProject* _tmp175_;
					GeeArrayList* _tmp176_;
					gint _compilation_size = 0;
					GeeArrayList* _tmp177_;
					gint _tmp178_;
					gint _tmp179_;
					gint _compilation_index = 0;
#line 448 "../src/server.vala"
					_tmp175_ = project;
#line 448 "../src/server.vala"
					_tmp176_ = vls_project_get_compilations (_tmp175_);
#line 448 "../src/server.vala"
					_compilation_list = _tmp176_;
#line 448 "../src/server.vala"
					_tmp177_ = _compilation_list;
#line 448 "../src/server.vala"
					_tmp178_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp177_);
#line 448 "../src/server.vala"
					_tmp179_ = _tmp178_;
#line 448 "../src/server.vala"
					_compilation_size = _tmp179_;
#line 448 "../src/server.vala"
					_compilation_index = -1;
#line 448 "../src/server.vala"
					while (TRUE) {
#line 4308 "server.c"
						gint _tmp180_;
						gint _tmp181_;
						VlsCompilation* compilation = NULL;
						GeeArrayList* _tmp182_;
						gpointer _tmp183_;
						VlsProject* _tmp184_;
						VlsCompilation* _tmp185_;
#line 448 "../src/server.vala"
						_compilation_index = _compilation_index + 1;
#line 448 "../src/server.vala"
						_tmp180_ = _compilation_index;
#line 448 "../src/server.vala"
						_tmp181_ = _compilation_size;
#line 448 "../src/server.vala"
						if (!(_tmp180_ < _tmp181_)) {
#line 448 "../src/server.vala"
							break;
#line 4326 "server.c"
						}
#line 448 "../src/server.vala"
						_tmp182_ = _compilation_list;
#line 448 "../src/server.vala"
						_tmp183_ = gee_abstract_list_get ((GeeAbstractList*) _tmp182_, _compilation_index);
#line 448 "../src/server.vala"
						compilation = (VlsCompilation*) _tmp183_;
#line 449 "../src/server.vala"
						_tmp184_ = project;
#line 449 "../src/server.vala"
						_tmp185_ = compilation;
#line 449 "../src/server.vala"
						vls_server_publish_diagnostics (self, _tmp184_, _tmp185_, client);
#line 448 "../src/server.vala"
						_g_object_unref0 (compilation);
#line 4342 "server.c"
					}
#line 448 "../src/server.vala"
					_g_object_unref0 (_compilation_list);
#line 4346 "server.c"
				}
			}
			goto __finally4;
			__catch4_g_error:
			{
				GError* e = NULL;
				GError* _tmp186_;
				const gchar* _tmp187_;
				const gchar* _tmp188_;
				gchar* _tmp189_;
				gchar* _tmp190_;
#line 444 "../src/server.vala"
				e = _inner_error0_;
#line 444 "../src/server.vala"
				_inner_error0_ = NULL;
#line 451 "../src/server.vala"
				_tmp186_ = e;
#line 451 "../src/server.vala"
				_tmp187_ = _tmp186_->message;
#line 451 "../src/server.vala"
				_tmp188_ = string_to_string (_tmp187_);
#line 451 "../src/server.vala"
				_tmp189_ = g_strconcat ("Failed to build project - ", _tmp188_, NULL);
#line 451 "../src/server.vala"
				_tmp190_ = _tmp189_;
#line 451 "../src/server.vala"
				vls_server_show_message (self, client, _tmp190_, LSP_MESSAGE_TYPE_Error);
#line 451 "../src/server.vala"
				_g_free0 (_tmp190_);
#line 444 "../src/server.vala"
				_g_error_free0 (e);
#line 4378 "server.c"
			}
			__finally4:
#line 444 "../src/server.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 444 "../src/server.vala"
				_g_object_unref0 (project);
#line 444 "../src/server.vala"
				_g_object_unref0 (backend_project);
#line 444 "../src/server.vala"
				_g_object_unref0 (new_projects);
#line 444 "../src/server.vala"
				_g_object_unref0 (cc_files);
#line 444 "../src/server.vala"
				_g_object_unref0 (meson_file);
#line 444 "../src/server.vala"
				_g_free0 (root_path);
#line 444 "../src/server.vala"
				_g_object_unref0 (root_dir);
#line 444 "../src/server.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 444 "../src/server.vala"
				g_clear_error (&_inner_error0_);
#line 444 "../src/server.vala"
				return;
#line 4403 "server.c"
			}
#line 443 "../src/server.vala"
			_g_object_unref0 (project);
#line 4407 "server.c"
		}
	}
#line 456 "../src/server.vala"
	_tmp191_ = gee_hash_set_new (VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, NULL, NULL, NULL, NULL, NULL, NULL);
#line 456 "../src/server.vala"
	if (_tmp191_) {
#line 456 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp191_, "vala-creation-function", "Vls.Server.initialize");
#line 4416 "server.c"
	}
#line 456 "../src/server.vala"
	packages = _tmp191_;
#line 457 "../src/server.vala"
	_tmp192_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
#line 457 "../src/server.vala"
	if (_tmp192_) {
#line 457 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp192_, "vala-creation-function", "Vls.Server.initialize");
#line 4426 "server.c"
	}
#line 457 "../src/server.vala"
	custom_gir_dirs = _tmp192_;
#line 4430 "server.c"
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp193_;
		gint _project_size = 0;
		GeeArrayList* _tmp194_;
		gint _tmp195_;
		gint _tmp196_;
		gint _project_index = 0;
#line 458 "../src/server.vala"
		_tmp193_ = new_projects;
#line 458 "../src/server.vala"
		_project_list = _tmp193_;
#line 458 "../src/server.vala"
		_tmp194_ = _project_list;
#line 458 "../src/server.vala"
		_tmp195_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp194_);
#line 458 "../src/server.vala"
		_tmp196_ = _tmp195_;
#line 458 "../src/server.vala"
		_project_size = _tmp196_;
#line 458 "../src/server.vala"
		_project_index = -1;
#line 458 "../src/server.vala"
		while (TRUE) {
#line 4455 "server.c"
			gint _tmp197_;
			gint _tmp198_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp199_;
			gpointer _tmp200_;
			GeeHashSet* _tmp201_;
			VlsProject* _tmp202_;
			GeeCollection* _tmp203_;
			GeeCollection* _tmp204_;
			GeeHashSet* _tmp205_;
			VlsProject* _tmp206_;
			GeeCollection* _tmp207_;
			GeeCollection* _tmp208_;
#line 458 "../src/server.vala"
			_project_index = _project_index + 1;
#line 458 "../src/server.vala"
			_tmp197_ = _project_index;
#line 458 "../src/server.vala"
			_tmp198_ = _project_size;
#line 458 "../src/server.vala"
			if (!(_tmp197_ < _tmp198_)) {
#line 458 "../src/server.vala"
				break;
#line 4479 "server.c"
			}
#line 458 "../src/server.vala"
			_tmp199_ = _project_list;
#line 458 "../src/server.vala"
			_tmp200_ = gee_abstract_list_get ((GeeAbstractList*) _tmp199_, _project_index);
#line 458 "../src/server.vala"
			project = (VlsProject*) _tmp200_;
#line 459 "../src/server.vala"
			_tmp201_ = packages;
#line 459 "../src/server.vala"
			_tmp202_ = project;
#line 459 "../src/server.vala"
			_tmp203_ = vls_project_get_packages (_tmp202_);
#line 459 "../src/server.vala"
			_tmp204_ = _tmp203_;
#line 459 "../src/server.vala"
			gee_collection_add_all ((GeeCollection*) _tmp201_, _tmp204_);
#line 459 "../src/server.vala"
			_g_object_unref0 (_tmp204_);
#line 460 "../src/server.vala"
			_tmp205_ = custom_gir_dirs;
#line 460 "../src/server.vala"
			_tmp206_ = project;
#line 460 "../src/server.vala"
			_tmp207_ = vls_project_get_custom_gir_dirs (_tmp206_);
#line 460 "../src/server.vala"
			_tmp208_ = _tmp207_;
#line 460 "../src/server.vala"
			gee_collection_add_all ((GeeCollection*) _tmp205_, _tmp208_);
#line 460 "../src/server.vala"
			_g_object_unref0 (_tmp208_);
#line 458 "../src/server.vala"
			_g_object_unref0 (project);
#line 4513 "server.c"
		}
	}
#line 462 "../src/server.vala"
	_tmp209_ = packages;
#line 462 "../src/server.vala"
	_tmp210_ = custom_gir_dirs;
#line 462 "../src/server.vala"
	_tmp211_ = vls_gir_documentation_new ((GeeCollection*) _tmp209_, (GeeCollection*) _tmp210_);
#line 462 "../src/server.vala"
	_vls_gir_documentation_unref0 (self->priv->documentation);
#line 462 "../src/server.vala"
	self->priv->documentation = _tmp211_;
#line 465 "../src/server.vala"
	_tmp212_ = _g_object_ref0 (client);
#line 465 "../src/server.vala"
	_g_object_unref0 (self->priv->update_context_client);
#line 465 "../src/server.vala"
	self->priv->update_context_client = _tmp212_;
#line 466 "../src/server.vala"
	_vala_array_add24 (&self->priv->g_sources, &self->priv->g_sources_length1, &self->priv->_g_sources_size_, g_timeout_add_full (G_PRIORITY_DEFAULT, VLS_SERVER_check_update_context_period_ms, _vls_server_check_update_context_gsource_func, g_object_ref (self), g_object_unref));
#line 4534 "server.c"
	{
		GeeArrayList* _project_list = NULL;
		GeeArrayList* _tmp213_;
		gint _project_size = 0;
		GeeArrayList* _tmp214_;
		gint _tmp215_;
		gint _tmp216_;
		gint _project_index = 0;
#line 469 "../src/server.vala"
		_tmp213_ = new_projects;
#line 469 "../src/server.vala"
		_project_list = _tmp213_;
#line 469 "../src/server.vala"
		_tmp214_ = _project_list;
#line 469 "../src/server.vala"
		_tmp215_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp214_);
#line 469 "../src/server.vala"
		_tmp216_ = _tmp215_;
#line 469 "../src/server.vala"
		_project_size = _tmp216_;
#line 469 "../src/server.vala"
		_project_index = -1;
#line 469 "../src/server.vala"
		while (TRUE) {
#line 4559 "server.c"
			gint _tmp217_;
			gint _tmp218_;
			VlsProject* project = NULL;
			GeeArrayList* _tmp219_;
			gpointer _tmp220_;
			GHashTable* _tmp221_;
			VlsProject* _tmp222_;
			VlsProject* _tmp223_;
			VlsProject* _tmp224_;
			gulong _tmp225_;
#line 469 "../src/server.vala"
			_project_index = _project_index + 1;
#line 469 "../src/server.vala"
			_tmp217_ = _project_index;
#line 469 "../src/server.vala"
			_tmp218_ = _project_size;
#line 469 "../src/server.vala"
			if (!(_tmp217_ < _tmp218_)) {
#line 469 "../src/server.vala"
				break;
#line 4580 "server.c"
			}
#line 469 "../src/server.vala"
			_tmp219_ = _project_list;
#line 469 "../src/server.vala"
			_tmp220_ = gee_abstract_list_get ((GeeAbstractList*) _tmp219_, _project_index);
#line 469 "../src/server.vala"
			project = (VlsProject*) _tmp220_;
#line 470 "../src/server.vala"
			_tmp221_ = self->priv->projects;
#line 470 "../src/server.vala"
			_tmp222_ = project;
#line 470 "../src/server.vala"
			_tmp223_ = _g_object_ref0 (_tmp222_);
#line 470 "../src/server.vala"
			_tmp224_ = project;
#line 470 "../src/server.vala"
			_tmp225_ = g_signal_connect_object (_tmp224_, "changed", (GCallback) _vls_server_project_changed_event_vls_project_changed, self, 0);
#line 470 "../src/server.vala"
			g_hash_table_insert (_tmp221_, _tmp223_, (gpointer) ((guintptr) _tmp225_));
#line 469 "../src/server.vala"
			_g_object_unref0 (project);
#line 4602 "server.c"
		}
	}
#line 337 "../src/server.vala"
	_g_object_unref0 (custom_gir_dirs);
#line 337 "../src/server.vala"
	_g_object_unref0 (packages);
#line 337 "../src/server.vala"
	_g_object_unref0 (backend_project);
#line 337 "../src/server.vala"
	_g_object_unref0 (new_projects);
#line 337 "../src/server.vala"
	_g_object_unref0 (cc_files);
#line 337 "../src/server.vala"
	_g_object_unref0 (meson_file);
#line 337 "../src/server.vala"
	_g_free0 (root_path);
#line 337 "../src/server.vala"
	_g_object_unref0 (root_dir);
#line 4621 "server.c"
}

static void
vls_server_project_changed_event (VlsServer* self)
{
	JsonrpcClient* _tmp0_;
#line 473 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/server.vala"
	_tmp0_ = self->priv->update_context_client;
#line 474 "../src/server.vala"
	vls_server_request_context_update (self, _tmp0_);
#line 475 "../src/server.vala"
	g_debug ("server.vala:475: requested context update for project change event");
#line 4636 "server.c"
}

static void
vls_server_cancel_request (VlsServer* self,
                           JsonrpcClient* client,
                           GVariant* params)
{
	GVariant* id = NULL;
	GVariant* _tmp0_;
	GVariant* _tmp1_;
	VlsRequest* req = NULL;
	GVariant* _tmp2_;
	VlsRequest* _tmp3_;
	GeeHashSet* _tmp4_;
	VlsRequest* _tmp5_;
#line 478 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 478 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 478 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 479 "../src/server.vala"
	_tmp0_ = g_variant_lookup_value (params, "id", NULL);
#line 479 "../src/server.vala"
	id = _tmp0_;
#line 480 "../src/server.vala"
	_tmp1_ = id;
#line 480 "../src/server.vala"
	if (_tmp1_ == NULL) {
#line 481 "../src/server.vala"
		_g_variant_unref0 (id);
#line 481 "../src/server.vala"
		return;
#line 4670 "server.c"
	}
#line 483 "../src/server.vala"
	_tmp2_ = id;
#line 483 "../src/server.vala"
	_tmp3_ = vls_request_new (_tmp2_, NULL);
#line 483 "../src/server.vala"
	if (_tmp3_) {
#line 483 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "Vls.Server.cancel_request");
#line 4680 "server.c"
	}
#line 483 "../src/server.vala"
	req = _tmp3_;
#line 488 "../src/server.vala"
	_tmp4_ = self->priv->pending_requests;
#line 488 "../src/server.vala"
	_tmp5_ = req;
#line 488 "../src/server.vala"
	gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp4_, _tmp5_);
#line 478 "../src/server.vala"
	_g_object_unref0 (req);
#line 478 "../src/server.vala"
	_g_variant_unref0 (id);
#line 4694 "server.c"
}

void
vls_server_reply_null (GVariant* id,
                       JsonrpcClient* client,
                       const gchar* method)
{
	GError* _inner_error0_ = NULL;
#line 491 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 491 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 491 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 4709 "server.c"
	{
		const GVariantType* _tmp0_;
		GVariant* _tmp1_;
		GVariant* _tmp2_;
		GCancellable* _tmp3_;
#line 493 "../src/server.vala"
		_tmp0_ = G_VARIANT_TYPE_VARIANT;
#line 493 "../src/server.vala"
		_tmp1_ = g_variant_new_maybe (_tmp0_, NULL);
#line 493 "../src/server.vala"
		g_variant_ref_sink (_tmp1_);
#line 493 "../src/server.vala"
		_tmp2_ = _tmp1_;
#line 493 "../src/server.vala"
		_tmp3_ = vls_server_cancellable;
#line 493 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp2_, _tmp3_, &_inner_error0_);
#line 493 "../src/server.vala"
		_g_variant_unref0 (_tmp2_);
#line 493 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4731 "server.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp4_;
		GError* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 492 "../src/server.vala"
		e = _inner_error0_;
#line 492 "../src/server.vala"
		_inner_error0_ = NULL;
#line 495 "../src/server.vala"
		_tmp4_ = string_to_string (method);
#line 495 "../src/server.vala"
		_tmp5_ = e;
#line 495 "../src/server.vala"
		_tmp6_ = _tmp5_->message;
#line 495 "../src/server.vala"
		_tmp7_ = string_to_string (_tmp6_);
#line 495 "../src/server.vala"
		_tmp8_ = g_strconcat ("[", _tmp4_, "] failed to reply to client: ", _tmp7_, NULL);
#line 495 "../src/server.vala"
		_tmp9_ = _tmp8_;
#line 495 "../src/server.vala"
		g_debug ("server.vala:495: %s", _tmp9_);
#line 495 "../src/server.vala"
		_g_free0 (_tmp9_);
#line 492 "../src/server.vala"
		_g_error_free0 (e);
#line 4767 "server.c"
	}
	__finally0:
#line 492 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 492 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 492 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 492 "../src/server.vala"
		return;
#line 4778 "server.c"
	}
}

static gchar*
_variant_get3 (GVariant* value)
{
#line 502 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 4787 "server.c"
}

static gchar*
_variant_get4 (GVariant* value)
{
#line 503 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 4795 "server.c"
}

static gchar*
_variant_get5 (GVariant* value)
{
#line 504 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 4803 "server.c"
}

static void
vls_server_text_document_did_open (VlsServer* self,
                                   JsonrpcClient* client,
                                   GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* languageId = NULL;
	GVariant* _tmp8_;
	const GVariantType* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* fileContents = NULL;
	GVariant* _tmp14_;
	const GVariantType* _tmp15_;
	GVariant* _tmp16_;
	GVariant* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gboolean _tmp20_ = FALSE;
	const gchar* _tmp21_;
	const gchar* _tmp27_;
	VlsPair* doc_w_bt = NULL;
	GHashTable* _tmp28_;
	guint _tmp29_ = 0;
	gconstpointer* _tmp30_;
	VlsPair* _tmp44_;
	VlsPair* _tmp67_;
	ValaSourceFile* doc = NULL;
	VlsPair* _tmp69_;
	gconstpointer _tmp70_;
	gconstpointer _tmp71_;
	ValaSourceFile* _tmp72_;
	ValaSourceFile* _tmp73_;
	const gchar* _tmp74_;
	const gchar* _tmp75_;
	ValaSourceFile* _tmp77_;
	GeeHashSet* _tmp100_;
	const gchar* _tmp101_;
	GError* _inner_error0_ = NULL;
#line 499 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 499 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 499 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 500 "../src/server.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 500 "../src/server.vala"
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
#line 500 "../src/server.vala"
	document = _tmp1_;
#line 502 "../src/server.vala"
	_tmp2_ = document;
#line 502 "../src/server.vala"
	_tmp3_ = G_VARIANT_TYPE_STRING;
#line 502 "../src/server.vala"
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
#line 502 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 502 "../src/server.vala"
	_tmp6_ = _variant_get3 (_tmp5_);
#line 502 "../src/server.vala"
	_tmp7_ = _tmp6_;
#line 502 "../src/server.vala"
	_g_variant_unref0 (_tmp5_);
#line 502 "../src/server.vala"
	uri = _tmp7_;
#line 503 "../src/server.vala"
	_tmp8_ = document;
#line 503 "../src/server.vala"
	_tmp9_ = G_VARIANT_TYPE_STRING;
#line 503 "../src/server.vala"
	_tmp10_ = g_variant_lookup_value (_tmp8_, "languageId", _tmp9_);
#line 503 "../src/server.vala"
	_tmp11_ = _tmp10_;
#line 503 "../src/server.vala"
	_tmp12_ = _variant_get4 (_tmp11_);
#line 503 "../src/server.vala"
	_tmp13_ = _tmp12_;
#line 503 "../src/server.vala"
	_g_variant_unref0 (_tmp11_);
#line 503 "../src/server.vala"
	languageId = _tmp13_;
#line 504 "../src/server.vala"
	_tmp14_ = document;
#line 504 "../src/server.vala"
	_tmp15_ = G_VARIANT_TYPE_STRING;
#line 504 "../src/server.vala"
	_tmp16_ = g_variant_lookup_value (_tmp14_, "text", _tmp15_);
#line 504 "../src/server.vala"
	_tmp17_ = _tmp16_;
#line 504 "../src/server.vala"
	_tmp18_ = _variant_get5 (_tmp17_);
#line 504 "../src/server.vala"
	_tmp19_ = _tmp18_;
#line 504 "../src/server.vala"
	_g_variant_unref0 (_tmp17_);
#line 504 "../src/server.vala"
	fileContents = _tmp19_;
#line 506 "../src/server.vala"
	_tmp21_ = languageId;
#line 506 "../src/server.vala"
	if (g_strcmp0 (_tmp21_, "vala") != 0) {
#line 4920 "server.c"
		const gchar* _tmp22_;
#line 506 "../src/server.vala"
		_tmp22_ = languageId;
#line 506 "../src/server.vala"
		_tmp20_ = g_strcmp0 (_tmp22_, "genie") != 0;
#line 4926 "server.c"
	} else {
#line 506 "../src/server.vala"
		_tmp20_ = FALSE;
#line 4930 "server.c"
	}
#line 506 "../src/server.vala"
	if (_tmp20_) {
#line 4934 "server.c"
		const gchar* _tmp23_;
		const gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
#line 507 "../src/server.vala"
		_tmp23_ = languageId;
#line 507 "../src/server.vala"
		_tmp24_ = string_to_string (_tmp23_);
#line 507 "../src/server.vala"
		_tmp25_ = g_strconcat ("[textDocument/didOpen] ", _tmp24_, " file sent to vala language server", NULL);
#line 507 "../src/server.vala"
		_tmp26_ = _tmp25_;
#line 507 "../src/server.vala"
		g_warning ("server.vala:507: %s", _tmp26_);
#line 507 "../src/server.vala"
		_g_free0 (_tmp26_);
#line 508 "../src/server.vala"
		_g_free0 (fileContents);
#line 508 "../src/server.vala"
		_g_free0 (languageId);
#line 508 "../src/server.vala"
		_g_free0 (uri);
#line 508 "../src/server.vala"
		_g_variant_unref0 (document);
#line 508 "../src/server.vala"
		return;
#line 4961 "server.c"
	}
#line 511 "../src/server.vala"
	_tmp27_ = uri;
#line 511 "../src/server.vala"
	if (_tmp27_ == NULL) {
#line 512 "../src/server.vala"
		g_warning ("server.vala:512: %s", "[textDocument/didOpen] null URI sent to vala language server");
#line 513 "../src/server.vala"
		_g_free0 (fileContents);
#line 513 "../src/server.vala"
		_g_free0 (languageId);
#line 513 "../src/server.vala"
		_g_free0 (uri);
#line 513 "../src/server.vala"
		_g_variant_unref0 (document);
#line 513 "../src/server.vala"
		return;
#line 4979 "server.c"
	}
#line 516 "../src/server.vala"
	doc_w_bt = NULL;
#line 518 "../src/server.vala"
	_tmp28_ = self->priv->projects;
#line 518 "../src/server.vala"
	_tmp30_ = g_hash_table_get_keys_as_array (_tmp28_, &_tmp29_);
#line 4987 "server.c"
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
#line 518 "../src/server.vala"
		project_collection = _tmp30_;
#line 518 "../src/server.vala"
		project_collection_length1 = _tmp29_;
#line 518 "../src/server.vala"
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
#line 4999 "server.c"
			VlsProject* project = NULL;
#line 518 "../src/server.vala"
			project = project_collection[project_it];
#line 5003 "server.c"
			{
				{
					GeeArrayList* _tmp31_ = NULL;
					VlsProject* _tmp32_;
					const gchar* _tmp33_;
					const gchar* _tmp34_;
					GCancellable* _tmp35_;
					GeeArrayList* _tmp36_;
					gpointer _tmp37_;
#line 520 "../src/server.vala"
					_tmp32_ = project;
#line 520 "../src/server.vala"
					_tmp33_ = uri;
#line 520 "../src/server.vala"
					_tmp34_ = fileContents;
#line 520 "../src/server.vala"
					_tmp35_ = vls_server_cancellable;
#line 520 "../src/server.vala"
					_tmp36_ = vls_project_open (_tmp32_, _tmp33_, _tmp34_, _tmp35_, &_inner_error0_);
#line 520 "../src/server.vala"
					_tmp31_ = _tmp36_;
#line 520 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5027 "server.c"
						goto __catch0_g_error;
					}
#line 520 "../src/server.vala"
					_tmp37_ = gee_list_first ((GeeList*) _tmp31_);
#line 520 "../src/server.vala"
					_g_object_unref0 (doc_w_bt);
#line 520 "../src/server.vala"
					doc_w_bt = (VlsPair*) _tmp37_;
#line 521 "../src/server.vala"
					_g_object_unref0 (_tmp31_);
#line 521 "../src/server.vala"
					break;
#line 5040 "server.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp38_;
#line 519 "../src/server.vala"
					e = _inner_error0_;
#line 519 "../src/server.vala"
					_inner_error0_ = NULL;
#line 523 "../src/server.vala"
					_tmp38_ = e;
#line 523 "../src/server.vala"
					if (!g_error_matches (_tmp38_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_NOT_FOUND)) {
#line 5055 "server.c"
						const gchar* _tmp39_;
						gchar* _tmp40_;
						gchar* _tmp41_;
						GError* _tmp42_;
						const gchar* _tmp43_;
#line 524 "../src/server.vala"
						_tmp39_ = uri;
#line 524 "../src/server.vala"
						_tmp40_ = g_uri_unescape_string (_tmp39_, NULL);
#line 524 "../src/server.vala"
						_tmp41_ = _tmp40_;
#line 524 "../src/server.vala"
						_tmp42_ = e;
#line 524 "../src/server.vala"
						_tmp43_ = _tmp42_->message;
#line 524 "../src/server.vala"
						g_warning ("server.vala:524: [textDocument/didOpen] failed to open %s - %s", _tmp41_, _tmp43_);
#line 524 "../src/server.vala"
						_g_free0 (_tmp41_);
#line 5075 "server.c"
					}
#line 519 "../src/server.vala"
					_g_error_free0 (e);
#line 5079 "server.c"
				}
				__finally0:
#line 519 "../src/server.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 519 "../src/server.vala"
					project_collection = (g_free (project_collection), NULL);
#line 519 "../src/server.vala"
					_g_object_unref0 (doc_w_bt);
#line 519 "../src/server.vala"
					_g_free0 (fileContents);
#line 519 "../src/server.vala"
					_g_free0 (languageId);
#line 519 "../src/server.vala"
					_g_free0 (uri);
#line 519 "../src/server.vala"
					_g_variant_unref0 (document);
#line 519 "../src/server.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 519 "../src/server.vala"
					g_clear_error (&_inner_error0_);
#line 519 "../src/server.vala"
					return;
#line 5102 "server.c"
				}
			}
		}
#line 518 "../src/server.vala"
		project_collection = (g_free (project_collection), NULL);
#line 5108 "server.c"
	}
#line 529 "../src/server.vala"
	_tmp44_ = doc_w_bt;
#line 529 "../src/server.vala"
	if (_tmp44_ == NULL) {
#line 5114 "server.c"
		{
			GeeArrayList* _tmp45_ = NULL;
			VlsDefaultProject* _tmp46_;
			const gchar* _tmp47_;
			const gchar* _tmp48_;
			GCancellable* _tmp49_;
			GeeArrayList* _tmp50_;
			gpointer _tmp51_;
#line 531 "../src/server.vala"
			_tmp46_ = self->priv->default_project;
#line 531 "../src/server.vala"
			_tmp47_ = uri;
#line 531 "../src/server.vala"
			_tmp48_ = fileContents;
#line 531 "../src/server.vala"
			_tmp49_ = vls_server_cancellable;
#line 531 "../src/server.vala"
			_tmp50_ = vls_project_open ((VlsProject*) _tmp46_, _tmp47_, _tmp48_, _tmp49_, &_inner_error0_);
#line 531 "../src/server.vala"
			_tmp45_ = _tmp50_;
#line 531 "../src/server.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5137 "server.c"
				goto __catch1_g_error;
			}
#line 531 "../src/server.vala"
			_tmp51_ = gee_list_first ((GeeList*) _tmp45_);
#line 531 "../src/server.vala"
			_g_object_unref0 (doc_w_bt);
#line 531 "../src/server.vala"
			doc_w_bt = (VlsPair*) _tmp51_;
#line 5146 "server.c"
			{
				GeeIterator* _pkg_it = NULL;
				VlsDefaultProject* _tmp52_;
				GeeCollection* _tmp53_;
				GeeCollection* _tmp54_;
				GeeIterator* _tmp55_;
				GeeIterator* _tmp56_;
#line 534 "../src/server.vala"
				_tmp52_ = self->priv->default_project;
#line 534 "../src/server.vala"
				_tmp53_ = vls_project_get_packages ((VlsProject*) _tmp52_);
#line 534 "../src/server.vala"
				_tmp54_ = _tmp53_;
#line 534 "../src/server.vala"
				_tmp55_ = gee_iterable_iterator ((GeeIterable*) _tmp54_);
#line 534 "../src/server.vala"
				_tmp56_ = _tmp55_;
#line 534 "../src/server.vala"
				_g_object_unref0 (_tmp54_);
#line 534 "../src/server.vala"
				_pkg_it = _tmp56_;
#line 534 "../src/server.vala"
				while (TRUE) {
#line 5170 "server.c"
					GeeIterator* _tmp57_;
					ValaSourceFile* pkg = NULL;
					GeeIterator* _tmp58_;
					gpointer _tmp59_;
					VlsGirDocumentation* _tmp60_;
					ValaSourceFile* _tmp61_;
#line 534 "../src/server.vala"
					_tmp57_ = _pkg_it;
#line 534 "../src/server.vala"
					if (!gee_iterator_next (_tmp57_)) {
#line 534 "../src/server.vala"
						break;
#line 5183 "server.c"
					}
#line 534 "../src/server.vala"
					_tmp58_ = _pkg_it;
#line 534 "../src/server.vala"
					_tmp59_ = gee_iterator_get (_tmp58_);
#line 534 "../src/server.vala"
					pkg = (ValaSourceFile*) _tmp59_;
#line 535 "../src/server.vala"
					_tmp60_ = self->priv->documentation;
#line 535 "../src/server.vala"
					_tmp61_ = pkg;
#line 535 "../src/server.vala"
					vls_gir_documentation_add_package_from_source_file (_tmp60_, _tmp61_);
#line 534 "../src/server.vala"
					_vala_source_file_unref0 (pkg);
#line 5199 "server.c"
				}
#line 534 "../src/server.vala"
				_g_object_unref0 (_pkg_it);
#line 5203 "server.c"
			}
#line 537 "../src/server.vala"
			vls_server_request_context_update (self, client);
#line 530 "../src/server.vala"
			_g_object_unref0 (_tmp45_);
#line 5209 "server.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
			GError* e = NULL;
			const gchar* _tmp62_;
			gchar* _tmp63_;
			gchar* _tmp64_;
			GError* _tmp65_;
			const gchar* _tmp66_;
#line 530 "../src/server.vala"
			e = _inner_error0_;
#line 530 "../src/server.vala"
			_inner_error0_ = NULL;
#line 539 "../src/server.vala"
			_tmp62_ = uri;
#line 539 "../src/server.vala"
			_tmp63_ = g_uri_unescape_string (_tmp62_, NULL);
#line 539 "../src/server.vala"
			_tmp64_ = _tmp63_;
#line 539 "../src/server.vala"
			_tmp65_ = e;
#line 539 "../src/server.vala"
			_tmp66_ = _tmp65_->message;
#line 539 "../src/server.vala"
			g_warning ("server.vala:539: [textDocumnt/didOpen] failed to open %s - %s", _tmp64_, _tmp66_);
#line 539 "../src/server.vala"
			_g_free0 (_tmp64_);
#line 530 "../src/server.vala"
			_g_error_free0 (e);
#line 5240 "server.c"
		}
		__finally1:
#line 530 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 530 "../src/server.vala"
			_g_object_unref0 (doc_w_bt);
#line 530 "../src/server.vala"
			_g_free0 (fileContents);
#line 530 "../src/server.vala"
			_g_free0 (languageId);
#line 530 "../src/server.vala"
			_g_free0 (uri);
#line 530 "../src/server.vala"
			_g_variant_unref0 (document);
#line 530 "../src/server.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 530 "../src/server.vala"
			g_clear_error (&_inner_error0_);
#line 530 "../src/server.vala"
			return;
#line 5261 "server.c"
		}
	}
#line 543 "../src/server.vala"
	_tmp67_ = doc_w_bt;
#line 543 "../src/server.vala"
	if (_tmp67_ == NULL) {
#line 5268 "server.c"
		const gchar* _tmp68_;
#line 544 "../src/server.vala"
		_tmp68_ = uri;
#line 544 "../src/server.vala"
		g_warning ("server.vala:544: [textDocument/didOpen] could not open %s", _tmp68_);
#line 545 "../src/server.vala"
		_g_object_unref0 (doc_w_bt);
#line 545 "../src/server.vala"
		_g_free0 (fileContents);
#line 545 "../src/server.vala"
		_g_free0 (languageId);
#line 545 "../src/server.vala"
		_g_free0 (uri);
#line 545 "../src/server.vala"
		_g_variant_unref0 (document);
#line 545 "../src/server.vala"
		return;
#line 5286 "server.c"
	}
#line 548 "../src/server.vala"
	_tmp69_ = doc_w_bt;
#line 548 "../src/server.vala"
	_tmp70_ = vls_pair_get_first (_tmp69_);
#line 548 "../src/server.vala"
	_tmp71_ = _tmp70_;
#line 548 "../src/server.vala"
	_tmp72_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp71_);
#line 548 "../src/server.vala"
	doc = _tmp72_;
#line 552 "../src/server.vala"
	_tmp73_ = doc;
#line 552 "../src/server.vala"
	_tmp74_ = vala_source_file_get_content (_tmp73_);
#line 552 "../src/server.vala"
	_tmp75_ = _tmp74_;
#line 552 "../src/server.vala"
	if (_tmp75_ == NULL) {
#line 5306 "server.c"
		ValaSourceFile* _tmp76_;
#line 553 "../src/server.vala"
		_tmp76_ = doc;
#line 553 "../src/server.vala"
		vala_source_file_get_mapped_contents (_tmp76_);
#line 5312 "server.c"
	}
#line 554 "../src/server.vala"
	_tmp77_ = doc;
#line 554 "../src/server.vala"
	if (VLS_IS_TEXT_DOCUMENT (_tmp77_)) {
#line 5318 "server.c"
		VlsTextDocument* tdoc = NULL;
		ValaSourceFile* _tmp78_;
		VlsTextDocument* _tmp79_;
		const gchar* _tmp80_;
		gchar* _tmp81_;
		gchar* _tmp82_;
		const gchar* _tmp83_;
		gchar* _tmp84_;
		gchar* _tmp85_;
		VlsTextDocument* _tmp86_;
		const gchar* _tmp87_;
		VlsTextDocument* _tmp88_;
		const gchar* _tmp89_;
		const gchar* _tmp90_;
		const gchar* _tmp91_;
#line 555 "../src/server.vala"
		_tmp78_ = doc;
#line 555 "../src/server.vala"
		_tmp79_ = _vala_source_file_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp78_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument));
#line 555 "../src/server.vala"
		tdoc = _tmp79_;
#line 556 "../src/server.vala"
		_tmp80_ = uri;
#line 556 "../src/server.vala"
		_tmp81_ = g_uri_unescape_string (_tmp80_, NULL);
#line 556 "../src/server.vala"
		_tmp82_ = _tmp81_;
#line 556 "../src/server.vala"
		_tmp83_ = string_to_string (_tmp82_);
#line 556 "../src/server.vala"
		_tmp84_ = g_strconcat ("[textDocument/didOpen] opened ", _tmp83_, NULL);
#line 556 "../src/server.vala"
		_tmp85_ = _tmp84_;
#line 556 "../src/server.vala"
		g_debug ("server.vala:556: %s", _tmp85_);
#line 556 "../src/server.vala"
		_g_free0 (_tmp85_);
#line 556 "../src/server.vala"
		_g_free0 (_tmp82_);
#line 557 "../src/server.vala"
		_tmp86_ = tdoc;
#line 557 "../src/server.vala"
		_tmp87_ = fileContents;
#line 557 "../src/server.vala"
		vls_text_document_set_last_saved_content (_tmp86_, _tmp87_);
#line 558 "../src/server.vala"
		_tmp88_ = tdoc;
#line 558 "../src/server.vala"
		_tmp89_ = vala_source_file_get_content ((ValaSourceFile*) _tmp88_);
#line 558 "../src/server.vala"
		_tmp90_ = _tmp89_;
#line 558 "../src/server.vala"
		_tmp91_ = fileContents;
#line 558 "../src/server.vala"
		if (g_strcmp0 (_tmp90_, _tmp91_) != 0) {
#line 5374 "server.c"
			VlsTextDocument* _tmp92_;
			const gchar* _tmp93_;
#line 559 "../src/server.vala"
			_tmp92_ = tdoc;
#line 559 "../src/server.vala"
			_tmp93_ = fileContents;
#line 559 "../src/server.vala"
			vala_source_file_set_content ((ValaSourceFile*) _tmp92_, _tmp93_);
#line 560 "../src/server.vala"
			vls_server_request_context_update (self, client);
#line 561 "../src/server.vala"
			g_debug ("server.vala:561: %s", "[textDocument/didOpen] requested context update");
#line 5387 "server.c"
		}
#line 554 "../src/server.vala"
		_vala_source_file_unref0 (tdoc);
#line 5391 "server.c"
	} else {
		const gchar* _tmp94_;
		gchar* _tmp95_;
		gchar* _tmp96_;
		const gchar* _tmp97_;
		gchar* _tmp98_;
		gchar* _tmp99_;
#line 564 "../src/server.vala"
		_tmp94_ = uri;
#line 564 "../src/server.vala"
		_tmp95_ = g_uri_unescape_string (_tmp94_, NULL);
#line 564 "../src/server.vala"
		_tmp96_ = _tmp95_;
#line 564 "../src/server.vala"
		_tmp97_ = string_to_string (_tmp96_);
#line 564 "../src/server.vala"
		_tmp98_ = g_strconcat ("[textDocument/didOpen] opened read-only ", _tmp97_, NULL);
#line 564 "../src/server.vala"
		_tmp99_ = _tmp98_;
#line 564 "../src/server.vala"
		g_debug ("server.vala:564: %s", _tmp99_);
#line 564 "../src/server.vala"
		_g_free0 (_tmp99_);
#line 564 "../src/server.vala"
		_g_free0 (_tmp96_);
#line 5417 "server.c"
	}
#line 568 "../src/server.vala"
	_tmp100_ = self->priv->open_files;
#line 568 "../src/server.vala"
	_tmp101_ = uri;
#line 568 "../src/server.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp100_, _tmp101_);
#line 499 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 499 "../src/server.vala"
	_g_object_unref0 (doc_w_bt);
#line 499 "../src/server.vala"
	_g_free0 (fileContents);
#line 499 "../src/server.vala"
	_g_free0 (languageId);
#line 499 "../src/server.vala"
	_g_free0 (uri);
#line 499 "../src/server.vala"
	_g_variant_unref0 (document);
#line 5437 "server.c"
}

static gchar*
_variant_get6 (GVariant* value)
{
#line 574 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 5445 "server.c"
}

static VlsProject**
_vala_array_dup13 (VlsProject** self,
                   gssize length)
{
#line 580 "../src/server.vala"
	if (length >= 0) {
#line 5454 "server.c"
		VlsProject** result;
		gssize i;
#line 580 "../src/server.vala"
		result = g_new0 (VlsProject*, length + 1);
#line 580 "../src/server.vala"
		for (i = 0; i < length; i++) {
#line 5461 "server.c"
			VlsProject* _tmp0_;
#line 580 "../src/server.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 580 "../src/server.vala"
			result[i] = _tmp0_;
#line 5467 "server.c"
		}
#line 580 "../src/server.vala"
		return result;
#line 5471 "server.c"
	}
#line 580 "../src/server.vala"
	return NULL;
#line 5475 "server.c"
}

static void
_vala_array_add25 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
#line 581 "../src/server.vala"
	if ((*length) == (*size)) {
#line 581 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 581 "../src/server.vala"
		*array = g_renew (VlsProject*, *array, (*size) + 1);
#line 5490 "server.c"
	}
#line 581 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 581 "../src/server.vala"
	(*array)[*length] = NULL;
#line 5496 "server.c"
}

static void
vls_server_text_document_did_save (VlsServer* self,
                                   JsonrpcClient* client,
                                   GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp9_;
	guint _tmp10_ = 0;
	gconstpointer* _tmp11_;
	VlsProject** _tmp12_;
	gint _tmp12__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp13_;
	VlsProject* _tmp14_;
	VlsProject** _tmp15_;
	gint _tmp15__length1;
#line 571 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 571 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 571 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 572 "../src/server.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 572 "../src/server.vala"
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
#line 572 "../src/server.vala"
	document = _tmp1_;
#line 574 "../src/server.vala"
	_tmp2_ = document;
#line 574 "../src/server.vala"
	_tmp3_ = G_VARIANT_TYPE_STRING;
#line 574 "../src/server.vala"
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
#line 574 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 574 "../src/server.vala"
	_tmp6_ = _variant_get6 (_tmp5_);
#line 574 "../src/server.vala"
	_tmp7_ = _tmp6_;
#line 574 "../src/server.vala"
	_g_variant_unref0 (_tmp5_);
#line 574 "../src/server.vala"
	uri = _tmp7_;
#line 575 "../src/server.vala"
	_tmp8_ = uri;
#line 575 "../src/server.vala"
	if (_tmp8_ == NULL) {
#line 576 "../src/server.vala"
		g_warning ("server.vala:576: %s", "[textDocument/didSave] null URI sent to vala language server");
#line 577 "../src/server.vala"
		_g_free0 (uri);
#line 577 "../src/server.vala"
		_g_variant_unref0 (document);
#line 577 "../src/server.vala"
		return;
#line 5567 "server.c"
	}
#line 580 "../src/server.vala"
	_tmp9_ = self->priv->projects;
#line 580 "../src/server.vala"
	_tmp11_ = g_hash_table_get_keys_as_array (_tmp9_, &_tmp10_);
#line 580 "../src/server.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup13 (_tmp11_, _tmp10_) : _tmp11_;
#line 580 "../src/server.vala"
	_tmp12__length1 = _tmp10_;
#line 580 "../src/server.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 580 "../src/server.vala"
	all_projects = _tmp12_;
#line 580 "../src/server.vala"
	all_projects_length1 = _tmp12__length1;
#line 580 "../src/server.vala"
	_all_projects_size_ = all_projects_length1;
#line 581 "../src/server.vala"
	_tmp13_ = self->priv->default_project;
#line 581 "../src/server.vala"
	_tmp14_ = _g_object_ref0 ((VlsProject*) _tmp13_);
#line 581 "../src/server.vala"
	_vala_array_add25 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp14_);
#line 583 "../src/server.vala"
	_tmp15_ = all_projects;
#line 583 "../src/server.vala"
	_tmp15__length1 = all_projects_length1;
#line 5595 "server.c"
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
#line 583 "../src/server.vala"
		project_collection = _tmp15_;
#line 583 "../src/server.vala"
		project_collection_length1 = _tmp15__length1;
#line 583 "../src/server.vala"
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
#line 5607 "server.c"
			VlsProject* _tmp16_;
			VlsProject* project = NULL;
#line 583 "../src/server.vala"
			_tmp16_ = _g_object_ref0 (project_collection[project_it]);
#line 583 "../src/server.vala"
			project = _tmp16_;
#line 5614 "server.c"
			{
				{
					GeeArrayList* _pair_list = NULL;
					VlsProject* _tmp17_;
					const gchar* _tmp18_;
					GeeArrayList* _tmp19_;
					gint _pair_size = 0;
					GeeArrayList* _tmp20_;
					gint _tmp21_;
					gint _tmp22_;
					gint _pair_index = 0;
#line 584 "../src/server.vala"
					_tmp17_ = project;
#line 584 "../src/server.vala"
					_tmp18_ = uri;
#line 584 "../src/server.vala"
					_tmp19_ = vls_project_lookup_compile_input_source_file (_tmp17_, _tmp18_);
#line 584 "../src/server.vala"
					_pair_list = _tmp19_;
#line 584 "../src/server.vala"
					_tmp20_ = _pair_list;
#line 584 "../src/server.vala"
					_tmp21_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp20_);
#line 584 "../src/server.vala"
					_tmp22_ = _tmp21_;
#line 584 "../src/server.vala"
					_pair_size = _tmp22_;
#line 584 "../src/server.vala"
					_pair_index = -1;
#line 584 "../src/server.vala"
					while (TRUE) {
#line 5646 "server.c"
						gint _tmp23_;
						gint _tmp24_;
						VlsPair* pair = NULL;
						GeeArrayList* _tmp25_;
						gpointer _tmp26_;
						VlsTextDocument* text_document = NULL;
						VlsPair* _tmp27_;
						gconstpointer _tmp28_;
						gconstpointer _tmp29_;
						ValaSourceFile* _tmp30_;
						VlsTextDocument* _tmp31_;
						VlsTextDocument* _tmp32_;
						VlsTextDocument* _tmp33_;
						VlsTextDocument* _tmp34_;
						const gchar* _tmp35_;
						const gchar* _tmp36_;
						const gchar* _tmp37_;
						VlsTextDocument* _tmp38_;
						gint _tmp39_;
						gint _tmp40_;
#line 584 "../src/server.vala"
						_pair_index = _pair_index + 1;
#line 584 "../src/server.vala"
						_tmp23_ = _pair_index;
#line 584 "../src/server.vala"
						_tmp24_ = _pair_size;
#line 584 "../src/server.vala"
						if (!(_tmp23_ < _tmp24_)) {
#line 584 "../src/server.vala"
							break;
#line 5677 "server.c"
						}
#line 584 "../src/server.vala"
						_tmp25_ = _pair_list;
#line 584 "../src/server.vala"
						_tmp26_ = gee_abstract_list_get ((GeeAbstractList*) _tmp25_, _pair_index);
#line 584 "../src/server.vala"
						pair = (VlsPair*) _tmp26_;
#line 585 "../src/server.vala"
						_tmp27_ = pair;
#line 585 "../src/server.vala"
						_tmp28_ = vls_pair_get_first (_tmp27_);
#line 585 "../src/server.vala"
						_tmp29_ = _tmp28_;
#line 585 "../src/server.vala"
						_tmp30_ = (ValaSourceFile*) _tmp29_;
#line 585 "../src/server.vala"
						_tmp31_ = _vala_source_file_ref0 (VLS_IS_TEXT_DOCUMENT (_tmp30_) ? ((VlsTextDocument*) _tmp30_) : NULL);
#line 585 "../src/server.vala"
						text_document = _tmp31_;
#line 587 "../src/server.vala"
						_tmp32_ = text_document;
#line 587 "../src/server.vala"
						if (_tmp32_ == NULL) {
#line 588 "../src/server.vala"
							g_warning ("server.vala:588: [textDocument/didSave] ignoring save to system file");
#line 589 "../src/server.vala"
							_vala_source_file_unref0 (text_document);
#line 589 "../src/server.vala"
							_g_object_unref0 (pair);
#line 589 "../src/server.vala"
							continue;
#line 5709 "server.c"
						}
#line 593 "../src/server.vala"
						_tmp33_ = text_document;
#line 593 "../src/server.vala"
						_tmp34_ = text_document;
#line 593 "../src/server.vala"
						_tmp35_ = vala_source_file_get_content ((ValaSourceFile*) _tmp34_);
#line 593 "../src/server.vala"
						_tmp36_ = _tmp35_;
#line 593 "../src/server.vala"
						vls_text_document_set_last_saved_content (_tmp33_, _tmp36_);
#line 594 "../src/server.vala"
						_tmp37_ = uri;
#line 594 "../src/server.vala"
						_tmp38_ = text_document;
#line 594 "../src/server.vala"
						_tmp39_ = vls_text_document_get_last_saved_version (_tmp38_);
#line 594 "../src/server.vala"
						_tmp40_ = _tmp39_;
#line 594 "../src/server.vala"
						g_debug ("server.vala:594: [textDocument/didSave] last save of %s is now at vers" \
"ion %d", _tmp37_, _tmp40_);
#line 584 "../src/server.vala"
						_vala_source_file_unref0 (text_document);
#line 584 "../src/server.vala"
						_g_object_unref0 (pair);
#line 5735 "server.c"
					}
#line 584 "../src/server.vala"
					_g_object_unref0 (_pair_list);
#line 5739 "server.c"
				}
#line 583 "../src/server.vala"
				_g_object_unref0 (project);
#line 5743 "server.c"
			}
		}
	}
#line 571 "../src/server.vala"
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 571 "../src/server.vala"
	_g_free0 (uri);
#line 571 "../src/server.vala"
	_g_variant_unref0 (document);
#line 5753 "server.c"
}

static gchar*
_variant_get7 (GVariant* value)
{
#line 601 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 5761 "server.c"
}

static VlsProject**
_vala_array_dup14 (VlsProject** self,
                   gssize length)
{
#line 608 "../src/server.vala"
	if (length >= 0) {
#line 5770 "server.c"
		VlsProject** result;
		gssize i;
#line 608 "../src/server.vala"
		result = g_new0 (VlsProject*, length + 1);
#line 608 "../src/server.vala"
		for (i = 0; i < length; i++) {
#line 5777 "server.c"
			VlsProject* _tmp0_;
#line 608 "../src/server.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 608 "../src/server.vala"
			result[i] = _tmp0_;
#line 5783 "server.c"
		}
#line 608 "../src/server.vala"
		return result;
#line 5787 "server.c"
	}
#line 608 "../src/server.vala"
	return NULL;
#line 5791 "server.c"
}

static void
_vala_array_add26 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
#line 609 "../src/server.vala"
	if ((*length) == (*size)) {
#line 609 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 609 "../src/server.vala"
		*array = g_renew (VlsProject*, *array, (*size) + 1);
#line 5806 "server.c"
	}
#line 609 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 609 "../src/server.vala"
	(*array)[*length] = NULL;
#line 5812 "server.c"
}

static void
vls_server_text_document_did_close (VlsServer* self,
                                    JsonrpcClient* client,
                                    GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* uri = NULL;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp9_;
	guint _tmp10_ = 0;
	gconstpointer* _tmp11_;
	VlsProject** _tmp12_;
	gint _tmp12__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp13_;
	VlsProject* _tmp14_;
	VlsProject** _tmp15_;
	gint _tmp15__length1;
	GError* _inner_error0_ = NULL;
#line 599 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 599 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 599 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 600 "../src/server.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 600 "../src/server.vala"
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
#line 600 "../src/server.vala"
	document = _tmp1_;
#line 601 "../src/server.vala"
	_tmp2_ = document;
#line 601 "../src/server.vala"
	_tmp3_ = G_VARIANT_TYPE_STRING;
#line 601 "../src/server.vala"
	_tmp4_ = g_variant_lookup_value (_tmp2_, "uri", _tmp3_);
#line 601 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 601 "../src/server.vala"
	_tmp6_ = _variant_get7 (_tmp5_);
#line 601 "../src/server.vala"
	_tmp7_ = _tmp6_;
#line 601 "../src/server.vala"
	_g_variant_unref0 (_tmp5_);
#line 601 "../src/server.vala"
	uri = _tmp7_;
#line 603 "../src/server.vala"
	_tmp8_ = uri;
#line 603 "../src/server.vala"
	if (_tmp8_ == NULL) {
#line 604 "../src/server.vala"
		g_warning ("server.vala:604: %s", "[textDocument/didClose] null URI sent to vala language server");
#line 605 "../src/server.vala"
		_g_free0 (uri);
#line 605 "../src/server.vala"
		_g_variant_unref0 (document);
#line 605 "../src/server.vala"
		return;
#line 5884 "server.c"
	}
#line 608 "../src/server.vala"
	_tmp9_ = self->priv->projects;
#line 608 "../src/server.vala"
	_tmp11_ = g_hash_table_get_keys_as_array (_tmp9_, &_tmp10_);
#line 608 "../src/server.vala"
	_tmp12_ = (_tmp11_ != NULL) ? _vala_array_dup14 (_tmp11_, _tmp10_) : _tmp11_;
#line 608 "../src/server.vala"
	_tmp12__length1 = _tmp10_;
#line 608 "../src/server.vala"
	_tmp11_ = (g_free (_tmp11_), NULL);
#line 608 "../src/server.vala"
	all_projects = _tmp12_;
#line 608 "../src/server.vala"
	all_projects_length1 = _tmp12__length1;
#line 608 "../src/server.vala"
	_all_projects_size_ = all_projects_length1;
#line 609 "../src/server.vala"
	_tmp13_ = self->priv->default_project;
#line 609 "../src/server.vala"
	_tmp14_ = _g_object_ref0 ((VlsProject*) _tmp13_);
#line 609 "../src/server.vala"
	_vala_array_add26 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp14_);
#line 611 "../src/server.vala"
	_tmp15_ = all_projects;
#line 611 "../src/server.vala"
	_tmp15__length1 = all_projects_length1;
#line 5912 "server.c"
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
#line 611 "../src/server.vala"
		project_collection = _tmp15_;
#line 611 "../src/server.vala"
		project_collection_length1 = _tmp15__length1;
#line 611 "../src/server.vala"
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
#line 5924 "server.c"
			VlsProject* _tmp16_;
			VlsProject* project = NULL;
#line 611 "../src/server.vala"
			_tmp16_ = _g_object_ref0 (project_collection[project_it]);
#line 611 "../src/server.vala"
			project = _tmp16_;
#line 5931 "server.c"
			{
				{
					gboolean _tmp17_ = FALSE;
					VlsProject* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp22_;
#line 613 "../src/server.vala"
					_tmp18_ = project;
#line 613 "../src/server.vala"
					_tmp19_ = uri;
#line 613 "../src/server.vala"
					_tmp17_ = vls_project_close (_tmp18_, _tmp19_, &_inner_error0_);
#line 613 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 5946 "server.c"
						goto __catch0_g_error;
					}
#line 613 "../src/server.vala"
					if (_tmp17_) {
#line 5951 "server.c"
						GeeHashSet* _tmp20_;
						const gchar* _tmp21_;
#line 614 "../src/server.vala"
						_tmp20_ = self->priv->discarded_files;
#line 614 "../src/server.vala"
						_tmp21_ = uri;
#line 614 "../src/server.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp20_, _tmp21_);
#line 615 "../src/server.vala"
						vls_server_request_context_update (self, client);
#line 616 "../src/server.vala"
						g_debug ("server.vala:616: %s", "[textDocument/didClose] requested context update");
#line 5964 "server.c"
					}
#line 618 "../src/server.vala"
					_tmp22_ = uri;
#line 618 "../src/server.vala"
					g_debug ("server.vala:618: [textDocument/didClose] closed %s", _tmp22_);
#line 5970 "server.c"
				}
				goto __finally0;
				__catch0_g_error:
				{
					GError* e = NULL;
					GError* _tmp23_;
#line 612 "../src/server.vala"
					e = _inner_error0_;
#line 612 "../src/server.vala"
					_inner_error0_ = NULL;
#line 620 "../src/server.vala"
					_tmp23_ = e;
#line 620 "../src/server.vala"
					if (!g_error_matches (_tmp23_, VLS_PROJECT_ERROR, VLS_PROJECT_ERROR_NOT_FOUND)) {
#line 5985 "server.c"
						const gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						GError* _tmp27_;
						const gchar* _tmp28_;
#line 621 "../src/server.vala"
						_tmp24_ = uri;
#line 621 "../src/server.vala"
						_tmp25_ = g_uri_unescape_string (_tmp24_, NULL);
#line 621 "../src/server.vala"
						_tmp26_ = _tmp25_;
#line 621 "../src/server.vala"
						_tmp27_ = e;
#line 621 "../src/server.vala"
						_tmp28_ = _tmp27_->message;
#line 621 "../src/server.vala"
						g_warning ("server.vala:621: [textDocument/didClose] failed to close %s - %s", _tmp26_, _tmp28_);
#line 621 "../src/server.vala"
						_g_free0 (_tmp26_);
#line 6005 "server.c"
					}
#line 612 "../src/server.vala"
					_g_error_free0 (e);
#line 6009 "server.c"
				}
				__finally0:
#line 612 "../src/server.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 612 "../src/server.vala"
					_g_object_unref0 (project);
#line 612 "../src/server.vala"
					all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 612 "../src/server.vala"
					_g_free0 (uri);
#line 612 "../src/server.vala"
					_g_variant_unref0 (document);
#line 612 "../src/server.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 612 "../src/server.vala"
					g_clear_error (&_inner_error0_);
#line 612 "../src/server.vala"
					return;
#line 6028 "server.c"
				}
#line 611 "../src/server.vala"
				_g_object_unref0 (project);
#line 6032 "server.c"
			}
		}
	}
#line 599 "../src/server.vala"
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 599 "../src/server.vala"
	_g_free0 (uri);
#line 599 "../src/server.vala"
	_g_variant_unref0 (document);
#line 6042 "server.c"
}

static gchar*
_variant_get8 (GVariant* value)
{
#line 634 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 6050 "server.c"
}

static gint64
_variant_get9 (GVariant* value)
{
#line 635 "../src/server.vala"
	return g_variant_get_int64 (value);
#line 6058 "server.c"
}

static VlsProject**
_vala_array_dup15 (VlsProject** self,
                   gssize length)
{
#line 637 "../src/server.vala"
	if (length >= 0) {
#line 6067 "server.c"
		VlsProject** result;
		gssize i;
#line 637 "../src/server.vala"
		result = g_new0 (VlsProject*, length + 1);
#line 637 "../src/server.vala"
		for (i = 0; i < length; i++) {
#line 6074 "server.c"
			VlsProject* _tmp0_;
#line 637 "../src/server.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 637 "../src/server.vala"
			result[i] = _tmp0_;
#line 6080 "server.c"
		}
#line 637 "../src/server.vala"
		return result;
#line 6084 "server.c"
	}
#line 637 "../src/server.vala"
	return NULL;
#line 6088 "server.c"
}

static void
_vala_array_add27 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
#line 638 "../src/server.vala"
	if ((*length) == (*size)) {
#line 638 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 638 "../src/server.vala"
		*array = g_renew (VlsProject*, *array, (*size) + 1);
#line 6103 "server.c"
	}
#line 638 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 638 "../src/server.vala"
	(*array)[*length] = NULL;
#line 6109 "server.c"
}

static void
vls_server_text_document_did_change (VlsServer* self,
                                     JsonrpcClient* client,
                                     GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	GVariant* changes = NULL;
	const GVariantType* _tmp2_;
	GVariant* _tmp3_;
	gchar* uri = NULL;
	GVariant* _tmp4_;
	const GVariantType* _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint64 version = 0LL;
	GVariant* _tmp10_;
	const GVariantType* _tmp11_;
	GVariant* _tmp12_;
	GVariant* _tmp13_;
	gint64 _tmp14_;
	gint64 _tmp15_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp16_;
	guint _tmp17_ = 0;
	gconstpointer* _tmp18_;
	VlsProject** _tmp19_;
	gint _tmp19__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp20_;
	VlsProject* _tmp21_;
	VlsProject** _tmp22_;
	gint _tmp22__length1;
#line 630 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 630 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 630 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 631 "../src/server.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 631 "../src/server.vala"
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
#line 631 "../src/server.vala"
	document = _tmp1_;
#line 632 "../src/server.vala"
	_tmp2_ = G_VARIANT_TYPE_ARRAY;
#line 632 "../src/server.vala"
	_tmp3_ = g_variant_lookup_value (params, "contentChanges", _tmp2_);
#line 632 "../src/server.vala"
	changes = _tmp3_;
#line 634 "../src/server.vala"
	_tmp4_ = document;
#line 634 "../src/server.vala"
	_tmp5_ = G_VARIANT_TYPE_STRING;
#line 634 "../src/server.vala"
	_tmp6_ = g_variant_lookup_value (_tmp4_, "uri", _tmp5_);
#line 634 "../src/server.vala"
	_tmp7_ = _tmp6_;
#line 634 "../src/server.vala"
	_tmp8_ = _variant_get8 (_tmp7_);
#line 634 "../src/server.vala"
	_tmp9_ = _tmp8_;
#line 634 "../src/server.vala"
	_g_variant_unref0 (_tmp7_);
#line 634 "../src/server.vala"
	uri = _tmp9_;
#line 635 "../src/server.vala"
	_tmp10_ = document;
#line 635 "../src/server.vala"
	_tmp11_ = G_VARIANT_TYPE_INT64;
#line 635 "../src/server.vala"
	_tmp12_ = g_variant_lookup_value (_tmp10_, "version", _tmp11_);
#line 635 "../src/server.vala"
	_tmp13_ = _tmp12_;
#line 635 "../src/server.vala"
	_tmp14_ = _variant_get9 (_tmp13_);
#line 635 "../src/server.vala"
	_tmp15_ = _tmp14_;
#line 635 "../src/server.vala"
	_g_variant_unref0 (_tmp13_);
#line 635 "../src/server.vala"
	version = _tmp15_;
#line 637 "../src/server.vala"
	_tmp16_ = self->priv->projects;
#line 637 "../src/server.vala"
	_tmp18_ = g_hash_table_get_keys_as_array (_tmp16_, &_tmp17_);
#line 637 "../src/server.vala"
	_tmp19_ = (_tmp18_ != NULL) ? _vala_array_dup15 (_tmp18_, _tmp17_) : _tmp18_;
#line 637 "../src/server.vala"
	_tmp19__length1 = _tmp17_;
#line 637 "../src/server.vala"
	_tmp18_ = (g_free (_tmp18_), NULL);
#line 637 "../src/server.vala"
	all_projects = _tmp19_;
#line 637 "../src/server.vala"
	all_projects_length1 = _tmp19__length1;
#line 637 "../src/server.vala"
	_all_projects_size_ = all_projects_length1;
#line 638 "../src/server.vala"
	_tmp20_ = self->priv->default_project;
#line 638 "../src/server.vala"
	_tmp21_ = _g_object_ref0 ((VlsProject*) _tmp20_);
#line 638 "../src/server.vala"
	_vala_array_add27 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp21_);
#line 640 "../src/server.vala"
	_tmp22_ = all_projects;
#line 640 "../src/server.vala"
	_tmp22__length1 = all_projects_length1;
#line 6225 "server.c"
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
#line 640 "../src/server.vala"
		project_collection = _tmp22_;
#line 640 "../src/server.vala"
		project_collection_length1 = _tmp22__length1;
#line 640 "../src/server.vala"
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
#line 6237 "server.c"
			VlsProject* _tmp23_;
			VlsProject* project = NULL;
#line 640 "../src/server.vala"
			_tmp23_ = _g_object_ref0 (project_collection[project_it]);
#line 640 "../src/server.vala"
			project = _tmp23_;
#line 6244 "server.c"
			{
				{
					GeeArrayList* _pair_list = NULL;
					VlsProject* _tmp24_;
					const gchar* _tmp25_;
					GeeArrayList* _tmp26_;
					gint _pair_size = 0;
					GeeArrayList* _tmp27_;
					gint _tmp28_;
					gint _tmp29_;
					gint _pair_index = 0;
#line 641 "../src/server.vala"
					_tmp24_ = project;
#line 641 "../src/server.vala"
					_tmp25_ = uri;
#line 641 "../src/server.vala"
					_tmp26_ = vls_project_lookup_compile_input_source_file (_tmp24_, _tmp25_);
#line 641 "../src/server.vala"
					_pair_list = _tmp26_;
#line 641 "../src/server.vala"
					_tmp27_ = _pair_list;
#line 641 "../src/server.vala"
					_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
#line 641 "../src/server.vala"
					_tmp29_ = _tmp28_;
#line 641 "../src/server.vala"
					_pair_size = _tmp29_;
#line 641 "../src/server.vala"
					_pair_index = -1;
#line 641 "../src/server.vala"
					while (TRUE) {
#line 6276 "server.c"
						gint _tmp30_;
						gint _tmp31_;
						VlsPair* pair = NULL;
						GeeArrayList* _tmp32_;
						gpointer _tmp33_;
						ValaSourceFile* source_file = NULL;
						VlsPair* _tmp34_;
						gconstpointer _tmp35_;
						gconstpointer _tmp36_;
						ValaSourceFile* _tmp37_;
						ValaSourceFile* _tmp38_;
						VlsTextDocument* source = NULL;
						ValaSourceFile* _tmp39_;
						VlsTextDocument* _tmp40_;
						VlsTextDocument* _tmp41_;
						gint _tmp42_;
						gint _tmp43_;
						ValaSourceFile* _tmp50_;
						const gchar* _tmp51_;
						const gchar* _tmp52_;
						GVariantIter* iter = NULL;
						GVariant* _tmp53_;
						GVariantIter* _tmp54_;
						GVariant* elem = NULL;
						GString* sb = NULL;
						VlsTextDocument* _tmp55_;
						const gchar* _tmp56_;
						const gchar* _tmp57_;
						GString* _tmp58_;
						VlsTextDocument* _tmp104_;
						GString* _tmp105_;
						const gchar* _tmp106_;
						VlsTextDocument* _tmp107_;
						GTimeZone* _tmp108_;
						GTimeZone* _tmp109_;
						GDateTime* _tmp110_;
						GDateTime* _tmp111_;
						VlsTextDocument* _tmp112_;
#line 641 "../src/server.vala"
						_pair_index = _pair_index + 1;
#line 641 "../src/server.vala"
						_tmp30_ = _pair_index;
#line 641 "../src/server.vala"
						_tmp31_ = _pair_size;
#line 641 "../src/server.vala"
						if (!(_tmp30_ < _tmp31_)) {
#line 641 "../src/server.vala"
							break;
#line 6325 "server.c"
						}
#line 641 "../src/server.vala"
						_tmp32_ = _pair_list;
#line 641 "../src/server.vala"
						_tmp33_ = gee_abstract_list_get ((GeeAbstractList*) _tmp32_, _pair_index);
#line 641 "../src/server.vala"
						pair = (VlsPair*) _tmp33_;
#line 642 "../src/server.vala"
						_tmp34_ = pair;
#line 642 "../src/server.vala"
						_tmp35_ = vls_pair_get_first (_tmp34_);
#line 642 "../src/server.vala"
						_tmp36_ = _tmp35_;
#line 642 "../src/server.vala"
						_tmp37_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp36_);
#line 642 "../src/server.vala"
						source_file = _tmp37_;
#line 644 "../src/server.vala"
						_tmp38_ = source_file;
#line 644 "../src/server.vala"
						if (!VLS_IS_TEXT_DOCUMENT (_tmp38_)) {
#line 645 "../src/server.vala"
							g_warning ("server.vala:645: %s", "[textDocument/didChange] Ignoring change to system file");
#line 646 "../src/server.vala"
							_vala_source_file_unref0 (source_file);
#line 646 "../src/server.vala"
							_g_object_unref0 (pair);
#line 646 "../src/server.vala"
							_g_object_unref0 (_pair_list);
#line 646 "../src/server.vala"
							_g_object_unref0 (project);
#line 646 "../src/server.vala"
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 646 "../src/server.vala"
							_g_free0 (uri);
#line 646 "../src/server.vala"
							_g_variant_unref0 (changes);
#line 646 "../src/server.vala"
							_g_variant_unref0 (document);
#line 646 "../src/server.vala"
							return;
#line 6367 "server.c"
						}
#line 649 "../src/server.vala"
						_tmp39_ = source_file;
#line 649 "../src/server.vala"
						_tmp40_ = _vala_source_file_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument));
#line 649 "../src/server.vala"
						source = _tmp40_;
#line 650 "../src/server.vala"
						_tmp41_ = source;
#line 650 "../src/server.vala"
						_tmp42_ = vls_text_document_get_version (_tmp41_);
#line 650 "../src/server.vala"
						_tmp43_ = _tmp42_;
#line 650 "../src/server.vala"
						if (((gint64) _tmp43_) >= version) {
#line 6383 "server.c"
							const gchar* _tmp44_;
							gchar* _tmp45_;
							gchar* _tmp46_;
							const gchar* _tmp47_;
							gchar* _tmp48_;
							gchar* _tmp49_;
#line 651 "../src/server.vala"
							_tmp44_ = uri;
#line 651 "../src/server.vala"
							_tmp45_ = g_uri_unescape_string (_tmp44_, NULL);
#line 651 "../src/server.vala"
							_tmp46_ = _tmp45_;
#line 651 "../src/server.vala"
							_tmp47_ = string_to_string (_tmp46_);
#line 651 "../src/server.vala"
							_tmp48_ = g_strconcat ("[textDocument/didChange] rejecting outdated version of ", _tmp47_, NULL);
#line 651 "../src/server.vala"
							_tmp49_ = _tmp48_;
#line 651 "../src/server.vala"
							g_warning ("server.vala:651: %s", _tmp49_);
#line 651 "../src/server.vala"
							_g_free0 (_tmp49_);
#line 651 "../src/server.vala"
							_g_free0 (_tmp46_);
#line 652 "../src/server.vala"
							_vala_source_file_unref0 (source);
#line 652 "../src/server.vala"
							_vala_source_file_unref0 (source_file);
#line 652 "../src/server.vala"
							_g_object_unref0 (pair);
#line 652 "../src/server.vala"
							_g_object_unref0 (_pair_list);
#line 652 "../src/server.vala"
							_g_object_unref0 (project);
#line 652 "../src/server.vala"
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 652 "../src/server.vala"
							_g_free0 (uri);
#line 652 "../src/server.vala"
							_g_variant_unref0 (changes);
#line 652 "../src/server.vala"
							_g_variant_unref0 (document);
#line 652 "../src/server.vala"
							return;
#line 6428 "server.c"
						}
#line 655 "../src/server.vala"
						_tmp50_ = source_file;
#line 655 "../src/server.vala"
						_tmp51_ = vala_source_file_get_content (_tmp50_);
#line 655 "../src/server.vala"
						_tmp52_ = _tmp51_;
#line 655 "../src/server.vala"
						if (_tmp52_ == NULL) {
#line 656 "../src/server.vala"
							g_error ("server.vala:656: %s", "[textDocument/didChange] source content is null!");
#line 6440 "server.c"
						}
#line 660 "../src/server.vala"
						_tmp53_ = changes;
#line 660 "../src/server.vala"
						_tmp54_ = g_variant_iter_new (_tmp53_);
#line 660 "../src/server.vala"
						iter = _tmp54_;
#line 661 "../src/server.vala"
						elem = NULL;
#line 662 "../src/server.vala"
						_tmp55_ = source;
#line 662 "../src/server.vala"
						_tmp56_ = vala_source_file_get_content ((ValaSourceFile*) _tmp55_);
#line 662 "../src/server.vala"
						_tmp57_ = _tmp56_;
#line 662 "../src/server.vala"
						_tmp58_ = g_string_new (_tmp57_);
#line 662 "../src/server.vala"
						sb = _tmp58_;
#line 663 "../src/server.vala"
						while (TRUE) {
#line 6462 "server.c"
							GVariantIter* _tmp59_;
							GVariant* _tmp60_;
							GVariant* _tmp61_;
							LspTextDocumentContentChangeEvent* changeEvent = NULL;
							GVariant* _tmp62_;
							gpointer _tmp63_;
							LspTextDocumentContentChangeEvent* _tmp64_;
							LspRange* _tmp65_;
							LspRange* _tmp66_;
#line 663 "../src/server.vala"
							_tmp59_ = iter;
#line 663 "../src/server.vala"
							_tmp60_ = g_variant_iter_next_value (_tmp59_);
#line 663 "../src/server.vala"
							_g_variant_unref0 (elem);
#line 663 "../src/server.vala"
							elem = _tmp60_;
#line 663 "../src/server.vala"
							_tmp61_ = elem;
#line 663 "../src/server.vala"
							if (!(_tmp61_ != NULL)) {
#line 663 "../src/server.vala"
								break;
#line 6486 "server.c"
							}
#line 664 "../src/server.vala"
							_tmp62_ = elem;
#line 664 "../src/server.vala"
							_tmp63_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_CONTENT_CHANGE_EVENT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp62_);
#line 664 "../src/server.vala"
							changeEvent = (LspTextDocumentContentChangeEvent*) _tmp63_;
#line 666 "../src/server.vala"
							_tmp64_ = changeEvent;
#line 666 "../src/server.vala"
							_tmp65_ = lsp_text_document_content_change_event_get_range (_tmp64_);
#line 666 "../src/server.vala"
							_tmp66_ = _tmp65_;
#line 666 "../src/server.vala"
							if (_tmp66_ == NULL) {
#line 6502 "server.c"
								GString* _tmp67_;
								LspTextDocumentContentChangeEvent* _tmp68_;
								const gchar* _tmp69_;
								const gchar* _tmp70_;
#line 667 "../src/server.vala"
								_tmp67_ = sb;
#line 667 "../src/server.vala"
								_tmp68_ = changeEvent;
#line 667 "../src/server.vala"
								_tmp69_ = lsp_text_document_content_change_event_get_text (_tmp68_);
#line 667 "../src/server.vala"
								_tmp70_ = _tmp69_;
#line 667 "../src/server.vala"
								g_string_assign (_tmp67_, _tmp70_);
#line 6517 "server.c"
							} else {
								LspPosition* start = NULL;
								LspTextDocumentContentChangeEvent* _tmp71_;
								LspRange* _tmp72_;
								LspRange* _tmp73_;
								LspPosition* _tmp74_;
								LspPosition* _tmp75_;
								LspPosition* _tmp76_;
								LspPosition* end = NULL;
								LspTextDocumentContentChangeEvent* _tmp77_;
								LspRange* _tmp78_;
								LspRange* _tmp79_;
								LspPosition* _tmp80_;
								LspPosition* _tmp81_;
								LspPosition* _tmp82_;
								gsize pos_begin = 0UL;
								GString* _tmp83_;
								const gchar* _tmp84_;
								LspPosition* _tmp85_;
								guint _tmp86_;
								guint _tmp87_;
								LspPosition* _tmp88_;
								guint _tmp89_;
								guint _tmp90_;
								gsize pos_end = 0UL;
								GString* _tmp91_;
								const gchar* _tmp92_;
								LspPosition* _tmp93_;
								guint _tmp94_;
								guint _tmp95_;
								LspPosition* _tmp96_;
								guint _tmp97_;
								guint _tmp98_;
								GString* _tmp99_;
								GString* _tmp100_;
								LspTextDocumentContentChangeEvent* _tmp101_;
								const gchar* _tmp102_;
								const gchar* _tmp103_;
#line 669 "../src/server.vala"
								_tmp71_ = changeEvent;
#line 669 "../src/server.vala"
								_tmp72_ = lsp_text_document_content_change_event_get_range (_tmp71_);
#line 669 "../src/server.vala"
								_tmp73_ = _tmp72_;
#line 669 "../src/server.vala"
								_tmp74_ = lsp_range_get_start (_tmp73_);
#line 669 "../src/server.vala"
								_tmp75_ = _tmp74_;
#line 669 "../src/server.vala"
								_tmp76_ = _g_object_ref0 (_tmp75_);
#line 669 "../src/server.vala"
								start = _tmp76_;
#line 670 "../src/server.vala"
								_tmp77_ = changeEvent;
#line 670 "../src/server.vala"
								_tmp78_ = lsp_text_document_content_change_event_get_range (_tmp77_);
#line 670 "../src/server.vala"
								_tmp79_ = _tmp78_;
#line 670 "../src/server.vala"
								_tmp80_ = lsp_range_get_end (_tmp79_);
#line 670 "../src/server.vala"
								_tmp81_ = _tmp80_;
#line 670 "../src/server.vala"
								_tmp82_ = _g_object_ref0 (_tmp81_);
#line 670 "../src/server.vala"
								end = _tmp82_;
#line 671 "../src/server.vala"
								_tmp83_ = sb;
#line 671 "../src/server.vala"
								_tmp84_ = _tmp83_->str;
#line 671 "../src/server.vala"
								_tmp85_ = start;
#line 671 "../src/server.vala"
								_tmp86_ = lsp_position_get_line (_tmp85_);
#line 671 "../src/server.vala"
								_tmp87_ = _tmp86_;
#line 671 "../src/server.vala"
								_tmp88_ = start;
#line 671 "../src/server.vala"
								_tmp89_ = lsp_position_get_character (_tmp88_);
#line 671 "../src/server.vala"
								_tmp90_ = _tmp89_;
#line 671 "../src/server.vala"
								pos_begin = vls_util_get_string_pos (_tmp84_, _tmp87_, _tmp90_);
#line 672 "../src/server.vala"
								_tmp91_ = sb;
#line 672 "../src/server.vala"
								_tmp92_ = _tmp91_->str;
#line 672 "../src/server.vala"
								_tmp93_ = end;
#line 672 "../src/server.vala"
								_tmp94_ = lsp_position_get_line (_tmp93_);
#line 672 "../src/server.vala"
								_tmp95_ = _tmp94_;
#line 672 "../src/server.vala"
								_tmp96_ = end;
#line 672 "../src/server.vala"
								_tmp97_ = lsp_position_get_character (_tmp96_);
#line 672 "../src/server.vala"
								_tmp98_ = _tmp97_;
#line 672 "../src/server.vala"
								pos_end = vls_util_get_string_pos (_tmp92_, _tmp95_, _tmp98_);
#line 673 "../src/server.vala"
								_tmp99_ = sb;
#line 673 "../src/server.vala"
								g_string_erase (_tmp99_, (gssize) pos_begin, (gssize) (pos_end - pos_begin));
#line 674 "../src/server.vala"
								_tmp100_ = sb;
#line 674 "../src/server.vala"
								_tmp101_ = changeEvent;
#line 674 "../src/server.vala"
								_tmp102_ = lsp_text_document_content_change_event_get_text (_tmp101_);
#line 674 "../src/server.vala"
								_tmp103_ = _tmp102_;
#line 674 "../src/server.vala"
								g_string_insert (_tmp100_, (gssize) pos_begin, _tmp103_);
#line 666 "../src/server.vala"
								_g_object_unref0 (end);
#line 666 "../src/server.vala"
								_g_object_unref0 (start);
#line 6638 "server.c"
							}
#line 663 "../src/server.vala"
							_g_object_unref0 (changeEvent);
#line 6642 "server.c"
						}
#line 677 "../src/server.vala"
						_tmp104_ = source;
#line 677 "../src/server.vala"
						_tmp105_ = sb;
#line 677 "../src/server.vala"
						_tmp106_ = _tmp105_->str;
#line 677 "../src/server.vala"
						vala_source_file_set_content ((ValaSourceFile*) _tmp104_, _tmp106_);
#line 678 "../src/server.vala"
						_tmp107_ = source;
#line 678 "../src/server.vala"
						_tmp108_ = g_time_zone_new_local ();
#line 678 "../src/server.vala"
						_tmp109_ = _tmp108_;
#line 678 "../src/server.vala"
						_tmp110_ = g_date_time_new_now (_tmp109_);
#line 678 "../src/server.vala"
						_tmp111_ = _tmp110_;
#line 678 "../src/server.vala"
						vls_text_document_set_last_updated (_tmp107_, _tmp111_);
#line 678 "../src/server.vala"
						_g_date_time_unref0 (_tmp111_);
#line 678 "../src/server.vala"
						_g_time_zone_unref0 (_tmp109_);
#line 679 "../src/server.vala"
						_tmp112_ = source;
#line 679 "../src/server.vala"
						vls_text_document_set_version (_tmp112_, (gint) version);
#line 681 "../src/server.vala"
						vls_server_request_context_update (self, client);
#line 641 "../src/server.vala"
						_g_string_free0 (sb);
#line 641 "../src/server.vala"
						_g_variant_unref0 (elem);
#line 641 "../src/server.vala"
						_g_variant_iter_free0 (iter);
#line 641 "../src/server.vala"
						_vala_source_file_unref0 (source);
#line 641 "../src/server.vala"
						_vala_source_file_unref0 (source_file);
#line 641 "../src/server.vala"
						_g_object_unref0 (pair);
#line 6686 "server.c"
					}
#line 641 "../src/server.vala"
					_g_object_unref0 (_pair_list);
#line 6690 "server.c"
				}
#line 640 "../src/server.vala"
				_g_object_unref0 (project);
#line 6694 "server.c"
			}
		}
	}
#line 630 "../src/server.vala"
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 630 "../src/server.vala"
	_g_free0 (uri);
#line 630 "../src/server.vala"
	_g_variant_unref0 (changes);
#line 630 "../src/server.vala"
	_g_variant_unref0 (document);
#line 6706 "server.c"
}

/** 
     * Indicate to the server that the code context(s) it is tracking may
     * need to be refreshed.
     * 
     * @param client        the client to eventually send a `publishDiagnostics` 
     *                      notification to, if the context is refreshed
     */
static void
vls_server_request_context_update (VlsServer* self,
                                   JsonrpcClient* client)
{
	JsonrpcClient* _tmp0_;
	gint64 delay_us = 0LL;
#line 693 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 693 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 694 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 694 "../src/server.vala"
	_g_object_unref0 (self->priv->update_context_client);
#line 694 "../src/server.vala"
	self->priv->update_context_client = _tmp0_;
#line 695 "../src/server.vala"
	self->priv->update_context_requests = self->priv->update_context_requests + 1;
#line 696 "../src/server.vala"
	delay_us = MIN (VLS_SERVER_update_context_delay_inc_us * self->priv->update_context_requests, VLS_SERVER_update_context_delay_max_us);
#line 697 "../src/server.vala"
	self->priv->update_context_time_us = g_get_monotonic_time () + delay_us;
#line 6738 "server.c"
}

/** 
     * Reconfigure the project if needed, and check whether we need to rebuild
     * the project and documentation engine if we have context update requests.
     */
static VlsProject**
_vala_array_dup16 (VlsProject** self,
                   gssize length)
{
#line 711 "../src/server.vala"
	if (length >= 0) {
#line 6751 "server.c"
		VlsProject** result;
		gssize i;
#line 711 "../src/server.vala"
		result = g_new0 (VlsProject*, length + 1);
#line 711 "../src/server.vala"
		for (i = 0; i < length; i++) {
#line 6758 "server.c"
			VlsProject* _tmp0_;
#line 711 "../src/server.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 711 "../src/server.vala"
			result[i] = _tmp0_;
#line 6764 "server.c"
		}
#line 711 "../src/server.vala"
		return result;
#line 6768 "server.c"
	}
#line 711 "../src/server.vala"
	return NULL;
#line 6772 "server.c"
}

static void
_vala_array_add28 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
#line 712 "../src/server.vala"
	if ((*length) == (*size)) {
#line 712 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 712 "../src/server.vala"
		*array = g_renew (VlsProject*, *array, (*size) + 1);
#line 6787 "server.c"
	}
#line 712 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 712 "../src/server.vala"
	(*array)[*length] = NULL;
#line 6793 "server.c"
}

static gchar*
_________lambda49_ (VlsServer* self,
                    ValaSourceFile* f)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* result;
#line 724 "../src/server.vala"
	g_return_val_if_fail (f != NULL, NULL);
#line 724 "../src/server.vala"
	_tmp0_ = vala_source_file_get_filename (f);
#line 724 "../src/server.vala"
	_tmp1_ = _tmp0_;
#line 724 "../src/server.vala"
	_tmp2_ = g_strdup (_tmp1_);
#line 724 "../src/server.vala"
	result = _tmp2_;
#line 724 "../src/server.vala"
	_vala_source_file_unref0 (f);
#line 724 "../src/server.vala"
	return result;
#line 6818 "server.c"
}

static gpointer
__________lambda49__gee_map_func (gpointer g,
                                  gpointer self)
{
	gpointer result;
	result = _________lambda49_ ((VlsServer*) self, (ValaSourceFile*) g);
#line 724 "../src/server.vala"
	return result;
#line 6829 "server.c"
}

static gboolean
vls_server_check_update_context (VlsServer* self)
{
	gboolean _tmp0_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 705 "../src/server.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 706 "../src/server.vala"
	if (self->priv->update_context_requests > ((gint64) 0)) {
#line 706 "../src/server.vala"
		_tmp0_ = g_get_monotonic_time () >= self->priv->update_context_time_us;
#line 6844 "server.c"
	} else {
#line 706 "../src/server.vala"
		_tmp0_ = FALSE;
#line 6848 "server.c"
	}
#line 706 "../src/server.vala"
	if (_tmp0_) {
#line 6852 "server.c"
		VlsProject** all_projects = NULL;
		GHashTable* _tmp1_;
		guint _tmp2_ = 0;
		gconstpointer* _tmp3_;
		VlsProject** _tmp4_;
		gint _tmp4__length1;
		gint all_projects_length1;
		gint _all_projects_size_;
		VlsDefaultProject* _tmp5_;
		VlsProject* _tmp6_;
		gboolean reconfigured_projects = FALSE;
		VlsProject** _tmp7_;
		gint _tmp7__length1;
		VlsGirDocumentation* _tmp168_;
#line 707 "../src/server.vala"
		g_debug ("server.vala:707: updating contexts and publishing diagnostics...");
#line 708 "../src/server.vala"
		self->priv->update_context_requests = (gint64) 0;
#line 709 "../src/server.vala"
		self->priv->update_context_time_us = (gint64) 0;
#line 711 "../src/server.vala"
		_tmp1_ = self->priv->projects;
#line 711 "../src/server.vala"
		_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
#line 711 "../src/server.vala"
		_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup16 (_tmp3_, _tmp2_) : _tmp3_;
#line 711 "../src/server.vala"
		_tmp4__length1 = _tmp2_;
#line 711 "../src/server.vala"
		_tmp3_ = (g_free (_tmp3_), NULL);
#line 711 "../src/server.vala"
		all_projects = _tmp4_;
#line 711 "../src/server.vala"
		all_projects_length1 = _tmp4__length1;
#line 711 "../src/server.vala"
		_all_projects_size_ = all_projects_length1;
#line 712 "../src/server.vala"
		_tmp5_ = self->priv->default_project;
#line 712 "../src/server.vala"
		_tmp6_ = _g_object_ref0 ((VlsProject*) _tmp5_);
#line 712 "../src/server.vala"
		_vala_array_add28 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp6_);
#line 713 "../src/server.vala"
		reconfigured_projects = FALSE;
#line 714 "../src/server.vala"
		_tmp7_ = all_projects;
#line 714 "../src/server.vala"
		_tmp7__length1 = all_projects_length1;
#line 6901 "server.c"
		{
			VlsProject** project_collection = NULL;
			gint project_collection_length1 = 0;
			gint _project_collection_size_ = 0;
			gint project_it = 0;
#line 714 "../src/server.vala"
			project_collection = _tmp7_;
#line 714 "../src/server.vala"
			project_collection_length1 = _tmp7__length1;
#line 714 "../src/server.vala"
			for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
#line 6913 "server.c"
				VlsProject* _tmp8_;
				VlsProject* project = NULL;
#line 714 "../src/server.vala"
				_tmp8_ = _g_object_ref0 (project_collection[project_it]);
#line 714 "../src/server.vala"
				project = _tmp8_;
#line 6920 "server.c"
				{
					{
						gboolean reconfigured = FALSE;
						VlsProject* _tmp9_;
						GCancellable* _tmp10_;
						VlsProject* _tmp11_;
						GCancellable* _tmp12_;
						gboolean _tmp13_ = FALSE;
#line 716 "../src/server.vala"
						_tmp9_ = project;
#line 716 "../src/server.vala"
						_tmp10_ = vls_server_cancellable;
#line 716 "../src/server.vala"
						reconfigured = vls_project_reconfigure_if_stale (_tmp9_, _tmp10_, &_inner_error0_);
#line 716 "../src/server.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6937 "server.c"
							goto __catch0_g_error;
						}
#line 717 "../src/server.vala"
						reconfigured_projects |= reconfigured;
#line 718 "../src/server.vala"
						_tmp11_ = project;
#line 718 "../src/server.vala"
						_tmp12_ = vls_server_cancellable;
#line 718 "../src/server.vala"
						vls_project_build_if_stale (_tmp11_, _tmp12_, &_inner_error0_);
#line 718 "../src/server.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 6950 "server.c"
							goto __catch0_g_error;
						}
#line 721 "../src/server.vala"
						if (reconfigured) {
#line 6955 "server.c"
							VlsProject* _tmp14_;
							VlsDefaultProject* _tmp15_;
#line 721 "../src/server.vala"
							_tmp14_ = project;
#line 721 "../src/server.vala"
							_tmp15_ = self->priv->default_project;
#line 721 "../src/server.vala"
							_tmp13_ = _tmp14_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, VLS_TYPE_PROJECT, VlsProject);
#line 6964 "server.c"
						} else {
#line 721 "../src/server.vala"
							_tmp13_ = FALSE;
#line 6968 "server.c"
						}
#line 721 "../src/server.vala"
						if (_tmp13_) {
#line 6972 "server.c"
							GeeHashSet* newly_added = NULL;
							GeeHashSet* _tmp16_;
#line 722 "../src/server.vala"
							_tmp16_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 722 "../src/server.vala"
							if (_tmp16_) {
#line 722 "../src/server.vala"
								g_object_set_data ((GObject *) _tmp16_, "vala-creation-function", "Vls.Server.check_update_context");
#line 6981 "server.c"
							}
#line 722 "../src/server.vala"
							newly_added = _tmp16_;
#line 6985 "server.c"
							{
								GeeArrayList* _compilation_list = NULL;
								VlsProject* _tmp17_;
								GeeArrayList* _tmp18_;
								gint _compilation_size = 0;
								GeeArrayList* _tmp19_;
								gint _tmp20_;
								gint _tmp21_;
								gint _compilation_index = 0;
#line 723 "../src/server.vala"
								_tmp17_ = project;
#line 723 "../src/server.vala"
								_tmp18_ = vls_project_get_compilations (_tmp17_);
#line 723 "../src/server.vala"
								_compilation_list = _tmp18_;
#line 723 "../src/server.vala"
								_tmp19_ = _compilation_list;
#line 723 "../src/server.vala"
								_tmp20_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp19_);
#line 723 "../src/server.vala"
								_tmp21_ = _tmp20_;
#line 723 "../src/server.vala"
								_compilation_size = _tmp21_;
#line 723 "../src/server.vala"
								_compilation_index = -1;
#line 723 "../src/server.vala"
								while (TRUE) {
#line 7013 "server.c"
									gint _tmp22_;
									gint _tmp23_;
									VlsCompilation* compilation = NULL;
									GeeArrayList* _tmp24_;
									gpointer _tmp25_;
									GeeHashSet* _tmp26_;
									VlsCompilation* _tmp27_;
									GeeCollection* _tmp28_;
									GeeCollection* _tmp29_;
									GeeIterator* _tmp30_;
									GeeIterator* _tmp31_;
#line 723 "../src/server.vala"
									_compilation_index = _compilation_index + 1;
#line 723 "../src/server.vala"
									_tmp22_ = _compilation_index;
#line 723 "../src/server.vala"
									_tmp23_ = _compilation_size;
#line 723 "../src/server.vala"
									if (!(_tmp22_ < _tmp23_)) {
#line 723 "../src/server.vala"
										break;
#line 7035 "server.c"
									}
#line 723 "../src/server.vala"
									_tmp24_ = _compilation_list;
#line 723 "../src/server.vala"
									_tmp25_ = gee_abstract_list_get ((GeeAbstractList*) _tmp24_, _compilation_index);
#line 723 "../src/server.vala"
									compilation = (VlsCompilation*) _tmp25_;
#line 724 "../src/server.vala"
									_tmp26_ = newly_added;
#line 724 "../src/server.vala"
									_tmp27_ = compilation;
#line 724 "../src/server.vala"
									_tmp28_ = vls_compilation_get_project_files (_tmp27_);
#line 724 "../src/server.vala"
									_tmp29_ = _tmp28_;
#line 724 "../src/server.vala"
									_tmp30_ = gee_traversable_map ((GeeTraversable*) _tmp29_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, __________lambda49__gee_map_func, self);
#line 724 "../src/server.vala"
									_tmp31_ = _tmp30_;
#line 724 "../src/server.vala"
									gee_collection_add_all_iterator ((GeeCollection*) _tmp26_, _tmp31_);
#line 724 "../src/server.vala"
									_g_object_unref0 (_tmp31_);
#line 724 "../src/server.vala"
									_g_object_unref0 (_tmp29_);
#line 723 "../src/server.vala"
									_g_object_unref0 (compilation);
#line 7063 "server.c"
								}
#line 723 "../src/server.vala"
								_g_object_unref0 (_compilation_list);
#line 7067 "server.c"
							}
							{
								GeeArrayList* _compilation_list = NULL;
								VlsDefaultProject* _tmp32_;
								GeeArrayList* _tmp33_;
								gint _compilation_size = 0;
								GeeArrayList* _tmp34_;
								gint _tmp35_;
								gint _tmp36_;
								gint _compilation_index = 0;
#line 725 "../src/server.vala"
								_tmp32_ = self->priv->default_project;
#line 725 "../src/server.vala"
								_tmp33_ = vls_project_get_compilations ((VlsProject*) _tmp32_);
#line 725 "../src/server.vala"
								_compilation_list = _tmp33_;
#line 725 "../src/server.vala"
								_tmp34_ = _compilation_list;
#line 725 "../src/server.vala"
								_tmp35_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp34_);
#line 725 "../src/server.vala"
								_tmp36_ = _tmp35_;
#line 725 "../src/server.vala"
								_compilation_size = _tmp36_;
#line 725 "../src/server.vala"
								_compilation_index = -1;
#line 725 "../src/server.vala"
								while (TRUE) {
#line 7096 "server.c"
									gint _tmp37_;
									gint _tmp38_;
									VlsCompilation* compilation = NULL;
									GeeArrayList* _tmp39_;
									gpointer _tmp40_;
#line 725 "../src/server.vala"
									_compilation_index = _compilation_index + 1;
#line 725 "../src/server.vala"
									_tmp37_ = _compilation_index;
#line 725 "../src/server.vala"
									_tmp38_ = _compilation_size;
#line 725 "../src/server.vala"
									if (!(_tmp37_ < _tmp38_)) {
#line 725 "../src/server.vala"
										break;
#line 7112 "server.c"
									}
#line 725 "../src/server.vala"
									_tmp39_ = _compilation_list;
#line 725 "../src/server.vala"
									_tmp40_ = gee_abstract_list_get ((GeeAbstractList*) _tmp39_, _compilation_index);
#line 725 "../src/server.vala"
									compilation = (VlsCompilation*) _tmp40_;
#line 7120 "server.c"
									{
										GeeIterator* _source_file_it = NULL;
										VlsCompilation* _tmp41_;
										GeeCollection* _tmp42_;
										GeeCollection* _tmp43_;
										GeeIterator* _tmp44_;
										GeeIterator* _tmp45_;
#line 726 "../src/server.vala"
										_tmp41_ = compilation;
#line 726 "../src/server.vala"
										_tmp42_ = vls_compilation_get_project_files (_tmp41_);
#line 726 "../src/server.vala"
										_tmp43_ = _tmp42_;
#line 726 "../src/server.vala"
										_tmp44_ = gee_iterable_iterator ((GeeIterable*) _tmp43_);
#line 726 "../src/server.vala"
										_tmp45_ = _tmp44_;
#line 726 "../src/server.vala"
										_g_object_unref0 (_tmp43_);
#line 726 "../src/server.vala"
										_source_file_it = _tmp45_;
#line 726 "../src/server.vala"
										while (TRUE) {
#line 7144 "server.c"
											GeeIterator* _tmp46_;
											ValaSourceFile* source_file = NULL;
											GeeIterator* _tmp47_;
											gpointer _tmp48_;
											GeeHashSet* _tmp49_;
											ValaSourceFile* _tmp50_;
											const gchar* _tmp51_;
											const gchar* _tmp52_;
#line 726 "../src/server.vala"
											_tmp46_ = _source_file_it;
#line 726 "../src/server.vala"
											if (!gee_iterator_next (_tmp46_)) {
#line 726 "../src/server.vala"
												break;
#line 7159 "server.c"
											}
#line 726 "../src/server.vala"
											_tmp47_ = _source_file_it;
#line 726 "../src/server.vala"
											_tmp48_ = gee_iterator_get (_tmp47_);
#line 726 "../src/server.vala"
											source_file = (ValaSourceFile*) _tmp48_;
#line 727 "../src/server.vala"
											_tmp49_ = newly_added;
#line 727 "../src/server.vala"
											_tmp50_ = source_file;
#line 727 "../src/server.vala"
											_tmp51_ = vala_source_file_get_filename (_tmp50_);
#line 727 "../src/server.vala"
											_tmp52_ = _tmp51_;
#line 727 "../src/server.vala"
											if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp49_, _tmp52_)) {
#line 7177 "server.c"
												gchar* uri = NULL;
												ValaSourceFile* _tmp53_;
												const gchar* _tmp54_;
												const gchar* _tmp55_;
												GFile* _tmp56_;
												GFile* _tmp57_;
												gchar* _tmp58_;
												gchar* _tmp59_;
#line 728 "../src/server.vala"
												_tmp53_ = source_file;
#line 728 "../src/server.vala"
												_tmp54_ = vala_source_file_get_filename (_tmp53_);
#line 728 "../src/server.vala"
												_tmp55_ = _tmp54_;
#line 728 "../src/server.vala"
												_tmp56_ = g_file_new_for_path (_tmp55_);
#line 728 "../src/server.vala"
												_tmp57_ = _tmp56_;
#line 728 "../src/server.vala"
												_tmp58_ = g_file_get_uri (_tmp57_);
#line 728 "../src/server.vala"
												_tmp59_ = _tmp58_;
#line 728 "../src/server.vala"
												_g_object_unref0 (_tmp57_);
#line 728 "../src/server.vala"
												uri = _tmp59_;
#line 7204 "server.c"
												{
													VlsDefaultProject* _tmp60_;
													const gchar* _tmp61_;
													GeeHashSet* _tmp62_;
													const gchar* _tmp63_;
													const gchar* _tmp64_;
#line 730 "../src/server.vala"
													_tmp60_ = self->priv->default_project;
#line 730 "../src/server.vala"
													_tmp61_ = uri;
#line 730 "../src/server.vala"
													vls_project_close ((VlsProject*) _tmp60_, _tmp61_, &_inner_error0_);
#line 730 "../src/server.vala"
													if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7219 "server.c"
														goto __catch1_g_error;
													}
#line 731 "../src/server.vala"
													_tmp62_ = self->priv->discarded_files;
#line 731 "../src/server.vala"
													_tmp63_ = uri;
#line 731 "../src/server.vala"
													gee_abstract_collection_add ((GeeAbstractCollection*) _tmp62_, _tmp63_);
#line 732 "../src/server.vala"
													_tmp64_ = uri;
#line 732 "../src/server.vala"
													g_debug ("server.vala:732: discarding %s from DefaultProject", _tmp64_);
#line 7232 "server.c"
												}
												goto __finally1;
												__catch1_g_error:
												{
#line 729 "../src/server.vala"
													g_clear_error (&_inner_error0_);
#line 7239 "server.c"
												}
												__finally1:
#line 729 "../src/server.vala"
												if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 729 "../src/server.vala"
													_g_free0 (uri);
#line 729 "../src/server.vala"
													_vala_source_file_unref0 (source_file);
#line 729 "../src/server.vala"
													_g_object_unref0 (_source_file_it);
#line 729 "../src/server.vala"
													_g_object_unref0 (compilation);
#line 729 "../src/server.vala"
													_g_object_unref0 (_compilation_list);
#line 729 "../src/server.vala"
													_g_object_unref0 (newly_added);
#line 7256 "server.c"
													goto __catch0_g_error;
												}
#line 727 "../src/server.vala"
												_g_free0 (uri);
#line 7261 "server.c"
											}
#line 726 "../src/server.vala"
											_vala_source_file_unref0 (source_file);
#line 7265 "server.c"
										}
#line 726 "../src/server.vala"
										_g_object_unref0 (_source_file_it);
#line 7269 "server.c"
									}
#line 725 "../src/server.vala"
									_g_object_unref0 (compilation);
#line 7273 "server.c"
								}
#line 725 "../src/server.vala"
								_g_object_unref0 (_compilation_list);
#line 7277 "server.c"
							}
#line 721 "../src/server.vala"
							_g_object_unref0 (newly_added);
#line 7281 "server.c"
						}
						{
							GeeArrayList* _compilation_list = NULL;
							VlsProject* _tmp65_;
							GeeArrayList* _tmp66_;
							gint _compilation_size = 0;
							GeeArrayList* _tmp67_;
							gint _tmp68_;
							gint _tmp69_;
							gint _compilation_index = 0;
#line 741 "../src/server.vala"
							_tmp65_ = project;
#line 741 "../src/server.vala"
							_tmp66_ = vls_project_get_compilations (_tmp65_);
#line 741 "../src/server.vala"
							_compilation_list = _tmp66_;
#line 741 "../src/server.vala"
							_tmp67_ = _compilation_list;
#line 741 "../src/server.vala"
							_tmp68_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp67_);
#line 741 "../src/server.vala"
							_tmp69_ = _tmp68_;
#line 741 "../src/server.vala"
							_compilation_size = _tmp69_;
#line 741 "../src/server.vala"
							_compilation_index = -1;
#line 741 "../src/server.vala"
							while (TRUE) {
#line 7310 "server.c"
								gint _tmp70_;
								gint _tmp71_;
								VlsCompilation* compilation = NULL;
								GeeArrayList* _tmp72_;
								gpointer _tmp73_;
								VlsProject* _tmp74_;
								VlsCompilation* _tmp75_;
								JsonrpcClient* _tmp76_;
#line 741 "../src/server.vala"
								_compilation_index = _compilation_index + 1;
#line 741 "../src/server.vala"
								_tmp70_ = _compilation_index;
#line 741 "../src/server.vala"
								_tmp71_ = _compilation_size;
#line 741 "../src/server.vala"
								if (!(_tmp70_ < _tmp71_)) {
#line 741 "../src/server.vala"
									break;
#line 7329 "server.c"
								}
#line 741 "../src/server.vala"
								_tmp72_ = _compilation_list;
#line 741 "../src/server.vala"
								_tmp73_ = gee_abstract_list_get ((GeeAbstractList*) _tmp72_, _compilation_index);
#line 741 "../src/server.vala"
								compilation = (VlsCompilation*) _tmp73_;
#line 747 "../src/server.vala"
								_tmp74_ = project;
#line 747 "../src/server.vala"
								_tmp75_ = compilation;
#line 747 "../src/server.vala"
								_tmp76_ = self->priv->update_context_client;
#line 747 "../src/server.vala"
								vls_server_publish_diagnostics (self, _tmp74_, _tmp75_, _tmp76_);
#line 741 "../src/server.vala"
								_g_object_unref0 (compilation);
#line 7347 "server.c"
							}
#line 741 "../src/server.vala"
							_g_object_unref0 (_compilation_list);
#line 7351 "server.c"
						}
					}
					goto __finally0;
					__catch0_g_error:
					{
						GError* e = NULL;
						GError* _tmp77_;
						const gchar* _tmp78_;
						JsonrpcClient* _tmp79_;
						GError* _tmp80_;
						const gchar* _tmp81_;
						const gchar* _tmp82_;
						gchar* _tmp83_;
						gchar* _tmp84_;
#line 715 "../src/server.vala"
						e = _inner_error0_;
#line 715 "../src/server.vala"
						_inner_error0_ = NULL;
#line 749 "../src/server.vala"
						_tmp77_ = e;
#line 749 "../src/server.vala"
						_tmp78_ = _tmp77_->message;
#line 749 "../src/server.vala"
						g_warning ("server.vala:749: Failed to rebuild and/or reconfigure project: %s", _tmp78_);
#line 750 "../src/server.vala"
						_tmp79_ = self->priv->update_context_client;
#line 750 "../src/server.vala"
						_tmp80_ = e;
#line 750 "../src/server.vala"
						_tmp81_ = _tmp80_->message;
#line 750 "../src/server.vala"
						_tmp82_ = string_to_string (_tmp81_);
#line 750 "../src/server.vala"
						_tmp83_ = g_strconcat ("Failed to rebuild/reconfigure project: ", _tmp82_, NULL);
#line 750 "../src/server.vala"
						_tmp84_ = _tmp83_;
#line 750 "../src/server.vala"
						vls_server_show_message (self, _tmp79_, _tmp84_, LSP_MESSAGE_TYPE_Error);
#line 750 "../src/server.vala"
						_g_free0 (_tmp84_);
#line 715 "../src/server.vala"
						_g_error_free0 (e);
#line 7394 "server.c"
					}
					__finally0:
#line 715 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7399 "server.c"
						gboolean _tmp85_ = FALSE;
#line 715 "../src/server.vala"
						_g_object_unref0 (project);
#line 715 "../src/server.vala"
						all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 715 "../src/server.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 715 "../src/server.vala"
						g_clear_error (&_inner_error0_);
#line 715 "../src/server.vala"
						return _tmp85_;
#line 7411 "server.c"
					}
#line 714 "../src/server.vala"
					_g_object_unref0 (project);
#line 7415 "server.c"
				}
			}
		}
#line 755 "../src/server.vala"
		if (reconfigured_projects) {
#line 7421 "server.c"
			GeeHashSet* orphaned_files = NULL;
			GeeHashSet* _tmp86_;
			GeeHashSet* _tmp87_;
			GeeHashSet* _tmp88_;
			GHashTable* _tmp89_;
			GList* _tmp90_;
#line 756 "../src/server.vala"
			_tmp86_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 756 "../src/server.vala"
			if (_tmp86_) {
#line 756 "../src/server.vala"
				g_object_set_data ((GObject *) _tmp86_, "vala-creation-function", "Vls.Server.check_update_context");
#line 7434 "server.c"
			}
#line 756 "../src/server.vala"
			orphaned_files = _tmp86_;
#line 757 "../src/server.vala"
			_tmp87_ = orphaned_files;
#line 757 "../src/server.vala"
			_tmp88_ = self->priv->open_files;
#line 757 "../src/server.vala"
			gee_collection_add_all ((GeeCollection*) _tmp87_, (GeeCollection*) _tmp88_);
#line 758 "../src/server.vala"
			_tmp89_ = self->priv->projects;
#line 758 "../src/server.vala"
			_tmp90_ = g_hash_table_get_keys (_tmp89_);
#line 7448 "server.c"
			{
				GList* project_collection = NULL;
				GList* project_it = NULL;
#line 758 "../src/server.vala"
				project_collection = _tmp90_;
#line 758 "../src/server.vala"
				for (project_it = project_collection; project_it != NULL; project_it = project_it->next) {
#line 7456 "server.c"
					VlsProject* project = NULL;
#line 758 "../src/server.vala"
					project = (VlsProject*) project_it->data;
#line 7460 "server.c"
					{
						{
							GeeArrayList* _compilation_list = NULL;
							VlsProject* _tmp91_;
							GeeArrayList* _tmp92_;
							gint _compilation_size = 0;
							GeeArrayList* _tmp93_;
							gint _tmp94_;
							gint _tmp95_;
							gint _compilation_index = 0;
#line 759 "../src/server.vala"
							_tmp91_ = project;
#line 759 "../src/server.vala"
							_tmp92_ = vls_project_get_compilations (_tmp91_);
#line 759 "../src/server.vala"
							_compilation_list = _tmp92_;
#line 759 "../src/server.vala"
							_tmp93_ = _compilation_list;
#line 759 "../src/server.vala"
							_tmp94_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp93_);
#line 759 "../src/server.vala"
							_tmp95_ = _tmp94_;
#line 759 "../src/server.vala"
							_compilation_size = _tmp95_;
#line 759 "../src/server.vala"
							_compilation_index = -1;
#line 759 "../src/server.vala"
							while (TRUE) {
#line 7489 "server.c"
								gint _tmp96_;
								gint _tmp97_;
								VlsCompilation* compilation = NULL;
								GeeArrayList* _tmp98_;
								gpointer _tmp99_;
#line 759 "../src/server.vala"
								_compilation_index = _compilation_index + 1;
#line 759 "../src/server.vala"
								_tmp96_ = _compilation_index;
#line 759 "../src/server.vala"
								_tmp97_ = _compilation_size;
#line 759 "../src/server.vala"
								if (!(_tmp96_ < _tmp97_)) {
#line 759 "../src/server.vala"
									break;
#line 7505 "server.c"
								}
#line 759 "../src/server.vala"
								_tmp98_ = _compilation_list;
#line 759 "../src/server.vala"
								_tmp99_ = gee_abstract_list_get ((GeeAbstractList*) _tmp98_, _compilation_index);
#line 759 "../src/server.vala"
								compilation = (VlsCompilation*) _tmp99_;
#line 7513 "server.c"
								{
									ValaList* _source_file_list = NULL;
									VlsCompilation* _tmp100_;
									ValaCodeContext* _tmp101_;
									ValaCodeContext* _tmp102_;
									ValaList* _tmp103_;
									gint _source_file_size = 0;
									ValaList* _tmp104_;
									gint _tmp105_;
									gint _tmp106_;
									gint _source_file_index = 0;
#line 760 "../src/server.vala"
									_tmp100_ = compilation;
#line 760 "../src/server.vala"
									_tmp101_ = vls_compilation_get_code_context (_tmp100_);
#line 760 "../src/server.vala"
									_tmp102_ = _tmp101_;
#line 760 "../src/server.vala"
									_tmp103_ = vala_code_context_get_source_files (_tmp102_);
#line 760 "../src/server.vala"
									_source_file_list = _tmp103_;
#line 760 "../src/server.vala"
									_tmp104_ = _source_file_list;
#line 760 "../src/server.vala"
									_tmp105_ = vala_collection_get_size ((ValaCollection*) _tmp104_);
#line 760 "../src/server.vala"
									_tmp106_ = _tmp105_;
#line 760 "../src/server.vala"
									_source_file_size = _tmp106_;
#line 760 "../src/server.vala"
									_source_file_index = -1;
#line 760 "../src/server.vala"
									while (TRUE) {
#line 7547 "server.c"
										gint _tmp107_;
										gint _tmp108_;
										ValaSourceFile* source_file = NULL;
										ValaList* _tmp109_;
										gpointer _tmp110_;
										gchar* uri = NULL;
										ValaSourceFile* _tmp111_;
										const gchar* _tmp112_;
										const gchar* _tmp113_;
										GFile* _tmp114_;
										GFile* _tmp115_;
										gchar* _tmp116_;
										gchar* _tmp117_;
										GeeHashSet* _tmp118_;
										const gchar* _tmp119_;
#line 760 "../src/server.vala"
										_source_file_index = _source_file_index + 1;
#line 760 "../src/server.vala"
										_tmp107_ = _source_file_index;
#line 760 "../src/server.vala"
										_tmp108_ = _source_file_size;
#line 760 "../src/server.vala"
										if (!(_tmp107_ < _tmp108_)) {
#line 760 "../src/server.vala"
											break;
#line 7573 "server.c"
										}
#line 760 "../src/server.vala"
										_tmp109_ = _source_file_list;
#line 760 "../src/server.vala"
										_tmp110_ = vala_list_get (_tmp109_, _source_file_index);
#line 760 "../src/server.vala"
										source_file = (ValaSourceFile*) _tmp110_;
#line 761 "../src/server.vala"
										_tmp111_ = source_file;
#line 761 "../src/server.vala"
										_tmp112_ = vala_source_file_get_filename (_tmp111_);
#line 761 "../src/server.vala"
										_tmp113_ = _tmp112_;
#line 761 "../src/server.vala"
										_tmp114_ = g_file_new_for_path (_tmp113_);
#line 761 "../src/server.vala"
										_tmp115_ = _tmp114_;
#line 761 "../src/server.vala"
										_tmp116_ = g_file_get_uri (_tmp115_);
#line 761 "../src/server.vala"
										_tmp117_ = _tmp116_;
#line 761 "../src/server.vala"
										_g_object_unref0 (_tmp115_);
#line 761 "../src/server.vala"
										uri = _tmp117_;
#line 762 "../src/server.vala"
										_tmp118_ = orphaned_files;
#line 762 "../src/server.vala"
										_tmp119_ = uri;
#line 762 "../src/server.vala"
										gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp118_, _tmp119_);
#line 760 "../src/server.vala"
										_g_free0 (uri);
#line 760 "../src/server.vala"
										_vala_source_file_unref0 (source_file);
#line 7609 "server.c"
									}
								}
#line 759 "../src/server.vala"
								_g_object_unref0 (compilation);
#line 7614 "server.c"
							}
#line 759 "../src/server.vala"
							_g_object_unref0 (_compilation_list);
#line 7618 "server.c"
						}
					}
				}
#line 758 "../src/server.vala"
				(project_collection == NULL) ? NULL : (project_collection = (g_list_free (project_collection), NULL));
#line 7624 "server.c"
			}
			{
				GeeIterator* _uri_it = NULL;
				GeeHashSet* _tmp120_;
				GeeIterator* _tmp121_;
#line 766 "../src/server.vala"
				_tmp120_ = orphaned_files;
#line 766 "../src/server.vala"
				_tmp121_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp120_);
#line 766 "../src/server.vala"
				_uri_it = _tmp121_;
#line 766 "../src/server.vala"
				while (TRUE) {
#line 7638 "server.c"
					GeeIterator* _tmp122_;
					gchar* uri = NULL;
					GeeIterator* _tmp123_;
					gpointer _tmp124_;
#line 766 "../src/server.vala"
					_tmp122_ = _uri_it;
#line 766 "../src/server.vala"
					if (!gee_iterator_next (_tmp122_)) {
#line 766 "../src/server.vala"
						break;
#line 7649 "server.c"
					}
#line 766 "../src/server.vala"
					_tmp123_ = _uri_it;
#line 766 "../src/server.vala"
					_tmp124_ = gee_iterator_get (_tmp123_);
#line 766 "../src/server.vala"
					uri = (gchar*) _tmp124_;
#line 7657 "server.c"
					{
						GeeArrayList* _tmp125_ = NULL;
						VlsDefaultProject* _tmp126_;
						const gchar* _tmp127_;
						GCancellable* _tmp128_;
						GeeArrayList* _tmp129_;
						VlsPair* opened = NULL;
						gpointer _tmp130_;
						ValaSourceFile* doc = NULL;
						VlsPair* _tmp131_;
						gconstpointer _tmp132_;
						gconstpointer _tmp133_;
						ValaSourceFile* _tmp134_;
						ValaSourceFile* _tmp135_;
						const gchar* _tmp136_;
						const gchar* _tmp137_;
						ValaSourceFile* _tmp139_;
						VlsDefaultProject* _tmp144_;
						VlsPair* _tmp145_;
						gconstpointer _tmp146_;
						gconstpointer _tmp147_;
						JsonrpcClient* _tmp148_;
#line 768 "../src/server.vala"
						_tmp126_ = self->priv->default_project;
#line 768 "../src/server.vala"
						_tmp127_ = uri;
#line 768 "../src/server.vala"
						_tmp128_ = vls_server_cancellable;
#line 768 "../src/server.vala"
						_tmp129_ = vls_project_open ((VlsProject*) _tmp126_, _tmp127_, NULL, _tmp128_, &_inner_error0_);
#line 768 "../src/server.vala"
						_tmp125_ = _tmp129_;
#line 768 "../src/server.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7692 "server.c"
							goto __catch2_g_error;
						}
#line 768 "../src/server.vala"
						_tmp130_ = gee_list_first ((GeeList*) _tmp125_);
#line 768 "../src/server.vala"
						opened = (VlsPair*) _tmp130_;
#line 770 "../src/server.vala"
						_tmp131_ = opened;
#line 770 "../src/server.vala"
						_tmp132_ = vls_pair_get_first (_tmp131_);
#line 770 "../src/server.vala"
						_tmp133_ = _tmp132_;
#line 770 "../src/server.vala"
						_tmp134_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp133_);
#line 770 "../src/server.vala"
						doc = _tmp134_;
#line 771 "../src/server.vala"
						_tmp135_ = doc;
#line 771 "../src/server.vala"
						_tmp136_ = vala_source_file_get_content (_tmp135_);
#line 771 "../src/server.vala"
						_tmp137_ = _tmp136_;
#line 771 "../src/server.vala"
						if (_tmp137_ == NULL) {
#line 7717 "server.c"
							ValaSourceFile* _tmp138_;
#line 772 "../src/server.vala"
							_tmp138_ = doc;
#line 772 "../src/server.vala"
							vala_source_file_get_mapped_contents (_tmp138_);
#line 7723 "server.c"
						}
#line 773 "../src/server.vala"
						_tmp139_ = doc;
#line 773 "../src/server.vala"
						if (VLS_IS_TEXT_DOCUMENT (_tmp139_)) {
#line 7729 "server.c"
							ValaSourceFile* _tmp140_;
							ValaSourceFile* _tmp141_;
							const gchar* _tmp142_;
							const gchar* _tmp143_;
#line 774 "../src/server.vala"
							_tmp140_ = doc;
#line 774 "../src/server.vala"
							_tmp141_ = doc;
#line 774 "../src/server.vala"
							_tmp142_ = vala_source_file_get_content (_tmp141_);
#line 774 "../src/server.vala"
							_tmp143_ = _tmp142_;
#line 774 "../src/server.vala"
							vls_text_document_set_last_saved_content (G_TYPE_CHECK_INSTANCE_CAST (_tmp140_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument), _tmp143_);
#line 7744 "server.c"
						}
#line 775 "../src/server.vala"
						_tmp144_ = self->priv->default_project;
#line 775 "../src/server.vala"
						_tmp145_ = opened;
#line 775 "../src/server.vala"
						_tmp146_ = vls_pair_get_second (_tmp145_);
#line 775 "../src/server.vala"
						_tmp147_ = _tmp146_;
#line 775 "../src/server.vala"
						_tmp148_ = self->priv->update_context_client;
#line 775 "../src/server.vala"
						vls_server_publish_diagnostics (self, (VlsProject*) _tmp144_, (VlsCompilation*) _tmp147_, _tmp148_);
#line 767 "../src/server.vala"
						_vala_source_file_unref0 (doc);
#line 767 "../src/server.vala"
						_g_object_unref0 (opened);
#line 767 "../src/server.vala"
						_g_object_unref0 (_tmp125_);
#line 7764 "server.c"
					}
					goto __finally2;
					__catch2_g_error:
					{
						GError* e = NULL;
						const gchar* _tmp149_;
						GError* _tmp150_;
						const gchar* _tmp151_;
#line 767 "../src/server.vala"
						e = _inner_error0_;
#line 767 "../src/server.vala"
						_inner_error0_ = NULL;
#line 777 "../src/server.vala"
						_tmp149_ = uri;
#line 777 "../src/server.vala"
						_tmp150_ = e;
#line 777 "../src/server.vala"
						_tmp151_ = _tmp150_->message;
#line 777 "../src/server.vala"
						g_warning ("server.vala:777: Failed to reopen in default project %s - %s", _tmp149_, _tmp151_);
#line 7785 "server.c"
						{
							JsonrpcClient* _tmp152_;
							const gchar* _tmp153_;
							GVariant* _tmp154_;
							GVariant* _tmp155_;
							const GVariantType* _tmp156_;
							GVariant** _tmp157_;
							GVariant** _tmp158_;
							gint _tmp158__length1;
							GVariant* _tmp159_;
							GVariant* _tmp160_;
							GVariant* _tmp161_;
							GVariant* _tmp162_;
#line 780 "../src/server.vala"
							_tmp152_ = self->priv->update_context_client;
#line 780 "../src/server.vala"
							_tmp153_ = uri;
#line 780 "../src/server.vala"
							_tmp154_ = g_variant_new_string (_tmp153_);
#line 780 "../src/server.vala"
							g_variant_ref_sink (_tmp154_);
#line 780 "../src/server.vala"
							_tmp155_ = _tmp154_;
#line 780 "../src/server.vala"
							_tmp156_ = G_VARIANT_TYPE_VARIANT;
#line 780 "../src/server.vala"
							_tmp157_ = g_new0 (GVariant*, 0 + 1);
#line 780 "../src/server.vala"
							_tmp158_ = _tmp157_;
#line 780 "../src/server.vala"
							_tmp158__length1 = 0;
#line 780 "../src/server.vala"
							_tmp159_ = g_variant_new_array (_tmp156_, _tmp158_, 0);
#line 780 "../src/server.vala"
							g_variant_ref_sink (_tmp159_);
#line 780 "../src/server.vala"
							_tmp160_ = _tmp159_;
#line 780 "../src/server.vala"
							_tmp161_ = vls_server_build_dict (self, "uri", _tmp155_, "diagnostics", _tmp160_, NULL);
#line 780 "../src/server.vala"
							_tmp162_ = _tmp161_;
#line 780 "../src/server.vala"
							jsonrpc_client_send_notification (_tmp152_, "textDocument/publishDiagnostics", _tmp162_, NULL, &_inner_error0_);
#line 780 "../src/server.vala"
							_g_variant_unref0 (_tmp162_);
#line 780 "../src/server.vala"
							_g_variant_unref0 (_tmp160_);
#line 780 "../src/server.vala"
							_tmp158_ = (_vala_array_free (_tmp158_, _tmp158__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 780 "../src/server.vala"
							_g_variant_unref0 (_tmp155_);
#line 780 "../src/server.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7839 "server.c"
								goto __catch3_g_error;
							}
						}
						goto __finally3;
						__catch3_g_error:
						{
							GError* e = NULL;
							const gchar* _tmp163_;
							GError* _tmp164_;
							const gchar* _tmp165_;
#line 779 "../src/server.vala"
							e = _inner_error0_;
#line 779 "../src/server.vala"
							_inner_error0_ = NULL;
#line 788 "../src/server.vala"
							_tmp163_ = uri;
#line 788 "../src/server.vala"
							_tmp164_ = e;
#line 788 "../src/server.vala"
							_tmp165_ = _tmp164_->message;
#line 788 "../src/server.vala"
							g_warning ("server.vala:788: Failed to clear diagnostics for %s - %s", _tmp163_, _tmp165_);
#line 779 "../src/server.vala"
							_g_error_free0 (e);
#line 7864 "server.c"
						}
						__finally3:
#line 779 "../src/server.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7869 "server.c"
							gboolean _tmp166_ = FALSE;
#line 779 "../src/server.vala"
							_g_error_free0 (e);
#line 779 "../src/server.vala"
							_g_free0 (uri);
#line 779 "../src/server.vala"
							_g_object_unref0 (_uri_it);
#line 779 "../src/server.vala"
							_g_object_unref0 (orphaned_files);
#line 779 "../src/server.vala"
							all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 779 "../src/server.vala"
							g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 779 "../src/server.vala"
							g_clear_error (&_inner_error0_);
#line 779 "../src/server.vala"
							return _tmp166_;
#line 7887 "server.c"
						}
#line 767 "../src/server.vala"
						_g_error_free0 (e);
#line 7891 "server.c"
					}
					__finally2:
#line 767 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 7896 "server.c"
						gboolean _tmp167_ = FALSE;
#line 767 "../src/server.vala"
						_g_free0 (uri);
#line 767 "../src/server.vala"
						_g_object_unref0 (_uri_it);
#line 767 "../src/server.vala"
						_g_object_unref0 (orphaned_files);
#line 767 "../src/server.vala"
						all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 767 "../src/server.vala"
						g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 767 "../src/server.vala"
						g_clear_error (&_inner_error0_);
#line 767 "../src/server.vala"
						return _tmp167_;
#line 7912 "server.c"
					}
#line 766 "../src/server.vala"
					_g_free0 (uri);
#line 7916 "server.c"
				}
#line 766 "../src/server.vala"
				_g_object_unref0 (_uri_it);
#line 7920 "server.c"
			}
#line 755 "../src/server.vala"
			_g_object_unref0 (orphaned_files);
#line 7924 "server.c"
		}
#line 795 "../src/server.vala"
		_tmp168_ = self->priv->documentation;
#line 795 "../src/server.vala"
		vls_gir_documentation_rebuild_if_stale (_tmp168_);
#line 706 "../src/server.vala"
		all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 7932 "server.c"
	}
#line 797 "../src/server.vala"
	result = !self->priv->shutting_down;
#line 797 "../src/server.vala"
	return result;
#line 7938 "server.c"
}

/**
     * Rather than satisfying all requests in `check_update_context ()`,
     * to avoid race conditions, we have to spawn a timeout to check for 
     * the right conditions to call `on_context_updated_func ()`.
     */
void
vls_server_wait_for_context_update (VlsServer* self,
                                    GVariant* id,
                                    VlsServerOnContextUpdatedFunc on_context_updated_func,
                                    gpointer on_context_updated_func_target,
                                    GDestroyNotify on_context_updated_func_target_destroy_notify)
{
#line 807 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 807 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 809 "../src/server.vala"
	if (self->priv->update_context_requests == ((gint64) 0)) {
#line 810 "../src/server.vala"
		on_context_updated_func (FALSE, on_context_updated_func_target);
#line 7961 "server.c"
	} else {
		VlsRequest* req = NULL;
		VlsRequest* _tmp0_;
		GeeHashSet* _tmp1_;
		VlsRequest* _tmp2_;
		VlsRequest* _tmp8_;
		VlsServerOnContextUpdatedFunc _tmp9_;
		gpointer _tmp9__target;
		GDestroyNotify _tmp9__target_destroy_notify;
#line 812 "../src/server.vala"
		_tmp0_ = vls_request_new (id, NULL);
#line 812 "../src/server.vala"
		if (_tmp0_) {
#line 812 "../src/server.vala"
			g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "Vls.Server.wait_for_context_update");
#line 7977 "server.c"
		}
#line 812 "../src/server.vala"
		req = _tmp0_;
#line 813 "../src/server.vala"
		_tmp1_ = self->priv->pending_requests;
#line 813 "../src/server.vala"
		_tmp2_ = req;
#line 813 "../src/server.vala"
		if (!gee_abstract_collection_add ((GeeAbstractCollection*) _tmp1_, _tmp2_)) {
#line 7987 "server.c"
			VlsRequest* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
#line 814 "../src/server.vala"
			_tmp3_ = req;
#line 814 "../src/server.vala"
			_tmp4_ = vls_request_to_string (_tmp3_);
#line 814 "../src/server.vala"
			_tmp5_ = _tmp4_;
#line 814 "../src/server.vala"
			_tmp6_ = g_strconcat ("Request (", _tmp5_, "): request already in pending requests, this should not happen", NULL);
#line 814 "../src/server.vala"
			_tmp7_ = _tmp6_;
#line 814 "../src/server.vala"
			g_warning ("server.vala:814: %s", _tmp7_);
#line 814 "../src/server.vala"
			_g_free0 (_tmp7_);
#line 814 "../src/server.vala"
			_g_free0 (_tmp5_);
#line 8009 "server.c"
		}
#line 817 "../src/server.vala"
		_tmp8_ = req;
#line 817 "../src/server.vala"
		_tmp9_ = on_context_updated_func;
#line 817 "../src/server.vala"
		_tmp9__target = on_context_updated_func_target;
#line 817 "../src/server.vala"
		_tmp9__target_destroy_notify = on_context_updated_func_target_destroy_notify;
#line 817 "../src/server.vala"
		on_context_updated_func = NULL;
#line 817 "../src/server.vala"
		on_context_updated_func_target = NULL;
#line 817 "../src/server.vala"
		on_context_updated_func_target_destroy_notify = NULL;
#line 817 "../src/server.vala"
		vls_server_wait_for_context_update_aux (self, _tmp8_, _tmp9_, _tmp9__target, _tmp9__target_destroy_notify);
#line 809 "../src/server.vala"
		_g_object_unref0 (req);
#line 8029 "server.c"
	}
#line 807 "../src/server.vala"
	(on_context_updated_func_target_destroy_notify == NULL) ? NULL : (on_context_updated_func_target_destroy_notify (on_context_updated_func_target), NULL);
#line 807 "../src/server.vala"
	on_context_updated_func = NULL;
#line 807 "../src/server.vala"
	on_context_updated_func_target = NULL;
#line 807 "../src/server.vala"
	on_context_updated_func_target_destroy_notify = NULL;
#line 8039 "server.c"
}

/**
     * Execute `on_context_updated_func ()` or wait.
     */
static Block29Data*
block29_data_ref (Block29Data* _data29_)
{
#line 824 "../src/server.vala"
	g_atomic_int_inc (&_data29_->_ref_count_);
#line 824 "../src/server.vala"
	return _data29_;
#line 8052 "server.c"
}

static void
block29_data_unref (void * _userdata_)
{
	Block29Data* _data29_;
	_data29_ = (Block29Data*) _userdata_;
#line 824 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data29_->_ref_count_)) {
#line 8062 "server.c"
		VlsServer* self;
#line 824 "../src/server.vala"
		self = _data29_->self;
#line 824 "../src/server.vala"
		_g_object_unref0 (_data29_->req);
#line 824 "../src/server.vala"
		(_data29_->on_context_updated_func_target_destroy_notify == NULL) ? NULL : (_data29_->on_context_updated_func_target_destroy_notify (_data29_->on_context_updated_func_target), NULL);
#line 824 "../src/server.vala"
		_data29_->on_context_updated_func = NULL;
#line 824 "../src/server.vala"
		_data29_->on_context_updated_func_target = NULL;
#line 824 "../src/server.vala"
		_data29_->on_context_updated_func_target_destroy_notify = NULL;
#line 824 "../src/server.vala"
		_g_object_unref0 (self);
#line 824 "../src/server.vala"
		g_slice_free (Block29Data, _data29_);
#line 8080 "server.c"
	}
}

static gboolean
___lambda50_ (Block29Data* _data29_)
{
	VlsServer* self;
	GeeHashSet* _tmp0_;
	gboolean result;
#line 835 "../src/server.vala"
	self = _data29_->self;
#line 836 "../src/server.vala"
	_tmp0_ = self->priv->pending_requests;
#line 836 "../src/server.vala"
	if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp0_, _data29_->req)) {
#line 8096 "server.c"
		VlsServerOnContextUpdatedFunc _tmp1_;
		gpointer _tmp1__target;
		GDestroyNotify _tmp1__target_destroy_notify;
#line 837 "../src/server.vala"
		_tmp1_ = _data29_->on_context_updated_func;
#line 837 "../src/server.vala"
		_tmp1__target = _data29_->on_context_updated_func_target;
#line 837 "../src/server.vala"
		_tmp1__target_destroy_notify = _data29_->on_context_updated_func_target_destroy_notify;
#line 837 "../src/server.vala"
		_data29_->on_context_updated_func = NULL;
#line 837 "../src/server.vala"
		_data29_->on_context_updated_func_target = NULL;
#line 837 "../src/server.vala"
		_data29_->on_context_updated_func_target_destroy_notify = NULL;
#line 837 "../src/server.vala"
		vls_server_wait_for_context_update_aux (self, _data29_->req, _tmp1_, _tmp1__target, _tmp1__target_destroy_notify);
#line 8114 "server.c"
	} else {
#line 840 "../src/server.vala"
		_data29_->on_context_updated_func (TRUE, _data29_->on_context_updated_func_target);
#line 8118 "server.c"
	}
#line 842 "../src/server.vala"
	result = G_SOURCE_REMOVE;
#line 842 "../src/server.vala"
	return result;
#line 8124 "server.c"
}

static gboolean
____lambda50__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda50_ (self);
#line 835 "../src/server.vala"
	return result;
#line 8134 "server.c"
}

static void
vls_server_wait_for_context_update_aux (VlsServer* self,
                                        VlsRequest* req,
                                        VlsServerOnContextUpdatedFunc on_context_updated_func,
                                        gpointer on_context_updated_func_target,
                                        GDestroyNotify on_context_updated_func_target_destroy_notify)
{
	Block29Data* _data29_;
	VlsRequest* _tmp0_;
#line 824 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 824 "../src/server.vala"
	g_return_if_fail (req != NULL);
#line 824 "../src/server.vala"
	_data29_ = g_slice_new0 (Block29Data);
#line 824 "../src/server.vala"
	_data29_->_ref_count_ = 1;
#line 824 "../src/server.vala"
	_data29_->self = g_object_ref (self);
#line 824 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (req);
#line 824 "../src/server.vala"
	_g_object_unref0 (_data29_->req);
#line 824 "../src/server.vala"
	_data29_->req = _tmp0_;
#line 824 "../src/server.vala"
	(_data29_->on_context_updated_func_target_destroy_notify == NULL) ? NULL : (_data29_->on_context_updated_func_target_destroy_notify (_data29_->on_context_updated_func_target), NULL);
#line 824 "../src/server.vala"
	_data29_->on_context_updated_func = NULL;
#line 824 "../src/server.vala"
	_data29_->on_context_updated_func_target = NULL;
#line 824 "../src/server.vala"
	_data29_->on_context_updated_func_target_destroy_notify = NULL;
#line 824 "../src/server.vala"
	_data29_->on_context_updated_func = on_context_updated_func;
#line 824 "../src/server.vala"
	_data29_->on_context_updated_func_target = on_context_updated_func_target;
#line 824 "../src/server.vala"
	_data29_->on_context_updated_func_target_destroy_notify = on_context_updated_func_target_destroy_notify;
#line 826 "../src/server.vala"
	if (self->priv->update_context_requests == ((gint64) 0)) {
#line 8178 "server.c"
		GeeHashSet* _tmp1_;
#line 827 "../src/server.vala"
		_tmp1_ = self->priv->pending_requests;
#line 827 "../src/server.vala"
		if (!gee_abstract_collection_remove ((GeeAbstractCollection*) _tmp1_, _data29_->req)) {
#line 829 "../src/server.vala"
			_data29_->on_context_updated_func (TRUE, _data29_->on_context_updated_func_target);
#line 8186 "server.c"
		} else {
#line 832 "../src/server.vala"
			_data29_->on_context_updated_func (FALSE, _data29_->on_context_updated_func_target);
#line 8190 "server.c"
		}
	} else {
#line 835 "../src/server.vala"
		g_timeout_add_full (G_PRIORITY_DEFAULT, VLS_SERVER_wait_for_context_update_delay_ms, ____lambda50__gsource_func, block29_data_ref (_data29_), block29_data_unref);
#line 8195 "server.c"
	}
#line 824 "../src/server.vala"
	block29_data_unref (_data29_);
#line 824 "../src/server.vala"
	_data29_ = NULL;
#line 8201 "server.c"
}

static Block30Data*
block30_data_ref (Block30Data* _data30_)
{
#line 847 "../src/server.vala"
	g_atomic_int_inc (&_data30_->_ref_count_);
#line 847 "../src/server.vala"
	return _data30_;
#line 8211 "server.c"
}

static void
block30_data_unref (void * _userdata_)
{
	Block30Data* _data30_;
	_data30_ = (Block30Data*) _userdata_;
#line 847 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data30_->_ref_count_)) {
#line 8221 "server.c"
		VlsServer* self;
#line 847 "../src/server.vala"
		self = _data30_->self;
#line 847 "../src/server.vala"
		_g_object_unref0 (_data30_->doc_diags);
#line 847 "../src/server.vala"
		_json_array_unref0 (_data30_->diags_without_source);
#line 847 "../src/server.vala"
		_g_object_unref0 (_data30_->target);
#line 847 "../src/server.vala"
		_g_object_unref0 (self);
#line 847 "../src/server.vala"
		g_slice_free (Block30Data, _data30_);
#line 8235 "server.c"
	}
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 898 "../src/server.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 8244 "server.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 898 "../src/server.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 8252 "server.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 856 "../src/server.vala"
	g_boxed_free (json_node_get_type (), self);
#line 8260 "server.c"
}

static void
__lambda48_ (Block30Data* _data30_,
             VlsSourceMessage* err)
{
	VlsServer* self;
	ValaSourceReference* _tmp0_;
	ValaSourceReference* _tmp10_;
	ValaSourceFile* _tmp11_;
	ValaSourceFile* _tmp12_;
	ValaCodeContext* _tmp13_;
	ValaCodeContext* _tmp14_;
	ValaList* _tmp15_;
	ValaSourceReference* _tmp16_;
	ValaSourceFile* _tmp17_;
	ValaSourceFile* _tmp18_;
	LspDiagnostic* diag = NULL;
	ValaSourceReference* _tmp23_;
	ValaSourceLocation _tmp24_ = {0};
	ValaSourceLocation _tmp25_;
	ValaSourceReference* _tmp26_;
	ValaSourceLocation _tmp27_ = {0};
	ValaSourceLocation _tmp28_;
	LspPosition* _tmp29_ = NULL;
	ValaSourceReference* _tmp30_;
	ValaSourceLocation _tmp31_ = {0};
	ValaSourceLocation _tmp32_;
	ValaSourceReference* _tmp33_;
	ValaSourceLocation _tmp34_ = {0};
	ValaSourceLocation _tmp35_;
	LspPosition* _tmp36_ = NULL;
	LspRange* _tmp37_ = NULL;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	LspDiagnostic* _tmp40_ = NULL;
	JsonNode* node = NULL;
	LspDiagnostic* _tmp41_;
	JsonNode* _tmp42_;
	gboolean _tmp43_ = FALSE;
	GeeHashMap* _tmp44_;
	ValaSourceReference* _tmp45_;
	ValaSourceFile* _tmp46_;
	ValaSourceFile* _tmp47_;
	GeeHashMap* _tmp60_;
	ValaSourceReference* _tmp61_;
	ValaSourceFile* _tmp62_;
	ValaSourceFile* _tmp63_;
	gpointer _tmp64_;
	JsonArray* _tmp65_;
	JsonNode* _tmp66_;
	JsonNode* _tmp67_;
#line 856 "../src/server.vala"
	self = _data30_->self;
#line 856 "../src/server.vala"
	g_return_if_fail (err != NULL);
#line 857 "../src/server.vala"
	_tmp0_ = err->loc;
#line 857 "../src/server.vala"
	if (_tmp0_ == NULL) {
#line 8321 "server.c"
		JsonArray* _tmp1_;
		LspPosition* _tmp2_ = NULL;
		LspPosition* _tmp3_ = NULL;
		LspRange* _tmp4_ = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		LspDiagnostic* _tmp7_ = NULL;
		LspDiagnostic* _tmp8_;
		JsonNode* _tmp9_;
#line 858 "../src/server.vala"
		_tmp1_ = _data30_->diags_without_source;
#line 858 "../src/server.vala"
		_tmp2_ = lsp_position_new ();
#line 858 "../src/server.vala"
		lsp_position_set_line (_tmp2_, (guint) 1);
#line 858 "../src/server.vala"
		lsp_position_set_character (_tmp2_, (guint) 1);
#line 858 "../src/server.vala"
		_tmp3_ = lsp_position_new ();
#line 858 "../src/server.vala"
		lsp_position_set_line (_tmp3_, (guint) 1);
#line 858 "../src/server.vala"
		lsp_position_set_character (_tmp3_, (guint) 1);
#line 858 "../src/server.vala"
		_tmp4_ = lsp_range_new ();
#line 858 "../src/server.vala"
		lsp_range_set_start (_tmp4_, _tmp2_);
#line 858 "../src/server.vala"
		_g_object_unref0 (_tmp2_);
#line 858 "../src/server.vala"
		lsp_range_set_end (_tmp4_, _tmp3_);
#line 858 "../src/server.vala"
		_g_object_unref0 (_tmp3_);
#line 858 "../src/server.vala"
		_tmp5_ = err->message;
#line 858 "../src/server.vala"
		_tmp6_ = g_strdup (_tmp5_);
#line 858 "../src/server.vala"
		_tmp7_ = lsp_diagnostic_new ();
#line 858 "../src/server.vala"
		lsp_diagnostic_set_range (_tmp7_, _tmp4_);
#line 858 "../src/server.vala"
		_g_object_unref0 (_tmp4_);
#line 858 "../src/server.vala"
		lsp_diagnostic_set_severity (_tmp7_, err->severity);
#line 858 "../src/server.vala"
		lsp_diagnostic_set_message (_tmp7_, _tmp6_);
#line 858 "../src/server.vala"
		_g_free0 (_tmp6_);
#line 858 "../src/server.vala"
		_tmp8_ = _tmp7_;
#line 858 "../src/server.vala"
		_tmp9_ = json_gobject_serialize ((GObject*) _tmp8_);
#line 858 "../src/server.vala"
		json_array_add_element (_tmp1_, _tmp9_);
#line 858 "../src/server.vala"
		_g_object_unref0 (_tmp8_);
#line 872 "../src/server.vala"
		return;
#line 8381 "server.c"
	}
#line 874 "../src/server.vala"
	_tmp10_ = err->loc;
#line 874 "../src/server.vala"
	_tmp11_ = vala_source_reference_get_file (_tmp10_);
#line 874 "../src/server.vala"
	_tmp12_ = _tmp11_;
#line 874 "../src/server.vala"
	_vala_assert (_tmp12_ != NULL, "err.loc.file != null");
#line 875 "../src/server.vala"
	_tmp13_ = vls_compilation_get_code_context (_data30_->target);
#line 875 "../src/server.vala"
	_tmp14_ = _tmp13_;
#line 875 "../src/server.vala"
	_tmp15_ = vala_code_context_get_source_files (_tmp14_);
#line 875 "../src/server.vala"
	_tmp16_ = err->loc;
#line 875 "../src/server.vala"
	_tmp17_ = vala_source_reference_get_file (_tmp16_);
#line 875 "../src/server.vala"
	_tmp18_ = _tmp17_;
#line 875 "../src/server.vala"
	if (!vala_collection_contains ((ValaCollection*) _tmp15_, _tmp18_)) {
#line 8405 "server.c"
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
#line 876 "../src/server.vala"
		_tmp19_ = err->message;
#line 876 "../src/server.vala"
		_tmp20_ = string_to_string (_tmp19_);
#line 876 "../src/server.vala"
		_tmp21_ = g_strconcat ("diagnostic has source not in compilation! - ", _tmp20_, NULL);
#line 876 "../src/server.vala"
		_tmp22_ = _tmp21_;
#line 876 "../src/server.vala"
		g_warning ("server.vala:876: %s", _tmp22_);
#line 876 "../src/server.vala"
		_g_free0 (_tmp22_);
#line 877 "../src/server.vala"
		return;
#line 8424 "server.c"
	}
#line 880 "../src/server.vala"
	_tmp23_ = err->loc;
#line 880 "../src/server.vala"
	vala_source_reference_get_begin (_tmp23_, &_tmp24_);
#line 880 "../src/server.vala"
	_tmp25_ = _tmp24_;
#line 880 "../src/server.vala"
	_tmp26_ = err->loc;
#line 880 "../src/server.vala"
	vala_source_reference_get_begin (_tmp26_, &_tmp27_);
#line 880 "../src/server.vala"
	_tmp28_ = _tmp27_;
#line 880 "../src/server.vala"
	_tmp29_ = lsp_position_new ();
#line 880 "../src/server.vala"
	lsp_position_set_line (_tmp29_, (guint) (_tmp25_.line - 1));
#line 880 "../src/server.vala"
	lsp_position_set_character (_tmp29_, (guint) (_tmp28_.column - 1));
#line 880 "../src/server.vala"
	_tmp30_ = err->loc;
#line 880 "../src/server.vala"
	vala_source_reference_get_end (_tmp30_, &_tmp31_);
#line 880 "../src/server.vala"
	_tmp32_ = _tmp31_;
#line 880 "../src/server.vala"
	_tmp33_ = err->loc;
#line 880 "../src/server.vala"
	vala_source_reference_get_end (_tmp33_, &_tmp34_);
#line 880 "../src/server.vala"
	_tmp35_ = _tmp34_;
#line 880 "../src/server.vala"
	_tmp36_ = lsp_position_new ();
#line 880 "../src/server.vala"
	lsp_position_set_line (_tmp36_, (guint) (_tmp32_.line - 1));
#line 880 "../src/server.vala"
	lsp_position_set_character (_tmp36_, (guint) _tmp35_.column);
#line 880 "../src/server.vala"
	_tmp37_ = lsp_range_new ();
#line 880 "../src/server.vala"
	lsp_range_set_start (_tmp37_, _tmp29_);
#line 880 "../src/server.vala"
	_g_object_unref0 (_tmp29_);
#line 880 "../src/server.vala"
	lsp_range_set_end (_tmp37_, _tmp36_);
#line 880 "../src/server.vala"
	_g_object_unref0 (_tmp36_);
#line 880 "../src/server.vala"
	_tmp38_ = err->message;
#line 880 "../src/server.vala"
	_tmp39_ = g_strdup (_tmp38_);
#line 880 "../src/server.vala"
	_tmp40_ = lsp_diagnostic_new ();
#line 880 "../src/server.vala"
	lsp_diagnostic_set_range (_tmp40_, _tmp37_);
#line 880 "../src/server.vala"
	_g_object_unref0 (_tmp37_);
#line 880 "../src/server.vala"
	lsp_diagnostic_set_severity (_tmp40_, err->severity);
#line 880 "../src/server.vala"
	lsp_diagnostic_set_message (_tmp40_, _tmp39_);
#line 880 "../src/server.vala"
	_g_free0 (_tmp39_);
#line 880 "../src/server.vala"
	diag = _tmp40_;
#line 895 "../src/server.vala"
	_tmp41_ = diag;
#line 895 "../src/server.vala"
	_tmp42_ = json_gobject_serialize ((GObject*) _tmp41_);
#line 895 "../src/server.vala"
	node = _tmp42_;
#line 896 "../src/server.vala"
	_tmp44_ = _data30_->doc_diags;
#line 896 "../src/server.vala"
	_tmp45_ = err->loc;
#line 896 "../src/server.vala"
	_tmp46_ = vala_source_reference_get_file (_tmp45_);
#line 896 "../src/server.vala"
	_tmp47_ = _tmp46_;
#line 896 "../src/server.vala"
	if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp44_, _tmp47_)) {
#line 896 "../src/server.vala"
		_tmp43_ = TRUE;
#line 8508 "server.c"
	} else {
		GeeHashMap* _tmp48_;
		ValaSourceReference* _tmp49_;
		ValaSourceFile* _tmp50_;
		ValaSourceFile* _tmp51_;
		gpointer _tmp52_;
		JsonArray* _tmp53_;
#line 896 "../src/server.vala"
		_tmp48_ = _data30_->doc_diags;
#line 896 "../src/server.vala"
		_tmp49_ = err->loc;
#line 896 "../src/server.vala"
		_tmp50_ = vala_source_reference_get_file (_tmp49_);
#line 896 "../src/server.vala"
		_tmp51_ = _tmp50_;
#line 896 "../src/server.vala"
		_tmp52_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp48_, _tmp51_);
#line 896 "../src/server.vala"
		_tmp53_ = (JsonArray*) _tmp52_;
#line 896 "../src/server.vala"
		_tmp43_ = _tmp53_ == NULL;
#line 896 "../src/server.vala"
		_json_array_unref0 (_tmp53_);
#line 8532 "server.c"
	}
#line 896 "../src/server.vala"
	if (_tmp43_) {
#line 8536 "server.c"
		GeeHashMap* _tmp54_;
		ValaSourceReference* _tmp55_;
		ValaSourceFile* _tmp56_;
		ValaSourceFile* _tmp57_;
		JsonArray* _tmp58_;
		JsonArray* _tmp59_;
#line 897 "../src/server.vala"
		_tmp54_ = _data30_->doc_diags;
#line 897 "../src/server.vala"
		_tmp55_ = err->loc;
#line 897 "../src/server.vala"
		_tmp56_ = vala_source_reference_get_file (_tmp55_);
#line 897 "../src/server.vala"
		_tmp57_ = _tmp56_;
#line 897 "../src/server.vala"
		_tmp58_ = json_array_new ();
#line 897 "../src/server.vala"
		_tmp59_ = _tmp58_;
#line 897 "../src/server.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp54_, _tmp57_, _tmp59_);
#line 897 "../src/server.vala"
		_json_array_unref0 (_tmp59_);
#line 8559 "server.c"
	}
#line 898 "../src/server.vala"
	_tmp60_ = _data30_->doc_diags;
#line 898 "../src/server.vala"
	_tmp61_ = err->loc;
#line 898 "../src/server.vala"
	_tmp62_ = vala_source_reference_get_file (_tmp61_);
#line 898 "../src/server.vala"
	_tmp63_ = _tmp62_;
#line 898 "../src/server.vala"
	_tmp64_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp60_, _tmp63_);
#line 898 "../src/server.vala"
	_tmp65_ = (JsonArray*) _tmp64_;
#line 898 "../src/server.vala"
	_tmp66_ = node;
#line 898 "../src/server.vala"
	_tmp67_ = __vala_JsonNode_copy0 (_tmp66_);
#line 898 "../src/server.vala"
	json_array_add_element (_tmp65_, _tmp67_);
#line 898 "../src/server.vala"
	_json_array_unref0 (_tmp65_);
#line 856 "../src/server.vala"
	__vala_JsonNode_free0 (node);
#line 856 "../src/server.vala"
	_g_object_unref0 (diag);
#line 8585 "server.c"
}

static void
___lambda48__gfunc (gconstpointer data,
                    gpointer self)
{
#line 856 "../src/server.vala"
	__lambda48_ (self, (VlsSourceMessage*) data);
#line 8594 "server.c"
}

static void
vls_server_publish_diagnostics (VlsServer* self,
                                VlsProject* project,
                                VlsCompilation* target,
                                JsonrpcClient* client)
{
	Block30Data* _data30_;
	VlsCompilation* _tmp0_;
	JsonArray* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GeeHashMap* _tmp4_;
	VlsReporter* _tmp17_;
	VlsReporter* _tmp18_;
	GPtrArray* _tmp19_;
	GeeArrayList* discarded_files_published = NULL;
	GeeArrayList* _tmp20_;
	GeeHashSet* _tmp41_;
	GeeArrayList* _tmp42_;
	GError* _inner_error0_ = NULL;
#line 847 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 847 "../src/server.vala"
	g_return_if_fail (project != NULL);
#line 847 "../src/server.vala"
	g_return_if_fail (target != NULL);
#line 847 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 847 "../src/server.vala"
	_data30_ = g_slice_new0 (Block30Data);
#line 847 "../src/server.vala"
	_data30_->_ref_count_ = 1;
#line 847 "../src/server.vala"
	_data30_->self = g_object_ref (self);
#line 847 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (target);
#line 847 "../src/server.vala"
	_g_object_unref0 (_data30_->target);
#line 847 "../src/server.vala"
	_data30_->target = _tmp0_;
#line 848 "../src/server.vala"
	_tmp1_ = json_array_new ();
#line 848 "../src/server.vala"
	_data30_->diags_without_source = _tmp1_;
#line 850 "../src/server.vala"
	_tmp2_ = vls_build_target_get_id ((VlsBuildTarget*) _data30_->target);
#line 850 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 850 "../src/server.vala"
	g_debug ("server.vala:850: publishing diagnostics for Compilation target %s", _tmp3_);
#line 852 "../src/server.vala"
	_tmp4_ = gee_hash_map_new (VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, json_array_get_type (), (GBoxedCopyFunc) json_array_ref, (GDestroyNotify) json_array_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 852 "../src/server.vala"
	if (_tmp4_) {
#line 852 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp4_, "vala-creation-function", "Vls.Server.publish_diagnostics");
#line 8653 "server.c"
	}
#line 852 "../src/server.vala"
	_data30_->doc_diags = _tmp4_;
#line 8657 "server.c"
	{
		ValaList* _file_list = NULL;
		ValaCodeContext* _tmp5_;
		ValaCodeContext* _tmp6_;
		ValaList* _tmp7_;
		gint _file_size = 0;
		ValaList* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gint _file_index = 0;
#line 853 "../src/server.vala"
		_tmp5_ = vls_compilation_get_code_context (_data30_->target);
#line 853 "../src/server.vala"
		_tmp6_ = _tmp5_;
#line 853 "../src/server.vala"
		_tmp7_ = vala_code_context_get_source_files (_tmp6_);
#line 853 "../src/server.vala"
		_file_list = _tmp7_;
#line 853 "../src/server.vala"
		_tmp8_ = _file_list;
#line 853 "../src/server.vala"
		_tmp9_ = vala_collection_get_size ((ValaCollection*) _tmp8_);
#line 853 "../src/server.vala"
		_tmp10_ = _tmp9_;
#line 853 "../src/server.vala"
		_file_size = _tmp10_;
#line 853 "../src/server.vala"
		_file_index = -1;
#line 853 "../src/server.vala"
		while (TRUE) {
#line 8688 "server.c"
			gint _tmp11_;
			gint _tmp12_;
			ValaSourceFile* file = NULL;
			ValaList* _tmp13_;
			gpointer _tmp14_;
			GeeHashMap* _tmp15_;
			ValaSourceFile* _tmp16_;
#line 853 "../src/server.vala"
			_file_index = _file_index + 1;
#line 853 "../src/server.vala"
			_tmp11_ = _file_index;
#line 853 "../src/server.vala"
			_tmp12_ = _file_size;
#line 853 "../src/server.vala"
			if (!(_tmp11_ < _tmp12_)) {
#line 853 "../src/server.vala"
				break;
#line 8706 "server.c"
			}
#line 853 "../src/server.vala"
			_tmp13_ = _file_list;
#line 853 "../src/server.vala"
			_tmp14_ = vala_list_get (_tmp13_, _file_index);
#line 853 "../src/server.vala"
			file = (ValaSourceFile*) _tmp14_;
#line 854 "../src/server.vala"
			_tmp15_ = _data30_->doc_diags;
#line 854 "../src/server.vala"
			_tmp16_ = file;
#line 854 "../src/server.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, _tmp16_, NULL);
#line 853 "../src/server.vala"
			_vala_source_file_unref0 (file);
#line 8722 "server.c"
		}
	}
#line 856 "../src/server.vala"
	_tmp17_ = vls_compilation_get_reporter (_data30_->target);
#line 856 "../src/server.vala"
	_tmp18_ = _tmp17_;
#line 856 "../src/server.vala"
	_tmp19_ = _tmp18_->messages;
#line 856 "../src/server.vala"
	g_ptr_array_foreach (_tmp19_, ___lambda48__gfunc, _data30_);
#line 902 "../src/server.vala"
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 902 "../src/server.vala"
	if (_tmp20_) {
#line 902 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp20_, "vala-creation-function", "Vls.Server.publish_diagnostics");
#line 8739 "server.c"
	}
#line 902 "../src/server.vala"
	discarded_files_published = _tmp20_;
#line 8743 "server.c"
	{
		GeeIterator* _discarded_uri_it = NULL;
		GeeHashSet* _tmp21_;
		GeeIterator* _tmp22_;
#line 903 "../src/server.vala"
		_tmp21_ = self->priv->discarded_files;
#line 903 "../src/server.vala"
		_tmp22_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp21_);
#line 903 "../src/server.vala"
		_discarded_uri_it = _tmp22_;
#line 903 "../src/server.vala"
		while (TRUE) {
#line 8756 "server.c"
			GeeIterator* _tmp23_;
			gchar* discarded_uri = NULL;
			GeeIterator* _tmp24_;
			gpointer _tmp25_;
#line 903 "../src/server.vala"
			_tmp23_ = _discarded_uri_it;
#line 903 "../src/server.vala"
			if (!gee_iterator_next (_tmp23_)) {
#line 903 "../src/server.vala"
				break;
#line 8767 "server.c"
			}
#line 903 "../src/server.vala"
			_tmp24_ = _discarded_uri_it;
#line 903 "../src/server.vala"
			_tmp25_ = gee_iterator_get (_tmp24_);
#line 903 "../src/server.vala"
			discarded_uri = (gchar*) _tmp25_;
#line 8775 "server.c"
			{
				const gchar* _tmp26_;
				GVariant* _tmp27_;
				GVariant* _tmp28_;
				const GVariantType* _tmp29_;
				GVariant** _tmp30_;
				GVariant** _tmp31_;
				gint _tmp31__length1;
				GVariant* _tmp32_;
				GVariant* _tmp33_;
				GVariant* _tmp34_;
				GVariant* _tmp35_;
				GeeArrayList* _tmp36_;
				const gchar* _tmp37_;
#line 905 "../src/server.vala"
				_tmp26_ = discarded_uri;
#line 905 "../src/server.vala"
				_tmp27_ = g_variant_new_string (_tmp26_);
#line 905 "../src/server.vala"
				g_variant_ref_sink (_tmp27_);
#line 905 "../src/server.vala"
				_tmp28_ = _tmp27_;
#line 905 "../src/server.vala"
				_tmp29_ = G_VARIANT_TYPE_VARIANT;
#line 905 "../src/server.vala"
				_tmp30_ = g_new0 (GVariant*, 0 + 1);
#line 905 "../src/server.vala"
				_tmp31_ = _tmp30_;
#line 905 "../src/server.vala"
				_tmp31__length1 = 0;
#line 905 "../src/server.vala"
				_tmp32_ = g_variant_new_array (_tmp29_, _tmp31_, 0);
#line 905 "../src/server.vala"
				g_variant_ref_sink (_tmp32_);
#line 905 "../src/server.vala"
				_tmp33_ = _tmp32_;
#line 905 "../src/server.vala"
				_tmp34_ = vls_server_build_dict (self, "uri", _tmp28_, "diagnostics", _tmp33_, NULL);
#line 905 "../src/server.vala"
				_tmp35_ = _tmp34_;
#line 905 "../src/server.vala"
				jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp35_, NULL, &_inner_error0_);
#line 905 "../src/server.vala"
				_g_variant_unref0 (_tmp35_);
#line 905 "../src/server.vala"
				_g_variant_unref0 (_tmp33_);
#line 905 "../src/server.vala"
				_tmp31_ = (_vala_array_free (_tmp31_, _tmp31__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 905 "../src/server.vala"
				_g_variant_unref0 (_tmp28_);
#line 905 "../src/server.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 8828 "server.c"
					goto __catch0_g_error;
				}
#line 912 "../src/server.vala"
				_tmp36_ = discarded_files_published;
#line 912 "../src/server.vala"
				_tmp37_ = discarded_uri;
#line 912 "../src/server.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 8837 "server.c"
			}
			goto __finally0;
			__catch0_g_error:
			{
				GError* e = NULL;
				const gchar* _tmp38_;
				GError* _tmp39_;
				const gchar* _tmp40_;
#line 904 "../src/server.vala"
				e = _inner_error0_;
#line 904 "../src/server.vala"
				_inner_error0_ = NULL;
#line 914 "../src/server.vala"
				_tmp38_ = discarded_uri;
#line 914 "../src/server.vala"
				_tmp39_ = e;
#line 914 "../src/server.vala"
				_tmp40_ = _tmp39_->message;
#line 914 "../src/server.vala"
				g_warning ("server.vala:914: [publishDiagnostics] failed to publish empty diags fo" \
"r %s: %s", _tmp38_, _tmp40_);
#line 904 "../src/server.vala"
				_g_error_free0 (e);
#line 8860 "server.c"
			}
			__finally0:
#line 904 "../src/server.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 904 "../src/server.vala"
				_g_free0 (discarded_uri);
#line 904 "../src/server.vala"
				_g_object_unref0 (_discarded_uri_it);
#line 904 "../src/server.vala"
				_g_object_unref0 (discarded_files_published);
#line 904 "../src/server.vala"
				block30_data_unref (_data30_);
#line 904 "../src/server.vala"
				_data30_ = NULL;
#line 904 "../src/server.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 904 "../src/server.vala"
				g_clear_error (&_inner_error0_);
#line 904 "../src/server.vala"
				return;
#line 8881 "server.c"
			}
#line 903 "../src/server.vala"
			_g_free0 (discarded_uri);
#line 8885 "server.c"
		}
#line 903 "../src/server.vala"
		_g_object_unref0 (_discarded_uri_it);
#line 8889 "server.c"
	}
#line 917 "../src/server.vala"
	_tmp41_ = self->priv->discarded_files;
#line 917 "../src/server.vala"
	_tmp42_ = discarded_files_published;
#line 917 "../src/server.vala"
	gee_collection_remove_all ((GeeCollection*) _tmp41_, (GeeCollection*) _tmp42_);
#line 8897 "server.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp43_;
		GeeSet* _tmp44_;
		GeeSet* _tmp45_;
		GeeSet* _tmp46_;
		GeeIterator* _tmp47_;
		GeeIterator* _tmp48_;
#line 920 "../src/server.vala"
		_tmp43_ = _data30_->doc_diags;
#line 920 "../src/server.vala"
		_tmp44_ = gee_abstract_map_get_entries ((GeeAbstractMap*) _tmp43_);
#line 920 "../src/server.vala"
		_tmp45_ = _tmp44_;
#line 920 "../src/server.vala"
		_tmp46_ = _tmp45_;
#line 920 "../src/server.vala"
		_tmp47_ = gee_iterable_iterator ((GeeIterable*) _tmp46_);
#line 920 "../src/server.vala"
		_tmp48_ = _tmp47_;
#line 920 "../src/server.vala"
		_g_object_unref0 (_tmp46_);
#line 920 "../src/server.vala"
		_entry_it = _tmp48_;
#line 920 "../src/server.vala"
		while (TRUE) {
#line 8924 "server.c"
			GeeIterator* _tmp49_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp50_;
			gpointer _tmp51_;
			GVariant* diags_variant_array = NULL;
			GFile* gfile = NULL;
			GeeMapEntry* _tmp52_;
			gconstpointer _tmp53_;
			gconstpointer _tmp54_;
			const gchar* _tmp55_;
			const gchar* _tmp56_;
			ValaCodeContext* _tmp57_;
			ValaCodeContext* _tmp58_;
			const gchar* _tmp59_;
			const gchar* _tmp60_;
			GFile* _tmp61_;
			GeeMapEntry* _tmp62_;
			gconstpointer _tmp63_;
			gconstpointer _tmp64_;
#line 920 "../src/server.vala"
			_tmp49_ = _entry_it;
#line 920 "../src/server.vala"
			if (!gee_iterator_next (_tmp49_)) {
#line 920 "../src/server.vala"
				break;
#line 8950 "server.c"
			}
#line 920 "../src/server.vala"
			_tmp50_ = _entry_it;
#line 920 "../src/server.vala"
			_tmp51_ = gee_iterator_get (_tmp50_);
#line 920 "../src/server.vala"
			entry = (GeeMapEntry*) _tmp51_;
#line 922 "../src/server.vala"
			_tmp52_ = entry;
#line 922 "../src/server.vala"
			_tmp53_ = gee_map_entry_get_key (_tmp52_);
#line 922 "../src/server.vala"
			_tmp54_ = _tmp53_;
#line 922 "../src/server.vala"
			_tmp55_ = vala_source_file_get_filename ((ValaSourceFile*) _tmp54_);
#line 922 "../src/server.vala"
			_tmp56_ = _tmp55_;
#line 922 "../src/server.vala"
			_tmp57_ = vls_compilation_get_code_context (_data30_->target);
#line 922 "../src/server.vala"
			_tmp58_ = _tmp57_;
#line 922 "../src/server.vala"
			_tmp59_ = vala_code_context_get_directory (_tmp58_);
#line 922 "../src/server.vala"
			_tmp60_ = _tmp59_;
#line 922 "../src/server.vala"
			_tmp61_ = g_file_new_for_commandline_arg_and_cwd (_tmp56_, _tmp60_);
#line 922 "../src/server.vala"
			gfile = _tmp61_;
#line 924 "../src/server.vala"
			_tmp62_ = entry;
#line 924 "../src/server.vala"
			_tmp63_ = gee_map_entry_get_value (_tmp62_);
#line 924 "../src/server.vala"
			_tmp64_ = _tmp63_;
#line 924 "../src/server.vala"
			if (((JsonArray*) _tmp64_) != NULL) {
#line 8988 "server.c"
				{
					GVariant* _tmp65_ = NULL;
					JsonNode* _tmp66_;
					JsonNode* _tmp67_;
					GeeMapEntry* _tmp68_;
					gconstpointer _tmp69_;
					gconstpointer _tmp70_;
					JsonNode* _tmp71_;
					GVariant* _tmp72_;
					GVariant* _tmp73_;
					GVariant* _tmp74_;
#line 926 "../src/server.vala"
					_tmp66_ = json_node_alloc ();
#line 926 "../src/server.vala"
					_tmp67_ = _tmp66_;
#line 926 "../src/server.vala"
					_tmp68_ = entry;
#line 926 "../src/server.vala"
					_tmp69_ = gee_map_entry_get_value (_tmp68_);
#line 926 "../src/server.vala"
					_tmp70_ = _tmp69_;
#line 926 "../src/server.vala"
					_tmp71_ = json_node_init_array (_tmp67_, (JsonArray*) _tmp70_);
#line 926 "../src/server.vala"
					_tmp72_ = json_gvariant_deserialize (_tmp71_, NULL, &_inner_error0_);
#line 926 "../src/server.vala"
					_tmp73_ = _tmp72_;
#line 926 "../src/server.vala"
					__vala_JsonNode_free0 (_tmp67_);
#line 926 "../src/server.vala"
					_tmp65_ = _tmp73_;
#line 926 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9022 "server.c"
						goto __catch1_g_error;
					}
#line 926 "../src/server.vala"
					_tmp74_ = _tmp65_;
#line 926 "../src/server.vala"
					_tmp65_ = NULL;
#line 926 "../src/server.vala"
					if (_tmp74_ != NULL) {
#line 926 "../src/server.vala"
						g_variant_ref_sink (_tmp74_);
#line 9033 "server.c"
					}
#line 926 "../src/server.vala"
					_g_variant_unref0 (diags_variant_array);
#line 926 "../src/server.vala"
					diags_variant_array = _tmp74_;
#line 925 "../src/server.vala"
					_g_variant_unref0 (_tmp65_);
#line 9041 "server.c"
				}
				goto __finally1;
				__catch1_g_error:
				{
					GError* e = NULL;
					GFile* _tmp75_;
					gchar* _tmp76_;
					gchar* _tmp77_;
					const gchar* _tmp78_;
					GError* _tmp79_;
					const gchar* _tmp80_;
					const gchar* _tmp81_;
					gchar* _tmp82_;
					gchar* _tmp83_;
#line 925 "../src/server.vala"
					e = _inner_error0_;
#line 925 "../src/server.vala"
					_inner_error0_ = NULL;
#line 930 "../src/server.vala"
					_tmp75_ = gfile;
#line 930 "../src/server.vala"
					_tmp76_ = g_file_get_uri (_tmp75_);
#line 930 "../src/server.vala"
					_tmp77_ = _tmp76_;
#line 930 "../src/server.vala"
					_tmp78_ = string_to_string (_tmp77_);
#line 930 "../src/server.vala"
					_tmp79_ = e;
#line 930 "../src/server.vala"
					_tmp80_ = _tmp79_->message;
#line 930 "../src/server.vala"
					_tmp81_ = string_to_string (_tmp80_);
#line 930 "../src/server.vala"
					_tmp82_ = g_strconcat ("[publishDiagnostics] failed to deserialize diags for `", _tmp78_, "': ", _tmp81_, NULL);
#line 930 "../src/server.vala"
					_tmp83_ = _tmp82_;
#line 930 "../src/server.vala"
					g_warning ("server.vala:930: %s", _tmp83_);
#line 930 "../src/server.vala"
					_g_free0 (_tmp83_);
#line 930 "../src/server.vala"
					_g_free0 (_tmp77_);
#line 931 "../src/server.vala"
					_g_error_free0 (e);
#line 931 "../src/server.vala"
					_g_object_unref0 (gfile);
#line 931 "../src/server.vala"
					_g_variant_unref0 (diags_variant_array);
#line 931 "../src/server.vala"
					_g_object_unref0 (entry);
#line 931 "../src/server.vala"
					continue;
#line 9094 "server.c"
				}
				__finally1:
#line 925 "../src/server.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 925 "../src/server.vala"
					_g_object_unref0 (gfile);
#line 925 "../src/server.vala"
					_g_variant_unref0 (diags_variant_array);
#line 925 "../src/server.vala"
					_g_object_unref0 (entry);
#line 925 "../src/server.vala"
					_g_object_unref0 (_entry_it);
#line 925 "../src/server.vala"
					_g_object_unref0 (discarded_files_published);
#line 925 "../src/server.vala"
					block30_data_unref (_data30_);
#line 925 "../src/server.vala"
					_data30_ = NULL;
#line 925 "../src/server.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 925 "../src/server.vala"
					g_clear_error (&_inner_error0_);
#line 925 "../src/server.vala"
					return;
#line 9119 "server.c"
				}
			} else {
				const GVariantType* _tmp84_;
				GVariant** _tmp85_;
				GVariant** _tmp86_;
				gint _tmp86__length1;
				GVariant* _tmp87_;
#line 934 "../src/server.vala"
				_tmp84_ = G_VARIANT_TYPE_VARIANT;
#line 934 "../src/server.vala"
				_tmp85_ = g_new0 (GVariant*, 0 + 1);
#line 934 "../src/server.vala"
				_tmp86_ = _tmp85_;
#line 934 "../src/server.vala"
				_tmp86__length1 = 0;
#line 934 "../src/server.vala"
				_tmp87_ = g_variant_new_array (_tmp84_, _tmp86_, 0);
#line 934 "../src/server.vala"
				g_variant_ref_sink (_tmp87_);
#line 934 "../src/server.vala"
				_g_variant_unref0 (diags_variant_array);
#line 934 "../src/server.vala"
				diags_variant_array = _tmp87_;
#line 934 "../src/server.vala"
				_tmp86_ = (_vala_array_free (_tmp86_, _tmp86__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 9145 "server.c"
			}
			{
				GFile* _tmp88_;
				gchar* _tmp89_;
				gchar* _tmp90_;
				GVariant* _tmp91_;
				GVariant* _tmp92_;
				GVariant* _tmp93_;
				GVariant* _tmp94_;
				GVariant* _tmp95_;
				GCancellable* _tmp96_;
#line 938 "../src/server.vala"
				_tmp88_ = gfile;
#line 938 "../src/server.vala"
				_tmp89_ = g_file_get_uri (_tmp88_);
#line 938 "../src/server.vala"
				_tmp90_ = _tmp89_;
#line 938 "../src/server.vala"
				_tmp91_ = g_variant_new_string (_tmp90_);
#line 938 "../src/server.vala"
				g_variant_ref_sink (_tmp91_);
#line 938 "../src/server.vala"
				_tmp92_ = _tmp91_;
#line 938 "../src/server.vala"
				_tmp93_ = diags_variant_array;
#line 938 "../src/server.vala"
				_tmp94_ = vls_server_build_dict (self, "uri", _tmp92_, "diagnostics", _tmp93_, NULL);
#line 938 "../src/server.vala"
				_tmp95_ = _tmp94_;
#line 938 "../src/server.vala"
				_tmp96_ = vls_server_cancellable;
#line 938 "../src/server.vala"
				jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp95_, _tmp96_, &_inner_error0_);
#line 938 "../src/server.vala"
				_g_variant_unref0 (_tmp95_);
#line 938 "../src/server.vala"
				_g_variant_unref0 (_tmp92_);
#line 938 "../src/server.vala"
				_g_free0 (_tmp90_);
#line 938 "../src/server.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9187 "server.c"
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				GError* e = NULL;
				GError* _tmp97_;
				const gchar* _tmp98_;
				const gchar* _tmp99_;
				gchar* _tmp100_;
				gchar* _tmp101_;
#line 937 "../src/server.vala"
				e = _inner_error0_;
#line 937 "../src/server.vala"
				_inner_error0_ = NULL;
#line 946 "../src/server.vala"
				_tmp97_ = e;
#line 946 "../src/server.vala"
				_tmp98_ = _tmp97_->message;
#line 946 "../src/server.vala"
				_tmp99_ = string_to_string (_tmp98_);
#line 946 "../src/server.vala"
				_tmp100_ = g_strconcat ("[publishDiagnostics] failed to notify client: ", _tmp99_, NULL);
#line 946 "../src/server.vala"
				_tmp101_ = _tmp100_;
#line 946 "../src/server.vala"
				g_warning ("server.vala:946: %s", _tmp101_);
#line 946 "../src/server.vala"
				_g_free0 (_tmp101_);
#line 937 "../src/server.vala"
				_g_error_free0 (e);
#line 9220 "server.c"
			}
			__finally2:
#line 937 "../src/server.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 937 "../src/server.vala"
				_g_object_unref0 (gfile);
#line 937 "../src/server.vala"
				_g_variant_unref0 (diags_variant_array);
#line 937 "../src/server.vala"
				_g_object_unref0 (entry);
#line 937 "../src/server.vala"
				_g_object_unref0 (_entry_it);
#line 937 "../src/server.vala"
				_g_object_unref0 (discarded_files_published);
#line 937 "../src/server.vala"
				block30_data_unref (_data30_);
#line 937 "../src/server.vala"
				_data30_ = NULL;
#line 937 "../src/server.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 937 "../src/server.vala"
				g_clear_error (&_inner_error0_);
#line 937 "../src/server.vala"
				return;
#line 9245 "server.c"
			}
#line 920 "../src/server.vala"
			_g_object_unref0 (gfile);
#line 920 "../src/server.vala"
			_g_variant_unref0 (diags_variant_array);
#line 920 "../src/server.vala"
			_g_object_unref0 (entry);
#line 9253 "server.c"
		}
#line 920 "../src/server.vala"
		_g_object_unref0 (_entry_it);
#line 9257 "server.c"
	}
	{
		GVariant* diags_wo_src_variant_array = NULL;
		JsonNode* _tmp102_;
		JsonNode* _tmp103_;
		JsonArray* _tmp104_;
		JsonNode* _tmp105_;
		GVariant* _tmp106_;
		GVariant* _tmp107_;
		const gchar* _tmp108_;
		const gchar* _tmp109_;
		GFile* _tmp110_;
		GFile* _tmp111_;
		gchar* _tmp112_;
		gchar* _tmp113_;
		GVariant* _tmp114_;
		GVariant* _tmp115_;
		GVariant* _tmp116_;
		GVariant* _tmp117_;
		GVariant* _tmp118_;
		GCancellable* _tmp119_;
#line 951 "../src/server.vala"
		_tmp102_ = json_node_alloc ();
#line 951 "../src/server.vala"
		_tmp103_ = _tmp102_;
#line 951 "../src/server.vala"
		_tmp104_ = _data30_->diags_without_source;
#line 951 "../src/server.vala"
		_tmp105_ = json_node_init_array (_tmp103_, _tmp104_);
#line 951 "../src/server.vala"
		_tmp106_ = json_gvariant_deserialize (_tmp105_, NULL, &_inner_error0_);
#line 951 "../src/server.vala"
		if (_tmp106_ != NULL) {
#line 951 "../src/server.vala"
			g_variant_ref_sink (_tmp106_);
#line 9293 "server.c"
		}
#line 951 "../src/server.vala"
		_tmp107_ = _tmp106_;
#line 951 "../src/server.vala"
		__vala_JsonNode_free0 (_tmp103_);
#line 951 "../src/server.vala"
		diags_wo_src_variant_array = _tmp107_;
#line 951 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9303 "server.c"
			goto __catch3_g_error;
		}
#line 954 "../src/server.vala"
		_tmp108_ = vls_project_get_root_path (project);
#line 954 "../src/server.vala"
		_tmp109_ = _tmp108_;
#line 954 "../src/server.vala"
		_tmp110_ = g_file_new_for_path (_tmp109_);
#line 954 "../src/server.vala"
		_tmp111_ = _tmp110_;
#line 954 "../src/server.vala"
		_tmp112_ = g_file_get_uri (_tmp111_);
#line 954 "../src/server.vala"
		_tmp113_ = _tmp112_;
#line 954 "../src/server.vala"
		_tmp114_ = g_variant_new_string (_tmp113_);
#line 954 "../src/server.vala"
		g_variant_ref_sink (_tmp114_);
#line 954 "../src/server.vala"
		_tmp115_ = _tmp114_;
#line 954 "../src/server.vala"
		_tmp116_ = diags_wo_src_variant_array;
#line 954 "../src/server.vala"
		_tmp117_ = vls_server_build_dict (self, "uri", _tmp115_, "diagnostics", _tmp116_, NULL);
#line 954 "../src/server.vala"
		_tmp118_ = _tmp117_;
#line 954 "../src/server.vala"
		_tmp119_ = vls_server_cancellable;
#line 954 "../src/server.vala"
		jsonrpc_client_send_notification (client, "textDocument/publishDiagnostics", _tmp118_, _tmp119_, &_inner_error0_);
#line 954 "../src/server.vala"
		_g_variant_unref0 (_tmp118_);
#line 954 "../src/server.vala"
		_g_variant_unref0 (_tmp115_);
#line 954 "../src/server.vala"
		_g_free0 (_tmp113_);
#line 954 "../src/server.vala"
		_g_object_unref0 (_tmp111_);
#line 954 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 954 "../src/server.vala"
			_g_variant_unref0 (diags_wo_src_variant_array);
#line 9346 "server.c"
			goto __catch3_g_error;
		}
#line 950 "../src/server.vala"
		_g_variant_unref0 (diags_wo_src_variant_array);
#line 9351 "server.c"
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* e = NULL;
		GError* _tmp120_;
		const gchar* _tmp121_;
		const gchar* _tmp122_;
		gchar* _tmp123_;
		gchar* _tmp124_;
#line 950 "../src/server.vala"
		e = _inner_error0_;
#line 950 "../src/server.vala"
		_inner_error0_ = NULL;
#line 963 "../src/server.vala"
		_tmp120_ = e;
#line 963 "../src/server.vala"
		_tmp121_ = _tmp120_->message;
#line 963 "../src/server.vala"
		_tmp122_ = string_to_string (_tmp121_);
#line 963 "../src/server.vala"
		_tmp123_ = g_strconcat ("[publishDiagnostics] failed to publish diags without source: ", _tmp122_, NULL);
#line 963 "../src/server.vala"
		_tmp124_ = _tmp123_;
#line 963 "../src/server.vala"
		g_warning ("server.vala:963: %s", _tmp124_);
#line 963 "../src/server.vala"
		_g_free0 (_tmp124_);
#line 950 "../src/server.vala"
		_g_error_free0 (e);
#line 9382 "server.c"
	}
	__finally3:
#line 950 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 950 "../src/server.vala"
		_g_object_unref0 (discarded_files_published);
#line 950 "../src/server.vala"
		block30_data_unref (_data30_);
#line 950 "../src/server.vala"
		_data30_ = NULL;
#line 950 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 950 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 950 "../src/server.vala"
		return;
#line 9399 "server.c"
	}
#line 847 "../src/server.vala"
	_g_object_unref0 (discarded_files_published);
#line 847 "../src/server.vala"
	block30_data_unref (_data30_);
#line 847 "../src/server.vala"
	_data30_ = NULL;
#line 9407 "server.c"
}

static gpointer
_vala_code_node_ref0 (gpointer self)
{
#line 972 "../src/server.vala"
	return self ? vala_code_node_ref (self) : NULL;
#line 9415 "server.c"
}

ValaCodeNode*
vls_server_get_best (VlsNodeSearch* fs,
                     ValaSourceFile* file)
{
	ValaCodeNode* best = NULL;
	ValaCodeNode* _tmp60_;
	ValaCodeNode* _tmp61_;
	ValaCodeNode* _tmp62_;
	ValaCodeNode* result;
#line 967 "../src/server.vala"
	g_return_val_if_fail (fs != NULL, NULL);
#line 967 "../src/server.vala"
	g_return_val_if_fail (file != NULL, NULL);
#line 968 "../src/server.vala"
	best = NULL;
#line 9433 "server.c"
	{
		GeeList* _node_list = NULL;
		GeeList* _tmp0_;
		gint _node_size = 0;
		GeeList* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint _node_index = 0;
#line 970 "../src/server.vala"
		_tmp0_ = fs->result;
#line 970 "../src/server.vala"
		_node_list = _tmp0_;
#line 970 "../src/server.vala"
		_tmp1_ = _node_list;
#line 970 "../src/server.vala"
		_tmp2_ = gee_collection_get_size ((GeeCollection*) _tmp1_);
#line 970 "../src/server.vala"
		_tmp3_ = _tmp2_;
#line 970 "../src/server.vala"
		_node_size = _tmp3_;
#line 970 "../src/server.vala"
		_node_index = -1;
#line 970 "../src/server.vala"
		while (TRUE) {
#line 9458 "server.c"
			gint _tmp4_;
			gint _tmp5_;
			ValaCodeNode* node = NULL;
			GeeList* _tmp6_;
			gpointer _tmp7_;
			ValaCodeNode* _tmp8_;
#line 970 "../src/server.vala"
			_node_index = _node_index + 1;
#line 970 "../src/server.vala"
			_tmp4_ = _node_index;
#line 970 "../src/server.vala"
			_tmp5_ = _node_size;
#line 970 "../src/server.vala"
			if (!(_tmp4_ < _tmp5_)) {
#line 970 "../src/server.vala"
				break;
#line 9475 "server.c"
			}
#line 970 "../src/server.vala"
			_tmp6_ = _node_list;
#line 970 "../src/server.vala"
			_tmp7_ = gee_list_get (_tmp6_, _node_index);
#line 970 "../src/server.vala"
			node = (ValaCodeNode*) _tmp7_;
#line 971 "../src/server.vala"
			_tmp8_ = best;
#line 971 "../src/server.vala"
			if (_tmp8_ == NULL) {
#line 9487 "server.c"
				ValaCodeNode* _tmp9_;
				ValaCodeNode* _tmp10_;
#line 972 "../src/server.vala"
				_tmp9_ = node;
#line 972 "../src/server.vala"
				_tmp10_ = _vala_code_node_ref0 (_tmp9_);
#line 972 "../src/server.vala"
				_vala_code_node_unref0 (best);
#line 972 "../src/server.vala"
				best = _tmp10_;
#line 9498 "server.c"
			} else {
				LspPosition* best_begin = NULL;
				ValaCodeNode* _tmp11_;
				ValaSourceReference* _tmp12_;
				ValaSourceReference* _tmp13_;
				ValaSourceLocation _tmp14_ = {0};
				ValaSourceLocation _tmp15_;
				LspPosition* _tmp16_;
				LspPosition* best_end = NULL;
				ValaCodeNode* _tmp17_;
				ValaSourceReference* _tmp18_;
				ValaSourceReference* _tmp19_;
				ValaSourceLocation _tmp20_ = {0};
				ValaSourceLocation _tmp21_;
				LspPosition* _tmp22_;
				LspPosition* node_begin = NULL;
				ValaCodeNode* _tmp23_;
				ValaSourceReference* _tmp24_;
				ValaSourceReference* _tmp25_;
				ValaSourceLocation _tmp26_ = {0};
				ValaSourceLocation _tmp27_;
				LspPosition* _tmp28_;
				LspPosition* node_end = NULL;
				ValaCodeNode* _tmp29_;
				ValaSourceReference* _tmp30_;
				ValaSourceReference* _tmp31_;
				ValaSourceLocation _tmp32_ = {0};
				ValaSourceLocation _tmp33_;
				LspPosition* _tmp34_;
				gboolean _tmp35_ = FALSE;
				gboolean _tmp36_ = FALSE;
				LspPosition* _tmp37_;
				LspPosition* _tmp38_;
#line 974 "../src/server.vala"
				_tmp11_ = best;
#line 974 "../src/server.vala"
				_tmp12_ = vala_code_node_get_source_reference (_tmp11_);
#line 974 "../src/server.vala"
				_tmp13_ = _tmp12_;
#line 974 "../src/server.vala"
				vala_source_reference_get_begin (_tmp13_, &_tmp14_);
#line 974 "../src/server.vala"
				_tmp15_ = _tmp14_;
#line 974 "../src/server.vala"
				_tmp16_ = lsp_position_new_from_libvala (&_tmp15_);
#line 974 "../src/server.vala"
				if (_tmp16_) {
#line 974 "../src/server.vala"
					g_object_set_data ((GObject *) _tmp16_, "vala-creation-function", "Vls.Server.get_best");
#line 9548 "server.c"
				}
#line 974 "../src/server.vala"
				best_begin = _tmp16_;
#line 975 "../src/server.vala"
				_tmp17_ = best;
#line 975 "../src/server.vala"
				_tmp18_ = vala_code_node_get_source_reference (_tmp17_);
#line 975 "../src/server.vala"
				_tmp19_ = _tmp18_;
#line 975 "../src/server.vala"
				vala_source_reference_get_end (_tmp19_, &_tmp20_);
#line 975 "../src/server.vala"
				_tmp21_ = _tmp20_;
#line 975 "../src/server.vala"
				_tmp22_ = lsp_position_new_from_libvala (&_tmp21_);
#line 975 "../src/server.vala"
				if (_tmp22_) {
#line 975 "../src/server.vala"
					g_object_set_data ((GObject *) _tmp22_, "vala-creation-function", "Vls.Server.get_best");
#line 9568 "server.c"
				}
#line 975 "../src/server.vala"
				best_end = _tmp22_;
#line 976 "../src/server.vala"
				_tmp23_ = node;
#line 976 "../src/server.vala"
				_tmp24_ = vala_code_node_get_source_reference (_tmp23_);
#line 976 "../src/server.vala"
				_tmp25_ = _tmp24_;
#line 976 "../src/server.vala"
				vala_source_reference_get_begin (_tmp25_, &_tmp26_);
#line 976 "../src/server.vala"
				_tmp27_ = _tmp26_;
#line 976 "../src/server.vala"
				_tmp28_ = lsp_position_new_from_libvala (&_tmp27_);
#line 976 "../src/server.vala"
				if (_tmp28_) {
#line 976 "../src/server.vala"
					g_object_set_data ((GObject *) _tmp28_, "vala-creation-function", "Vls.Server.get_best");
#line 9588 "server.c"
				}
#line 976 "../src/server.vala"
				node_begin = _tmp28_;
#line 977 "../src/server.vala"
				_tmp29_ = node;
#line 977 "../src/server.vala"
				_tmp30_ = vala_code_node_get_source_reference (_tmp29_);
#line 977 "../src/server.vala"
				_tmp31_ = _tmp30_;
#line 977 "../src/server.vala"
				vala_source_reference_get_end (_tmp31_, &_tmp32_);
#line 977 "../src/server.vala"
				_tmp33_ = _tmp32_;
#line 977 "../src/server.vala"
				_tmp34_ = lsp_position_new_from_libvala (&_tmp33_);
#line 977 "../src/server.vala"
				if (_tmp34_) {
#line 977 "../src/server.vala"
					g_object_set_data ((GObject *) _tmp34_, "vala-creation-function", "Vls.Server.get_best");
#line 9608 "server.c"
				}
#line 977 "../src/server.vala"
				node_end = _tmp34_;
#line 981 "../src/server.vala"
				_tmp37_ = best_begin;
#line 981 "../src/server.vala"
				_tmp38_ = node_begin;
#line 981 "../src/server.vala"
				if (gee_comparable_compare_to ((GeeComparable*) _tmp37_, _tmp38_) <= 0) {
#line 9618 "server.c"
					LspPosition* _tmp39_;
					LspPosition* _tmp40_;
#line 981 "../src/server.vala"
					_tmp39_ = node_end;
#line 981 "../src/server.vala"
					_tmp40_ = best_end;
#line 981 "../src/server.vala"
					_tmp36_ = gee_comparable_compare_to ((GeeComparable*) _tmp39_, _tmp40_) <= 0;
#line 9627 "server.c"
				} else {
#line 981 "../src/server.vala"
					_tmp36_ = FALSE;
#line 9631 "server.c"
				}
#line 981 "../src/server.vala"
				if (_tmp36_) {
#line 9635 "server.c"
					gboolean _tmp41_ = FALSE;
					gboolean _tmp42_ = FALSE;
					gboolean _tmp43_ = FALSE;
					gboolean _tmp44_ = FALSE;
					LspPosition* _tmp45_;
					LspPosition* _tmp46_;
#line 982 "../src/server.vala"
					_tmp45_ = best_begin;
#line 982 "../src/server.vala"
					_tmp46_ = node_begin;
#line 982 "../src/server.vala"
					if (gee_comparable_compare_to ((GeeComparable*) _tmp45_, _tmp46_) == 0) {
#line 9648 "server.c"
						LspPosition* _tmp47_;
						LspPosition* _tmp48_;
#line 982 "../src/server.vala"
						_tmp47_ = node_end;
#line 982 "../src/server.vala"
						_tmp48_ = best_end;
#line 982 "../src/server.vala"
						_tmp44_ = gee_comparable_compare_to ((GeeComparable*) _tmp47_, _tmp48_) == 0;
#line 9657 "server.c"
					} else {
#line 982 "../src/server.vala"
						_tmp44_ = FALSE;
#line 9661 "server.c"
					}
#line 982 "../src/server.vala"
					if (!_tmp44_) {
#line 982 "../src/server.vala"
						_tmp43_ = TRUE;
#line 9667 "server.c"
					} else {
						gboolean _tmp49_ = FALSE;
						ValaCodeNode* _tmp50_;
#line 984 "../src/server.vala"
						_tmp50_ = best;
#line 984 "../src/server.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp50_, VALA_TYPE_LOCAL_VARIABLE)) {
#line 9675 "server.c"
							ValaCodeNode* _tmp51_;
#line 984 "../src/server.vala"
							_tmp51_ = node;
#line 984 "../src/server.vala"
							_tmp49_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp51_, VALA_TYPE_LOCAL_VARIABLE);
#line 9681 "server.c"
						} else {
#line 984 "../src/server.vala"
							_tmp49_ = FALSE;
#line 9685 "server.c"
						}
#line 984 "../src/server.vala"
						_tmp43_ = _tmp49_;
#line 9689 "server.c"
					}
#line 982 "../src/server.vala"
					if (_tmp43_) {
#line 982 "../src/server.vala"
						_tmp42_ = TRUE;
#line 9695 "server.c"
					} else {
						gboolean _tmp52_ = FALSE;
						ValaCodeNode* _tmp53_;
#line 986 "../src/server.vala"
						_tmp53_ = best;
#line 986 "../src/server.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_FIELD)) {
#line 9703 "server.c"
							ValaCodeNode* _tmp54_;
#line 986 "../src/server.vala"
							_tmp54_ = node;
#line 986 "../src/server.vala"
							_tmp52_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, VALA_TYPE_PROPERTY);
#line 9709 "server.c"
						} else {
#line 986 "../src/server.vala"
							_tmp52_ = FALSE;
#line 9713 "server.c"
						}
#line 986 "../src/server.vala"
						_tmp42_ = _tmp52_;
#line 9717 "server.c"
					}
#line 982 "../src/server.vala"
					if (_tmp42_) {
#line 982 "../src/server.vala"
						_tmp41_ = TRUE;
#line 9723 "server.c"
					} else {
						gboolean _tmp55_ = FALSE;
						ValaCodeNode* _tmp56_;
#line 988 "../src/server.vala"
						_tmp56_ = best;
#line 988 "../src/server.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp56_, VALA_TYPE_NULL_LITERAL)) {
#line 9731 "server.c"
							ValaCodeNode* _tmp57_;
#line 988 "../src/server.vala"
							_tmp57_ = node;
#line 988 "../src/server.vala"
							_tmp55_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_METHOD);
#line 9737 "server.c"
						} else {
#line 988 "../src/server.vala"
							_tmp55_ = FALSE;
#line 9741 "server.c"
						}
#line 988 "../src/server.vala"
						_tmp41_ = _tmp55_;
#line 9745 "server.c"
					}
#line 982 "../src/server.vala"
					_tmp35_ = _tmp41_;
#line 9749 "server.c"
				} else {
#line 981 "../src/server.vala"
					_tmp35_ = FALSE;
#line 9753 "server.c"
				}
#line 981 "../src/server.vala"
				if (_tmp35_) {
#line 9757 "server.c"
					ValaCodeNode* _tmp58_;
					ValaCodeNode* _tmp59_;
#line 990 "../src/server.vala"
					_tmp58_ = node;
#line 990 "../src/server.vala"
					_tmp59_ = _vala_code_node_ref0 (_tmp58_);
#line 990 "../src/server.vala"
					_vala_code_node_unref0 (best);
#line 990 "../src/server.vala"
					best = _tmp59_;
#line 9768 "server.c"
				}
#line 971 "../src/server.vala"
				_g_object_unref0 (node_end);
#line 971 "../src/server.vala"
				_g_object_unref0 (node_begin);
#line 971 "../src/server.vala"
				_g_object_unref0 (best_end);
#line 971 "../src/server.vala"
				_g_object_unref0 (best_begin);
#line 9778 "server.c"
			}
#line 970 "../src/server.vala"
			_vala_code_node_unref0 (node);
#line 9782 "server.c"
		}
	}
#line 995 "../src/server.vala"
	_tmp60_ = best;
#line 995 "../src/server.vala"
	_vala_assert (_tmp60_ != NULL, "best != null");
#line 1002 "../src/server.vala"
	_tmp61_ = best;
#line 1002 "../src/server.vala"
	_tmp62_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, VALA_TYPE_CODE_NODE, ValaCodeNode));
#line 1002 "../src/server.vala"
	result = _tmp62_;
#line 1002 "../src/server.vala"
	_vala_code_node_unref0 (best);
#line 1002 "../src/server.vala"
	return result;
#line 9799 "server.c"
}

static Block31Data*
block31_data_ref (Block31Data* _data31_)
{
#line 1005 "../src/server.vala"
	g_atomic_int_inc (&_data31_->_ref_count_);
#line 1005 "../src/server.vala"
	return _data31_;
#line 9809 "server.c"
}

static void
block31_data_unref (void * _userdata_)
{
	Block31Data* _data31_;
	_data31_ = (Block31Data*) _userdata_;
#line 1005 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data31_->_ref_count_)) {
#line 9819 "server.c"
		VlsServer* self;
#line 1005 "../src/server.vala"
		self = _data31_->self;
#line 1005 "../src/server.vala"
		_g_object_unref0 (_data31_->p);
#line 1005 "../src/server.vala"
		_g_object_unref0 (_data31_->client);
#line 1005 "../src/server.vala"
		_g_free0 (_data31_->method);
#line 1005 "../src/server.vala"
		_g_variant_unref0 (_data31_->id);
#line 1005 "../src/server.vala"
		_g_object_unref0 (self);
#line 1005 "../src/server.vala"
		g_slice_free (Block31Data, _data31_);
#line 9835 "server.c"
	}
}

static void
__lambda51_ (Block31Data* _data31_,
             gboolean request_cancelled)
{
	VlsServer* self;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* file = NULL;
	LspTextDocumentIdentifier* _tmp0_;
	LspTextDocumentIdentifier* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	VlsCompilation* _tmp4_ = NULL;
	VlsProject* _tmp5_ = NULL;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	VlsCompilation* _tmp12_;
	ValaCodeContext* _tmp13_;
	ValaCodeContext* _tmp14_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp15_;
	LspPosition* _tmp16_;
	LspPosition* _tmp17_;
	VlsNodeSearch* _tmp18_;
	VlsNodeSearch* _tmp19_;
	GeeList* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	ValaCodeNode* best = NULL;
	VlsNodeSearch* _tmp29_;
	ValaSourceFile* _tmp30_;
	ValaCodeNode* _tmp31_;
	gboolean _tmp32_ = FALSE;
	ValaCodeNode* _tmp33_;
	ValaCodeNode* _tmp131_;
	LspLocation* location = NULL;
	ValaCodeNode* _tmp135_;
	ValaSourceReference* _tmp136_;
	ValaSourceReference* _tmp137_;
	LspLocation* _tmp138_;
	LspLocation* _tmp139_;
	const gchar* _tmp140_;
	const gchar* _tmp141_;
	GError* _inner_error0_ = NULL;
#line 1008 "../src/server.vala"
	self = _data31_->self;
#line 1009 "../src/server.vala"
	if (request_cancelled) {
#line 1010 "../src/server.vala"
		vls_server_reply_null (_data31_->id, _data31_->client, _data31_->method);
#line 1011 "../src/server.vala"
		return;
#line 9891 "server.c"
	}
#line 1016 "../src/server.vala"
	_tmp0_ = lsp_text_document_position_params_get_textDocument (_data31_->p);
#line 1016 "../src/server.vala"
	_tmp1_ = _tmp0_;
#line 1016 "../src/server.vala"
	_tmp2_ = lsp_text_document_identifier_get_uri (_tmp1_);
#line 1016 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 1016 "../src/server.vala"
	_tmp6_ = vls_server_find_file (self, _tmp3_, &_tmp4_, &_tmp5_);
#line 1016 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1016 "../src/server.vala"
	compilation = _tmp4_;
#line 1016 "../src/server.vala"
	_g_object_unref0 (project);
#line 1016 "../src/server.vala"
	project = _tmp5_;
#line 1016 "../src/server.vala"
	file = _tmp6_;
#line 1017 "../src/server.vala"
	_tmp7_ = file;
#line 1017 "../src/server.vala"
	if (_tmp7_ == NULL) {
#line 9917 "server.c"
		LspTextDocumentIdentifier* _tmp8_;
		LspTextDocumentIdentifier* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 1018 "../src/server.vala"
		_tmp8_ = lsp_text_document_position_params_get_textDocument (_data31_->p);
#line 1018 "../src/server.vala"
		_tmp9_ = _tmp8_;
#line 1018 "../src/server.vala"
		_tmp10_ = lsp_text_document_identifier_get_uri (_tmp9_);
#line 1018 "../src/server.vala"
		_tmp11_ = _tmp10_;
#line 1018 "../src/server.vala"
		g_debug ("server.vala:1018: [%s] file `%s' not found", _data31_->method, _tmp11_);
#line 1019 "../src/server.vala"
		vls_server_reply_null (_data31_->id, _data31_->client, _data31_->method);
#line 1020 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 1020 "../src/server.vala"
		_g_object_unref0 (project);
#line 1020 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1020 "../src/server.vala"
		return;
#line 9942 "server.c"
	}
#line 1023 "../src/server.vala"
	_tmp12_ = compilation;
#line 1023 "../src/server.vala"
	_tmp13_ = vls_compilation_get_code_context (_tmp12_);
#line 1023 "../src/server.vala"
	_tmp14_ = _tmp13_;
#line 1023 "../src/server.vala"
	vala_code_context_push (_tmp14_);
#line 1024 "../src/server.vala"
	_tmp15_ = file;
#line 1024 "../src/server.vala"
	_tmp16_ = lsp_text_document_position_params_get_position (_data31_->p);
#line 1024 "../src/server.vala"
	_tmp17_ = _tmp16_;
#line 1024 "../src/server.vala"
	_tmp18_ = vls_node_search_new (_tmp15_, _tmp17_, TRUE, NULL, TRUE);
#line 1024 "../src/server.vala"
	fs = _tmp18_;
#line 1026 "../src/server.vala"
	_tmp19_ = fs;
#line 1026 "../src/server.vala"
	_tmp20_ = _tmp19_->result;
#line 1026 "../src/server.vala"
	_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 1026 "../src/server.vala"
	_tmp22_ = _tmp21_;
#line 1026 "../src/server.vala"
	if (_tmp22_ == 0) {
#line 1027 "../src/server.vala"
		g_debug ("server.vala:1027: [%s] find symbol is empty", _data31_->method);
#line 9974 "server.c"
		{
			const GVariantType* _tmp23_;
			GVariant* _tmp24_;
			GVariant* _tmp25_;
			GCancellable* _tmp26_;
#line 1029 "../src/server.vala"
			_tmp23_ = G_VARIANT_TYPE_VARIANT;
#line 1029 "../src/server.vala"
			_tmp24_ = g_variant_new_maybe (_tmp23_, NULL);
#line 1029 "../src/server.vala"
			g_variant_ref_sink (_tmp24_);
#line 1029 "../src/server.vala"
			_tmp25_ = _tmp24_;
#line 1029 "../src/server.vala"
			_tmp26_ = vls_server_cancellable;
#line 1029 "../src/server.vala"
			jsonrpc_client_reply (_data31_->client, _data31_->id, _tmp25_, _tmp26_, &_inner_error0_);
#line 1029 "../src/server.vala"
			_g_variant_unref0 (_tmp25_);
#line 1029 "../src/server.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 9996 "server.c"
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp27_;
			const gchar* _tmp28_;
#line 1028 "../src/server.vala"
			e = _inner_error0_;
#line 1028 "../src/server.vala"
			_inner_error0_ = NULL;
#line 1031 "../src/server.vala"
			_tmp27_ = e;
#line 1031 "../src/server.vala"
			_tmp28_ = _tmp27_->message;
#line 1031 "../src/server.vala"
			g_debug ("server.vala:1031: [textDocument/definition] failed to reply to client:" \
" %s", _tmp28_);
#line 1028 "../src/server.vala"
			_g_error_free0 (e);
#line 10018 "server.c"
		}
		__finally0:
#line 1028 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1028 "../src/server.vala"
			_vala_code_visitor_unref0 (fs);
#line 1028 "../src/server.vala"
			_vala_source_file_unref0 (file);
#line 1028 "../src/server.vala"
			_g_object_unref0 (project);
#line 1028 "../src/server.vala"
			_g_object_unref0 (compilation);
#line 1028 "../src/server.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1028 "../src/server.vala"
			g_clear_error (&_inner_error0_);
#line 1028 "../src/server.vala"
			return;
#line 10037 "server.c"
		}
#line 1033 "../src/server.vala"
		vala_code_context_pop ();
#line 1034 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1034 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 1034 "../src/server.vala"
		_g_object_unref0 (project);
#line 1034 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1034 "../src/server.vala"
		return;
#line 10051 "server.c"
	}
#line 1037 "../src/server.vala"
	_tmp29_ = fs;
#line 1037 "../src/server.vala"
	_tmp30_ = file;
#line 1037 "../src/server.vala"
	_tmp31_ = vls_server_get_best (_tmp29_, _tmp30_);
#line 1037 "../src/server.vala"
	best = _tmp31_;
#line 1039 "../src/server.vala"
	_tmp33_ = best;
#line 1039 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_EXPRESSION)) {
#line 10065 "server.c"
		ValaCodeNode* _tmp34_;
#line 1039 "../src/server.vala"
		_tmp34_ = best;
#line 1039 "../src/server.vala"
		_tmp32_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, VALA_TYPE_LITERAL);
#line 10071 "server.c"
	} else {
#line 1039 "../src/server.vala"
		_tmp32_ = FALSE;
#line 10075 "server.c"
	}
#line 1039 "../src/server.vala"
	if (_tmp32_) {
#line 10079 "server.c"
		ValaExpression* b = NULL;
		ValaCodeNode* _tmp35_;
		ValaExpression* _tmp36_;
		ValaCodeNode* _tmp37_;
		ValaExpression* _tmp38_;
		ValaSymbol* _tmp39_;
		ValaSymbol* _tmp40_;
		gboolean _tmp41_ = FALSE;
		ValaExpression* _tmp42_;
		ValaSymbol* _tmp43_;
		ValaSymbol* _tmp44_;
#line 1040 "../src/server.vala"
		_tmp35_ = best;
#line 1040 "../src/server.vala"
		_tmp36_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 1040 "../src/server.vala"
		b = _tmp36_;
#line 1041 "../src/server.vala"
		_tmp37_ = best;
#line 1041 "../src/server.vala"
		_tmp38_ = b;
#line 1041 "../src/server.vala"
		_tmp39_ = vala_expression_get_symbol_reference (_tmp38_);
#line 1041 "../src/server.vala"
		_tmp40_ = _tmp39_;
#line 1041 "../src/server.vala"
		g_debug ("server.vala:1041: best (%p) is a Expression (symbol_reference = %p)", _tmp37_, _tmp40_);
#line 1042 "../src/server.vala"
		_tmp42_ = b;
#line 1042 "../src/server.vala"
		_tmp43_ = vala_expression_get_symbol_reference (_tmp42_);
#line 1042 "../src/server.vala"
		_tmp44_ = _tmp43_;
#line 1042 "../src/server.vala"
		if (_tmp44_ != NULL) {
#line 10115 "server.c"
			ValaExpression* _tmp45_;
			ValaSymbol* _tmp46_;
			ValaSymbol* _tmp47_;
			ValaSourceReference* _tmp48_;
			ValaSourceReference* _tmp49_;
#line 1042 "../src/server.vala"
			_tmp45_ = b;
#line 1042 "../src/server.vala"
			_tmp46_ = vala_expression_get_symbol_reference (_tmp45_);
#line 1042 "../src/server.vala"
			_tmp47_ = _tmp46_;
#line 1042 "../src/server.vala"
			_tmp48_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp47_);
#line 1042 "../src/server.vala"
			_tmp49_ = _tmp48_;
#line 1042 "../src/server.vala"
			_tmp41_ = _tmp49_ != NULL;
#line 10133 "server.c"
		} else {
#line 1042 "../src/server.vala"
			_tmp41_ = FALSE;
#line 10137 "server.c"
		}
#line 1042 "../src/server.vala"
		if (_tmp41_) {
#line 10141 "server.c"
			ValaExpression* _tmp50_;
			ValaSymbol* _tmp51_;
			ValaSymbol* _tmp52_;
			ValaCodeNode* _tmp53_;
			ValaCodeNode* _tmp54_;
			ValaCodeNode* _tmp55_;
			gchar* _tmp56_;
			gchar* _tmp57_;
#line 1043 "../src/server.vala"
			_tmp50_ = b;
#line 1043 "../src/server.vala"
			_tmp51_ = vala_expression_get_symbol_reference (_tmp50_);
#line 1043 "../src/server.vala"
			_tmp52_ = _tmp51_;
#line 1043 "../src/server.vala"
			_tmp53_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp52_);
#line 1043 "../src/server.vala"
			_vala_code_node_unref0 (best);
#line 1043 "../src/server.vala"
			best = _tmp53_;
#line 1044 "../src/server.vala"
			_tmp54_ = best;
#line 1044 "../src/server.vala"
			_tmp55_ = best;
#line 1044 "../src/server.vala"
			_tmp56_ = vala_code_node_to_string (_tmp55_);
#line 1044 "../src/server.vala"
			_tmp57_ = _tmp56_;
#line 1044 "../src/server.vala"
			g_debug ("server.vala:1044: best is now the symbol_referenece => %p (%s)", _tmp54_, _tmp57_);
#line 1044 "../src/server.vala"
			_g_free0 (_tmp57_);
#line 10174 "server.c"
		}
#line 1039 "../src/server.vala"
		_vala_code_node_unref0 (b);
#line 10178 "server.c"
	} else {
		ValaCodeNode* _tmp58_;
#line 1046 "../src/server.vala"
		_tmp58_ = best;
#line 1046 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp58_, VALA_TYPE_DATA_TYPE)) {
#line 10185 "server.c"
			ValaCodeNode* _tmp59_;
			ValaSymbol* _tmp60_;
#line 1047 "../src/server.vala"
			_tmp59_ = best;
#line 1047 "../src/server.vala"
			_tmp60_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 1047 "../src/server.vala"
			_vala_code_node_unref0 (best);
#line 1047 "../src/server.vala"
			best = (ValaCodeNode*) _tmp60_;
#line 10196 "server.c"
		} else {
			ValaCodeNode* _tmp61_;
#line 1048 "../src/server.vala"
			_tmp61_ = best;
#line 1048 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp61_, VALA_TYPE_USING_DIRECTIVE)) {
#line 10203 "server.c"
				ValaCodeNode* _tmp62_;
				ValaSymbol* _tmp63_;
				ValaSymbol* _tmp64_;
				ValaCodeNode* _tmp65_;
#line 1049 "../src/server.vala"
				_tmp62_ = best;
#line 1049 "../src/server.vala"
				_tmp63_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
#line 1049 "../src/server.vala"
				_tmp64_ = _tmp63_;
#line 1049 "../src/server.vala"
				_tmp65_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp64_);
#line 1049 "../src/server.vala"
				_vala_code_node_unref0 (best);
#line 1049 "../src/server.vala"
				best = _tmp65_;
#line 10220 "server.c"
			} else {
				ValaCodeNode* _tmp66_;
#line 1050 "../src/server.vala"
				_tmp66_ = best;
#line 1050 "../src/server.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp66_, VALA_TYPE_METHOD)) {
#line 10227 "server.c"
					ValaMethod* m = NULL;
					ValaCodeNode* _tmp67_;
					ValaMethod* _tmp68_;
					gboolean _tmp69_ = FALSE;
					ValaMethod* _tmp70_;
					ValaMethod* _tmp71_;
					ValaMethod* _tmp72_;
					ValaMethod* _tmp73_;
#line 1051 "../src/server.vala"
					_tmp67_ = best;
#line 1051 "../src/server.vala"
					_tmp68_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, VALA_TYPE_METHOD, ValaMethod));
#line 1051 "../src/server.vala"
					m = _tmp68_;
#line 1053 "../src/server.vala"
					_tmp70_ = m;
#line 1053 "../src/server.vala"
					_tmp71_ = vala_method_get_base_interface_method (_tmp70_);
#line 1053 "../src/server.vala"
					_tmp72_ = _tmp71_;
#line 1053 "../src/server.vala"
					_tmp73_ = m;
#line 1053 "../src/server.vala"
					if (_tmp72_ != _tmp73_) {
#line 10252 "server.c"
						ValaMethod* _tmp74_;
						ValaMethod* _tmp75_;
						ValaMethod* _tmp76_;
#line 1053 "../src/server.vala"
						_tmp74_ = m;
#line 1053 "../src/server.vala"
						_tmp75_ = vala_method_get_base_interface_method (_tmp74_);
#line 1053 "../src/server.vala"
						_tmp76_ = _tmp75_;
#line 1053 "../src/server.vala"
						_tmp69_ = _tmp76_ != NULL;
#line 10264 "server.c"
					} else {
#line 1053 "../src/server.vala"
						_tmp69_ = FALSE;
#line 10268 "server.c"
					}
#line 1053 "../src/server.vala"
					if (_tmp69_) {
#line 10272 "server.c"
						ValaMethod* _tmp77_;
						ValaMethod* _tmp78_;
						ValaMethod* _tmp79_;
						ValaCodeNode* _tmp80_;
#line 1054 "../src/server.vala"
						_tmp77_ = m;
#line 1054 "../src/server.vala"
						_tmp78_ = vala_method_get_base_interface_method (_tmp77_);
#line 1054 "../src/server.vala"
						_tmp79_ = _tmp78_;
#line 1054 "../src/server.vala"
						_tmp80_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp79_);
#line 1054 "../src/server.vala"
						_vala_code_node_unref0 (best);
#line 1054 "../src/server.vala"
						best = _tmp80_;
#line 10289 "server.c"
					} else {
						gboolean _tmp81_ = FALSE;
						ValaMethod* _tmp82_;
						ValaMethod* _tmp83_;
						ValaMethod* _tmp84_;
						ValaMethod* _tmp85_;
#line 1055 "../src/server.vala"
						_tmp82_ = m;
#line 1055 "../src/server.vala"
						_tmp83_ = vala_method_get_base_method (_tmp82_);
#line 1055 "../src/server.vala"
						_tmp84_ = _tmp83_;
#line 1055 "../src/server.vala"
						_tmp85_ = m;
#line 1055 "../src/server.vala"
						if (_tmp84_ != _tmp85_) {
#line 10306 "server.c"
							ValaMethod* _tmp86_;
							ValaMethod* _tmp87_;
							ValaMethod* _tmp88_;
#line 1055 "../src/server.vala"
							_tmp86_ = m;
#line 1055 "../src/server.vala"
							_tmp87_ = vala_method_get_base_method (_tmp86_);
#line 1055 "../src/server.vala"
							_tmp88_ = _tmp87_;
#line 1055 "../src/server.vala"
							_tmp81_ = _tmp88_ != NULL;
#line 10318 "server.c"
						} else {
#line 1055 "../src/server.vala"
							_tmp81_ = FALSE;
#line 10322 "server.c"
						}
#line 1055 "../src/server.vala"
						if (_tmp81_) {
#line 10326 "server.c"
							ValaMethod* _tmp89_;
							ValaMethod* _tmp90_;
							ValaMethod* _tmp91_;
							ValaCodeNode* _tmp92_;
#line 1056 "../src/server.vala"
							_tmp89_ = m;
#line 1056 "../src/server.vala"
							_tmp90_ = vala_method_get_base_method (_tmp89_);
#line 1056 "../src/server.vala"
							_tmp91_ = _tmp90_;
#line 1056 "../src/server.vala"
							_tmp92_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp91_);
#line 1056 "../src/server.vala"
							_vala_code_node_unref0 (best);
#line 1056 "../src/server.vala"
							best = _tmp92_;
#line 10343 "server.c"
						}
					}
#line 1050 "../src/server.vala"
					_vala_code_node_unref0 (m);
#line 10348 "server.c"
				} else {
					ValaCodeNode* _tmp93_;
#line 1057 "../src/server.vala"
					_tmp93_ = best;
#line 1057 "../src/server.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp93_, VALA_TYPE_PROPERTY)) {
#line 10355 "server.c"
						ValaProperty* prop = NULL;
						ValaCodeNode* _tmp94_;
						ValaProperty* _tmp95_;
						gboolean _tmp96_ = FALSE;
						ValaProperty* _tmp97_;
						ValaProperty* _tmp98_;
						ValaProperty* _tmp99_;
						ValaProperty* _tmp100_;
#line 1058 "../src/server.vala"
						_tmp94_ = best;
#line 1058 "../src/server.vala"
						_tmp95_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp94_, VALA_TYPE_PROPERTY, ValaProperty));
#line 1058 "../src/server.vala"
						prop = _tmp95_;
#line 1060 "../src/server.vala"
						_tmp97_ = prop;
#line 1060 "../src/server.vala"
						_tmp98_ = vala_property_get_base_interface_property (_tmp97_);
#line 1060 "../src/server.vala"
						_tmp99_ = _tmp98_;
#line 1060 "../src/server.vala"
						_tmp100_ = prop;
#line 1060 "../src/server.vala"
						if (_tmp99_ != _tmp100_) {
#line 10380 "server.c"
							ValaProperty* _tmp101_;
							ValaProperty* _tmp102_;
							ValaProperty* _tmp103_;
#line 1060 "../src/server.vala"
							_tmp101_ = prop;
#line 1060 "../src/server.vala"
							_tmp102_ = vala_property_get_base_interface_property (_tmp101_);
#line 1060 "../src/server.vala"
							_tmp103_ = _tmp102_;
#line 1060 "../src/server.vala"
							_tmp96_ = _tmp103_ != NULL;
#line 10392 "server.c"
						} else {
#line 1060 "../src/server.vala"
							_tmp96_ = FALSE;
#line 10396 "server.c"
						}
#line 1060 "../src/server.vala"
						if (_tmp96_) {
#line 10400 "server.c"
							ValaProperty* _tmp104_;
							ValaProperty* _tmp105_;
							ValaProperty* _tmp106_;
							ValaCodeNode* _tmp107_;
#line 1061 "../src/server.vala"
							_tmp104_ = prop;
#line 1061 "../src/server.vala"
							_tmp105_ = vala_property_get_base_interface_property (_tmp104_);
#line 1061 "../src/server.vala"
							_tmp106_ = _tmp105_;
#line 1061 "../src/server.vala"
							_tmp107_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp106_);
#line 1061 "../src/server.vala"
							_vala_code_node_unref0 (best);
#line 1061 "../src/server.vala"
							best = _tmp107_;
#line 10417 "server.c"
						} else {
							gboolean _tmp108_ = FALSE;
							ValaProperty* _tmp109_;
							ValaProperty* _tmp110_;
							ValaProperty* _tmp111_;
							ValaProperty* _tmp112_;
#line 1062 "../src/server.vala"
							_tmp109_ = prop;
#line 1062 "../src/server.vala"
							_tmp110_ = vala_property_get_base_property (_tmp109_);
#line 1062 "../src/server.vala"
							_tmp111_ = _tmp110_;
#line 1062 "../src/server.vala"
							_tmp112_ = prop;
#line 1062 "../src/server.vala"
							if (_tmp111_ != _tmp112_) {
#line 10434 "server.c"
								ValaProperty* _tmp113_;
								ValaProperty* _tmp114_;
								ValaProperty* _tmp115_;
#line 1062 "../src/server.vala"
								_tmp113_ = prop;
#line 1062 "../src/server.vala"
								_tmp114_ = vala_property_get_base_property (_tmp113_);
#line 1062 "../src/server.vala"
								_tmp115_ = _tmp114_;
#line 1062 "../src/server.vala"
								_tmp108_ = _tmp115_ != NULL;
#line 10446 "server.c"
							} else {
#line 1062 "../src/server.vala"
								_tmp108_ = FALSE;
#line 10450 "server.c"
							}
#line 1062 "../src/server.vala"
							if (_tmp108_) {
#line 10454 "server.c"
								ValaProperty* _tmp116_;
								ValaProperty* _tmp117_;
								ValaProperty* _tmp118_;
								ValaCodeNode* _tmp119_;
#line 1063 "../src/server.vala"
								_tmp116_ = prop;
#line 1063 "../src/server.vala"
								_tmp117_ = vala_property_get_base_property (_tmp116_);
#line 1063 "../src/server.vala"
								_tmp118_ = _tmp117_;
#line 1063 "../src/server.vala"
								_tmp119_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp118_);
#line 1063 "../src/server.vala"
								_vala_code_node_unref0 (best);
#line 1063 "../src/server.vala"
								best = _tmp119_;
#line 10471 "server.c"
							}
						}
#line 1057 "../src/server.vala"
						_vala_code_node_unref0 (prop);
#line 10476 "server.c"
					} else {
						const gchar* _tmp120_ = NULL;
						ValaCodeNode* _tmp121_;
#line 1065 "../src/server.vala"
						_tmp121_ = best;
#line 1065 "../src/server.vala"
						if (_tmp121_ != NULL) {
#line 10484 "server.c"
							ValaCodeNode* _tmp122_;
							const gchar* _tmp123_;
							const gchar* _tmp124_;
#line 1065 "../src/server.vala"
							_tmp122_ = best;
#line 1065 "../src/server.vala"
							_tmp123_ = vala_code_node_get_type_name (_tmp122_);
#line 1065 "../src/server.vala"
							_tmp124_ = _tmp123_;
#line 1065 "../src/server.vala"
							_tmp120_ = _tmp124_;
#line 10496 "server.c"
						} else {
#line 1065 "../src/server.vala"
							_tmp120_ = NULL;
#line 10500 "server.c"
						}
#line 1065 "../src/server.vala"
						g_debug ("server.vala:1065: [%s] best is %s, which we can't handle", _data31_->method, _tmp120_);
#line 10504 "server.c"
						{
							const GVariantType* _tmp125_;
							GVariant* _tmp126_;
							GVariant* _tmp127_;
							GCancellable* _tmp128_;
#line 1067 "../src/server.vala"
							_tmp125_ = G_VARIANT_TYPE_VARIANT;
#line 1067 "../src/server.vala"
							_tmp126_ = g_variant_new_maybe (_tmp125_, NULL);
#line 1067 "../src/server.vala"
							g_variant_ref_sink (_tmp126_);
#line 1067 "../src/server.vala"
							_tmp127_ = _tmp126_;
#line 1067 "../src/server.vala"
							_tmp128_ = vls_server_cancellable;
#line 1067 "../src/server.vala"
							jsonrpc_client_reply (_data31_->client, _data31_->id, _tmp127_, _tmp128_, &_inner_error0_);
#line 1067 "../src/server.vala"
							_g_variant_unref0 (_tmp127_);
#line 1067 "../src/server.vala"
							if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10526 "server.c"
								goto __catch1_g_error;
							}
						}
						goto __finally1;
						__catch1_g_error:
						{
							GError* e = NULL;
							GError* _tmp129_;
							const gchar* _tmp130_;
#line 1066 "../src/server.vala"
							e = _inner_error0_;
#line 1066 "../src/server.vala"
							_inner_error0_ = NULL;
#line 1069 "../src/server.vala"
							_tmp129_ = e;
#line 1069 "../src/server.vala"
							_tmp130_ = _tmp129_->message;
#line 1069 "../src/server.vala"
							g_debug ("server.vala:1069: [textDocument/definition] failed to reply to client:" \
" %s", _tmp130_);
#line 1066 "../src/server.vala"
							_g_error_free0 (e);
#line 10548 "server.c"
						}
						__finally1:
#line 1066 "../src/server.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1066 "../src/server.vala"
							_vala_code_node_unref0 (best);
#line 1066 "../src/server.vala"
							_vala_code_visitor_unref0 (fs);
#line 1066 "../src/server.vala"
							_vala_source_file_unref0 (file);
#line 1066 "../src/server.vala"
							_g_object_unref0 (project);
#line 1066 "../src/server.vala"
							_g_object_unref0 (compilation);
#line 1066 "../src/server.vala"
							g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1066 "../src/server.vala"
							g_clear_error (&_inner_error0_);
#line 1066 "../src/server.vala"
							return;
#line 10569 "server.c"
						}
#line 1071 "../src/server.vala"
						vala_code_context_pop ();
#line 1072 "../src/server.vala"
						_vala_code_node_unref0 (best);
#line 1072 "../src/server.vala"
						_vala_code_visitor_unref0 (fs);
#line 1072 "../src/server.vala"
						_vala_source_file_unref0 (file);
#line 1072 "../src/server.vala"
						_g_object_unref0 (project);
#line 1072 "../src/server.vala"
						_g_object_unref0 (compilation);
#line 1072 "../src/server.vala"
						return;
#line 10585 "server.c"
					}
				}
			}
		}
	}
#line 1075 "../src/server.vala"
	_tmp131_ = best;
#line 1075 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp131_, VALA_TYPE_SYMBOL)) {
#line 10595 "server.c"
		VlsProject* _tmp132_;
		ValaCodeNode* _tmp133_;
		ValaSymbol* _tmp134_;
#line 1076 "../src/server.vala"
		_tmp132_ = project;
#line 1076 "../src/server.vala"
		_tmp133_ = best;
#line 1076 "../src/server.vala"
		_tmp134_ = vls_symbol_references_find_real_symbol (_tmp132_, G_TYPE_CHECK_INSTANCE_CAST (_tmp133_, VALA_TYPE_SYMBOL, ValaSymbol));
#line 1076 "../src/server.vala"
		_vala_code_node_unref0 (best);
#line 1076 "../src/server.vala"
		best = (ValaCodeNode*) _tmp134_;
#line 10609 "server.c"
	}
#line 1078 "../src/server.vala"
	_tmp135_ = best;
#line 1078 "../src/server.vala"
	_tmp136_ = vala_code_node_get_source_reference (_tmp135_);
#line 1078 "../src/server.vala"
	_tmp137_ = _tmp136_;
#line 1078 "../src/server.vala"
	_tmp138_ = lsp_location_new_from_sourceref (_tmp137_);
#line 1078 "../src/server.vala"
	if (_tmp138_) {
#line 1078 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp138_, "vala-creation-function", "Vls.Server.goto_definition._lambda51_");
#line 10623 "server.c"
	}
#line 1078 "../src/server.vala"
	location = _tmp138_;
#line 1079 "../src/server.vala"
	_tmp139_ = location;
#line 1079 "../src/server.vala"
	_tmp140_ = lsp_location_get_uri (_tmp139_);
#line 1079 "../src/server.vala"
	_tmp141_ = _tmp140_;
#line 1079 "../src/server.vala"
	g_debug ("server.vala:1079: [textDocument/definition] found location ... %s", _tmp141_);
#line 10635 "server.c"
	{
		GVariant* _tmp142_ = NULL;
		LspLocation* _tmp143_;
		GVariant* _tmp144_;
		GCancellable* _tmp145_;
#line 1081 "../src/server.vala"
		_tmp143_ = location;
#line 1081 "../src/server.vala"
		_tmp144_ = vls_util_object_to_variant ((GObject*) _tmp143_, &_inner_error0_);
#line 1081 "../src/server.vala"
		_tmp142_ = _tmp144_;
#line 1081 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 10649 "server.c"
			goto __catch2_g_error;
		}
#line 1081 "../src/server.vala"
		_tmp145_ = vls_server_cancellable;
#line 1081 "../src/server.vala"
		jsonrpc_client_reply (_data31_->client, _data31_->id, _tmp142_, _tmp145_, &_inner_error0_);
#line 1081 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1081 "../src/server.vala"
			_g_variant_unref0 (_tmp142_);
#line 10660 "server.c"
			goto __catch2_g_error;
		}
#line 1080 "../src/server.vala"
		_g_variant_unref0 (_tmp142_);
#line 10665 "server.c"
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp146_;
		const gchar* _tmp147_;
#line 1080 "../src/server.vala"
		e = _inner_error0_;
#line 1080 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1083 "../src/server.vala"
		_tmp146_ = e;
#line 1083 "../src/server.vala"
		_tmp147_ = _tmp146_->message;
#line 1083 "../src/server.vala"
		g_debug ("server.vala:1083: [textDocument/definition] failed to reply to client:" \
" %s", _tmp147_);
#line 1080 "../src/server.vala"
		_g_error_free0 (e);
#line 10685 "server.c"
	}
	__finally2:
#line 1080 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1080 "../src/server.vala"
		_g_object_unref0 (location);
#line 1080 "../src/server.vala"
		_vala_code_node_unref0 (best);
#line 1080 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1080 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 1080 "../src/server.vala"
		_g_object_unref0 (project);
#line 1080 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1080 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1080 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1080 "../src/server.vala"
		return;
#line 10708 "server.c"
	}
#line 1085 "../src/server.vala"
	vala_code_context_pop ();
#line 1008 "../src/server.vala"
	_g_object_unref0 (location);
#line 1008 "../src/server.vala"
	_vala_code_node_unref0 (best);
#line 1008 "../src/server.vala"
	_vala_code_visitor_unref0 (fs);
#line 1008 "../src/server.vala"
	_vala_source_file_unref0 (file);
#line 1008 "../src/server.vala"
	_g_object_unref0 (project);
#line 1008 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 10724 "server.c"
}

static void
___lambda51__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
#line 1008 "../src/server.vala"
	__lambda51_ (self, request_cancelled);
#line 10733 "server.c"
}

static void
vls_server_goto_definition (VlsServer* self,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params)
{
	Block31Data* _data31_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
#line 1005 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1005 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1005 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1005 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1005 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1005 "../src/server.vala"
	_data31_ = g_slice_new0 (Block31Data);
#line 1005 "../src/server.vala"
	_data31_->_ref_count_ = 1;
#line 1005 "../src/server.vala"
	_data31_->self = g_object_ref (self);
#line 1005 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 1005 "../src/server.vala"
	_g_object_unref0 (_data31_->client);
#line 1005 "../src/server.vala"
	_data31_->client = _tmp0_;
#line 1005 "../src/server.vala"
	_tmp1_ = g_strdup (method);
#line 1005 "../src/server.vala"
	_g_free0 (_data31_->method);
#line 1005 "../src/server.vala"
	_data31_->method = _tmp1_;
#line 1005 "../src/server.vala"
	_tmp2_ = _g_variant_ref0 (id);
#line 1005 "../src/server.vala"
	_g_variant_unref0 (_data31_->id);
#line 1005 "../src/server.vala"
	_data31_->id = _tmp2_;
#line 1006 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1006 "../src/server.vala"
	_data31_->p = (LspTextDocumentPositionParams*) _tmp3_;
#line 1008 "../src/server.vala"
	vls_server_wait_for_context_update (self, _data31_->id, ___lambda51__vls_server_on_context_updated_func, block31_data_ref (_data31_), block31_data_unref);
#line 1005 "../src/server.vala"
	block31_data_unref (_data31_);
#line 1005 "../src/server.vala"
	_data31_ = NULL;
#line 10792 "server.c"
}

static Block32Data*
block32_data_ref (Block32Data* _data32_)
{
#line 1089 "../src/server.vala"
	g_atomic_int_inc (&_data32_->_ref_count_);
#line 1089 "../src/server.vala"
	return _data32_;
#line 10802 "server.c"
}

static void
block32_data_unref (void * _userdata_)
{
	Block32Data* _data32_;
	_data32_ = (Block32Data*) _userdata_;
#line 1089 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data32_->_ref_count_)) {
#line 10812 "server.c"
		VlsServer* self;
#line 1089 "../src/server.vala"
		self = _data32_->self;
#line 1089 "../src/server.vala"
		_g_object_unref0 (_data32_->p);
#line 1089 "../src/server.vala"
		_g_object_unref0 (_data32_->client);
#line 1089 "../src/server.vala"
		_g_free0 (_data32_->method);
#line 1089 "../src/server.vala"
		_g_variant_unref0 (_data32_->id);
#line 1089 "../src/server.vala"
		_g_object_unref0 (self);
#line 1089 "../src/server.vala"
		g_slice_free (Block32Data, _data32_);
#line 10828 "server.c"
	}
}

static void
__lambda52_ (Block32Data* _data32_,
             gboolean request_cancelled)
{
	VlsServer* self;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* file = NULL;
	LspTextDocumentIdentifier* _tmp0_;
	LspTextDocumentIdentifier* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	VlsCompilation* _tmp4_ = NULL;
	VlsProject* _tmp5_ = NULL;
	ValaSourceFile* _tmp6_;
	ValaSourceFile* _tmp7_;
	VlsCompilation* _tmp12_;
	ValaCodeContext* _tmp13_;
	ValaCodeContext* _tmp14_;
	JsonArray* array = NULL;
	JsonArray* _tmp15_;
	VlsSymbolEnumerator* syms = NULL;
	VlsCompilation* _tmp16_;
	ValaSourceFile* _tmp17_;
	gpointer _tmp18_;
	LspInitializeParams* _tmp19_;
	LspClientCapabilities* _tmp20_;
	LspClientCapabilities* _tmp21_;
	LspTextDocumentClientCapabilities* _tmp22_;
	LspTextDocumentClientCapabilities* _tmp23_;
	LspDocumentSymbolCapabilities* _tmp24_;
	LspDocumentSymbolCapabilities* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	GError* _inner_error0_ = NULL;
#line 1092 "../src/server.vala"
	self = _data32_->self;
#line 1093 "../src/server.vala"
	if (request_cancelled) {
#line 1094 "../src/server.vala"
		vls_server_reply_null (_data32_->id, _data32_->client, _data32_->method);
#line 1095 "../src/server.vala"
		return;
#line 10875 "server.c"
	}
#line 1100 "../src/server.vala"
	_tmp0_ = lsp_text_document_position_params_get_textDocument (_data32_->p);
#line 1100 "../src/server.vala"
	_tmp1_ = _tmp0_;
#line 1100 "../src/server.vala"
	_tmp2_ = lsp_text_document_identifier_get_uri (_tmp1_);
#line 1100 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 1100 "../src/server.vala"
	_tmp6_ = vls_server_find_file (self, _tmp3_, &_tmp4_, &_tmp5_);
#line 1100 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1100 "../src/server.vala"
	compilation = _tmp4_;
#line 1100 "../src/server.vala"
	_g_object_unref0 (project);
#line 1100 "../src/server.vala"
	project = _tmp5_;
#line 1100 "../src/server.vala"
	file = _tmp6_;
#line 1101 "../src/server.vala"
	_tmp7_ = file;
#line 1101 "../src/server.vala"
	if (_tmp7_ == NULL) {
#line 10901 "server.c"
		LspTextDocumentIdentifier* _tmp8_;
		LspTextDocumentIdentifier* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 1102 "../src/server.vala"
		_tmp8_ = lsp_text_document_position_params_get_textDocument (_data32_->p);
#line 1102 "../src/server.vala"
		_tmp9_ = _tmp8_;
#line 1102 "../src/server.vala"
		_tmp10_ = lsp_text_document_identifier_get_uri (_tmp9_);
#line 1102 "../src/server.vala"
		_tmp11_ = _tmp10_;
#line 1102 "../src/server.vala"
		g_debug ("server.vala:1102: [%s] file `%s' not found", _data32_->method, _tmp11_);
#line 1103 "../src/server.vala"
		vls_server_reply_null (_data32_->id, _data32_->client, _data32_->method);
#line 1104 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 1104 "../src/server.vala"
		_g_object_unref0 (project);
#line 1104 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1104 "../src/server.vala"
		return;
#line 10926 "server.c"
	}
#line 1107 "../src/server.vala"
	_tmp12_ = compilation;
#line 1107 "../src/server.vala"
	_tmp13_ = vls_compilation_get_code_context (_tmp12_);
#line 1107 "../src/server.vala"
	_tmp14_ = _tmp13_;
#line 1107 "../src/server.vala"
	vala_code_context_push (_tmp14_);
#line 1109 "../src/server.vala"
	_tmp15_ = json_array_new ();
#line 1109 "../src/server.vala"
	array = _tmp15_;
#line 1110 "../src/server.vala"
	_tmp16_ = compilation;
#line 1110 "../src/server.vala"
	_tmp17_ = file;
#line 1110 "../src/server.vala"
	_tmp18_ = vls_compilation_get_analysis_for_file (_tmp16_, VLS_TYPE_SYMBOL_ENUMERATOR, (GBoxedCopyFunc) vala_code_visitor_ref, (GDestroyNotify) vala_code_visitor_unref, _tmp17_);
#line 1110 "../src/server.vala"
	syms = (VlsSymbolEnumerator*) _tmp18_;
#line 1111 "../src/server.vala"
	_tmp19_ = self->priv->init_params;
#line 1111 "../src/server.vala"
	_tmp20_ = lsp_initialize_params_get_capabilities (_tmp19_);
#line 1111 "../src/server.vala"
	_tmp21_ = _tmp20_;
#line 1111 "../src/server.vala"
	_tmp22_ = lsp_client_capabilities_get_textDocument (_tmp21_);
#line 1111 "../src/server.vala"
	_tmp23_ = _tmp22_;
#line 1111 "../src/server.vala"
	_tmp24_ = lsp_text_document_client_capabilities_get_documentSymbol (_tmp23_);
#line 1111 "../src/server.vala"
	_tmp25_ = _tmp24_;
#line 1111 "../src/server.vala"
	_tmp26_ = lsp_document_symbol_capabilities_get_hierarchicalDocumentSymbolSupport (_tmp25_);
#line 1111 "../src/server.vala"
	_tmp27_ = _tmp26_;
#line 1111 "../src/server.vala"
	if (_tmp27_) {
#line 10968 "server.c"
		{
			GeeIterator* _dsym_it = NULL;
			VlsSymbolEnumerator* _tmp28_;
			GeeIterator* _tmp29_;
#line 1112 "../src/server.vala"
			_tmp28_ = syms;
#line 1112 "../src/server.vala"
			_tmp29_ = vls_symbol_enumerator_iterator (_tmp28_);
#line 1112 "../src/server.vala"
			_dsym_it = _tmp29_;
#line 1112 "../src/server.vala"
			while (TRUE) {
#line 10981 "server.c"
				GeeIterator* _tmp30_;
				LspDocumentSymbol* dsym = NULL;
				GeeIterator* _tmp31_;
				gpointer _tmp32_;
				JsonArray* _tmp33_;
				LspDocumentSymbol* _tmp34_;
				JsonNode* _tmp35_;
#line 1112 "../src/server.vala"
				_tmp30_ = _dsym_it;
#line 1112 "../src/server.vala"
				if (!gee_iterator_next (_tmp30_)) {
#line 1112 "../src/server.vala"
					break;
#line 10995 "server.c"
				}
#line 1112 "../src/server.vala"
				_tmp31_ = _dsym_it;
#line 1112 "../src/server.vala"
				_tmp32_ = gee_iterator_get (_tmp31_);
#line 1112 "../src/server.vala"
				dsym = (LspDocumentSymbol*) _tmp32_;
#line 1114 "../src/server.vala"
				_tmp33_ = array;
#line 1114 "../src/server.vala"
				_tmp34_ = dsym;
#line 1114 "../src/server.vala"
				_tmp35_ = json_gobject_serialize ((GObject*) _tmp34_);
#line 1114 "../src/server.vala"
				json_array_add_element (_tmp33_, _tmp35_);
#line 1112 "../src/server.vala"
				_g_object_unref0 (dsym);
#line 11013 "server.c"
			}
#line 1112 "../src/server.vala"
			_g_object_unref0 (_dsym_it);
#line 11017 "server.c"
		}
	} else {
		{
			GeeIterator* _dsym_it = NULL;
			VlsSymbolEnumerator* _tmp36_;
			GeeIterable* _tmp37_;
			GeeIterable* _tmp38_;
			GeeIterator* _tmp39_;
			GeeIterator* _tmp40_;
#line 1117 "../src/server.vala"
			_tmp36_ = syms;
#line 1117 "../src/server.vala"
			_tmp37_ = vls_symbol_enumerator_flattened (_tmp36_);
#line 1117 "../src/server.vala"
			_tmp38_ = _tmp37_;
#line 1117 "../src/server.vala"
			_tmp39_ = gee_iterable_iterator (_tmp38_);
#line 1117 "../src/server.vala"
			_tmp40_ = _tmp39_;
#line 1117 "../src/server.vala"
			_g_object_unref0 (_tmp38_);
#line 1117 "../src/server.vala"
			_dsym_it = _tmp40_;
#line 1117 "../src/server.vala"
			while (TRUE) {
#line 11043 "server.c"
				GeeIterator* _tmp41_;
				LspSymbolInformation* dsym = NULL;
				GeeIterator* _tmp42_;
				gpointer _tmp43_;
				JsonArray* _tmp44_;
				LspSymbolInformation* _tmp45_;
				JsonNode* _tmp46_;
#line 1117 "../src/server.vala"
				_tmp41_ = _dsym_it;
#line 1117 "../src/server.vala"
				if (!gee_iterator_next (_tmp41_)) {
#line 1117 "../src/server.vala"
					break;
#line 11057 "server.c"
				}
#line 1117 "../src/server.vala"
				_tmp42_ = _dsym_it;
#line 1117 "../src/server.vala"
				_tmp43_ = gee_iterator_get (_tmp42_);
#line 1117 "../src/server.vala"
				dsym = (LspSymbolInformation*) _tmp43_;
#line 1119 "../src/server.vala"
				_tmp44_ = array;
#line 1119 "../src/server.vala"
				_tmp45_ = dsym;
#line 1119 "../src/server.vala"
				_tmp46_ = json_gobject_serialize ((GObject*) _tmp45_);
#line 1119 "../src/server.vala"
				json_array_add_element (_tmp44_, _tmp46_);
#line 1117 "../src/server.vala"
				_g_object_unref0 (dsym);
#line 11075 "server.c"
			}
#line 1117 "../src/server.vala"
			_g_object_unref0 (_dsym_it);
#line 11079 "server.c"
		}
	}
	{
		GVariant* _result_ = NULL;
		JsonNode* _tmp47_;
		JsonNode* _tmp48_;
		JsonArray* _tmp49_;
		JsonNode* _tmp50_;
		GVariant* _tmp51_;
		GVariant* _tmp52_;
		GVariant* _tmp53_;
		GCancellable* _tmp54_;
#line 1124 "../src/server.vala"
		_tmp47_ = json_node_alloc ();
#line 1124 "../src/server.vala"
		_tmp48_ = _tmp47_;
#line 1124 "../src/server.vala"
		_tmp49_ = array;
#line 1124 "../src/server.vala"
		_tmp50_ = json_node_init_array (_tmp48_, _tmp49_);
#line 1124 "../src/server.vala"
		_tmp51_ = json_gvariant_deserialize (_tmp50_, NULL, &_inner_error0_);
#line 1124 "../src/server.vala"
		if (_tmp51_ != NULL) {
#line 1124 "../src/server.vala"
			g_variant_ref_sink (_tmp51_);
#line 11106 "server.c"
		}
#line 1124 "../src/server.vala"
		_tmp52_ = _tmp51_;
#line 1124 "../src/server.vala"
		__vala_JsonNode_free0 (_tmp48_);
#line 1124 "../src/server.vala"
		_result_ = _tmp52_;
#line 1124 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 11116 "server.c"
			goto __catch0_g_error;
		}
#line 1125 "../src/server.vala"
		_tmp53_ = _result_;
#line 1125 "../src/server.vala"
		_tmp54_ = vls_server_cancellable;
#line 1125 "../src/server.vala"
		jsonrpc_client_reply (_data32_->client, _data32_->id, _tmp53_, _tmp54_, &_inner_error0_);
#line 1125 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1125 "../src/server.vala"
			_g_variant_unref0 (_result_);
#line 11129 "server.c"
			goto __catch0_g_error;
		}
#line 1123 "../src/server.vala"
		_g_variant_unref0 (_result_);
#line 11134 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp55_;
		const gchar* _tmp56_;
		const gchar* _tmp57_;
		gchar* _tmp58_;
		gchar* _tmp59_;
#line 1123 "../src/server.vala"
		e = _inner_error0_;
#line 1123 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1127 "../src/server.vala"
		_tmp55_ = e;
#line 1127 "../src/server.vala"
		_tmp56_ = _tmp55_->message;
#line 1127 "../src/server.vala"
		_tmp57_ = string_to_string (_tmp56_);
#line 1127 "../src/server.vala"
		_tmp58_ = g_strconcat ("[textDocument/documentSymbol] failed to reply to client: ", _tmp57_, NULL);
#line 1127 "../src/server.vala"
		_tmp59_ = _tmp58_;
#line 1127 "../src/server.vala"
		g_debug ("server.vala:1127: %s", _tmp59_);
#line 1127 "../src/server.vala"
		_g_free0 (_tmp59_);
#line 1123 "../src/server.vala"
		_g_error_free0 (e);
#line 11165 "server.c"
	}
	__finally0:
#line 1123 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1123 "../src/server.vala"
		_vala_code_visitor_unref0 (syms);
#line 1123 "../src/server.vala"
		_json_array_unref0 (array);
#line 1123 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 1123 "../src/server.vala"
		_g_object_unref0 (project);
#line 1123 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1123 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1123 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1123 "../src/server.vala"
		return;
#line 11186 "server.c"
	}
#line 1129 "../src/server.vala"
	vala_code_context_pop ();
#line 1092 "../src/server.vala"
	_vala_code_visitor_unref0 (syms);
#line 1092 "../src/server.vala"
	_json_array_unref0 (array);
#line 1092 "../src/server.vala"
	_vala_source_file_unref0 (file);
#line 1092 "../src/server.vala"
	_g_object_unref0 (project);
#line 1092 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 11200 "server.c"
}

static void
___lambda52__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
#line 1092 "../src/server.vala"
	__lambda52_ (self, request_cancelled);
#line 11209 "server.c"
}

static void
vls_server_document_symbol_outline (VlsServer* self,
                                    JsonrpcClient* client,
                                    const gchar* method,
                                    GVariant* id,
                                    GVariant* params)
{
	Block32Data* _data32_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
#line 1089 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1089 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1089 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1089 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1089 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1089 "../src/server.vala"
	_data32_ = g_slice_new0 (Block32Data);
#line 1089 "../src/server.vala"
	_data32_->_ref_count_ = 1;
#line 1089 "../src/server.vala"
	_data32_->self = g_object_ref (self);
#line 1089 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 1089 "../src/server.vala"
	_g_object_unref0 (_data32_->client);
#line 1089 "../src/server.vala"
	_data32_->client = _tmp0_;
#line 1089 "../src/server.vala"
	_tmp1_ = g_strdup (method);
#line 1089 "../src/server.vala"
	_g_free0 (_data32_->method);
#line 1089 "../src/server.vala"
	_data32_->method = _tmp1_;
#line 1089 "../src/server.vala"
	_tmp2_ = _g_variant_ref0 (id);
#line 1089 "../src/server.vala"
	_g_variant_unref0 (_data32_->id);
#line 1089 "../src/server.vala"
	_data32_->id = _tmp2_;
#line 1090 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1090 "../src/server.vala"
	_data32_->p = (LspTextDocumentPositionParams*) _tmp3_;
#line 1092 "../src/server.vala"
	vls_server_wait_for_context_update (self, _data32_->id, ___lambda52__vls_server_on_context_updated_func, block32_data_ref (_data32_), block32_data_unref);
#line 1089 "../src/server.vala"
	block32_data_unref (_data32_);
#line 1089 "../src/server.vala"
	_data32_ = NULL;
#line 11268 "server.c"
}

static gpointer
_vala_comment_ref0 (gpointer self)
{
#line 1155 "../src/server.vala"
	return self ? vala_comment_ref (self) : NULL;
#line 11276 "server.c"
}

VlsDocComment*
vls_server_get_symbol_documentation (VlsServer* self,
                                     VlsProject* project,
                                     ValaSymbol* sym)
{
	VlsCompilation* compilation = NULL;
	ValaSymbol* real_sym = NULL;
	ValaSymbol* _tmp0_;
	ValaSymbol* _tmp1_;
	ValaSymbol* root = NULL;
	ValaSymbol* _tmp11_;
	VlsCompilation* _tmp28_;
	ValaComment* comment = NULL;
	VlsDocComment* doc_comment = NULL;
	ValaSymbol* gir_sym = NULL;
	VlsGirDocumentation* _tmp29_;
	ValaSymbol* _tmp30_;
	gboolean _tmp31_ = FALSE;
	ValaSymbol* _tmp32_;
	ValaComment* _tmp43_;
	gboolean _tmp65_ = FALSE;
	VlsDocComment* _tmp66_;
	GError* _inner_error0_ = NULL;
	VlsDocComment* result;
#line 1133 "../src/server.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1133 "../src/server.vala"
	g_return_val_if_fail (project != NULL, NULL);
#line 1133 "../src/server.vala"
	g_return_val_if_fail (sym != NULL, NULL);
#line 1134 "../src/server.vala"
	compilation = NULL;
#line 1135 "../src/server.vala"
	_tmp0_ = vls_symbol_references_find_real_symbol (project, sym);
#line 1135 "../src/server.vala"
	real_sym = _tmp0_;
#line 1136 "../src/server.vala"
	_tmp1_ = real_sym;
#line 1136 "../src/server.vala"
	sym = _tmp1_;
#line 1137 "../src/server.vala"
	root = NULL;
#line 11321 "server.c"
	{
		ValaSymbol* node = NULL;
		ValaSymbol* _tmp2_;
#line 1138 "../src/server.vala"
		_tmp2_ = _vala_code_node_ref0 (sym);
#line 1138 "../src/server.vala"
		node = _tmp2_;
#line 11329 "server.c"
		{
			gboolean _tmp3_ = FALSE;
#line 1138 "../src/server.vala"
			_tmp3_ = TRUE;
#line 1138 "../src/server.vala"
			while (TRUE) {
#line 11336 "server.c"
				ValaSymbol* _tmp8_;
				ValaSymbol* _tmp9_;
				ValaSymbol* _tmp10_;
#line 1138 "../src/server.vala"
				if (!_tmp3_) {
#line 11342 "server.c"
					ValaSymbol* _tmp4_;
					ValaSymbol* _tmp5_;
					ValaSymbol* _tmp6_;
					ValaSymbol* _tmp7_;
#line 1138 "../src/server.vala"
					_tmp4_ = node;
#line 1138 "../src/server.vala"
					_tmp5_ = vala_symbol_get_parent_symbol (_tmp4_);
#line 1138 "../src/server.vala"
					_tmp6_ = _tmp5_;
#line 1138 "../src/server.vala"
					_tmp7_ = _vala_code_node_ref0 (_tmp6_);
#line 1138 "../src/server.vala"
					_vala_code_node_unref0 (node);
#line 1138 "../src/server.vala"
					node = _tmp7_;
#line 11359 "server.c"
				}
#line 1138 "../src/server.vala"
				_tmp3_ = FALSE;
#line 1138 "../src/server.vala"
				_tmp8_ = node;
#line 1138 "../src/server.vala"
				if (!(_tmp8_ != NULL)) {
#line 1138 "../src/server.vala"
					break;
#line 11369 "server.c"
				}
#line 1139 "../src/server.vala"
				_tmp9_ = node;
#line 1139 "../src/server.vala"
				_tmp10_ = _vala_code_node_ref0 (_tmp9_);
#line 1139 "../src/server.vala"
				_vala_code_node_unref0 (root);
#line 1139 "../src/server.vala"
				root = _tmp10_;
#line 11379 "server.c"
			}
		}
#line 1138 "../src/server.vala"
		_vala_code_node_unref0 (node);
#line 11384 "server.c"
	}
#line 1140 "../src/server.vala"
	_tmp11_ = root;
#line 1140 "../src/server.vala"
	_vala_assert (_tmp11_ != NULL, "root != null");
#line 11390 "server.c"
	{
		GeeArrayList* _project_compilation_list = NULL;
		GeeArrayList* _tmp12_;
		gint _project_compilation_size = 0;
		GeeArrayList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _project_compilation_index = 0;
#line 1141 "../src/server.vala"
		_tmp12_ = vls_project_get_compilations (project);
#line 1141 "../src/server.vala"
		_project_compilation_list = _tmp12_;
#line 1141 "../src/server.vala"
		_tmp13_ = _project_compilation_list;
#line 1141 "../src/server.vala"
		_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
#line 1141 "../src/server.vala"
		_tmp15_ = _tmp14_;
#line 1141 "../src/server.vala"
		_project_compilation_size = _tmp15_;
#line 1141 "../src/server.vala"
		_project_compilation_index = -1;
#line 1141 "../src/server.vala"
		while (TRUE) {
#line 11415 "server.c"
			gint _tmp16_;
			gint _tmp17_;
			VlsCompilation* project_compilation = NULL;
			GeeArrayList* _tmp18_;
			gpointer _tmp19_;
			VlsCompilation* _tmp20_;
			ValaCodeContext* _tmp21_;
			ValaCodeContext* _tmp22_;
			ValaNamespace* _tmp23_;
			ValaNamespace* _tmp24_;
			ValaSymbol* _tmp25_;
#line 1141 "../src/server.vala"
			_project_compilation_index = _project_compilation_index + 1;
#line 1141 "../src/server.vala"
			_tmp16_ = _project_compilation_index;
#line 1141 "../src/server.vala"
			_tmp17_ = _project_compilation_size;
#line 1141 "../src/server.vala"
			if (!(_tmp16_ < _tmp17_)) {
#line 1141 "../src/server.vala"
				break;
#line 11437 "server.c"
			}
#line 1141 "../src/server.vala"
			_tmp18_ = _project_compilation_list;
#line 1141 "../src/server.vala"
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _project_compilation_index);
#line 1141 "../src/server.vala"
			project_compilation = (VlsCompilation*) _tmp19_;
#line 1142 "../src/server.vala"
			_tmp20_ = project_compilation;
#line 1142 "../src/server.vala"
			_tmp21_ = vls_compilation_get_code_context (_tmp20_);
#line 1142 "../src/server.vala"
			_tmp22_ = _tmp21_;
#line 1142 "../src/server.vala"
			_tmp23_ = vala_code_context_get_root (_tmp22_);
#line 1142 "../src/server.vala"
			_tmp24_ = _tmp23_;
#line 1142 "../src/server.vala"
			_tmp25_ = root;
#line 1142 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, VALA_TYPE_SYMBOL, ValaSymbol) == _tmp25_) {
#line 11459 "server.c"
				VlsCompilation* _tmp26_;
				VlsCompilation* _tmp27_;
#line 1143 "../src/server.vala"
				_tmp26_ = project_compilation;
#line 1143 "../src/server.vala"
				_tmp27_ = _g_object_ref0 (_tmp26_);
#line 1143 "../src/server.vala"
				_g_object_unref0 (compilation);
#line 1143 "../src/server.vala"
				compilation = _tmp27_;
#line 1144 "../src/server.vala"
				_g_object_unref0 (project_compilation);
#line 1144 "../src/server.vala"
				break;
#line 11474 "server.c"
			}
#line 1141 "../src/server.vala"
			_g_object_unref0 (project_compilation);
#line 11478 "server.c"
		}
#line 1141 "../src/server.vala"
		_g_object_unref0 (_project_compilation_list);
#line 11482 "server.c"
	}
#line 1148 "../src/server.vala"
	_tmp28_ = compilation;
#line 1148 "../src/server.vala"
	if (_tmp28_ == NULL) {
#line 1149 "../src/server.vala"
		result = NULL;
#line 1149 "../src/server.vala"
		_vala_code_node_unref0 (root);
#line 1149 "../src/server.vala"
		_vala_code_node_unref0 (real_sym);
#line 1149 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1149 "../src/server.vala"
		return result;
#line 11498 "server.c"
	}
#line 1151 "../src/server.vala"
	comment = NULL;
#line 1152 "../src/server.vala"
	doc_comment = NULL;
#line 1153 "../src/server.vala"
	_tmp29_ = self->priv->documentation;
#line 1153 "../src/server.vala"
	_tmp30_ = vls_gir_documentation_find_gir_symbol (_tmp29_, sym);
#line 1153 "../src/server.vala"
	gir_sym = _tmp30_;
#line 1154 "../src/server.vala"
	_tmp32_ = gir_sym;
#line 1154 "../src/server.vala"
	if (_tmp32_ != NULL) {
#line 11514 "server.c"
		ValaSymbol* _tmp33_;
		ValaComment* _tmp34_;
		ValaComment* _tmp35_;
#line 1154 "../src/server.vala"
		_tmp33_ = gir_sym;
#line 1154 "../src/server.vala"
		_tmp34_ = vala_symbol_get_comment (_tmp33_);
#line 1154 "../src/server.vala"
		_tmp35_ = _tmp34_;
#line 1154 "../src/server.vala"
		_tmp31_ = _tmp35_ != NULL;
#line 11526 "server.c"
	} else {
#line 1154 "../src/server.vala"
		_tmp31_ = FALSE;
#line 11530 "server.c"
	}
#line 1154 "../src/server.vala"
	if (_tmp31_) {
#line 11534 "server.c"
		ValaSymbol* _tmp36_;
		ValaComment* _tmp37_;
		ValaComment* _tmp38_;
		ValaComment* _tmp39_;
#line 1155 "../src/server.vala"
		_tmp36_ = gir_sym;
#line 1155 "../src/server.vala"
		_tmp37_ = vala_symbol_get_comment (_tmp36_);
#line 1155 "../src/server.vala"
		_tmp38_ = _tmp37_;
#line 1155 "../src/server.vala"
		_tmp39_ = _vala_comment_ref0 (_tmp38_);
#line 1155 "../src/server.vala"
		_vala_comment_unref0 (comment);
#line 1155 "../src/server.vala"
		comment = _tmp39_;
#line 11551 "server.c"
	} else {
		ValaComment* _tmp40_;
		ValaComment* _tmp41_;
		ValaComment* _tmp42_;
#line 1157 "../src/server.vala"
		_tmp40_ = vala_symbol_get_comment (sym);
#line 1157 "../src/server.vala"
		_tmp41_ = _tmp40_;
#line 1157 "../src/server.vala"
		_tmp42_ = _vala_comment_ref0 (_tmp41_);
#line 1157 "../src/server.vala"
		_vala_comment_unref0 (comment);
#line 1157 "../src/server.vala"
		comment = _tmp42_;
#line 11566 "server.c"
	}
#line 1159 "../src/server.vala"
	_tmp43_ = comment;
#line 1159 "../src/server.vala"
	if (_tmp43_ != NULL) {
#line 11572 "server.c"
		{
			gboolean _tmp44_ = FALSE;
			ValaComment* _tmp45_;
#line 1161 "../src/server.vala"
			_tmp45_ = comment;
#line 1161 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_GIR_COMMENT)) {
#line 1161 "../src/server.vala"
				_tmp44_ = TRUE;
#line 11582 "server.c"
			} else {
				gboolean _tmp46_ = FALSE;
				ValaSymbol* _tmp47_;
#line 1161 "../src/server.vala"
				_tmp47_ = gir_sym;
#line 1161 "../src/server.vala"
				if (_tmp47_ != NULL) {
#line 11590 "server.c"
					ValaSymbol* _tmp48_;
					ValaComment* _tmp49_;
					ValaComment* _tmp50_;
					ValaComment* _tmp51_;
#line 1161 "../src/server.vala"
					_tmp48_ = gir_sym;
#line 1161 "../src/server.vala"
					_tmp49_ = vala_symbol_get_comment (_tmp48_);
#line 1161 "../src/server.vala"
					_tmp50_ = _tmp49_;
#line 1161 "../src/server.vala"
					_tmp51_ = comment;
#line 1161 "../src/server.vala"
					_tmp46_ = _tmp50_ == _tmp51_;
#line 11605 "server.c"
				} else {
#line 1161 "../src/server.vala"
					_tmp46_ = FALSE;
#line 11609 "server.c"
				}
#line 1161 "../src/server.vala"
				_tmp44_ = _tmp46_;
#line 11613 "server.c"
			}
#line 1161 "../src/server.vala"
			if (_tmp44_) {
#line 11617 "server.c"
				VlsDocComment* _tmp52_ = NULL;
				ValaComment* _tmp53_;
				VlsGirDocumentation* _tmp54_;
				VlsCompilation* _tmp55_;
				VlsDocComment* _tmp56_;
				VlsDocComment* _tmp57_;
#line 1162 "../src/server.vala"
				_tmp53_ = comment;
#line 1162 "../src/server.vala"
				_tmp54_ = self->priv->documentation;
#line 1162 "../src/server.vala"
				_tmp55_ = compilation;
#line 1162 "../src/server.vala"
				_tmp56_ = vls_doc_comment_new_from_gir_comment (_tmp53_, _tmp54_, _tmp55_, &_inner_error0_);
#line 1162 "../src/server.vala"
				_tmp52_ = _tmp56_;
#line 1162 "../src/server.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1162 "../src/server.vala"
					if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 11638 "server.c"
						goto __catch0_g_regex_error;
					}
#line 1162 "../src/server.vala"
					_vala_code_node_unref0 (gir_sym);
#line 1162 "../src/server.vala"
					_vls_doc_comment_unref0 (doc_comment);
#line 1162 "../src/server.vala"
					_vala_comment_unref0 (comment);
#line 1162 "../src/server.vala"
					_vala_code_node_unref0 (root);
#line 1162 "../src/server.vala"
					_vala_code_node_unref0 (real_sym);
#line 1162 "../src/server.vala"
					_g_object_unref0 (compilation);
#line 1162 "../src/server.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1162 "../src/server.vala"
					g_clear_error (&_inner_error0_);
#line 1162 "../src/server.vala"
					return NULL;
#line 11659 "server.c"
				}
#line 1162 "../src/server.vala"
				_tmp57_ = _tmp52_;
#line 1162 "../src/server.vala"
				_tmp52_ = NULL;
#line 1162 "../src/server.vala"
				_vls_doc_comment_unref0 (doc_comment);
#line 1162 "../src/server.vala"
				doc_comment = _tmp57_;
#line 1161 "../src/server.vala"
				_vls_doc_comment_unref0 (_tmp52_);
#line 11671 "server.c"
			} else {
				VlsDocComment* _tmp58_ = NULL;
				ValaComment* _tmp59_;
				VlsCompilation* _tmp60_;
				VlsDocComment* _tmp61_;
				VlsDocComment* _tmp62_;
#line 1164 "../src/server.vala"
				_tmp59_ = comment;
#line 1164 "../src/server.vala"
				_tmp60_ = compilation;
#line 1164 "../src/server.vala"
				_tmp61_ = vls_doc_comment_new_from_valadoc_comment (_tmp59_, sym, _tmp60_, &_inner_error0_);
#line 1164 "../src/server.vala"
				_tmp58_ = _tmp61_;
#line 1164 "../src/server.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1164 "../src/server.vala"
					if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 11690 "server.c"
						goto __catch0_g_regex_error;
					}
#line 1164 "../src/server.vala"
					_vala_code_node_unref0 (gir_sym);
#line 1164 "../src/server.vala"
					_vls_doc_comment_unref0 (doc_comment);
#line 1164 "../src/server.vala"
					_vala_comment_unref0 (comment);
#line 1164 "../src/server.vala"
					_vala_code_node_unref0 (root);
#line 1164 "../src/server.vala"
					_vala_code_node_unref0 (real_sym);
#line 1164 "../src/server.vala"
					_g_object_unref0 (compilation);
#line 1164 "../src/server.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1164 "../src/server.vala"
					g_clear_error (&_inner_error0_);
#line 1164 "../src/server.vala"
					return NULL;
#line 11711 "server.c"
				}
#line 1164 "../src/server.vala"
				_tmp62_ = _tmp58_;
#line 1164 "../src/server.vala"
				_tmp58_ = NULL;
#line 1164 "../src/server.vala"
				_vls_doc_comment_unref0 (doc_comment);
#line 1164 "../src/server.vala"
				doc_comment = _tmp62_;
#line 1161 "../src/server.vala"
				_vls_doc_comment_unref0 (_tmp58_);
#line 11723 "server.c"
			}
		}
		goto __finally0;
		__catch0_g_regex_error:
		{
			GError* e = NULL;
			GError* _tmp63_;
			const gchar* _tmp64_;
#line 1160 "../src/server.vala"
			e = _inner_error0_;
#line 1160 "../src/server.vala"
			_inner_error0_ = NULL;
#line 1166 "../src/server.vala"
			_tmp63_ = e;
#line 1166 "../src/server.vala"
			_tmp64_ = _tmp63_->message;
#line 1166 "../src/server.vala"
			g_warning ("server.vala:1166: failed to render comment - %s", _tmp64_);
#line 1160 "../src/server.vala"
			_g_error_free0 (e);
#line 11744 "server.c"
		}
		__finally0:
#line 1160 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1160 "../src/server.vala"
			_vala_code_node_unref0 (gir_sym);
#line 1160 "../src/server.vala"
			_vls_doc_comment_unref0 (doc_comment);
#line 1160 "../src/server.vala"
			_vala_comment_unref0 (comment);
#line 1160 "../src/server.vala"
			_vala_code_node_unref0 (root);
#line 1160 "../src/server.vala"
			_vala_code_node_unref0 (real_sym);
#line 1160 "../src/server.vala"
			_g_object_unref0 (compilation);
#line 1160 "../src/server.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1160 "../src/server.vala"
			g_clear_error (&_inner_error0_);
#line 1160 "../src/server.vala"
			return NULL;
#line 11767 "server.c"
		}
	}
#line 1170 "../src/server.vala"
	_tmp66_ = doc_comment;
#line 1170 "../src/server.vala"
	if (_tmp66_ == NULL) {
#line 1170 "../src/server.vala"
		_tmp65_ = G_TYPE_CHECK_INSTANCE_TYPE (sym, VALA_TYPE_PARAMETER);
#line 11776 "server.c"
	} else {
#line 1170 "../src/server.vala"
		_tmp65_ = FALSE;
#line 11780 "server.c"
	}
#line 1170 "../src/server.vala"
	if (_tmp65_) {
#line 11784 "server.c"
		VlsDocComment* parent_doc = NULL;
		ValaSymbol* _tmp67_;
		ValaSymbol* _tmp68_;
		VlsDocComment* _tmp69_;
		VlsDocComment* _tmp70_;
#line 1171 "../src/server.vala"
		_tmp67_ = vala_symbol_get_parent_symbol (sym);
#line 1171 "../src/server.vala"
		_tmp68_ = _tmp67_;
#line 1171 "../src/server.vala"
		_tmp69_ = vls_server_get_symbol_documentation (self, project, _tmp68_);
#line 1171 "../src/server.vala"
		parent_doc = _tmp69_;
#line 1172 "../src/server.vala"
		_tmp70_ = parent_doc;
#line 1172 "../src/server.vala"
		if (_tmp70_ != NULL) {
#line 11802 "server.c"
			gchar* doc = NULL;
			VlsDocComment* _tmp71_;
			GeeHashMap* _tmp72_;
			GeeHashMap* _tmp73_;
			const gchar* _tmp74_;
			const gchar* _tmp75_;
			gpointer _tmp76_;
			const gchar* _tmp77_;
#line 1173 "../src/server.vala"
			_tmp71_ = parent_doc;
#line 1173 "../src/server.vala"
			_tmp72_ = vls_doc_comment_get_parameters (_tmp71_);
#line 1173 "../src/server.vala"
			_tmp73_ = _tmp72_;
#line 1173 "../src/server.vala"
			_tmp74_ = vala_symbol_get_name (sym);
#line 1173 "../src/server.vala"
			_tmp75_ = _tmp74_;
#line 1173 "../src/server.vala"
			_tmp76_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp73_, _tmp75_);
#line 1173 "../src/server.vala"
			doc = (gchar*) _tmp76_;
#line 1174 "../src/server.vala"
			_tmp77_ = doc;
#line 1174 "../src/server.vala"
			if (_tmp77_ != NULL) {
#line 11829 "server.c"
				const gchar* _tmp78_;
				VlsDocComment* _tmp79_;
#line 1175 "../src/server.vala"
				_tmp78_ = doc;
#line 1175 "../src/server.vala"
				_tmp79_ = vls_doc_comment_new (_tmp78_);
#line 1175 "../src/server.vala"
				_vls_doc_comment_unref0 (doc_comment);
#line 1175 "../src/server.vala"
				doc_comment = _tmp79_;
#line 11840 "server.c"
			}
#line 1172 "../src/server.vala"
			_g_free0 (doc);
#line 11844 "server.c"
		}
#line 1170 "../src/server.vala"
		_vls_doc_comment_unref0 (parent_doc);
#line 11848 "server.c"
	}
#line 1179 "../src/server.vala"
	result = doc_comment;
#line 1179 "../src/server.vala"
	_vala_code_node_unref0 (gir_sym);
#line 1179 "../src/server.vala"
	_vala_comment_unref0 (comment);
#line 1179 "../src/server.vala"
	_vala_code_node_unref0 (root);
#line 1179 "../src/server.vala"
	_vala_code_node_unref0 (real_sym);
#line 1179 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1179 "../src/server.vala"
	return result;
#line 11864 "server.c"
}

static void
vls_server_show_completion (VlsServer* self,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params)
{
	LspCompletionParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* file = NULL;
	LspCompletionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	VlsProject* _tmp7_ = NULL;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp9_;
	VlsProject* _tmp15_;
	ValaSourceFile* _tmp16_;
	VlsCompilation* _tmp17_;
	LspCompletionParams* _tmp18_;
	LspPosition* _tmp19_;
	LspPosition* _tmp20_;
	LspCompletionParams* _tmp21_;
	LspCompletionContext* _tmp22_;
	LspCompletionContext* _tmp23_;
#line 1182 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1182 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1182 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1182 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1182 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1183 "../src/server.vala"
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_COMPLETION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1183 "../src/server.vala"
	p = (LspCompletionParams*) _tmp0_;
#line 1187 "../src/server.vala"
	_tmp1_ = p;
#line 1187 "../src/server.vala"
	_tmp2_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp1_);
#line 1187 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 1187 "../src/server.vala"
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
#line 1187 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 1187 "../src/server.vala"
	_tmp8_ = vls_server_find_file (self, _tmp5_, &_tmp6_, &_tmp7_);
#line 1187 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1187 "../src/server.vala"
	compilation = _tmp6_;
#line 1187 "../src/server.vala"
	_g_object_unref0 (project);
#line 1187 "../src/server.vala"
	project = _tmp7_;
#line 1187 "../src/server.vala"
	file = _tmp8_;
#line 1188 "../src/server.vala"
	_tmp9_ = file;
#line 1188 "../src/server.vala"
	if (_tmp9_ == NULL) {
#line 11937 "server.c"
		LspCompletionParams* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 1189 "../src/server.vala"
		_tmp10_ = p;
#line 1189 "../src/server.vala"
		_tmp11_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _tmp10_);
#line 1189 "../src/server.vala"
		_tmp12_ = _tmp11_;
#line 1189 "../src/server.vala"
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
#line 1189 "../src/server.vala"
		_tmp14_ = _tmp13_;
#line 1189 "../src/server.vala"
		g_debug ("server.vala:1189: [%s] file `%s' not found", method, _tmp14_);
#line 1190 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 1191 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 1191 "../src/server.vala"
		_g_object_unref0 (project);
#line 1191 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1191 "../src/server.vala"
		_g_object_unref0 (p);
#line 1191 "../src/server.vala"
		return;
#line 11967 "server.c"
	}
#line 1194 "../src/server.vala"
	_tmp15_ = project;
#line 1194 "../src/server.vala"
	_tmp16_ = file;
#line 1194 "../src/server.vala"
	_tmp17_ = compilation;
#line 1194 "../src/server.vala"
	_tmp18_ = p;
#line 1194 "../src/server.vala"
	_tmp19_ = lsp_text_document_position_params_get_position ((LspTextDocumentPositionParams*) _tmp18_);
#line 1194 "../src/server.vala"
	_tmp20_ = _tmp19_;
#line 1194 "../src/server.vala"
	_tmp21_ = p;
#line 1194 "../src/server.vala"
	_tmp22_ = lsp_completion_params_get_context (_tmp21_);
#line 1194 "../src/server.vala"
	_tmp23_ = _tmp22_;
#line 1194 "../src/server.vala"
	vls_completion_engine_begin_response (self, _tmp15_, client, id, method, _tmp16_, _tmp17_, _tmp20_, _tmp23_);
#line 1182 "../src/server.vala"
	_vala_source_file_unref0 (file);
#line 1182 "../src/server.vala"
	_g_object_unref0 (project);
#line 1182 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1182 "../src/server.vala"
	_g_object_unref0 (p);
#line 11997 "server.c"
}

static void
vls_server_show_signature_help (VlsServer* self,
                                JsonrpcClient* client,
                                const gchar* method,
                                GVariant* id,
                                GVariant* params)
{
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* file = NULL;
	LspTextDocumentPositionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	VlsProject* _tmp7_ = NULL;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp9_;
	VlsProject* _tmp15_;
	ValaSourceFile* _tmp16_;
	VlsCompilation* _tmp17_;
	LspTextDocumentPositionParams* _tmp18_;
	LspPosition* _tmp19_;
	LspPosition* _tmp20_;
#line 1200 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1200 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1200 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1200 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1200 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1201 "../src/server.vala"
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1201 "../src/server.vala"
	p = (LspTextDocumentPositionParams*) _tmp0_;
#line 1205 "../src/server.vala"
	_tmp1_ = p;
#line 1205 "../src/server.vala"
	_tmp2_ = lsp_text_document_position_params_get_textDocument (_tmp1_);
#line 1205 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 1205 "../src/server.vala"
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
#line 1205 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 1205 "../src/server.vala"
	_tmp8_ = vls_server_find_file (self, _tmp5_, &_tmp6_, &_tmp7_);
#line 1205 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1205 "../src/server.vala"
	compilation = _tmp6_;
#line 1205 "../src/server.vala"
	_g_object_unref0 (project);
#line 1205 "../src/server.vala"
	project = _tmp7_;
#line 1205 "../src/server.vala"
	file = _tmp8_;
#line 1206 "../src/server.vala"
	_tmp9_ = file;
#line 1206 "../src/server.vala"
	if (_tmp9_ == NULL) {
#line 12067 "server.c"
		LspTextDocumentPositionParams* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 1207 "../src/server.vala"
		_tmp10_ = p;
#line 1207 "../src/server.vala"
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_tmp10_);
#line 1207 "../src/server.vala"
		_tmp12_ = _tmp11_;
#line 1207 "../src/server.vala"
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
#line 1207 "../src/server.vala"
		_tmp14_ = _tmp13_;
#line 1207 "../src/server.vala"
		g_debug ("server.vala:1207: [%s] file `%s' not found", method, _tmp14_);
#line 1208 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 1209 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 1209 "../src/server.vala"
		_g_object_unref0 (project);
#line 1209 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1209 "../src/server.vala"
		_g_object_unref0 (p);
#line 1209 "../src/server.vala"
		return;
#line 12097 "server.c"
	}
#line 1212 "../src/server.vala"
	_tmp15_ = project;
#line 1212 "../src/server.vala"
	_tmp16_ = file;
#line 1212 "../src/server.vala"
	_tmp17_ = compilation;
#line 1212 "../src/server.vala"
	_tmp18_ = p;
#line 1212 "../src/server.vala"
	_tmp19_ = lsp_text_document_position_params_get_position (_tmp18_);
#line 1212 "../src/server.vala"
	_tmp20_ = _tmp19_;
#line 1212 "../src/server.vala"
	vls_signature_help_engine_begin_response (self, _tmp15_, client, id, method, _tmp16_, _tmp17_, _tmp20_);
#line 1200 "../src/server.vala"
	_vala_source_file_unref0 (file);
#line 1200 "../src/server.vala"
	_g_object_unref0 (project);
#line 1200 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1200 "../src/server.vala"
	_g_object_unref0 (p);
#line 12121 "server.c"
}

static Block33Data*
block33_data_ref (Block33Data* _data33_)
{
#line 1218 "../src/server.vala"
	g_atomic_int_inc (&_data33_->_ref_count_);
#line 1218 "../src/server.vala"
	return _data33_;
#line 12131 "server.c"
}

static void
block33_data_unref (void * _userdata_)
{
	Block33Data* _data33_;
	_data33_ = (Block33Data*) _userdata_;
#line 1218 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data33_->_ref_count_)) {
#line 12141 "server.c"
		VlsServer* self;
#line 1218 "../src/server.vala"
		self = _data33_->self;
#line 1218 "../src/server.vala"
		_g_object_unref0 (_data33_->p);
#line 1218 "../src/server.vala"
		_g_object_unref0 (_data33_->client);
#line 1218 "../src/server.vala"
		_g_free0 (_data33_->method);
#line 1218 "../src/server.vala"
		_g_variant_unref0 (_data33_->id);
#line 1218 "../src/server.vala"
		_g_object_unref0 (self);
#line 1218 "../src/server.vala"
		g_slice_free (Block33Data, _data33_);
#line 12157 "server.c"
	}
}

static gpointer
_vala_scope_ref0 (gpointer self)
{
#line 1247 "../src/server.vala"
	return self ? vala_scope_ref (self) : NULL;
#line 12166 "server.c"
}

static gpointer
_vala_iterable_ref0 (gpointer self)
{
#line 1273 "../src/server.vala"
	return self ? vala_iterable_ref (self) : NULL;
#line 12174 "server.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1240 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1241 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1241 "glib-2.0.vapi"
	result = _tmp0_;
#line 1241 "glib-2.0.vapi"
	return result;
#line 12191 "server.c"
}

static void
__lambda65_ (Block33Data* _data33_,
             gboolean request_cancelled)
{
	VlsServer* self;
	LspPosition* pos = NULL;
	LspPosition* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentIdentifier* _tmp3_;
	LspTextDocumentIdentifier* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspPosition* _tmp19_;
	VlsNodeSearch* _tmp20_;
	VlsNodeSearch* _tmp21_;
	GeeList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	ValaScope* scope = NULL;
	ValaSourceFile* _tmp25_;
	LspPosition* _tmp26_;
	VlsFindScope* _tmp27_;
	VlsFindScope* _tmp28_;
	ValaSymbol* _tmp29_;
	ValaSymbol* _tmp30_;
	ValaScope* _tmp31_;
	ValaScope* _tmp32_;
	ValaScope* _tmp33_;
	ValaScope* _tmp34_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp35_;
	ValaSourceFile* _tmp36_;
	ValaCodeNode* _tmp37_;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	ValaCodeNode* _tmp40_;
	ValaDataType* data_type = NULL;
	ValaList* method_type_arguments = NULL;
	ValaSymbol* symbol = NULL;
	ValaCodeNode* _tmp45_;
	gboolean _tmp112_ = FALSE;
	gboolean _tmp113_ = FALSE;
	gboolean _tmp114_ = FALSE;
	ValaSymbol* _tmp115_;
	LspHover* hoverInfo = NULL;
	LspHover* _tmp132_;
	LspRange* symbol_range = NULL;
	ValaSymbol* _tmp133_;
	LspRange* _tmp162_;
	gchar* representation = NULL;
	ValaDataType* _tmp169_;
	ValaSymbol* _tmp170_;
	ValaScope* _tmp171_;
	ValaList* _tmp172_;
	gchar* _tmp173_;
	const gchar* _tmp174_;
	GError* _inner_error0_ = NULL;
#line 1221 "../src/server.vala"
	self = _data33_->self;
#line 1222 "../src/server.vala"
	if (request_cancelled) {
#line 1223 "../src/server.vala"
		vls_server_reply_null (_data33_->id, _data33_->client, "textDocument/hover");
#line 1224 "../src/server.vala"
		return;
#line 12272 "server.c"
	}
#line 1227 "../src/server.vala"
	_tmp0_ = lsp_text_document_position_params_get_position (_data33_->p);
#line 1227 "../src/server.vala"
	_tmp1_ = _tmp0_;
#line 1227 "../src/server.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1227 "../src/server.vala"
	pos = _tmp2_;
#line 1230 "../src/server.vala"
	_tmp3_ = lsp_text_document_position_params_get_textDocument (_data33_->p);
#line 1230 "../src/server.vala"
	_tmp4_ = _tmp3_;
#line 1230 "../src/server.vala"
	_tmp5_ = lsp_text_document_identifier_get_uri (_tmp4_);
#line 1230 "../src/server.vala"
	_tmp6_ = _tmp5_;
#line 1230 "../src/server.vala"
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
#line 1230 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1230 "../src/server.vala"
	compilation = _tmp7_;
#line 1230 "../src/server.vala"
	_g_object_unref0 (project);
#line 1230 "../src/server.vala"
	project = _tmp8_;
#line 1230 "../src/server.vala"
	doc = _tmp9_;
#line 1231 "../src/server.vala"
	_tmp10_ = doc;
#line 1231 "../src/server.vala"
	if (_tmp10_ == NULL) {
#line 12306 "server.c"
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 1232 "../src/server.vala"
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_data33_->p);
#line 1232 "../src/server.vala"
		_tmp12_ = _tmp11_;
#line 1232 "../src/server.vala"
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
#line 1232 "../src/server.vala"
		_tmp14_ = _tmp13_;
#line 1232 "../src/server.vala"
		g_debug ("server.vala:1232: [%s] file `%s' not found", _data33_->method, _tmp14_);
#line 1233 "../src/server.vala"
		vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
#line 1234 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1234 "../src/server.vala"
		_g_object_unref0 (project);
#line 1234 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1234 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1234 "../src/server.vala"
		return;
#line 12333 "server.c"
	}
#line 1237 "../src/server.vala"
	_tmp15_ = compilation;
#line 1237 "../src/server.vala"
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
#line 1237 "../src/server.vala"
	_tmp17_ = _tmp16_;
#line 1237 "../src/server.vala"
	vala_code_context_push (_tmp17_);
#line 1239 "../src/server.vala"
	_tmp18_ = doc;
#line 1239 "../src/server.vala"
	_tmp19_ = pos;
#line 1239 "../src/server.vala"
	_tmp20_ = vls_node_search_new (_tmp18_, _tmp19_, TRUE, NULL, TRUE);
#line 1239 "../src/server.vala"
	fs = _tmp20_;
#line 1241 "../src/server.vala"
	_tmp21_ = fs;
#line 1241 "../src/server.vala"
	_tmp22_ = _tmp21_->result;
#line 1241 "../src/server.vala"
	_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
#line 1241 "../src/server.vala"
	_tmp24_ = _tmp23_;
#line 1241 "../src/server.vala"
	if (_tmp24_ == 0) {
#line 1242 "../src/server.vala"
		vls_server_reply_null (_data33_->id, _data33_->client, _data33_->method);
#line 1243 "../src/server.vala"
		vala_code_context_pop ();
#line 1244 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1244 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1244 "../src/server.vala"
		_g_object_unref0 (project);
#line 1244 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1244 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1244 "../src/server.vala"
		return;
#line 12377 "server.c"
	}
#line 1247 "../src/server.vala"
	_tmp25_ = doc;
#line 1247 "../src/server.vala"
	_tmp26_ = pos;
#line 1247 "../src/server.vala"
	_tmp27_ = vls_find_scope_new (_tmp25_, _tmp26_, TRUE);
#line 1247 "../src/server.vala"
	_tmp28_ = _tmp27_;
#line 1247 "../src/server.vala"
	_tmp29_ = vls_find_scope_get_best_block (_tmp28_);
#line 1247 "../src/server.vala"
	_tmp30_ = _tmp29_;
#line 1247 "../src/server.vala"
	_tmp31_ = vala_symbol_get_scope (_tmp30_);
#line 1247 "../src/server.vala"
	_tmp32_ = _tmp31_;
#line 1247 "../src/server.vala"
	_tmp33_ = _vala_scope_ref0 (_tmp32_);
#line 1247 "../src/server.vala"
	_tmp34_ = _tmp33_;
#line 1247 "../src/server.vala"
	_vala_code_visitor_unref0 (_tmp28_);
#line 1247 "../src/server.vala"
	scope = _tmp34_;
#line 1248 "../src/server.vala"
	_tmp35_ = fs;
#line 1248 "../src/server.vala"
	_tmp36_ = doc;
#line 1248 "../src/server.vala"
	_tmp37_ = vls_server_get_best (_tmp35_, _tmp36_);
#line 1248 "../src/server.vala"
	_result_ = _tmp37_;
#line 1251 "../src/server.vala"
	_tmp40_ = _result_;
#line 1251 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, VALA_TYPE_METHOD)) {
#line 12415 "server.c"
		ValaCodeNode* _tmp41_;
		gboolean _tmp42_;
		gboolean _tmp43_;
#line 1251 "../src/server.vala"
		_tmp41_ = _result_;
#line 1251 "../src/server.vala"
		_tmp42_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_METHOD, ValaMethod));
#line 1251 "../src/server.vala"
		_tmp43_ = _tmp42_;
#line 1251 "../src/server.vala"
		_tmp39_ = _tmp43_;
#line 12427 "server.c"
	} else {
#line 1251 "../src/server.vala"
		_tmp39_ = FALSE;
#line 12431 "server.c"
	}
#line 1251 "../src/server.vala"
	if (_tmp39_) {
#line 1251 "../src/server.vala"
		_tmp38_ = TRUE;
#line 12437 "server.c"
	} else {
		ValaCodeNode* _tmp44_;
#line 1252 "../src/server.vala"
		_tmp44_ = _result_;
#line 1252 "../src/server.vala"
		_tmp38_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_PROPERTY_ACCESSOR);
#line 12444 "server.c"
	}
#line 1251 "../src/server.vala"
	if (_tmp38_) {
#line 1253 "../src/server.vala"
		vls_server_reply_null (_data33_->id, _data33_->client, "textDocument/hover");
#line 1254 "../src/server.vala"
		vala_code_context_pop ();
#line 1255 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1255 "../src/server.vala"
		_vala_scope_unref0 (scope);
#line 1255 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1255 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1255 "../src/server.vala"
		_g_object_unref0 (project);
#line 1255 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1255 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1255 "../src/server.vala"
		return;
#line 12468 "server.c"
	}
#line 1259 "../src/server.vala"
	data_type = NULL;
#line 1260 "../src/server.vala"
	method_type_arguments = NULL;
#line 1261 "../src/server.vala"
	symbol = NULL;
#line 1263 "../src/server.vala"
	_tmp45_ = _result_;
#line 1263 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_EXPRESSION)) {
#line 12480 "server.c"
		ValaExpression* expr = NULL;
		ValaCodeNode* _tmp46_;
		ValaExpression* _tmp47_;
		ValaExpression* _tmp48_;
		ValaSymbol* _tmp49_;
		ValaSymbol* _tmp50_;
		ValaSymbol* _tmp51_;
		ValaExpression* _tmp52_;
		ValaDataType* _tmp53_;
		ValaDataType* _tmp54_;
		ValaDataType* _tmp55_;
		gboolean _tmp56_ = FALSE;
		ValaSymbol* _tmp57_;
		ValaExpression* _tmp79_;
		ValaCodeNode* _tmp80_;
		ValaCodeNode* _tmp81_;
		gboolean _tmp88_ = FALSE;
		gboolean _tmp89_ = FALSE;
		ValaSymbol* _tmp90_;
#line 1264 "../src/server.vala"
		_tmp46_ = _result_;
#line 1264 "../src/server.vala"
		_tmp47_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 1264 "../src/server.vala"
		expr = _tmp47_;
#line 1265 "../src/server.vala"
		_tmp48_ = expr;
#line 1265 "../src/server.vala"
		_tmp49_ = vala_expression_get_symbol_reference (_tmp48_);
#line 1265 "../src/server.vala"
		_tmp50_ = _tmp49_;
#line 1265 "../src/server.vala"
		_tmp51_ = _vala_code_node_ref0 (_tmp50_);
#line 1265 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1265 "../src/server.vala"
		symbol = _tmp51_;
#line 1266 "../src/server.vala"
		_tmp52_ = expr;
#line 1266 "../src/server.vala"
		_tmp53_ = vala_expression_get_value_type (_tmp52_);
#line 1266 "../src/server.vala"
		_tmp54_ = _tmp53_;
#line 1266 "../src/server.vala"
		_tmp55_ = _vala_code_node_ref0 (_tmp54_);
#line 1266 "../src/server.vala"
		_vala_code_node_unref0 (data_type);
#line 1266 "../src/server.vala"
		data_type = _tmp55_;
#line 1267 "../src/server.vala"
		_tmp57_ = symbol;
#line 1267 "../src/server.vala"
		if (_tmp57_ != NULL) {
#line 12534 "server.c"
			ValaExpression* _tmp58_;
#line 1267 "../src/server.vala"
			_tmp58_ = expr;
#line 1267 "../src/server.vala"
			_tmp56_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp58_, VALA_TYPE_MEMBER_ACCESS);
#line 12540 "server.c"
		} else {
#line 1267 "../src/server.vala"
			_tmp56_ = FALSE;
#line 12544 "server.c"
		}
#line 1267 "../src/server.vala"
		if (_tmp56_) {
#line 12548 "server.c"
			ValaMemberAccess* ma = NULL;
			ValaExpression* _tmp59_;
			ValaMemberAccess* _tmp60_;
			gboolean _tmp61_ = FALSE;
			ValaMemberAccess* _tmp62_;
			ValaExpression* _tmp63_;
			ValaExpression* _tmp64_;
			ValaMemberAccess* _tmp76_;
			ValaList* _tmp77_;
			ValaList* _tmp78_;
#line 1268 "../src/server.vala"
			_tmp59_ = expr;
#line 1268 "../src/server.vala"
			_tmp60_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, VALA_TYPE_MEMBER_ACCESS, ValaMemberAccess));
#line 1268 "../src/server.vala"
			ma = _tmp60_;
#line 1269 "../src/server.vala"
			_tmp62_ = ma;
#line 1269 "../src/server.vala"
			_tmp63_ = vala_member_access_get_inner (_tmp62_);
#line 1269 "../src/server.vala"
			_tmp64_ = _tmp63_;
#line 1269 "../src/server.vala"
			if (_tmp64_ != NULL) {
#line 12573 "server.c"
				ValaMemberAccess* _tmp65_;
				ValaExpression* _tmp66_;
				ValaExpression* _tmp67_;
				ValaDataType* _tmp68_;
				ValaDataType* _tmp69_;
#line 1269 "../src/server.vala"
				_tmp65_ = ma;
#line 1269 "../src/server.vala"
				_tmp66_ = vala_member_access_get_inner (_tmp65_);
#line 1269 "../src/server.vala"
				_tmp67_ = _tmp66_;
#line 1269 "../src/server.vala"
				_tmp68_ = vala_expression_get_value_type (_tmp67_);
#line 1269 "../src/server.vala"
				_tmp69_ = _tmp68_;
#line 1269 "../src/server.vala"
				_tmp61_ = _tmp69_ != NULL;
#line 12591 "server.c"
			} else {
#line 1269 "../src/server.vala"
				_tmp61_ = FALSE;
#line 12595 "server.c"
			}
#line 1269 "../src/server.vala"
			if (_tmp61_) {
#line 12599 "server.c"
				ValaMemberAccess* _tmp70_;
				ValaExpression* _tmp71_;
				ValaExpression* _tmp72_;
				ValaDataType* _tmp73_;
				ValaDataType* _tmp74_;
				ValaDataType* _tmp75_;
#line 1271 "../src/server.vala"
				_tmp70_ = ma;
#line 1271 "../src/server.vala"
				_tmp71_ = vala_member_access_get_inner (_tmp70_);
#line 1271 "../src/server.vala"
				_tmp72_ = _tmp71_;
#line 1271 "../src/server.vala"
				_tmp73_ = vala_expression_get_value_type (_tmp72_);
#line 1271 "../src/server.vala"
				_tmp74_ = _tmp73_;
#line 1271 "../src/server.vala"
				_tmp75_ = _vala_code_node_ref0 (_tmp74_);
#line 1271 "../src/server.vala"
				_vala_code_node_unref0 (data_type);
#line 1271 "../src/server.vala"
				data_type = _tmp75_;
#line 12622 "server.c"
			}
#line 1273 "../src/server.vala"
			_tmp76_ = ma;
#line 1273 "../src/server.vala"
			_tmp77_ = vala_member_access_get_type_arguments (_tmp76_);
#line 1273 "../src/server.vala"
			_tmp78_ = _vala_iterable_ref0 (_tmp77_);
#line 1273 "../src/server.vala"
			_vala_iterable_unref0 (method_type_arguments);
#line 1273 "../src/server.vala"
			method_type_arguments = _tmp78_;
#line 1267 "../src/server.vala"
			_vala_code_node_unref0 (ma);
#line 12636 "server.c"
		}
#line 1276 "../src/server.vala"
		_tmp79_ = expr;
#line 1276 "../src/server.vala"
		_tmp80_ = vala_code_node_get_parent_node ((ValaCodeNode*) _tmp79_);
#line 1276 "../src/server.vala"
		_tmp81_ = _tmp80_;
#line 1276 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp81_, VALA_TYPE_OBJECT_CREATION_EXPRESSION)) {
#line 12646 "server.c"
			ValaExpression* _tmp82_;
			ValaCodeNode* _tmp83_;
			ValaCodeNode* _tmp84_;
			ValaDataType* _tmp85_;
			ValaDataType* _tmp86_;
			ValaDataType* _tmp87_;
#line 1277 "../src/server.vala"
			_tmp82_ = expr;
#line 1277 "../src/server.vala"
			_tmp83_ = vala_code_node_get_parent_node ((ValaCodeNode*) _tmp82_);
#line 1277 "../src/server.vala"
			_tmp84_ = _tmp83_;
#line 1277 "../src/server.vala"
			_tmp85_ = vala_expression_get_value_type ((ValaExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp84_, VALA_TYPE_OBJECT_CREATION_EXPRESSION, ValaObjectCreationExpression));
#line 1277 "../src/server.vala"
			_tmp86_ = _tmp85_;
#line 1277 "../src/server.vala"
			_tmp87_ = _vala_code_node_ref0 (_tmp86_);
#line 1277 "../src/server.vala"
			_vala_code_node_unref0 (data_type);
#line 1277 "../src/server.vala"
			data_type = _tmp87_;
#line 12669 "server.c"
		}
#line 1282 "../src/server.vala"
		_tmp90_ = symbol;
#line 1282 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp90_, VALA_TYPE_VARIABLE)) {
#line 12675 "server.c"
			ValaDataType* _tmp91_;
#line 1282 "../src/server.vala"
			_tmp91_ = data_type;
#line 1282 "../src/server.vala"
			_tmp89_ = _tmp91_ != NULL;
#line 12681 "server.c"
		} else {
#line 1282 "../src/server.vala"
			_tmp89_ = FALSE;
#line 12685 "server.c"
		}
#line 1282 "../src/server.vala"
		if (_tmp89_) {
#line 12689 "server.c"
			ValaDataType* _tmp92_;
			ValaSymbol* _tmp93_;
			ValaDataType* _tmp94_;
			ValaDataType* _tmp95_;
#line 1282 "../src/server.vala"
			_tmp92_ = data_type;
#line 1282 "../src/server.vala"
			_tmp93_ = symbol;
#line 1282 "../src/server.vala"
			_tmp94_ = vala_variable_get_variable_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp93_, VALA_TYPE_VARIABLE, ValaVariable));
#line 1282 "../src/server.vala"
			_tmp95_ = _tmp94_;
#line 1282 "../src/server.vala"
			_tmp88_ = vala_data_type_equals (_tmp92_, _tmp95_);
#line 12704 "server.c"
		} else {
#line 1282 "../src/server.vala"
			_tmp88_ = FALSE;
#line 12708 "server.c"
		}
#line 1282 "../src/server.vala"
		if (_tmp88_) {
#line 1283 "../src/server.vala"
			_vala_code_node_unref0 (data_type);
#line 1283 "../src/server.vala"
			data_type = NULL;
#line 12716 "server.c"
		}
#line 1263 "../src/server.vala"
		_vala_code_node_unref0 (expr);
#line 12720 "server.c"
	} else {
		ValaCodeNode* _tmp96_;
#line 1284 "../src/server.vala"
		_tmp96_ = _result_;
#line 1284 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp96_, VALA_TYPE_SYMBOL)) {
#line 12727 "server.c"
			ValaCodeNode* _tmp97_;
			ValaSymbol* _tmp98_;
#line 1285 "../src/server.vala"
			_tmp97_ = _result_;
#line 1285 "../src/server.vala"
			_tmp98_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, VALA_TYPE_SYMBOL, ValaSymbol));
#line 1285 "../src/server.vala"
			_vala_code_node_unref0 (symbol);
#line 1285 "../src/server.vala"
			symbol = _tmp98_;
#line 12738 "server.c"
		} else {
			ValaCodeNode* _tmp99_;
#line 1286 "../src/server.vala"
			_tmp99_ = _result_;
#line 1286 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp99_, VALA_TYPE_DATA_TYPE)) {
#line 12745 "server.c"
				ValaCodeNode* _tmp100_;
				ValaDataType* _tmp101_;
				ValaDataType* _tmp102_;
				ValaSymbol* _tmp103_;
#line 1287 "../src/server.vala"
				_tmp100_ = _result_;
#line 1287 "../src/server.vala"
				_tmp101_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp100_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 1287 "../src/server.vala"
				_vala_code_node_unref0 (data_type);
#line 1287 "../src/server.vala"
				data_type = _tmp101_;
#line 1288 "../src/server.vala"
				_tmp102_ = data_type;
#line 1288 "../src/server.vala"
				_tmp103_ = vls_symbol_references_get_symbol_data_type_refers_to (_tmp102_);
#line 1288 "../src/server.vala"
				_vala_code_node_unref0 (symbol);
#line 1288 "../src/server.vala"
				symbol = _tmp103_;
#line 12766 "server.c"
			} else {
				ValaCodeNode* _tmp104_;
#line 1289 "../src/server.vala"
				_tmp104_ = _result_;
#line 1289 "../src/server.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp104_, VALA_TYPE_USING_DIRECTIVE)) {
#line 12773 "server.c"
					ValaCodeNode* _tmp105_;
					ValaSymbol* _tmp106_;
					ValaSymbol* _tmp107_;
					ValaSymbol* _tmp108_;
#line 1290 "../src/server.vala"
					_tmp105_ = _result_;
#line 1290 "../src/server.vala"
					_tmp106_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
#line 1290 "../src/server.vala"
					_tmp107_ = _tmp106_;
#line 1290 "../src/server.vala"
					_tmp108_ = _vala_code_node_ref0 (_tmp107_);
#line 1290 "../src/server.vala"
					_vala_code_node_unref0 (symbol);
#line 1290 "../src/server.vala"
					symbol = _tmp108_;
#line 12790 "server.c"
				} else {
					ValaCodeNode* _tmp109_;
					const gchar* _tmp110_;
					const gchar* _tmp111_;
#line 1292 "../src/server.vala"
					_tmp109_ = _result_;
#line 1292 "../src/server.vala"
					_tmp110_ = vala_code_node_get_type_name (_tmp109_);
#line 1292 "../src/server.vala"
					_tmp111_ = _tmp110_;
#line 1292 "../src/server.vala"
					g_warning ("server.vala:1292: result as %s not matched", _tmp111_);
#line 12803 "server.c"
				}
			}
		}
	}
#line 1296 "../src/server.vala"
	_tmp115_ = symbol;
#line 1296 "../src/server.vala"
	if (_tmp115_ != NULL) {
#line 12812 "server.c"
		ValaSymbol* _tmp116_;
		const gchar* _tmp117_;
		const gchar* _tmp118_;
#line 1296 "../src/server.vala"
		_tmp116_ = symbol;
#line 1296 "../src/server.vala"
		_tmp117_ = vala_symbol_get_name (_tmp116_);
#line 1296 "../src/server.vala"
		_tmp118_ = _tmp117_;
#line 1296 "../src/server.vala"
		_tmp114_ = _tmp118_ != NULL;
#line 12824 "server.c"
	} else {
#line 1296 "../src/server.vala"
		_tmp114_ = FALSE;
#line 12828 "server.c"
	}
#line 1296 "../src/server.vala"
	if (_tmp114_) {
#line 12832 "server.c"
		ValaSymbol* _tmp119_;
		const gchar* _tmp120_;
		const gchar* _tmp121_;
#line 1296 "../src/server.vala"
		_tmp119_ = symbol;
#line 1296 "../src/server.vala"
		_tmp120_ = vala_symbol_get_name (_tmp119_);
#line 1296 "../src/server.vala"
		_tmp121_ = _tmp120_;
#line 1296 "../src/server.vala"
		_tmp113_ = string_get (_tmp121_, (glong) 0) == '.';
#line 12844 "server.c"
	} else {
#line 1296 "../src/server.vala"
		_tmp113_ = FALSE;
#line 12848 "server.c"
	}
#line 1296 "../src/server.vala"
	if (_tmp113_) {
#line 12852 "server.c"
		ValaSymbol* _tmp122_;
		const gchar* _tmp123_;
		const gchar* _tmp124_;
#line 1296 "../src/server.vala"
		_tmp122_ = symbol;
#line 1296 "../src/server.vala"
		_tmp123_ = vala_symbol_get_name (_tmp122_);
#line 1296 "../src/server.vala"
		_tmp124_ = _tmp123_;
#line 1296 "../src/server.vala"
		_tmp112_ = g_ascii_isdigit (string_get (_tmp124_, (glong) 1));
#line 12864 "server.c"
	} else {
#line 1296 "../src/server.vala"
		_tmp112_ = FALSE;
#line 12868 "server.c"
	}
#line 1296 "../src/server.vala"
	if (_tmp112_) {
#line 12872 "server.c"
		gboolean _tmp125_ = FALSE;
		ValaSymbol* _tmp126_;
#line 1297 "../src/server.vala"
		_tmp126_ = symbol;
#line 1297 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp126_, VALA_TYPE_VARIABLE)) {
#line 12879 "server.c"
			ValaDataType* _tmp127_;
#line 1297 "../src/server.vala"
			_tmp127_ = data_type;
#line 1297 "../src/server.vala"
			_tmp125_ = _tmp127_ == NULL;
#line 12885 "server.c"
		} else {
#line 1297 "../src/server.vala"
			_tmp125_ = FALSE;
#line 12889 "server.c"
		}
#line 1297 "../src/server.vala"
		if (_tmp125_) {
#line 12893 "server.c"
			ValaSymbol* _tmp128_;
			ValaDataType* _tmp129_;
			ValaDataType* _tmp130_;
			ValaDataType* _tmp131_;
#line 1298 "../src/server.vala"
			_tmp128_ = symbol;
#line 1298 "../src/server.vala"
			_tmp129_ = vala_variable_get_variable_type (G_TYPE_CHECK_INSTANCE_CAST (_tmp128_, VALA_TYPE_VARIABLE, ValaVariable));
#line 1298 "../src/server.vala"
			_tmp130_ = _tmp129_;
#line 1298 "../src/server.vala"
			_tmp131_ = _vala_code_node_ref0 (_tmp130_);
#line 1298 "../src/server.vala"
			_vala_code_node_unref0 (data_type);
#line 1298 "../src/server.vala"
			data_type = _tmp131_;
#line 12910 "server.c"
		}
#line 1299 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1299 "../src/server.vala"
		symbol = NULL;
#line 12916 "server.c"
	}
#line 1306 "../src/server.vala"
	_tmp132_ = lsp_hover_new ();
#line 1306 "../src/server.vala"
	if (_tmp132_) {
#line 1306 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp132_, "vala-creation-function", "Vls.Server.hover._lambda65_");
#line 12924 "server.c"
	}
#line 1306 "../src/server.vala"
	hoverInfo = _tmp132_;
#line 1308 "../src/server.vala"
	symbol_range = NULL;
#line 1309 "../src/server.vala"
	_tmp133_ = symbol;
#line 1309 "../src/server.vala"
	if (_tmp133_ != NULL) {
#line 12934 "server.c"
		ValaCodeNode* _tmp134_;
		ValaSymbol* _tmp135_;
		LspRange* _tmp136_;
		LspRange* _tmp137_;
#line 1310 "../src/server.vala"
		_tmp134_ = _result_;
#line 1310 "../src/server.vala"
		_tmp135_ = symbol;
#line 1310 "../src/server.vala"
		_tmp136_ = vls_symbol_references_get_replacement_range (_tmp134_, _tmp135_);
#line 1310 "../src/server.vala"
		_g_object_unref0 (symbol_range);
#line 1310 "../src/server.vala"
		symbol_range = _tmp136_;
#line 1311 "../src/server.vala"
		_tmp137_ = symbol_range;
#line 1311 "../src/server.vala"
		if (_tmp137_ != NULL) {
#line 12953 "server.c"
			gboolean found_component = FALSE;
			LspRange* _tmp138_;
			LspPosition* _tmp139_;
#line 1314 "../src/server.vala"
			found_component = FALSE;
#line 1315 "../src/server.vala"
			_tmp138_ = symbol_range;
#line 1315 "../src/server.vala"
			_tmp139_ = pos;
#line 1315 "../src/server.vala"
			if (!lsp_range_contains (_tmp138_, _tmp139_)) {
#line 12965 "server.c"
				{
					GeeIterator* _component_it = NULL;
					ValaCodeNode* _tmp140_;
					GeeCollection* _tmp141_;
					GeeCollection* _tmp142_;
					GeeIterator* _tmp143_;
					GeeIterator* _tmp144_;
#line 1316 "../src/server.vala"
					_tmp140_ = _result_;
#line 1316 "../src/server.vala"
					_tmp141_ = vls_symbol_references_get_visible_components_of_code_node (_tmp140_);
#line 1316 "../src/server.vala"
					_tmp142_ = _tmp141_;
#line 1316 "../src/server.vala"
					_tmp143_ = gee_iterable_iterator ((GeeIterable*) _tmp142_);
#line 1316 "../src/server.vala"
					_tmp144_ = _tmp143_;
#line 1316 "../src/server.vala"
					_g_object_unref0 (_tmp142_);
#line 1316 "../src/server.vala"
					_component_it = _tmp144_;
#line 1316 "../src/server.vala"
					while (TRUE) {
#line 12989 "server.c"
						GeeIterator* _tmp145_;
						VlsPair* component = NULL;
						GeeIterator* _tmp146_;
						gpointer _tmp147_;
						VlsPair* _tmp148_;
						gconstpointer _tmp149_;
						gconstpointer _tmp150_;
						LspPosition* _tmp151_;
#line 1316 "../src/server.vala"
						_tmp145_ = _component_it;
#line 1316 "../src/server.vala"
						if (!gee_iterator_next (_tmp145_)) {
#line 1316 "../src/server.vala"
							break;
#line 13004 "server.c"
						}
#line 1316 "../src/server.vala"
						_tmp146_ = _component_it;
#line 1316 "../src/server.vala"
						_tmp147_ = gee_iterator_get (_tmp146_);
#line 1316 "../src/server.vala"
						component = (VlsPair*) _tmp147_;
#line 1317 "../src/server.vala"
						_tmp148_ = component;
#line 1317 "../src/server.vala"
						_tmp149_ = vls_pair_get_second (_tmp148_);
#line 1317 "../src/server.vala"
						_tmp150_ = _tmp149_;
#line 1317 "../src/server.vala"
						_tmp151_ = pos;
#line 1317 "../src/server.vala"
						if (lsp_range_contains ((LspRange*) _tmp150_, _tmp151_)) {
#line 13022 "server.c"
							LspHover* _tmp152_;
							VlsPair* _tmp153_;
							gconstpointer _tmp154_;
							gconstpointer _tmp155_;
							VlsPair* _tmp156_;
							gconstpointer _tmp157_;
							gconstpointer _tmp158_;
							ValaSymbol* _tmp159_;
#line 1318 "../src/server.vala"
							_tmp152_ = hoverInfo;
#line 1318 "../src/server.vala"
							_tmp153_ = component;
#line 1318 "../src/server.vala"
							_tmp154_ = vls_pair_get_second (_tmp153_);
#line 1318 "../src/server.vala"
							_tmp155_ = _tmp154_;
#line 1318 "../src/server.vala"
							lsp_hover_set_range (_tmp152_, (LspRange*) _tmp155_);
#line 1319 "../src/server.vala"
							_tmp156_ = component;
#line 1319 "../src/server.vala"
							_tmp157_ = vls_pair_get_first (_tmp156_);
#line 1319 "../src/server.vala"
							_tmp158_ = _tmp157_;
#line 1319 "../src/server.vala"
							_tmp159_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp158_);
#line 1319 "../src/server.vala"
							_vala_code_node_unref0 (symbol);
#line 1319 "../src/server.vala"
							symbol = _tmp159_;
#line 1320 "../src/server.vala"
							_vala_code_node_unref0 (data_type);
#line 1320 "../src/server.vala"
							data_type = NULL;
#line 1321 "../src/server.vala"
							_vala_iterable_unref0 (method_type_arguments);
#line 1321 "../src/server.vala"
							method_type_arguments = NULL;
#line 1322 "../src/server.vala"
							found_component = TRUE;
#line 1323 "../src/server.vala"
							_g_object_unref0 (component);
#line 1323 "../src/server.vala"
							break;
#line 13067 "server.c"
						}
#line 1316 "../src/server.vala"
						_g_object_unref0 (component);
#line 13071 "server.c"
					}
#line 1316 "../src/server.vala"
					_g_object_unref0 (_component_it);
#line 13075 "server.c"
				}
			}
#line 1327 "../src/server.vala"
			if (!found_component) {
#line 13080 "server.c"
				LspHover* _tmp160_;
				LspRange* _tmp161_;
#line 1328 "../src/server.vala"
				_tmp160_ = hoverInfo;
#line 1328 "../src/server.vala"
				_tmp161_ = symbol_range;
#line 1328 "../src/server.vala"
				lsp_hover_set_range (_tmp160_, _tmp161_);
#line 13089 "server.c"
			}
		}
	}
#line 1332 "../src/server.vala"
	_tmp162_ = symbol_range;
#line 1332 "../src/server.vala"
	if (_tmp162_ == NULL) {
#line 13097 "server.c"
		LspHover* _tmp163_;
		ValaCodeNode* _tmp164_;
		ValaSourceReference* _tmp165_;
		ValaSourceReference* _tmp166_;
		LspRange* _tmp167_;
		LspRange* _tmp168_;
#line 1333 "../src/server.vala"
		_tmp163_ = hoverInfo;
#line 1333 "../src/server.vala"
		_tmp164_ = _result_;
#line 1333 "../src/server.vala"
		_tmp165_ = vala_code_node_get_source_reference (_tmp164_);
#line 1333 "../src/server.vala"
		_tmp166_ = _tmp165_;
#line 1333 "../src/server.vala"
		_tmp167_ = lsp_range_new_from_sourceref (_tmp166_);
#line 1333 "../src/server.vala"
		if (_tmp167_) {
#line 1333 "../src/server.vala"
			g_object_set_data ((GObject *) _tmp167_, "vala-creation-function", "Vls.Server.hover._lambda65_");
#line 13118 "server.c"
		}
#line 1333 "../src/server.vala"
		_tmp168_ = _tmp167_;
#line 1333 "../src/server.vala"
		lsp_hover_set_range (_tmp163_, _tmp168_);
#line 1333 "../src/server.vala"
		_g_object_unref0 (_tmp168_);
#line 13126 "server.c"
	}
#line 1335 "../src/server.vala"
	_tmp169_ = data_type;
#line 1335 "../src/server.vala"
	_tmp170_ = symbol;
#line 1335 "../src/server.vala"
	_tmp171_ = scope;
#line 1335 "../src/server.vala"
	_tmp172_ = method_type_arguments;
#line 1335 "../src/server.vala"
	_tmp173_ = vls_code_help_get_symbol_representation (_tmp169_, _tmp170_, _tmp171_, TRUE, _tmp172_, NULL, TRUE, FALSE, NULL, TRUE);
#line 1335 "../src/server.vala"
	representation = _tmp173_;
#line 1336 "../src/server.vala"
	_tmp174_ = representation;
#line 1336 "../src/server.vala"
	if (_tmp174_ != NULL) {
#line 13144 "server.c"
		LspHover* _tmp175_;
		GeeList* _tmp176_;
		GeeList* _tmp177_;
		gchar* _tmp178_;
		const gchar* _tmp179_;
		gchar* _tmp180_;
		LspMarkedString* _tmp181_ = NULL;
		LspMarkedString* _tmp182_;
		ValaSymbol* _tmp183_;
#line 1337 "../src/server.vala"
		_tmp175_ = hoverInfo;
#line 1337 "../src/server.vala"
		_tmp176_ = lsp_hover_get_contents (_tmp175_);
#line 1337 "../src/server.vala"
		_tmp177_ = _tmp176_;
#line 1337 "../src/server.vala"
		_tmp178_ = g_strdup ("vala");
#line 1337 "../src/server.vala"
		_tmp179_ = representation;
#line 1337 "../src/server.vala"
		_tmp180_ = g_strdup (_tmp179_);
#line 1337 "../src/server.vala"
		_tmp181_ = lsp_marked_string_new ();
#line 1337 "../src/server.vala"
		lsp_marked_string_set_language (_tmp181_, _tmp178_);
#line 1337 "../src/server.vala"
		_g_free0 (_tmp178_);
#line 1337 "../src/server.vala"
		lsp_marked_string_set_value (_tmp181_, _tmp180_);
#line 1337 "../src/server.vala"
		_g_free0 (_tmp180_);
#line 1337 "../src/server.vala"
		_tmp182_ = _tmp181_;
#line 1337 "../src/server.vala"
		gee_collection_add ((GeeCollection*) _tmp177_, _tmp182_);
#line 1337 "../src/server.vala"
		_g_object_unref0 (_tmp182_);
#line 1342 "../src/server.vala"
		_tmp183_ = symbol;
#line 1342 "../src/server.vala"
		if (_tmp183_ != NULL) {
#line 13186 "server.c"
			VlsDocComment* comment = NULL;
			VlsProject* _tmp184_;
			ValaSymbol* _tmp185_;
			VlsDocComment* _tmp186_;
			VlsDocComment* _tmp187_;
#line 1343 "../src/server.vala"
			_tmp184_ = project;
#line 1343 "../src/server.vala"
			_tmp185_ = symbol;
#line 1343 "../src/server.vala"
			_tmp186_ = vls_server_get_symbol_documentation (self, _tmp184_, _tmp185_);
#line 1343 "../src/server.vala"
			comment = _tmp186_;
#line 1344 "../src/server.vala"
			_tmp187_ = comment;
#line 1344 "../src/server.vala"
			if (_tmp187_ != NULL) {
#line 13204 "server.c"
				LspHover* _tmp188_;
				GeeList* _tmp189_;
				GeeList* _tmp190_;
				VlsDocComment* _tmp191_;
				const gchar* _tmp192_;
				const gchar* _tmp193_;
				gchar* _tmp194_;
				LspMarkedString* _tmp195_ = NULL;
				LspMarkedString* _tmp196_;
#line 1345 "../src/server.vala"
				_tmp188_ = hoverInfo;
#line 1345 "../src/server.vala"
				_tmp189_ = lsp_hover_get_contents (_tmp188_);
#line 1345 "../src/server.vala"
				_tmp190_ = _tmp189_;
#line 1345 "../src/server.vala"
				_tmp191_ = comment;
#line 1345 "../src/server.vala"
				_tmp192_ = vls_doc_comment_get_body (_tmp191_);
#line 1345 "../src/server.vala"
				_tmp193_ = _tmp192_;
#line 1345 "../src/server.vala"
				_tmp194_ = g_strdup (_tmp193_);
#line 1345 "../src/server.vala"
				_tmp195_ = lsp_marked_string_new ();
#line 1345 "../src/server.vala"
				lsp_marked_string_set_value (_tmp195_, _tmp194_);
#line 1345 "../src/server.vala"
				_g_free0 (_tmp194_);
#line 1345 "../src/server.vala"
				_tmp196_ = _tmp195_;
#line 1345 "../src/server.vala"
				gee_collection_add ((GeeCollection*) _tmp190_, _tmp196_);
#line 1345 "../src/server.vala"
				_g_object_unref0 (_tmp196_);
#line 13240 "server.c"
			}
#line 1342 "../src/server.vala"
			_vls_doc_comment_unref0 (comment);
#line 13244 "server.c"
		}
	}
	{
		GVariant* _tmp197_ = NULL;
		LspHover* _tmp198_;
		GVariant* _tmp199_;
		GCancellable* _tmp200_;
#line 1370 "../src/server.vala"
		_tmp198_ = hoverInfo;
#line 1370 "../src/server.vala"
		_tmp199_ = vls_util_object_to_variant ((GObject*) _tmp198_, &_inner_error0_);
#line 1370 "../src/server.vala"
		_tmp197_ = _tmp199_;
#line 1370 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 13260 "server.c"
			goto __catch0_g_error;
		}
#line 1370 "../src/server.vala"
		_tmp200_ = vls_server_cancellable;
#line 1370 "../src/server.vala"
		jsonrpc_client_reply (_data33_->client, _data33_->id, _tmp197_, _tmp200_, &_inner_error0_);
#line 1370 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1370 "../src/server.vala"
			_g_variant_unref0 (_tmp197_);
#line 13271 "server.c"
			goto __catch0_g_error;
		}
#line 1369 "../src/server.vala"
		_g_variant_unref0 (_tmp197_);
#line 13276 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp201_;
		const gchar* _tmp202_;
#line 1369 "../src/server.vala"
		e = _inner_error0_;
#line 1369 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1372 "../src/server.vala"
		_tmp201_ = e;
#line 1372 "../src/server.vala"
		_tmp202_ = _tmp201_->message;
#line 1372 "../src/server.vala"
		g_warning ("server.vala:1372: [%s] failed to reply to client: %s", _data33_->method, _tmp202_);
#line 1369 "../src/server.vala"
		_g_error_free0 (e);
#line 13296 "server.c"
	}
	__finally0:
#line 1369 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1369 "../src/server.vala"
		_g_free0 (representation);
#line 1369 "../src/server.vala"
		_g_object_unref0 (symbol_range);
#line 1369 "../src/server.vala"
		_g_object_unref0 (hoverInfo);
#line 1369 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1369 "../src/server.vala"
		_vala_iterable_unref0 (method_type_arguments);
#line 1369 "../src/server.vala"
		_vala_code_node_unref0 (data_type);
#line 1369 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1369 "../src/server.vala"
		_vala_scope_unref0 (scope);
#line 1369 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1369 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1369 "../src/server.vala"
		_g_object_unref0 (project);
#line 1369 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1369 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1369 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1369 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1369 "../src/server.vala"
		return;
#line 13333 "server.c"
	}
#line 1375 "../src/server.vala"
	vala_code_context_pop ();
#line 1221 "../src/server.vala"
	_g_free0 (representation);
#line 1221 "../src/server.vala"
	_g_object_unref0 (symbol_range);
#line 1221 "../src/server.vala"
	_g_object_unref0 (hoverInfo);
#line 1221 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 1221 "../src/server.vala"
	_vala_iterable_unref0 (method_type_arguments);
#line 1221 "../src/server.vala"
	_vala_code_node_unref0 (data_type);
#line 1221 "../src/server.vala"
	_vala_code_node_unref0 (_result_);
#line 1221 "../src/server.vala"
	_vala_scope_unref0 (scope);
#line 1221 "../src/server.vala"
	_vala_code_visitor_unref0 (fs);
#line 1221 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 1221 "../src/server.vala"
	_g_object_unref0 (project);
#line 1221 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1221 "../src/server.vala"
	_g_object_unref0 (pos);
#line 13363 "server.c"
}

static void
___lambda65__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
#line 1221 "../src/server.vala"
	__lambda65_ (self, request_cancelled);
#line 13372 "server.c"
}

static void
vls_server_hover (VlsServer* self,
                  JsonrpcClient* client,
                  const gchar* method,
                  GVariant* id,
                  GVariant* params)
{
	Block33Data* _data33_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
#line 1218 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1218 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1218 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1218 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1218 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1218 "../src/server.vala"
	_data33_ = g_slice_new0 (Block33Data);
#line 1218 "../src/server.vala"
	_data33_->_ref_count_ = 1;
#line 1218 "../src/server.vala"
	_data33_->self = g_object_ref (self);
#line 1218 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 1218 "../src/server.vala"
	_g_object_unref0 (_data33_->client);
#line 1218 "../src/server.vala"
	_data33_->client = _tmp0_;
#line 1218 "../src/server.vala"
	_tmp1_ = g_strdup (method);
#line 1218 "../src/server.vala"
	_g_free0 (_data33_->method);
#line 1218 "../src/server.vala"
	_data33_->method = _tmp1_;
#line 1218 "../src/server.vala"
	_tmp2_ = _g_variant_ref0 (id);
#line 1218 "../src/server.vala"
	_g_variant_unref0 (_data33_->id);
#line 1218 "../src/server.vala"
	_data33_->id = _tmp2_;
#line 1219 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1219 "../src/server.vala"
	_data33_->p = (LspTextDocumentPositionParams*) _tmp3_;
#line 1221 "../src/server.vala"
	vls_server_wait_for_context_update (self, _data33_->id, ___lambda65__vls_server_on_context_updated_func, block33_data_ref (_data33_), block33_data_unref);
#line 1218 "../src/server.vala"
	block33_data_unref (_data33_);
#line 1218 "../src/server.vala"
	_data33_ = NULL;
#line 13431 "server.c"
}

static LspDocumentHighlightKind
vls_server_determine_node_highlight_kind (VlsServer* self,
                                          ValaCodeNode* node)
{
	ValaCodeNode* previous_node = NULL;
	ValaCodeNode* _tmp0_;
	LspDocumentHighlightKind result;
#line 1379 "../src/server.vala"
	g_return_val_if_fail (self != NULL, LSP_DOCUMENT_HIGHLIGHT_KIND_Text);
#line 1379 "../src/server.vala"
	g_return_val_if_fail (node != NULL, LSP_DOCUMENT_HIGHLIGHT_KIND_Text);
#line 1380 "../src/server.vala"
	_tmp0_ = _vala_code_node_ref0 (node);
#line 1380 "../src/server.vala"
	previous_node = _tmp0_;
#line 13449 "server.c"
	{
		ValaCodeNode* current_node = NULL;
		ValaCodeNode* _tmp1_;
		ValaCodeNode* _tmp2_;
		ValaCodeNode* _tmp3_;
#line 1382 "../src/server.vala"
		_tmp1_ = vala_code_node_get_parent_node (node);
#line 1382 "../src/server.vala"
		_tmp2_ = _tmp1_;
#line 1382 "../src/server.vala"
		_tmp3_ = _vala_code_node_ref0 (_tmp2_);
#line 1382 "../src/server.vala"
		current_node = _tmp3_;
#line 13463 "server.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1382 "../src/server.vala"
			_tmp4_ = TRUE;
#line 1382 "../src/server.vala"
			while (TRUE) {
#line 13470 "server.c"
				ValaCodeNode* _tmp11_;
				ValaCodeNode* _tmp12_;
#line 1382 "../src/server.vala"
				if (!_tmp4_) {
#line 13475 "server.c"
					ValaCodeNode* _tmp5_;
					ValaCodeNode* _tmp6_;
					ValaCodeNode* _tmp7_;
					ValaCodeNode* _tmp8_;
					ValaCodeNode* _tmp9_;
					ValaCodeNode* _tmp10_;
#line 1384 "../src/server.vala"
					_tmp5_ = current_node;
#line 1384 "../src/server.vala"
					_tmp6_ = vala_code_node_get_parent_node (_tmp5_);
#line 1384 "../src/server.vala"
					_tmp7_ = _tmp6_;
#line 1384 "../src/server.vala"
					_tmp8_ = _vala_code_node_ref0 (_tmp7_);
#line 1384 "../src/server.vala"
					_vala_code_node_unref0 (current_node);
#line 1384 "../src/server.vala"
					current_node = _tmp8_;
#line 1385 "../src/server.vala"
					_tmp9_ = current_node;
#line 1385 "../src/server.vala"
					_tmp10_ = _vala_code_node_ref0 (_tmp9_);
#line 1385 "../src/server.vala"
					_vala_code_node_unref0 (previous_node);
#line 1385 "../src/server.vala"
					previous_node = _tmp10_;
#line 13502 "server.c"
				}
#line 1382 "../src/server.vala"
				_tmp4_ = FALSE;
#line 1383 "../src/server.vala"
				_tmp11_ = current_node;
#line 1383 "../src/server.vala"
				if (!(_tmp11_ != NULL)) {
#line 1383 "../src/server.vala"
					break;
#line 13512 "server.c"
				}
#line 1386 "../src/server.vala"
				_tmp12_ = current_node;
#line 1386 "../src/server.vala"
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, VALA_TYPE_METHOD_CALL)) {
#line 1387 "../src/server.vala"
					result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
#line 1387 "../src/server.vala"
					_vala_code_node_unref0 (current_node);
#line 1387 "../src/server.vala"
					_vala_code_node_unref0 (previous_node);
#line 1387 "../src/server.vala"
					return result;
#line 13526 "server.c"
				} else {
					ValaCodeNode* _tmp13_;
#line 1388 "../src/server.vala"
					_tmp13_ = current_node;
#line 1388 "../src/server.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, VALA_TYPE_ASSIGNMENT)) {
#line 13533 "server.c"
						ValaCodeNode* _tmp14_;
						ValaCodeNode* _tmp15_;
						ValaExpression* _tmp16_;
						ValaExpression* _tmp17_;
#line 1389 "../src/server.vala"
						_tmp14_ = previous_node;
#line 1389 "../src/server.vala"
						_tmp15_ = current_node;
#line 1389 "../src/server.vala"
						_tmp16_ = vala_assignment_get_left (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, VALA_TYPE_ASSIGNMENT, ValaAssignment));
#line 1389 "../src/server.vala"
						_tmp17_ = _tmp16_;
#line 1389 "../src/server.vala"
						if (_tmp14_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, VALA_TYPE_CODE_NODE, ValaCodeNode)) {
#line 1390 "../src/server.vala"
							result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
#line 1390 "../src/server.vala"
							_vala_code_node_unref0 (current_node);
#line 1390 "../src/server.vala"
							_vala_code_node_unref0 (previous_node);
#line 1390 "../src/server.vala"
							return result;
#line 13556 "server.c"
						} else {
							ValaCodeNode* _tmp18_;
							ValaCodeNode* _tmp19_;
							ValaExpression* _tmp20_;
							ValaExpression* _tmp21_;
#line 1391 "../src/server.vala"
							_tmp18_ = previous_node;
#line 1391 "../src/server.vala"
							_tmp19_ = current_node;
#line 1391 "../src/server.vala"
							_tmp20_ = vala_assignment_get_right (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, VALA_TYPE_ASSIGNMENT, ValaAssignment));
#line 1391 "../src/server.vala"
							_tmp21_ = _tmp20_;
#line 1391 "../src/server.vala"
							if (_tmp18_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, VALA_TYPE_CODE_NODE, ValaCodeNode)) {
#line 1392 "../src/server.vala"
								result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
#line 1392 "../src/server.vala"
								_vala_code_node_unref0 (current_node);
#line 1392 "../src/server.vala"
								_vala_code_node_unref0 (previous_node);
#line 1392 "../src/server.vala"
								return result;
#line 13580 "server.c"
							}
						}
					} else {
						gboolean _tmp22_ = FALSE;
						ValaCodeNode* _tmp23_;
#line 1393 "../src/server.vala"
						_tmp23_ = current_node;
#line 1393 "../src/server.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, VALA_TYPE_DECLARATION_STATEMENT)) {
#line 13590 "server.c"
							ValaCodeNode* _tmp24_;
							ValaSymbol* _tmp25_;
							ValaSymbol* _tmp26_;
#line 1394 "../src/server.vala"
							_tmp24_ = current_node;
#line 1394 "../src/server.vala"
							_tmp25_ = vala_declaration_statement_get_declaration (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, VALA_TYPE_DECLARATION_STATEMENT, ValaDeclarationStatement));
#line 1394 "../src/server.vala"
							_tmp26_ = _tmp25_;
#line 1394 "../src/server.vala"
							_tmp22_ = node == G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, VALA_TYPE_CODE_NODE, ValaCodeNode);
#line 13602 "server.c"
						} else {
#line 1393 "../src/server.vala"
							_tmp22_ = FALSE;
#line 13606 "server.c"
						}
#line 1393 "../src/server.vala"
						if (_tmp22_) {
#line 1395 "../src/server.vala"
							result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
#line 1395 "../src/server.vala"
							_vala_code_node_unref0 (current_node);
#line 1395 "../src/server.vala"
							_vala_code_node_unref0 (previous_node);
#line 1395 "../src/server.vala"
							return result;
#line 13618 "server.c"
						} else {
							gboolean _tmp27_ = FALSE;
							ValaCodeNode* _tmp28_;
#line 1396 "../src/server.vala"
							_tmp28_ = current_node;
#line 1396 "../src/server.vala"
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, VALA_TYPE_FOREACH_STATEMENT)) {
#line 13626 "server.c"
								ValaCodeNode* _tmp29_;
								ValaLocalVariable* _tmp30_;
								ValaLocalVariable* _tmp31_;
#line 1397 "../src/server.vala"
								_tmp29_ = current_node;
#line 1397 "../src/server.vala"
								_tmp30_ = vala_foreach_statement_get_element_variable (G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
#line 1397 "../src/server.vala"
								_tmp31_ = _tmp30_;
#line 1397 "../src/server.vala"
								_tmp27_ = node == G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, VALA_TYPE_CODE_NODE, ValaCodeNode);
#line 13638 "server.c"
							} else {
#line 1396 "../src/server.vala"
								_tmp27_ = FALSE;
#line 13642 "server.c"
							}
#line 1396 "../src/server.vala"
							if (_tmp27_) {
#line 1398 "../src/server.vala"
								result = LSP_DOCUMENT_HIGHLIGHT_KIND_Write;
#line 1398 "../src/server.vala"
								_vala_code_node_unref0 (current_node);
#line 1398 "../src/server.vala"
								_vala_code_node_unref0 (previous_node);
#line 1398 "../src/server.vala"
								return result;
#line 13654 "server.c"
							} else {
								ValaCodeNode* _tmp32_;
#line 1399 "../src/server.vala"
								_tmp32_ = current_node;
#line 1399 "../src/server.vala"
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, VALA_TYPE_STATEMENT)) {
#line 1400 "../src/server.vala"
									result = LSP_DOCUMENT_HIGHLIGHT_KIND_Read;
#line 1400 "../src/server.vala"
									_vala_code_node_unref0 (current_node);
#line 1400 "../src/server.vala"
									_vala_code_node_unref0 (previous_node);
#line 1400 "../src/server.vala"
									return result;
#line 13669 "server.c"
								}
							}
						}
					}
				}
			}
		}
#line 1382 "../src/server.vala"
		_vala_code_node_unref0 (current_node);
#line 13679 "server.c"
	}
#line 1403 "../src/server.vala"
	result = LSP_DOCUMENT_HIGHLIGHT_KIND_Text;
#line 1403 "../src/server.vala"
	_vala_code_node_unref0 (previous_node);
#line 1403 "../src/server.vala"
	return result;
#line 13687 "server.c"
}

static Block34Data*
block34_data_ref (Block34Data* _data34_)
{
#line 1406 "../src/server.vala"
	g_atomic_int_inc (&_data34_->_ref_count_);
#line 1406 "../src/server.vala"
	return _data34_;
#line 13697 "server.c"
}

static void
block34_data_unref (void * _userdata_)
{
	Block34Data* _data34_;
	_data34_ = (Block34Data*) _userdata_;
#line 1406 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data34_->_ref_count_)) {
#line 13707 "server.c"
		VlsServer* self;
#line 1406 "../src/server.vala"
		self = _data34_->self;
#line 1406 "../src/server.vala"
		_g_object_unref0 (_data34_->p);
#line 1406 "../src/server.vala"
		_g_object_unref0 (_data34_->client);
#line 1406 "../src/server.vala"
		_g_free0 (_data34_->method);
#line 1406 "../src/server.vala"
		_g_variant_unref0 (_data34_->id);
#line 1406 "../src/server.vala"
		_g_object_unref0 (self);
#line 1406 "../src/server.vala"
		g_slice_free (Block34Data, _data34_);
#line 13723 "server.c"
	}
}

static void
__lambda66_ (Block34Data* _data34_,
             gboolean request_cancelled)
{
	VlsServer* self;
	gboolean is_highlight = FALSE;
	gboolean _tmp0_ = FALSE;
	LspReferenceParamsReferenceContext* _tmp1_;
	LspReferenceParamsReferenceContext* _tmp2_;
	gboolean include_declaration = FALSE;
	LspPosition* pos = NULL;
	LspPosition* _tmp7_;
	LspPosition* _tmp8_;
	LspPosition* _tmp9_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentIdentifier* _tmp10_;
	LspTextDocumentIdentifier* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	VlsCompilation* _tmp14_ = NULL;
	VlsProject* _tmp15_ = NULL;
	ValaSourceFile* _tmp16_;
	ValaSourceFile* _tmp17_;
	VlsCompilation* _tmp22_;
	ValaCodeContext* _tmp23_;
	ValaCodeContext* _tmp24_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp25_;
	LspPosition* _tmp26_;
	VlsNodeSearch* _tmp27_;
	VlsNodeSearch* _tmp28_;
	GeeList* _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp35_;
	ValaSourceFile* _tmp36_;
	ValaCodeNode* _tmp37_;
	ValaSymbol* symbol = NULL;
	JsonArray* json_array = NULL;
	JsonArray* _tmp38_;
	GeeHashMap* references = NULL;
	GeeHashMap* _tmp39_;
	gboolean _tmp40_ = FALSE;
	ValaCodeNode* _tmp41_;
	gboolean _tmp61_ = FALSE;
	ValaCodeNode* _tmp62_;
	ValaCodeNode* _tmp68_;
	ValaSymbol* _tmp69_;
	const gchar* _tmp70_;
	ValaCodeNode* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	ValaCodeNode* _tmp74_;
	const gchar* _tmp75_;
	const gchar* _tmp76_;
	const gchar* _tmp77_;
	gchar* _tmp78_;
	gchar* _tmp79_;
	gboolean _tmp80_ = FALSE;
	const gchar* _tmp138_;
	GeeHashMap* _tmp139_;
	gint _tmp140_;
	gint _tmp141_;
	gchar* _tmp142_;
	gchar* _tmp143_;
	gchar* _tmp144_;
	gchar* _tmp145_;
	GError* _inner_error0_ = NULL;
#line 1409 "../src/server.vala"
	self = _data34_->self;
#line 1410 "../src/server.vala"
	if (request_cancelled) {
#line 1411 "../src/server.vala"
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
#line 1412 "../src/server.vala"
		return;
#line 13806 "server.c"
	}
#line 1415 "../src/server.vala"
	is_highlight = g_strcmp0 (_data34_->method, "textDocument/documentHighlight") == 0;
#line 1416 "../src/server.vala"
	_tmp1_ = lsp_reference_params_get_context (_data34_->p);
#line 1416 "../src/server.vala"
	_tmp2_ = _tmp1_;
#line 1416 "../src/server.vala"
	if (_tmp2_ != NULL) {
#line 13816 "server.c"
		LspReferenceParamsReferenceContext* _tmp3_;
		LspReferenceParamsReferenceContext* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 1416 "../src/server.vala"
		_tmp3_ = lsp_reference_params_get_context (_data34_->p);
#line 1416 "../src/server.vala"
		_tmp4_ = _tmp3_;
#line 1416 "../src/server.vala"
		_tmp5_ = lsp_reference_params_reference_context_get_includeDeclaration (_tmp4_);
#line 1416 "../src/server.vala"
		_tmp6_ = _tmp5_;
#line 1416 "../src/server.vala"
		_tmp0_ = _tmp6_;
#line 13831 "server.c"
	} else {
#line 1416 "../src/server.vala"
		_tmp0_ = TRUE;
#line 13835 "server.c"
	}
#line 1416 "../src/server.vala"
	include_declaration = _tmp0_;
#line 1417 "../src/server.vala"
	_tmp7_ = lsp_text_document_position_params_get_position ((LspTextDocumentPositionParams*) _data34_->p);
#line 1417 "../src/server.vala"
	_tmp8_ = _tmp7_;
#line 1417 "../src/server.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1417 "../src/server.vala"
	pos = _tmp9_;
#line 1421 "../src/server.vala"
	_tmp10_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _data34_->p);
#line 1421 "../src/server.vala"
	_tmp11_ = _tmp10_;
#line 1421 "../src/server.vala"
	_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
#line 1421 "../src/server.vala"
	_tmp13_ = _tmp12_;
#line 1421 "../src/server.vala"
	_tmp16_ = vls_server_find_file (self, _tmp13_, &_tmp14_, &_tmp15_);
#line 1421 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1421 "../src/server.vala"
	compilation = _tmp14_;
#line 1421 "../src/server.vala"
	_g_object_unref0 (project);
#line 1421 "../src/server.vala"
	project = _tmp15_;
#line 1421 "../src/server.vala"
	doc = _tmp16_;
#line 1422 "../src/server.vala"
	_tmp17_ = doc;
#line 1422 "../src/server.vala"
	if (_tmp17_ == NULL) {
#line 13871 "server.c"
		LspTextDocumentIdentifier* _tmp18_;
		LspTextDocumentIdentifier* _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
#line 1423 "../src/server.vala"
		_tmp18_ = lsp_text_document_position_params_get_textDocument ((LspTextDocumentPositionParams*) _data34_->p);
#line 1423 "../src/server.vala"
		_tmp19_ = _tmp18_;
#line 1423 "../src/server.vala"
		_tmp20_ = lsp_text_document_identifier_get_uri (_tmp19_);
#line 1423 "../src/server.vala"
		_tmp21_ = _tmp20_;
#line 1423 "../src/server.vala"
		g_debug ("server.vala:1423: [%s] file `%s' not found", _data34_->method, _tmp21_);
#line 1424 "../src/server.vala"
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
#line 1425 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1425 "../src/server.vala"
		_g_object_unref0 (project);
#line 1425 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1425 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1425 "../src/server.vala"
		return;
#line 13898 "server.c"
	}
#line 1428 "../src/server.vala"
	_tmp22_ = compilation;
#line 1428 "../src/server.vala"
	_tmp23_ = vls_compilation_get_code_context (_tmp22_);
#line 1428 "../src/server.vala"
	_tmp24_ = _tmp23_;
#line 1428 "../src/server.vala"
	vala_code_context_push (_tmp24_);
#line 1430 "../src/server.vala"
	_tmp25_ = doc;
#line 1430 "../src/server.vala"
	_tmp26_ = pos;
#line 1430 "../src/server.vala"
	_tmp27_ = vls_node_search_new (_tmp25_, _tmp26_, TRUE, NULL, TRUE);
#line 1430 "../src/server.vala"
	fs = _tmp27_;
#line 1432 "../src/server.vala"
	_tmp28_ = fs;
#line 1432 "../src/server.vala"
	_tmp29_ = _tmp28_->result;
#line 1432 "../src/server.vala"
	_tmp30_ = gee_collection_get_size ((GeeCollection*) _tmp29_);
#line 1432 "../src/server.vala"
	_tmp31_ = _tmp30_;
#line 1432 "../src/server.vala"
	if (_tmp31_ == 0) {
#line 13926 "server.c"
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
#line 1433 "../src/server.vala"
		_tmp32_ = string_to_string (_data34_->method);
#line 1433 "../src/server.vala"
		_tmp33_ = g_strconcat ("[", _tmp32_, "] no results found", NULL);
#line 1433 "../src/server.vala"
		_tmp34_ = _tmp33_;
#line 1433 "../src/server.vala"
		g_debug ("server.vala:1433: %s", _tmp34_);
#line 1433 "../src/server.vala"
		_g_free0 (_tmp34_);
#line 1434 "../src/server.vala"
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
#line 1435 "../src/server.vala"
		vala_code_context_pop ();
#line 1436 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1436 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1436 "../src/server.vala"
		_g_object_unref0 (project);
#line 1436 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1436 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1436 "../src/server.vala"
		return;
#line 13956 "server.c"
	}
#line 1439 "../src/server.vala"
	_tmp35_ = fs;
#line 1439 "../src/server.vala"
	_tmp36_ = doc;
#line 1439 "../src/server.vala"
	_tmp37_ = vls_server_get_best (_tmp35_, _tmp36_);
#line 1439 "../src/server.vala"
	_result_ = _tmp37_;
#line 1441 "../src/server.vala"
	_tmp38_ = json_array_new ();
#line 1441 "../src/server.vala"
	json_array = _tmp38_;
#line 1442 "../src/server.vala"
	_tmp39_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1442 "../src/server.vala"
	if (_tmp39_) {
#line 1442 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp39_, "vala-creation-function", "Vls.Server.show_references._lambda66_");
#line 13976 "server.c"
	}
#line 1442 "../src/server.vala"
	references = _tmp39_;
#line 1444 "../src/server.vala"
	_tmp41_ = _result_;
#line 1444 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, VALA_TYPE_EXPRESSION)) {
#line 13984 "server.c"
		ValaCodeNode* _tmp42_;
		ValaSymbol* _tmp43_;
		ValaSymbol* _tmp44_;
#line 1444 "../src/server.vala"
		_tmp42_ = _result_;
#line 1444 "../src/server.vala"
		_tmp43_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 1444 "../src/server.vala"
		_tmp44_ = _tmp43_;
#line 1444 "../src/server.vala"
		_tmp40_ = _tmp44_ != NULL;
#line 13996 "server.c"
	} else {
#line 1444 "../src/server.vala"
		_tmp40_ = FALSE;
#line 14000 "server.c"
	}
#line 1444 "../src/server.vala"
	if (_tmp40_) {
#line 14004 "server.c"
		ValaCodeNode* _tmp45_;
		ValaSymbol* _tmp46_;
		ValaSymbol* _tmp47_;
		ValaCodeNode* _tmp48_;
#line 1445 "../src/server.vala"
		_tmp45_ = _result_;
#line 1445 "../src/server.vala"
		_tmp46_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 1445 "../src/server.vala"
		_tmp47_ = _tmp46_;
#line 1445 "../src/server.vala"
		_tmp48_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp47_);
#line 1445 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1445 "../src/server.vala"
		_result_ = _tmp48_;
#line 14021 "server.c"
	} else {
		ValaCodeNode* _tmp49_;
#line 1446 "../src/server.vala"
		_tmp49_ = _result_;
#line 1446 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp49_, VALA_TYPE_DATA_TYPE)) {
#line 14028 "server.c"
			ValaCodeNode* _tmp50_;
			ValaSymbol* _tmp51_;
#line 1447 "../src/server.vala"
			_tmp50_ = _result_;
#line 1447 "../src/server.vala"
			_tmp51_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 1447 "../src/server.vala"
			_vala_code_node_unref0 (_result_);
#line 1447 "../src/server.vala"
			_result_ = (ValaCodeNode*) _tmp51_;
#line 14039 "server.c"
		} else {
			gboolean _tmp52_ = FALSE;
			ValaCodeNode* _tmp53_;
#line 1448 "../src/server.vala"
			_tmp53_ = _result_;
#line 1448 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_USING_DIRECTIVE)) {
#line 14047 "server.c"
				ValaCodeNode* _tmp54_;
				ValaSymbol* _tmp55_;
				ValaSymbol* _tmp56_;
#line 1448 "../src/server.vala"
				_tmp54_ = _result_;
#line 1448 "../src/server.vala"
				_tmp55_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
#line 1448 "../src/server.vala"
				_tmp56_ = _tmp55_;
#line 1448 "../src/server.vala"
				_tmp52_ = _tmp56_ != NULL;
#line 14059 "server.c"
			} else {
#line 1448 "../src/server.vala"
				_tmp52_ = FALSE;
#line 14063 "server.c"
			}
#line 1448 "../src/server.vala"
			if (_tmp52_) {
#line 14067 "server.c"
				ValaCodeNode* _tmp57_;
				ValaSymbol* _tmp58_;
				ValaSymbol* _tmp59_;
				ValaCodeNode* _tmp60_;
#line 1449 "../src/server.vala"
				_tmp57_ = _result_;
#line 1449 "../src/server.vala"
				_tmp58_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
#line 1449 "../src/server.vala"
				_tmp59_ = _tmp58_;
#line 1449 "../src/server.vala"
				_tmp60_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp59_);
#line 1449 "../src/server.vala"
				_vala_code_node_unref0 (_result_);
#line 1449 "../src/server.vala"
				_result_ = _tmp60_;
#line 14084 "server.c"
			}
		}
	}
#line 1452 "../src/server.vala"
	_tmp62_ = _result_;
#line 1452 "../src/server.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp62_, VALA_TYPE_SYMBOL)) {
#line 1452 "../src/server.vala"
		_tmp61_ = TRUE;
#line 14094 "server.c"
	} else {
		gboolean _tmp63_ = FALSE;
		ValaCodeNode* _tmp64_;
#line 1453 "../src/server.vala"
		_tmp64_ = _result_;
#line 1453 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp64_, VALA_TYPE_METHOD)) {
#line 14102 "server.c"
			ValaCodeNode* _tmp65_;
			gboolean _tmp66_;
			gboolean _tmp67_;
#line 1453 "../src/server.vala"
			_tmp65_ = _result_;
#line 1453 "../src/server.vala"
			_tmp66_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, VALA_TYPE_METHOD, ValaMethod));
#line 1453 "../src/server.vala"
			_tmp67_ = _tmp66_;
#line 1453 "../src/server.vala"
			_tmp63_ = _tmp67_;
#line 14114 "server.c"
		} else {
#line 1453 "../src/server.vala"
			_tmp63_ = FALSE;
#line 14118 "server.c"
		}
#line 1453 "../src/server.vala"
		_tmp61_ = _tmp63_;
#line 14122 "server.c"
	}
#line 1452 "../src/server.vala"
	if (_tmp61_) {
#line 1454 "../src/server.vala"
		vls_server_reply_null (_data34_->id, _data34_->client, _data34_->method);
#line 1455 "../src/server.vala"
		vala_code_context_pop ();
#line 1456 "../src/server.vala"
		_g_object_unref0 (references);
#line 1456 "../src/server.vala"
		_json_array_unref0 (json_array);
#line 1456 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1456 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1456 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1456 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1456 "../src/server.vala"
		_g_object_unref0 (project);
#line 1456 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1456 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1456 "../src/server.vala"
		return;
#line 14150 "server.c"
	}
#line 1459 "../src/server.vala"
	_tmp68_ = _result_;
#line 1459 "../src/server.vala"
	_tmp69_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, VALA_TYPE_SYMBOL, ValaSymbol));
#line 1459 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 1459 "../src/server.vala"
	symbol = _tmp69_;
#line 1461 "../src/server.vala"
	_tmp70_ = string_to_string (_data34_->method);
#line 1461 "../src/server.vala"
	_tmp71_ = _result_;
#line 1461 "../src/server.vala"
	_tmp72_ = vala_code_node_to_string (_tmp71_);
#line 1461 "../src/server.vala"
	_tmp73_ = _tmp72_;
#line 1461 "../src/server.vala"
	_tmp74_ = _result_;
#line 1461 "../src/server.vala"
	_tmp75_ = vala_code_node_get_type_name (_tmp74_);
#line 1461 "../src/server.vala"
	_tmp76_ = _tmp75_;
#line 1461 "../src/server.vala"
	_tmp77_ = string_to_string (_tmp76_);
#line 1461 "../src/server.vala"
	_tmp78_ = g_strconcat ("[", _tmp70_, "] got best: ", _tmp73_, " (", _tmp77_, ")", NULL);
#line 1461 "../src/server.vala"
	_tmp79_ = _tmp78_;
#line 1461 "../src/server.vala"
	g_debug ("server.vala:1461: %s", _tmp79_);
#line 1461 "../src/server.vala"
	_g_free0 (_tmp79_);
#line 1461 "../src/server.vala"
	_g_free0 (_tmp73_);
#line 1462 "../src/server.vala"
	if (is_highlight) {
#line 1462 "../src/server.vala"
		_tmp80_ = TRUE;
#line 14190 "server.c"
	} else {
		ValaSymbol* _tmp81_;
#line 1462 "../src/server.vala"
		_tmp81_ = symbol;
#line 1462 "../src/server.vala"
		_tmp80_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp81_, VALA_TYPE_LOCAL_VARIABLE);
#line 14197 "server.c"
	}
#line 1462 "../src/server.vala"
	if (_tmp80_) {
#line 14201 "server.c"
		ValaSourceFile* _tmp82_;
		ValaSymbol* _tmp83_;
		GeeHashMap* _tmp84_;
#line 1466 "../src/server.vala"
		_tmp82_ = doc;
#line 1466 "../src/server.vala"
		_tmp83_ = symbol;
#line 1466 "../src/server.vala"
		_tmp84_ = references;
#line 1466 "../src/server.vala"
		vls_symbol_references_list_in_file (_tmp82_, _tmp83_, include_declaration, TRUE, _tmp84_);
#line 14213 "server.c"
	} else {
		GeeHashSet* generated_vapis = NULL;
		GeeHashSet* _tmp85_;
		GeeHashSet* shown_files = NULL;
		GeeHashSet* _tmp99_;
#line 1469 "../src/server.vala"
		_tmp85_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
#line 1469 "../src/server.vala"
		if (_tmp85_) {
#line 1469 "../src/server.vala"
			g_object_set_data ((GObject *) _tmp85_, "vala-creation-function", "Vls.Server.show_references._lambda66_");
#line 14225 "server.c"
		}
#line 1469 "../src/server.vala"
		generated_vapis = _tmp85_;
#line 14229 "server.c"
		{
			GeeArrayList* _btarget_list = NULL;
			VlsProject* _tmp86_;
			GeeArrayList* _tmp87_;
			gint _btarget_size = 0;
			GeeArrayList* _tmp88_;
			gint _tmp89_;
			gint _tmp90_;
			gint _btarget_index = 0;
#line 1470 "../src/server.vala"
			_tmp86_ = project;
#line 1470 "../src/server.vala"
			_tmp87_ = vls_project_get_compilations (_tmp86_);
#line 1470 "../src/server.vala"
			_btarget_list = _tmp87_;
#line 1470 "../src/server.vala"
			_tmp88_ = _btarget_list;
#line 1470 "../src/server.vala"
			_tmp89_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp88_);
#line 1470 "../src/server.vala"
			_tmp90_ = _tmp89_;
#line 1470 "../src/server.vala"
			_btarget_size = _tmp90_;
#line 1470 "../src/server.vala"
			_btarget_index = -1;
#line 1470 "../src/server.vala"
			while (TRUE) {
#line 14257 "server.c"
				gint _tmp91_;
				gint _tmp92_;
				VlsCompilation* btarget = NULL;
				GeeArrayList* _tmp93_;
				gpointer _tmp94_;
				GeeHashSet* _tmp95_;
				VlsCompilation* _tmp96_;
				GeeArrayList* _tmp97_;
				GeeArrayList* _tmp98_;
#line 1470 "../src/server.vala"
				_btarget_index = _btarget_index + 1;
#line 1470 "../src/server.vala"
				_tmp91_ = _btarget_index;
#line 1470 "../src/server.vala"
				_tmp92_ = _btarget_size;
#line 1470 "../src/server.vala"
				if (!(_tmp91_ < _tmp92_)) {
#line 1470 "../src/server.vala"
					break;
#line 14277 "server.c"
				}
#line 1470 "../src/server.vala"
				_tmp93_ = _btarget_list;
#line 1470 "../src/server.vala"
				_tmp94_ = gee_abstract_list_get ((GeeAbstractList*) _tmp93_, _btarget_index);
#line 1470 "../src/server.vala"
				btarget = (VlsCompilation*) _tmp94_;
#line 1471 "../src/server.vala"
				_tmp95_ = generated_vapis;
#line 1471 "../src/server.vala"
				_tmp96_ = btarget;
#line 1471 "../src/server.vala"
				_tmp97_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp96_);
#line 1471 "../src/server.vala"
				_tmp98_ = _tmp97_;
#line 1471 "../src/server.vala"
				gee_collection_add_all ((GeeCollection*) _tmp95_, (GeeCollection*) _tmp98_);
#line 1470 "../src/server.vala"
				_g_object_unref0 (btarget);
#line 14297 "server.c"
			}
#line 1470 "../src/server.vala"
			_g_object_unref0 (_btarget_list);
#line 14301 "server.c"
		}
#line 1472 "../src/server.vala"
		_tmp99_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
#line 1472 "../src/server.vala"
		if (_tmp99_) {
#line 1472 "../src/server.vala"
			g_object_set_data ((GObject *) _tmp99_, "vala-creation-function", "Vls.Server.show_references._lambda66_");
#line 14309 "server.c"
		}
#line 1472 "../src/server.vala"
		shown_files = _tmp99_;
#line 14313 "server.c"
		{
			GeeIterator* _btarget_w_sym_it = NULL;
			VlsProject* _tmp100_;
			ValaSymbol* _tmp101_;
			GeeCollection* _tmp102_;
			GeeCollection* _tmp103_;
			GeeIterator* _tmp104_;
			GeeIterator* _tmp105_;
#line 1473 "../src/server.vala"
			_tmp100_ = project;
#line 1473 "../src/server.vala"
			_tmp101_ = symbol;
#line 1473 "../src/server.vala"
			_tmp102_ = vls_symbol_references_get_compilations_using_symbol (_tmp100_, _tmp101_);
#line 1473 "../src/server.vala"
			_tmp103_ = _tmp102_;
#line 1473 "../src/server.vala"
			_tmp104_ = gee_iterable_iterator ((GeeIterable*) _tmp103_);
#line 1473 "../src/server.vala"
			_tmp105_ = _tmp104_;
#line 1473 "../src/server.vala"
			_g_object_unref0 (_tmp103_);
#line 1473 "../src/server.vala"
			_btarget_w_sym_it = _tmp105_;
#line 1473 "../src/server.vala"
			while (TRUE) {
#line 14340 "server.c"
				GeeIterator* _tmp106_;
				VlsPair* btarget_w_sym = NULL;
				GeeIterator* _tmp107_;
				gpointer _tmp108_;
#line 1473 "../src/server.vala"
				_tmp106_ = _btarget_w_sym_it;
#line 1473 "../src/server.vala"
				if (!gee_iterator_next (_tmp106_)) {
#line 1473 "../src/server.vala"
					break;
#line 14351 "server.c"
				}
#line 1473 "../src/server.vala"
				_tmp107_ = _btarget_w_sym_it;
#line 1473 "../src/server.vala"
				_tmp108_ = gee_iterator_get (_tmp107_);
#line 1473 "../src/server.vala"
				btarget_w_sym = (VlsPair*) _tmp108_;
#line 14359 "server.c"
				{
					ValaList* _project_file_list = NULL;
					VlsPair* _tmp109_;
					gconstpointer _tmp110_;
					gconstpointer _tmp111_;
					ValaCodeContext* _tmp112_;
					ValaCodeContext* _tmp113_;
					ValaList* _tmp114_;
					gint _project_file_size = 0;
					ValaList* _tmp115_;
					gint _tmp116_;
					gint _tmp117_;
					gint _project_file_index = 0;
#line 1474 "../src/server.vala"
					_tmp109_ = btarget_w_sym;
#line 1474 "../src/server.vala"
					_tmp110_ = vls_pair_get_first (_tmp109_);
#line 1474 "../src/server.vala"
					_tmp111_ = _tmp110_;
#line 1474 "../src/server.vala"
					_tmp112_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp111_);
#line 1474 "../src/server.vala"
					_tmp113_ = _tmp112_;
#line 1474 "../src/server.vala"
					_tmp114_ = vala_code_context_get_source_files (_tmp113_);
#line 1474 "../src/server.vala"
					_project_file_list = _tmp114_;
#line 1474 "../src/server.vala"
					_tmp115_ = _project_file_list;
#line 1474 "../src/server.vala"
					_tmp116_ = vala_collection_get_size ((ValaCollection*) _tmp115_);
#line 1474 "../src/server.vala"
					_tmp117_ = _tmp116_;
#line 1474 "../src/server.vala"
					_project_file_size = _tmp117_;
#line 1474 "../src/server.vala"
					_project_file_index = -1;
#line 1474 "../src/server.vala"
					while (TRUE) {
#line 14399 "server.c"
						gint _tmp118_;
						gint _tmp119_;
						ValaSourceFile* project_file = NULL;
						ValaList* _tmp120_;
						gpointer _tmp121_;
						GFile* file = NULL;
						ValaSourceFile* _tmp122_;
						const gchar* _tmp123_;
						const gchar* _tmp124_;
						GFile* _tmp125_;
						gboolean _tmp126_ = FALSE;
						GeeHashSet* _tmp127_;
						GFile* _tmp128_;
						ValaSourceFile* _tmp131_;
						VlsPair* _tmp132_;
						gconstpointer _tmp133_;
						gconstpointer _tmp134_;
						GeeHashMap* _tmp135_;
						GeeHashSet* _tmp136_;
						GFile* _tmp137_;
#line 1474 "../src/server.vala"
						_project_file_index = _project_file_index + 1;
#line 1474 "../src/server.vala"
						_tmp118_ = _project_file_index;
#line 1474 "../src/server.vala"
						_tmp119_ = _project_file_size;
#line 1474 "../src/server.vala"
						if (!(_tmp118_ < _tmp119_)) {
#line 1474 "../src/server.vala"
							break;
#line 14430 "server.c"
						}
#line 1474 "../src/server.vala"
						_tmp120_ = _project_file_list;
#line 1474 "../src/server.vala"
						_tmp121_ = vala_list_get (_tmp120_, _project_file_index);
#line 1474 "../src/server.vala"
						project_file = (ValaSourceFile*) _tmp121_;
#line 1476 "../src/server.vala"
						_tmp122_ = project_file;
#line 1476 "../src/server.vala"
						_tmp123_ = vala_source_file_get_filename (_tmp122_);
#line 1476 "../src/server.vala"
						_tmp124_ = _tmp123_;
#line 1476 "../src/server.vala"
						_tmp125_ = g_file_new_for_commandline_arg (_tmp124_);
#line 1476 "../src/server.vala"
						file = _tmp125_;
#line 1477 "../src/server.vala"
						_tmp127_ = generated_vapis;
#line 1477 "../src/server.vala"
						_tmp128_ = file;
#line 1477 "../src/server.vala"
						if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp127_, _tmp128_)) {
#line 1477 "../src/server.vala"
							_tmp126_ = TRUE;
#line 14456 "server.c"
						} else {
							GeeHashSet* _tmp129_;
							GFile* _tmp130_;
#line 1477 "../src/server.vala"
							_tmp129_ = shown_files;
#line 1477 "../src/server.vala"
							_tmp130_ = file;
#line 1477 "../src/server.vala"
							_tmp126_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp129_, _tmp130_);
#line 14466 "server.c"
						}
#line 1477 "../src/server.vala"
						if (_tmp126_) {
#line 1478 "../src/server.vala"
							_g_object_unref0 (file);
#line 1478 "../src/server.vala"
							_vala_source_file_unref0 (project_file);
#line 1478 "../src/server.vala"
							continue;
#line 14476 "server.c"
						}
#line 1479 "../src/server.vala"
						_tmp131_ = project_file;
#line 1479 "../src/server.vala"
						_tmp132_ = btarget_w_sym;
#line 1479 "../src/server.vala"
						_tmp133_ = vls_pair_get_second (_tmp132_);
#line 1479 "../src/server.vala"
						_tmp134_ = _tmp133_;
#line 1479 "../src/server.vala"
						_tmp135_ = references;
#line 1479 "../src/server.vala"
						vls_symbol_references_list_in_file (_tmp131_, (ValaSymbol*) _tmp134_, include_declaration, TRUE, _tmp135_);
#line 1480 "../src/server.vala"
						_tmp136_ = shown_files;
#line 1480 "../src/server.vala"
						_tmp137_ = file;
#line 1480 "../src/server.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp136_, _tmp137_);
#line 1474 "../src/server.vala"
						_g_object_unref0 (file);
#line 1474 "../src/server.vala"
						_vala_source_file_unref0 (project_file);
#line 14500 "server.c"
					}
				}
#line 1473 "../src/server.vala"
				_g_object_unref0 (btarget_w_sym);
#line 14505 "server.c"
			}
#line 1473 "../src/server.vala"
			_g_object_unref0 (_btarget_w_sym_it);
#line 14509 "server.c"
		}
#line 1462 "../src/server.vala"
		_g_object_unref0 (shown_files);
#line 1462 "../src/server.vala"
		_g_object_unref0 (generated_vapis);
#line 14515 "server.c"
	}
#line 1484 "../src/server.vala"
	_tmp138_ = string_to_string (_data34_->method);
#line 1484 "../src/server.vala"
	_tmp139_ = references;
#line 1484 "../src/server.vala"
	_tmp140_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp139_);
#line 1484 "../src/server.vala"
	_tmp141_ = _tmp140_;
#line 1484 "../src/server.vala"
	_tmp142_ = g_strdup_printf ("%i", _tmp141_);
#line 1484 "../src/server.vala"
	_tmp143_ = _tmp142_;
#line 1484 "../src/server.vala"
	_tmp144_ = g_strconcat ("[", _tmp138_, "] found ", _tmp143_, " reference(s)", NULL);
#line 1484 "../src/server.vala"
	_tmp145_ = _tmp144_;
#line 1484 "../src/server.vala"
	g_debug ("server.vala:1484: %s", _tmp145_);
#line 1484 "../src/server.vala"
	_g_free0 (_tmp145_);
#line 1484 "../src/server.vala"
	_g_free0 (_tmp143_);
#line 14539 "server.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp146_;
		GeeIterator* _tmp147_;
#line 1485 "../src/server.vala"
		_tmp146_ = references;
#line 1485 "../src/server.vala"
		_tmp147_ = gee_iterable_iterator ((GeeIterable*) _tmp146_);
#line 1485 "../src/server.vala"
		_entry_it = _tmp147_;
#line 1485 "../src/server.vala"
		while (TRUE) {
#line 14552 "server.c"
			GeeIterator* _tmp148_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp149_;
			gpointer _tmp150_;
#line 1485 "../src/server.vala"
			_tmp148_ = _entry_it;
#line 1485 "../src/server.vala"
			if (!gee_iterator_next (_tmp148_)) {
#line 1485 "../src/server.vala"
				break;
#line 14563 "server.c"
			}
#line 1485 "../src/server.vala"
			_tmp149_ = _entry_it;
#line 1485 "../src/server.vala"
			_tmp150_ = gee_iterator_get (_tmp149_);
#line 1485 "../src/server.vala"
			entry = (GeeMapEntry*) _tmp150_;
#line 1486 "../src/server.vala"
			if (is_highlight) {
#line 14573 "server.c"
				JsonArray* _tmp151_;
				GeeMapEntry* _tmp152_;
				gconstpointer _tmp153_;
				gconstpointer _tmp154_;
				LspRange* _tmp155_;
				GeeMapEntry* _tmp156_;
				gconstpointer _tmp157_;
				gconstpointer _tmp158_;
				LspDocumentHighlight* _tmp159_ = NULL;
				LspDocumentHighlight* _tmp160_;
				JsonNode* _tmp161_;
#line 1487 "../src/server.vala"
				_tmp151_ = json_array;
#line 1487 "../src/server.vala"
				_tmp152_ = entry;
#line 1487 "../src/server.vala"
				_tmp153_ = gee_map_entry_get_key (_tmp152_);
#line 1487 "../src/server.vala"
				_tmp154_ = _tmp153_;
#line 1487 "../src/server.vala"
				_tmp155_ = _g_object_ref0 ((LspRange*) _tmp154_);
#line 1487 "../src/server.vala"
				_tmp156_ = entry;
#line 1487 "../src/server.vala"
				_tmp157_ = gee_map_entry_get_value (_tmp156_);
#line 1487 "../src/server.vala"
				_tmp158_ = _tmp157_;
#line 1487 "../src/server.vala"
				_tmp159_ = lsp_document_highlight_new ();
#line 1487 "../src/server.vala"
				lsp_document_highlight_set_range (_tmp159_, _tmp155_);
#line 1487 "../src/server.vala"
				_g_object_unref0 (_tmp155_);
#line 1487 "../src/server.vala"
				lsp_document_highlight_set_kind (_tmp159_, vls_server_determine_node_highlight_kind (self, (ValaCodeNode*) _tmp158_));
#line 1487 "../src/server.vala"
				_tmp160_ = _tmp159_;
#line 1487 "../src/server.vala"
				_tmp161_ = json_gobject_serialize ((GObject*) _tmp160_);
#line 1487 "../src/server.vala"
				json_array_add_element (_tmp151_, _tmp161_);
#line 1487 "../src/server.vala"
				_g_object_unref0 (_tmp160_);
#line 14617 "server.c"
			} else {
				JsonArray* _tmp162_;
				GeeMapEntry* _tmp163_;
				gconstpointer _tmp164_;
				gconstpointer _tmp165_;
				ValaSourceReference* _tmp166_;
				ValaSourceReference* _tmp167_;
				ValaSourceFile* _tmp168_;
				ValaSourceFile* _tmp169_;
				const gchar* _tmp170_;
				const gchar* _tmp171_;
				GeeMapEntry* _tmp172_;
				gconstpointer _tmp173_;
				gconstpointer _tmp174_;
				LspLocation* _tmp175_;
				LspLocation* _tmp176_;
				JsonNode* _tmp177_;
#line 1492 "../src/server.vala"
				_tmp162_ = json_array;
#line 1492 "../src/server.vala"
				_tmp163_ = entry;
#line 1492 "../src/server.vala"
				_tmp164_ = gee_map_entry_get_value (_tmp163_);
#line 1492 "../src/server.vala"
				_tmp165_ = _tmp164_;
#line 1492 "../src/server.vala"
				_tmp166_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp165_);
#line 1492 "../src/server.vala"
				_tmp167_ = _tmp166_;
#line 1492 "../src/server.vala"
				_tmp168_ = vala_source_reference_get_file (_tmp167_);
#line 1492 "../src/server.vala"
				_tmp169_ = _tmp168_;
#line 1492 "../src/server.vala"
				_tmp170_ = vala_source_file_get_filename (_tmp169_);
#line 1492 "../src/server.vala"
				_tmp171_ = _tmp170_;
#line 1492 "../src/server.vala"
				_tmp172_ = entry;
#line 1492 "../src/server.vala"
				_tmp173_ = gee_map_entry_get_key (_tmp172_);
#line 1492 "../src/server.vala"
				_tmp174_ = _tmp173_;
#line 1492 "../src/server.vala"
				_tmp175_ = lsp_location_new (_tmp171_, (LspRange*) _tmp174_);
#line 1492 "../src/server.vala"
				if (_tmp175_) {
#line 1492 "../src/server.vala"
					g_object_set_data ((GObject *) _tmp175_, "vala-creation-function", "Vls.Server.show_references._lambda66_");
#line 14667 "server.c"
				}
#line 1492 "../src/server.vala"
				_tmp176_ = _tmp175_;
#line 1492 "../src/server.vala"
				_tmp177_ = json_gobject_serialize ((GObject*) _tmp176_);
#line 1492 "../src/server.vala"
				json_array_add_element (_tmp162_, _tmp177_);
#line 1492 "../src/server.vala"
				_g_object_unref0 (_tmp176_);
#line 14677 "server.c"
			}
#line 1485 "../src/server.vala"
			_g_object_unref0 (entry);
#line 14681 "server.c"
		}
#line 1485 "../src/server.vala"
		_g_object_unref0 (_entry_it);
#line 14685 "server.c"
	}
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp178_;
		JsonNode* _tmp179_;
		JsonArray* _tmp180_;
		JsonNode* _tmp181_;
		GVariant* _tmp182_;
		GVariant* _tmp183_;
		GVariant* _tmp184_;
		GCancellable* _tmp185_;
#line 1497 "../src/server.vala"
		_tmp178_ = json_node_alloc ();
#line 1497 "../src/server.vala"
		_tmp179_ = _tmp178_;
#line 1497 "../src/server.vala"
		_tmp180_ = json_array;
#line 1497 "../src/server.vala"
		_tmp181_ = json_node_init_array (_tmp179_, _tmp180_);
#line 1497 "../src/server.vala"
		_tmp182_ = json_gvariant_deserialize (_tmp181_, NULL, &_inner_error0_);
#line 1497 "../src/server.vala"
		if (_tmp182_ != NULL) {
#line 1497 "../src/server.vala"
			g_variant_ref_sink (_tmp182_);
#line 14711 "server.c"
		}
#line 1497 "../src/server.vala"
		_tmp183_ = _tmp182_;
#line 1497 "../src/server.vala"
		__vala_JsonNode_free0 (_tmp179_);
#line 1497 "../src/server.vala"
		variant_array = _tmp183_;
#line 1497 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 14721 "server.c"
			goto __catch0_g_error;
		}
#line 1498 "../src/server.vala"
		_tmp184_ = variant_array;
#line 1498 "../src/server.vala"
		_tmp185_ = vls_server_cancellable;
#line 1498 "../src/server.vala"
		jsonrpc_client_reply (_data34_->client, _data34_->id, _tmp184_, _tmp185_, &_inner_error0_);
#line 1498 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1498 "../src/server.vala"
			_g_variant_unref0 (variant_array);
#line 14734 "server.c"
			goto __catch0_g_error;
		}
#line 1496 "../src/server.vala"
		_g_variant_unref0 (variant_array);
#line 14739 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp186_;
		GError* _tmp187_;
		const gchar* _tmp188_;
		const gchar* _tmp189_;
		gchar* _tmp190_;
		gchar* _tmp191_;
#line 1496 "../src/server.vala"
		e = _inner_error0_;
#line 1496 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1500 "../src/server.vala"
		_tmp186_ = string_to_string (_data34_->method);
#line 1500 "../src/server.vala"
		_tmp187_ = e;
#line 1500 "../src/server.vala"
		_tmp188_ = _tmp187_->message;
#line 1500 "../src/server.vala"
		_tmp189_ = string_to_string (_tmp188_);
#line 1500 "../src/server.vala"
		_tmp190_ = g_strconcat ("[", _tmp186_, "] failed to reply to client: ", _tmp189_, NULL);
#line 1500 "../src/server.vala"
		_tmp191_ = _tmp190_;
#line 1500 "../src/server.vala"
		g_debug ("server.vala:1500: %s", _tmp191_);
#line 1500 "../src/server.vala"
		_g_free0 (_tmp191_);
#line 1496 "../src/server.vala"
		_g_error_free0 (e);
#line 14773 "server.c"
	}
	__finally0:
#line 1496 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1496 "../src/server.vala"
		_g_object_unref0 (references);
#line 1496 "../src/server.vala"
		_json_array_unref0 (json_array);
#line 1496 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1496 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1496 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1496 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1496 "../src/server.vala"
		_g_object_unref0 (project);
#line 1496 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1496 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1496 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1496 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1496 "../src/server.vala"
		return;
#line 14802 "server.c"
	}
#line 1503 "../src/server.vala"
	vala_code_context_pop ();
#line 1409 "../src/server.vala"
	_g_object_unref0 (references);
#line 1409 "../src/server.vala"
	_json_array_unref0 (json_array);
#line 1409 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 1409 "../src/server.vala"
	_vala_code_node_unref0 (_result_);
#line 1409 "../src/server.vala"
	_vala_code_visitor_unref0 (fs);
#line 1409 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 1409 "../src/server.vala"
	_g_object_unref0 (project);
#line 1409 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1409 "../src/server.vala"
	_g_object_unref0 (pos);
#line 14824 "server.c"
}

static void
___lambda66__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
#line 1409 "../src/server.vala"
	__lambda66_ (self, request_cancelled);
#line 14833 "server.c"
}

static void
vls_server_show_references (VlsServer* self,
                            JsonrpcClient* client,
                            const gchar* method,
                            GVariant* id,
                            GVariant* params)
{
	Block34Data* _data34_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
#line 1406 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1406 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1406 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1406 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1406 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1406 "../src/server.vala"
	_data34_ = g_slice_new0 (Block34Data);
#line 1406 "../src/server.vala"
	_data34_->_ref_count_ = 1;
#line 1406 "../src/server.vala"
	_data34_->self = g_object_ref (self);
#line 1406 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 1406 "../src/server.vala"
	_g_object_unref0 (_data34_->client);
#line 1406 "../src/server.vala"
	_data34_->client = _tmp0_;
#line 1406 "../src/server.vala"
	_tmp1_ = g_strdup (method);
#line 1406 "../src/server.vala"
	_g_free0 (_data34_->method);
#line 1406 "../src/server.vala"
	_data34_->method = _tmp1_;
#line 1406 "../src/server.vala"
	_tmp2_ = _g_variant_ref0 (id);
#line 1406 "../src/server.vala"
	_g_variant_unref0 (_data34_->id);
#line 1406 "../src/server.vala"
	_data34_->id = _tmp2_;
#line 1407 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_REFERENCE_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1407 "../src/server.vala"
	_data34_->p = (LspReferenceParams*) _tmp3_;
#line 1409 "../src/server.vala"
	vls_server_wait_for_context_update (self, _data34_->id, ___lambda66__vls_server_on_context_updated_func, block34_data_ref (_data34_), block34_data_unref);
#line 1406 "../src/server.vala"
	block34_data_unref (_data34_);
#line 1406 "../src/server.vala"
	_data34_ = NULL;
#line 14892 "server.c"
}

static Block35Data*
block35_data_ref (Block35Data* _data35_)
{
#line 1507 "../src/server.vala"
	g_atomic_int_inc (&_data35_->_ref_count_);
#line 1507 "../src/server.vala"
	return _data35_;
#line 14902 "server.c"
}

static void
block35_data_unref (void * _userdata_)
{
	Block35Data* _data35_;
	_data35_ = (Block35Data*) _userdata_;
#line 1507 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data35_->_ref_count_)) {
#line 14912 "server.c"
		VlsServer* self;
#line 1507 "../src/server.vala"
		self = _data35_->self;
#line 1507 "../src/server.vala"
		_g_object_unref0 (_data35_->p);
#line 1507 "../src/server.vala"
		_g_object_unref0 (_data35_->client);
#line 1507 "../src/server.vala"
		_g_free0 (_data35_->method);
#line 1507 "../src/server.vala"
		_g_variant_unref0 (_data35_->id);
#line 1507 "../src/server.vala"
		_g_object_unref0 (self);
#line 1507 "../src/server.vala"
		g_slice_free (Block35Data, _data35_);
#line 14928 "server.c"
	}
}

static gboolean
_______lambda68_ (ValaCodeNode* needle,
                  ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 1578 "../src/server.vala"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1578 "../src/server.vala"
	g_return_val_if_fail (node != NULL, FALSE);
#line 1578 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_OBJECT_TYPE_SYMBOL)) {
#line 1579 "../src/server.vala"
		_tmp0_ = vala_typesymbol_is_subtype_of ((ValaTypeSymbol*) G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol), (ValaTypeSymbol*) G_TYPE_CHECK_INSTANCE_CAST (needle, VALA_TYPE_OBJECT_TYPE_SYMBOL, ValaObjectTypeSymbol));
#line 14946 "server.c"
	} else {
#line 1578 "../src/server.vala"
		_tmp0_ = FALSE;
#line 14950 "server.c"
	}
#line 1578 "../src/server.vala"
	result = _tmp0_;
#line 1578 "../src/server.vala"
	return result;
#line 14956 "server.c"
}

static gboolean
________lambda68__vls_node_search_filter (ValaCodeNode* needle,
                                          ValaCodeNode* hay_node)
{
	gboolean result;
	result = _______lambda68_ (needle, hay_node);
#line 1577 "../src/server.vala"
	return result;
#line 14967 "server.c"
}

static gboolean
________lambda69_ (ValaCodeNode* needle,
                   ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 1582 "../src/server.vala"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1582 "../src/server.vala"
	g_return_val_if_fail (node != NULL, FALSE);
#line 1582 "../src/server.vala"
	if (needle != node) {
#line 1582 "../src/server.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_METHOD);
#line 14985 "server.c"
	} else {
#line 1582 "../src/server.vala"
		_tmp1_ = FALSE;
#line 14989 "server.c"
	}
#line 1582 "../src/server.vala"
	if (_tmp1_) {
#line 14993 "server.c"
		gboolean _tmp2_ = FALSE;
		ValaMethod* _tmp3_;
		ValaMethod* _tmp4_;
#line 1583 "../src/server.vala"
		_tmp3_ = vala_method_get_base_method (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_METHOD, ValaMethod));
#line 1583 "../src/server.vala"
		_tmp4_ = _tmp3_;
#line 1583 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle) {
#line 1583 "../src/server.vala"
			_tmp2_ = TRUE;
#line 15005 "server.c"
		} else {
			ValaMethod* _tmp5_;
			ValaMethod* _tmp6_;
#line 1584 "../src/server.vala"
			_tmp5_ = vala_method_get_base_interface_method (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_METHOD, ValaMethod));
#line 1584 "../src/server.vala"
			_tmp6_ = _tmp5_;
#line 1584 "../src/server.vala"
			_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle;
#line 15015 "server.c"
		}
#line 1583 "../src/server.vala"
		_tmp0_ = _tmp2_;
#line 15019 "server.c"
	} else {
#line 1582 "../src/server.vala"
		_tmp0_ = FALSE;
#line 15023 "server.c"
	}
#line 1582 "../src/server.vala"
	result = _tmp0_;
#line 1582 "../src/server.vala"
	return result;
#line 15029 "server.c"
}

static gboolean
_________lambda69__vls_node_search_filter (ValaCodeNode* needle,
                                           ValaCodeNode* hay_node)
{
	gboolean result;
	result = ________lambda69_ (needle, hay_node);
#line 1581 "../src/server.vala"
	return result;
#line 15040 "server.c"
}

static gboolean
________lambda70_ (ValaCodeNode* needle,
                   ValaCodeNode* node)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 1587 "../src/server.vala"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1587 "../src/server.vala"
	g_return_val_if_fail (node != NULL, FALSE);
#line 1587 "../src/server.vala"
	if (needle != node) {
#line 1587 "../src/server.vala"
		_tmp1_ = G_TYPE_CHECK_INSTANCE_TYPE (node, VALA_TYPE_PROPERTY);
#line 15058 "server.c"
	} else {
#line 1587 "../src/server.vala"
		_tmp1_ = FALSE;
#line 15062 "server.c"
	}
#line 1587 "../src/server.vala"
	if (_tmp1_) {
#line 15066 "server.c"
		gboolean _tmp2_ = FALSE;
		ValaProperty* _tmp3_;
		ValaProperty* _tmp4_;
#line 1588 "../src/server.vala"
		_tmp3_ = vala_property_get_base_property (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_PROPERTY, ValaProperty));
#line 1588 "../src/server.vala"
		_tmp4_ = _tmp3_;
#line 1588 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle) {
#line 1588 "../src/server.vala"
			_tmp2_ = TRUE;
#line 15078 "server.c"
		} else {
			ValaProperty* _tmp5_;
			ValaProperty* _tmp6_;
#line 1589 "../src/server.vala"
			_tmp5_ = vala_property_get_base_interface_property (G_TYPE_CHECK_INSTANCE_CAST (node, VALA_TYPE_PROPERTY, ValaProperty));
#line 1589 "../src/server.vala"
			_tmp6_ = _tmp5_;
#line 1589 "../src/server.vala"
			_tmp2_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, VALA_TYPE_CODE_NODE, ValaCodeNode) == needle;
#line 15088 "server.c"
		}
#line 1588 "../src/server.vala"
		_tmp0_ = _tmp2_;
#line 15092 "server.c"
	} else {
#line 1587 "../src/server.vala"
		_tmp0_ = FALSE;
#line 15096 "server.c"
	}
#line 1587 "../src/server.vala"
	result = _tmp0_;
#line 1587 "../src/server.vala"
	return result;
#line 15102 "server.c"
}

static gboolean
_________lambda70__vls_node_search_filter (ValaCodeNode* needle,
                                           ValaCodeNode* hay_node)
{
	gboolean result;
	result = ________lambda70_ (needle, hay_node);
#line 1586 "../src/server.vala"
	return result;
#line 15113 "server.c"
}

static void
__lambda67_ (Block35Data* _data35_,
             gboolean request_cancelled)
{
	VlsServer* self;
	LspPosition* pos = NULL;
	LspPosition* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	VlsCompilation* compilation = NULL;
	VlsProject* project = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentIdentifier* _tmp3_;
	LspTextDocumentIdentifier* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspPosition* _tmp19_;
	VlsNodeSearch* _tmp20_;
	VlsNodeSearch* _tmp21_;
	GeeList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp28_;
	ValaSourceFile* _tmp29_;
	ValaCodeNode* _tmp30_;
	ValaSymbol* symbol = NULL;
	JsonArray* json_array = NULL;
	JsonArray* _tmp31_;
	GeeArrayList* references = NULL;
	GeeArrayList* _tmp32_;
	gboolean _tmp33_ = FALSE;
	ValaCodeNode* _tmp34_;
	const gchar* _tmp42_;
	ValaCodeNode* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	ValaCodeNode* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	gchar* _tmp50_;
	gchar* _tmp51_;
	gboolean _tmp52_ = FALSE;
	ValaCodeNode* _tmp53_;
	gboolean is_abstract_type = FALSE;
	gboolean _tmp59_ = FALSE;
	ValaCodeNode* _tmp60_;
	gboolean is_abstract_or_virtual_method = FALSE;
	gboolean _tmp68_ = FALSE;
	ValaCodeNode* _tmp69_;
	gboolean is_abstract_or_virtual_property = FALSE;
	gboolean _tmp77_ = FALSE;
	gboolean _tmp78_ = FALSE;
	GeeHashSet* generated_vapis = NULL;
	GeeHashSet* _tmp84_;
	GeeHashSet* shown_files = NULL;
	GeeHashSet* _tmp98_;
	const gchar* _tmp148_;
	GeeArrayList* _tmp149_;
	gint _tmp150_;
	gint _tmp151_;
	gchar* _tmp152_;
	gchar* _tmp153_;
	gchar* _tmp154_;
	gchar* _tmp155_;
	GError* _inner_error0_ = NULL;
#line 1510 "../src/server.vala"
	self = _data35_->self;
#line 1511 "../src/server.vala"
	if (request_cancelled) {
#line 1512 "../src/server.vala"
		vls_server_reply_null (_data35_->id, _data35_->client, _data35_->method);
#line 1513 "../src/server.vala"
		return;
#line 15200 "server.c"
	}
#line 1516 "../src/server.vala"
	_tmp0_ = lsp_text_document_position_params_get_position (_data35_->p);
#line 1516 "../src/server.vala"
	_tmp1_ = _tmp0_;
#line 1516 "../src/server.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1516 "../src/server.vala"
	pos = _tmp2_;
#line 1520 "../src/server.vala"
	_tmp3_ = lsp_text_document_position_params_get_textDocument (_data35_->p);
#line 1520 "../src/server.vala"
	_tmp4_ = _tmp3_;
#line 1520 "../src/server.vala"
	_tmp5_ = lsp_text_document_identifier_get_uri (_tmp4_);
#line 1520 "../src/server.vala"
	_tmp6_ = _tmp5_;
#line 1520 "../src/server.vala"
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
#line 1520 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1520 "../src/server.vala"
	compilation = _tmp7_;
#line 1520 "../src/server.vala"
	_g_object_unref0 (project);
#line 1520 "../src/server.vala"
	project = _tmp8_;
#line 1520 "../src/server.vala"
	doc = _tmp9_;
#line 1521 "../src/server.vala"
	_tmp10_ = doc;
#line 1521 "../src/server.vala"
	if (_tmp10_ == NULL) {
#line 15234 "server.c"
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 1522 "../src/server.vala"
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_data35_->p);
#line 1522 "../src/server.vala"
		_tmp12_ = _tmp11_;
#line 1522 "../src/server.vala"
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
#line 1522 "../src/server.vala"
		_tmp14_ = _tmp13_;
#line 1522 "../src/server.vala"
		g_debug ("server.vala:1522: [%s] file `%s' not found", _data35_->method, _tmp14_);
#line 1523 "../src/server.vala"
		vls_server_reply_null (_data35_->id, _data35_->client, _data35_->method);
#line 1524 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1524 "../src/server.vala"
		_g_object_unref0 (project);
#line 1524 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1524 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1524 "../src/server.vala"
		return;
#line 15261 "server.c"
	}
#line 1527 "../src/server.vala"
	_tmp15_ = compilation;
#line 1527 "../src/server.vala"
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
#line 1527 "../src/server.vala"
	_tmp17_ = _tmp16_;
#line 1527 "../src/server.vala"
	vala_code_context_push (_tmp17_);
#line 1529 "../src/server.vala"
	_tmp18_ = doc;
#line 1529 "../src/server.vala"
	_tmp19_ = pos;
#line 1529 "../src/server.vala"
	_tmp20_ = vls_node_search_new (_tmp18_, _tmp19_, TRUE, NULL, TRUE);
#line 1529 "../src/server.vala"
	fs = _tmp20_;
#line 1531 "../src/server.vala"
	_tmp21_ = fs;
#line 1531 "../src/server.vala"
	_tmp22_ = _tmp21_->result;
#line 1531 "../src/server.vala"
	_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
#line 1531 "../src/server.vala"
	_tmp24_ = _tmp23_;
#line 1531 "../src/server.vala"
	if (_tmp24_ == 0) {
#line 15289 "server.c"
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
#line 1532 "../src/server.vala"
		_tmp25_ = string_to_string (_data35_->method);
#line 1532 "../src/server.vala"
		_tmp26_ = g_strconcat ("[", _tmp25_, "] no results found", NULL);
#line 1532 "../src/server.vala"
		_tmp27_ = _tmp26_;
#line 1532 "../src/server.vala"
		g_debug ("server.vala:1532: %s", _tmp27_);
#line 1532 "../src/server.vala"
		_g_free0 (_tmp27_);
#line 1533 "../src/server.vala"
		vls_server_reply_null (_data35_->id, _data35_->client, _data35_->method);
#line 1534 "../src/server.vala"
		vala_code_context_pop ();
#line 1535 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1535 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1535 "../src/server.vala"
		_g_object_unref0 (project);
#line 1535 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1535 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1535 "../src/server.vala"
		return;
#line 15319 "server.c"
	}
#line 1538 "../src/server.vala"
	_tmp28_ = fs;
#line 1538 "../src/server.vala"
	_tmp29_ = doc;
#line 1538 "../src/server.vala"
	_tmp30_ = vls_server_get_best (_tmp28_, _tmp29_);
#line 1538 "../src/server.vala"
	_result_ = _tmp30_;
#line 1541 "../src/server.vala"
	_tmp31_ = json_array_new ();
#line 1541 "../src/server.vala"
	json_array = _tmp31_;
#line 1542 "../src/server.vala"
	_tmp32_ = gee_array_list_new (VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL);
#line 1542 "../src/server.vala"
	if (_tmp32_) {
#line 1542 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp32_, "vala-creation-function", "Vls.Server.show_implementations._lambda67_");
#line 15339 "server.c"
	}
#line 1542 "../src/server.vala"
	references = _tmp32_;
#line 1544 "../src/server.vala"
	_tmp34_ = _result_;
#line 1544 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, VALA_TYPE_DATA_TYPE)) {
#line 15347 "server.c"
		ValaCodeNode* _tmp35_;
		ValaTypeSymbol* _tmp36_;
		ValaTypeSymbol* _tmp37_;
#line 1544 "../src/server.vala"
		_tmp35_ = _result_;
#line 1544 "../src/server.vala"
		_tmp36_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 1544 "../src/server.vala"
		_tmp37_ = _tmp36_;
#line 1544 "../src/server.vala"
		_tmp33_ = _tmp37_ != NULL;
#line 15359 "server.c"
	} else {
#line 1544 "../src/server.vala"
		_tmp33_ = FALSE;
#line 15363 "server.c"
	}
#line 1544 "../src/server.vala"
	if (_tmp33_) {
#line 15367 "server.c"
		ValaCodeNode* _tmp38_;
		ValaTypeSymbol* _tmp39_;
		ValaTypeSymbol* _tmp40_;
		ValaCodeNode* _tmp41_;
#line 1545 "../src/server.vala"
		_tmp38_ = _result_;
#line 1545 "../src/server.vala"
		_tmp39_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 1545 "../src/server.vala"
		_tmp40_ = _tmp39_;
#line 1545 "../src/server.vala"
		_tmp41_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp40_);
#line 1545 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1545 "../src/server.vala"
		_result_ = _tmp41_;
#line 15384 "server.c"
	}
#line 1547 "../src/server.vala"
	_tmp42_ = string_to_string (_data35_->method);
#line 1547 "../src/server.vala"
	_tmp43_ = _result_;
#line 1547 "../src/server.vala"
	_tmp44_ = vala_code_node_to_string (_tmp43_);
#line 1547 "../src/server.vala"
	_tmp45_ = _tmp44_;
#line 1547 "../src/server.vala"
	_tmp46_ = _result_;
#line 1547 "../src/server.vala"
	_tmp47_ = vala_code_node_get_type_name (_tmp46_);
#line 1547 "../src/server.vala"
	_tmp48_ = _tmp47_;
#line 1547 "../src/server.vala"
	_tmp49_ = string_to_string (_tmp48_);
#line 1547 "../src/server.vala"
	_tmp50_ = g_strconcat ("[", _tmp42_, "] got best: ", _tmp45_, " (", _tmp49_, ")", NULL);
#line 1547 "../src/server.vala"
	_tmp51_ = _tmp50_;
#line 1547 "../src/server.vala"
	g_debug ("server.vala:1547: %s", _tmp51_);
#line 1547 "../src/server.vala"
	_g_free0 (_tmp51_);
#line 1547 "../src/server.vala"
	_g_free0 (_tmp45_);
#line 1548 "../src/server.vala"
	_tmp53_ = _result_;
#line 1548 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_INTERFACE)) {
#line 1548 "../src/server.vala"
		_tmp52_ = TRUE;
#line 15418 "server.c"
	} else {
		gboolean _tmp54_ = FALSE;
		ValaCodeNode* _tmp55_;
#line 1548 "../src/server.vala"
		_tmp55_ = _result_;
#line 1548 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp55_, VALA_TYPE_CLASS)) {
#line 15426 "server.c"
			ValaCodeNode* _tmp56_;
			gboolean _tmp57_;
			gboolean _tmp58_;
#line 1548 "../src/server.vala"
			_tmp56_ = _result_;
#line 1548 "../src/server.vala"
			_tmp57_ = vala_class_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, VALA_TYPE_CLASS, ValaClass));
#line 1548 "../src/server.vala"
			_tmp58_ = _tmp57_;
#line 1548 "../src/server.vala"
			_tmp54_ = _tmp58_;
#line 15438 "server.c"
		} else {
#line 1548 "../src/server.vala"
			_tmp54_ = FALSE;
#line 15442 "server.c"
		}
#line 1548 "../src/server.vala"
		_tmp52_ = _tmp54_;
#line 15446 "server.c"
	}
#line 1548 "../src/server.vala"
	is_abstract_type = _tmp52_;
#line 1549 "../src/server.vala"
	_tmp60_ = _result_;
#line 1549 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp60_, VALA_TYPE_METHOD)) {
#line 15454 "server.c"
		gboolean _tmp61_ = FALSE;
		ValaCodeNode* _tmp62_;
		gboolean _tmp63_;
		gboolean _tmp64_;
#line 1550 "../src/server.vala"
		_tmp62_ = _result_;
#line 1550 "../src/server.vala"
		_tmp63_ = vala_method_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, VALA_TYPE_METHOD, ValaMethod));
#line 1550 "../src/server.vala"
		_tmp64_ = _tmp63_;
#line 1550 "../src/server.vala"
		if (_tmp64_) {
#line 1550 "../src/server.vala"
			_tmp61_ = TRUE;
#line 15469 "server.c"
		} else {
			ValaCodeNode* _tmp65_;
			gboolean _tmp66_;
			gboolean _tmp67_;
#line 1550 "../src/server.vala"
			_tmp65_ = _result_;
#line 1550 "../src/server.vala"
			_tmp66_ = vala_method_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, VALA_TYPE_METHOD, ValaMethod));
#line 1550 "../src/server.vala"
			_tmp67_ = _tmp66_;
#line 1550 "../src/server.vala"
			_tmp61_ = _tmp67_;
#line 15482 "server.c"
		}
#line 1550 "../src/server.vala"
		_tmp59_ = _tmp61_;
#line 15486 "server.c"
	} else {
#line 1549 "../src/server.vala"
		_tmp59_ = FALSE;
#line 15490 "server.c"
	}
#line 1549 "../src/server.vala"
	is_abstract_or_virtual_method = _tmp59_;
#line 1551 "../src/server.vala"
	_tmp69_ = _result_;
#line 1551 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp69_, VALA_TYPE_PROPERTY)) {
#line 15498 "server.c"
		gboolean _tmp70_ = FALSE;
		ValaCodeNode* _tmp71_;
		gboolean _tmp72_;
		gboolean _tmp73_;
#line 1552 "../src/server.vala"
		_tmp71_ = _result_;
#line 1552 "../src/server.vala"
		_tmp72_ = vala_property_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp71_, VALA_TYPE_PROPERTY, ValaProperty));
#line 1552 "../src/server.vala"
		_tmp73_ = _tmp72_;
#line 1552 "../src/server.vala"
		if (_tmp73_) {
#line 1552 "../src/server.vala"
			_tmp70_ = TRUE;
#line 15513 "server.c"
		} else {
			ValaCodeNode* _tmp74_;
			gboolean _tmp75_;
			gboolean _tmp76_;
#line 1552 "../src/server.vala"
			_tmp74_ = _result_;
#line 1552 "../src/server.vala"
			_tmp75_ = vala_property_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp74_, VALA_TYPE_PROPERTY, ValaProperty));
#line 1552 "../src/server.vala"
			_tmp76_ = _tmp75_;
#line 1552 "../src/server.vala"
			_tmp70_ = _tmp76_;
#line 15526 "server.c"
		}
#line 1552 "../src/server.vala"
		_tmp68_ = _tmp70_;
#line 15530 "server.c"
	} else {
#line 1551 "../src/server.vala"
		_tmp68_ = FALSE;
#line 15534 "server.c"
	}
#line 1551 "../src/server.vala"
	is_abstract_or_virtual_property = _tmp68_;
#line 1554 "../src/server.vala"
	if (!is_abstract_type) {
#line 1554 "../src/server.vala"
		_tmp78_ = !is_abstract_or_virtual_method;
#line 15542 "server.c"
	} else {
#line 1554 "../src/server.vala"
		_tmp78_ = FALSE;
#line 15546 "server.c"
	}
#line 1554 "../src/server.vala"
	if (_tmp78_) {
#line 1554 "../src/server.vala"
		_tmp77_ = !is_abstract_or_virtual_property;
#line 15552 "server.c"
	} else {
#line 1554 "../src/server.vala"
		_tmp77_ = FALSE;
#line 15556 "server.c"
	}
#line 1554 "../src/server.vala"
	if (_tmp77_) {
#line 15560 "server.c"
		const gchar* _tmp79_;
		gchar* _tmp80_;
		gchar* _tmp81_;
#line 1555 "../src/server.vala"
		_tmp79_ = string_to_string (_data35_->method);
#line 1555 "../src/server.vala"
		_tmp80_ = g_strconcat ("[", _tmp79_, "] best is neither an abstract type/interface nor abstract/virtual meth" \
"od/property", NULL);
#line 1555 "../src/server.vala"
		_tmp81_ = _tmp80_;
#line 1555 "../src/server.vala"
		g_debug ("server.vala:1555: %s", _tmp81_);
#line 1555 "../src/server.vala"
		_g_free0 (_tmp81_);
#line 1556 "../src/server.vala"
		vls_server_reply_null (_data35_->id, _data35_->client, _data35_->method);
#line 1557 "../src/server.vala"
		vala_code_context_pop ();
#line 1558 "../src/server.vala"
		_g_object_unref0 (references);
#line 1558 "../src/server.vala"
		_json_array_unref0 (json_array);
#line 1558 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1558 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1558 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1558 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1558 "../src/server.vala"
		_g_object_unref0 (project);
#line 1558 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1558 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1558 "../src/server.vala"
		return;
#line 15598 "server.c"
	} else {
		ValaCodeNode* _tmp82_;
		ValaSymbol* _tmp83_;
#line 1560 "../src/server.vala"
		_tmp82_ = _result_;
#line 1560 "../src/server.vala"
		_tmp83_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp82_, VALA_TYPE_SYMBOL, ValaSymbol));
#line 1560 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1560 "../src/server.vala"
		symbol = _tmp83_;
#line 15610 "server.c"
	}
#line 1564 "../src/server.vala"
	_tmp84_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
#line 1564 "../src/server.vala"
	if (_tmp84_) {
#line 1564 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp84_, "vala-creation-function", "Vls.Server.show_implementations._lambda67_");
#line 15618 "server.c"
	}
#line 1564 "../src/server.vala"
	generated_vapis = _tmp84_;
#line 15622 "server.c"
	{
		GeeArrayList* _btarget_list = NULL;
		VlsProject* _tmp85_;
		GeeArrayList* _tmp86_;
		gint _btarget_size = 0;
		GeeArrayList* _tmp87_;
		gint _tmp88_;
		gint _tmp89_;
		gint _btarget_index = 0;
#line 1565 "../src/server.vala"
		_tmp85_ = project;
#line 1565 "../src/server.vala"
		_tmp86_ = vls_project_get_compilations (_tmp85_);
#line 1565 "../src/server.vala"
		_btarget_list = _tmp86_;
#line 1565 "../src/server.vala"
		_tmp87_ = _btarget_list;
#line 1565 "../src/server.vala"
		_tmp88_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp87_);
#line 1565 "../src/server.vala"
		_tmp89_ = _tmp88_;
#line 1565 "../src/server.vala"
		_btarget_size = _tmp89_;
#line 1565 "../src/server.vala"
		_btarget_index = -1;
#line 1565 "../src/server.vala"
		while (TRUE) {
#line 15650 "server.c"
			gint _tmp90_;
			gint _tmp91_;
			VlsCompilation* btarget = NULL;
			GeeArrayList* _tmp92_;
			gpointer _tmp93_;
			GeeHashSet* _tmp94_;
			VlsCompilation* _tmp95_;
			GeeArrayList* _tmp96_;
			GeeArrayList* _tmp97_;
#line 1565 "../src/server.vala"
			_btarget_index = _btarget_index + 1;
#line 1565 "../src/server.vala"
			_tmp90_ = _btarget_index;
#line 1565 "../src/server.vala"
			_tmp91_ = _btarget_size;
#line 1565 "../src/server.vala"
			if (!(_tmp90_ < _tmp91_)) {
#line 1565 "../src/server.vala"
				break;
#line 15670 "server.c"
			}
#line 1565 "../src/server.vala"
			_tmp92_ = _btarget_list;
#line 1565 "../src/server.vala"
			_tmp93_ = gee_abstract_list_get ((GeeAbstractList*) _tmp92_, _btarget_index);
#line 1565 "../src/server.vala"
			btarget = (VlsCompilation*) _tmp93_;
#line 1566 "../src/server.vala"
			_tmp94_ = generated_vapis;
#line 1566 "../src/server.vala"
			_tmp95_ = btarget;
#line 1566 "../src/server.vala"
			_tmp96_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp95_);
#line 1566 "../src/server.vala"
			_tmp97_ = _tmp96_;
#line 1566 "../src/server.vala"
			gee_collection_add_all ((GeeCollection*) _tmp94_, (GeeCollection*) _tmp97_);
#line 1565 "../src/server.vala"
			_g_object_unref0 (btarget);
#line 15690 "server.c"
		}
#line 1565 "../src/server.vala"
		_g_object_unref0 (_btarget_list);
#line 15694 "server.c"
	}
#line 1567 "../src/server.vala"
	_tmp98_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
#line 1567 "../src/server.vala"
	if (_tmp98_) {
#line 1567 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp98_, "vala-creation-function", "Vls.Server.show_implementations._lambda67_");
#line 15702 "server.c"
	}
#line 1567 "../src/server.vala"
	shown_files = _tmp98_;
#line 15706 "server.c"
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp99_;
		ValaSymbol* _tmp100_;
		GeeCollection* _tmp101_;
		GeeCollection* _tmp102_;
		GeeIterator* _tmp103_;
		GeeIterator* _tmp104_;
#line 1568 "../src/server.vala"
		_tmp99_ = project;
#line 1568 "../src/server.vala"
		_tmp100_ = symbol;
#line 1568 "../src/server.vala"
		_tmp101_ = vls_symbol_references_get_compilations_using_symbol (_tmp99_, _tmp100_);
#line 1568 "../src/server.vala"
		_tmp102_ = _tmp101_;
#line 1568 "../src/server.vala"
		_tmp103_ = gee_iterable_iterator ((GeeIterable*) _tmp102_);
#line 1568 "../src/server.vala"
		_tmp104_ = _tmp103_;
#line 1568 "../src/server.vala"
		_g_object_unref0 (_tmp102_);
#line 1568 "../src/server.vala"
		_btarget_w_sym_it = _tmp104_;
#line 1568 "../src/server.vala"
		while (TRUE) {
#line 15733 "server.c"
			GeeIterator* _tmp105_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp106_;
			gpointer _tmp107_;
#line 1568 "../src/server.vala"
			_tmp105_ = _btarget_w_sym_it;
#line 1568 "../src/server.vala"
			if (!gee_iterator_next (_tmp105_)) {
#line 1568 "../src/server.vala"
				break;
#line 15744 "server.c"
			}
#line 1568 "../src/server.vala"
			_tmp106_ = _btarget_w_sym_it;
#line 1568 "../src/server.vala"
			_tmp107_ = gee_iterator_get (_tmp106_);
#line 1568 "../src/server.vala"
			btarget_w_sym = (VlsPair*) _tmp107_;
#line 15752 "server.c"
			{
				ValaList* _file_list = NULL;
				VlsPair* _tmp108_;
				gconstpointer _tmp109_;
				gconstpointer _tmp110_;
				ValaCodeContext* _tmp111_;
				ValaCodeContext* _tmp112_;
				ValaList* _tmp113_;
				gint _file_size = 0;
				ValaList* _tmp114_;
				gint _tmp115_;
				gint _tmp116_;
				gint _file_index = 0;
#line 1569 "../src/server.vala"
				_tmp108_ = btarget_w_sym;
#line 1569 "../src/server.vala"
				_tmp109_ = vls_pair_get_first (_tmp108_);
#line 1569 "../src/server.vala"
				_tmp110_ = _tmp109_;
#line 1569 "../src/server.vala"
				_tmp111_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp110_);
#line 1569 "../src/server.vala"
				_tmp112_ = _tmp111_;
#line 1569 "../src/server.vala"
				_tmp113_ = vala_code_context_get_source_files (_tmp112_);
#line 1569 "../src/server.vala"
				_file_list = _tmp113_;
#line 1569 "../src/server.vala"
				_tmp114_ = _file_list;
#line 1569 "../src/server.vala"
				_tmp115_ = vala_collection_get_size ((ValaCollection*) _tmp114_);
#line 1569 "../src/server.vala"
				_tmp116_ = _tmp115_;
#line 1569 "../src/server.vala"
				_file_size = _tmp116_;
#line 1569 "../src/server.vala"
				_file_index = -1;
#line 1569 "../src/server.vala"
				while (TRUE) {
#line 15792 "server.c"
					gint _tmp117_;
					gint _tmp118_;
					ValaSourceFile* file = NULL;
					ValaList* _tmp119_;
					gpointer _tmp120_;
					GFile* gfile = NULL;
					ValaSourceFile* _tmp121_;
					const gchar* _tmp122_;
					const gchar* _tmp123_;
					GFile* _tmp124_;
					gboolean _tmp125_ = FALSE;
					GeeHashSet* _tmp126_;
					GFile* _tmp127_;
					VlsNodeSearch* fs2 = NULL;
					GeeArrayList* _tmp143_;
					VlsNodeSearch* _tmp144_;
					GeeList* _tmp145_;
					GeeHashSet* _tmp146_;
					GFile* _tmp147_;
#line 1569 "../src/server.vala"
					_file_index = _file_index + 1;
#line 1569 "../src/server.vala"
					_tmp117_ = _file_index;
#line 1569 "../src/server.vala"
					_tmp118_ = _file_size;
#line 1569 "../src/server.vala"
					if (!(_tmp117_ < _tmp118_)) {
#line 1569 "../src/server.vala"
						break;
#line 15822 "server.c"
					}
#line 1569 "../src/server.vala"
					_tmp119_ = _file_list;
#line 1569 "../src/server.vala"
					_tmp120_ = vala_list_get (_tmp119_, _file_index);
#line 1569 "../src/server.vala"
					file = (ValaSourceFile*) _tmp120_;
#line 1570 "../src/server.vala"
					_tmp121_ = file;
#line 1570 "../src/server.vala"
					_tmp122_ = vala_source_file_get_filename (_tmp121_);
#line 1570 "../src/server.vala"
					_tmp123_ = _tmp122_;
#line 1570 "../src/server.vala"
					_tmp124_ = g_file_new_for_commandline_arg (_tmp123_);
#line 1570 "../src/server.vala"
					gfile = _tmp124_;
#line 1572 "../src/server.vala"
					_tmp126_ = generated_vapis;
#line 1572 "../src/server.vala"
					_tmp127_ = gfile;
#line 1572 "../src/server.vala"
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp126_, _tmp127_)) {
#line 1572 "../src/server.vala"
						_tmp125_ = TRUE;
#line 15848 "server.c"
					} else {
						GeeHashSet* _tmp128_;
						GFile* _tmp129_;
#line 1572 "../src/server.vala"
						_tmp128_ = shown_files;
#line 1572 "../src/server.vala"
						_tmp129_ = gfile;
#line 1572 "../src/server.vala"
						_tmp125_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp128_, _tmp129_);
#line 15858 "server.c"
					}
#line 1572 "../src/server.vala"
					if (_tmp125_) {
#line 1573 "../src/server.vala"
						_g_object_unref0 (gfile);
#line 1573 "../src/server.vala"
						_vala_source_file_unref0 (file);
#line 1573 "../src/server.vala"
						continue;
#line 15868 "server.c"
					}
#line 1576 "../src/server.vala"
					if (is_abstract_type) {
#line 15872 "server.c"
						ValaSourceFile* _tmp130_;
						VlsPair* _tmp131_;
						gconstpointer _tmp132_;
						gconstpointer _tmp133_;
						VlsNodeSearch* _tmp134_;
#line 1577 "../src/server.vala"
						_tmp130_ = file;
#line 1577 "../src/server.vala"
						_tmp131_ = btarget_w_sym;
#line 1577 "../src/server.vala"
						_tmp132_ = vls_pair_get_second (_tmp131_);
#line 1577 "../src/server.vala"
						_tmp133_ = _tmp132_;
#line 1577 "../src/server.vala"
						_tmp134_ = vls_node_search_new_with_filter (_tmp130_, (ValaCodeNode*) ((ValaSymbol*) _tmp133_), ________lambda68__vls_node_search_filter, FALSE);
#line 1577 "../src/server.vala"
						_vala_code_visitor_unref0 (fs2);
#line 1577 "../src/server.vala"
						fs2 = _tmp134_;
#line 15892 "server.c"
					} else {
#line 1580 "../src/server.vala"
						if (is_abstract_or_virtual_method) {
#line 15896 "server.c"
							ValaSourceFile* _tmp135_;
							VlsPair* _tmp136_;
							gconstpointer _tmp137_;
							gconstpointer _tmp138_;
							VlsNodeSearch* _tmp139_;
#line 1581 "../src/server.vala"
							_tmp135_ = file;
#line 1581 "../src/server.vala"
							_tmp136_ = btarget_w_sym;
#line 1581 "../src/server.vala"
							_tmp137_ = vls_pair_get_second (_tmp136_);
#line 1581 "../src/server.vala"
							_tmp138_ = _tmp137_;
#line 1581 "../src/server.vala"
							_tmp139_ = vls_node_search_new_with_filter (_tmp135_, (ValaCodeNode*) ((ValaSymbol*) _tmp138_), _________lambda69__vls_node_search_filter, FALSE);
#line 1581 "../src/server.vala"
							_vala_code_visitor_unref0 (fs2);
#line 1581 "../src/server.vala"
							fs2 = _tmp139_;
#line 15916 "server.c"
						} else {
							ValaSourceFile* _tmp140_;
							ValaSymbol* _tmp141_;
							VlsNodeSearch* _tmp142_;
#line 1586 "../src/server.vala"
							_tmp140_ = file;
#line 1586 "../src/server.vala"
							_tmp141_ = symbol;
#line 1586 "../src/server.vala"
							_tmp142_ = vls_node_search_new_with_filter (_tmp140_, (ValaCodeNode*) _tmp141_, _________lambda70__vls_node_search_filter, FALSE);
#line 1586 "../src/server.vala"
							_vala_code_visitor_unref0 (fs2);
#line 1586 "../src/server.vala"
							fs2 = _tmp142_;
#line 15931 "server.c"
						}
					}
#line 1591 "../src/server.vala"
					_tmp143_ = references;
#line 1591 "../src/server.vala"
					_tmp144_ = fs2;
#line 1591 "../src/server.vala"
					_tmp145_ = _tmp144_->result;
#line 1591 "../src/server.vala"
					gee_array_list_add_all (_tmp143_, (GeeCollection*) _tmp145_);
#line 1592 "../src/server.vala"
					_tmp146_ = shown_files;
#line 1592 "../src/server.vala"
					_tmp147_ = gfile;
#line 1592 "../src/server.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp146_, _tmp147_);
#line 1569 "../src/server.vala"
					_vala_code_visitor_unref0 (fs2);
#line 1569 "../src/server.vala"
					_g_object_unref0 (gfile);
#line 1569 "../src/server.vala"
					_vala_source_file_unref0 (file);
#line 15954 "server.c"
				}
			}
#line 1568 "../src/server.vala"
			_g_object_unref0 (btarget_w_sym);
#line 15959 "server.c"
		}
#line 1568 "../src/server.vala"
		_g_object_unref0 (_btarget_w_sym_it);
#line 15963 "server.c"
	}
#line 1596 "../src/server.vala"
	_tmp148_ = string_to_string (_data35_->method);
#line 1596 "../src/server.vala"
	_tmp149_ = references;
#line 1596 "../src/server.vala"
	_tmp150_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp149_);
#line 1596 "../src/server.vala"
	_tmp151_ = _tmp150_;
#line 1596 "../src/server.vala"
	_tmp152_ = g_strdup_printf ("%i", _tmp151_);
#line 1596 "../src/server.vala"
	_tmp153_ = _tmp152_;
#line 1596 "../src/server.vala"
	_tmp154_ = g_strconcat ("[", _tmp148_, "] found ", _tmp153_, " reference(s)", NULL);
#line 1596 "../src/server.vala"
	_tmp155_ = _tmp154_;
#line 1596 "../src/server.vala"
	g_debug ("server.vala:1596: %s", _tmp155_);
#line 1596 "../src/server.vala"
	_g_free0 (_tmp155_);
#line 1596 "../src/server.vala"
	_g_free0 (_tmp153_);
#line 15987 "server.c"
	{
		GeeArrayList* _node_list = NULL;
		GeeArrayList* _tmp156_;
		gint _node_size = 0;
		GeeArrayList* _tmp157_;
		gint _tmp158_;
		gint _tmp159_;
		gint _node_index = 0;
#line 1597 "../src/server.vala"
		_tmp156_ = references;
#line 1597 "../src/server.vala"
		_node_list = _tmp156_;
#line 1597 "../src/server.vala"
		_tmp157_ = _node_list;
#line 1597 "../src/server.vala"
		_tmp158_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp157_);
#line 1597 "../src/server.vala"
		_tmp159_ = _tmp158_;
#line 1597 "../src/server.vala"
		_node_size = _tmp159_;
#line 1597 "../src/server.vala"
		_node_index = -1;
#line 1597 "../src/server.vala"
		while (TRUE) {
#line 16012 "server.c"
			gint _tmp160_;
			gint _tmp161_;
			ValaCodeNode* node = NULL;
			GeeArrayList* _tmp162_;
			gpointer _tmp163_;
			ValaCodeNode* real_node = NULL;
			ValaCodeNode* _tmp164_;
			ValaCodeNode* _tmp165_;
			ValaCodeNode* _tmp166_;
			JsonArray* _tmp170_;
			ValaCodeNode* _tmp171_;
			ValaSourceReference* _tmp172_;
			ValaSourceReference* _tmp173_;
			LspLocation* _tmp174_;
			LspLocation* _tmp175_;
			JsonNode* _tmp176_;
#line 1597 "../src/server.vala"
			_node_index = _node_index + 1;
#line 1597 "../src/server.vala"
			_tmp160_ = _node_index;
#line 1597 "../src/server.vala"
			_tmp161_ = _node_size;
#line 1597 "../src/server.vala"
			if (!(_tmp160_ < _tmp161_)) {
#line 1597 "../src/server.vala"
				break;
#line 16039 "server.c"
			}
#line 1597 "../src/server.vala"
			_tmp162_ = _node_list;
#line 1597 "../src/server.vala"
			_tmp163_ = gee_abstract_list_get ((GeeAbstractList*) _tmp162_, _node_index);
#line 1597 "../src/server.vala"
			node = (ValaCodeNode*) _tmp163_;
#line 1598 "../src/server.vala"
			_tmp164_ = node;
#line 1598 "../src/server.vala"
			_tmp165_ = _vala_code_node_ref0 (_tmp164_);
#line 1598 "../src/server.vala"
			real_node = _tmp165_;
#line 1599 "../src/server.vala"
			_tmp166_ = node;
#line 1599 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp166_, VALA_TYPE_SYMBOL)) {
#line 16057 "server.c"
				VlsProject* _tmp167_;
				ValaCodeNode* _tmp168_;
				ValaSymbol* _tmp169_;
#line 1600 "../src/server.vala"
				_tmp167_ = project;
#line 1600 "../src/server.vala"
				_tmp168_ = node;
#line 1600 "../src/server.vala"
				_tmp169_ = vls_symbol_references_find_real_symbol (_tmp167_, G_TYPE_CHECK_INSTANCE_CAST (_tmp168_, VALA_TYPE_SYMBOL, ValaSymbol));
#line 1600 "../src/server.vala"
				_vala_code_node_unref0 (real_node);
#line 1600 "../src/server.vala"
				real_node = (ValaCodeNode*) _tmp169_;
#line 16071 "server.c"
			}
#line 1601 "../src/server.vala"
			_tmp170_ = json_array;
#line 1601 "../src/server.vala"
			_tmp171_ = real_node;
#line 1601 "../src/server.vala"
			_tmp172_ = vala_code_node_get_source_reference (_tmp171_);
#line 1601 "../src/server.vala"
			_tmp173_ = _tmp172_;
#line 1601 "../src/server.vala"
			_tmp174_ = lsp_location_new_from_sourceref (_tmp173_);
#line 1601 "../src/server.vala"
			if (_tmp174_) {
#line 1601 "../src/server.vala"
				g_object_set_data ((GObject *) _tmp174_, "vala-creation-function", "Vls.Server.show_implementations._lambda67_");
#line 16087 "server.c"
			}
#line 1601 "../src/server.vala"
			_tmp175_ = _tmp174_;
#line 1601 "../src/server.vala"
			_tmp176_ = json_gobject_serialize ((GObject*) _tmp175_);
#line 1601 "../src/server.vala"
			json_array_add_element (_tmp170_, _tmp176_);
#line 1601 "../src/server.vala"
			_g_object_unref0 (_tmp175_);
#line 1597 "../src/server.vala"
			_vala_code_node_unref0 (real_node);
#line 1597 "../src/server.vala"
			_vala_code_node_unref0 (node);
#line 16101 "server.c"
		}
	}
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp177_;
		JsonNode* _tmp178_;
		JsonArray* _tmp179_;
		JsonNode* _tmp180_;
		GVariant* _tmp181_;
		GVariant* _tmp182_;
		GVariant* _tmp183_;
		GCancellable* _tmp184_;
#line 1605 "../src/server.vala"
		_tmp177_ = json_node_alloc ();
#line 1605 "../src/server.vala"
		_tmp178_ = _tmp177_;
#line 1605 "../src/server.vala"
		_tmp179_ = json_array;
#line 1605 "../src/server.vala"
		_tmp180_ = json_node_init_array (_tmp178_, _tmp179_);
#line 1605 "../src/server.vala"
		_tmp181_ = json_gvariant_deserialize (_tmp180_, NULL, &_inner_error0_);
#line 1605 "../src/server.vala"
		if (_tmp181_ != NULL) {
#line 1605 "../src/server.vala"
			g_variant_ref_sink (_tmp181_);
#line 16128 "server.c"
		}
#line 1605 "../src/server.vala"
		_tmp182_ = _tmp181_;
#line 1605 "../src/server.vala"
		__vala_JsonNode_free0 (_tmp178_);
#line 1605 "../src/server.vala"
		variant_array = _tmp182_;
#line 1605 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16138 "server.c"
			goto __catch0_g_error;
		}
#line 1606 "../src/server.vala"
		_tmp183_ = variant_array;
#line 1606 "../src/server.vala"
		_tmp184_ = vls_server_cancellable;
#line 1606 "../src/server.vala"
		jsonrpc_client_reply (_data35_->client, _data35_->id, _tmp183_, _tmp184_, &_inner_error0_);
#line 1606 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1606 "../src/server.vala"
			_g_variant_unref0 (variant_array);
#line 16151 "server.c"
			goto __catch0_g_error;
		}
#line 1604 "../src/server.vala"
		_g_variant_unref0 (variant_array);
#line 16156 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp185_;
		GError* _tmp186_;
		const gchar* _tmp187_;
		const gchar* _tmp188_;
		gchar* _tmp189_;
		gchar* _tmp190_;
#line 1604 "../src/server.vala"
		e = _inner_error0_;
#line 1604 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1608 "../src/server.vala"
		_tmp185_ = string_to_string (_data35_->method);
#line 1608 "../src/server.vala"
		_tmp186_ = e;
#line 1608 "../src/server.vala"
		_tmp187_ = _tmp186_->message;
#line 1608 "../src/server.vala"
		_tmp188_ = string_to_string (_tmp187_);
#line 1608 "../src/server.vala"
		_tmp189_ = g_strconcat ("[", _tmp185_, "] failed to reply to client: ", _tmp188_, NULL);
#line 1608 "../src/server.vala"
		_tmp190_ = _tmp189_;
#line 1608 "../src/server.vala"
		g_debug ("server.vala:1608: %s", _tmp190_);
#line 1608 "../src/server.vala"
		_g_free0 (_tmp190_);
#line 1604 "../src/server.vala"
		_g_error_free0 (e);
#line 16190 "server.c"
	}
	__finally0:
#line 1604 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1604 "../src/server.vala"
		_g_object_unref0 (shown_files);
#line 1604 "../src/server.vala"
		_g_object_unref0 (generated_vapis);
#line 1604 "../src/server.vala"
		_g_object_unref0 (references);
#line 1604 "../src/server.vala"
		_json_array_unref0 (json_array);
#line 1604 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1604 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1604 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1604 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1604 "../src/server.vala"
		_g_object_unref0 (project);
#line 1604 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1604 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1604 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1604 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1604 "../src/server.vala"
		return;
#line 16223 "server.c"
	}
#line 1611 "../src/server.vala"
	vala_code_context_pop ();
#line 1510 "../src/server.vala"
	_g_object_unref0 (shown_files);
#line 1510 "../src/server.vala"
	_g_object_unref0 (generated_vapis);
#line 1510 "../src/server.vala"
	_g_object_unref0 (references);
#line 1510 "../src/server.vala"
	_json_array_unref0 (json_array);
#line 1510 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 1510 "../src/server.vala"
	_vala_code_node_unref0 (_result_);
#line 1510 "../src/server.vala"
	_vala_code_visitor_unref0 (fs);
#line 1510 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 1510 "../src/server.vala"
	_g_object_unref0 (project);
#line 1510 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1510 "../src/server.vala"
	_g_object_unref0 (pos);
#line 16249 "server.c"
}

static void
___lambda67__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
#line 1510 "../src/server.vala"
	__lambda67_ (self, request_cancelled);
#line 16258 "server.c"
}

static void
vls_server_show_implementations (VlsServer* self,
                                 JsonrpcClient* client,
                                 const gchar* method,
                                 GVariant* id,
                                 GVariant* params)
{
	Block35Data* _data35_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
#line 1507 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1507 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1507 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1507 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1507 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1507 "../src/server.vala"
	_data35_ = g_slice_new0 (Block35Data);
#line 1507 "../src/server.vala"
	_data35_->_ref_count_ = 1;
#line 1507 "../src/server.vala"
	_data35_->self = g_object_ref (self);
#line 1507 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 1507 "../src/server.vala"
	_g_object_unref0 (_data35_->client);
#line 1507 "../src/server.vala"
	_data35_->client = _tmp0_;
#line 1507 "../src/server.vala"
	_tmp1_ = g_strdup (method);
#line 1507 "../src/server.vala"
	_g_free0 (_data35_->method);
#line 1507 "../src/server.vala"
	_data35_->method = _tmp1_;
#line 1507 "../src/server.vala"
	_tmp2_ = _g_variant_ref0 (id);
#line 1507 "../src/server.vala"
	_g_variant_unref0 (_data35_->id);
#line 1507 "../src/server.vala"
	_data35_->id = _tmp2_;
#line 1508 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1508 "../src/server.vala"
	_data35_->p = (LspTextDocumentPositionParams*) _tmp3_;
#line 1510 "../src/server.vala"
	vls_server_wait_for_context_update (self, _data35_->id, ___lambda67__vls_server_on_context_updated_func, block35_data_ref (_data35_), block35_data_unref);
#line 1507 "../src/server.vala"
	block35_data_unref (_data35_);
#line 1507 "../src/server.vala"
	_data35_ = NULL;
#line 16317 "server.c"
}

static void
vls_server_format (VlsServer* self,
                   JsonrpcClient* client,
                   const gchar* method,
                   GVariant* id,
                   GVariant* params)
{
	LspDocumentRangeFormattingParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* source_file = NULL;
	LspDocumentRangeFormattingParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	JsonArray* json_array = NULL;
	JsonArray* _tmp14_;
	LspTextEdit* edited = NULL;
	VlsCodeStyleAnalyzer* code_style = NULL;
	VlsCompilation* _tmp15_;
	ValaSourceFile* _tmp16_;
	gpointer _tmp17_;
	JsonArray* _tmp35_;
	LspTextEdit* _tmp36_;
	JsonNode* _tmp37_;
	GError* _inner_error0_ = NULL;
#line 1615 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1615 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1615 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1615 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1615 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1616 "../src/server.vala"
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_DOCUMENT_RANGE_FORMATTING_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1616 "../src/server.vala"
	p = (LspDocumentRangeFormattingParams*) _tmp0_;
#line 1619 "../src/server.vala"
	_tmp1_ = p;
#line 1619 "../src/server.vala"
	_tmp2_ = lsp_document_range_formatting_params_get_textDocument (_tmp1_);
#line 1619 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 1619 "../src/server.vala"
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
#line 1619 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 1619 "../src/server.vala"
	_tmp7_ = vls_server_find_file (self, _tmp5_, &_tmp6_, NULL);
#line 1619 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1619 "../src/server.vala"
	compilation = _tmp6_;
#line 1619 "../src/server.vala"
	source_file = _tmp7_;
#line 1620 "../src/server.vala"
	_tmp8_ = source_file;
#line 1620 "../src/server.vala"
	if (_tmp8_ == NULL) {
#line 16386 "server.c"
		LspDocumentRangeFormattingParams* _tmp9_;
		LspTextDocumentIdentifier* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 1621 "../src/server.vala"
		_tmp9_ = p;
#line 1621 "../src/server.vala"
		_tmp10_ = lsp_document_range_formatting_params_get_textDocument (_tmp9_);
#line 1621 "../src/server.vala"
		_tmp11_ = _tmp10_;
#line 1621 "../src/server.vala"
		_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
#line 1621 "../src/server.vala"
		_tmp13_ = _tmp12_;
#line 1621 "../src/server.vala"
		g_debug ("server.vala:1621: [%s] file `%s' not found", method, _tmp13_);
#line 1622 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 1623 "../src/server.vala"
		_vala_source_file_unref0 (source_file);
#line 1623 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1623 "../src/server.vala"
		_g_object_unref0 (p);
#line 1623 "../src/server.vala"
		return;
#line 16414 "server.c"
	}
#line 1626 "../src/server.vala"
	_tmp14_ = json_array_new ();
#line 1626 "../src/server.vala"
	json_array = _tmp14_;
#line 1628 "../src/server.vala"
	_tmp15_ = compilation;
#line 1628 "../src/server.vala"
	_tmp16_ = source_file;
#line 1628 "../src/server.vala"
	_tmp17_ = vls_compilation_get_analysis_for_file (_tmp15_, VLS_TYPE_CODE_STYLE_ANALYZER, (GBoxedCopyFunc) vala_code_visitor_ref, (GDestroyNotify) vala_code_visitor_unref, _tmp16_);
#line 1628 "../src/server.vala"
	code_style = (VlsCodeStyleAnalyzer*) _tmp17_;
#line 16428 "server.c"
	{
		LspTextEdit* _tmp18_ = NULL;
		LspDocumentRangeFormattingParams* _tmp19_;
		LspFormattingOptions* _tmp20_;
		LspFormattingOptions* _tmp21_;
		VlsCodeStyleAnalyzer* _tmp22_;
		ValaSourceFile* _tmp23_;
		LspDocumentRangeFormattingParams* _tmp24_;
		LspRange* _tmp25_;
		LspRange* _tmp26_;
		GCancellable* _tmp27_;
		LspTextEdit* _tmp28_;
		LspTextEdit* _tmp29_;
#line 1630 "../src/server.vala"
		_tmp19_ = p;
#line 1630 "../src/server.vala"
		_tmp20_ = lsp_document_range_formatting_params_get_options (_tmp19_);
#line 1630 "../src/server.vala"
		_tmp21_ = _tmp20_;
#line 1630 "../src/server.vala"
		_tmp22_ = code_style;
#line 1630 "../src/server.vala"
		_tmp23_ = source_file;
#line 1630 "../src/server.vala"
		_tmp24_ = p;
#line 1630 "../src/server.vala"
		_tmp25_ = lsp_document_range_formatting_params_get_range (_tmp24_);
#line 1630 "../src/server.vala"
		_tmp26_ = _tmp25_;
#line 1630 "../src/server.vala"
		_tmp27_ = vls_server_cancellable;
#line 1630 "../src/server.vala"
		_tmp28_ = vls_formatter_format (_tmp21_, _tmp22_, _tmp23_, _tmp26_, _tmp27_, &_inner_error0_);
#line 1630 "../src/server.vala"
		_tmp18_ = _tmp28_;
#line 1630 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16466 "server.c"
			goto __catch0_g_error;
		}
#line 1630 "../src/server.vala"
		_tmp29_ = _tmp18_;
#line 1630 "../src/server.vala"
		_tmp18_ = NULL;
#line 1630 "../src/server.vala"
		_g_object_unref0 (edited);
#line 1630 "../src/server.vala"
		edited = _tmp29_;
#line 1629 "../src/server.vala"
		_g_object_unref0 (_tmp18_);
#line 16479 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp30_;
		const gchar* _tmp31_;
		GCancellable* _tmp32_;
		GError* _tmp33_;
		const gchar* _tmp34_;
#line 1629 "../src/server.vala"
		e = _inner_error0_;
#line 1629 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1632 "../src/server.vala"
		_tmp30_ = e;
#line 1632 "../src/server.vala"
		_tmp31_ = _tmp30_->message;
#line 1632 "../src/server.vala"
		_tmp32_ = vls_server_cancellable;
#line 1632 "../src/server.vala"
		jsonrpc_client_reply_error_async (client, id, (gint) JSONRPC_CLIENT_ERROR_INTERNAL_ERROR, _tmp31_, _tmp32_, NULL, NULL);
#line 1637 "../src/server.vala"
		_tmp33_ = e;
#line 1637 "../src/server.vala"
		_tmp34_ = _tmp33_->message;
#line 1637 "../src/server.vala"
		g_warning ("server.vala:1637: Formatting failed: %s", _tmp34_);
#line 1638 "../src/server.vala"
		_g_error_free0 (e);
#line 1638 "../src/server.vala"
		_vala_code_visitor_unref0 (code_style);
#line 1638 "../src/server.vala"
		_g_object_unref0 (edited);
#line 1638 "../src/server.vala"
		_json_array_unref0 (json_array);
#line 1638 "../src/server.vala"
		_vala_source_file_unref0 (source_file);
#line 1638 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1638 "../src/server.vala"
		_g_object_unref0 (p);
#line 1638 "../src/server.vala"
		return;
#line 16524 "server.c"
	}
	__finally0:
#line 1629 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1629 "../src/server.vala"
		_vala_code_visitor_unref0 (code_style);
#line 1629 "../src/server.vala"
		_g_object_unref0 (edited);
#line 1629 "../src/server.vala"
		_json_array_unref0 (json_array);
#line 1629 "../src/server.vala"
		_vala_source_file_unref0 (source_file);
#line 1629 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1629 "../src/server.vala"
		_g_object_unref0 (p);
#line 1629 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1629 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1629 "../src/server.vala"
		return;
#line 16547 "server.c"
	}
#line 1640 "../src/server.vala"
	_tmp35_ = json_array;
#line 1640 "../src/server.vala"
	_tmp36_ = edited;
#line 1640 "../src/server.vala"
	_tmp37_ = json_gobject_serialize ((GObject*) _tmp36_);
#line 1640 "../src/server.vala"
	json_array_add_element (_tmp35_, _tmp37_);
#line 16557 "server.c"
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp38_;
		JsonNode* _tmp39_;
		JsonArray* _tmp40_;
		JsonNode* _tmp41_;
		GVariant* _tmp42_;
		GVariant* _tmp43_;
		GVariant* _tmp44_;
		GCancellable* _tmp45_;
#line 1642 "../src/server.vala"
		_tmp38_ = json_node_alloc ();
#line 1642 "../src/server.vala"
		_tmp39_ = _tmp38_;
#line 1642 "../src/server.vala"
		_tmp40_ = json_array;
#line 1642 "../src/server.vala"
		_tmp41_ = json_node_init_array (_tmp39_, _tmp40_);
#line 1642 "../src/server.vala"
		_tmp42_ = json_gvariant_deserialize (_tmp41_, NULL, &_inner_error0_);
#line 1642 "../src/server.vala"
		if (_tmp42_ != NULL) {
#line 1642 "../src/server.vala"
			g_variant_ref_sink (_tmp42_);
#line 16582 "server.c"
		}
#line 1642 "../src/server.vala"
		_tmp43_ = _tmp42_;
#line 1642 "../src/server.vala"
		__vala_JsonNode_free0 (_tmp39_);
#line 1642 "../src/server.vala"
		variant_array = _tmp43_;
#line 1642 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16592 "server.c"
			goto __catch1_g_error;
		}
#line 1643 "../src/server.vala"
		_tmp44_ = variant_array;
#line 1643 "../src/server.vala"
		_tmp45_ = vls_server_cancellable;
#line 1643 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp44_, _tmp45_, &_inner_error0_);
#line 1643 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1643 "../src/server.vala"
			_g_variant_unref0 (variant_array);
#line 16605 "server.c"
			goto __catch1_g_error;
		}
#line 1641 "../src/server.vala"
		_g_variant_unref0 (variant_array);
#line 16610 "server.c"
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp46_;
		GError* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
#line 1641 "../src/server.vala"
		e = _inner_error0_;
#line 1641 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1645 "../src/server.vala"
		_tmp46_ = string_to_string (method);
#line 1645 "../src/server.vala"
		_tmp47_ = e;
#line 1645 "../src/server.vala"
		_tmp48_ = _tmp47_->message;
#line 1645 "../src/server.vala"
		_tmp49_ = string_to_string (_tmp48_);
#line 1645 "../src/server.vala"
		_tmp50_ = g_strconcat ("[", _tmp46_, "] failed to reply to client: ", _tmp49_, NULL);
#line 1645 "../src/server.vala"
		_tmp51_ = _tmp50_;
#line 1645 "../src/server.vala"
		g_debug ("server.vala:1645: %s", _tmp51_);
#line 1645 "../src/server.vala"
		_g_free0 (_tmp51_);
#line 1641 "../src/server.vala"
		_g_error_free0 (e);
#line 16644 "server.c"
	}
	__finally1:
#line 1641 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1641 "../src/server.vala"
		_vala_code_visitor_unref0 (code_style);
#line 1641 "../src/server.vala"
		_g_object_unref0 (edited);
#line 1641 "../src/server.vala"
		_json_array_unref0 (json_array);
#line 1641 "../src/server.vala"
		_vala_source_file_unref0 (source_file);
#line 1641 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1641 "../src/server.vala"
		_g_object_unref0 (p);
#line 1641 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1641 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1641 "../src/server.vala"
		return;
#line 16667 "server.c"
	}
#line 1615 "../src/server.vala"
	_vala_code_visitor_unref0 (code_style);
#line 1615 "../src/server.vala"
	_g_object_unref0 (edited);
#line 1615 "../src/server.vala"
	_json_array_unref0 (json_array);
#line 1615 "../src/server.vala"
	_vala_source_file_unref0 (source_file);
#line 1615 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1615 "../src/server.vala"
	_g_object_unref0 (p);
#line 16681 "server.c"
}

static void
vls_server_code_action (VlsServer* self,
                        JsonrpcClient* client,
                        const gchar* method,
                        GVariant* id,
                        GVariant* params)
{
	LspCodeActionParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* source_file = NULL;
	LspCodeActionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp14_;
	JsonArray* json_array = NULL;
	JsonArray* _tmp15_;
	VlsCompilation* _tmp16_;
	ValaCodeContext* _tmp17_;
	ValaCodeContext* _tmp18_;
	ValaCollection* code_actions = NULL;
	LspCodeActionParams* _tmp19_;
	LspCodeActionContext* _tmp20_;
	LspCodeActionContext* _tmp21_;
	VlsCompilation* _tmp22_;
	ValaSourceFile* _tmp23_;
	LspCodeActionParams* _tmp24_;
	LspRange* _tmp25_;
	LspRange* _tmp26_;
	LspCodeActionParams* _tmp27_;
	LspTextDocumentIdentifier* _tmp28_;
	LspTextDocumentIdentifier* _tmp29_;
	const gchar* _tmp30_;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	ValaCollection* _tmp34_;
	ValaCollection* _tmp35_;
	GError* _inner_error0_ = NULL;
#line 1649 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1649 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1649 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1649 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1649 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1650 "../src/server.vala"
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_CODE_ACTION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1650 "../src/server.vala"
	p = (LspCodeActionParams*) _tmp0_;
#line 1653 "../src/server.vala"
	_tmp1_ = p;
#line 1653 "../src/server.vala"
	_tmp2_ = lsp_code_action_params_get_textDocument (_tmp1_);
#line 1653 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 1653 "../src/server.vala"
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
#line 1653 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 1653 "../src/server.vala"
	_tmp7_ = vls_server_find_file (self, _tmp5_, &_tmp6_, NULL);
#line 1653 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1653 "../src/server.vala"
	compilation = _tmp6_;
#line 1653 "../src/server.vala"
	source_file = _tmp7_;
#line 1654 "../src/server.vala"
	_tmp8_ = source_file;
#line 1654 "../src/server.vala"
	if (_tmp8_ == NULL) {
#line 16764 "server.c"
		LspCodeActionParams* _tmp9_;
		LspTextDocumentIdentifier* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 1655 "../src/server.vala"
		_tmp9_ = p;
#line 1655 "../src/server.vala"
		_tmp10_ = lsp_code_action_params_get_textDocument (_tmp9_);
#line 1655 "../src/server.vala"
		_tmp11_ = _tmp10_;
#line 1655 "../src/server.vala"
		_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
#line 1655 "../src/server.vala"
		_tmp13_ = _tmp12_;
#line 1655 "../src/server.vala"
		g_debug ("server.vala:1655: [%s] file `%s' not found", method, _tmp13_);
#line 1656 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 1657 "../src/server.vala"
		_vala_source_file_unref0 (source_file);
#line 1657 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1657 "../src/server.vala"
		_g_object_unref0 (p);
#line 1657 "../src/server.vala"
		return;
#line 16792 "server.c"
	}
#line 1660 "../src/server.vala"
	_tmp14_ = source_file;
#line 1660 "../src/server.vala"
	if (!VLS_IS_TEXT_DOCUMENT (_tmp14_)) {
#line 1661 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 1662 "../src/server.vala"
		_vala_source_file_unref0 (source_file);
#line 1662 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1662 "../src/server.vala"
		_g_object_unref0 (p);
#line 1662 "../src/server.vala"
		return;
#line 16808 "server.c"
	}
#line 1664 "../src/server.vala"
	_tmp15_ = json_array_new ();
#line 1664 "../src/server.vala"
	json_array = _tmp15_;
#line 1666 "../src/server.vala"
	_tmp16_ = compilation;
#line 1666 "../src/server.vala"
	_tmp17_ = vls_compilation_get_code_context (_tmp16_);
#line 1666 "../src/server.vala"
	_tmp18_ = _tmp17_;
#line 1666 "../src/server.vala"
	vala_code_context_push (_tmp18_);
#line 1667 "../src/server.vala"
	_tmp19_ = p;
#line 1667 "../src/server.vala"
	_tmp20_ = lsp_code_action_params_get_context (_tmp19_);
#line 1667 "../src/server.vala"
	_tmp21_ = _tmp20_;
#line 1667 "../src/server.vala"
	_tmp22_ = compilation;
#line 1667 "../src/server.vala"
	_tmp23_ = source_file;
#line 1667 "../src/server.vala"
	_tmp24_ = p;
#line 1667 "../src/server.vala"
	_tmp25_ = lsp_code_action_params_get_range (_tmp24_);
#line 1667 "../src/server.vala"
	_tmp26_ = _tmp25_;
#line 1667 "../src/server.vala"
	_tmp27_ = p;
#line 1667 "../src/server.vala"
	_tmp28_ = lsp_code_action_params_get_textDocument (_tmp27_);
#line 1667 "../src/server.vala"
	_tmp29_ = _tmp28_;
#line 1667 "../src/server.vala"
	_tmp30_ = lsp_text_document_identifier_get_uri (_tmp29_);
#line 1667 "../src/server.vala"
	_tmp31_ = _tmp30_;
#line 1667 "../src/server.vala"
	_tmp32_ = g_uri_unescape_string (_tmp31_, NULL);
#line 1667 "../src/server.vala"
	_tmp33_ = _tmp32_;
#line 1667 "../src/server.vala"
	_tmp34_ = vls_code_actions_extract (_tmp21_, _tmp22_, G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument), _tmp26_, _tmp33_);
#line 1667 "../src/server.vala"
	_tmp35_ = _tmp34_;
#line 1667 "../src/server.vala"
	_g_free0 (_tmp33_);
#line 1667 "../src/server.vala"
	code_actions = _tmp35_;
#line 16860 "server.c"
	{
		ValaIterator* _action_it = NULL;
		ValaCollection* _tmp36_;
		ValaIterator* _tmp37_;
#line 1669 "../src/server.vala"
		_tmp36_ = code_actions;
#line 1669 "../src/server.vala"
		_tmp37_ = vala_iterable_iterator ((ValaIterable*) _tmp36_);
#line 1669 "../src/server.vala"
		_action_it = _tmp37_;
#line 1669 "../src/server.vala"
		while (TRUE) {
#line 16873 "server.c"
			ValaIterator* _tmp38_;
			LspCodeAction* action = NULL;
			ValaIterator* _tmp39_;
			gpointer _tmp40_;
			JsonArray* _tmp41_;
			LspCodeAction* _tmp42_;
			JsonNode* _tmp43_;
#line 1669 "../src/server.vala"
			_tmp38_ = _action_it;
#line 1669 "../src/server.vala"
			if (!vala_iterator_next (_tmp38_)) {
#line 1669 "../src/server.vala"
				break;
#line 16887 "server.c"
			}
#line 1669 "../src/server.vala"
			_tmp39_ = _action_it;
#line 1669 "../src/server.vala"
			_tmp40_ = vala_iterator_get (_tmp39_);
#line 1669 "../src/server.vala"
			action = (LspCodeAction*) _tmp40_;
#line 1670 "../src/server.vala"
			_tmp41_ = json_array;
#line 1670 "../src/server.vala"
			_tmp42_ = action;
#line 1670 "../src/server.vala"
			_tmp43_ = json_gobject_serialize ((GObject*) _tmp42_);
#line 1670 "../src/server.vala"
			json_array_add_element (_tmp41_, _tmp43_);
#line 1669 "../src/server.vala"
			_g_object_unref0 (action);
#line 16905 "server.c"
		}
#line 1669 "../src/server.vala"
		_vala_iterator_unref0 (_action_it);
#line 16909 "server.c"
	}
#line 1671 "../src/server.vala"
	vala_code_context_pop ();
#line 16913 "server.c"
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp44_;
		JsonNode* _tmp45_;
		JsonArray* _tmp46_;
		JsonNode* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		GCancellable* _tmp51_;
#line 1673 "../src/server.vala"
		_tmp44_ = json_node_alloc ();
#line 1673 "../src/server.vala"
		_tmp45_ = _tmp44_;
#line 1673 "../src/server.vala"
		_tmp46_ = json_array;
#line 1673 "../src/server.vala"
		_tmp47_ = json_node_init_array (_tmp45_, _tmp46_);
#line 1673 "../src/server.vala"
		_tmp48_ = json_gvariant_deserialize (_tmp47_, NULL, &_inner_error0_);
#line 1673 "../src/server.vala"
		if (_tmp48_ != NULL) {
#line 1673 "../src/server.vala"
			g_variant_ref_sink (_tmp48_);
#line 16938 "server.c"
		}
#line 1673 "../src/server.vala"
		_tmp49_ = _tmp48_;
#line 1673 "../src/server.vala"
		__vala_JsonNode_free0 (_tmp45_);
#line 1673 "../src/server.vala"
		variant_array = _tmp49_;
#line 1673 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 16948 "server.c"
			goto __catch0_g_error;
		}
#line 1674 "../src/server.vala"
		_tmp50_ = variant_array;
#line 1674 "../src/server.vala"
		_tmp51_ = vls_server_cancellable;
#line 1674 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp50_, _tmp51_, &_inner_error0_);
#line 1674 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1674 "../src/server.vala"
			_g_variant_unref0 (variant_array);
#line 16961 "server.c"
			goto __catch0_g_error;
		}
#line 1672 "../src/server.vala"
		_g_variant_unref0 (variant_array);
#line 16966 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp52_;
		GError* _tmp53_;
		const gchar* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 1672 "../src/server.vala"
		e = _inner_error0_;
#line 1672 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1676 "../src/server.vala"
		_tmp52_ = string_to_string (method);
#line 1676 "../src/server.vala"
		_tmp53_ = e;
#line 1676 "../src/server.vala"
		_tmp54_ = _tmp53_->message;
#line 1676 "../src/server.vala"
		_tmp55_ = string_to_string (_tmp54_);
#line 1676 "../src/server.vala"
		_tmp56_ = g_strconcat ("[", _tmp52_, "] failed to reply to client: ", _tmp55_, NULL);
#line 1676 "../src/server.vala"
		_tmp57_ = _tmp56_;
#line 1676 "../src/server.vala"
		g_debug ("server.vala:1676: %s", _tmp57_);
#line 1676 "../src/server.vala"
		_g_free0 (_tmp57_);
#line 1672 "../src/server.vala"
		_g_error_free0 (e);
#line 17000 "server.c"
	}
	__finally0:
#line 1672 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1672 "../src/server.vala"
		_vala_iterable_unref0 (code_actions);
#line 1672 "../src/server.vala"
		_json_array_unref0 (json_array);
#line 1672 "../src/server.vala"
		_vala_source_file_unref0 (source_file);
#line 1672 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1672 "../src/server.vala"
		_g_object_unref0 (p);
#line 1672 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1672 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1672 "../src/server.vala"
		return;
#line 17021 "server.c"
	}
#line 1649 "../src/server.vala"
	_vala_iterable_unref0 (code_actions);
#line 1649 "../src/server.vala"
	_json_array_unref0 (json_array);
#line 1649 "../src/server.vala"
	_vala_source_file_unref0 (source_file);
#line 1649 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1649 "../src/server.vala"
	_g_object_unref0 (p);
#line 17033 "server.c"
}

static Block36Data*
block36_data_ref (Block36Data* _data36_)
{
#line 1680 "../src/server.vala"
	g_atomic_int_inc (&_data36_->_ref_count_);
#line 1680 "../src/server.vala"
	return _data36_;
#line 17043 "server.c"
}

static void
block36_data_unref (void * _userdata_)
{
	Block36Data* _data36_;
	_data36_ = (Block36Data*) _userdata_;
#line 1680 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data36_->_ref_count_)) {
#line 17053 "server.c"
		VlsServer* self;
#line 1680 "../src/server.vala"
		self = _data36_->self;
#line 1680 "../src/server.vala"
		_g_free0 (_data36_->query);
#line 1680 "../src/server.vala"
		_g_object_unref0 (_data36_->client);
#line 1680 "../src/server.vala"
		_g_free0 (_data36_->method);
#line 1680 "../src/server.vala"
		_g_variant_unref0 (_data36_->id);
#line 1680 "../src/server.vala"
		_g_object_unref0 (self);
#line 1680 "../src/server.vala"
		g_slice_free (Block36Data, _data36_);
#line 17069 "server.c"
	}
}

static gchar*
_variant_get10 (GVariant* value)
{
#line 1681 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 17078 "server.c"
}

static Block37Data*
block37_data_ref (Block37Data* _data37_)
{
#line 1683 "../src/server.vala"
	g_atomic_int_inc (&_data37_->_ref_count_);
#line 1683 "../src/server.vala"
	return _data37_;
#line 17088 "server.c"
}

static void
block37_data_unref (void * _userdata_)
{
	Block37Data* _data37_;
	_data37_ = (Block37Data*) _userdata_;
#line 1683 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data37_->_ref_count_)) {
#line 17098 "server.c"
		VlsServer* self;
#line 1683 "../src/server.vala"
		self = _data37_->_data36_->self;
#line 1683 "../src/server.vala"
		_json_array_unref0 (_data37_->json_array);
#line 1683 "../src/server.vala"
		block36_data_unref (_data37_->_data36_);
#line 1683 "../src/server.vala"
		_data37_->_data36_ = NULL;
#line 1683 "../src/server.vala"
		g_slice_free (Block37Data, _data37_);
#line 17110 "server.c"
	}
}

static VlsProject**
_vala_array_dup17 (VlsProject** self,
                   gssize length)
{
#line 1690 "../src/server.vala"
	if (length >= 0) {
#line 17120 "server.c"
		VlsProject** result;
		gssize i;
#line 1690 "../src/server.vala"
		result = g_new0 (VlsProject*, length + 1);
#line 1690 "../src/server.vala"
		for (i = 0; i < length; i++) {
#line 17127 "server.c"
			VlsProject* _tmp0_;
#line 1690 "../src/server.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1690 "../src/server.vala"
			result[i] = _tmp0_;
#line 17133 "server.c"
		}
#line 1690 "../src/server.vala"
		return result;
#line 17137 "server.c"
	}
#line 1690 "../src/server.vala"
	return NULL;
#line 17141 "server.c"
}

static void
_vala_array_add29 (VlsProject** * array,
                   gint* length,
                   gint* size,
                   VlsProject* value)
{
#line 1691 "../src/server.vala"
	if ((*length) == (*size)) {
#line 1691 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 1691 "../src/server.vala"
		*array = g_renew (VlsProject*, *array, (*size) + 1);
#line 17156 "server.c"
	}
#line 1691 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 1691 "../src/server.vala"
	(*array)[*length] = NULL;
#line 17162 "server.c"
}

static gboolean
_______lambda72_ (Block37Data* _data37_,
                  LspSymbolInformation* dsym)
{
	Block36Data* _data36_;
	VlsServer* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gboolean result;
#line 1703 "../src/server.vala"
	_data36_ = _data37_->_data36_;
#line 1703 "../src/server.vala"
	self = _data36_->self;
#line 1703 "../src/server.vala"
	g_return_val_if_fail (dsym != NULL, FALSE);
#line 1703 "../src/server.vala"
	_tmp0_ = lsp_symbol_information_get_name (dsym);
#line 1703 "../src/server.vala"
	_tmp1_ = _tmp0_;
#line 1703 "../src/server.vala"
	result = g_str_match_string (_data36_->query, _tmp1_, TRUE);
#line 1703 "../src/server.vala"
	return result;
#line 17188 "server.c"
}

static gboolean
________lambda72__gee_predicate (gconstpointer g,
                                 gpointer self)
{
	gboolean result;
	result = _______lambda72_ (self, (LspSymbolInformation*) g);
#line 1699 "../src/server.vala"
	return result;
#line 17199 "server.c"
}

static gboolean
_______lambda73_ (Block37Data* _data37_,
                  LspSymbolInformation* dsym)
{
	Block36Data* _data36_;
	VlsServer* self;
	JsonArray* _tmp0_;
	JsonNode* _tmp1_;
	gboolean result;
#line 1704 "../src/server.vala"
	_data36_ = _data37_->_data36_;
#line 1704 "../src/server.vala"
	self = _data36_->self;
#line 1704 "../src/server.vala"
	g_return_val_if_fail (dsym != NULL, FALSE);
#line 1705 "../src/server.vala"
	_tmp0_ = _data37_->json_array;
#line 1705 "../src/server.vala"
	_tmp1_ = json_gobject_serialize ((GObject*) dsym);
#line 1705 "../src/server.vala"
	json_array_add_element (_tmp0_, _tmp1_);
#line 1706 "../src/server.vala"
	result = TRUE;
#line 1706 "../src/server.vala"
	_g_object_unref0 (dsym);
#line 1706 "../src/server.vala"
	return result;
#line 17229 "server.c"
}

static gboolean
________lambda73__gee_forall_func (gpointer g,
                                   gpointer self)
{
	gboolean result;
	result = _______lambda73_ (self, (LspSymbolInformation*) g);
#line 1699 "../src/server.vala"
	return result;
#line 17240 "server.c"
}

static void
__lambda71_ (Block36Data* _data36_,
             gboolean request_cancelled)
{
	VlsServer* self;
	Block37Data* _data37_;
	JsonArray* _tmp0_;
	VlsProject** all_projects = NULL;
	GHashTable* _tmp1_;
	guint _tmp2_ = 0;
	gconstpointer* _tmp3_;
	VlsProject** _tmp4_;
	gint _tmp4__length1;
	gint all_projects_length1;
	gint _all_projects_size_;
	VlsDefaultProject* _tmp5_;
	VlsProject* _tmp6_;
	VlsProject** _tmp7_;
	gint _tmp7__length1;
	const gchar* _tmp37_;
	JsonArray* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GError* _inner_error0_ = NULL;
#line 1683 "../src/server.vala"
	self = _data36_->self;
#line 1683 "../src/server.vala"
	_data37_ = g_slice_new0 (Block37Data);
#line 1683 "../src/server.vala"
	_data37_->_ref_count_ = 1;
#line 1683 "../src/server.vala"
	_data37_->_data36_ = block36_data_ref (_data36_);
#line 1684 "../src/server.vala"
	if (request_cancelled) {
#line 1685 "../src/server.vala"
		vls_server_reply_null (_data36_->id, _data36_->client, _data36_->method);
#line 1686 "../src/server.vala"
		block37_data_unref (_data37_);
#line 1686 "../src/server.vala"
		_data37_ = NULL;
#line 1686 "../src/server.vala"
		return;
#line 17288 "server.c"
	}
#line 1689 "../src/server.vala"
	_tmp0_ = json_array_new ();
#line 1689 "../src/server.vala"
	_data37_->json_array = _tmp0_;
#line 1690 "../src/server.vala"
	_tmp1_ = self->priv->projects;
#line 1690 "../src/server.vala"
	_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
#line 1690 "../src/server.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup17 (_tmp3_, _tmp2_) : _tmp3_;
#line 1690 "../src/server.vala"
	_tmp4__length1 = _tmp2_;
#line 1690 "../src/server.vala"
	_tmp3_ = (g_free (_tmp3_), NULL);
#line 1690 "../src/server.vala"
	all_projects = _tmp4_;
#line 1690 "../src/server.vala"
	all_projects_length1 = _tmp4__length1;
#line 1690 "../src/server.vala"
	_all_projects_size_ = all_projects_length1;
#line 1691 "../src/server.vala"
	_tmp5_ = self->priv->default_project;
#line 1691 "../src/server.vala"
	_tmp6_ = _g_object_ref0 ((VlsProject*) _tmp5_);
#line 1691 "../src/server.vala"
	_vala_array_add29 (&all_projects, &all_projects_length1, &_all_projects_size_, _tmp6_);
#line 1692 "../src/server.vala"
	_tmp7_ = all_projects;
#line 1692 "../src/server.vala"
	_tmp7__length1 = all_projects_length1;
#line 17320 "server.c"
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
#line 1692 "../src/server.vala"
		project_collection = _tmp7_;
#line 1692 "../src/server.vala"
		project_collection_length1 = _tmp7__length1;
#line 1692 "../src/server.vala"
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
#line 17332 "server.c"
			VlsProject* _tmp8_;
			VlsProject* project = NULL;
#line 1692 "../src/server.vala"
			_tmp8_ = _g_object_ref0 (project_collection[project_it]);
#line 1692 "../src/server.vala"
			project = _tmp8_;
#line 17339 "server.c"
			{
				{
					GeeIterator* _source_pair_it = NULL;
					VlsProject* _tmp9_;
					GeeIterable* _tmp10_;
					GeeIterable* _tmp11_;
					GeeIterator* _tmp12_;
					GeeIterator* _tmp13_;
#line 1693 "../src/server.vala"
					_tmp9_ = project;
#line 1693 "../src/server.vala"
					_tmp10_ = vls_project_get_project_source_files (_tmp9_);
#line 1693 "../src/server.vala"
					_tmp11_ = _tmp10_;
#line 1693 "../src/server.vala"
					_tmp12_ = gee_iterable_iterator (_tmp11_);
#line 1693 "../src/server.vala"
					_tmp13_ = _tmp12_;
#line 1693 "../src/server.vala"
					_g_object_unref0 (_tmp11_);
#line 1693 "../src/server.vala"
					_source_pair_it = _tmp13_;
#line 1693 "../src/server.vala"
					while (TRUE) {
#line 17364 "server.c"
						GeeIterator* _tmp14_;
						GeeMapEntry* source_pair = NULL;
						GeeIterator* _tmp15_;
						gpointer _tmp16_;
						ValaSourceFile* text_document = NULL;
						GeeMapEntry* _tmp17_;
						gconstpointer _tmp18_;
						gconstpointer _tmp19_;
						ValaSourceFile* _tmp20_;
						VlsCompilation* compilation = NULL;
						GeeMapEntry* _tmp21_;
						gconstpointer _tmp22_;
						gconstpointer _tmp23_;
						VlsCompilation* _tmp24_;
						VlsCompilation* _tmp25_;
						ValaCodeContext* _tmp26_;
						ValaCodeContext* _tmp27_;
						VlsSymbolEnumerator* symbol_enumerator = NULL;
						VlsCompilation* _tmp28_;
						ValaSourceFile* _tmp29_;
						gpointer _tmp30_;
						VlsSymbolEnumerator* _tmp31_;
#line 1693 "../src/server.vala"
						_tmp14_ = _source_pair_it;
#line 1693 "../src/server.vala"
						if (!gee_iterator_next (_tmp14_)) {
#line 1693 "../src/server.vala"
							break;
#line 17393 "server.c"
						}
#line 1693 "../src/server.vala"
						_tmp15_ = _source_pair_it;
#line 1693 "../src/server.vala"
						_tmp16_ = gee_iterator_get (_tmp15_);
#line 1693 "../src/server.vala"
						source_pair = (GeeMapEntry*) _tmp16_;
#line 1694 "../src/server.vala"
						_tmp17_ = source_pair;
#line 1694 "../src/server.vala"
						_tmp18_ = gee_map_entry_get_key (_tmp17_);
#line 1694 "../src/server.vala"
						_tmp19_ = _tmp18_;
#line 1694 "../src/server.vala"
						_tmp20_ = _vala_source_file_ref0 ((ValaSourceFile*) _tmp19_);
#line 1694 "../src/server.vala"
						text_document = _tmp20_;
#line 1695 "../src/server.vala"
						_tmp21_ = source_pair;
#line 1695 "../src/server.vala"
						_tmp22_ = gee_map_entry_get_value (_tmp21_);
#line 1695 "../src/server.vala"
						_tmp23_ = _tmp22_;
#line 1695 "../src/server.vala"
						_tmp24_ = _g_object_ref0 ((VlsCompilation*) _tmp23_);
#line 1695 "../src/server.vala"
						compilation = _tmp24_;
#line 1696 "../src/server.vala"
						_tmp25_ = compilation;
#line 1696 "../src/server.vala"
						_tmp26_ = vls_compilation_get_code_context (_tmp25_);
#line 1696 "../src/server.vala"
						_tmp27_ = _tmp26_;
#line 1696 "../src/server.vala"
						vala_code_context_push (_tmp27_);
#line 1697 "../src/server.vala"
						_tmp28_ = compilation;
#line 1697 "../src/server.vala"
						_tmp29_ = text_document;
#line 1697 "../src/server.vala"
						_tmp30_ = vls_compilation_get_analysis_for_file (_tmp28_, VLS_TYPE_SYMBOL_ENUMERATOR, (GBoxedCopyFunc) vala_code_visitor_ref, (GDestroyNotify) vala_code_visitor_unref, _tmp29_);
#line 1697 "../src/server.vala"
						symbol_enumerator = (VlsSymbolEnumerator*) _tmp30_;
#line 1698 "../src/server.vala"
						_tmp31_ = symbol_enumerator;
#line 1698 "../src/server.vala"
						if (_tmp31_ != NULL) {
#line 17441 "server.c"
							VlsSymbolEnumerator* _tmp32_;
							GeeIterable* _tmp33_;
							GeeIterable* _tmp34_;
							GeeIterator* _tmp35_;
							GeeIterator* _tmp36_;
#line 1699 "../src/server.vala"
							_tmp32_ = symbol_enumerator;
#line 1699 "../src/server.vala"
							_tmp33_ = vls_symbol_enumerator_flattened (_tmp32_);
#line 1699 "../src/server.vala"
							_tmp34_ = _tmp33_;
#line 1699 "../src/server.vala"
							_tmp35_ = gee_traversable_filter ((GeeTraversable*) _tmp34_, ________lambda72__gee_predicate, block37_data_ref (_data37_), block37_data_unref);
#line 1699 "../src/server.vala"
							_tmp36_ = _tmp35_;
#line 1699 "../src/server.vala"
							gee_traversable_foreach ((GeeTraversable*) _tmp36_, ________lambda73__gee_forall_func, _data37_);
#line 1699 "../src/server.vala"
							_g_object_unref0 (_tmp36_);
#line 1699 "../src/server.vala"
							_g_object_unref0 (_tmp34_);
#line 17463 "server.c"
						}
#line 1709 "../src/server.vala"
						vala_code_context_pop ();
#line 1693 "../src/server.vala"
						_vala_code_visitor_unref0 (symbol_enumerator);
#line 1693 "../src/server.vala"
						_g_object_unref0 (compilation);
#line 1693 "../src/server.vala"
						_vala_source_file_unref0 (text_document);
#line 1693 "../src/server.vala"
						_g_object_unref0 (source_pair);
#line 17475 "server.c"
					}
#line 1693 "../src/server.vala"
					_g_object_unref0 (_source_pair_it);
#line 17479 "server.c"
				}
#line 1692 "../src/server.vala"
				_g_object_unref0 (project);
#line 17483 "server.c"
			}
		}
	}
#line 1713 "../src/server.vala"
	_tmp37_ = string_to_string (_data36_->method);
#line 1713 "../src/server.vala"
	_tmp38_ = _data37_->json_array;
#line 1713 "../src/server.vala"
	_tmp39_ = g_strdup_printf ("%u", json_array_get_length (_tmp38_));
#line 1713 "../src/server.vala"
	_tmp40_ = _tmp39_;
#line 1713 "../src/server.vala"
	_tmp41_ = string_to_string (_data36_->query);
#line 1713 "../src/server.vala"
	_tmp42_ = g_strconcat ("[", _tmp37_, "] found ", _tmp40_, " element(s) matching `", _tmp41_, "'", NULL);
#line 1713 "../src/server.vala"
	_tmp43_ = _tmp42_;
#line 1713 "../src/server.vala"
	g_debug ("server.vala:1713: %s", _tmp43_);
#line 1713 "../src/server.vala"
	_g_free0 (_tmp43_);
#line 1713 "../src/server.vala"
	_g_free0 (_tmp40_);
#line 17507 "server.c"
	{
		GVariant* variant_array = NULL;
		JsonNode* _tmp44_;
		JsonNode* _tmp45_;
		JsonArray* _tmp46_;
		JsonNode* _tmp47_;
		GVariant* _tmp48_;
		GVariant* _tmp49_;
		GVariant* _tmp50_;
		GCancellable* _tmp51_;
#line 1715 "../src/server.vala"
		_tmp44_ = json_node_alloc ();
#line 1715 "../src/server.vala"
		_tmp45_ = _tmp44_;
#line 1715 "../src/server.vala"
		_tmp46_ = _data37_->json_array;
#line 1715 "../src/server.vala"
		_tmp47_ = json_node_init_array (_tmp45_, _tmp46_);
#line 1715 "../src/server.vala"
		_tmp48_ = json_gvariant_deserialize (_tmp47_, NULL, &_inner_error0_);
#line 1715 "../src/server.vala"
		if (_tmp48_ != NULL) {
#line 1715 "../src/server.vala"
			g_variant_ref_sink (_tmp48_);
#line 17532 "server.c"
		}
#line 1715 "../src/server.vala"
		_tmp49_ = _tmp48_;
#line 1715 "../src/server.vala"
		__vala_JsonNode_free0 (_tmp45_);
#line 1715 "../src/server.vala"
		variant_array = _tmp49_;
#line 1715 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 17542 "server.c"
			goto __catch0_g_error;
		}
#line 1716 "../src/server.vala"
		_tmp50_ = variant_array;
#line 1716 "../src/server.vala"
		_tmp51_ = vls_server_cancellable;
#line 1716 "../src/server.vala"
		jsonrpc_client_reply (_data36_->client, _data36_->id, _tmp50_, _tmp51_, &_inner_error0_);
#line 1716 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1716 "../src/server.vala"
			_g_variant_unref0 (variant_array);
#line 17555 "server.c"
			goto __catch0_g_error;
		}
#line 1714 "../src/server.vala"
		_g_variant_unref0 (variant_array);
#line 17560 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp52_;
		GError* _tmp53_;
		const gchar* _tmp54_;
		const gchar* _tmp55_;
		gchar* _tmp56_;
		gchar* _tmp57_;
#line 1714 "../src/server.vala"
		e = _inner_error0_;
#line 1714 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1718 "../src/server.vala"
		_tmp52_ = string_to_string (_data36_->method);
#line 1718 "../src/server.vala"
		_tmp53_ = e;
#line 1718 "../src/server.vala"
		_tmp54_ = _tmp53_->message;
#line 1718 "../src/server.vala"
		_tmp55_ = string_to_string (_tmp54_);
#line 1718 "../src/server.vala"
		_tmp56_ = g_strconcat ("[", _tmp52_, "] failed to reply to client: ", _tmp55_, NULL);
#line 1718 "../src/server.vala"
		_tmp57_ = _tmp56_;
#line 1718 "../src/server.vala"
		g_debug ("server.vala:1718: %s", _tmp57_);
#line 1718 "../src/server.vala"
		_g_free0 (_tmp57_);
#line 1714 "../src/server.vala"
		_g_error_free0 (e);
#line 17594 "server.c"
	}
	__finally0:
#line 1714 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1714 "../src/server.vala"
		all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1714 "../src/server.vala"
		block37_data_unref (_data37_);
#line 1714 "../src/server.vala"
		_data37_ = NULL;
#line 1714 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1714 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1714 "../src/server.vala"
		return;
#line 17611 "server.c"
	}
#line 1683 "../src/server.vala"
	all_projects = (_vala_array_free (all_projects, all_projects_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1683 "../src/server.vala"
	block37_data_unref (_data37_);
#line 1683 "../src/server.vala"
	_data37_ = NULL;
#line 17619 "server.c"
}

static void
___lambda71__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
#line 1683 "../src/server.vala"
	__lambda71_ (self, request_cancelled);
#line 17628 "server.c"
}

static void
vls_server_search_workspace_symbols (VlsServer* self,
                                     JsonrpcClient* client,
                                     const gchar* method,
                                     GVariant* id,
                                     GVariant* params)
{
	Block36Data* _data36_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
#line 1680 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1680 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1680 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1680 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1680 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1680 "../src/server.vala"
	_data36_ = g_slice_new0 (Block36Data);
#line 1680 "../src/server.vala"
	_data36_->_ref_count_ = 1;
#line 1680 "../src/server.vala"
	_data36_->self = g_object_ref (self);
#line 1680 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 1680 "../src/server.vala"
	_g_object_unref0 (_data36_->client);
#line 1680 "../src/server.vala"
	_data36_->client = _tmp0_;
#line 1680 "../src/server.vala"
	_tmp1_ = g_strdup (method);
#line 1680 "../src/server.vala"
	_g_free0 (_data36_->method);
#line 1680 "../src/server.vala"
	_data36_->method = _tmp1_;
#line 1680 "../src/server.vala"
	_tmp2_ = _g_variant_ref0 (id);
#line 1680 "../src/server.vala"
	_g_variant_unref0 (_data36_->id);
#line 1680 "../src/server.vala"
	_data36_->id = _tmp2_;
#line 1681 "../src/server.vala"
	_tmp3_ = G_VARIANT_TYPE_STRING;
#line 1681 "../src/server.vala"
	_tmp4_ = g_variant_lookup_value (params, "query", _tmp3_);
#line 1681 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 1681 "../src/server.vala"
	_tmp6_ = _variant_get10 (_tmp5_);
#line 1681 "../src/server.vala"
	_tmp7_ = _tmp6_;
#line 1681 "../src/server.vala"
	_g_variant_unref0 (_tmp5_);
#line 1681 "../src/server.vala"
	_data36_->query = _tmp7_;
#line 1683 "../src/server.vala"
	vls_server_wait_for_context_update (self, _data36_->id, ___lambda71__vls_server_on_context_updated_func, block36_data_ref (_data36_), block36_data_unref);
#line 1680 "../src/server.vala"
	block36_data_unref (_data36_);
#line 1680 "../src/server.vala"
	_data36_ = NULL;
#line 17701 "server.c"
}

static Block38Data*
block38_data_ref (Block38Data* _data38_)
{
#line 1723 "../src/server.vala"
	g_atomic_int_inc (&_data38_->_ref_count_);
#line 1723 "../src/server.vala"
	return _data38_;
#line 17711 "server.c"
}

static void
block38_data_unref (void * _userdata_)
{
	Block38Data* _data38_;
	_data38_ = (Block38Data*) _userdata_;
#line 1723 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data38_->_ref_count_)) {
#line 17721 "server.c"
		VlsServer* self;
#line 1723 "../src/server.vala"
		self = _data38_->self;
#line 1723 "../src/server.vala"
		_g_object_unref0 (_data38_->p);
#line 1723 "../src/server.vala"
		_g_free0 (_data38_->new_name);
#line 1723 "../src/server.vala"
		_g_object_unref0 (_data38_->client);
#line 1723 "../src/server.vala"
		_g_free0 (_data38_->method);
#line 1723 "../src/server.vala"
		_g_variant_unref0 (_data38_->id);
#line 1723 "../src/server.vala"
		_g_object_unref0 (self);
#line 1723 "../src/server.vala"
		g_slice_free (Block38Data, _data38_);
#line 17739 "server.c"
	}
}

static gchar*
_variant_get11 (GVariant* value)
{
#line 1724 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 17748 "server.c"
}

static void
__lambda74_ (Block38Data* _data38_,
             gboolean request_cancelled)
{
	VlsServer* self;
	LspPosition* pos = NULL;
	LspTextDocumentPositionParams* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	LspPosition* _tmp3_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentPositionParams* _tmp4_;
	LspTextDocumentIdentifier* _tmp5_;
	LspTextDocumentIdentifier* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	VlsCompilation* _tmp9_ = NULL;
	VlsProject* _tmp10_ = NULL;
	ValaSourceFile* _tmp11_;
	ValaSourceFile* _tmp12_;
	VlsCompilation* _tmp18_;
	ValaCodeContext* _tmp19_;
	ValaCodeContext* _tmp20_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp21_;
	LspPosition* _tmp22_;
	VlsNodeSearch* _tmp23_;
	VlsNodeSearch* _tmp24_;
	GeeList* _tmp25_;
	gint _tmp26_;
	gint _tmp27_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp31_;
	ValaSourceFile* _tmp32_;
	ValaCodeNode* _tmp33_;
	ValaSymbol* symbol = NULL;
	GeeHashMap* references = NULL;
	GeeHashMap* _tmp34_;
	gboolean _tmp35_ = FALSE;
	ValaCodeNode* _tmp36_;
	gboolean _tmp56_ = FALSE;
	ValaCodeNode* _tmp57_;
	ValaCodeNode* _tmp63_;
	ValaSymbol* _tmp64_;
	ValaSymbol* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	ValaSymbol* _tmp68_;
	ValaSourceReference* _tmp69_;
	ValaSourceReference* _tmp70_;
	gchar* _tmp71_;
	gchar* _tmp72_;
	GeeHashSet* generated_vapis = NULL;
	GeeHashSet* _tmp73_;
	GeeHashSet* shown_files = NULL;
	GeeHashSet* _tmp87_;
	gboolean _tmp88_ = FALSE;
	gboolean _tmp89_ = FALSE;
	gboolean _tmp90_ = FALSE;
	ValaSymbol* _tmp91_;
	gboolean is_abstract_or_virtual = FALSE;
	GeeHashMap* _tmp183_;
	gint _tmp184_;
	gint _tmp185_;
	GeeHashMap* edits = NULL;
	GeeHashMap* _tmp186_;
	GeeHashMap* source_files = NULL;
	GeeHashMap* _tmp187_;
	JsonArray* text_document_edits_json = NULL;
	JsonArray* _tmp248_;
	GError* _inner_error0_ = NULL;
#line 1738 "../src/server.vala"
	self = _data38_->self;
#line 1739 "../src/server.vala"
	if (request_cancelled) {
#line 1740 "../src/server.vala"
		vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
#line 1741 "../src/server.vala"
		return;
#line 17832 "server.c"
	}
#line 1744 "../src/server.vala"
	_tmp0_ = _data38_->p;
#line 1744 "../src/server.vala"
	_tmp1_ = lsp_text_document_position_params_get_position (_tmp0_);
#line 1744 "../src/server.vala"
	_tmp2_ = _tmp1_;
#line 1744 "../src/server.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1744 "../src/server.vala"
	pos = _tmp3_;
#line 1747 "../src/server.vala"
	_tmp4_ = _data38_->p;
#line 1747 "../src/server.vala"
	_tmp5_ = lsp_text_document_position_params_get_textDocument (_tmp4_);
#line 1747 "../src/server.vala"
	_tmp6_ = _tmp5_;
#line 1747 "../src/server.vala"
	_tmp7_ = lsp_text_document_identifier_get_uri (_tmp6_);
#line 1747 "../src/server.vala"
	_tmp8_ = _tmp7_;
#line 1747 "../src/server.vala"
	_tmp11_ = vls_server_find_file (self, _tmp8_, &_tmp9_, &_tmp10_);
#line 1747 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1747 "../src/server.vala"
	compilation = _tmp9_;
#line 1747 "../src/server.vala"
	_g_object_unref0 (project);
#line 1747 "../src/server.vala"
	project = _tmp10_;
#line 1747 "../src/server.vala"
	doc = _tmp11_;
#line 1748 "../src/server.vala"
	_tmp12_ = doc;
#line 1748 "../src/server.vala"
	if (_tmp12_ == NULL) {
#line 17870 "server.c"
		LspTextDocumentPositionParams* _tmp13_;
		LspTextDocumentIdentifier* _tmp14_;
		LspTextDocumentIdentifier* _tmp15_;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
#line 1749 "../src/server.vala"
		_tmp13_ = _data38_->p;
#line 1749 "../src/server.vala"
		_tmp14_ = lsp_text_document_position_params_get_textDocument (_tmp13_);
#line 1749 "../src/server.vala"
		_tmp15_ = _tmp14_;
#line 1749 "../src/server.vala"
		_tmp16_ = lsp_text_document_identifier_get_uri (_tmp15_);
#line 1749 "../src/server.vala"
		_tmp17_ = _tmp16_;
#line 1749 "../src/server.vala"
		g_debug ("server.vala:1749: [%s] file `%s' not found", _data38_->method, _tmp17_);
#line 1750 "../src/server.vala"
		vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
#line 1751 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1751 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1751 "../src/server.vala"
		_g_object_unref0 (project);
#line 1751 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1751 "../src/server.vala"
		return;
#line 17900 "server.c"
	}
#line 1754 "../src/server.vala"
	_tmp18_ = compilation;
#line 1754 "../src/server.vala"
	_tmp19_ = vls_compilation_get_code_context (_tmp18_);
#line 1754 "../src/server.vala"
	_tmp20_ = _tmp19_;
#line 1754 "../src/server.vala"
	vala_code_context_push (_tmp20_);
#line 1756 "../src/server.vala"
	_tmp21_ = doc;
#line 1756 "../src/server.vala"
	_tmp22_ = pos;
#line 1756 "../src/server.vala"
	_tmp23_ = vls_node_search_new (_tmp21_, _tmp22_, TRUE, NULL, TRUE);
#line 1756 "../src/server.vala"
	fs = _tmp23_;
#line 1758 "../src/server.vala"
	_tmp24_ = fs;
#line 1758 "../src/server.vala"
	_tmp25_ = _tmp24_->result;
#line 1758 "../src/server.vala"
	_tmp26_ = gee_collection_get_size ((GeeCollection*) _tmp25_);
#line 1758 "../src/server.vala"
	_tmp27_ = _tmp26_;
#line 1758 "../src/server.vala"
	if (_tmp27_ == 0) {
#line 17928 "server.c"
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
#line 1759 "../src/server.vala"
		_tmp28_ = string_to_string (_data38_->method);
#line 1759 "../src/server.vala"
		_tmp29_ = g_strconcat ("[", _tmp28_, "] no results found", NULL);
#line 1759 "../src/server.vala"
		_tmp30_ = _tmp29_;
#line 1759 "../src/server.vala"
		g_debug ("server.vala:1759: %s", _tmp30_);
#line 1759 "../src/server.vala"
		_g_free0 (_tmp30_);
#line 1760 "../src/server.vala"
		vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
#line 1761 "../src/server.vala"
		vala_code_context_pop ();
#line 1762 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1762 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1762 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1762 "../src/server.vala"
		_g_object_unref0 (project);
#line 1762 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1762 "../src/server.vala"
		return;
#line 17958 "server.c"
	}
#line 1765 "../src/server.vala"
	_tmp31_ = fs;
#line 1765 "../src/server.vala"
	_tmp32_ = doc;
#line 1765 "../src/server.vala"
	_tmp33_ = vls_server_get_best (_tmp31_, _tmp32_);
#line 1765 "../src/server.vala"
	_result_ = _tmp33_;
#line 1767 "../src/server.vala"
	_tmp34_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1767 "../src/server.vala"
	if (_tmp34_) {
#line 1767 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp34_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
#line 17974 "server.c"
	}
#line 1767 "../src/server.vala"
	references = _tmp34_;
#line 1769 "../src/server.vala"
	_tmp36_ = _result_;
#line 1769 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, VALA_TYPE_EXPRESSION)) {
#line 17982 "server.c"
		ValaCodeNode* _tmp37_;
		ValaSymbol* _tmp38_;
		ValaSymbol* _tmp39_;
#line 1769 "../src/server.vala"
		_tmp37_ = _result_;
#line 1769 "../src/server.vala"
		_tmp38_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 1769 "../src/server.vala"
		_tmp39_ = _tmp38_;
#line 1769 "../src/server.vala"
		_tmp35_ = _tmp39_ != NULL;
#line 17994 "server.c"
	} else {
#line 1769 "../src/server.vala"
		_tmp35_ = FALSE;
#line 17998 "server.c"
	}
#line 1769 "../src/server.vala"
	if (_tmp35_) {
#line 18002 "server.c"
		ValaCodeNode* _tmp40_;
		ValaSymbol* _tmp41_;
		ValaSymbol* _tmp42_;
		ValaCodeNode* _tmp43_;
#line 1770 "../src/server.vala"
		_tmp40_ = _result_;
#line 1770 "../src/server.vala"
		_tmp41_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 1770 "../src/server.vala"
		_tmp42_ = _tmp41_;
#line 1770 "../src/server.vala"
		_tmp43_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp42_);
#line 1770 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1770 "../src/server.vala"
		_result_ = _tmp43_;
#line 18019 "server.c"
	} else {
		ValaCodeNode* _tmp44_;
#line 1771 "../src/server.vala"
		_tmp44_ = _result_;
#line 1771 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_DATA_TYPE)) {
#line 18026 "server.c"
			ValaCodeNode* _tmp45_;
			ValaSymbol* _tmp46_;
#line 1772 "../src/server.vala"
			_tmp45_ = _result_;
#line 1772 "../src/server.vala"
			_tmp46_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 1772 "../src/server.vala"
			_vala_code_node_unref0 (_result_);
#line 1772 "../src/server.vala"
			_result_ = (ValaCodeNode*) _tmp46_;
#line 18037 "server.c"
		} else {
			gboolean _tmp47_ = FALSE;
			ValaCodeNode* _tmp48_;
#line 1773 "../src/server.vala"
			_tmp48_ = _result_;
#line 1773 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp48_, VALA_TYPE_USING_DIRECTIVE)) {
#line 18045 "server.c"
				ValaCodeNode* _tmp49_;
				ValaSymbol* _tmp50_;
				ValaSymbol* _tmp51_;
#line 1773 "../src/server.vala"
				_tmp49_ = _result_;
#line 1773 "../src/server.vala"
				_tmp50_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp49_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
#line 1773 "../src/server.vala"
				_tmp51_ = _tmp50_;
#line 1773 "../src/server.vala"
				_tmp47_ = _tmp51_ != NULL;
#line 18057 "server.c"
			} else {
#line 1773 "../src/server.vala"
				_tmp47_ = FALSE;
#line 18061 "server.c"
			}
#line 1773 "../src/server.vala"
			if (_tmp47_) {
#line 18065 "server.c"
				ValaCodeNode* _tmp52_;
				ValaSymbol* _tmp53_;
				ValaSymbol* _tmp54_;
				ValaCodeNode* _tmp55_;
#line 1774 "../src/server.vala"
				_tmp52_ = _result_;
#line 1774 "../src/server.vala"
				_tmp53_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
#line 1774 "../src/server.vala"
				_tmp54_ = _tmp53_;
#line 1774 "../src/server.vala"
				_tmp55_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp54_);
#line 1774 "../src/server.vala"
				_vala_code_node_unref0 (_result_);
#line 1774 "../src/server.vala"
				_result_ = _tmp55_;
#line 18082 "server.c"
			}
		}
	}
#line 1777 "../src/server.vala"
	_tmp57_ = _result_;
#line 1777 "../src/server.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_SYMBOL)) {
#line 1777 "../src/server.vala"
		_tmp56_ = TRUE;
#line 18092 "server.c"
	} else {
		gboolean _tmp58_ = FALSE;
		ValaCodeNode* _tmp59_;
#line 1778 "../src/server.vala"
		_tmp59_ = _result_;
#line 1778 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp59_, VALA_TYPE_METHOD)) {
#line 18100 "server.c"
			ValaCodeNode* _tmp60_;
			gboolean _tmp61_;
			gboolean _tmp62_;
#line 1778 "../src/server.vala"
			_tmp60_ = _result_;
#line 1778 "../src/server.vala"
			_tmp61_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, VALA_TYPE_METHOD, ValaMethod));
#line 1778 "../src/server.vala"
			_tmp62_ = _tmp61_;
#line 1778 "../src/server.vala"
			_tmp58_ = _tmp62_;
#line 18112 "server.c"
		} else {
#line 1778 "../src/server.vala"
			_tmp58_ = FALSE;
#line 18116 "server.c"
		}
#line 1778 "../src/server.vala"
		_tmp56_ = _tmp58_;
#line 18120 "server.c"
	}
#line 1777 "../src/server.vala"
	if (_tmp56_) {
#line 1779 "../src/server.vala"
		g_debug ("server.vala:1779: [%s] result is not a symbol", _data38_->method);
#line 1780 "../src/server.vala"
		vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
#line 1781 "../src/server.vala"
		vala_code_context_pop ();
#line 1782 "../src/server.vala"
		_g_object_unref0 (references);
#line 1782 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1782 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1782 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1782 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1782 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1782 "../src/server.vala"
		_g_object_unref0 (project);
#line 1782 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1782 "../src/server.vala"
		return;
#line 18148 "server.c"
	}
#line 1785 "../src/server.vala"
	_tmp63_ = _result_;
#line 1785 "../src/server.vala"
	_tmp64_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, VALA_TYPE_SYMBOL, ValaSymbol));
#line 1785 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 1785 "../src/server.vala"
	symbol = _tmp64_;
#line 1787 "../src/server.vala"
	_tmp65_ = symbol;
#line 1787 "../src/server.vala"
	_tmp66_ = vala_symbol_get_full_name (_tmp65_);
#line 1787 "../src/server.vala"
	_tmp67_ = _tmp66_;
#line 1787 "../src/server.vala"
	_tmp68_ = symbol;
#line 1787 "../src/server.vala"
	_tmp69_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp68_);
#line 1787 "../src/server.vala"
	_tmp70_ = _tmp69_;
#line 1787 "../src/server.vala"
	_tmp71_ = vala_source_reference_to_string (_tmp70_);
#line 1787 "../src/server.vala"
	_tmp72_ = _tmp71_;
#line 1787 "../src/server.vala"
	g_debug ("server.vala:1787: [%s] got symbol %s @ %s", _data38_->method, _tmp67_, _tmp72_);
#line 1787 "../src/server.vala"
	_g_free0 (_tmp72_);
#line 1787 "../src/server.vala"
	_g_free0 (_tmp67_);
#line 1790 "../src/server.vala"
	_tmp73_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
#line 1790 "../src/server.vala"
	if (_tmp73_) {
#line 1790 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp73_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
#line 18186 "server.c"
	}
#line 1790 "../src/server.vala"
	generated_vapis = _tmp73_;
#line 18190 "server.c"
	{
		GeeArrayList* _btarget_list = NULL;
		VlsProject* _tmp74_;
		GeeArrayList* _tmp75_;
		gint _btarget_size = 0;
		GeeArrayList* _tmp76_;
		gint _tmp77_;
		gint _tmp78_;
		gint _btarget_index = 0;
#line 1791 "../src/server.vala"
		_tmp74_ = project;
#line 1791 "../src/server.vala"
		_tmp75_ = vls_project_get_compilations (_tmp74_);
#line 1791 "../src/server.vala"
		_btarget_list = _tmp75_;
#line 1791 "../src/server.vala"
		_tmp76_ = _btarget_list;
#line 1791 "../src/server.vala"
		_tmp77_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp76_);
#line 1791 "../src/server.vala"
		_tmp78_ = _tmp77_;
#line 1791 "../src/server.vala"
		_btarget_size = _tmp78_;
#line 1791 "../src/server.vala"
		_btarget_index = -1;
#line 1791 "../src/server.vala"
		while (TRUE) {
#line 18218 "server.c"
			gint _tmp79_;
			gint _tmp80_;
			VlsCompilation* btarget = NULL;
			GeeArrayList* _tmp81_;
			gpointer _tmp82_;
			GeeHashSet* _tmp83_;
			VlsCompilation* _tmp84_;
			GeeArrayList* _tmp85_;
			GeeArrayList* _tmp86_;
#line 1791 "../src/server.vala"
			_btarget_index = _btarget_index + 1;
#line 1791 "../src/server.vala"
			_tmp79_ = _btarget_index;
#line 1791 "../src/server.vala"
			_tmp80_ = _btarget_size;
#line 1791 "../src/server.vala"
			if (!(_tmp79_ < _tmp80_)) {
#line 1791 "../src/server.vala"
				break;
#line 18238 "server.c"
			}
#line 1791 "../src/server.vala"
			_tmp81_ = _btarget_list;
#line 1791 "../src/server.vala"
			_tmp82_ = gee_abstract_list_get ((GeeAbstractList*) _tmp81_, _btarget_index);
#line 1791 "../src/server.vala"
			btarget = (VlsCompilation*) _tmp82_;
#line 1792 "../src/server.vala"
			_tmp83_ = generated_vapis;
#line 1792 "../src/server.vala"
			_tmp84_ = btarget;
#line 1792 "../src/server.vala"
			_tmp85_ = vls_build_target_get_output ((VlsBuildTarget*) _tmp84_);
#line 1792 "../src/server.vala"
			_tmp86_ = _tmp85_;
#line 1792 "../src/server.vala"
			gee_collection_add_all ((GeeCollection*) _tmp83_, (GeeCollection*) _tmp86_);
#line 1791 "../src/server.vala"
			_g_object_unref0 (btarget);
#line 18258 "server.c"
		}
#line 1791 "../src/server.vala"
		_g_object_unref0 (_btarget_list);
#line 18262 "server.c"
	}
#line 1793 "../src/server.vala"
	_tmp87_ = gee_hash_set_new (g_file_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _vls_util_file_hash_gee_hash_data_func, NULL, NULL, _vls_util_file_equal_gee_equal_data_func, NULL, NULL);
#line 1793 "../src/server.vala"
	if (_tmp87_) {
#line 1793 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp87_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
#line 18270 "server.c"
	}
#line 1793 "../src/server.vala"
	shown_files = _tmp87_;
#line 1795 "../src/server.vala"
	_tmp91_ = symbol;
#line 1795 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp91_, VALA_TYPE_PROPERTY)) {
#line 18278 "server.c"
		gboolean _tmp92_ = FALSE;
		ValaSymbol* _tmp93_;
		gboolean _tmp94_;
		gboolean _tmp95_;
#line 1795 "../src/server.vala"
		_tmp93_ = symbol;
#line 1795 "../src/server.vala"
		_tmp94_ = vala_property_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp93_, VALA_TYPE_PROPERTY, ValaProperty));
#line 1795 "../src/server.vala"
		_tmp95_ = _tmp94_;
#line 1795 "../src/server.vala"
		if (_tmp95_) {
#line 1795 "../src/server.vala"
			_tmp92_ = TRUE;
#line 18293 "server.c"
		} else {
			ValaSymbol* _tmp96_;
			gboolean _tmp97_;
			gboolean _tmp98_;
#line 1795 "../src/server.vala"
			_tmp96_ = symbol;
#line 1795 "../src/server.vala"
			_tmp97_ = vala_property_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp96_, VALA_TYPE_PROPERTY, ValaProperty));
#line 1795 "../src/server.vala"
			_tmp98_ = _tmp97_;
#line 1795 "../src/server.vala"
			_tmp92_ = _tmp98_;
#line 18306 "server.c"
		}
#line 1795 "../src/server.vala"
		_tmp90_ = _tmp92_;
#line 18310 "server.c"
	} else {
#line 1795 "../src/server.vala"
		_tmp90_ = FALSE;
#line 18314 "server.c"
	}
#line 1795 "../src/server.vala"
	if (_tmp90_) {
#line 1795 "../src/server.vala"
		_tmp89_ = TRUE;
#line 18320 "server.c"
	} else {
		gboolean _tmp99_ = FALSE;
		ValaSymbol* _tmp100_;
#line 1796 "../src/server.vala"
		_tmp100_ = symbol;
#line 1796 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp100_, VALA_TYPE_METHOD)) {
#line 18328 "server.c"
			gboolean _tmp101_ = FALSE;
			ValaSymbol* _tmp102_;
			gboolean _tmp103_;
			gboolean _tmp104_;
#line 1796 "../src/server.vala"
			_tmp102_ = symbol;
#line 1796 "../src/server.vala"
			_tmp103_ = vala_method_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, VALA_TYPE_METHOD, ValaMethod));
#line 1796 "../src/server.vala"
			_tmp104_ = _tmp103_;
#line 1796 "../src/server.vala"
			if (_tmp104_) {
#line 1796 "../src/server.vala"
				_tmp101_ = TRUE;
#line 18343 "server.c"
			} else {
				ValaSymbol* _tmp105_;
				gboolean _tmp106_;
				gboolean _tmp107_;
#line 1796 "../src/server.vala"
				_tmp105_ = symbol;
#line 1796 "../src/server.vala"
				_tmp106_ = vala_method_get_is_abstract (G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, VALA_TYPE_METHOD, ValaMethod));
#line 1796 "../src/server.vala"
				_tmp107_ = _tmp106_;
#line 1796 "../src/server.vala"
				_tmp101_ = _tmp107_;
#line 18356 "server.c"
			}
#line 1796 "../src/server.vala"
			_tmp99_ = _tmp101_;
#line 18360 "server.c"
		} else {
#line 1796 "../src/server.vala"
			_tmp99_ = FALSE;
#line 18364 "server.c"
		}
#line 1796 "../src/server.vala"
		_tmp89_ = _tmp99_;
#line 18368 "server.c"
	}
#line 1795 "../src/server.vala"
	if (_tmp89_) {
#line 1795 "../src/server.vala"
		_tmp88_ = TRUE;
#line 18374 "server.c"
	} else {
		gboolean _tmp108_ = FALSE;
		ValaSymbol* _tmp109_;
#line 1797 "../src/server.vala"
		_tmp109_ = symbol;
#line 1797 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp109_, VALA_TYPE_SIGNAL)) {
#line 18382 "server.c"
			ValaSymbol* _tmp110_;
			gboolean _tmp111_;
			gboolean _tmp112_;
#line 1797 "../src/server.vala"
			_tmp110_ = symbol;
#line 1797 "../src/server.vala"
			_tmp111_ = vala_signal_get_is_virtual (G_TYPE_CHECK_INSTANCE_CAST (_tmp110_, VALA_TYPE_SIGNAL, ValaSignal));
#line 1797 "../src/server.vala"
			_tmp112_ = _tmp111_;
#line 1797 "../src/server.vala"
			_tmp108_ = _tmp112_;
#line 18394 "server.c"
		} else {
#line 1797 "../src/server.vala"
			_tmp108_ = FALSE;
#line 18398 "server.c"
		}
#line 1797 "../src/server.vala"
		_tmp88_ = _tmp108_;
#line 18402 "server.c"
	}
#line 1794 "../src/server.vala"
	is_abstract_or_virtual = _tmp88_;
#line 18406 "server.c"
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp113_;
		ValaSymbol* _tmp114_;
		GeeCollection* _tmp115_;
		GeeCollection* _tmp116_;
		GeeIterator* _tmp117_;
		GeeIterator* _tmp118_;
#line 1798 "../src/server.vala"
		_tmp113_ = project;
#line 1798 "../src/server.vala"
		_tmp114_ = symbol;
#line 1798 "../src/server.vala"
		_tmp115_ = vls_symbol_references_get_compilations_using_symbol (_tmp113_, _tmp114_);
#line 1798 "../src/server.vala"
		_tmp116_ = _tmp115_;
#line 1798 "../src/server.vala"
		_tmp117_ = gee_iterable_iterator ((GeeIterable*) _tmp116_);
#line 1798 "../src/server.vala"
		_tmp118_ = _tmp117_;
#line 1798 "../src/server.vala"
		_g_object_unref0 (_tmp116_);
#line 1798 "../src/server.vala"
		_btarget_w_sym_it = _tmp118_;
#line 1798 "../src/server.vala"
		while (TRUE) {
#line 18433 "server.c"
			GeeIterator* _tmp119_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp120_;
			gpointer _tmp121_;
#line 1798 "../src/server.vala"
			_tmp119_ = _btarget_w_sym_it;
#line 1798 "../src/server.vala"
			if (!gee_iterator_next (_tmp119_)) {
#line 1798 "../src/server.vala"
				break;
#line 18444 "server.c"
			}
#line 1798 "../src/server.vala"
			_tmp120_ = _btarget_w_sym_it;
#line 1798 "../src/server.vala"
			_tmp121_ = gee_iterator_get (_tmp120_);
#line 1798 "../src/server.vala"
			btarget_w_sym = (VlsPair*) _tmp121_;
#line 18452 "server.c"
			{
				ValaList* _project_file_list = NULL;
				VlsPair* _tmp122_;
				gconstpointer _tmp123_;
				gconstpointer _tmp124_;
				ValaCodeContext* _tmp125_;
				ValaCodeContext* _tmp126_;
				ValaList* _tmp127_;
				gint _project_file_size = 0;
				ValaList* _tmp128_;
				gint _tmp129_;
				gint _tmp130_;
				gint _project_file_index = 0;
#line 1799 "../src/server.vala"
				_tmp122_ = btarget_w_sym;
#line 1799 "../src/server.vala"
				_tmp123_ = vls_pair_get_first (_tmp122_);
#line 1799 "../src/server.vala"
				_tmp124_ = _tmp123_;
#line 1799 "../src/server.vala"
				_tmp125_ = vls_compilation_get_code_context ((VlsCompilation*) _tmp124_);
#line 1799 "../src/server.vala"
				_tmp126_ = _tmp125_;
#line 1799 "../src/server.vala"
				_tmp127_ = vala_code_context_get_source_files (_tmp126_);
#line 1799 "../src/server.vala"
				_project_file_list = _tmp127_;
#line 1799 "../src/server.vala"
				_tmp128_ = _project_file_list;
#line 1799 "../src/server.vala"
				_tmp129_ = vala_collection_get_size ((ValaCollection*) _tmp128_);
#line 1799 "../src/server.vala"
				_tmp130_ = _tmp129_;
#line 1799 "../src/server.vala"
				_project_file_size = _tmp130_;
#line 1799 "../src/server.vala"
				_project_file_index = -1;
#line 1799 "../src/server.vala"
				while (TRUE) {
#line 18492 "server.c"
					gint _tmp131_;
					gint _tmp132_;
					ValaSourceFile* project_file = NULL;
					ValaList* _tmp133_;
					gpointer _tmp134_;
					GFile* file = NULL;
					ValaSourceFile* _tmp135_;
					const gchar* _tmp136_;
					const gchar* _tmp137_;
					GFile* _tmp138_;
					gboolean _tmp139_ = FALSE;
					GeeHashSet* _tmp140_;
					GFile* _tmp141_;
					GeeHashMap* file_references = NULL;
					GeeHashMap* _tmp144_;
					GFile* _tmp145_;
					gchar* _tmp146_;
					gchar* _tmp147_;
					ValaSourceFile* _tmp148_;
					VlsPair* _tmp149_;
					gconstpointer _tmp150_;
					gconstpointer _tmp151_;
					GeeHashMap* _tmp152_;
					gboolean _tmp161_ = FALSE;
					ValaSourceFile* _tmp162_;
					GeeHashSet* _tmp181_;
					GFile* _tmp182_;
#line 1799 "../src/server.vala"
					_project_file_index = _project_file_index + 1;
#line 1799 "../src/server.vala"
					_tmp131_ = _project_file_index;
#line 1799 "../src/server.vala"
					_tmp132_ = _project_file_size;
#line 1799 "../src/server.vala"
					if (!(_tmp131_ < _tmp132_)) {
#line 1799 "../src/server.vala"
						break;
#line 18530 "server.c"
					}
#line 1799 "../src/server.vala"
					_tmp133_ = _project_file_list;
#line 1799 "../src/server.vala"
					_tmp134_ = vala_list_get (_tmp133_, _project_file_index);
#line 1799 "../src/server.vala"
					project_file = (ValaSourceFile*) _tmp134_;
#line 1801 "../src/server.vala"
					_tmp135_ = project_file;
#line 1801 "../src/server.vala"
					_tmp136_ = vala_source_file_get_filename (_tmp135_);
#line 1801 "../src/server.vala"
					_tmp137_ = _tmp136_;
#line 1801 "../src/server.vala"
					_tmp138_ = g_file_new_for_commandline_arg (_tmp137_);
#line 1801 "../src/server.vala"
					file = _tmp138_;
#line 1802 "../src/server.vala"
					_tmp140_ = generated_vapis;
#line 1802 "../src/server.vala"
					_tmp141_ = file;
#line 1802 "../src/server.vala"
					if (gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp140_, _tmp141_)) {
#line 1802 "../src/server.vala"
						_tmp139_ = TRUE;
#line 18556 "server.c"
					} else {
						GeeHashSet* _tmp142_;
						GFile* _tmp143_;
#line 1802 "../src/server.vala"
						_tmp142_ = shown_files;
#line 1802 "../src/server.vala"
						_tmp143_ = file;
#line 1802 "../src/server.vala"
						_tmp139_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp142_, _tmp143_);
#line 18566 "server.c"
					}
#line 1802 "../src/server.vala"
					if (_tmp139_) {
#line 1803 "../src/server.vala"
						_g_object_unref0 (file);
#line 1803 "../src/server.vala"
						_vala_source_file_unref0 (project_file);
#line 1803 "../src/server.vala"
						continue;
#line 18576 "server.c"
					}
#line 1804 "../src/server.vala"
					_tmp144_ = gee_hash_map_new (LSP_TYPE_RANGE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, VALA_TYPE_CODE_NODE, (GBoxedCopyFunc) vala_code_node_ref, (GDestroyNotify) vala_code_node_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1804 "../src/server.vala"
					if (_tmp144_) {
#line 1804 "../src/server.vala"
						g_object_set_data ((GObject *) _tmp144_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
#line 18584 "server.c"
					}
#line 1804 "../src/server.vala"
					file_references = _tmp144_;
#line 1805 "../src/server.vala"
					_tmp145_ = file;
#line 1805 "../src/server.vala"
					_tmp146_ = g_file_get_uri (_tmp145_);
#line 1805 "../src/server.vala"
					_tmp147_ = _tmp146_;
#line 1805 "../src/server.vala"
					g_debug ("server.vala:1805: [%s] looking for references in %s ...", _data38_->method, _tmp147_);
#line 1805 "../src/server.vala"
					_g_free0 (_tmp147_);
#line 1806 "../src/server.vala"
					_tmp148_ = project_file;
#line 1806 "../src/server.vala"
					_tmp149_ = btarget_w_sym;
#line 1806 "../src/server.vala"
					_tmp150_ = vls_pair_get_second (_tmp149_);
#line 1806 "../src/server.vala"
					_tmp151_ = _tmp150_;
#line 1806 "../src/server.vala"
					_tmp152_ = file_references;
#line 1806 "../src/server.vala"
					vls_symbol_references_list_in_file (_tmp148_, (ValaSymbol*) _tmp151_, TRUE, FALSE, _tmp152_);
#line 1807 "../src/server.vala"
					if (is_abstract_or_virtual) {
#line 18612 "server.c"
						GFile* _tmp153_;
						gchar* _tmp154_;
						gchar* _tmp155_;
						ValaSourceFile* _tmp156_;
						VlsPair* _tmp157_;
						gconstpointer _tmp158_;
						gconstpointer _tmp159_;
						GeeHashMap* _tmp160_;
#line 1808 "../src/server.vala"
						_tmp153_ = file;
#line 1808 "../src/server.vala"
						_tmp154_ = g_file_get_uri (_tmp153_);
#line 1808 "../src/server.vala"
						_tmp155_ = _tmp154_;
#line 1808 "../src/server.vala"
						g_debug ("server.vala:1808: [%s] looking for implementations of abstract/virtual" \
" symbol in %s ...", _data38_->method, _tmp155_);
#line 1808 "../src/server.vala"
						_g_free0 (_tmp155_);
#line 1809 "../src/server.vala"
						_tmp156_ = project_file;
#line 1809 "../src/server.vala"
						_tmp157_ = btarget_w_sym;
#line 1809 "../src/server.vala"
						_tmp158_ = vls_pair_get_second (_tmp157_);
#line 1809 "../src/server.vala"
						_tmp159_ = _tmp158_;
#line 1809 "../src/server.vala"
						_tmp160_ = file_references;
#line 1809 "../src/server.vala"
						vls_symbol_references_list_implementations_of_virtual_symbol (_tmp156_, (ValaSymbol*) _tmp159_, _tmp160_);
#line 18643 "server.c"
					}
#line 1811 "../src/server.vala"
					_tmp162_ = project_file;
#line 1811 "../src/server.vala"
					if (!VLS_IS_TEXT_DOCUMENT (_tmp162_)) {
#line 18649 "server.c"
						GeeHashMap* _tmp163_;
						gint _tmp164_;
						gint _tmp165_;
#line 1811 "../src/server.vala"
						_tmp163_ = file_references;
#line 1811 "../src/server.vala"
						_tmp164_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp163_);
#line 1811 "../src/server.vala"
						_tmp165_ = _tmp164_;
#line 1811 "../src/server.vala"
						_tmp161_ = _tmp165_ > 0;
#line 18661 "server.c"
					} else {
#line 1811 "../src/server.vala"
						_tmp161_ = FALSE;
#line 18665 "server.c"
					}
#line 1811 "../src/server.vala"
					if (_tmp161_) {
#line 18669 "server.c"
						ValaSourceFile* _tmp166_;
						const gchar* _tmp167_;
						const gchar* _tmp168_;
#line 1814 "../src/server.vala"
						_tmp166_ = project_file;
#line 1814 "../src/server.vala"
						_tmp167_ = vala_source_file_get_filename (_tmp166_);
#line 1814 "../src/server.vala"
						_tmp168_ = _tmp167_;
#line 1814 "../src/server.vala"
						g_debug ("server.vala:1814: [%s] disallowing requested modification of %s", _data38_->method, _tmp168_);
#line 1815 "../src/server.vala"
						vls_server_reply_null (_data38_->id, _data38_->client, _data38_->method);
#line 1816 "../src/server.vala"
						vala_code_context_pop ();
#line 1817 "../src/server.vala"
						_g_object_unref0 (file_references);
#line 1817 "../src/server.vala"
						_g_object_unref0 (file);
#line 1817 "../src/server.vala"
						_vala_source_file_unref0 (project_file);
#line 1817 "../src/server.vala"
						_g_object_unref0 (btarget_w_sym);
#line 1817 "../src/server.vala"
						_g_object_unref0 (_btarget_w_sym_it);
#line 1817 "../src/server.vala"
						_g_object_unref0 (shown_files);
#line 1817 "../src/server.vala"
						_g_object_unref0 (generated_vapis);
#line 1817 "../src/server.vala"
						_g_object_unref0 (references);
#line 1817 "../src/server.vala"
						_vala_code_node_unref0 (symbol);
#line 1817 "../src/server.vala"
						_vala_code_node_unref0 (_result_);
#line 1817 "../src/server.vala"
						_vala_code_visitor_unref0 (fs);
#line 1817 "../src/server.vala"
						_vala_source_file_unref0 (doc);
#line 1817 "../src/server.vala"
						_g_object_unref0 (compilation);
#line 1817 "../src/server.vala"
						_g_object_unref0 (project);
#line 1817 "../src/server.vala"
						_g_object_unref0 (pos);
#line 1817 "../src/server.vala"
						return;
#line 18717 "server.c"
					}
					{
						GeeIterator* _entry_it = NULL;
						GeeHashMap* _tmp169_;
						GeeIterator* _tmp170_;
#line 1819 "../src/server.vala"
						_tmp169_ = file_references;
#line 1819 "../src/server.vala"
						_tmp170_ = gee_iterable_iterator ((GeeIterable*) _tmp169_);
#line 1819 "../src/server.vala"
						_entry_it = _tmp170_;
#line 1819 "../src/server.vala"
						while (TRUE) {
#line 18731 "server.c"
							GeeIterator* _tmp171_;
							GeeMapEntry* entry = NULL;
							GeeIterator* _tmp172_;
							gpointer _tmp173_;
							GeeHashMap* _tmp174_;
							GeeMapEntry* _tmp175_;
							gconstpointer _tmp176_;
							gconstpointer _tmp177_;
							GeeMapEntry* _tmp178_;
							gconstpointer _tmp179_;
							gconstpointer _tmp180_;
#line 1819 "../src/server.vala"
							_tmp171_ = _entry_it;
#line 1819 "../src/server.vala"
							if (!gee_iterator_next (_tmp171_)) {
#line 1819 "../src/server.vala"
								break;
#line 18749 "server.c"
							}
#line 1819 "../src/server.vala"
							_tmp172_ = _entry_it;
#line 1819 "../src/server.vala"
							_tmp173_ = gee_iterator_get (_tmp172_);
#line 1819 "../src/server.vala"
							entry = (GeeMapEntry*) _tmp173_;
#line 1820 "../src/server.vala"
							_tmp174_ = references;
#line 1820 "../src/server.vala"
							_tmp175_ = entry;
#line 1820 "../src/server.vala"
							_tmp176_ = gee_map_entry_get_key (_tmp175_);
#line 1820 "../src/server.vala"
							_tmp177_ = _tmp176_;
#line 1820 "../src/server.vala"
							_tmp178_ = entry;
#line 1820 "../src/server.vala"
							_tmp179_ = gee_map_entry_get_value (_tmp178_);
#line 1820 "../src/server.vala"
							_tmp180_ = _tmp179_;
#line 1820 "../src/server.vala"
							gee_abstract_map_set ((GeeAbstractMap*) _tmp174_, (LspRange*) _tmp177_, (ValaCodeNode*) _tmp180_);
#line 1819 "../src/server.vala"
							_g_object_unref0 (entry);
#line 18775 "server.c"
						}
#line 1819 "../src/server.vala"
						_g_object_unref0 (_entry_it);
#line 18779 "server.c"
					}
#line 1821 "../src/server.vala"
					_tmp181_ = shown_files;
#line 1821 "../src/server.vala"
					_tmp182_ = file;
#line 1821 "../src/server.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp181_, _tmp182_);
#line 1799 "../src/server.vala"
					_g_object_unref0 (file_references);
#line 1799 "../src/server.vala"
					_g_object_unref0 (file);
#line 1799 "../src/server.vala"
					_vala_source_file_unref0 (project_file);
#line 18793 "server.c"
				}
			}
#line 1798 "../src/server.vala"
			_g_object_unref0 (btarget_w_sym);
#line 18798 "server.c"
		}
#line 1798 "../src/server.vala"
		_g_object_unref0 (_btarget_w_sym_it);
#line 18802 "server.c"
	}
#line 1824 "../src/server.vala"
	_tmp183_ = references;
#line 1824 "../src/server.vala"
	_tmp184_ = gee_abstract_map_get_size ((GeeAbstractMap*) _tmp183_);
#line 1824 "../src/server.vala"
	_tmp185_ = _tmp184_;
#line 1824 "../src/server.vala"
	g_debug ("server.vala:1824: [%s] found %d references", _data38_->method, _tmp185_);
#line 1828 "../src/server.vala"
	_tmp186_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1828 "../src/server.vala"
	if (_tmp186_) {
#line 1828 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp186_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
#line 18818 "server.c"
	}
#line 1828 "../src/server.vala"
	edits = _tmp186_;
#line 1829 "../src/server.vala"
	_tmp187_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, VALA_TYPE_SOURCE_FILE, (GBoxedCopyFunc) vala_source_file_ref, (GDestroyNotify) vala_source_file_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 1829 "../src/server.vala"
	if (_tmp187_) {
#line 1829 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp187_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
#line 18828 "server.c"
	}
#line 1829 "../src/server.vala"
	source_files = _tmp187_;
#line 18832 "server.c"
	{
		GeeIterator* _entry_it = NULL;
		GeeHashMap* _tmp188_;
		GeeIterator* _tmp189_;
#line 1831 "../src/server.vala"
		_tmp188_ = references;
#line 1831 "../src/server.vala"
		_tmp189_ = gee_iterable_iterator ((GeeIterable*) _tmp188_);
#line 1831 "../src/server.vala"
		_entry_it = _tmp189_;
#line 1831 "../src/server.vala"
		while (TRUE) {
#line 18845 "server.c"
			GeeIterator* _tmp190_;
			GeeMapEntry* entry = NULL;
			GeeIterator* _tmp191_;
			gpointer _tmp192_;
			ValaCodeNode* code_node = NULL;
			GeeMapEntry* _tmp193_;
			gconstpointer _tmp194_;
			gconstpointer _tmp195_;
			ValaCodeNode* _tmp196_;
			LspRange* source_range = NULL;
			GeeMapEntry* _tmp197_;
			gconstpointer _tmp198_;
			gconstpointer _tmp199_;
			LspRange* _tmp200_;
			ValaCodeNode* _tmp201_;
			gchar* _tmp202_;
			gchar* _tmp203_;
			ValaCodeNode* _tmp204_;
			ValaSourceReference* _tmp205_;
			ValaSourceReference* _tmp206_;
			gchar* _tmp207_;
			gchar* _tmp208_;
			GFile* file = NULL;
			ValaCodeNode* _tmp209_;
			ValaSourceReference* _tmp210_;
			ValaSourceReference* _tmp211_;
			ValaSourceFile* _tmp212_;
			ValaSourceFile* _tmp213_;
			const gchar* _tmp214_;
			const gchar* _tmp215_;
			GFile* _tmp216_;
			GeeHashMap* _tmp217_;
			GFile* _tmp218_;
			gchar* _tmp219_;
			gchar* _tmp220_;
			gboolean _tmp221_;
			GeeArrayList* file_edits = NULL;
			GeeHashMap* _tmp228_;
			GFile* _tmp229_;
			gchar* _tmp230_;
			gchar* _tmp231_;
			gpointer _tmp232_;
			GeeArrayList* _tmp233_;
			GeeArrayList* _tmp234_;
			LspRange* _tmp235_;
			const gchar* _tmp236_;
			LspTextEdit* _tmp237_;
			LspTextEdit* _tmp238_;
			GeeHashMap* _tmp239_;
			GFile* _tmp240_;
			gchar* _tmp241_;
			gchar* _tmp242_;
			ValaCodeNode* _tmp243_;
			ValaSourceReference* _tmp244_;
			ValaSourceReference* _tmp245_;
			ValaSourceFile* _tmp246_;
			ValaSourceFile* _tmp247_;
#line 1831 "../src/server.vala"
			_tmp190_ = _entry_it;
#line 1831 "../src/server.vala"
			if (!gee_iterator_next (_tmp190_)) {
#line 1831 "../src/server.vala"
				break;
#line 18909 "server.c"
			}
#line 1831 "../src/server.vala"
			_tmp191_ = _entry_it;
#line 1831 "../src/server.vala"
			_tmp192_ = gee_iterator_get (_tmp191_);
#line 1831 "../src/server.vala"
			entry = (GeeMapEntry*) _tmp192_;
#line 1832 "../src/server.vala"
			_tmp193_ = entry;
#line 1832 "../src/server.vala"
			_tmp194_ = gee_map_entry_get_value (_tmp193_);
#line 1832 "../src/server.vala"
			_tmp195_ = _tmp194_;
#line 1832 "../src/server.vala"
			_tmp196_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp195_);
#line 1832 "../src/server.vala"
			code_node = _tmp196_;
#line 1833 "../src/server.vala"
			_tmp197_ = entry;
#line 1833 "../src/server.vala"
			_tmp198_ = gee_map_entry_get_key (_tmp197_);
#line 1833 "../src/server.vala"
			_tmp199_ = _tmp198_;
#line 1833 "../src/server.vala"
			_tmp200_ = _g_object_ref0 ((LspRange*) _tmp199_);
#line 1833 "../src/server.vala"
			source_range = _tmp200_;
#line 1834 "../src/server.vala"
			_tmp201_ = code_node;
#line 1834 "../src/server.vala"
			_tmp202_ = vls_code_help_get_code_node_source (_tmp201_);
#line 1834 "../src/server.vala"
			_tmp203_ = _tmp202_;
#line 1834 "../src/server.vala"
			_tmp204_ = code_node;
#line 1834 "../src/server.vala"
			_tmp205_ = vala_code_node_get_source_reference (_tmp204_);
#line 1834 "../src/server.vala"
			_tmp206_ = _tmp205_;
#line 1834 "../src/server.vala"
			_tmp207_ = vala_source_reference_to_string (_tmp206_);
#line 1834 "../src/server.vala"
			_tmp208_ = _tmp207_;
#line 1834 "../src/server.vala"
			g_debug ("server.vala:1834: [%s] editing reference %s @ %s ...", _data38_->method, _tmp203_, _tmp208_);
#line 1834 "../src/server.vala"
			_g_free0 (_tmp208_);
#line 1834 "../src/server.vala"
			_g_free0 (_tmp203_);
#line 1838 "../src/server.vala"
			_tmp209_ = code_node;
#line 1838 "../src/server.vala"
			_tmp210_ = vala_code_node_get_source_reference (_tmp209_);
#line 1838 "../src/server.vala"
			_tmp211_ = _tmp210_;
#line 1838 "../src/server.vala"
			_tmp212_ = vala_source_reference_get_file (_tmp211_);
#line 1838 "../src/server.vala"
			_tmp213_ = _tmp212_;
#line 1838 "../src/server.vala"
			_tmp214_ = vala_source_file_get_filename (_tmp213_);
#line 1838 "../src/server.vala"
			_tmp215_ = _tmp214_;
#line 1838 "../src/server.vala"
			_tmp216_ = g_file_new_for_commandline_arg (_tmp215_);
#line 1838 "../src/server.vala"
			file = _tmp216_;
#line 1839 "../src/server.vala"
			_tmp217_ = edits;
#line 1839 "../src/server.vala"
			_tmp218_ = file;
#line 1839 "../src/server.vala"
			_tmp219_ = g_file_get_uri (_tmp218_);
#line 1839 "../src/server.vala"
			_tmp220_ = _tmp219_;
#line 1839 "../src/server.vala"
			_tmp221_ = !gee_abstract_map_has_key ((GeeAbstractMap*) _tmp217_, _tmp220_);
#line 1839 "../src/server.vala"
			_g_free0 (_tmp220_);
#line 1839 "../src/server.vala"
			if (_tmp221_) {
#line 18991 "server.c"
				GeeHashMap* _tmp222_;
				GFile* _tmp223_;
				gchar* _tmp224_;
				gchar* _tmp225_;
				GeeArrayList* _tmp226_;
				GeeArrayList* _tmp227_;
#line 1840 "../src/server.vala"
				_tmp222_ = edits;
#line 1840 "../src/server.vala"
				_tmp223_ = file;
#line 1840 "../src/server.vala"
				_tmp224_ = g_file_get_uri (_tmp223_);
#line 1840 "../src/server.vala"
				_tmp225_ = _tmp224_;
#line 1840 "../src/server.vala"
				_tmp226_ = gee_array_list_new (LSP_TYPE_TEXT_EDIT, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1840 "../src/server.vala"
				if (_tmp226_) {
#line 1840 "../src/server.vala"
					g_object_set_data ((GObject *) _tmp226_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
#line 19012 "server.c"
				}
#line 1840 "../src/server.vala"
				_tmp227_ = _tmp226_;
#line 1840 "../src/server.vala"
				gee_abstract_map_set ((GeeAbstractMap*) _tmp222_, _tmp225_, _tmp227_);
#line 1840 "../src/server.vala"
				_g_object_unref0 (_tmp227_);
#line 1840 "../src/server.vala"
				_g_free0 (_tmp225_);
#line 19022 "server.c"
			}
#line 1841 "../src/server.vala"
			_tmp228_ = edits;
#line 1841 "../src/server.vala"
			_tmp229_ = file;
#line 1841 "../src/server.vala"
			_tmp230_ = g_file_get_uri (_tmp229_);
#line 1841 "../src/server.vala"
			_tmp231_ = _tmp230_;
#line 1841 "../src/server.vala"
			_tmp232_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp228_, _tmp231_);
#line 1841 "../src/server.vala"
			_tmp233_ = (GeeArrayList*) _tmp232_;
#line 1841 "../src/server.vala"
			_g_free0 (_tmp231_);
#line 1841 "../src/server.vala"
			file_edits = _tmp233_;
#line 1843 "../src/server.vala"
			_tmp234_ = file_edits;
#line 1843 "../src/server.vala"
			_tmp235_ = source_range;
#line 1843 "../src/server.vala"
			_tmp236_ = _data38_->new_name;
#line 1843 "../src/server.vala"
			_tmp237_ = lsp_text_edit_new (_tmp235_, _tmp236_);
#line 1843 "../src/server.vala"
			if (_tmp237_) {
#line 1843 "../src/server.vala"
				g_object_set_data ((GObject *) _tmp237_, "vala-creation-function", "Vls.Server.rename_symbol._lambda74_");
#line 19052 "server.c"
			}
#line 1843 "../src/server.vala"
			_tmp238_ = _tmp237_;
#line 1843 "../src/server.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp234_, _tmp238_);
#line 1843 "../src/server.vala"
			_g_object_unref0 (_tmp238_);
#line 1844 "../src/server.vala"
			_tmp239_ = source_files;
#line 1844 "../src/server.vala"
			_tmp240_ = file;
#line 1844 "../src/server.vala"
			_tmp241_ = g_file_get_uri (_tmp240_);
#line 1844 "../src/server.vala"
			_tmp242_ = _tmp241_;
#line 1844 "../src/server.vala"
			_tmp243_ = code_node;
#line 1844 "../src/server.vala"
			_tmp244_ = vala_code_node_get_source_reference (_tmp243_);
#line 1844 "../src/server.vala"
			_tmp245_ = _tmp244_;
#line 1844 "../src/server.vala"
			_tmp246_ = vala_source_reference_get_file (_tmp245_);
#line 1844 "../src/server.vala"
			_tmp247_ = _tmp246_;
#line 1844 "../src/server.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp239_, _tmp242_, _tmp247_);
#line 1844 "../src/server.vala"
			_g_free0 (_tmp242_);
#line 1831 "../src/server.vala"
			_g_object_unref0 (file_edits);
#line 1831 "../src/server.vala"
			_g_object_unref0 (file);
#line 1831 "../src/server.vala"
			_g_object_unref0 (source_range);
#line 1831 "../src/server.vala"
			_vala_code_node_unref0 (code_node);
#line 1831 "../src/server.vala"
			_g_object_unref0 (entry);
#line 19092 "server.c"
		}
#line 1831 "../src/server.vala"
		_g_object_unref0 (_entry_it);
#line 19096 "server.c"
	}
#line 1848 "../src/server.vala"
	_tmp248_ = json_array_new ();
#line 1848 "../src/server.vala"
	text_document_edits_json = _tmp248_;
#line 19102 "server.c"
	{
		GeeIterator* _uri_it = NULL;
		GeeHashMap* _tmp249_;
		GeeSet* _tmp250_;
		GeeSet* _tmp251_;
		GeeSet* _tmp252_;
		GeeIterator* _tmp253_;
		GeeIterator* _tmp254_;
#line 1849 "../src/server.vala"
		_tmp249_ = edits;
#line 1849 "../src/server.vala"
		_tmp250_ = gee_abstract_map_get_keys ((GeeAbstractMap*) _tmp249_);
#line 1849 "../src/server.vala"
		_tmp251_ = _tmp250_;
#line 1849 "../src/server.vala"
		_tmp252_ = _tmp251_;
#line 1849 "../src/server.vala"
		_tmp253_ = gee_iterable_iterator ((GeeIterable*) _tmp252_);
#line 1849 "../src/server.vala"
		_tmp254_ = _tmp253_;
#line 1849 "../src/server.vala"
		_g_object_unref0 (_tmp252_);
#line 1849 "../src/server.vala"
		_uri_it = _tmp254_;
#line 1849 "../src/server.vala"
		while (TRUE) {
#line 19129 "server.c"
			GeeIterator* _tmp255_;
			gchar* uri = NULL;
			GeeIterator* _tmp256_;
			gpointer _tmp257_;
			LspVersionedTextDocumentIdentifier* document_id = NULL;
			GeeHashMap* _tmp258_;
			const gchar* _tmp259_;
			gpointer _tmp260_;
			VlsTextDocument* _tmp261_;
			gint _tmp262_;
			gint _tmp263_;
			const gchar* _tmp264_;
			gchar* _tmp265_;
			LspVersionedTextDocumentIdentifier* _tmp266_ = NULL;
			LspVersionedTextDocumentIdentifier* _tmp267_;
			JsonArray* _tmp268_;
			LspVersionedTextDocumentIdentifier* _tmp269_;
			GeeHashMap* _tmp270_;
			const gchar* _tmp271_;
			gpointer _tmp272_;
			LspTextDocumentEdit* _tmp273_ = NULL;
			LspTextDocumentEdit* _tmp274_;
			JsonNode* _tmp275_;
#line 1849 "../src/server.vala"
			_tmp255_ = _uri_it;
#line 1849 "../src/server.vala"
			if (!gee_iterator_next (_tmp255_)) {
#line 1849 "../src/server.vala"
				break;
#line 19159 "server.c"
			}
#line 1849 "../src/server.vala"
			_tmp256_ = _uri_it;
#line 1849 "../src/server.vala"
			_tmp257_ = gee_iterator_get (_tmp256_);
#line 1849 "../src/server.vala"
			uri = (gchar*) _tmp257_;
#line 1850 "../src/server.vala"
			_tmp258_ = source_files;
#line 1850 "../src/server.vala"
			_tmp259_ = uri;
#line 1850 "../src/server.vala"
			_tmp260_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp258_, _tmp259_);
#line 1850 "../src/server.vala"
			_tmp261_ = G_TYPE_CHECK_INSTANCE_CAST ((ValaSourceFile*) _tmp260_, VLS_TYPE_TEXT_DOCUMENT, VlsTextDocument);
#line 1850 "../src/server.vala"
			_tmp262_ = vls_text_document_get_version (_tmp261_);
#line 1850 "../src/server.vala"
			_tmp263_ = _tmp262_;
#line 1850 "../src/server.vala"
			_tmp264_ = uri;
#line 1850 "../src/server.vala"
			_tmp265_ = g_strdup (_tmp264_);
#line 1850 "../src/server.vala"
			_tmp266_ = lsp_versioned_text_document_identifier_new ();
#line 1850 "../src/server.vala"
			lsp_versioned_text_document_identifier_set_version (_tmp266_, _tmp263_);
#line 1850 "../src/server.vala"
			lsp_text_document_identifier_set_uri ((LspTextDocumentIdentifier*) _tmp266_, _tmp265_);
#line 1850 "../src/server.vala"
			_g_free0 (_tmp265_);
#line 1850 "../src/server.vala"
			_tmp267_ = _tmp266_;
#line 1850 "../src/server.vala"
			_vala_source_file_unref0 (_tmp261_);
#line 1850 "../src/server.vala"
			document_id = _tmp267_;
#line 1854 "../src/server.vala"
			_tmp268_ = text_document_edits_json;
#line 1854 "../src/server.vala"
			_tmp269_ = document_id;
#line 1854 "../src/server.vala"
			_tmp270_ = edits;
#line 1854 "../src/server.vala"
			_tmp271_ = uri;
#line 1854 "../src/server.vala"
			_tmp272_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp270_, _tmp271_);
#line 1854 "../src/server.vala"
			_tmp273_ = lsp_text_document_edit_new (_tmp269_);
#line 1854 "../src/server.vala"
			lsp_text_document_edit_set_edits (_tmp273_, (GeeArrayList*) _tmp272_);
#line 1854 "../src/server.vala"
			_g_object_unref0 (_tmp272_);
#line 1854 "../src/server.vala"
			_tmp274_ = _tmp273_;
#line 1854 "../src/server.vala"
			_tmp275_ = json_gobject_serialize ((GObject*) _tmp274_);
#line 1854 "../src/server.vala"
			json_array_add_element (_tmp268_, _tmp275_);
#line 1854 "../src/server.vala"
			_g_object_unref0 (_tmp274_);
#line 1849 "../src/server.vala"
			_g_object_unref0 (document_id);
#line 1849 "../src/server.vala"
			_g_free0 (uri);
#line 19225 "server.c"
		}
#line 1849 "../src/server.vala"
		_g_object_unref0 (_uri_it);
#line 19229 "server.c"
	}
	{
		GVariant* changes = NULL;
		JsonNode* _tmp276_;
		JsonNode* _tmp277_;
		JsonArray* _tmp278_;
		JsonNode* _tmp279_;
		GVariant* _tmp280_;
		GVariant* _tmp281_;
		GVariant* _tmp282_;
		GVariant* _tmp283_;
		GVariant* _tmp284_;
		GCancellable* _tmp285_;
#line 1860 "../src/server.vala"
		_tmp276_ = json_node_alloc ();
#line 1860 "../src/server.vala"
		_tmp277_ = _tmp276_;
#line 1860 "../src/server.vala"
		_tmp278_ = text_document_edits_json;
#line 1860 "../src/server.vala"
		_tmp279_ = json_node_init_array (_tmp277_, _tmp278_);
#line 1860 "../src/server.vala"
		_tmp280_ = json_gvariant_deserialize (_tmp279_, NULL, &_inner_error0_);
#line 1860 "../src/server.vala"
		if (_tmp280_ != NULL) {
#line 1860 "../src/server.vala"
			g_variant_ref_sink (_tmp280_);
#line 19257 "server.c"
		}
#line 1860 "../src/server.vala"
		_tmp281_ = _tmp280_;
#line 1860 "../src/server.vala"
		__vala_JsonNode_free0 (_tmp277_);
#line 1860 "../src/server.vala"
		changes = _tmp281_;
#line 1860 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 19267 "server.c"
			goto __catch0_g_error;
		}
#line 1861 "../src/server.vala"
		_tmp282_ = changes;
#line 1861 "../src/server.vala"
		_tmp283_ = vls_server_build_dict (self, "documentChanges", _tmp282_, NULL);
#line 1861 "../src/server.vala"
		_tmp284_ = _tmp283_;
#line 1861 "../src/server.vala"
		_tmp285_ = vls_server_cancellable;
#line 1861 "../src/server.vala"
		jsonrpc_client_reply (_data38_->client, _data38_->id, _tmp284_, _tmp285_, &_inner_error0_);
#line 1861 "../src/server.vala"
		_g_variant_unref0 (_tmp284_);
#line 1861 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1861 "../src/server.vala"
			_g_variant_unref0 (changes);
#line 19286 "server.c"
			goto __catch0_g_error;
		}
#line 1859 "../src/server.vala"
		_g_variant_unref0 (changes);
#line 19291 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp286_;
		const gchar* _tmp287_;
#line 1859 "../src/server.vala"
		e = _inner_error0_;
#line 1859 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1868 "../src/server.vala"
		_tmp286_ = e;
#line 1868 "../src/server.vala"
		_tmp287_ = _tmp286_->message;
#line 1868 "../src/server.vala"
		g_warning ("server.vala:1868: [%s] failed to reply to client - %s", _data38_->method, _tmp287_);
#line 1859 "../src/server.vala"
		_g_error_free0 (e);
#line 19311 "server.c"
	}
	__finally0:
#line 1859 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1859 "../src/server.vala"
		_json_array_unref0 (text_document_edits_json);
#line 1859 "../src/server.vala"
		_g_object_unref0 (source_files);
#line 1859 "../src/server.vala"
		_g_object_unref0 (edits);
#line 1859 "../src/server.vala"
		_g_object_unref0 (shown_files);
#line 1859 "../src/server.vala"
		_g_object_unref0 (generated_vapis);
#line 1859 "../src/server.vala"
		_g_object_unref0 (references);
#line 1859 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1859 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1859 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1859 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1859 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1859 "../src/server.vala"
		_g_object_unref0 (project);
#line 1859 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1859 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1859 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1859 "../src/server.vala"
		return;
#line 19348 "server.c"
	}
#line 1871 "../src/server.vala"
	vala_code_context_pop ();
#line 1738 "../src/server.vala"
	_json_array_unref0 (text_document_edits_json);
#line 1738 "../src/server.vala"
	_g_object_unref0 (source_files);
#line 1738 "../src/server.vala"
	_g_object_unref0 (edits);
#line 1738 "../src/server.vala"
	_g_object_unref0 (shown_files);
#line 1738 "../src/server.vala"
	_g_object_unref0 (generated_vapis);
#line 1738 "../src/server.vala"
	_g_object_unref0 (references);
#line 1738 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 1738 "../src/server.vala"
	_vala_code_node_unref0 (_result_);
#line 1738 "../src/server.vala"
	_vala_code_visitor_unref0 (fs);
#line 1738 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 1738 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1738 "../src/server.vala"
	_g_object_unref0 (project);
#line 1738 "../src/server.vala"
	_g_object_unref0 (pos);
#line 19378 "server.c"
}

static void
___lambda74__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
#line 1738 "../src/server.vala"
	__lambda74_ (self, request_cancelled);
#line 19387 "server.c"
}

static void
vls_server_rename_symbol (VlsServer* self,
                          JsonrpcClient* client,
                          const gchar* method,
                          GVariant* id,
                          GVariant* params)
{
	Block38Data* _data38_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	const GVariantType* _tmp3_;
	GVariant* _tmp4_;
	GVariant* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	const gchar* _tmp8_;
	gpointer _tmp10_;
#line 1723 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1723 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1723 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1723 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1723 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1723 "../src/server.vala"
	_data38_ = g_slice_new0 (Block38Data);
#line 1723 "../src/server.vala"
	_data38_->_ref_count_ = 1;
#line 1723 "../src/server.vala"
	_data38_->self = g_object_ref (self);
#line 1723 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 1723 "../src/server.vala"
	_g_object_unref0 (_data38_->client);
#line 1723 "../src/server.vala"
	_data38_->client = _tmp0_;
#line 1723 "../src/server.vala"
	_tmp1_ = g_strdup (method);
#line 1723 "../src/server.vala"
	_g_free0 (_data38_->method);
#line 1723 "../src/server.vala"
	_data38_->method = _tmp1_;
#line 1723 "../src/server.vala"
	_tmp2_ = _g_variant_ref0 (id);
#line 1723 "../src/server.vala"
	_g_variant_unref0 (_data38_->id);
#line 1723 "../src/server.vala"
	_data38_->id = _tmp2_;
#line 1724 "../src/server.vala"
	_tmp3_ = G_VARIANT_TYPE_STRING;
#line 1724 "../src/server.vala"
	_tmp4_ = g_variant_lookup_value (params, "newName", _tmp3_);
#line 1724 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 1724 "../src/server.vala"
	_tmp6_ = _variant_get11 (_tmp5_);
#line 1724 "../src/server.vala"
	_tmp7_ = _tmp6_;
#line 1724 "../src/server.vala"
	_g_variant_unref0 (_tmp5_);
#line 1724 "../src/server.vala"
	_data38_->new_name = _tmp7_;
#line 1727 "../src/server.vala"
	_tmp8_ = _data38_->new_name;
#line 1727 "../src/server.vala"
	if (!g_regex_match (_thread_safe_regex_init (&_tmp_regex_1, "^(?=[^\\d])[^\\s~`!#%^&*()\\-\\+={}\\[\\]|\\\\\\/?.>,<'\";:]+$", 0), _tmp8_, 0, NULL)) {
#line 19460 "server.c"
		GCancellable* _tmp9_;
#line 1728 "../src/server.vala"
		_tmp9_ = vls_server_cancellable;
#line 1728 "../src/server.vala"
		jsonrpc_client_reply_error_async (_data38_->client, _data38_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "Invalid symbol name. Symbol names cannot start with a number and must " \
"not contain any operators.", _tmp9_, NULL, NULL);
#line 1733 "../src/server.vala"
		block38_data_unref (_data38_);
#line 1733 "../src/server.vala"
		_data38_ = NULL;
#line 1733 "../src/server.vala"
		return;
#line 19472 "server.c"
	}
#line 1736 "../src/server.vala"
	_tmp10_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1736 "../src/server.vala"
	_data38_->p = (LspTextDocumentPositionParams*) _tmp10_;
#line 1738 "../src/server.vala"
	vls_server_wait_for_context_update (self, _data38_->id, ___lambda74__vls_server_on_context_updated_func, block38_data_ref (_data38_), block38_data_unref);
#line 1723 "../src/server.vala"
	block38_data_unref (_data38_);
#line 1723 "../src/server.vala"
	_data38_ = NULL;
#line 19484 "server.c"
}

static Block39Data*
block39_data_ref (Block39Data* _data39_)
{
#line 1875 "../src/server.vala"
	g_atomic_int_inc (&_data39_->_ref_count_);
#line 1875 "../src/server.vala"
	return _data39_;
#line 19494 "server.c"
}

static void
block39_data_unref (void * _userdata_)
{
	Block39Data* _data39_;
	_data39_ = (Block39Data*) _userdata_;
#line 1875 "../src/server.vala"
	if (g_atomic_int_dec_and_test (&_data39_->_ref_count_)) {
#line 19504 "server.c"
		VlsServer* self;
#line 1875 "../src/server.vala"
		self = _data39_->self;
#line 1875 "../src/server.vala"
		_g_object_unref0 (_data39_->p);
#line 1875 "../src/server.vala"
		_g_object_unref0 (_data39_->client);
#line 1875 "../src/server.vala"
		_g_free0 (_data39_->method);
#line 1875 "../src/server.vala"
		_g_variant_unref0 (_data39_->id);
#line 1875 "../src/server.vala"
		_g_object_unref0 (self);
#line 1875 "../src/server.vala"
		g_slice_free (Block39Data, _data39_);
#line 19520 "server.c"
	}
}

static void
__lambda75_ (Block39Data* _data39_,
             gboolean request_cancelled)
{
	VlsServer* self;
	LspPosition* pos = NULL;
	LspPosition* _tmp0_;
	LspPosition* _tmp1_;
	LspPosition* _tmp2_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentIdentifier* _tmp3_;
	LspTextDocumentIdentifier* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspPosition* _tmp19_;
	VlsNodeSearch* _tmp20_;
	VlsNodeSearch* _tmp21_;
	GeeList* _tmp22_;
	gint _tmp23_;
	gint _tmp24_;
	ValaCodeNode* initial_result = NULL;
	VlsNodeSearch* _tmp26_;
	ValaSourceFile* _tmp27_;
	ValaCodeNode* _tmp28_;
	ValaCodeNode* _result_ = NULL;
	ValaCodeNode* _tmp29_;
	ValaCodeNode* _tmp30_;
	ValaSymbol* symbol = NULL;
	gboolean _tmp31_ = FALSE;
	ValaCodeNode* _tmp32_;
	gboolean _tmp52_ = FALSE;
	ValaCodeNode* _tmp53_;
	ValaCodeNode* _tmp60_;
	ValaSymbol* _tmp61_;
	LspRange* replacement_range = NULL;
	ValaCodeNode* _tmp62_;
	ValaSymbol* _tmp63_;
	LspRange* _tmp64_;
	gboolean _tmp65_ = FALSE;
	LspRange* _tmp66_;
	GError* _inner_error0_ = NULL;
#line 1878 "../src/server.vala"
	self = _data39_->self;
#line 1879 "../src/server.vala"
	if (request_cancelled) {
#line 1880 "../src/server.vala"
		vls_server_reply_null (_data39_->id, _data39_->client, _data39_->method);
#line 1881 "../src/server.vala"
		return;
#line 19584 "server.c"
	}
#line 1884 "../src/server.vala"
	_tmp0_ = lsp_text_document_position_params_get_position (_data39_->p);
#line 1884 "../src/server.vala"
	_tmp1_ = _tmp0_;
#line 1884 "../src/server.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1884 "../src/server.vala"
	pos = _tmp2_;
#line 1887 "../src/server.vala"
	_tmp3_ = lsp_text_document_position_params_get_textDocument (_data39_->p);
#line 1887 "../src/server.vala"
	_tmp4_ = _tmp3_;
#line 1887 "../src/server.vala"
	_tmp5_ = lsp_text_document_identifier_get_uri (_tmp4_);
#line 1887 "../src/server.vala"
	_tmp6_ = _tmp5_;
#line 1887 "../src/server.vala"
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
#line 1887 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1887 "../src/server.vala"
	compilation = _tmp7_;
#line 1887 "../src/server.vala"
	_g_object_unref0 (project);
#line 1887 "../src/server.vala"
	project = _tmp8_;
#line 1887 "../src/server.vala"
	doc = _tmp9_;
#line 1888 "../src/server.vala"
	_tmp10_ = doc;
#line 1888 "../src/server.vala"
	if (_tmp10_ == NULL) {
#line 19618 "server.c"
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 1889 "../src/server.vala"
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_data39_->p);
#line 1889 "../src/server.vala"
		_tmp12_ = _tmp11_;
#line 1889 "../src/server.vala"
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
#line 1889 "../src/server.vala"
		_tmp14_ = _tmp13_;
#line 1889 "../src/server.vala"
		g_debug ("server.vala:1889: [%s] file `%s' not found", _data39_->method, _tmp14_);
#line 1890 "../src/server.vala"
		vls_server_reply_null (_data39_->id, _data39_->client, _data39_->method);
#line 1891 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1891 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1891 "../src/server.vala"
		_g_object_unref0 (project);
#line 1891 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1891 "../src/server.vala"
		return;
#line 19645 "server.c"
	}
#line 1894 "../src/server.vala"
	_tmp15_ = compilation;
#line 1894 "../src/server.vala"
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
#line 1894 "../src/server.vala"
	_tmp17_ = _tmp16_;
#line 1894 "../src/server.vala"
	vala_code_context_push (_tmp17_);
#line 1896 "../src/server.vala"
	_tmp18_ = doc;
#line 1896 "../src/server.vala"
	_tmp19_ = pos;
#line 1896 "../src/server.vala"
	_tmp20_ = vls_node_search_new (_tmp18_, _tmp19_, TRUE, NULL, TRUE);
#line 1896 "../src/server.vala"
	fs = _tmp20_;
#line 1898 "../src/server.vala"
	_tmp21_ = fs;
#line 1898 "../src/server.vala"
	_tmp22_ = _tmp21_->result;
#line 1898 "../src/server.vala"
	_tmp23_ = gee_collection_get_size ((GeeCollection*) _tmp22_);
#line 1898 "../src/server.vala"
	_tmp24_ = _tmp23_;
#line 1898 "../src/server.vala"
	if (_tmp24_ == 0) {
#line 19673 "server.c"
		GCancellable* _tmp25_;
#line 1899 "../src/server.vala"
		_tmp25_ = vls_server_cancellable;
#line 1899 "../src/server.vala"
		jsonrpc_client_reply_error_async (_data39_->client, _data39_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp25_, NULL, NULL);
#line 1904 "../src/server.vala"
		vala_code_context_pop ();
#line 1905 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1905 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1905 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1905 "../src/server.vala"
		_g_object_unref0 (project);
#line 1905 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1905 "../src/server.vala"
		return;
#line 19693 "server.c"
	}
#line 1908 "../src/server.vala"
	_tmp26_ = fs;
#line 1908 "../src/server.vala"
	_tmp27_ = doc;
#line 1908 "../src/server.vala"
	_tmp28_ = vls_server_get_best (_tmp26_, _tmp27_);
#line 1908 "../src/server.vala"
	initial_result = _tmp28_;
#line 1909 "../src/server.vala"
	_tmp29_ = initial_result;
#line 1909 "../src/server.vala"
	_tmp30_ = _vala_code_node_ref0 (_tmp29_);
#line 1909 "../src/server.vala"
	_result_ = _tmp30_;
#line 1912 "../src/server.vala"
	_tmp32_ = _result_;
#line 1912 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, VALA_TYPE_EXPRESSION)) {
#line 19713 "server.c"
		ValaCodeNode* _tmp33_;
		ValaSymbol* _tmp34_;
		ValaSymbol* _tmp35_;
#line 1912 "../src/server.vala"
		_tmp33_ = _result_;
#line 1912 "../src/server.vala"
		_tmp34_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 1912 "../src/server.vala"
		_tmp35_ = _tmp34_;
#line 1912 "../src/server.vala"
		_tmp31_ = _tmp35_ != NULL;
#line 19725 "server.c"
	} else {
#line 1912 "../src/server.vala"
		_tmp31_ = FALSE;
#line 19729 "server.c"
	}
#line 1912 "../src/server.vala"
	if (_tmp31_) {
#line 19733 "server.c"
		ValaCodeNode* _tmp36_;
		ValaSymbol* _tmp37_;
		ValaSymbol* _tmp38_;
		ValaCodeNode* _tmp39_;
#line 1913 "../src/server.vala"
		_tmp36_ = _result_;
#line 1913 "../src/server.vala"
		_tmp37_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 1913 "../src/server.vala"
		_tmp38_ = _tmp37_;
#line 1913 "../src/server.vala"
		_tmp39_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp38_);
#line 1913 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1913 "../src/server.vala"
		_result_ = _tmp39_;
#line 19750 "server.c"
	} else {
		ValaCodeNode* _tmp40_;
#line 1914 "../src/server.vala"
		_tmp40_ = _result_;
#line 1914 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp40_, VALA_TYPE_DATA_TYPE)) {
#line 19757 "server.c"
			ValaCodeNode* _tmp41_;
			ValaSymbol* _tmp42_;
#line 1915 "../src/server.vala"
			_tmp41_ = _result_;
#line 1915 "../src/server.vala"
			_tmp42_ = vls_symbol_references_get_symbol_data_type_refers_to (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 1915 "../src/server.vala"
			_vala_code_node_unref0 (_result_);
#line 1915 "../src/server.vala"
			_result_ = (ValaCodeNode*) _tmp42_;
#line 19768 "server.c"
		} else {
			gboolean _tmp43_ = FALSE;
			ValaCodeNode* _tmp44_;
#line 1916 "../src/server.vala"
			_tmp44_ = _result_;
#line 1916 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_USING_DIRECTIVE)) {
#line 19776 "server.c"
				ValaCodeNode* _tmp45_;
				ValaSymbol* _tmp46_;
				ValaSymbol* _tmp47_;
#line 1916 "../src/server.vala"
				_tmp45_ = _result_;
#line 1916 "../src/server.vala"
				_tmp46_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
#line 1916 "../src/server.vala"
				_tmp47_ = _tmp46_;
#line 1916 "../src/server.vala"
				_tmp43_ = _tmp47_ != NULL;
#line 19788 "server.c"
			} else {
#line 1916 "../src/server.vala"
				_tmp43_ = FALSE;
#line 19792 "server.c"
			}
#line 1916 "../src/server.vala"
			if (_tmp43_) {
#line 19796 "server.c"
				ValaCodeNode* _tmp48_;
				ValaSymbol* _tmp49_;
				ValaSymbol* _tmp50_;
				ValaCodeNode* _tmp51_;
#line 1917 "../src/server.vala"
				_tmp48_ = _result_;
#line 1917 "../src/server.vala"
				_tmp49_ = vala_using_directive_get_namespace_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, VALA_TYPE_USING_DIRECTIVE, ValaUsingDirective));
#line 1917 "../src/server.vala"
				_tmp50_ = _tmp49_;
#line 1917 "../src/server.vala"
				_tmp51_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp50_);
#line 1917 "../src/server.vala"
				_vala_code_node_unref0 (_result_);
#line 1917 "../src/server.vala"
				_result_ = _tmp51_;
#line 19813 "server.c"
			}
		}
	}
#line 1920 "../src/server.vala"
	_tmp53_ = _result_;
#line 1920 "../src/server.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp53_, VALA_TYPE_SYMBOL)) {
#line 1920 "../src/server.vala"
		_tmp52_ = TRUE;
#line 19823 "server.c"
	} else {
		gboolean _tmp54_ = FALSE;
		ValaCodeNode* _tmp55_;
#line 1921 "../src/server.vala"
		_tmp55_ = _result_;
#line 1921 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp55_, VALA_TYPE_METHOD)) {
#line 19831 "server.c"
			ValaCodeNode* _tmp56_;
			gboolean _tmp57_;
			gboolean _tmp58_;
#line 1921 "../src/server.vala"
			_tmp56_ = _result_;
#line 1921 "../src/server.vala"
			_tmp57_ = vala_method_get_closure (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, VALA_TYPE_METHOD, ValaMethod));
#line 1921 "../src/server.vala"
			_tmp58_ = _tmp57_;
#line 1921 "../src/server.vala"
			_tmp54_ = _tmp58_;
#line 19843 "server.c"
		} else {
#line 1921 "../src/server.vala"
			_tmp54_ = FALSE;
#line 19847 "server.c"
		}
#line 1921 "../src/server.vala"
		_tmp52_ = _tmp54_;
#line 19851 "server.c"
	}
#line 1920 "../src/server.vala"
	if (_tmp52_) {
#line 19855 "server.c"
		GCancellable* _tmp59_;
#line 1923 "../src/server.vala"
		_tmp59_ = vls_server_cancellable;
#line 1923 "../src/server.vala"
		jsonrpc_client_reply_error_async (_data39_->client, _data39_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp59_, NULL, NULL);
#line 1928 "../src/server.vala"
		vala_code_context_pop ();
#line 1929 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1929 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1929 "../src/server.vala"
		_vala_code_node_unref0 (initial_result);
#line 1929 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1929 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1929 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1929 "../src/server.vala"
		_g_object_unref0 (project);
#line 1929 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1929 "../src/server.vala"
		return;
#line 19881 "server.c"
	}
#line 1932 "../src/server.vala"
	_tmp60_ = _result_;
#line 1932 "../src/server.vala"
	_tmp61_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, VALA_TYPE_SYMBOL, ValaSymbol));
#line 1932 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 1932 "../src/server.vala"
	symbol = _tmp61_;
#line 1934 "../src/server.vala"
	_tmp62_ = initial_result;
#line 1934 "../src/server.vala"
	_tmp63_ = symbol;
#line 1934 "../src/server.vala"
	_tmp64_ = vls_symbol_references_get_replacement_range (_tmp62_, _tmp63_);
#line 1934 "../src/server.vala"
	replacement_range = _tmp64_;
#line 1937 "../src/server.vala"
	_tmp66_ = replacement_range;
#line 1937 "../src/server.vala"
	if (_tmp66_ == NULL) {
#line 1937 "../src/server.vala"
		_tmp65_ = TRUE;
#line 19905 "server.c"
	} else {
		ValaSymbol* _tmp67_;
		ValaSourceReference* _tmp68_;
		ValaSourceReference* _tmp69_;
#line 1937 "../src/server.vala"
		_tmp67_ = symbol;
#line 1937 "../src/server.vala"
		_tmp68_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp67_);
#line 1937 "../src/server.vala"
		_tmp69_ = _tmp68_;
#line 1937 "../src/server.vala"
		_tmp65_ = _tmp69_ == NULL;
#line 19918 "server.c"
	}
#line 1937 "../src/server.vala"
	if (_tmp65_) {
#line 19922 "server.c"
		GCancellable* _tmp70_;
#line 1938 "../src/server.vala"
		_tmp70_ = vls_server_cancellable;
#line 1938 "../src/server.vala"
		jsonrpc_client_reply_error_async (_data39_->client, _data39_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, "There is no symbol at the cursor.", _tmp70_, NULL, NULL);
#line 1943 "../src/server.vala"
		vala_code_context_pop ();
#line 1944 "../src/server.vala"
		_g_object_unref0 (replacement_range);
#line 1944 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1944 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1944 "../src/server.vala"
		_vala_code_node_unref0 (initial_result);
#line 1944 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1944 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1944 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1944 "../src/server.vala"
		_g_object_unref0 (project);
#line 1944 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1944 "../src/server.vala"
		return;
#line 19950 "server.c"
	}
	{
		GeeIterator* _btarget_w_sym_it = NULL;
		VlsProject* _tmp71_;
		ValaSymbol* _tmp72_;
		GeeCollection* _tmp73_;
		GeeCollection* _tmp74_;
		GeeIterator* _tmp75_;
		GeeIterator* _tmp76_;
#line 1947 "../src/server.vala"
		_tmp71_ = project;
#line 1947 "../src/server.vala"
		_tmp72_ = symbol;
#line 1947 "../src/server.vala"
		_tmp73_ = vls_symbol_references_get_compilations_using_symbol (_tmp71_, _tmp72_);
#line 1947 "../src/server.vala"
		_tmp74_ = _tmp73_;
#line 1947 "../src/server.vala"
		_tmp75_ = gee_iterable_iterator ((GeeIterable*) _tmp74_);
#line 1947 "../src/server.vala"
		_tmp76_ = _tmp75_;
#line 1947 "../src/server.vala"
		_g_object_unref0 (_tmp74_);
#line 1947 "../src/server.vala"
		_btarget_w_sym_it = _tmp76_;
#line 1947 "../src/server.vala"
		while (TRUE) {
#line 19978 "server.c"
			GeeIterator* _tmp77_;
			VlsPair* btarget_w_sym = NULL;
			GeeIterator* _tmp78_;
			gpointer _tmp79_;
			VlsPair* _tmp80_;
			gconstpointer _tmp81_;
			gconstpointer _tmp82_;
			ValaSourceReference* _tmp83_;
			ValaSourceReference* _tmp84_;
			ValaSourceFile* _tmp85_;
			ValaSourceFile* _tmp86_;
#line 1947 "../src/server.vala"
			_tmp77_ = _btarget_w_sym_it;
#line 1947 "../src/server.vala"
			if (!gee_iterator_next (_tmp77_)) {
#line 1947 "../src/server.vala"
				break;
#line 19996 "server.c"
			}
#line 1947 "../src/server.vala"
			_tmp78_ = _btarget_w_sym_it;
#line 1947 "../src/server.vala"
			_tmp79_ = gee_iterator_get (_tmp78_);
#line 1947 "../src/server.vala"
			btarget_w_sym = (VlsPair*) _tmp79_;
#line 1948 "../src/server.vala"
			_tmp80_ = btarget_w_sym;
#line 1948 "../src/server.vala"
			_tmp81_ = vls_pair_get_second (_tmp80_);
#line 1948 "../src/server.vala"
			_tmp82_ = _tmp81_;
#line 1948 "../src/server.vala"
			_tmp83_ = vala_code_node_get_source_reference ((ValaCodeNode*) ((ValaSymbol*) _tmp82_));
#line 1948 "../src/server.vala"
			_tmp84_ = _tmp83_;
#line 1948 "../src/server.vala"
			_tmp85_ = vala_source_reference_get_file (_tmp84_);
#line 1948 "../src/server.vala"
			_tmp86_ = _tmp85_;
#line 1948 "../src/server.vala"
			if (!VLS_IS_TEXT_DOCUMENT (_tmp86_)) {
#line 20020 "server.c"
				gchar* pkg = NULL;
				VlsPair* _tmp87_;
				gconstpointer _tmp88_;
				gconstpointer _tmp89_;
				ValaSourceReference* _tmp90_;
				ValaSourceReference* _tmp91_;
				ValaSourceFile* _tmp92_;
				ValaSourceFile* _tmp93_;
				const gchar* _tmp94_;
				const gchar* _tmp95_;
				gchar* _tmp96_;
				gchar* _tmp97_ = NULL;
				const gchar* _tmp98_;
				gchar* _tmp103_;
				gchar* _tmp104_;
				GCancellable* _tmp105_;
#line 1952 "../src/server.vala"
				_tmp87_ = btarget_w_sym;
#line 1952 "../src/server.vala"
				_tmp88_ = vls_pair_get_second (_tmp87_);
#line 1952 "../src/server.vala"
				_tmp89_ = _tmp88_;
#line 1952 "../src/server.vala"
				_tmp90_ = vala_code_node_get_source_reference ((ValaCodeNode*) ((ValaSymbol*) _tmp89_));
#line 1952 "../src/server.vala"
				_tmp91_ = _tmp90_;
#line 1952 "../src/server.vala"
				_tmp92_ = vala_source_reference_get_file (_tmp91_);
#line 1952 "../src/server.vala"
				_tmp93_ = _tmp92_;
#line 1952 "../src/server.vala"
				_tmp94_ = vala_source_file_get_package_name (_tmp93_);
#line 1952 "../src/server.vala"
				_tmp95_ = _tmp94_;
#line 1952 "../src/server.vala"
				_tmp96_ = g_strdup (_tmp95_);
#line 1952 "../src/server.vala"
				pkg = _tmp96_;
#line 1956 "../src/server.vala"
				_tmp98_ = pkg;
#line 1956 "../src/server.vala"
				if (_tmp98_ != NULL) {
#line 20063 "server.c"
					const gchar* _tmp99_;
					const gchar* _tmp100_;
					gchar* _tmp101_;
#line 1956 "../src/server.vala"
					_tmp99_ = pkg;
#line 1956 "../src/server.vala"
					_tmp100_ = string_to_string (_tmp99_);
#line 1956 "../src/server.vala"
					_tmp101_ = g_strconcat (" (", _tmp100_, ").", NULL);
#line 1956 "../src/server.vala"
					_g_free0 (_tmp97_);
#line 1956 "../src/server.vala"
					_tmp97_ = _tmp101_;
#line 20077 "server.c"
				} else {
					gchar* _tmp102_;
#line 1956 "../src/server.vala"
					_tmp102_ = g_strdup (".");
#line 1956 "../src/server.vala"
					_g_free0 (_tmp97_);
#line 1956 "../src/server.vala"
					_tmp97_ = _tmp102_;
#line 20086 "server.c"
				}
#line 1953 "../src/server.vala"
				_tmp103_ = g_strconcat ("Cannot rename a symbol defined in a system library", _tmp97_, NULL);
#line 1953 "../src/server.vala"
				_tmp104_ = _tmp103_;
#line 1953 "../src/server.vala"
				_tmp105_ = vls_server_cancellable;
#line 1953 "../src/server.vala"
				jsonrpc_client_reply_error_async (_data39_->client, _data39_->id, (gint) JSONRPC_CLIENT_ERROR_INVALID_REQUEST, _tmp104_, _tmp105_, NULL, NULL);
#line 1953 "../src/server.vala"
				_g_free0 (_tmp104_);
#line 1958 "../src/server.vala"
				vala_code_context_pop ();
#line 1959 "../src/server.vala"
				_g_free0 (_tmp97_);
#line 1959 "../src/server.vala"
				_g_free0 (pkg);
#line 1959 "../src/server.vala"
				_g_object_unref0 (btarget_w_sym);
#line 1959 "../src/server.vala"
				_g_object_unref0 (_btarget_w_sym_it);
#line 1959 "../src/server.vala"
				_g_object_unref0 (replacement_range);
#line 1959 "../src/server.vala"
				_vala_code_node_unref0 (symbol);
#line 1959 "../src/server.vala"
				_vala_code_node_unref0 (_result_);
#line 1959 "../src/server.vala"
				_vala_code_node_unref0 (initial_result);
#line 1959 "../src/server.vala"
				_vala_code_visitor_unref0 (fs);
#line 1959 "../src/server.vala"
				_vala_source_file_unref0 (doc);
#line 1959 "../src/server.vala"
				_g_object_unref0 (compilation);
#line 1959 "../src/server.vala"
				_g_object_unref0 (project);
#line 1959 "../src/server.vala"
				_g_object_unref0 (pos);
#line 1959 "../src/server.vala"
				return;
#line 20128 "server.c"
			}
#line 1947 "../src/server.vala"
			_g_object_unref0 (btarget_w_sym);
#line 20132 "server.c"
		}
#line 1947 "../src/server.vala"
		_g_object_unref0 (_btarget_w_sym_it);
#line 20136 "server.c"
	}
	{
		GVariant* _tmp106_ = NULL;
		LspRange* _tmp107_;
		GVariant* _tmp108_;
		ValaSymbol* _tmp109_;
		const gchar* _tmp110_;
		const gchar* _tmp111_;
		GVariant* _tmp112_;
		GVariant* _tmp113_;
		GVariant* _tmp114_;
		GVariant* _tmp115_;
		GCancellable* _tmp116_;
#line 1967 "../src/server.vala"
		_tmp107_ = replacement_range;
#line 1967 "../src/server.vala"
		_tmp108_ = vls_util_object_to_variant ((GObject*) _tmp107_, &_inner_error0_);
#line 1967 "../src/server.vala"
		_tmp106_ = _tmp108_;
#line 1967 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20158 "server.c"
			goto __catch0_g_error;
		}
#line 1964 "../src/server.vala"
		_tmp109_ = symbol;
#line 1964 "../src/server.vala"
		_tmp110_ = vala_symbol_get_name (_tmp109_);
#line 1964 "../src/server.vala"
		_tmp111_ = _tmp110_;
#line 1964 "../src/server.vala"
		_tmp112_ = g_variant_new_string (_tmp111_);
#line 1964 "../src/server.vala"
		g_variant_ref_sink (_tmp112_);
#line 1964 "../src/server.vala"
		_tmp113_ = _tmp112_;
#line 1964 "../src/server.vala"
		_tmp114_ = vls_server_build_dict (self, "range", _tmp106_, "placeholder", _tmp113_, NULL);
#line 1964 "../src/server.vala"
		_tmp115_ = _tmp114_;
#line 1964 "../src/server.vala"
		_tmp116_ = vls_server_cancellable;
#line 1964 "../src/server.vala"
		jsonrpc_client_reply (_data39_->client, _data39_->id, _tmp115_, _tmp116_, &_inner_error0_);
#line 1964 "../src/server.vala"
		_g_variant_unref0 (_tmp115_);
#line 1964 "../src/server.vala"
		_g_variant_unref0 (_tmp113_);
#line 1964 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1964 "../src/server.vala"
			_g_variant_unref0 (_tmp106_);
#line 20189 "server.c"
			goto __catch0_g_error;
		}
#line 1963 "../src/server.vala"
		_g_variant_unref0 (_tmp106_);
#line 20194 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp117_;
		const gchar* _tmp118_;
#line 1963 "../src/server.vala"
		e = _inner_error0_;
#line 1963 "../src/server.vala"
		_inner_error0_ = NULL;
#line 1972 "../src/server.vala"
		_tmp117_ = e;
#line 1972 "../src/server.vala"
		_tmp118_ = _tmp117_->message;
#line 1972 "../src/server.vala"
		g_warning ("server.vala:1972: [%s] failed to reply with success - %s", _data39_->method, _tmp118_);
#line 1963 "../src/server.vala"
		_g_error_free0 (e);
#line 20214 "server.c"
	}
	__finally0:
#line 1963 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1963 "../src/server.vala"
		_g_object_unref0 (replacement_range);
#line 1963 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 1963 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 1963 "../src/server.vala"
		_vala_code_node_unref0 (initial_result);
#line 1963 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 1963 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 1963 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1963 "../src/server.vala"
		_g_object_unref0 (project);
#line 1963 "../src/server.vala"
		_g_object_unref0 (pos);
#line 1963 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1963 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 1963 "../src/server.vala"
		return;
#line 20243 "server.c"
	}
#line 1974 "../src/server.vala"
	vala_code_context_pop ();
#line 1878 "../src/server.vala"
	_g_object_unref0 (replacement_range);
#line 1878 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 1878 "../src/server.vala"
	_vala_code_node_unref0 (_result_);
#line 1878 "../src/server.vala"
	_vala_code_node_unref0 (initial_result);
#line 1878 "../src/server.vala"
	_vala_code_visitor_unref0 (fs);
#line 1878 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 1878 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1878 "../src/server.vala"
	_g_object_unref0 (project);
#line 1878 "../src/server.vala"
	_g_object_unref0 (pos);
#line 20265 "server.c"
}

static void
___lambda75__vls_server_on_context_updated_func (gboolean request_cancelled,
                                                 gpointer self)
{
#line 1878 "../src/server.vala"
	__lambda75_ (self, request_cancelled);
#line 20274 "server.c"
}

static void
vls_server_prepare_rename_symbol (VlsServer* self,
                                  JsonrpcClient* client,
                                  const gchar* method,
                                  GVariant* id,
                                  GVariant* params)
{
	Block39Data* _data39_;
	JsonrpcClient* _tmp0_;
	gchar* _tmp1_;
	GVariant* _tmp2_;
	gpointer _tmp3_;
#line 1875 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1875 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1875 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1875 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1875 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1875 "../src/server.vala"
	_data39_ = g_slice_new0 (Block39Data);
#line 1875 "../src/server.vala"
	_data39_->_ref_count_ = 1;
#line 1875 "../src/server.vala"
	_data39_->self = g_object_ref (self);
#line 1875 "../src/server.vala"
	_tmp0_ = _g_object_ref0 (client);
#line 1875 "../src/server.vala"
	_g_object_unref0 (_data39_->client);
#line 1875 "../src/server.vala"
	_data39_->client = _tmp0_;
#line 1875 "../src/server.vala"
	_tmp1_ = g_strdup (method);
#line 1875 "../src/server.vala"
	_g_free0 (_data39_->method);
#line 1875 "../src/server.vala"
	_data39_->method = _tmp1_;
#line 1875 "../src/server.vala"
	_tmp2_ = _g_variant_ref0 (id);
#line 1875 "../src/server.vala"
	_g_variant_unref0 (_data39_->id);
#line 1875 "../src/server.vala"
	_data39_->id = _tmp2_;
#line 1876 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 1876 "../src/server.vala"
	_data39_->p = (LspTextDocumentPositionParams*) _tmp3_;
#line 1878 "../src/server.vala"
	vls_server_wait_for_context_update (self, _data39_->id, ___lambda75__vls_server_on_context_updated_func, block39_data_ref (_data39_), block39_data_unref);
#line 1875 "../src/server.vala"
	block39_data_unref (_data39_);
#line 1875 "../src/server.vala"
	_data39_ = NULL;
#line 20333 "server.c"
}

/**
     * handle an incoming `textDocument/codeLens` request
     */
static gchar*
_variant_get12 (GVariant* value)
{
#line 1983 "../src/server.vala"
	return g_variant_dup_string (value, NULL);
#line 20344 "server.c"
}

static void
vls_server_code_lens (VlsServer* self,
                      JsonrpcClient* client,
                      const gchar* method,
                      GVariant* id,
                      GVariant* params)
{
	GVariant* document = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	gchar* _tmp2_ = NULL;
	GVariant* _tmp3_;
	gchar* uri = NULL;
	gchar* _tmp9_;
	gboolean _tmp10_ = FALSE;
	GVariant* _tmp11_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* file = NULL;
	const gchar* _tmp13_;
	VlsCompilation* _tmp14_ = NULL;
	VlsProject* _tmp15_ = NULL;
	ValaSourceFile* _tmp16_;
	ValaSourceFile* _tmp17_;
	VlsProject* _tmp19_;
	ValaSourceFile* _tmp20_;
	VlsCompilation* _tmp21_;
#line 1981 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 1981 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 1981 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 1981 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 1981 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 1982 "../src/server.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 1982 "../src/server.vala"
	_tmp1_ = g_variant_lookup_value (params, "textDocument", _tmp0_);
#line 1982 "../src/server.vala"
	document = _tmp1_;
#line 1983 "../src/server.vala"
	_tmp3_ = document;
#line 1983 "../src/server.vala"
	if (_tmp3_ != NULL) {
#line 20394 "server.c"
		GVariant* _tmp4_;
		const GVariantType* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		gchar* _tmp8_;
#line 1983 "../src/server.vala"
		_tmp4_ = document;
#line 1983 "../src/server.vala"
		_tmp5_ = G_VARIANT_TYPE_STRING;
#line 1983 "../src/server.vala"
		_tmp6_ = g_variant_lookup_value (_tmp4_, "uri", _tmp5_);
#line 1983 "../src/server.vala"
		_tmp7_ = _tmp6_;
#line 1983 "../src/server.vala"
		_tmp8_ = _variant_get12 (_tmp7_);
#line 1983 "../src/server.vala"
		_g_free0 (_tmp2_);
#line 1983 "../src/server.vala"
		_tmp2_ = _tmp8_;
#line 1983 "../src/server.vala"
		_g_variant_unref0 (_tmp7_);
#line 20416 "server.c"
	} else {
#line 1983 "../src/server.vala"
		_g_free0 (_tmp2_);
#line 1983 "../src/server.vala"
		_tmp2_ = NULL;
#line 20422 "server.c"
	}
#line 1983 "../src/server.vala"
	_tmp9_ = g_strdup (_tmp2_);
#line 1983 "../src/server.vala"
	uri = _tmp9_;
#line 1985 "../src/server.vala"
	_tmp11_ = document;
#line 1985 "../src/server.vala"
	if (_tmp11_ == NULL) {
#line 1985 "../src/server.vala"
		_tmp10_ = TRUE;
#line 20434 "server.c"
	} else {
		const gchar* _tmp12_;
#line 1985 "../src/server.vala"
		_tmp12_ = uri;
#line 1985 "../src/server.vala"
		_tmp10_ = _tmp12_ == NULL;
#line 20441 "server.c"
	}
#line 1985 "../src/server.vala"
	if (_tmp10_) {
#line 1986 "../src/server.vala"
		g_warning ("server.vala:1986: [%s] `textDocument` or `uri` not provided as expecte" \
"d", method);
#line 1987 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 1988 "../src/server.vala"
		_g_free0 (uri);
#line 1988 "../src/server.vala"
		_g_free0 (_tmp2_);
#line 1988 "../src/server.vala"
		_g_variant_unref0 (document);
#line 1988 "../src/server.vala"
		return;
#line 20457 "server.c"
	}
#line 1993 "../src/server.vala"
	_tmp13_ = uri;
#line 1993 "../src/server.vala"
	_tmp16_ = vls_server_find_file (self, _tmp13_, &_tmp14_, &_tmp15_);
#line 1993 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1993 "../src/server.vala"
	compilation = _tmp14_;
#line 1993 "../src/server.vala"
	_g_object_unref0 (project);
#line 1993 "../src/server.vala"
	project = _tmp15_;
#line 1993 "../src/server.vala"
	file = _tmp16_;
#line 1994 "../src/server.vala"
	_tmp17_ = file;
#line 1994 "../src/server.vala"
	if (_tmp17_ == NULL) {
#line 20477 "server.c"
		const gchar* _tmp18_;
#line 1995 "../src/server.vala"
		_tmp18_ = uri;
#line 1995 "../src/server.vala"
		g_debug ("server.vala:1995: [%s] file `%s' not found", method, _tmp18_);
#line 1996 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 1997 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 1997 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 1997 "../src/server.vala"
		_g_object_unref0 (project);
#line 1997 "../src/server.vala"
		_g_free0 (uri);
#line 1997 "../src/server.vala"
		_g_free0 (_tmp2_);
#line 1997 "../src/server.vala"
		_g_variant_unref0 (document);
#line 1997 "../src/server.vala"
		return;
#line 20499 "server.c"
	}
#line 2000 "../src/server.vala"
	_tmp19_ = project;
#line 2000 "../src/server.vala"
	_tmp20_ = file;
#line 2000 "../src/server.vala"
	_tmp21_ = compilation;
#line 2000 "../src/server.vala"
	vls_code_lens_engine_begin_response (self, _tmp19_, client, id, method, _tmp20_, _tmp21_);
#line 1981 "../src/server.vala"
	_vala_source_file_unref0 (file);
#line 1981 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 1981 "../src/server.vala"
	_g_object_unref0 (project);
#line 1981 "../src/server.vala"
	_g_free0 (uri);
#line 1981 "../src/server.vala"
	_g_free0 (_tmp2_);
#line 1981 "../src/server.vala"
	_g_variant_unref0 (document);
#line 20521 "server.c"
}

static void
vls_server_prepare_call_hierarchy (VlsServer* self,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* id,
                                   GVariant* params)
{
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp0_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentPositionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	VlsProject* _tmp7_ = NULL;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp9_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspTextDocumentPositionParams* _tmp19_;
	LspPosition* _tmp20_;
	LspPosition* _tmp21_;
	VlsNodeSearch* _tmp22_;
	VlsNodeSearch* _tmp23_;
	GeeList* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp30_;
	ValaSourceFile* _tmp31_;
	ValaCodeNode* _tmp32_;
	ValaMethod* method_sym = NULL;
	ValaCodeNode* _tmp33_;
	GError* _inner_error0_ = NULL;
#line 2003 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 2003 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 2003 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 2003 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 2003 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 2004 "../src/server.vala"
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 2004 "../src/server.vala"
	p = (LspTextDocumentPositionParams*) _tmp0_;
#line 2008 "../src/server.vala"
	_tmp1_ = p;
#line 2008 "../src/server.vala"
	_tmp2_ = lsp_text_document_position_params_get_textDocument (_tmp1_);
#line 2008 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 2008 "../src/server.vala"
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
#line 2008 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 2008 "../src/server.vala"
	_tmp8_ = vls_server_find_file (self, _tmp5_, &_tmp6_, &_tmp7_);
#line 2008 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2008 "../src/server.vala"
	compilation = _tmp6_;
#line 2008 "../src/server.vala"
	_g_object_unref0 (project);
#line 2008 "../src/server.vala"
	project = _tmp7_;
#line 2008 "../src/server.vala"
	doc = _tmp8_;
#line 2009 "../src/server.vala"
	_tmp9_ = doc;
#line 2009 "../src/server.vala"
	if (_tmp9_ == NULL) {
#line 20605 "server.c"
		LspTextDocumentPositionParams* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 2010 "../src/server.vala"
		_tmp10_ = p;
#line 2010 "../src/server.vala"
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_tmp10_);
#line 2010 "../src/server.vala"
		_tmp12_ = _tmp11_;
#line 2010 "../src/server.vala"
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
#line 2010 "../src/server.vala"
		_tmp14_ = _tmp13_;
#line 2010 "../src/server.vala"
		g_debug ("server.vala:2010: [%s] file `%s' not found", method, _tmp14_);
#line 2011 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2012 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2012 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2012 "../src/server.vala"
		_g_object_unref0 (project);
#line 2012 "../src/server.vala"
		_g_object_unref0 (p);
#line 2012 "../src/server.vala"
		return;
#line 20635 "server.c"
	}
#line 2015 "../src/server.vala"
	_tmp15_ = compilation;
#line 2015 "../src/server.vala"
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
#line 2015 "../src/server.vala"
	_tmp17_ = _tmp16_;
#line 2015 "../src/server.vala"
	vala_code_context_push (_tmp17_);
#line 2017 "../src/server.vala"
	_tmp18_ = doc;
#line 2017 "../src/server.vala"
	_tmp19_ = p;
#line 2017 "../src/server.vala"
	_tmp20_ = lsp_text_document_position_params_get_position (_tmp19_);
#line 2017 "../src/server.vala"
	_tmp21_ = _tmp20_;
#line 2017 "../src/server.vala"
	_tmp22_ = vls_node_search_new (_tmp18_, _tmp21_, FALSE, NULL, TRUE);
#line 2017 "../src/server.vala"
	fs = _tmp22_;
#line 2019 "../src/server.vala"
	_tmp23_ = fs;
#line 2019 "../src/server.vala"
	_tmp24_ = _tmp23_->result;
#line 2019 "../src/server.vala"
	_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
#line 2019 "../src/server.vala"
	_tmp26_ = _tmp25_;
#line 2019 "../src/server.vala"
	if (_tmp26_ == 0) {
#line 20667 "server.c"
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 2020 "../src/server.vala"
		_tmp27_ = string_to_string (method);
#line 2020 "../src/server.vala"
		_tmp28_ = g_strconcat ("[", _tmp27_, "] no results found", NULL);
#line 2020 "../src/server.vala"
		_tmp29_ = _tmp28_;
#line 2020 "../src/server.vala"
		g_debug ("server.vala:2020: %s", _tmp29_);
#line 2020 "../src/server.vala"
		_g_free0 (_tmp29_);
#line 2021 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2022 "../src/server.vala"
		vala_code_context_pop ();
#line 2023 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 2023 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2023 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2023 "../src/server.vala"
		_g_object_unref0 (project);
#line 2023 "../src/server.vala"
		_g_object_unref0 (p);
#line 2023 "../src/server.vala"
		return;
#line 20697 "server.c"
	}
#line 2026 "../src/server.vala"
	_tmp30_ = fs;
#line 2026 "../src/server.vala"
	_tmp31_ = doc;
#line 2026 "../src/server.vala"
	_tmp32_ = vls_server_get_best (_tmp30_, _tmp31_);
#line 2026 "../src/server.vala"
	_result_ = _tmp32_;
#line 2027 "../src/server.vala"
	vala_code_context_pop ();
#line 2031 "../src/server.vala"
	_tmp33_ = _result_;
#line 2031 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_METHOD)) {
#line 20713 "server.c"
		ValaCodeNode* _tmp34_;
		ValaMethod* _tmp35_;
#line 2032 "../src/server.vala"
		_tmp34_ = _result_;
#line 2032 "../src/server.vala"
		_tmp35_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, VALA_TYPE_METHOD, ValaMethod));
#line 2032 "../src/server.vala"
		_vala_code_node_unref0 (method_sym);
#line 2032 "../src/server.vala"
		method_sym = _tmp35_;
#line 20724 "server.c"
	} else {
		ValaCodeNode* _tmp36_;
#line 2033 "../src/server.vala"
		_tmp36_ = _result_;
#line 2033 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp36_, VALA_TYPE_METHOD_CALL)) {
#line 20731 "server.c"
			ValaMethod* call_method = NULL;
			ValaCodeNode* _tmp37_;
			ValaExpression* _tmp38_;
			ValaExpression* _tmp39_;
			ValaSymbol* _tmp40_;
			ValaSymbol* _tmp41_;
			ValaMethod* _tmp42_;
			ValaMethod* _tmp43_;
			ValaMethod* _tmp44_;
			ValaMethod* _tmp45_;
#line 2034 "../src/server.vala"
			_tmp37_ = _result_;
#line 2034 "../src/server.vala"
			_tmp38_ = vala_callable_expression_get_call ((ValaCallableExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp37_, VALA_TYPE_METHOD_CALL, ValaMethodCall));
#line 2034 "../src/server.vala"
			_tmp39_ = _tmp38_;
#line 2034 "../src/server.vala"
			_tmp40_ = vala_expression_get_symbol_reference (_tmp39_);
#line 2034 "../src/server.vala"
			_tmp41_ = _tmp40_;
#line 2034 "../src/server.vala"
			_tmp42_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp41_, VALA_TYPE_METHOD) ? ((ValaMethod*) _tmp41_) : NULL);
#line 2034 "../src/server.vala"
			call_method = _tmp42_;
#line 2035 "../src/server.vala"
			_tmp43_ = call_method;
#line 2035 "../src/server.vala"
			if (_tmp43_ == NULL) {
#line 2036 "../src/server.vala"
				vls_server_reply_null (id, client, method);
#line 2037 "../src/server.vala"
				_vala_code_node_unref0 (call_method);
#line 2037 "../src/server.vala"
				_vala_code_node_unref0 (method_sym);
#line 2037 "../src/server.vala"
				_vala_code_node_unref0 (_result_);
#line 2037 "../src/server.vala"
				_vala_code_visitor_unref0 (fs);
#line 2037 "../src/server.vala"
				_vala_source_file_unref0 (doc);
#line 2037 "../src/server.vala"
				_g_object_unref0 (compilation);
#line 2037 "../src/server.vala"
				_g_object_unref0 (project);
#line 2037 "../src/server.vala"
				_g_object_unref0 (p);
#line 2037 "../src/server.vala"
				return;
#line 20780 "server.c"
			}
#line 2039 "../src/server.vala"
			_tmp44_ = call_method;
#line 2039 "../src/server.vala"
			_tmp45_ = _vala_code_node_ref0 (_tmp44_);
#line 2039 "../src/server.vala"
			_vala_code_node_unref0 (method_sym);
#line 2039 "../src/server.vala"
			method_sym = _tmp45_;
#line 2033 "../src/server.vala"
			_vala_code_node_unref0 (call_method);
#line 20792 "server.c"
		} else {
			gboolean _tmp46_ = FALSE;
			ValaCodeNode* _tmp47_;
#line 2040 "../src/server.vala"
			_tmp47_ = _result_;
#line 2040 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp47_, VALA_TYPE_EXPRESSION)) {
#line 20800 "server.c"
				ValaCodeNode* _tmp48_;
				ValaSymbol* _tmp49_;
				ValaSymbol* _tmp50_;
#line 2040 "../src/server.vala"
				_tmp48_ = _result_;
#line 2040 "../src/server.vala"
				_tmp49_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 2040 "../src/server.vala"
				_tmp50_ = _tmp49_;
#line 2040 "../src/server.vala"
				_tmp46_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp50_, VALA_TYPE_METHOD);
#line 20812 "server.c"
			} else {
#line 2040 "../src/server.vala"
				_tmp46_ = FALSE;
#line 20816 "server.c"
			}
#line 2040 "../src/server.vala"
			if (_tmp46_) {
#line 20820 "server.c"
				ValaCodeNode* _tmp51_;
				ValaSymbol* _tmp52_;
				ValaSymbol* _tmp53_;
				ValaMethod* _tmp54_;
#line 2041 "../src/server.vala"
				_tmp51_ = _result_;
#line 2041 "../src/server.vala"
				_tmp52_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp51_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 2041 "../src/server.vala"
				_tmp53_ = _tmp52_;
#line 2041 "../src/server.vala"
				_tmp54_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, VALA_TYPE_METHOD, ValaMethod));
#line 2041 "../src/server.vala"
				_vala_code_node_unref0 (method_sym);
#line 2041 "../src/server.vala"
				method_sym = _tmp54_;
#line 20837 "server.c"
			} else {
#line 2043 "../src/server.vala"
				vls_server_reply_null (id, client, method);
#line 2044 "../src/server.vala"
				_vala_code_node_unref0 (method_sym);
#line 2044 "../src/server.vala"
				_vala_code_node_unref0 (_result_);
#line 2044 "../src/server.vala"
				_vala_code_visitor_unref0 (fs);
#line 2044 "../src/server.vala"
				_vala_source_file_unref0 (doc);
#line 2044 "../src/server.vala"
				_g_object_unref0 (compilation);
#line 2044 "../src/server.vala"
				_g_object_unref0 (project);
#line 2044 "../src/server.vala"
				_g_object_unref0 (p);
#line 2044 "../src/server.vala"
				return;
#line 20857 "server.c"
			}
		}
	}
	{
		GVariant* _tmp55_ = NULL;
		ValaMethod* _tmp56_;
		LspCallHierarchyItem* _tmp57_;
		LspCallHierarchyItem* _tmp58_;
		GVariant* _tmp59_;
		GVariant* _tmp60_;
		GVariant* array = NULL;
		GVariant* _tmp61_;
		GVariant** _tmp62_;
		GVariant** _tmp63_;
		gint _tmp63__length1;
		GVariant* _tmp64_;
		GVariant* _tmp65_;
		GVariant* _tmp66_;
		GCancellable* _tmp67_;
#line 2049 "../src/server.vala"
		_tmp56_ = method_sym;
#line 2049 "../src/server.vala"
		_tmp57_ = lsp_call_hierarchy_item_new_from_symbol ((ValaSymbol*) _tmp56_);
#line 2049 "../src/server.vala"
		if (_tmp57_) {
#line 2049 "../src/server.vala"
			g_object_set_data ((GObject *) _tmp57_, "vala-creation-function", "Vls.Server.prepare_call_hierarchy");
#line 20885 "server.c"
		}
#line 2049 "../src/server.vala"
		_tmp58_ = _tmp57_;
#line 2049 "../src/server.vala"
		_tmp59_ = vls_util_object_to_variant ((GObject*) _tmp58_, &_inner_error0_);
#line 2049 "../src/server.vala"
		_tmp60_ = _tmp59_;
#line 2049 "../src/server.vala"
		_g_object_unref0 (_tmp58_);
#line 2049 "../src/server.vala"
		_tmp55_ = _tmp60_;
#line 2049 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 20899 "server.c"
			goto __catch0_g_error;
		}
#line 2048 "../src/server.vala"
		_tmp61_ = _tmp55_;
#line 2048 "../src/server.vala"
		_tmp55_ = NULL;
#line 2048 "../src/server.vala"
		_tmp62_ = g_new0 (GVariant*, 1 + 1);
#line 2048 "../src/server.vala"
		_tmp62_[0] = _tmp61_;
#line 2048 "../src/server.vala"
		_tmp63_ = _tmp62_;
#line 2048 "../src/server.vala"
		_tmp63__length1 = 1;
#line 2048 "../src/server.vala"
		_tmp64_ = g_variant_new_array (NULL, _tmp63_, 1);
#line 2048 "../src/server.vala"
		g_variant_ref_sink (_tmp64_);
#line 2048 "../src/server.vala"
		_tmp65_ = _tmp64_;
#line 2048 "../src/server.vala"
		_tmp63_ = (_vala_array_free (_tmp63_, _tmp63__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 2048 "../src/server.vala"
		array = _tmp65_;
#line 2051 "../src/server.vala"
		_tmp66_ = array;
#line 2051 "../src/server.vala"
		_tmp67_ = vls_server_cancellable;
#line 2051 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp66_, _tmp67_, &_inner_error0_);
#line 2051 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2051 "../src/server.vala"
			_g_variant_unref0 (array);
#line 2051 "../src/server.vala"
			_g_variant_unref0 (_tmp55_);
#line 20936 "server.c"
			goto __catch0_g_error;
		}
#line 2047 "../src/server.vala"
		_g_variant_unref0 (array);
#line 2047 "../src/server.vala"
		_g_variant_unref0 (_tmp55_);
#line 20943 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp68_;
		GError* _tmp69_;
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		gchar* _tmp72_;
		gchar* _tmp73_;
#line 2047 "../src/server.vala"
		e = _inner_error0_;
#line 2047 "../src/server.vala"
		_inner_error0_ = NULL;
#line 2053 "../src/server.vala"
		_tmp68_ = string_to_string (method);
#line 2053 "../src/server.vala"
		_tmp69_ = e;
#line 2053 "../src/server.vala"
		_tmp70_ = _tmp69_->message;
#line 2053 "../src/server.vala"
		_tmp71_ = string_to_string (_tmp70_);
#line 2053 "../src/server.vala"
		_tmp72_ = g_strconcat ("[", _tmp68_, "] failed to reply to client: ", _tmp71_, NULL);
#line 2053 "../src/server.vala"
		_tmp73_ = _tmp72_;
#line 2053 "../src/server.vala"
		g_debug ("server.vala:2053: %s", _tmp73_);
#line 2053 "../src/server.vala"
		_g_free0 (_tmp73_);
#line 2047 "../src/server.vala"
		_g_error_free0 (e);
#line 20977 "server.c"
	}
	__finally0:
#line 2047 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2047 "../src/server.vala"
		_vala_code_node_unref0 (method_sym);
#line 2047 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 2047 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 2047 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2047 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2047 "../src/server.vala"
		_g_object_unref0 (project);
#line 2047 "../src/server.vala"
		_g_object_unref0 (p);
#line 2047 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2047 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 2047 "../src/server.vala"
		return;
#line 21002 "server.c"
	}
#line 2003 "../src/server.vala"
	_vala_code_node_unref0 (method_sym);
#line 2003 "../src/server.vala"
	_vala_code_node_unref0 (_result_);
#line 2003 "../src/server.vala"
	_vala_code_visitor_unref0 (fs);
#line 2003 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 2003 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2003 "../src/server.vala"
	_g_object_unref0 (project);
#line 2003 "../src/server.vala"
	_g_object_unref0 (p);
#line 21018 "server.c"
}

static void
_vala_array_add30 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
#line 2083 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2083 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2083 "../src/server.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 21033 "server.c"
	}
#line 2083 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2083 "../src/server.vala"
	(*array)[*length] = NULL;
#line 21039 "server.c"
}

static void
vls_server_call_hierarchy_incoming_calls (VlsServer* self,
                                          JsonrpcClient* client,
                                          const gchar* method,
                                          GVariant* id,
                                          GVariant* params)
{
	GVariant* itemv = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	LspCallHierarchyItem* item = NULL;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspCallHierarchyItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaSymbol* symbol = NULL;
	LspCallHierarchyItem* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	VlsCompilation* _tmp20_;
	ValaCodeContext* _tmp21_;
	ValaCodeContext* _tmp22_;
	ValaNamespace* _tmp23_;
	ValaNamespace* _tmp24_;
	ValaScope* _tmp25_;
	ValaScope* _tmp26_;
	ValaSymbol* _tmp27_;
	gboolean _tmp28_ = FALSE;
	ValaSymbol* _tmp29_;
	GError* _inner_error0_ = NULL;
#line 2057 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 2057 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 2057 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 2057 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 2057 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 2058 "../src/server.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 2058 "../src/server.vala"
	_tmp1_ = g_variant_lookup_value (params, "item", _tmp0_);
#line 2058 "../src/server.vala"
	itemv = _tmp1_;
#line 2059 "../src/server.vala"
	_tmp2_ = itemv;
#line 2059 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_CALL_HIERARCHY_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_);
#line 2059 "../src/server.vala"
	item = (LspCallHierarchyItem*) _tmp3_;
#line 2063 "../src/server.vala"
	_tmp4_ = item;
#line 2063 "../src/server.vala"
	_tmp5_ = lsp_call_hierarchy_item_get_uri (_tmp4_);
#line 2063 "../src/server.vala"
	_tmp6_ = _tmp5_;
#line 2063 "../src/server.vala"
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
#line 2063 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2063 "../src/server.vala"
	compilation = _tmp7_;
#line 2063 "../src/server.vala"
	_g_object_unref0 (project);
#line 2063 "../src/server.vala"
	project = _tmp8_;
#line 2063 "../src/server.vala"
	doc = _tmp9_;
#line 2064 "../src/server.vala"
	_tmp10_ = doc;
#line 2064 "../src/server.vala"
	if (_tmp10_ == NULL) {
#line 21127 "server.c"
		LspCallHierarchyItem* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 2065 "../src/server.vala"
		_tmp11_ = item;
#line 2065 "../src/server.vala"
		_tmp12_ = lsp_call_hierarchy_item_get_uri (_tmp11_);
#line 2065 "../src/server.vala"
		_tmp13_ = _tmp12_;
#line 2065 "../src/server.vala"
		g_debug ("server.vala:2065: [%s] file `%s' not found", method, _tmp13_);
#line 2066 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2067 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2067 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2067 "../src/server.vala"
		_g_object_unref0 (project);
#line 2067 "../src/server.vala"
		_g_object_unref0 (item);
#line 2067 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2067 "../src/server.vala"
		return;
#line 21153 "server.c"
	}
#line 2070 "../src/server.vala"
	_tmp14_ = compilation;
#line 2070 "../src/server.vala"
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
#line 2070 "../src/server.vala"
	_tmp16_ = _tmp15_;
#line 2070 "../src/server.vala"
	vala_code_context_push (_tmp16_);
#line 2072 "../src/server.vala"
	_tmp17_ = item;
#line 2072 "../src/server.vala"
	_tmp18_ = lsp_call_hierarchy_item_get_name (_tmp17_);
#line 2072 "../src/server.vala"
	_tmp19_ = _tmp18_;
#line 2072 "../src/server.vala"
	_tmp20_ = compilation;
#line 2072 "../src/server.vala"
	_tmp21_ = vls_compilation_get_code_context (_tmp20_);
#line 2072 "../src/server.vala"
	_tmp22_ = _tmp21_;
#line 2072 "../src/server.vala"
	_tmp23_ = vala_code_context_get_root (_tmp22_);
#line 2072 "../src/server.vala"
	_tmp24_ = _tmp23_;
#line 2072 "../src/server.vala"
	_tmp25_ = vala_symbol_get_scope ((ValaSymbol*) _tmp24_);
#line 2072 "../src/server.vala"
	_tmp26_ = _tmp25_;
#line 2072 "../src/server.vala"
	_tmp27_ = vls_code_help_lookup_symbol_full_name (_tmp19_, _tmp26_, NULL);
#line 2072 "../src/server.vala"
	symbol = _tmp27_;
#line 2073 "../src/server.vala"
	_tmp29_ = symbol;
#line 2073 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp29_, VALA_TYPE_CALLABLE)) {
#line 2073 "../src/server.vala"
		_tmp28_ = TRUE;
#line 21193 "server.c"
	} else {
		ValaSymbol* _tmp30_;
#line 2073 "../src/server.vala"
		_tmp30_ = symbol;
#line 2073 "../src/server.vala"
		_tmp28_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp30_, VALA_TYPE_SUBROUTINE);
#line 21200 "server.c"
	}
#line 2073 "../src/server.vala"
	if (!_tmp28_) {
#line 2074 "../src/server.vala"
		vala_code_context_pop ();
#line 2075 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2076 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 2076 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2076 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2076 "../src/server.vala"
		_g_object_unref0 (project);
#line 2076 "../src/server.vala"
		_g_object_unref0 (item);
#line 2076 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2076 "../src/server.vala"
		return;
#line 21222 "server.c"
	}
	{
		GVariant** incoming_va = NULL;
		GVariant** _tmp31_;
		gint incoming_va_length1;
		gint _incoming_va_size_;
		VlsProject* _tmp32_;
		ValaSymbol* _tmp33_;
		gint _tmp34_ = 0;
		LspCallHierarchyIncomingCall** _tmp35_;
		const GVariantType* _tmp41_;
		GVariant** _tmp42_;
		gint _tmp42__length1;
		GVariant* _tmp43_;
		GVariant* _tmp44_;
		GCancellable* _tmp45_;
#line 2081 "../src/server.vala"
		_tmp31_ = g_new0 (GVariant*, 0 + 1);
#line 2081 "../src/server.vala"
		incoming_va = _tmp31_;
#line 2081 "../src/server.vala"
		incoming_va_length1 = 0;
#line 2081 "../src/server.vala"
		_incoming_va_size_ = incoming_va_length1;
#line 2082 "../src/server.vala"
		_tmp32_ = project;
#line 2082 "../src/server.vala"
		_tmp33_ = symbol;
#line 2082 "../src/server.vala"
		_tmp35_ = vls_call_hierarchy_get_incoming_calls (_tmp32_, _tmp33_, &_tmp34_);
#line 21253 "server.c"
		{
			LspCallHierarchyIncomingCall** incoming_call_collection = NULL;
			gint incoming_call_collection_length1 = 0;
			gint _incoming_call_collection_size_ = 0;
			gint incoming_call_it = 0;
#line 2082 "../src/server.vala"
			incoming_call_collection = _tmp35_;
#line 2082 "../src/server.vala"
			incoming_call_collection_length1 = _tmp34_;
#line 2082 "../src/server.vala"
			for (incoming_call_it = 0; incoming_call_it < incoming_call_collection_length1; incoming_call_it = incoming_call_it + 1) {
#line 21265 "server.c"
				LspCallHierarchyIncomingCall* _tmp36_;
				LspCallHierarchyIncomingCall* incoming_call = NULL;
#line 2082 "../src/server.vala"
				_tmp36_ = _g_object_ref0 (incoming_call_collection[incoming_call_it]);
#line 2082 "../src/server.vala"
				incoming_call = _tmp36_;
#line 21272 "server.c"
				{
					GVariant* _tmp37_ = NULL;
					LspCallHierarchyIncomingCall* _tmp38_;
					GVariant* _tmp39_;
					GVariant* _tmp40_;
#line 2083 "../src/server.vala"
					_tmp38_ = incoming_call;
#line 2083 "../src/server.vala"
					_tmp39_ = vls_util_object_to_variant ((GObject*) _tmp38_, &_inner_error0_);
#line 2083 "../src/server.vala"
					_tmp37_ = _tmp39_;
#line 2083 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2083 "../src/server.vala"
						_g_object_unref0 (incoming_call);
#line 2083 "../src/server.vala"
						incoming_call_collection = (_vala_array_free (incoming_call_collection, incoming_call_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2083 "../src/server.vala"
						incoming_va = (_vala_array_free (incoming_va, incoming_va_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 21292 "server.c"
						goto __catch0_g_error;
					}
#line 2083 "../src/server.vala"
					_tmp40_ = _tmp37_;
#line 2083 "../src/server.vala"
					_tmp37_ = NULL;
#line 2083 "../src/server.vala"
					_vala_array_add30 (&incoming_va, &incoming_va_length1, &_incoming_va_size_, _tmp40_);
#line 2082 "../src/server.vala"
					_g_variant_unref0 (_tmp37_);
#line 2082 "../src/server.vala"
					_g_object_unref0 (incoming_call);
#line 21305 "server.c"
				}
			}
#line 2082 "../src/server.vala"
			incoming_call_collection = (_vala_array_free (incoming_call_collection, incoming_call_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 21310 "server.c"
		}
#line 2084 "../src/server.vala"
		vala_code_context_pop ();
#line 2085 "../src/server.vala"
		_tmp41_ = G_VARIANT_TYPE_VARDICT;
#line 2085 "../src/server.vala"
		_tmp42_ = incoming_va;
#line 2085 "../src/server.vala"
		_tmp42__length1 = incoming_va_length1;
#line 2085 "../src/server.vala"
		_tmp43_ = g_variant_new_array (_tmp41_, _tmp42_, _tmp42__length1);
#line 2085 "../src/server.vala"
		g_variant_ref_sink (_tmp43_);
#line 2085 "../src/server.vala"
		_tmp44_ = _tmp43_;
#line 2085 "../src/server.vala"
		_tmp45_ = vls_server_cancellable;
#line 2085 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp44_, _tmp45_, &_inner_error0_);
#line 2085 "../src/server.vala"
		_g_variant_unref0 (_tmp44_);
#line 2085 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2085 "../src/server.vala"
			incoming_va = (_vala_array_free (incoming_va, incoming_va_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 21336 "server.c"
			goto __catch0_g_error;
		}
#line 2080 "../src/server.vala"
		incoming_va = (_vala_array_free (incoming_va, incoming_va_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 21341 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp46_;
		GError* _tmp47_;
		const gchar* _tmp48_;
		const gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
#line 2080 "../src/server.vala"
		e = _inner_error0_;
#line 2080 "../src/server.vala"
		_inner_error0_ = NULL;
#line 2087 "../src/server.vala"
		_tmp46_ = string_to_string (method);
#line 2087 "../src/server.vala"
		_tmp47_ = e;
#line 2087 "../src/server.vala"
		_tmp48_ = _tmp47_->message;
#line 2087 "../src/server.vala"
		_tmp49_ = string_to_string (_tmp48_);
#line 2087 "../src/server.vala"
		_tmp50_ = g_strconcat ("[", _tmp46_, "] failed to reply to client: ", _tmp49_, NULL);
#line 2087 "../src/server.vala"
		_tmp51_ = _tmp50_;
#line 2087 "../src/server.vala"
		g_debug ("server.vala:2087: %s", _tmp51_);
#line 2087 "../src/server.vala"
		_g_free0 (_tmp51_);
#line 2080 "../src/server.vala"
		_g_error_free0 (e);
#line 21375 "server.c"
	}
	__finally0:
#line 2080 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2080 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 2080 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2080 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2080 "../src/server.vala"
		_g_object_unref0 (project);
#line 2080 "../src/server.vala"
		_g_object_unref0 (item);
#line 2080 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2080 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2080 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 2080 "../src/server.vala"
		return;
#line 21398 "server.c"
	}
#line 2057 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 2057 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 2057 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2057 "../src/server.vala"
	_g_object_unref0 (project);
#line 2057 "../src/server.vala"
	_g_object_unref0 (item);
#line 2057 "../src/server.vala"
	_g_variant_unref0 (itemv);
#line 21412 "server.c"
}

static void
_vala_array_add31 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
#line 2117 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2117 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2117 "../src/server.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 21427 "server.c"
	}
#line 2117 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2117 "../src/server.vala"
	(*array)[*length] = NULL;
#line 21433 "server.c"
}

static void
vls_server_call_hierarchy_outgoing_calls (VlsServer* self,
                                          JsonrpcClient* client,
                                          const gchar* method,
                                          GVariant* id,
                                          GVariant* params)
{
	GVariant* itemv = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	LspCallHierarchyItem* item = NULL;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspCallHierarchyItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaSubroutine* subroutine = NULL;
	LspCallHierarchyItem* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	VlsCompilation* _tmp20_;
	ValaCodeContext* _tmp21_;
	ValaCodeContext* _tmp22_;
	ValaNamespace* _tmp23_;
	ValaNamespace* _tmp24_;
	ValaScope* _tmp25_;
	ValaScope* _tmp26_;
	ValaSymbol* _tmp27_;
	ValaSubroutine* _tmp28_;
	ValaSubroutine* _tmp29_;
	GError* _inner_error0_ = NULL;
#line 2091 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 2091 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 2091 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 2091 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 2091 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 2092 "../src/server.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 2092 "../src/server.vala"
	_tmp1_ = g_variant_lookup_value (params, "item", _tmp0_);
#line 2092 "../src/server.vala"
	itemv = _tmp1_;
#line 2093 "../src/server.vala"
	_tmp2_ = itemv;
#line 2093 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_CALL_HIERARCHY_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_);
#line 2093 "../src/server.vala"
	item = (LspCallHierarchyItem*) _tmp3_;
#line 2097 "../src/server.vala"
	_tmp4_ = item;
#line 2097 "../src/server.vala"
	_tmp5_ = lsp_call_hierarchy_item_get_uri (_tmp4_);
#line 2097 "../src/server.vala"
	_tmp6_ = _tmp5_;
#line 2097 "../src/server.vala"
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
#line 2097 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2097 "../src/server.vala"
	compilation = _tmp7_;
#line 2097 "../src/server.vala"
	_g_object_unref0 (project);
#line 2097 "../src/server.vala"
	project = _tmp8_;
#line 2097 "../src/server.vala"
	doc = _tmp9_;
#line 2098 "../src/server.vala"
	_tmp10_ = doc;
#line 2098 "../src/server.vala"
	if (_tmp10_ == NULL) {
#line 21521 "server.c"
		LspCallHierarchyItem* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 2099 "../src/server.vala"
		_tmp11_ = item;
#line 2099 "../src/server.vala"
		_tmp12_ = lsp_call_hierarchy_item_get_uri (_tmp11_);
#line 2099 "../src/server.vala"
		_tmp13_ = _tmp12_;
#line 2099 "../src/server.vala"
		g_debug ("server.vala:2099: [%s] file `%s' not found", method, _tmp13_);
#line 2100 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2101 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2101 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2101 "../src/server.vala"
		_g_object_unref0 (project);
#line 2101 "../src/server.vala"
		_g_object_unref0 (item);
#line 2101 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2101 "../src/server.vala"
		return;
#line 21547 "server.c"
	}
#line 2104 "../src/server.vala"
	_tmp14_ = compilation;
#line 2104 "../src/server.vala"
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
#line 2104 "../src/server.vala"
	_tmp16_ = _tmp15_;
#line 2104 "../src/server.vala"
	vala_code_context_push (_tmp16_);
#line 2106 "../src/server.vala"
	_tmp17_ = item;
#line 2106 "../src/server.vala"
	_tmp18_ = lsp_call_hierarchy_item_get_name (_tmp17_);
#line 2106 "../src/server.vala"
	_tmp19_ = _tmp18_;
#line 2106 "../src/server.vala"
	_tmp20_ = compilation;
#line 2106 "../src/server.vala"
	_tmp21_ = vls_compilation_get_code_context (_tmp20_);
#line 2106 "../src/server.vala"
	_tmp22_ = _tmp21_;
#line 2106 "../src/server.vala"
	_tmp23_ = vala_code_context_get_root (_tmp22_);
#line 2106 "../src/server.vala"
	_tmp24_ = _tmp23_;
#line 2106 "../src/server.vala"
	_tmp25_ = vala_symbol_get_scope ((ValaSymbol*) _tmp24_);
#line 2106 "../src/server.vala"
	_tmp26_ = _tmp25_;
#line 2106 "../src/server.vala"
	_tmp27_ = vls_code_help_lookup_symbol_full_name (_tmp19_, _tmp26_, NULL);
#line 2106 "../src/server.vala"
	_tmp28_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp27_, VALA_TYPE_SUBROUTINE) ? ((ValaSubroutine*) _tmp27_) : NULL;
#line 2106 "../src/server.vala"
	if (_tmp28_ == NULL) {
#line 2106 "../src/server.vala"
		_vala_code_node_unref0 (_tmp27_);
#line 21585 "server.c"
	}
#line 2106 "../src/server.vala"
	subroutine = _tmp28_;
#line 2107 "../src/server.vala"
	_tmp29_ = subroutine;
#line 2107 "../src/server.vala"
	if (_tmp29_ == NULL) {
#line 2108 "../src/server.vala"
		vala_code_context_pop ();
#line 2109 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2110 "../src/server.vala"
		_vala_code_node_unref0 (subroutine);
#line 2110 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2110 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2110 "../src/server.vala"
		_g_object_unref0 (project);
#line 2110 "../src/server.vala"
		_g_object_unref0 (item);
#line 2110 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2110 "../src/server.vala"
		return;
#line 21611 "server.c"
	}
	{
		GVariant** outgoing_va = NULL;
		GVariant** _tmp30_;
		gint outgoing_va_length1;
		gint _outgoing_va_size_;
		VlsProject* _tmp31_;
		ValaSubroutine* _tmp32_;
		gint _tmp33_ = 0;
		LspCallHierarchyOutgoingCall** _tmp34_;
		const GVariantType* _tmp40_;
		GVariant** _tmp41_;
		gint _tmp41__length1;
		GVariant* _tmp42_;
		GVariant* _tmp43_;
		GCancellable* _tmp44_;
#line 2115 "../src/server.vala"
		_tmp30_ = g_new0 (GVariant*, 0 + 1);
#line 2115 "../src/server.vala"
		outgoing_va = _tmp30_;
#line 2115 "../src/server.vala"
		outgoing_va_length1 = 0;
#line 2115 "../src/server.vala"
		_outgoing_va_size_ = outgoing_va_length1;
#line 2116 "../src/server.vala"
		_tmp31_ = project;
#line 2116 "../src/server.vala"
		_tmp32_ = subroutine;
#line 2116 "../src/server.vala"
		_tmp34_ = vls_call_hierarchy_get_outgoing_calls (_tmp31_, _tmp32_, &_tmp33_);
#line 21642 "server.c"
		{
			LspCallHierarchyOutgoingCall** outgoing_call_collection = NULL;
			gint outgoing_call_collection_length1 = 0;
			gint _outgoing_call_collection_size_ = 0;
			gint outgoing_call_it = 0;
#line 2116 "../src/server.vala"
			outgoing_call_collection = _tmp34_;
#line 2116 "../src/server.vala"
			outgoing_call_collection_length1 = _tmp33_;
#line 2116 "../src/server.vala"
			for (outgoing_call_it = 0; outgoing_call_it < outgoing_call_collection_length1; outgoing_call_it = outgoing_call_it + 1) {
#line 21654 "server.c"
				LspCallHierarchyOutgoingCall* _tmp35_;
				LspCallHierarchyOutgoingCall* outgoing_call = NULL;
#line 2116 "../src/server.vala"
				_tmp35_ = _g_object_ref0 (outgoing_call_collection[outgoing_call_it]);
#line 2116 "../src/server.vala"
				outgoing_call = _tmp35_;
#line 21661 "server.c"
				{
					GVariant* _tmp36_ = NULL;
					LspCallHierarchyOutgoingCall* _tmp37_;
					GVariant* _tmp38_;
					GVariant* _tmp39_;
#line 2117 "../src/server.vala"
					_tmp37_ = outgoing_call;
#line 2117 "../src/server.vala"
					_tmp38_ = vls_util_object_to_variant ((GObject*) _tmp37_, &_inner_error0_);
#line 2117 "../src/server.vala"
					_tmp36_ = _tmp38_;
#line 2117 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2117 "../src/server.vala"
						_g_object_unref0 (outgoing_call);
#line 2117 "../src/server.vala"
						outgoing_call_collection = (_vala_array_free (outgoing_call_collection, outgoing_call_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2117 "../src/server.vala"
						outgoing_va = (_vala_array_free (outgoing_va, outgoing_va_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 21681 "server.c"
						goto __catch0_g_error;
					}
#line 2117 "../src/server.vala"
					_tmp39_ = _tmp36_;
#line 2117 "../src/server.vala"
					_tmp36_ = NULL;
#line 2117 "../src/server.vala"
					_vala_array_add31 (&outgoing_va, &outgoing_va_length1, &_outgoing_va_size_, _tmp39_);
#line 2116 "../src/server.vala"
					_g_variant_unref0 (_tmp36_);
#line 2116 "../src/server.vala"
					_g_object_unref0 (outgoing_call);
#line 21694 "server.c"
				}
			}
#line 2116 "../src/server.vala"
			outgoing_call_collection = (_vala_array_free (outgoing_call_collection, outgoing_call_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 21699 "server.c"
		}
#line 2118 "../src/server.vala"
		vala_code_context_pop ();
#line 2119 "../src/server.vala"
		_tmp40_ = G_VARIANT_TYPE_VARDICT;
#line 2119 "../src/server.vala"
		_tmp41_ = outgoing_va;
#line 2119 "../src/server.vala"
		_tmp41__length1 = outgoing_va_length1;
#line 2119 "../src/server.vala"
		_tmp42_ = g_variant_new_array (_tmp40_, _tmp41_, _tmp41__length1);
#line 2119 "../src/server.vala"
		g_variant_ref_sink (_tmp42_);
#line 2119 "../src/server.vala"
		_tmp43_ = _tmp42_;
#line 2119 "../src/server.vala"
		_tmp44_ = vls_server_cancellable;
#line 2119 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp43_, _tmp44_, &_inner_error0_);
#line 2119 "../src/server.vala"
		_g_variant_unref0 (_tmp43_);
#line 2119 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2119 "../src/server.vala"
			outgoing_va = (_vala_array_free (outgoing_va, outgoing_va_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 21725 "server.c"
			goto __catch0_g_error;
		}
#line 2114 "../src/server.vala"
		outgoing_va = (_vala_array_free (outgoing_va, outgoing_va_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 21730 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp45_;
		GError* _tmp46_;
		const gchar* _tmp47_;
		const gchar* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
#line 2114 "../src/server.vala"
		e = _inner_error0_;
#line 2114 "../src/server.vala"
		_inner_error0_ = NULL;
#line 2121 "../src/server.vala"
		_tmp45_ = string_to_string (method);
#line 2121 "../src/server.vala"
		_tmp46_ = e;
#line 2121 "../src/server.vala"
		_tmp47_ = _tmp46_->message;
#line 2121 "../src/server.vala"
		_tmp48_ = string_to_string (_tmp47_);
#line 2121 "../src/server.vala"
		_tmp49_ = g_strconcat ("[", _tmp45_, "] failed to reply to client: ", _tmp48_, NULL);
#line 2121 "../src/server.vala"
		_tmp50_ = _tmp49_;
#line 2121 "../src/server.vala"
		g_debug ("server.vala:2121: %s", _tmp50_);
#line 2121 "../src/server.vala"
		_g_free0 (_tmp50_);
#line 2114 "../src/server.vala"
		_g_error_free0 (e);
#line 21764 "server.c"
	}
	__finally0:
#line 2114 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2114 "../src/server.vala"
		_vala_code_node_unref0 (subroutine);
#line 2114 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2114 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2114 "../src/server.vala"
		_g_object_unref0 (project);
#line 2114 "../src/server.vala"
		_g_object_unref0 (item);
#line 2114 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2114 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2114 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 2114 "../src/server.vala"
		return;
#line 21787 "server.c"
	}
#line 2091 "../src/server.vala"
	_vala_code_node_unref0 (subroutine);
#line 2091 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 2091 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2091 "../src/server.vala"
	_g_object_unref0 (project);
#line 2091 "../src/server.vala"
	_g_object_unref0 (item);
#line 2091 "../src/server.vala"
	_g_variant_unref0 (itemv);
#line 21801 "server.c"
}

static void
_vala_array_add32 (LspInlayHint** * array,
                   gint* length,
                   gint* size,
                   LspInlayHint* value)
{
#line 2156 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2156 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2156 "../src/server.vala"
		*array = g_renew (LspInlayHint*, *array, (*size) + 1);
#line 21816 "server.c"
	}
#line 2156 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2156 "../src/server.vala"
	(*array)[*length] = NULL;
#line 21822 "server.c"
}

static void
_vala_array_add33 (LspInlayHint** * array,
                   gint* length,
                   gint* size,
                   LspInlayHint* value)
{
#line 2193 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2193 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2193 "../src/server.vala"
		*array = g_renew (LspInlayHint*, *array, (*size) + 1);
#line 21837 "server.c"
	}
#line 2193 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2193 "../src/server.vala"
	(*array)[*length] = NULL;
#line 21843 "server.c"
}

static void
_vala_array_add34 (LspInlayHint** * array,
                   gint* length,
                   gint* size,
                   LspInlayHint* value)
{
#line 2204 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2204 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2204 "../src/server.vala"
		*array = g_renew (LspInlayHint*, *array, (*size) + 1);
#line 21858 "server.c"
	}
#line 2204 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2204 "../src/server.vala"
	(*array)[*length] = NULL;
#line 21864 "server.c"
}

static void
_vala_array_add35 (LspInlayHint** * array,
                   gint* length,
                   gint* size,
                   LspInlayHint* value)
{
#line 2260 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2260 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2260 "../src/server.vala"
		*array = g_renew (LspInlayHint*, *array, (*size) + 1);
#line 21879 "server.c"
	}
#line 2260 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2260 "../src/server.vala"
	(*array)[*length] = NULL;
#line 21885 "server.c"
}

static void
_vala_array_add36 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
#line 2276 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2276 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2276 "../src/server.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 21900 "server.c"
	}
#line 2276 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2276 "../src/server.vala"
	(*array)[*length] = NULL;
#line 21906 "server.c"
}

static void
vls_server_show_inlay_hints (VlsServer* self,
                             JsonrpcClient* client,
                             const gchar* method,
                             GVariant* id,
                             GVariant* params)
{
	LspInlayHintParams* p = NULL;
	gpointer _tmp0_;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* file = NULL;
	LspInlayHintParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	ValaSourceFile* _tmp7_;
	ValaSourceFile* _tmp8_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	VlsNodeSearch* query = NULL;
	ValaSourceFile* _tmp17_;
	LspInlayHintParams* _tmp18_;
	LspRange* _tmp19_;
	LspRange* _tmp20_;
	VlsNodeSearch* _tmp21_;
	VlsNodeSearch* _tmp22_;
	GeeList* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	LspInlayHint** hints = NULL;
	LspInlayHint** _tmp31_;
	gint hints_length1;
	gint _hints_size_;
	GError* _inner_error0_ = NULL;
#line 2125 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 2125 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 2125 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 2125 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 2125 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 2126 "../src/server.vala"
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_INLAY_HINT_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 2126 "../src/server.vala"
	p = (LspInlayHintParams*) _tmp0_;
#line 2129 "../src/server.vala"
	_tmp1_ = p;
#line 2129 "../src/server.vala"
	_tmp2_ = lsp_inlay_hint_params_get_textDocument (_tmp1_);
#line 2129 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 2129 "../src/server.vala"
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
#line 2129 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 2129 "../src/server.vala"
	_tmp7_ = vls_server_find_file (self, _tmp5_, &_tmp6_, NULL);
#line 2129 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2129 "../src/server.vala"
	compilation = _tmp6_;
#line 2129 "../src/server.vala"
	file = _tmp7_;
#line 2130 "../src/server.vala"
	_tmp8_ = file;
#line 2130 "../src/server.vala"
	if (_tmp8_ == NULL) {
#line 21982 "server.c"
		LspInlayHintParams* _tmp9_;
		LspTextDocumentIdentifier* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 2131 "../src/server.vala"
		_tmp9_ = p;
#line 2131 "../src/server.vala"
		_tmp10_ = lsp_inlay_hint_params_get_textDocument (_tmp9_);
#line 2131 "../src/server.vala"
		_tmp11_ = _tmp10_;
#line 2131 "../src/server.vala"
		_tmp12_ = lsp_text_document_identifier_get_uri (_tmp11_);
#line 2131 "../src/server.vala"
		_tmp13_ = _tmp12_;
#line 2131 "../src/server.vala"
		g_debug ("server.vala:2131: [%s] file `%s' not found", method, _tmp13_);
#line 2132 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2133 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 2133 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2133 "../src/server.vala"
		_g_object_unref0 (p);
#line 2133 "../src/server.vala"
		return;
#line 22010 "server.c"
	}
#line 2136 "../src/server.vala"
	_tmp14_ = compilation;
#line 2136 "../src/server.vala"
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
#line 2136 "../src/server.vala"
	_tmp16_ = _tmp15_;
#line 2136 "../src/server.vala"
	vala_code_context_push (_tmp16_);
#line 2137 "../src/server.vala"
	_tmp17_ = file;
#line 2137 "../src/server.vala"
	_tmp18_ = p;
#line 2137 "../src/server.vala"
	_tmp19_ = lsp_inlay_hint_params_get_range (_tmp18_);
#line 2137 "../src/server.vala"
	_tmp20_ = _tmp19_;
#line 2137 "../src/server.vala"
	_tmp21_ = vls_node_search_new_within (_tmp17_, _tmp20_, FALSE);
#line 2137 "../src/server.vala"
	query = _tmp21_;
#line 2138 "../src/server.vala"
	_tmp22_ = query;
#line 2138 "../src/server.vala"
	_tmp23_ = _tmp22_->result;
#line 2138 "../src/server.vala"
	_tmp24_ = gee_collection_get_is_empty ((GeeCollection*) _tmp23_);
#line 2138 "../src/server.vala"
	_tmp25_ = _tmp24_;
#line 2138 "../src/server.vala"
	if (_tmp25_) {
#line 22042 "server.c"
		LspInlayHintParams* _tmp26_;
		LspRange* _tmp27_;
		LspRange* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
#line 2139 "../src/server.vala"
		_tmp26_ = p;
#line 2139 "../src/server.vala"
		_tmp27_ = lsp_inlay_hint_params_get_range (_tmp26_);
#line 2139 "../src/server.vala"
		_tmp28_ = _tmp27_;
#line 2139 "../src/server.vala"
		_tmp29_ = lsp_range_to_string (_tmp28_);
#line 2139 "../src/server.vala"
		_tmp30_ = _tmp29_;
#line 2139 "../src/server.vala"
		g_debug ("server.vala:2139: [%s] nothing found at %s", method, _tmp30_);
#line 2139 "../src/server.vala"
		_g_free0 (_tmp30_);
#line 2140 "../src/server.vala"
		vala_code_context_pop ();
#line 2141 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2142 "../src/server.vala"
		_vala_code_visitor_unref0 (query);
#line 2142 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 2142 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2142 "../src/server.vala"
		_g_object_unref0 (p);
#line 2142 "../src/server.vala"
		return;
#line 22076 "server.c"
	}
#line 2145 "../src/server.vala"
	_tmp31_ = g_new0 (LspInlayHint*, 0 + 1);
#line 2145 "../src/server.vala"
	hints = _tmp31_;
#line 2145 "../src/server.vala"
	hints_length1 = 0;
#line 2145 "../src/server.vala"
	_hints_size_ = hints_length1;
#line 22086 "server.c"
	{
		GeeList* _item_list = NULL;
		VlsNodeSearch* _tmp32_;
		GeeList* _tmp33_;
		gint _item_size = 0;
		GeeList* _tmp34_;
		gint _tmp35_;
		gint _tmp36_;
		gint _item_index = 0;
#line 2147 "../src/server.vala"
		_tmp32_ = query;
#line 2147 "../src/server.vala"
		_tmp33_ = _tmp32_->result;
#line 2147 "../src/server.vala"
		_item_list = _tmp33_;
#line 2147 "../src/server.vala"
		_tmp34_ = _item_list;
#line 2147 "../src/server.vala"
		_tmp35_ = gee_collection_get_size ((GeeCollection*) _tmp34_);
#line 2147 "../src/server.vala"
		_tmp36_ = _tmp35_;
#line 2147 "../src/server.vala"
		_item_size = _tmp36_;
#line 2147 "../src/server.vala"
		_item_index = -1;
#line 2147 "../src/server.vala"
		while (TRUE) {
#line 22114 "server.c"
			gint _tmp37_;
			gint _tmp38_;
			ValaCodeNode* item = NULL;
			GeeList* _tmp39_;
			gpointer _tmp40_;
			ValaLocalVariable* local = NULL;
			gchar* representation = NULL;
			ValaCodeNode* _tmp41_;
			gchar* _tmp42_;
			GMatchInfo* foreach_match = NULL;
			ValaCodeNode* _tmp43_;
			gboolean _tmp48_ = FALSE;
			gboolean _tmp49_ = FALSE;
			gboolean _tmp50_ = FALSE;
			ValaLocalVariable* _tmp51_;
#line 2147 "../src/server.vala"
			_item_index = _item_index + 1;
#line 2147 "../src/server.vala"
			_tmp37_ = _item_index;
#line 2147 "../src/server.vala"
			_tmp38_ = _item_size;
#line 2147 "../src/server.vala"
			if (!(_tmp37_ < _tmp38_)) {
#line 2147 "../src/server.vala"
				break;
#line 22140 "server.c"
			}
#line 2147 "../src/server.vala"
			_tmp39_ = _item_list;
#line 2147 "../src/server.vala"
			_tmp40_ = gee_list_get (_tmp39_, _item_index);
#line 2147 "../src/server.vala"
			item = (ValaCodeNode*) _tmp40_;
#line 2148 "../src/server.vala"
			local = NULL;
#line 2149 "../src/server.vala"
			_tmp41_ = item;
#line 2149 "../src/server.vala"
			_tmp42_ = vls_code_help_get_code_node_source (_tmp41_);
#line 2149 "../src/server.vala"
			representation = _tmp42_;
#line 2151 "../src/server.vala"
			_tmp43_ = item;
#line 2151 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp43_, VALA_TYPE_DECLARATION_STATEMENT)) {
#line 22160 "server.c"
				ValaCodeNode* _tmp44_;
				ValaSymbol* _tmp45_;
				ValaSymbol* _tmp46_;
				ValaLocalVariable* _tmp47_;
#line 2152 "../src/server.vala"
				_tmp44_ = item;
#line 2152 "../src/server.vala"
				_tmp45_ = vala_declaration_statement_get_declaration (G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, VALA_TYPE_DECLARATION_STATEMENT, ValaDeclarationStatement));
#line 2152 "../src/server.vala"
				_tmp46_ = _tmp45_;
#line 2152 "../src/server.vala"
				_tmp47_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp46_, VALA_TYPE_LOCAL_VARIABLE) ? ((ValaLocalVariable*) _tmp46_) : NULL);
#line 2152 "../src/server.vala"
				_vala_code_node_unref0 (local);
#line 2152 "../src/server.vala"
				local = _tmp47_;
#line 22177 "server.c"
			}
#line 2153 "../src/server.vala"
			_tmp51_ = local;
#line 2153 "../src/server.vala"
			if (_tmp51_ != NULL) {
#line 22183 "server.c"
				ValaLocalVariable* _tmp52_;
				ValaSourceReference* _tmp53_;
				ValaSourceReference* _tmp54_;
#line 2153 "../src/server.vala"
				_tmp52_ = local;
#line 2153 "../src/server.vala"
				_tmp53_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp52_);
#line 2153 "../src/server.vala"
				_tmp54_ = _tmp53_;
#line 2153 "../src/server.vala"
				_tmp50_ = _tmp54_ != NULL;
#line 22195 "server.c"
			} else {
#line 2153 "../src/server.vala"
				_tmp50_ = FALSE;
#line 22199 "server.c"
			}
#line 2153 "../src/server.vala"
			if (_tmp50_) {
#line 22203 "server.c"
				ValaLocalVariable* _tmp55_;
				ValaExpression* _tmp56_;
				ValaExpression* _tmp57_;
#line 2153 "../src/server.vala"
				_tmp55_ = local;
#line 2153 "../src/server.vala"
				_tmp56_ = vala_variable_get_initializer ((ValaVariable*) _tmp55_);
#line 2153 "../src/server.vala"
				_tmp57_ = _tmp56_;
#line 2153 "../src/server.vala"
				_tmp49_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_OBJECT_CREATION_EXPRESSION);
#line 22215 "server.c"
			} else {
#line 2153 "../src/server.vala"
				_tmp49_ = FALSE;
#line 22219 "server.c"
			}
#line 2153 "../src/server.vala"
			if (_tmp49_) {
#line 22223 "server.c"
				VlsCompilation* _tmp58_;
				GeeHashSet* _tmp59_;
				GeeHashSet* _tmp60_;
				ValaLocalVariable* _tmp61_;
#line 2154 "../src/server.vala"
				_tmp58_ = compilation;
#line 2154 "../src/server.vala"
				_tmp59_ = vls_compilation_get_var_decls (_tmp58_);
#line 2154 "../src/server.vala"
				_tmp60_ = _tmp59_;
#line 2154 "../src/server.vala"
				_tmp61_ = local;
#line 2154 "../src/server.vala"
				_tmp48_ = gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp60_, _tmp61_);
#line 22238 "server.c"
			} else {
#line 2153 "../src/server.vala"
				_tmp48_ = FALSE;
#line 22242 "server.c"
			}
#line 2153 "../src/server.vala"
			if (_tmp48_) {
#line 22246 "server.c"
				ValaLocalVariable* _tmp62_;
				ValaSourceReference* _tmp63_;
				ValaSourceReference* _tmp64_;
				ValaSourceLocation _tmp65_ = {0};
				ValaSourceLocation _tmp66_;
				LspPosition* _tmp67_;
				ValaLocalVariable* _tmp68_;
				ValaDataType* _tmp69_;
				ValaDataType* _tmp70_;
				gchar* _tmp71_;
				gchar* _tmp72_;
				gchar* _tmp73_;
				LspInlayHint* _tmp74_ = NULL;
#line 2156 "../src/server.vala"
				_tmp62_ = local;
#line 2156 "../src/server.vala"
				_tmp63_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp62_);
#line 2156 "../src/server.vala"
				_tmp64_ = _tmp63_;
#line 2156 "../src/server.vala"
				vala_source_reference_get_end (_tmp64_, &_tmp65_);
#line 2156 "../src/server.vala"
				_tmp66_ = _tmp65_;
#line 2156 "../src/server.vala"
				_tmp67_ = lsp_position_new_from_libvala (&_tmp66_);
#line 2156 "../src/server.vala"
				if (_tmp67_) {
#line 2156 "../src/server.vala"
					g_object_set_data ((GObject *) _tmp67_, "vala-creation-function", "Vls.Server.show_inlay_hints");
#line 22276 "server.c"
				}
#line 2156 "../src/server.vala"
				_tmp68_ = local;
#line 2156 "../src/server.vala"
				_tmp69_ = vala_variable_get_variable_type ((ValaVariable*) _tmp68_);
#line 2156 "../src/server.vala"
				_tmp70_ = _tmp69_;
#line 2156 "../src/server.vala"
				_tmp71_ = vls_code_help_get_data_type_representation (_tmp70_, NULL, FALSE);
#line 2156 "../src/server.vala"
				_tmp72_ = _tmp71_;
#line 2156 "../src/server.vala"
				_tmp73_ = g_strdup_printf (":%s", _tmp72_);
#line 2156 "../src/server.vala"
				_tmp74_ = lsp_inlay_hint_new ();
#line 2156 "../src/server.vala"
				lsp_inlay_hint_set_position (_tmp74_, _tmp67_);
#line 2156 "../src/server.vala"
				_g_object_unref0 (_tmp67_);
#line 2156 "../src/server.vala"
				lsp_inlay_hint_set_label (_tmp74_, _tmp73_);
#line 2156 "../src/server.vala"
				_g_free0 (_tmp73_);
#line 2156 "../src/server.vala"
				lsp_inlay_hint_set_kind (_tmp74_, LSP_INLAY_HINT_KIND_TYPE);
#line 2156 "../src/server.vala"
				lsp_inlay_hint_set_paddingLeft (_tmp74_, TRUE);
#line 2156 "../src/server.vala"
				_vala_array_add32 (&hints, &hints_length1, &_hints_size_, _tmp74_);
#line 2156 "../src/server.vala"
				_g_free0 (_tmp72_);
#line 22308 "server.c"
			} else {
				const gchar* _tmp75_;
				GMatchInfo* _tmp76_ = NULL;
				gboolean _tmp77_;
#line 2162 "../src/server.vala"
				_tmp75_ = representation;
#line 2162 "../src/server.vala"
				_tmp77_ = g_regex_match (_thread_safe_regex_init (&_tmp_regex_2, "foreach\\s*\\(\\s*var\\s+(\\w+)", 0 | G_REGEX_MULTILINE), _tmp75_, 0, &_tmp76_);
#line 2162 "../src/server.vala"
				_g_match_info_unref0 (foreach_match);
#line 2162 "../src/server.vala"
				foreach_match = _tmp76_;
#line 2162 "../src/server.vala"
				if (_tmp77_) {
#line 22323 "server.c"
					gint start = 0;
					gint end = 0;
					GMatchInfo* _tmp78_;
					gint _tmp79_ = 0;
					gint _tmp80_ = 0;
					gboolean _tmp81_;
#line 2165 "../src/server.vala"
					_tmp78_ = foreach_match;
#line 2165 "../src/server.vala"
					_tmp81_ = g_match_info_fetch_pos (_tmp78_, 1, &_tmp79_, &_tmp80_);
#line 2165 "../src/server.vala"
					start = _tmp79_;
#line 2165 "../src/server.vala"
					end = _tmp80_;
#line 2165 "../src/server.vala"
					if (_tmp81_) {
#line 22340 "server.c"
						ValaDataType* element_type = NULL;
						gboolean _tmp82_ = FALSE;
						gboolean _tmp83_ = FALSE;
						ValaCodeNode* _tmp84_;
						LspRange* range = NULL;
						ValaCodeNode* _tmp117_;
						ValaSourceReference* _tmp118_;
						ValaSourceReference* _tmp119_;
						const gchar* _tmp120_;
						LspRange* _tmp121_;
						LspRange* _tmp122_;
						LspPosition* _tmp123_;
						LspPosition* _tmp124_;
						LspPosition* _tmp125_;
						ValaDataType* _tmp126_;
						gchar* _tmp127_;
						gchar* _tmp128_;
						gchar* _tmp129_;
						LspInlayHint* _tmp130_ = NULL;
#line 2167 "../src/server.vala"
						element_type = NULL;
#line 2168 "../src/server.vala"
						_tmp84_ = item;
#line 2168 "../src/server.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp84_, VALA_TYPE_FOREACH_STATEMENT)) {
#line 22366 "server.c"
							ValaCodeNode* _tmp85_;
							ValaDataType* _tmp86_;
							ValaDataType* _tmp87_;
#line 2168 "../src/server.vala"
							_tmp85_ = item;
#line 2168 "../src/server.vala"
							_tmp86_ = vala_foreach_statement_get_type_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp85_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
#line 2168 "../src/server.vala"
							_tmp87_ = _tmp86_;
#line 2168 "../src/server.vala"
							_tmp83_ = !G_TYPE_CHECK_INSTANCE_TYPE (_tmp87_, VALA_TYPE_VAR_TYPE);
#line 22378 "server.c"
						} else {
#line 2168 "../src/server.vala"
							_tmp83_ = FALSE;
#line 22382 "server.c"
						}
#line 2168 "../src/server.vala"
						if (_tmp83_) {
#line 22386 "server.c"
							ValaCodeNode* _tmp88_;
							ValaLocalVariable* _tmp89_;
							ValaLocalVariable* _tmp90_;
#line 2169 "../src/server.vala"
							_tmp88_ = item;
#line 2169 "../src/server.vala"
							_tmp89_ = vala_foreach_statement_get_element_variable (G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
#line 2169 "../src/server.vala"
							_tmp90_ = _tmp89_;
#line 2169 "../src/server.vala"
							_tmp82_ = _tmp90_ != NULL;
#line 22398 "server.c"
						} else {
#line 2168 "../src/server.vala"
							_tmp82_ = FALSE;
#line 22402 "server.c"
						}
#line 2168 "../src/server.vala"
						if (_tmp82_) {
#line 22406 "server.c"
							ValaCodeNode* _tmp91_;
							ValaDataType* _tmp92_;
							ValaDataType* _tmp93_;
							ValaDataType* _tmp94_;
#line 2172 "../src/server.vala"
							_tmp91_ = item;
#line 2172 "../src/server.vala"
							_tmp92_ = vala_foreach_statement_get_type_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp91_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
#line 2172 "../src/server.vala"
							_tmp93_ = _tmp92_;
#line 2172 "../src/server.vala"
							_tmp94_ = _vala_code_node_ref0 (_tmp93_);
#line 2172 "../src/server.vala"
							_vala_code_node_unref0 (element_type);
#line 2172 "../src/server.vala"
							element_type = _tmp94_;
#line 22423 "server.c"
						} else {
							ValaLocalVariable* _tmp95_;
#line 2173 "../src/server.vala"
							_tmp95_ = local;
#line 2173 "../src/server.vala"
							if (_tmp95_ != NULL) {
#line 22430 "server.c"
								ValaLocalVariable* _tmp96_;
								ValaDataType* _tmp97_;
								ValaDataType* _tmp98_;
								ValaDataType* _tmp99_;
								gboolean is_element_var = FALSE;
#line 2175 "../src/server.vala"
								_tmp96_ = local;
#line 2175 "../src/server.vala"
								_tmp97_ = vala_variable_get_variable_type ((ValaVariable*) _tmp96_);
#line 2175 "../src/server.vala"
								_tmp98_ = _tmp97_;
#line 2175 "../src/server.vala"
								_tmp99_ = _vala_code_node_ref0 (_tmp98_);
#line 2175 "../src/server.vala"
								_vala_code_node_unref0 (element_type);
#line 2175 "../src/server.vala"
								element_type = _tmp99_;
#line 2177 "../src/server.vala"
								is_element_var = FALSE;
#line 22450 "server.c"
								{
									ValaCodeNode* current_node = NULL;
									ValaLocalVariable* _tmp100_;
									ValaCodeNode* _tmp101_;
#line 2178 "../src/server.vala"
									_tmp100_ = local;
#line 2178 "../src/server.vala"
									_tmp101_ = _vala_code_node_ref0 ((ValaCodeNode*) _tmp100_);
#line 2178 "../src/server.vala"
									current_node = _tmp101_;
#line 22461 "server.c"
									{
										gboolean _tmp102_ = FALSE;
#line 2178 "../src/server.vala"
										_tmp102_ = TRUE;
#line 2178 "../src/server.vala"
										while (TRUE) {
#line 22468 "server.c"
											ValaCodeNode* _tmp107_;
											ValaCodeNode* _tmp108_;
#line 2178 "../src/server.vala"
											if (!_tmp102_) {
#line 22473 "server.c"
												ValaCodeNode* _tmp103_;
												ValaCodeNode* _tmp104_;
												ValaCodeNode* _tmp105_;
												ValaCodeNode* _tmp106_;
#line 2178 "../src/server.vala"
												_tmp103_ = current_node;
#line 2178 "../src/server.vala"
												_tmp104_ = vala_code_node_get_parent_node (_tmp103_);
#line 2178 "../src/server.vala"
												_tmp105_ = _tmp104_;
#line 2178 "../src/server.vala"
												_tmp106_ = _vala_code_node_ref0 (_tmp105_);
#line 2178 "../src/server.vala"
												_vala_code_node_unref0 (current_node);
#line 2178 "../src/server.vala"
												current_node = _tmp106_;
#line 22490 "server.c"
											}
#line 2178 "../src/server.vala"
											_tmp102_ = FALSE;
#line 2178 "../src/server.vala"
											_tmp107_ = current_node;
#line 2178 "../src/server.vala"
											if (!(_tmp107_ != NULL)) {
#line 2178 "../src/server.vala"
												break;
#line 22500 "server.c"
											}
#line 2179 "../src/server.vala"
											_tmp108_ = current_node;
#line 2179 "../src/server.vala"
											if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp108_, VALA_TYPE_FOREACH_STATEMENT)) {
#line 22506 "server.c"
												ValaForeachStatement* stmt = NULL;
												ValaCodeNode* _tmp109_;
												ValaForeachStatement* _tmp110_;
												ValaForeachStatement* _tmp111_;
												const gchar* _tmp112_;
												const gchar* _tmp113_;
												ValaLocalVariable* _tmp114_;
												const gchar* _tmp115_;
												const gchar* _tmp116_;
#line 2180 "../src/server.vala"
												_tmp109_ = current_node;
#line 2180 "../src/server.vala"
												_tmp110_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp109_, VALA_TYPE_FOREACH_STATEMENT, ValaForeachStatement));
#line 2180 "../src/server.vala"
												stmt = _tmp110_;
#line 2181 "../src/server.vala"
												_tmp111_ = stmt;
#line 2181 "../src/server.vala"
												_tmp112_ = vala_foreach_statement_get_variable_name (_tmp111_);
#line 2181 "../src/server.vala"
												_tmp113_ = _tmp112_;
#line 2181 "../src/server.vala"
												_tmp114_ = local;
#line 2181 "../src/server.vala"
												_tmp115_ = vala_symbol_get_name ((ValaSymbol*) _tmp114_);
#line 2181 "../src/server.vala"
												_tmp116_ = _tmp115_;
#line 2181 "../src/server.vala"
												is_element_var = g_strcmp0 (_tmp113_, _tmp116_) == 0;
#line 2182 "../src/server.vala"
												_vala_code_node_unref0 (stmt);
#line 2182 "../src/server.vala"
												break;
#line 22540 "server.c"
											}
										}
									}
#line 2178 "../src/server.vala"
									_vala_code_node_unref0 (current_node);
#line 22546 "server.c"
								}
#line 2185 "../src/server.vala"
								if (!is_element_var) {
#line 2186 "../src/server.vala"
									_vala_code_node_unref0 (element_type);
#line 2186 "../src/server.vala"
									_g_match_info_unref0 (foreach_match);
#line 2186 "../src/server.vala"
									_g_free0 (representation);
#line 2186 "../src/server.vala"
									_vala_code_node_unref0 (local);
#line 2186 "../src/server.vala"
									_vala_code_node_unref0 (item);
#line 2186 "../src/server.vala"
									continue;
#line 22562 "server.c"
								}
							} else {
#line 2189 "../src/server.vala"
								_vala_code_node_unref0 (element_type);
#line 2189 "../src/server.vala"
								_g_match_info_unref0 (foreach_match);
#line 2189 "../src/server.vala"
								_g_free0 (representation);
#line 2189 "../src/server.vala"
								_vala_code_node_unref0 (local);
#line 2189 "../src/server.vala"
								_vala_code_node_unref0 (item);
#line 2189 "../src/server.vala"
								continue;
#line 22577 "server.c"
							}
						}
#line 2192 "../src/server.vala"
						_tmp117_ = item;
#line 2192 "../src/server.vala"
						_tmp118_ = vala_code_node_get_source_reference (_tmp117_);
#line 2192 "../src/server.vala"
						_tmp119_ = _tmp118_;
#line 2192 "../src/server.vala"
						_tmp120_ = representation;
#line 2192 "../src/server.vala"
						_tmp121_ = vls_symbol_references_get_narrowed_source_reference (_tmp119_, _tmp120_, start, end);
#line 2192 "../src/server.vala"
						range = _tmp121_;
#line 2193 "../src/server.vala"
						_tmp122_ = range;
#line 2193 "../src/server.vala"
						_tmp123_ = lsp_range_get_end (_tmp122_);
#line 2193 "../src/server.vala"
						_tmp124_ = _tmp123_;
#line 2193 "../src/server.vala"
						_tmp125_ = _g_object_ref0 (_tmp124_);
#line 2193 "../src/server.vala"
						_tmp126_ = element_type;
#line 2193 "../src/server.vala"
						_tmp127_ = vls_code_help_get_data_type_representation (_tmp126_, NULL, FALSE);
#line 2193 "../src/server.vala"
						_tmp128_ = _tmp127_;
#line 2193 "../src/server.vala"
						_tmp129_ = g_strdup_printf (":%s", _tmp128_);
#line 2193 "../src/server.vala"
						_tmp130_ = lsp_inlay_hint_new ();
#line 2193 "../src/server.vala"
						lsp_inlay_hint_set_position (_tmp130_, _tmp125_);
#line 2193 "../src/server.vala"
						_g_object_unref0 (_tmp125_);
#line 2193 "../src/server.vala"
						lsp_inlay_hint_set_label (_tmp130_, _tmp129_);
#line 2193 "../src/server.vala"
						_g_free0 (_tmp129_);
#line 2193 "../src/server.vala"
						lsp_inlay_hint_set_kind (_tmp130_, LSP_INLAY_HINT_KIND_TYPE);
#line 2193 "../src/server.vala"
						lsp_inlay_hint_set_paddingLeft (_tmp130_, TRUE);
#line 2193 "../src/server.vala"
						_vala_array_add33 (&hints, &hints_length1, &_hints_size_, _tmp130_);
#line 2193 "../src/server.vala"
						_g_free0 (_tmp128_);
#line 2165 "../src/server.vala"
						_g_object_unref0 (range);
#line 2165 "../src/server.vala"
						_vala_code_node_unref0 (element_type);
#line 22630 "server.c"
					}
				} else {
					ValaCodeNode* _tmp131_;
#line 2200 "../src/server.vala"
					_tmp131_ = item;
#line 2200 "../src/server.vala"
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp131_, VALA_TYPE_LAMBDA_EXPRESSION)) {
#line 22638 "server.c"
						ValaLambdaExpression* lambda = NULL;
						ValaCodeNode* _tmp132_;
						ValaLambdaExpression* _tmp133_;
#line 2201 "../src/server.vala"
						_tmp132_ = item;
#line 2201 "../src/server.vala"
						_tmp133_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp132_, VALA_TYPE_LAMBDA_EXPRESSION, ValaLambdaExpression));
#line 2201 "../src/server.vala"
						lambda = _tmp133_;
#line 22648 "server.c"
						{
							ValaList* _param_list = NULL;
							ValaLambdaExpression* _tmp134_;
							ValaList* _tmp135_;
							gint _param_size = 0;
							ValaList* _tmp136_;
							gint _tmp137_;
							gint _tmp138_;
							gint _param_index = 0;
#line 2202 "../src/server.vala"
							_tmp134_ = lambda;
#line 2202 "../src/server.vala"
							_tmp135_ = vala_lambda_expression_get_parameters (_tmp134_);
#line 2202 "../src/server.vala"
							_param_list = _tmp135_;
#line 2202 "../src/server.vala"
							_tmp136_ = _param_list;
#line 2202 "../src/server.vala"
							_tmp137_ = vala_collection_get_size ((ValaCollection*) _tmp136_);
#line 2202 "../src/server.vala"
							_tmp138_ = _tmp137_;
#line 2202 "../src/server.vala"
							_param_size = _tmp138_;
#line 2202 "../src/server.vala"
							_param_index = -1;
#line 2202 "../src/server.vala"
							while (TRUE) {
#line 22676 "server.c"
								gint _tmp139_;
								gint _tmp140_;
								ValaParameter* param = NULL;
								ValaList* _tmp141_;
								gpointer _tmp142_;
								LspRange* range = NULL;
								ValaParameter* _tmp143_;
								ValaSourceReference* _tmp144_;
								ValaSourceReference* _tmp145_;
								LspRange* _tmp146_;
								LspRange* _tmp147_;
								LspPosition* _tmp148_;
								LspPosition* _tmp149_;
								LspPosition* _tmp150_;
								ValaParameter* _tmp151_;
								ValaDataType* _tmp152_;
								ValaDataType* _tmp153_;
								gchar* _tmp154_;
								LspInlayHint* _tmp155_ = NULL;
#line 2202 "../src/server.vala"
								_param_index = _param_index + 1;
#line 2202 "../src/server.vala"
								_tmp139_ = _param_index;
#line 2202 "../src/server.vala"
								_tmp140_ = _param_size;
#line 2202 "../src/server.vala"
								if (!(_tmp139_ < _tmp140_)) {
#line 2202 "../src/server.vala"
									break;
#line 22706 "server.c"
								}
#line 2202 "../src/server.vala"
								_tmp141_ = _param_list;
#line 2202 "../src/server.vala"
								_tmp142_ = vala_list_get (_tmp141_, _param_index);
#line 2202 "../src/server.vala"
								param = (ValaParameter*) _tmp142_;
#line 2203 "../src/server.vala"
								_tmp143_ = param;
#line 2203 "../src/server.vala"
								_tmp144_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp143_);
#line 2203 "../src/server.vala"
								_tmp145_ = _tmp144_;
#line 2203 "../src/server.vala"
								_tmp146_ = lsp_range_new_from_sourceref (_tmp145_);
#line 2203 "../src/server.vala"
								if (_tmp146_) {
#line 2203 "../src/server.vala"
									g_object_set_data ((GObject *) _tmp146_, "vala-creation-function", "Vls.Server.show_inlay_hints");
#line 22726 "server.c"
								}
#line 2203 "../src/server.vala"
								range = _tmp146_;
#line 2204 "../src/server.vala"
								_tmp147_ = range;
#line 2204 "../src/server.vala"
								_tmp148_ = lsp_range_get_start (_tmp147_);
#line 2204 "../src/server.vala"
								_tmp149_ = _tmp148_;
#line 2204 "../src/server.vala"
								_tmp150_ = _g_object_ref0 (_tmp149_);
#line 2204 "../src/server.vala"
								_tmp151_ = param;
#line 2204 "../src/server.vala"
								_tmp152_ = vala_variable_get_variable_type ((ValaVariable*) _tmp151_);
#line 2204 "../src/server.vala"
								_tmp153_ = _tmp152_;
#line 2204 "../src/server.vala"
								_tmp154_ = vls_code_help_get_data_type_representation (_tmp153_, NULL, FALSE);
#line 2204 "../src/server.vala"
								_tmp155_ = lsp_inlay_hint_new ();
#line 2204 "../src/server.vala"
								lsp_inlay_hint_set_position (_tmp155_, _tmp150_);
#line 2204 "../src/server.vala"
								_g_object_unref0 (_tmp150_);
#line 2204 "../src/server.vala"
								lsp_inlay_hint_set_label (_tmp155_, _tmp154_);
#line 2204 "../src/server.vala"
								_g_free0 (_tmp154_);
#line 2204 "../src/server.vala"
								lsp_inlay_hint_set_kind (_tmp155_, LSP_INLAY_HINT_KIND_PARAMETER);
#line 2204 "../src/server.vala"
								lsp_inlay_hint_set_paddingRight (_tmp155_, TRUE);
#line 2204 "../src/server.vala"
								_vala_array_add34 (&hints, &hints_length1, &_hints_size_, _tmp155_);
#line 2202 "../src/server.vala"
								_g_object_unref0 (range);
#line 2202 "../src/server.vala"
								_vala_code_node_unref0 (param);
#line 22766 "server.c"
							}
						}
#line 2200 "../src/server.vala"
						_vala_code_node_unref0 (lambda);
#line 22771 "server.c"
					} else {
						gboolean _tmp156_ = FALSE;
						gboolean _tmp157_ = FALSE;
						ValaCodeNode* _tmp158_;
#line 2211 "../src/server.vala"
						_tmp158_ = item;
#line 2211 "../src/server.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp158_, VALA_TYPE_METHOD_CALL)) {
#line 2211 "../src/server.vala"
							_tmp157_ = TRUE;
#line 22782 "server.c"
						} else {
							ValaCodeNode* _tmp159_;
#line 2211 "../src/server.vala"
							_tmp159_ = item;
#line 2211 "../src/server.vala"
							_tmp157_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp159_, VALA_TYPE_OBJECT_CREATION_EXPRESSION);
#line 22789 "server.c"
						}
#line 2211 "../src/server.vala"
						if (_tmp157_) {
#line 22793 "server.c"
							VlsCompilation* _tmp160_;
							GeeHashMap* _tmp161_;
							GeeHashMap* _tmp162_;
							ValaCodeNode* _tmp163_;
#line 2211 "../src/server.vala"
							_tmp160_ = compilation;
#line 2211 "../src/server.vala"
							_tmp161_ = vls_compilation_get_method_calls (_tmp160_);
#line 2211 "../src/server.vala"
							_tmp162_ = _tmp161_;
#line 2211 "../src/server.vala"
							_tmp163_ = item;
#line 2211 "../src/server.vala"
							_tmp156_ = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp162_, _tmp163_);
#line 22808 "server.c"
						} else {
#line 2211 "../src/server.vala"
							_tmp156_ = FALSE;
#line 22812 "server.c"
						}
#line 2211 "../src/server.vala"
						if (_tmp156_) {
#line 22816 "server.c"
							ValaList* parameters = NULL;
							ValaCodeNode* _tmp164_;
							ValaList* _tmp195_;
#line 2212 "../src/server.vala"
							parameters = NULL;
#line 2213 "../src/server.vala"
							_tmp164_ = item;
#line 2213 "../src/server.vala"
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp164_, VALA_TYPE_METHOD_CALL)) {
#line 22826 "server.c"
								ValaCodeNode* _tmp165_;
								ValaExpression* _tmp166_;
								ValaExpression* _tmp167_;
								ValaDataType* _tmp168_;
								ValaDataType* _tmp169_;
								ValaList* _tmp170_;
								ValaList* _tmp171_;
#line 2214 "../src/server.vala"
								_tmp165_ = item;
#line 2214 "../src/server.vala"
								_tmp166_ = vala_callable_expression_get_call ((ValaCallableExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp165_, VALA_TYPE_METHOD_CALL, ValaMethodCall));
#line 2214 "../src/server.vala"
								_tmp167_ = _tmp166_;
#line 2214 "../src/server.vala"
								_tmp168_ = vala_expression_get_value_type (_tmp167_);
#line 2214 "../src/server.vala"
								_tmp169_ = _tmp168_;
#line 2214 "../src/server.vala"
								_tmp170_ = vala_data_type_get_parameters (_tmp169_);
#line 2214 "../src/server.vala"
								_tmp171_ = _vala_iterable_ref0 (_tmp170_);
#line 2214 "../src/server.vala"
								_vala_iterable_unref0 (parameters);
#line 2214 "../src/server.vala"
								parameters = _tmp171_;
#line 22852 "server.c"
							} else {
								ValaObjectCreationExpression* oce = NULL;
								ValaCodeNode* _tmp172_;
								ValaObjectCreationExpression* _tmp173_;
								gboolean _tmp174_ = FALSE;
								ValaObjectCreationExpression* _tmp175_;
								ValaMemberAccess* _tmp176_;
								ValaMemberAccess* _tmp177_;
#line 2216 "../src/server.vala"
								_tmp172_ = item;
#line 2216 "../src/server.vala"
								_tmp173_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp172_, VALA_TYPE_OBJECT_CREATION_EXPRESSION, ValaObjectCreationExpression));
#line 2216 "../src/server.vala"
								oce = _tmp173_;
#line 2217 "../src/server.vala"
								_tmp175_ = oce;
#line 2217 "../src/server.vala"
								_tmp176_ = vala_object_creation_expression_get_member_name (_tmp175_);
#line 2217 "../src/server.vala"
								_tmp177_ = _tmp176_;
#line 2217 "../src/server.vala"
								if (_tmp177_ != NULL) {
#line 22875 "server.c"
									ValaObjectCreationExpression* _tmp178_;
									ValaMemberAccess* _tmp179_;
									ValaMemberAccess* _tmp180_;
									ValaSymbol* _tmp181_;
									ValaSymbol* _tmp182_;
#line 2217 "../src/server.vala"
									_tmp178_ = oce;
#line 2217 "../src/server.vala"
									_tmp179_ = vala_object_creation_expression_get_member_name (_tmp178_);
#line 2217 "../src/server.vala"
									_tmp180_ = _tmp179_;
#line 2217 "../src/server.vala"
									_tmp181_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp180_);
#line 2217 "../src/server.vala"
									_tmp182_ = _tmp181_;
#line 2217 "../src/server.vala"
									_tmp174_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp182_, VALA_TYPE_CALLABLE);
#line 22893 "server.c"
								} else {
#line 2217 "../src/server.vala"
									_tmp174_ = FALSE;
#line 22897 "server.c"
								}
#line 2217 "../src/server.vala"
								if (_tmp174_) {
#line 22901 "server.c"
									ValaObjectCreationExpression* _tmp183_;
									ValaMemberAccess* _tmp184_;
									ValaMemberAccess* _tmp185_;
									ValaSymbol* _tmp186_;
									ValaSymbol* _tmp187_;
									ValaList* _tmp188_;
									ValaList* _tmp189_;
#line 2218 "../src/server.vala"
									_tmp183_ = oce;
#line 2218 "../src/server.vala"
									_tmp184_ = vala_object_creation_expression_get_member_name (_tmp183_);
#line 2218 "../src/server.vala"
									_tmp185_ = _tmp184_;
#line 2218 "../src/server.vala"
									_tmp186_ = vala_expression_get_symbol_reference ((ValaExpression*) _tmp185_);
#line 2218 "../src/server.vala"
									_tmp187_ = _tmp186_;
#line 2218 "../src/server.vala"
									_tmp188_ = vala_callable_get_parameters (G_TYPE_CHECK_INSTANCE_CAST (_tmp187_, VALA_TYPE_CALLABLE, ValaCallable));
#line 2218 "../src/server.vala"
									_tmp189_ = _vala_iterable_ref0 (_tmp188_);
#line 2218 "../src/server.vala"
									_vala_iterable_unref0 (parameters);
#line 2218 "../src/server.vala"
									parameters = _tmp189_;
#line 22927 "server.c"
								} else {
									ValaObjectCreationExpression* _tmp190_;
									ValaDataType* _tmp191_;
									ValaDataType* _tmp192_;
									ValaList* _tmp193_;
									ValaList* _tmp194_;
#line 2220 "../src/server.vala"
									_tmp190_ = oce;
#line 2220 "../src/server.vala"
									_tmp191_ = vala_object_creation_expression_get_type_reference (_tmp190_);
#line 2220 "../src/server.vala"
									_tmp192_ = _tmp191_;
#line 2220 "../src/server.vala"
									_tmp193_ = vala_data_type_get_parameters (_tmp192_);
#line 2220 "../src/server.vala"
									_tmp194_ = _vala_iterable_ref0 (_tmp193_);
#line 2220 "../src/server.vala"
									_vala_iterable_unref0 (parameters);
#line 2220 "../src/server.vala"
									parameters = _tmp194_;
#line 22948 "server.c"
								}
#line 2213 "../src/server.vala"
								_vala_code_node_unref0 (oce);
#line 22952 "server.c"
							}
#line 2222 "../src/server.vala"
							_tmp195_ = parameters;
#line 2222 "../src/server.vala"
							if (_tmp195_ != NULL) {
#line 22958 "server.c"
								gint orig_param_count = 0;
								VlsCompilation* _tmp196_;
								GeeHashMap* _tmp197_;
								GeeHashMap* _tmp198_;
								ValaCodeNode* _tmp199_;
								gpointer _tmp200_;
								ValaIterator* iter = NULL;
								ValaList* _tmp201_;
								ValaIterator* _tmp202_;
								gint args_i = 0;
								ValaParameter* last_ellipsis = NULL;
								ValaList* argument_list = NULL;
								ValaCodeNode* _tmp203_;
#line 2223 "../src/server.vala"
								_tmp196_ = compilation;
#line 2223 "../src/server.vala"
								_tmp197_ = vls_compilation_get_method_calls (_tmp196_);
#line 2223 "../src/server.vala"
								_tmp198_ = _tmp197_;
#line 2223 "../src/server.vala"
								_tmp199_ = item;
#line 2223 "../src/server.vala"
								_tmp200_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp198_, _tmp199_);
#line 2223 "../src/server.vala"
								orig_param_count = (gint) ((gintptr) _tmp200_);
#line 2224 "../src/server.vala"
								_tmp201_ = parameters;
#line 2224 "../src/server.vala"
								_tmp202_ = vala_iterable_iterator ((ValaIterable*) _tmp201_);
#line 2224 "../src/server.vala"
								iter = _tmp202_;
#line 2225 "../src/server.vala"
								args_i = 0;
#line 2226 "../src/server.vala"
								last_ellipsis = NULL;
#line 2228 "../src/server.vala"
								_tmp203_ = item;
#line 2228 "../src/server.vala"
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp203_, VALA_TYPE_METHOD_CALL)) {
#line 22998 "server.c"
									ValaCodeNode* _tmp204_;
									ValaList* _tmp205_;
									ValaList* _tmp206_;
#line 2229 "../src/server.vala"
									_tmp204_ = item;
#line 2229 "../src/server.vala"
									_tmp205_ = vala_callable_expression_get_argument_list ((ValaCallableExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp204_, VALA_TYPE_METHOD_CALL, ValaMethodCall));
#line 2229 "../src/server.vala"
									_tmp206_ = _vala_iterable_ref0 (_tmp205_);
#line 2229 "../src/server.vala"
									_vala_iterable_unref0 (argument_list);
#line 2229 "../src/server.vala"
									argument_list = _tmp206_;
#line 23012 "server.c"
								} else {
									ValaCodeNode* _tmp207_;
									ValaList* _tmp208_;
									ValaList* _tmp209_;
#line 2231 "../src/server.vala"
									_tmp207_ = item;
#line 2231 "../src/server.vala"
									_tmp208_ = vala_callable_expression_get_argument_list ((ValaCallableExpression*) G_TYPE_CHECK_INSTANCE_CAST (_tmp207_, VALA_TYPE_OBJECT_CREATION_EXPRESSION, ValaObjectCreationExpression));
#line 2231 "../src/server.vala"
									_tmp209_ = _vala_iterable_ref0 (_tmp208_);
#line 2231 "../src/server.vala"
									_vala_iterable_unref0 (argument_list);
#line 2231 "../src/server.vala"
									argument_list = _tmp209_;
#line 23027 "server.c"
								}
								{
									ValaList* _arg_list = NULL;
									ValaList* _tmp210_;
									gint _arg_size = 0;
									ValaList* _tmp211_;
									gint _tmp212_;
									gint _tmp213_;
									gint _arg_index = 0;
#line 2232 "../src/server.vala"
									_tmp210_ = argument_list;
#line 2232 "../src/server.vala"
									_arg_list = _tmp210_;
#line 2232 "../src/server.vala"
									_tmp211_ = _arg_list;
#line 2232 "../src/server.vala"
									_tmp212_ = vala_collection_get_size ((ValaCollection*) _tmp211_);
#line 2232 "../src/server.vala"
									_tmp213_ = _tmp212_;
#line 2232 "../src/server.vala"
									_arg_size = _tmp213_;
#line 2232 "../src/server.vala"
									_arg_index = -1;
#line 2232 "../src/server.vala"
									while (TRUE) {
#line 23053 "server.c"
										gint _tmp214_;
										gint _tmp215_;
										ValaExpression* arg = NULL;
										ValaList* _tmp216_;
										gpointer _tmp217_;
										ValaExpression* _tmp218_;
										ValaSourceReference* _tmp219_;
										ValaSourceReference* _tmp220_;
										ValaExpression* _tmp222_;
										gboolean _tmp224_ = FALSE;
										ValaIterator* _tmp225_;
										ValaParameter* _tmp227_ = NULL;
										ValaParameter* _tmp228_;
										ValaParameter* _tmp229_;
										ValaParameter* formal_parameter = NULL;
										ValaParameter* _tmp232_;
										ValaParameter* _tmp233_;
										gboolean _tmp234_;
										gboolean _tmp235_;
										gchar* _tmp238_ = NULL;
										ValaParameter* _tmp239_;
										const gchar* _tmp240_;
										const gchar* _tmp241_;
										gchar* _tmp242_;
										gchar* parameter_name = NULL;
										gchar* _tmp246_;
										ValaExpression* argument = NULL;
										ValaExpression* _tmp247_;
										ValaExpression* _tmp248_;
										gboolean _tmp249_ = FALSE;
										ValaExpression* _tmp250_;
										ValaExpression* _tmp262_;
										gchar* _tmp263_;
										gchar* _tmp264_;
										gchar* _tmp265_;
										gchar* _tmp266_;
										const gchar* _tmp267_;
										gchar* _tmp268_;
										gchar* _tmp269_;
										gboolean _tmp270_;
										LspRange* range = NULL;
										ValaExpression* _tmp272_;
										ValaSourceReference* _tmp273_;
										ValaSourceReference* _tmp274_;
										LspRange* _tmp275_;
										LspRange* _tmp276_;
										LspPosition* _tmp277_;
										LspPosition* _tmp278_;
										LspPosition* _tmp279_;
										const gchar* _tmp280_;
										gchar* _tmp281_;
										LspInlayHint* _tmp282_ = NULL;
										gint _tmp283_;
#line 2232 "../src/server.vala"
										_arg_index = _arg_index + 1;
#line 2232 "../src/server.vala"
										_tmp214_ = _arg_index;
#line 2232 "../src/server.vala"
										_tmp215_ = _arg_size;
#line 2232 "../src/server.vala"
										if (!(_tmp214_ < _tmp215_)) {
#line 2232 "../src/server.vala"
											break;
#line 23117 "server.c"
										}
#line 2232 "../src/server.vala"
										_tmp216_ = _arg_list;
#line 2232 "../src/server.vala"
										_tmp217_ = vala_list_get (_tmp216_, _arg_index);
#line 2232 "../src/server.vala"
										arg = (ValaExpression*) _tmp217_;
#line 2233 "../src/server.vala"
										_tmp218_ = arg;
#line 2233 "../src/server.vala"
										_tmp219_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp218_);
#line 2233 "../src/server.vala"
										_tmp220_ = _tmp219_;
#line 2233 "../src/server.vala"
										if (_tmp220_ == NULL) {
#line 23133 "server.c"
											gint _tmp221_;
#line 2235 "../src/server.vala"
											_tmp221_ = args_i;
#line 2235 "../src/server.vala"
											args_i = _tmp221_ + 1;
#line 2236 "../src/server.vala"
											_vala_code_node_unref0 (arg);
#line 2236 "../src/server.vala"
											continue;
#line 23143 "server.c"
										}
#line 2238 "../src/server.vala"
										if (args_i >= orig_param_count) {
#line 2239 "../src/server.vala"
											_vala_code_node_unref0 (arg);
#line 2239 "../src/server.vala"
											break;
#line 23151 "server.c"
										}
#line 2240 "../src/server.vala"
										_tmp222_ = arg;
#line 2240 "../src/server.vala"
										if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp222_, VALA_TYPE_NAMED_ARGUMENT)) {
#line 23157 "server.c"
											gint _tmp223_;
#line 2241 "../src/server.vala"
											_tmp223_ = args_i;
#line 2241 "../src/server.vala"
											args_i = _tmp223_ + 1;
#line 2242 "../src/server.vala"
											_vala_code_node_unref0 (arg);
#line 2242 "../src/server.vala"
											continue;
#line 23167 "server.c"
										}
#line 2244 "../src/server.vala"
										_tmp225_ = iter;
#line 2244 "../src/server.vala"
										if (!vala_iterator_next (_tmp225_)) {
#line 23173 "server.c"
											ValaParameter* _tmp226_;
#line 2244 "../src/server.vala"
											_tmp226_ = last_ellipsis;
#line 2244 "../src/server.vala"
											_tmp224_ = _tmp226_ == NULL;
#line 23179 "server.c"
										} else {
#line 2244 "../src/server.vala"
											_tmp224_ = FALSE;
#line 23183 "server.c"
										}
#line 2244 "../src/server.vala"
										if (_tmp224_) {
#line 2245 "../src/server.vala"
											_vala_code_node_unref0 (arg);
#line 2245 "../src/server.vala"
											break;
#line 23191 "server.c"
										}
#line 2246 "../src/server.vala"
										_tmp228_ = last_ellipsis;
#line 2246 "../src/server.vala"
										_tmp229_ = _vala_code_node_ref0 (_tmp228_);
#line 2246 "../src/server.vala"
										_tmp227_ = _tmp229_;
#line 2246 "../src/server.vala"
										if (_tmp227_ == NULL) {
#line 23201 "server.c"
											ValaIterator* _tmp230_;
											gpointer _tmp231_;
#line 2246 "../src/server.vala"
											_tmp230_ = iter;
#line 2246 "../src/server.vala"
											_tmp231_ = vala_iterator_get (_tmp230_);
#line 2246 "../src/server.vala"
											_vala_code_node_unref0 (_tmp227_);
#line 2246 "../src/server.vala"
											_tmp227_ = (ValaParameter*) _tmp231_;
#line 23212 "server.c"
										}
#line 2246 "../src/server.vala"
										_tmp232_ = _tmp227_;
#line 2246 "../src/server.vala"
										_tmp227_ = NULL;
#line 2246 "../src/server.vala"
										formal_parameter = _tmp232_;
#line 2247 "../src/server.vala"
										_tmp233_ = formal_parameter;
#line 2247 "../src/server.vala"
										_tmp234_ = vala_parameter_get_ellipsis (_tmp233_);
#line 2247 "../src/server.vala"
										_tmp235_ = _tmp234_;
#line 2247 "../src/server.vala"
										if (_tmp235_) {
#line 23228 "server.c"
											ValaParameter* _tmp236_;
											ValaParameter* _tmp237_;
#line 2248 "../src/server.vala"
											_tmp236_ = formal_parameter;
#line 2248 "../src/server.vala"
											_tmp237_ = _vala_code_node_ref0 (_tmp236_);
#line 2248 "../src/server.vala"
											_vala_code_node_unref0 (last_ellipsis);
#line 2248 "../src/server.vala"
											last_ellipsis = _tmp237_;
#line 23239 "server.c"
										}
#line 2249 "../src/server.vala"
										_tmp239_ = formal_parameter;
#line 2249 "../src/server.vala"
										_tmp240_ = vala_symbol_get_name ((ValaSymbol*) _tmp239_);
#line 2249 "../src/server.vala"
										_tmp241_ = _tmp240_;
#line 2249 "../src/server.vala"
										_tmp242_ = g_strdup (_tmp241_);
#line 2249 "../src/server.vala"
										_tmp238_ = _tmp242_;
#line 2249 "../src/server.vala"
										if (_tmp238_ == NULL) {
#line 23253 "server.c"
											gchar* _tmp243_;
											gchar* _tmp244_;
											gchar* _tmp245_;
#line 2249 "../src/server.vala"
											_tmp243_ = g_strdup_printf ("%i", args_i);
#line 2249 "../src/server.vala"
											_tmp244_ = _tmp243_;
#line 2249 "../src/server.vala"
											_tmp245_ = g_strconcat ("arg", _tmp244_, NULL);
#line 2249 "../src/server.vala"
											_g_free0 (_tmp238_);
#line 2249 "../src/server.vala"
											_tmp238_ = _tmp245_;
#line 2249 "../src/server.vala"
											_g_free0 (_tmp244_);
#line 23269 "server.c"
										}
#line 2249 "../src/server.vala"
										_tmp246_ = _tmp238_;
#line 2249 "../src/server.vala"
										_tmp238_ = NULL;
#line 2249 "../src/server.vala"
										parameter_name = _tmp246_;
#line 2250 "../src/server.vala"
										_tmp247_ = arg;
#line 2250 "../src/server.vala"
										_tmp248_ = _vala_code_node_ref0 (_tmp247_);
#line 2250 "../src/server.vala"
										argument = _tmp248_;
#line 2251 "../src/server.vala"
										_tmp250_ = argument;
#line 2251 "../src/server.vala"
										if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp250_, VALA_TYPE_UNARY_EXPRESSION)) {
#line 23287 "server.c"
											gboolean _tmp251_ = FALSE;
											ValaExpression* _tmp252_;
											ValaUnaryOperator _tmp253_;
											ValaUnaryOperator _tmp254_;
#line 2252 "../src/server.vala"
											_tmp252_ = argument;
#line 2252 "../src/server.vala"
											_tmp253_ = vala_unary_expression_get_operator (G_TYPE_CHECK_INSTANCE_CAST (_tmp252_, VALA_TYPE_UNARY_EXPRESSION, ValaUnaryExpression));
#line 2252 "../src/server.vala"
											_tmp254_ = _tmp253_;
#line 2252 "../src/server.vala"
											if (_tmp254_ == VALA_UNARY_OPERATOR_REF) {
#line 2252 "../src/server.vala"
												_tmp251_ = TRUE;
#line 23302 "server.c"
											} else {
												ValaExpression* _tmp255_;
												ValaUnaryOperator _tmp256_;
												ValaUnaryOperator _tmp257_;
#line 2252 "../src/server.vala"
												_tmp255_ = argument;
#line 2252 "../src/server.vala"
												_tmp256_ = vala_unary_expression_get_operator (G_TYPE_CHECK_INSTANCE_CAST (_tmp255_, VALA_TYPE_UNARY_EXPRESSION, ValaUnaryExpression));
#line 2252 "../src/server.vala"
												_tmp257_ = _tmp256_;
#line 2252 "../src/server.vala"
												_tmp251_ = _tmp257_ == VALA_UNARY_OPERATOR_OUT;
#line 23315 "server.c"
											}
#line 2252 "../src/server.vala"
											_tmp249_ = _tmp251_;
#line 23319 "server.c"
										} else {
#line 2251 "../src/server.vala"
											_tmp249_ = FALSE;
#line 23323 "server.c"
										}
#line 2251 "../src/server.vala"
										if (_tmp249_) {
#line 23327 "server.c"
											ValaExpression* _tmp258_;
											ValaExpression* _tmp259_;
											ValaExpression* _tmp260_;
											ValaExpression* _tmp261_;
#line 2253 "../src/server.vala"
											_tmp258_ = argument;
#line 2253 "../src/server.vala"
											_tmp259_ = vala_unary_expression_get_inner (G_TYPE_CHECK_INSTANCE_CAST (_tmp258_, VALA_TYPE_UNARY_EXPRESSION, ValaUnaryExpression));
#line 2253 "../src/server.vala"
											_tmp260_ = _tmp259_;
#line 2253 "../src/server.vala"
											_tmp261_ = _vala_code_node_ref0 (_tmp260_);
#line 2253 "../src/server.vala"
											_vala_code_node_unref0 (argument);
#line 2253 "../src/server.vala"
											argument = _tmp261_;
#line 23344 "server.c"
										}
#line 2254 "../src/server.vala"
										_tmp262_ = argument;
#line 2254 "../src/server.vala"
										_tmp263_ = vls_code_help_get_code_node_source ((ValaCodeNode*) _tmp262_);
#line 2254 "../src/server.vala"
										_tmp264_ = _tmp263_;
#line 2254 "../src/server.vala"
										_tmp265_ = g_utf8_casefold (_tmp264_, (gssize) -1);
#line 2254 "../src/server.vala"
										_tmp266_ = _tmp265_;
#line 2254 "../src/server.vala"
										_tmp267_ = parameter_name;
#line 2254 "../src/server.vala"
										_tmp268_ = g_utf8_casefold (_tmp267_, (gssize) -1);
#line 2254 "../src/server.vala"
										_tmp269_ = _tmp268_;
#line 2254 "../src/server.vala"
										_tmp270_ = g_strcmp0 (_tmp266_, _tmp269_) == 0;
#line 2254 "../src/server.vala"
										_g_free0 (_tmp269_);
#line 2254 "../src/server.vala"
										_g_free0 (_tmp266_);
#line 2254 "../src/server.vala"
										_g_free0 (_tmp264_);
#line 2254 "../src/server.vala"
										if (_tmp270_) {
#line 23372 "server.c"
											gint _tmp271_;
#line 2256 "../src/server.vala"
											_tmp271_ = args_i;
#line 2256 "../src/server.vala"
											args_i = _tmp271_ + 1;
#line 2257 "../src/server.vala"
											_vala_code_node_unref0 (argument);
#line 2257 "../src/server.vala"
											_g_free0 (parameter_name);
#line 2257 "../src/server.vala"
											_g_free0 (_tmp238_);
#line 2257 "../src/server.vala"
											_vala_code_node_unref0 (formal_parameter);
#line 2257 "../src/server.vala"
											_vala_code_node_unref0 (_tmp227_);
#line 2257 "../src/server.vala"
											_vala_code_node_unref0 (arg);
#line 2257 "../src/server.vala"
											continue;
#line 23392 "server.c"
										}
#line 2259 "../src/server.vala"
										_tmp272_ = arg;
#line 2259 "../src/server.vala"
										_tmp273_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp272_);
#line 2259 "../src/server.vala"
										_tmp274_ = _tmp273_;
#line 2259 "../src/server.vala"
										_tmp275_ = lsp_range_new_from_sourceref (_tmp274_);
#line 2259 "../src/server.vala"
										if (_tmp275_) {
#line 2259 "../src/server.vala"
											g_object_set_data ((GObject *) _tmp275_, "vala-creation-function", "Vls.Server.show_inlay_hints");
#line 23406 "server.c"
										}
#line 2259 "../src/server.vala"
										range = _tmp275_;
#line 2260 "../src/server.vala"
										_tmp276_ = range;
#line 2260 "../src/server.vala"
										_tmp277_ = lsp_range_get_start (_tmp276_);
#line 2260 "../src/server.vala"
										_tmp278_ = _tmp277_;
#line 2260 "../src/server.vala"
										_tmp279_ = _g_object_ref0 (_tmp278_);
#line 2260 "../src/server.vala"
										_tmp280_ = parameter_name;
#line 2260 "../src/server.vala"
										_tmp281_ = g_strdup_printf ("%s:", _tmp280_);
#line 2260 "../src/server.vala"
										_tmp282_ = lsp_inlay_hint_new ();
#line 2260 "../src/server.vala"
										lsp_inlay_hint_set_position (_tmp282_, _tmp279_);
#line 2260 "../src/server.vala"
										_g_object_unref0 (_tmp279_);
#line 2260 "../src/server.vala"
										lsp_inlay_hint_set_label (_tmp282_, _tmp281_);
#line 2260 "../src/server.vala"
										_g_free0 (_tmp281_);
#line 2260 "../src/server.vala"
										lsp_inlay_hint_set_kind (_tmp282_, LSP_INLAY_HINT_KIND_PARAMETER);
#line 2260 "../src/server.vala"
										lsp_inlay_hint_set_paddingRight (_tmp282_, TRUE);
#line 2260 "../src/server.vala"
										_vala_array_add35 (&hints, &hints_length1, &_hints_size_, _tmp282_);
#line 2266 "../src/server.vala"
										_tmp283_ = args_i;
#line 2266 "../src/server.vala"
										args_i = _tmp283_ + 1;
#line 2232 "../src/server.vala"
										_g_object_unref0 (range);
#line 2232 "../src/server.vala"
										_vala_code_node_unref0 (argument);
#line 2232 "../src/server.vala"
										_g_free0 (parameter_name);
#line 2232 "../src/server.vala"
										_g_free0 (_tmp238_);
#line 2232 "../src/server.vala"
										_vala_code_node_unref0 (formal_parameter);
#line 2232 "../src/server.vala"
										_vala_code_node_unref0 (_tmp227_);
#line 2232 "../src/server.vala"
										_vala_code_node_unref0 (arg);
#line 23456 "server.c"
									}
								}
#line 2222 "../src/server.vala"
								_vala_iterable_unref0 (argument_list);
#line 2222 "../src/server.vala"
								_vala_code_node_unref0 (last_ellipsis);
#line 2222 "../src/server.vala"
								_vala_iterator_unref0 (iter);
#line 23465 "server.c"
							}
#line 2211 "../src/server.vala"
							_vala_iterable_unref0 (parameters);
#line 23469 "server.c"
						}
					}
				}
			}
#line 2147 "../src/server.vala"
			_g_match_info_unref0 (foreach_match);
#line 2147 "../src/server.vala"
			_g_free0 (representation);
#line 2147 "../src/server.vala"
			_vala_code_node_unref0 (local);
#line 2147 "../src/server.vala"
			_vala_code_node_unref0 (item);
#line 23482 "server.c"
		}
	}
#line 2272 "../src/server.vala"
	vala_code_context_pop ();
#line 23487 "server.c"
	{
		GVariant** array = NULL;
		GVariant** _tmp284_;
		gint array_length1;
		gint _array_size_;
		LspInlayHint** _tmp285_;
		gint _tmp285__length1;
		const GVariantType* _tmp291_;
		GVariant** _tmp292_;
		gint _tmp292__length1;
		GVariant* _tmp293_;
		GVariant* _tmp294_;
		GCancellable* _tmp295_;
#line 2274 "../src/server.vala"
		_tmp284_ = g_new0 (GVariant*, 0 + 1);
#line 2274 "../src/server.vala"
		array = _tmp284_;
#line 2274 "../src/server.vala"
		array_length1 = 0;
#line 2274 "../src/server.vala"
		_array_size_ = array_length1;
#line 2275 "../src/server.vala"
		_tmp285_ = hints;
#line 2275 "../src/server.vala"
		_tmp285__length1 = hints_length1;
#line 23513 "server.c"
		{
			LspInlayHint** hint_collection = NULL;
			gint hint_collection_length1 = 0;
			gint _hint_collection_size_ = 0;
			gint hint_it = 0;
#line 2275 "../src/server.vala"
			hint_collection = _tmp285_;
#line 2275 "../src/server.vala"
			hint_collection_length1 = _tmp285__length1;
#line 2275 "../src/server.vala"
			for (hint_it = 0; hint_it < hint_collection_length1; hint_it = hint_it + 1) {
#line 23525 "server.c"
				LspInlayHint* _tmp286_;
				LspInlayHint* hint = NULL;
#line 2275 "../src/server.vala"
				_tmp286_ = _g_object_ref0 (hint_collection[hint_it]);
#line 2275 "../src/server.vala"
				hint = _tmp286_;
#line 23532 "server.c"
				{
					GVariant* _tmp287_ = NULL;
					LspInlayHint* _tmp288_;
					GVariant* _tmp289_;
					GVariant* _tmp290_;
#line 2276 "../src/server.vala"
					_tmp288_ = hint;
#line 2276 "../src/server.vala"
					_tmp289_ = vls_util_object_to_variant ((GObject*) _tmp288_, &_inner_error0_);
#line 2276 "../src/server.vala"
					_tmp287_ = _tmp289_;
#line 2276 "../src/server.vala"
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2276 "../src/server.vala"
						_g_object_unref0 (hint);
#line 2276 "../src/server.vala"
						array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 23550 "server.c"
						goto __catch0_g_error;
					}
#line 2276 "../src/server.vala"
					_tmp290_ = _tmp287_;
#line 2276 "../src/server.vala"
					_tmp287_ = NULL;
#line 2276 "../src/server.vala"
					_vala_array_add36 (&array, &array_length1, &_array_size_, _tmp290_);
#line 2275 "../src/server.vala"
					_g_variant_unref0 (_tmp287_);
#line 2275 "../src/server.vala"
					_g_object_unref0 (hint);
#line 23563 "server.c"
				}
			}
		}
#line 2277 "../src/server.vala"
		_tmp291_ = G_VARIANT_TYPE_VARDICT;
#line 2277 "../src/server.vala"
		_tmp292_ = array;
#line 2277 "../src/server.vala"
		_tmp292__length1 = array_length1;
#line 2277 "../src/server.vala"
		_tmp293_ = g_variant_new_array (_tmp291_, _tmp292_, _tmp292__length1);
#line 2277 "../src/server.vala"
		g_variant_ref_sink (_tmp293_);
#line 2277 "../src/server.vala"
		_tmp294_ = _tmp293_;
#line 2277 "../src/server.vala"
		_tmp295_ = vls_server_cancellable;
#line 2277 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp294_, _tmp295_, &_inner_error0_);
#line 2277 "../src/server.vala"
		_g_variant_unref0 (_tmp294_);
#line 2277 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2277 "../src/server.vala"
			array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 23589 "server.c"
			goto __catch0_g_error;
		}
#line 2273 "../src/server.vala"
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 23594 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp296_;
		GError* _tmp297_;
		const gchar* _tmp298_;
		const gchar* _tmp299_;
		gchar* _tmp300_;
		gchar* _tmp301_;
#line 2273 "../src/server.vala"
		e = _inner_error0_;
#line 2273 "../src/server.vala"
		_inner_error0_ = NULL;
#line 2279 "../src/server.vala"
		_tmp296_ = string_to_string (method);
#line 2279 "../src/server.vala"
		_tmp297_ = e;
#line 2279 "../src/server.vala"
		_tmp298_ = _tmp297_->message;
#line 2279 "../src/server.vala"
		_tmp299_ = string_to_string (_tmp298_);
#line 2279 "../src/server.vala"
		_tmp300_ = g_strconcat ("[", _tmp296_, "] failed to reply to client: ", _tmp299_, NULL);
#line 2279 "../src/server.vala"
		_tmp301_ = _tmp300_;
#line 2279 "../src/server.vala"
		g_debug ("server.vala:2279: %s", _tmp301_);
#line 2279 "../src/server.vala"
		_g_free0 (_tmp301_);
#line 2273 "../src/server.vala"
		_g_error_free0 (e);
#line 23628 "server.c"
	}
	__finally0:
#line 2273 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2273 "../src/server.vala"
		hints = (_vala_array_free (hints, hints_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2273 "../src/server.vala"
		_vala_code_visitor_unref0 (query);
#line 2273 "../src/server.vala"
		_vala_source_file_unref0 (file);
#line 2273 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2273 "../src/server.vala"
		_g_object_unref0 (p);
#line 2273 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2273 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 2273 "../src/server.vala"
		return;
#line 23649 "server.c"
	}
#line 2125 "../src/server.vala"
	hints = (_vala_array_free (hints, hints_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2125 "../src/server.vala"
	_vala_code_visitor_unref0 (query);
#line 2125 "../src/server.vala"
	_vala_source_file_unref0 (file);
#line 2125 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2125 "../src/server.vala"
	_g_object_unref0 (p);
#line 23661 "server.c"
}

static void
vls_server_prepare_type_hierarchy (VlsServer* self,
                                   JsonrpcClient* client,
                                   const gchar* method,
                                   GVariant* id,
                                   GVariant* params)
{
	LspTextDocumentPositionParams* p = NULL;
	gpointer _tmp0_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTextDocumentPositionParams* _tmp1_;
	LspTextDocumentIdentifier* _tmp2_;
	LspTextDocumentIdentifier* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	VlsCompilation* _tmp6_ = NULL;
	VlsProject* _tmp7_ = NULL;
	ValaSourceFile* _tmp8_;
	ValaSourceFile* _tmp9_;
	VlsCompilation* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaCodeContext* _tmp17_;
	VlsNodeSearch* fs = NULL;
	ValaSourceFile* _tmp18_;
	LspTextDocumentPositionParams* _tmp19_;
	LspPosition* _tmp20_;
	LspPosition* _tmp21_;
	VlsNodeSearch* _tmp22_;
	VlsNodeSearch* _tmp23_;
	GeeList* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	ValaCodeNode* _result_ = NULL;
	VlsNodeSearch* _tmp30_;
	ValaSourceFile* _tmp31_;
	ValaCodeNode* _tmp32_;
	ValaTypeSymbol* type_symbol = NULL;
	ValaCodeNode* _tmp33_;
	GError* _inner_error0_ = NULL;
#line 2283 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 2283 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 2283 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 2283 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 2283 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 2284 "../src/server.vala"
	_tmp0_ = vls_util_parse_variant (LSP_TYPE_TEXT_DOCUMENT_POSITION_PARAMS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, params);
#line 2284 "../src/server.vala"
	p = (LspTextDocumentPositionParams*) _tmp0_;
#line 2288 "../src/server.vala"
	_tmp1_ = p;
#line 2288 "../src/server.vala"
	_tmp2_ = lsp_text_document_position_params_get_textDocument (_tmp1_);
#line 2288 "../src/server.vala"
	_tmp3_ = _tmp2_;
#line 2288 "../src/server.vala"
	_tmp4_ = lsp_text_document_identifier_get_uri (_tmp3_);
#line 2288 "../src/server.vala"
	_tmp5_ = _tmp4_;
#line 2288 "../src/server.vala"
	_tmp8_ = vls_server_find_file (self, _tmp5_, &_tmp6_, &_tmp7_);
#line 2288 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2288 "../src/server.vala"
	compilation = _tmp6_;
#line 2288 "../src/server.vala"
	_g_object_unref0 (project);
#line 2288 "../src/server.vala"
	project = _tmp7_;
#line 2288 "../src/server.vala"
	doc = _tmp8_;
#line 2289 "../src/server.vala"
	_tmp9_ = doc;
#line 2289 "../src/server.vala"
	if (_tmp9_ == NULL) {
#line 23745 "server.c"
		LspTextDocumentPositionParams* _tmp10_;
		LspTextDocumentIdentifier* _tmp11_;
		LspTextDocumentIdentifier* _tmp12_;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
#line 2290 "../src/server.vala"
		_tmp10_ = p;
#line 2290 "../src/server.vala"
		_tmp11_ = lsp_text_document_position_params_get_textDocument (_tmp10_);
#line 2290 "../src/server.vala"
		_tmp12_ = _tmp11_;
#line 2290 "../src/server.vala"
		_tmp13_ = lsp_text_document_identifier_get_uri (_tmp12_);
#line 2290 "../src/server.vala"
		_tmp14_ = _tmp13_;
#line 2290 "../src/server.vala"
		g_debug ("server.vala:2290: [%s] file `%s' not found", method, _tmp14_);
#line 2291 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2292 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2292 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2292 "../src/server.vala"
		_g_object_unref0 (project);
#line 2292 "../src/server.vala"
		_g_object_unref0 (p);
#line 2292 "../src/server.vala"
		return;
#line 23775 "server.c"
	}
#line 2295 "../src/server.vala"
	_tmp15_ = compilation;
#line 2295 "../src/server.vala"
	_tmp16_ = vls_compilation_get_code_context (_tmp15_);
#line 2295 "../src/server.vala"
	_tmp17_ = _tmp16_;
#line 2295 "../src/server.vala"
	vala_code_context_push (_tmp17_);
#line 2297 "../src/server.vala"
	_tmp18_ = doc;
#line 2297 "../src/server.vala"
	_tmp19_ = p;
#line 2297 "../src/server.vala"
	_tmp20_ = lsp_text_document_position_params_get_position (_tmp19_);
#line 2297 "../src/server.vala"
	_tmp21_ = _tmp20_;
#line 2297 "../src/server.vala"
	_tmp22_ = vls_node_search_new (_tmp18_, _tmp21_, FALSE, NULL, TRUE);
#line 2297 "../src/server.vala"
	fs = _tmp22_;
#line 2299 "../src/server.vala"
	_tmp23_ = fs;
#line 2299 "../src/server.vala"
	_tmp24_ = _tmp23_->result;
#line 2299 "../src/server.vala"
	_tmp25_ = gee_collection_get_size ((GeeCollection*) _tmp24_);
#line 2299 "../src/server.vala"
	_tmp26_ = _tmp25_;
#line 2299 "../src/server.vala"
	if (_tmp26_ == 0) {
#line 23807 "server.c"
		const gchar* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 2300 "../src/server.vala"
		_tmp27_ = string_to_string (method);
#line 2300 "../src/server.vala"
		_tmp28_ = g_strconcat ("[", _tmp27_, "] no results found", NULL);
#line 2300 "../src/server.vala"
		_tmp29_ = _tmp28_;
#line 2300 "../src/server.vala"
		g_debug ("server.vala:2300: %s", _tmp29_);
#line 2300 "../src/server.vala"
		_g_free0 (_tmp29_);
#line 2301 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2302 "../src/server.vala"
		vala_code_context_pop ();
#line 2303 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 2303 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2303 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2303 "../src/server.vala"
		_g_object_unref0 (project);
#line 2303 "../src/server.vala"
		_g_object_unref0 (p);
#line 2303 "../src/server.vala"
		return;
#line 23837 "server.c"
	}
#line 2306 "../src/server.vala"
	_tmp30_ = fs;
#line 2306 "../src/server.vala"
	_tmp31_ = doc;
#line 2306 "../src/server.vala"
	_tmp32_ = vls_server_get_best (_tmp30_, _tmp31_);
#line 2306 "../src/server.vala"
	_result_ = _tmp32_;
#line 2307 "../src/server.vala"
	vala_code_context_pop ();
#line 2310 "../src/server.vala"
	_tmp33_ = _result_;
#line 2310 "../src/server.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, VALA_TYPE_TYPESYMBOL)) {
#line 23853 "server.c"
		ValaCodeNode* _tmp34_;
		ValaTypeSymbol* _tmp35_;
#line 2311 "../src/server.vala"
		_tmp34_ = _result_;
#line 2311 "../src/server.vala"
		_tmp35_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
#line 2311 "../src/server.vala"
		_vala_code_node_unref0 (type_symbol);
#line 2311 "../src/server.vala"
		type_symbol = _tmp35_;
#line 23864 "server.c"
	} else {
		gboolean _tmp36_ = FALSE;
		ValaCodeNode* _tmp37_;
#line 2312 "../src/server.vala"
		_tmp37_ = _result_;
#line 2312 "../src/server.vala"
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp37_, VALA_TYPE_DATA_TYPE)) {
#line 23872 "server.c"
			ValaCodeNode* _tmp38_;
			ValaTypeSymbol* _tmp39_;
			ValaTypeSymbol* _tmp40_;
#line 2312 "../src/server.vala"
			_tmp38_ = _result_;
#line 2312 "../src/server.vala"
			_tmp39_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 2312 "../src/server.vala"
			_tmp40_ = _tmp39_;
#line 2312 "../src/server.vala"
			_tmp36_ = _tmp40_ != NULL;
#line 23884 "server.c"
		} else {
#line 2312 "../src/server.vala"
			_tmp36_ = FALSE;
#line 23888 "server.c"
		}
#line 2312 "../src/server.vala"
		if (_tmp36_) {
#line 23892 "server.c"
			ValaCodeNode* _tmp41_;
			ValaTypeSymbol* _tmp42_;
			ValaTypeSymbol* _tmp43_;
			ValaTypeSymbol* _tmp44_;
#line 2313 "../src/server.vala"
			_tmp41_ = _result_;
#line 2313 "../src/server.vala"
			_tmp42_ = vala_data_type_get_type_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_DATA_TYPE, ValaDataType));
#line 2313 "../src/server.vala"
			_tmp43_ = _tmp42_;
#line 2313 "../src/server.vala"
			_tmp44_ = _vala_code_node_ref0 (_tmp43_);
#line 2313 "../src/server.vala"
			_vala_code_node_unref0 (type_symbol);
#line 2313 "../src/server.vala"
			type_symbol = _tmp44_;
#line 23909 "server.c"
		} else {
			gboolean _tmp45_ = FALSE;
			ValaCodeNode* _tmp46_;
#line 2314 "../src/server.vala"
			_tmp46_ = _result_;
#line 2314 "../src/server.vala"
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp46_, VALA_TYPE_EXPRESSION)) {
#line 23917 "server.c"
				ValaCodeNode* _tmp47_;
				ValaSymbol* _tmp48_;
				ValaSymbol* _tmp49_;
#line 2314 "../src/server.vala"
				_tmp47_ = _result_;
#line 2314 "../src/server.vala"
				_tmp48_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 2314 "../src/server.vala"
				_tmp49_ = _tmp48_;
#line 2314 "../src/server.vala"
				_tmp45_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp49_, VALA_TYPE_TYPESYMBOL);
#line 23929 "server.c"
			} else {
#line 2314 "../src/server.vala"
				_tmp45_ = FALSE;
#line 23933 "server.c"
			}
#line 2314 "../src/server.vala"
			if (_tmp45_) {
#line 23937 "server.c"
				ValaCodeNode* _tmp50_;
				ValaSymbol* _tmp51_;
				ValaSymbol* _tmp52_;
				ValaTypeSymbol* _tmp53_;
#line 2315 "../src/server.vala"
				_tmp50_ = _result_;
#line 2315 "../src/server.vala"
				_tmp51_ = vala_expression_get_symbol_reference (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, VALA_TYPE_EXPRESSION, ValaExpression));
#line 2315 "../src/server.vala"
				_tmp52_ = _tmp51_;
#line 2315 "../src/server.vala"
				_tmp53_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
#line 2315 "../src/server.vala"
				_vala_code_node_unref0 (type_symbol);
#line 2315 "../src/server.vala"
				type_symbol = _tmp53_;
#line 23954 "server.c"
				{
					GeeIterator* _pair_it = NULL;
					ValaCodeNode* _tmp54_;
					GeeCollection* _tmp55_;
					GeeCollection* _tmp56_;
					GeeIterator* _tmp57_;
					GeeIterator* _tmp58_;
#line 2317 "../src/server.vala"
					_tmp54_ = _result_;
#line 2317 "../src/server.vala"
					_tmp55_ = vls_symbol_references_get_visible_components_of_code_node (_tmp54_);
#line 2317 "../src/server.vala"
					_tmp56_ = _tmp55_;
#line 2317 "../src/server.vala"
					_tmp57_ = gee_iterable_iterator ((GeeIterable*) _tmp56_);
#line 2317 "../src/server.vala"
					_tmp58_ = _tmp57_;
#line 2317 "../src/server.vala"
					_g_object_unref0 (_tmp56_);
#line 2317 "../src/server.vala"
					_pair_it = _tmp58_;
#line 2317 "../src/server.vala"
					while (TRUE) {
#line 23978 "server.c"
						GeeIterator* _tmp59_;
						VlsPair* pair = NULL;
						GeeIterator* _tmp60_;
						gpointer _tmp61_;
						ValaSymbol* symbol = NULL;
						VlsPair* _tmp62_;
						gconstpointer _tmp63_;
						gconstpointer _tmp64_;
						ValaSymbol* _tmp65_;
						LspRange* range = NULL;
						VlsPair* _tmp66_;
						gconstpointer _tmp67_;
						gconstpointer _tmp68_;
						LspRange* _tmp69_;
						gboolean _tmp70_ = FALSE;
						ValaSymbol* _tmp71_;
#line 2317 "../src/server.vala"
						_tmp59_ = _pair_it;
#line 2317 "../src/server.vala"
						if (!gee_iterator_next (_tmp59_)) {
#line 2317 "../src/server.vala"
							break;
#line 24001 "server.c"
						}
#line 2317 "../src/server.vala"
						_tmp60_ = _pair_it;
#line 2317 "../src/server.vala"
						_tmp61_ = gee_iterator_get (_tmp60_);
#line 2317 "../src/server.vala"
						pair = (VlsPair*) _tmp61_;
#line 2318 "../src/server.vala"
						_tmp62_ = pair;
#line 2318 "../src/server.vala"
						_tmp63_ = vls_pair_get_first (_tmp62_);
#line 2318 "../src/server.vala"
						_tmp64_ = _tmp63_;
#line 2318 "../src/server.vala"
						_tmp65_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp64_);
#line 2318 "../src/server.vala"
						symbol = _tmp65_;
#line 2319 "../src/server.vala"
						_tmp66_ = pair;
#line 2319 "../src/server.vala"
						_tmp67_ = vls_pair_get_second (_tmp66_);
#line 2319 "../src/server.vala"
						_tmp68_ = _tmp67_;
#line 2319 "../src/server.vala"
						_tmp69_ = _g_object_ref0 ((LspRange*) _tmp68_);
#line 2319 "../src/server.vala"
						range = _tmp69_;
#line 2320 "../src/server.vala"
						_tmp71_ = symbol;
#line 2320 "../src/server.vala"
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp71_, VALA_TYPE_TYPESYMBOL)) {
#line 24033 "server.c"
							LspRange* _tmp72_;
							LspTextDocumentPositionParams* _tmp73_;
							LspPosition* _tmp74_;
							LspPosition* _tmp75_;
#line 2320 "../src/server.vala"
							_tmp72_ = range;
#line 2320 "../src/server.vala"
							_tmp73_ = p;
#line 2320 "../src/server.vala"
							_tmp74_ = lsp_text_document_position_params_get_position (_tmp73_);
#line 2320 "../src/server.vala"
							_tmp75_ = _tmp74_;
#line 2320 "../src/server.vala"
							_tmp70_ = lsp_range_contains (_tmp72_, _tmp75_);
#line 24048 "server.c"
						} else {
#line 2320 "../src/server.vala"
							_tmp70_ = FALSE;
#line 24052 "server.c"
						}
#line 2320 "../src/server.vala"
						if (_tmp70_) {
#line 24056 "server.c"
							ValaSymbol* _tmp76_;
							ValaTypeSymbol* _tmp77_;
#line 2321 "../src/server.vala"
							_tmp76_ = symbol;
#line 2321 "../src/server.vala"
							_tmp77_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
#line 2321 "../src/server.vala"
							_vala_code_node_unref0 (type_symbol);
#line 2321 "../src/server.vala"
							type_symbol = _tmp77_;
#line 2322 "../src/server.vala"
							_g_object_unref0 (range);
#line 2322 "../src/server.vala"
							_vala_code_node_unref0 (symbol);
#line 2322 "../src/server.vala"
							_g_object_unref0 (pair);
#line 2322 "../src/server.vala"
							break;
#line 24075 "server.c"
						}
#line 2317 "../src/server.vala"
						_g_object_unref0 (range);
#line 2317 "../src/server.vala"
						_vala_code_node_unref0 (symbol);
#line 2317 "../src/server.vala"
						_g_object_unref0 (pair);
#line 24083 "server.c"
					}
#line 2317 "../src/server.vala"
					_g_object_unref0 (_pair_it);
#line 24087 "server.c"
				}
			} else {
#line 2326 "../src/server.vala"
				vls_server_reply_null (id, client, method);
#line 2327 "../src/server.vala"
				_vala_code_node_unref0 (type_symbol);
#line 2327 "../src/server.vala"
				_vala_code_node_unref0 (_result_);
#line 2327 "../src/server.vala"
				_vala_code_visitor_unref0 (fs);
#line 2327 "../src/server.vala"
				_vala_source_file_unref0 (doc);
#line 2327 "../src/server.vala"
				_g_object_unref0 (compilation);
#line 2327 "../src/server.vala"
				_g_object_unref0 (project);
#line 2327 "../src/server.vala"
				_g_object_unref0 (p);
#line 2327 "../src/server.vala"
				return;
#line 24108 "server.c"
			}
		}
	}
	{
		GVariant* _tmp78_ = NULL;
		ValaTypeSymbol* _tmp79_;
		LspTypeHierarchyItem* _tmp80_;
		LspTypeHierarchyItem* _tmp81_;
		GVariant* _tmp82_;
		GVariant* _tmp83_;
		GVariant* array = NULL;
		GVariant* _tmp84_;
		GVariant** _tmp85_;
		GVariant** _tmp86_;
		gint _tmp86__length1;
		GVariant* _tmp87_;
		GVariant* _tmp88_;
		GVariant* _tmp89_;
		GCancellable* _tmp90_;
#line 2332 "../src/server.vala"
		_tmp79_ = type_symbol;
#line 2332 "../src/server.vala"
		_tmp80_ = lsp_typehierarchy_item_new_from_symbol (_tmp79_);
#line 2332 "../src/server.vala"
		if (_tmp80_) {
#line 2332 "../src/server.vala"
			g_object_set_data ((GObject *) _tmp80_, "vala-creation-function", "Vls.Server.prepare_type_hierarchy");
#line 24136 "server.c"
		}
#line 2332 "../src/server.vala"
		_tmp81_ = _tmp80_;
#line 2332 "../src/server.vala"
		_tmp82_ = vls_util_object_to_variant ((GObject*) _tmp81_, &_inner_error0_);
#line 2332 "../src/server.vala"
		_tmp83_ = _tmp82_;
#line 2332 "../src/server.vala"
		_g_object_unref0 (_tmp81_);
#line 2332 "../src/server.vala"
		_tmp78_ = _tmp83_;
#line 2332 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 24150 "server.c"
			goto __catch0_g_error;
		}
#line 2331 "../src/server.vala"
		_tmp84_ = _tmp78_;
#line 2331 "../src/server.vala"
		_tmp78_ = NULL;
#line 2331 "../src/server.vala"
		_tmp85_ = g_new0 (GVariant*, 1 + 1);
#line 2331 "../src/server.vala"
		_tmp85_[0] = _tmp84_;
#line 2331 "../src/server.vala"
		_tmp86_ = _tmp85_;
#line 2331 "../src/server.vala"
		_tmp86__length1 = 1;
#line 2331 "../src/server.vala"
		_tmp87_ = g_variant_new_array (NULL, _tmp86_, 1);
#line 2331 "../src/server.vala"
		g_variant_ref_sink (_tmp87_);
#line 2331 "../src/server.vala"
		_tmp88_ = _tmp87_;
#line 2331 "../src/server.vala"
		_tmp86_ = (_vala_array_free (_tmp86_, _tmp86__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 2331 "../src/server.vala"
		array = _tmp88_;
#line 2334 "../src/server.vala"
		_tmp89_ = array;
#line 2334 "../src/server.vala"
		_tmp90_ = vls_server_cancellable;
#line 2334 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp89_, _tmp90_, &_inner_error0_);
#line 2334 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2334 "../src/server.vala"
			_g_variant_unref0 (array);
#line 2334 "../src/server.vala"
			_g_variant_unref0 (_tmp78_);
#line 24187 "server.c"
			goto __catch0_g_error;
		}
#line 2330 "../src/server.vala"
		_g_variant_unref0 (array);
#line 2330 "../src/server.vala"
		_g_variant_unref0 (_tmp78_);
#line 24194 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		const gchar* _tmp91_;
		GError* _tmp92_;
		const gchar* _tmp93_;
		const gchar* _tmp94_;
		gchar* _tmp95_;
		gchar* _tmp96_;
#line 2330 "../src/server.vala"
		e = _inner_error0_;
#line 2330 "../src/server.vala"
		_inner_error0_ = NULL;
#line 2336 "../src/server.vala"
		_tmp91_ = string_to_string (method);
#line 2336 "../src/server.vala"
		_tmp92_ = e;
#line 2336 "../src/server.vala"
		_tmp93_ = _tmp92_->message;
#line 2336 "../src/server.vala"
		_tmp94_ = string_to_string (_tmp93_);
#line 2336 "../src/server.vala"
		_tmp95_ = g_strconcat ("[", _tmp91_, "] failed to reply to client: ", _tmp94_, NULL);
#line 2336 "../src/server.vala"
		_tmp96_ = _tmp95_;
#line 2336 "../src/server.vala"
		g_debug ("server.vala:2336: %s", _tmp96_);
#line 2336 "../src/server.vala"
		_g_free0 (_tmp96_);
#line 2330 "../src/server.vala"
		_g_error_free0 (e);
#line 24228 "server.c"
	}
	__finally0:
#line 2330 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2330 "../src/server.vala"
		_vala_code_node_unref0 (type_symbol);
#line 2330 "../src/server.vala"
		_vala_code_node_unref0 (_result_);
#line 2330 "../src/server.vala"
		_vala_code_visitor_unref0 (fs);
#line 2330 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2330 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2330 "../src/server.vala"
		_g_object_unref0 (project);
#line 2330 "../src/server.vala"
		_g_object_unref0 (p);
#line 2330 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2330 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 2330 "../src/server.vala"
		return;
#line 24253 "server.c"
	}
#line 2283 "../src/server.vala"
	_vala_code_node_unref0 (type_symbol);
#line 2283 "../src/server.vala"
	_vala_code_node_unref0 (_result_);
#line 2283 "../src/server.vala"
	_vala_code_visitor_unref0 (fs);
#line 2283 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 2283 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2283 "../src/server.vala"
	_g_object_unref0 (project);
#line 2283 "../src/server.vala"
	_g_object_unref0 (p);
#line 24269 "server.c"
}

static void
_vala_array_add37 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
#line 2365 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2365 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2365 "../src/server.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 24284 "server.c"
	}
#line 2365 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2365 "../src/server.vala"
	(*array)[*length] = NULL;
#line 24290 "server.c"
}

static void
_vala_array_add38 (GVariant** * array,
                   gint* length,
                   gint* size,
                   GVariant* value)
{
#line 2368 "../src/server.vala"
	if ((*length) == (*size)) {
#line 2368 "../src/server.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 2368 "../src/server.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 24305 "server.c"
	}
#line 2368 "../src/server.vala"
	(*array)[(*length)++] = value;
#line 2368 "../src/server.vala"
	(*array)[*length] = NULL;
#line 24311 "server.c"
}

static GVariant*
_variant_new1 (GVariant** value,
               gint value_length1)
{
	GVariant** _tmp49_;
	GVariantBuilder _tmp50_;
	gint _tmp51_;
#line 2371 "../src/server.vala"
	_tmp49_ = value;
#line 2371 "../src/server.vala"
	g_variant_builder_init (&_tmp50_, G_VARIANT_TYPE ("av"));
#line 2371 "../src/server.vala"
	for (_tmp51_ = 0; _tmp51_ < value_length1; _tmp51_++) {
#line 2371 "../src/server.vala"
		g_variant_builder_add_value (&_tmp50_, g_variant_new_variant (*_tmp49_));
#line 2371 "../src/server.vala"
		_tmp49_++;
#line 24331 "server.c"
	}
#line 2371 "../src/server.vala"
	return g_variant_ref_sink (g_variant_builder_end (&_tmp50_));
#line 24335 "server.c"
}

static void
vls_server_show_type_hierarchy (VlsServer* self,
                                JsonrpcClient* client,
                                const gchar* method,
                                GVariant* id,
                                GVariant* params,
                                gboolean supertypes)
{
	GVariant* itemv = NULL;
	const GVariantType* _tmp0_;
	GVariant* _tmp1_;
	LspTypeHierarchyItem* item = NULL;
	GVariant* _tmp2_;
	gpointer _tmp3_;
	VlsProject* project = NULL;
	VlsCompilation* compilation = NULL;
	ValaSourceFile* doc = NULL;
	LspTypeHierarchyItem* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	VlsCompilation* _tmp7_ = NULL;
	VlsProject* _tmp8_ = NULL;
	ValaSourceFile* _tmp9_;
	ValaSourceFile* _tmp10_;
	VlsCompilation* _tmp14_;
	ValaCodeContext* _tmp15_;
	ValaCodeContext* _tmp16_;
	ValaSymbol* symbol = NULL;
	LspTypeHierarchyItem* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	VlsCompilation* _tmp20_;
	ValaCodeContext* _tmp21_;
	ValaCodeContext* _tmp22_;
	ValaNamespace* _tmp23_;
	ValaNamespace* _tmp24_;
	ValaScope* _tmp25_;
	ValaScope* _tmp26_;
	ValaSymbol* _tmp27_;
	ValaSymbol* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 2340 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 2340 "../src/server.vala"
	g_return_if_fail (client != NULL);
#line 2340 "../src/server.vala"
	g_return_if_fail (method != NULL);
#line 2340 "../src/server.vala"
	g_return_if_fail (id != NULL);
#line 2340 "../src/server.vala"
	g_return_if_fail (params != NULL);
#line 2341 "../src/server.vala"
	_tmp0_ = G_VARIANT_TYPE_VARDICT;
#line 2341 "../src/server.vala"
	_tmp1_ = g_variant_lookup_value (params, "item", _tmp0_);
#line 2341 "../src/server.vala"
	itemv = _tmp1_;
#line 2342 "../src/server.vala"
	_tmp2_ = itemv;
#line 2342 "../src/server.vala"
	_tmp3_ = vls_util_parse_variant (LSP_TYPE_TYPEHIERARCHY_ITEM, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _tmp2_);
#line 2342 "../src/server.vala"
	item = (LspTypeHierarchyItem*) _tmp3_;
#line 2346 "../src/server.vala"
	_tmp4_ = item;
#line 2346 "../src/server.vala"
	_tmp5_ = lsp_typehierarchy_item_get_uri (_tmp4_);
#line 2346 "../src/server.vala"
	_tmp6_ = _tmp5_;
#line 2346 "../src/server.vala"
	_tmp9_ = vls_server_find_file (self, _tmp6_, &_tmp7_, &_tmp8_);
#line 2346 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2346 "../src/server.vala"
	compilation = _tmp7_;
#line 2346 "../src/server.vala"
	_g_object_unref0 (project);
#line 2346 "../src/server.vala"
	project = _tmp8_;
#line 2346 "../src/server.vala"
	doc = _tmp9_;
#line 2347 "../src/server.vala"
	_tmp10_ = doc;
#line 2347 "../src/server.vala"
	if (_tmp10_ == NULL) {
#line 24423 "server.c"
		LspTypeHierarchyItem* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 2348 "../src/server.vala"
		_tmp11_ = item;
#line 2348 "../src/server.vala"
		_tmp12_ = lsp_typehierarchy_item_get_uri (_tmp11_);
#line 2348 "../src/server.vala"
		_tmp13_ = _tmp12_;
#line 2348 "../src/server.vala"
		g_debug ("server.vala:2348: [%s] file `%s' not found", method, _tmp13_);
#line 2349 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2350 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2350 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2350 "../src/server.vala"
		_g_object_unref0 (project);
#line 2350 "../src/server.vala"
		_g_object_unref0 (item);
#line 2350 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2350 "../src/server.vala"
		return;
#line 24449 "server.c"
	}
#line 2353 "../src/server.vala"
	_tmp14_ = compilation;
#line 2353 "../src/server.vala"
	_tmp15_ = vls_compilation_get_code_context (_tmp14_);
#line 2353 "../src/server.vala"
	_tmp16_ = _tmp15_;
#line 2353 "../src/server.vala"
	vala_code_context_push (_tmp16_);
#line 2354 "../src/server.vala"
	_tmp17_ = item;
#line 2354 "../src/server.vala"
	_tmp18_ = lsp_typehierarchy_item_get_name (_tmp17_);
#line 2354 "../src/server.vala"
	_tmp19_ = _tmp18_;
#line 2354 "../src/server.vala"
	_tmp20_ = compilation;
#line 2354 "../src/server.vala"
	_tmp21_ = vls_compilation_get_code_context (_tmp20_);
#line 2354 "../src/server.vala"
	_tmp22_ = _tmp21_;
#line 2354 "../src/server.vala"
	_tmp23_ = vala_code_context_get_root (_tmp22_);
#line 2354 "../src/server.vala"
	_tmp24_ = _tmp23_;
#line 2354 "../src/server.vala"
	_tmp25_ = vala_symbol_get_scope ((ValaSymbol*) _tmp24_);
#line 2354 "../src/server.vala"
	_tmp26_ = _tmp25_;
#line 2354 "../src/server.vala"
	_tmp27_ = vls_code_help_lookup_symbol_full_name (_tmp19_, _tmp26_, NULL);
#line 2354 "../src/server.vala"
	symbol = _tmp27_;
#line 2355 "../src/server.vala"
	_tmp28_ = symbol;
#line 2355 "../src/server.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, VALA_TYPE_TYPESYMBOL)) {
#line 2356 "../src/server.vala"
		vala_code_context_pop ();
#line 2357 "../src/server.vala"
		vls_server_reply_null (id, client, method);
#line 2358 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 2358 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2358 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2358 "../src/server.vala"
		_g_object_unref0 (project);
#line 2358 "../src/server.vala"
		_g_object_unref0 (item);
#line 2358 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2358 "../src/server.vala"
		return;
#line 24505 "server.c"
	}
	{
		GVariant** array = NULL;
		GVariant** _tmp29_;
		gint array_length1;
		gint _array_size_;
		GVariant** _tmp48_;
		gint _tmp48__length1;
		GVariant* _tmp52_;
		GCancellable* _tmp53_;
#line 2362 "../src/server.vala"
		_tmp29_ = g_new0 (GVariant*, 0 + 1);
#line 2362 "../src/server.vala"
		array = _tmp29_;
#line 2362 "../src/server.vala"
		array_length1 = 0;
#line 2362 "../src/server.vala"
		_array_size_ = array_length1;
#line 2363 "../src/server.vala"
		if (supertypes) {
#line 24526 "server.c"
			VlsProject* _tmp30_;
			ValaSymbol* _tmp31_;
			gint _tmp32_ = 0;
			LspTypeHierarchyItem** _tmp33_;
#line 2364 "../src/server.vala"
			_tmp30_ = project;
#line 2364 "../src/server.vala"
			_tmp31_ = symbol;
#line 2364 "../src/server.vala"
			_tmp33_ = vls_type_hierarchy_get_supertypes (_tmp30_, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol), &_tmp32_);
#line 24537 "server.c"
			{
				LspTypeHierarchyItem** supertype_collection = NULL;
				gint supertype_collection_length1 = 0;
				gint _supertype_collection_size_ = 0;
				gint supertype_it = 0;
#line 2364 "../src/server.vala"
				supertype_collection = _tmp33_;
#line 2364 "../src/server.vala"
				supertype_collection_length1 = _tmp32_;
#line 2364 "../src/server.vala"
				for (supertype_it = 0; supertype_it < supertype_collection_length1; supertype_it = supertype_it + 1) {
#line 24549 "server.c"
					LspTypeHierarchyItem* _tmp34_;
					LspTypeHierarchyItem* supertype = NULL;
#line 2364 "../src/server.vala"
					_tmp34_ = _g_object_ref0 (supertype_collection[supertype_it]);
#line 2364 "../src/server.vala"
					supertype = _tmp34_;
#line 24556 "server.c"
					{
						GVariant* _tmp35_ = NULL;
						LspTypeHierarchyItem* _tmp36_;
						GVariant* _tmp37_;
						GVariant* _tmp38_;
#line 2365 "../src/server.vala"
						_tmp36_ = supertype;
#line 2365 "../src/server.vala"
						_tmp37_ = vls_util_object_to_variant ((GObject*) _tmp36_, &_inner_error0_);
#line 2365 "../src/server.vala"
						_tmp35_ = _tmp37_;
#line 2365 "../src/server.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2365 "../src/server.vala"
							_g_object_unref0 (supertype);
#line 2365 "../src/server.vala"
							supertype_collection = (_vala_array_free (supertype_collection, supertype_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2365 "../src/server.vala"
							array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 24576 "server.c"
							goto __catch0_g_error;
						}
#line 2365 "../src/server.vala"
						_tmp38_ = _tmp35_;
#line 2365 "../src/server.vala"
						_tmp35_ = NULL;
#line 2365 "../src/server.vala"
						_vala_array_add37 (&array, &array_length1, &_array_size_, _tmp38_);
#line 2364 "../src/server.vala"
						_g_variant_unref0 (_tmp35_);
#line 2364 "../src/server.vala"
						_g_object_unref0 (supertype);
#line 24589 "server.c"
					}
				}
#line 2364 "../src/server.vala"
				supertype_collection = (_vala_array_free (supertype_collection, supertype_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24594 "server.c"
			}
		} else {
			VlsProject* _tmp39_;
			ValaSymbol* _tmp40_;
			gint _tmp41_ = 0;
			LspTypeHierarchyItem** _tmp42_;
#line 2367 "../src/server.vala"
			_tmp39_ = project;
#line 2367 "../src/server.vala"
			_tmp40_ = symbol;
#line 2367 "../src/server.vala"
			_tmp42_ = vls_type_hierarchy_get_subtypes (_tmp39_, G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol), &_tmp41_);
#line 24607 "server.c"
			{
				LspTypeHierarchyItem** subtype_collection = NULL;
				gint subtype_collection_length1 = 0;
				gint _subtype_collection_size_ = 0;
				gint subtype_it = 0;
#line 2367 "../src/server.vala"
				subtype_collection = _tmp42_;
#line 2367 "../src/server.vala"
				subtype_collection_length1 = _tmp41_;
#line 2367 "../src/server.vala"
				for (subtype_it = 0; subtype_it < subtype_collection_length1; subtype_it = subtype_it + 1) {
#line 24619 "server.c"
					LspTypeHierarchyItem* _tmp43_;
					LspTypeHierarchyItem* subtype = NULL;
#line 2367 "../src/server.vala"
					_tmp43_ = _g_object_ref0 (subtype_collection[subtype_it]);
#line 2367 "../src/server.vala"
					subtype = _tmp43_;
#line 24626 "server.c"
					{
						GVariant* _tmp44_ = NULL;
						LspTypeHierarchyItem* _tmp45_;
						GVariant* _tmp46_;
						GVariant* _tmp47_;
#line 2368 "../src/server.vala"
						_tmp45_ = subtype;
#line 2368 "../src/server.vala"
						_tmp46_ = vls_util_object_to_variant ((GObject*) _tmp45_, &_inner_error0_);
#line 2368 "../src/server.vala"
						_tmp44_ = _tmp46_;
#line 2368 "../src/server.vala"
						if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2368 "../src/server.vala"
							_g_object_unref0 (subtype);
#line 2368 "../src/server.vala"
							subtype_collection = (_vala_array_free (subtype_collection, subtype_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 2368 "../src/server.vala"
							array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 24646 "server.c"
							goto __catch0_g_error;
						}
#line 2368 "../src/server.vala"
						_tmp47_ = _tmp44_;
#line 2368 "../src/server.vala"
						_tmp44_ = NULL;
#line 2368 "../src/server.vala"
						_vala_array_add38 (&array, &array_length1, &_array_size_, _tmp47_);
#line 2367 "../src/server.vala"
						_g_variant_unref0 (_tmp44_);
#line 2367 "../src/server.vala"
						_g_object_unref0 (subtype);
#line 24659 "server.c"
					}
				}
#line 2367 "../src/server.vala"
				subtype_collection = (_vala_array_free (subtype_collection, subtype_collection_length1, (GDestroyNotify) g_object_unref), NULL);
#line 24664 "server.c"
			}
		}
#line 2370 "../src/server.vala"
		vala_code_context_pop ();
#line 2371 "../src/server.vala"
		_tmp48_ = array;
#line 2371 "../src/server.vala"
		_tmp48__length1 = array_length1;
#line 2371 "../src/server.vala"
		_tmp52_ = _variant_new1 (_tmp48_, _tmp48__length1);
#line 2371 "../src/server.vala"
		_tmp53_ = vls_server_cancellable;
#line 2371 "../src/server.vala"
		jsonrpc_client_reply (client, id, _tmp52_, _tmp53_, &_inner_error0_);
#line 2371 "../src/server.vala"
		_g_variant_unref0 (_tmp52_);
#line 2371 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2371 "../src/server.vala"
			array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 24685 "server.c"
			goto __catch0_g_error;
		}
#line 2361 "../src/server.vala"
		array = (_vala_array_free (array, array_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 24690 "server.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp54_;
		const gchar* _tmp55_;
#line 2361 "../src/server.vala"
		e = _inner_error0_;
#line 2361 "../src/server.vala"
		_inner_error0_ = NULL;
#line 2373 "../src/server.vala"
		_tmp54_ = e;
#line 2373 "../src/server.vala"
		_tmp55_ = _tmp54_->message;
#line 2373 "../src/server.vala"
		g_debug ("server.vala:2373: [%s] failed to reply to client: %s", method, _tmp55_);
#line 2361 "../src/server.vala"
		_g_error_free0 (e);
#line 24710 "server.c"
	}
	__finally0:
#line 2361 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2361 "../src/server.vala"
		_vala_code_node_unref0 (symbol);
#line 2361 "../src/server.vala"
		_vala_source_file_unref0 (doc);
#line 2361 "../src/server.vala"
		_g_object_unref0 (compilation);
#line 2361 "../src/server.vala"
		_g_object_unref0 (project);
#line 2361 "../src/server.vala"
		_g_object_unref0 (item);
#line 2361 "../src/server.vala"
		_g_variant_unref0 (itemv);
#line 2361 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2361 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 2361 "../src/server.vala"
		return;
#line 24733 "server.c"
	}
#line 2340 "../src/server.vala"
	_vala_code_node_unref0 (symbol);
#line 2340 "../src/server.vala"
	_vala_source_file_unref0 (doc);
#line 2340 "../src/server.vala"
	_g_object_unref0 (compilation);
#line 2340 "../src/server.vala"
	_g_object_unref0 (project);
#line 2340 "../src/server.vala"
	_g_object_unref0 (item);
#line 2340 "../src/server.vala"
	_g_variant_unref0 (itemv);
#line 24747 "server.c"
}

static void
vls_server_shutdown (VlsServer* self)
{
	GCancellable* _tmp0_;
	GHashTable* _tmp1_;
	guint _tmp2_ = 0;
	gconstpointer* _tmp3_;
	guint* _tmp8_;
	gint _tmp8__length1;
#line 2377 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 2378 "../src/server.vala"
	g_debug ("server.vala:2378: shutting down...");
#line 2379 "../src/server.vala"
	self->priv->shutting_down = TRUE;
#line 2380 "../src/server.vala"
	_tmp0_ = vls_server_cancellable;
#line 2380 "../src/server.vala"
	g_cancellable_cancel (_tmp0_);
#line 2381 "../src/server.vala"
	if (self->priv->client_closed_event_id != ((gulong) 0)) {
#line 2382 "../src/server.vala"
		g_signal_handler_disconnect ((GObject*) self, self->priv->client_closed_event_id);
#line 24773 "server.c"
	}
#line 2383 "../src/server.vala"
	_tmp1_ = self->priv->projects;
#line 2383 "../src/server.vala"
	_tmp3_ = g_hash_table_get_keys_as_array (_tmp1_, &_tmp2_);
#line 24779 "server.c"
	{
		VlsProject** project_collection = NULL;
		gint project_collection_length1 = 0;
		gint _project_collection_size_ = 0;
		gint project_it = 0;
#line 2383 "../src/server.vala"
		project_collection = _tmp3_;
#line 2383 "../src/server.vala"
		project_collection_length1 = _tmp2_;
#line 2383 "../src/server.vala"
		for (project_it = 0; project_it < project_collection_length1; project_it = project_it + 1) {
#line 24791 "server.c"
			VlsProject* project = NULL;
#line 2383 "../src/server.vala"
			project = project_collection[project_it];
#line 24795 "server.c"
			{
				VlsProject* _tmp4_;
				GHashTable* _tmp5_;
				VlsProject* _tmp6_;
				gconstpointer _tmp7_;
#line 2384 "../src/server.vala"
				_tmp4_ = project;
#line 2384 "../src/server.vala"
				_tmp5_ = self->priv->projects;
#line 2384 "../src/server.vala"
				_tmp6_ = project;
#line 2384 "../src/server.vala"
				_tmp7_ = g_hash_table_lookup (_tmp5_, _tmp6_);
#line 2384 "../src/server.vala"
				g_signal_handler_disconnect ((GObject*) _tmp4_, (gulong) ((guintptr) _tmp7_));
#line 24811 "server.c"
			}
		}
#line 2383 "../src/server.vala"
		project_collection = (g_free (project_collection), NULL);
#line 24816 "server.c"
	}
#line 2385 "../src/server.vala"
	_tmp8_ = self->priv->g_sources;
#line 2385 "../src/server.vala"
	_tmp8__length1 = self->priv->g_sources_length1;
#line 24822 "server.c"
	{
		guint* source_id_collection = NULL;
		gint source_id_collection_length1 = 0;
		gint _source_id_collection_size_ = 0;
		gint source_id_it = 0;
#line 2385 "../src/server.vala"
		source_id_collection = _tmp8_;
#line 2385 "../src/server.vala"
		source_id_collection_length1 = _tmp8__length1;
#line 2385 "../src/server.vala"
		for (source_id_it = 0; source_id_it < source_id_collection_length1; source_id_it = source_id_it + 1) {
#line 24834 "server.c"
			guint source_id = 0U;
#line 2385 "../src/server.vala"
			source_id = source_id_collection[source_id_it];
#line 24838 "server.c"
			{
#line 2386 "../src/server.vala"
				g_source_remove (source_id);
#line 24842 "server.c"
			}
		}
	}
}

static void
vls_server_exit (VlsServer* self)
{
	GMainLoop* _tmp0_;
#line 2389 "../src/server.vala"
	g_return_if_fail (self != NULL);
#line 2390 "../src/server.vala"
	_tmp0_ = self->priv->loop;
#line 2390 "../src/server.vala"
	g_main_loop_quit (_tmp0_);
#line 24858 "server.c"
}

static void
_vls_server___lambda77_ (void)
{
#line 73 "../src/server.vala"
	vls_server_received_signal = TRUE;
#line 24866 "server.c"
}

static void
__vls_server___lambda77____sighandler_t (gint signum)
{
#line 72 "../src/server.vala"
	_vls_server___lambda77_ ();
#line 24874 "server.c"
}

static void
_vls_server___lambda78_ (void)
{
#line 76 "../src/server.vala"
	vls_server_received_signal = TRUE;
#line 24882 "server.c"
}

static void
__vls_server___lambda78____sighandler_t (gint signum)
{
#line 75 "../src/server.vala"
	_vls_server___lambda78_ ();
#line 24890 "server.c"
}

static void
vls_server_class_init (VlsServerClass * klass,
                       gpointer klass_data)
{
	GCancellable* _tmp0_;
#line 23 "../src/server.vala"
	vls_server_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/server.vala"
	g_type_class_adjust_private_offset (klass, &VlsServer_private_offset);
#line 23 "../src/server.vala"
	((JsonrpcServerClass *) klass)->notification = (void (*) (JsonrpcServer*, JsonrpcClient*, const gchar*, GVariant*)) vls_server_real_notification;
#line 23 "../src/server.vala"
	((JsonrpcServerClass *) klass)->handle_call = (gboolean (*) (JsonrpcServer*, JsonrpcClient*, const gchar*, GVariant*, GVariant*)) vls_server_real_handle_call;
#line 23 "../src/server.vala"
	((JsonrpcServerClass *) klass)->client_closed = (void (*) (JsonrpcServer*, JsonrpcClient*)) vls_server_real_client_closed;
#line 23 "../src/server.vala"
	G_OBJECT_CLASS (klass)->finalize = vls_server_finalize;
#line 46 "../src/server.vala"
	_tmp0_ = g_cancellable_new ();
#line 46 "../src/server.vala"
	if (_tmp0_) {
#line 46 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp0_, "vala-creation-function", "");
#line 24916 "server.c"
	}
#line 46 "../src/server.vala"
	vls_server_cancellable = _tmp0_;
#line 72 "../src/server.vala"
	signal (SIGINT, __vls_server___lambda77____sighandler_t);
#line 75 "../src/server.vala"
	signal (SIGTERM, __vls_server___lambda78____sighandler_t);
#line 24924 "server.c"
}

static void
vls_server_instance_init (VlsServer * self,
                          gpointer klass)
{
	guint* _tmp0_;
	GeeHashSet* _tmp1_;
	GeeHashSet* _tmp2_;
	VlsFileCache* _tmp3_;
#line 23 "../src/server.vala"
	self->priv = vls_server_get_instance_private (self);
#line 41 "../src/server.vala"
	self->priv->shutting_down = FALSE;
#line 48 "../src/server.vala"
	_tmp0_ = g_new0 (guint, 0);
#line 48 "../src/server.vala"
	self->priv->g_sources = _tmp0_;
#line 48 "../src/server.vala"
	self->priv->g_sources_length1 = 0;
#line 48 "../src/server.vala"
	self->priv->_g_sources_size_ = self->priv->g_sources_length1;
#line 58 "../src/server.vala"
	_tmp1_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 58 "../src/server.vala"
	if (_tmp1_) {
#line 58 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp1_, "vala-creation-function", "");
#line 24953 "server.c"
	}
#line 58 "../src/server.vala"
	self->priv->discarded_files = _tmp1_;
#line 63 "../src/server.vala"
	_tmp2_ = gee_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 63 "../src/server.vala"
	if (_tmp2_) {
#line 63 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp2_, "vala-creation-function", "");
#line 24963 "server.c"
	}
#line 63 "../src/server.vala"
	self->priv->open_files = _tmp2_;
#line 69 "../src/server.vala"
	_tmp3_ = vls_file_cache_new ();
#line 69 "../src/server.vala"
	if (_tmp3_) {
#line 69 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp3_, "vala-creation-function", "");
#line 24973 "server.c"
	}
#line 69 "../src/server.vala"
	self->priv->file_cache = _tmp3_;
#line 626 "../src/server.vala"
	self->priv->update_context_client = NULL;
#line 627 "../src/server.vala"
	self->priv->update_context_requests = (gint64) 0;
#line 628 "../src/server.vala"
	self->priv->update_context_time_us = (gint64) 0;
#line 24983 "server.c"
}

static void
vls_server_finalize (GObject * obj)
{
	VlsServer * self;
#line 23 "../src/server.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VLS_TYPE_SERVER, VlsServer);
#line 25 "../src/server.vala"
	_g_main_loop_unref0 (self->priv->loop);
#line 27 "../src/server.vala"
	_g_object_unref0 (self->priv->init_params);
#line 37 "../src/server.vala"
	_vls_gir_documentation_unref0 (self->priv->documentation);
#line 39 "../src/server.vala"
	_g_object_unref0 (self->priv->pending_requests);
#line 48 "../src/server.vala"
	self->priv->g_sources = (g_free (self->priv->g_sources), NULL);
#line 50 "../src/server.vala"
	_g_hash_table_unref0 (self->priv->projects);
#line 51 "../src/server.vala"
	_g_object_unref0 (self->priv->default_project);
#line 58 "../src/server.vala"
	_g_object_unref0 (self->priv->discarded_files);
#line 63 "../src/server.vala"
	_g_object_unref0 (self->priv->open_files);
#line 69 "../src/server.vala"
	_g_object_unref0 (self->priv->file_cache);
#line 626 "../src/server.vala"
	_g_object_unref0 (self->priv->update_context_client);
#line 23 "../src/server.vala"
	G_OBJECT_CLASS (vls_server_parent_class)->finalize (obj);
#line 25016 "server.c"
}

 G_GNUC_NO_INLINE static GType
vls_server_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (VlsServerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vls_server_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (VlsServer), 0, (GInstanceInitFunc) vls_server_instance_init, NULL };
	GType vls_server_type_id;
	vls_server_type_id = g_type_register_static (jsonrpc_server_get_type (), "VlsServer", &g_define_type_info, 0);
	VlsServer_private_offset = g_type_add_instance_private (vls_server_type_id, sizeof (VlsServerPrivate));
	return vls_server_type_id;
}

GType
vls_server_get_type (void)
{
	static gsize vls_server_type_id__once = 0;
	if (g_once_init_enter (&vls_server_type_id__once)) {
		GType vls_server_type_id;
		vls_server_type_id = vls_server_get_type_once ();
		g_once_init_leave (&vls_server_type_id__once, vls_server_type_id);
	}
	return vls_server_type_id__once;
}

static gint
_vala_main (gchar** args,
            gint args_length1)
{
	GOptionContext* ocontext = NULL;
	GOptionContext* _tmp0_;
	GOptionContext* _tmp1_;
	GOptionContext* _tmp2_;
	GOptionContext* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GMainLoop* loop = NULL;
	GMainLoop* _tmp15_;
	GMainLoop* _tmp16_;
	VlsServer* _tmp17_;
	VlsServer* _tmp18_;
	GMainLoop* _tmp19_;
	GError* _inner_error0_ = NULL;
	gint result;
#line 2405 "../src/server.vala"
	g_set_prgname ("vala-language-server");
#line 2406 "../src/server.vala"
	_tmp0_ = g_option_context_new ("- vala-language-server");
#line 2406 "../src/server.vala"
	ocontext = _tmp0_;
#line 2407 "../src/server.vala"
	_tmp1_ = ocontext;
#line 2407 "../src/server.vala"
	g_option_context_add_main_entries (_tmp1_, entries, NULL);
#line 2408 "../src/server.vala"
	_tmp2_ = ocontext;
#line 2408 "../src/server.vala"
	g_option_context_set_summary (_tmp2_, "A language server for Vala");
#line 2409 "../src/server.vala"
	_tmp3_ = ocontext;
#line 2409 "../src/server.vala"
	_tmp4_ = string_to_string (CONFIG_PROJECT_BUGSITE);
#line 2409 "../src/server.vala"
	_tmp5_ = g_strconcat ("Report bugs to ", _tmp4_, NULL);
#line 2409 "../src/server.vala"
	_tmp6_ = _tmp5_;
#line 2409 "../src/server.vala"
	g_option_context_set_description (_tmp3_, _tmp6_);
#line 2409 "../src/server.vala"
	_g_free0 (_tmp6_);
#line 25087 "server.c"
	{
		GOptionContext* _tmp7_;
#line 2411 "../src/server.vala"
		_tmp7_ = ocontext;
#line 2411 "../src/server.vala"
		g_option_context_parse (_tmp7_, (gint*) (&args_length1), &args, &_inner_error0_);
#line 2411 "../src/server.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25096 "server.c"
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		FILE* _tmp8_;
		GError* _tmp9_;
		const gchar* _tmp10_;
		FILE* _tmp11_;
		const gchar* _tmp12_;
#line 2410 "../src/server.vala"
		e = _inner_error0_;
#line 2410 "../src/server.vala"
		_inner_error0_ = NULL;
#line 2413 "../src/server.vala"
		_tmp8_ = stderr;
#line 2413 "../src/server.vala"
		_tmp9_ = e;
#line 2413 "../src/server.vala"
		_tmp10_ = _tmp9_->message;
#line 2413 "../src/server.vala"
		fprintf (_tmp8_, "%s\n", _tmp10_);
#line 2414 "../src/server.vala"
		_tmp11_ = stderr;
#line 2414 "../src/server.vala"
		_tmp12_ = args[0];
#line 2414 "../src/server.vala"
		fprintf (_tmp11_, "Run '%s --version' to print version, or no arguments to run the langua" \
"ge server.\n", _tmp12_);
#line 2415 "../src/server.vala"
		result = 1;
#line 2415 "../src/server.vala"
		_g_error_free0 (e);
#line 2415 "../src/server.vala"
		_g_option_context_free0 (ocontext);
#line 2415 "../src/server.vala"
		return result;
#line 25135 "server.c"
	}
	__finally0:
#line 2410 "../src/server.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 25140 "server.c"
		gint _tmp13_ = -1;
#line 2410 "../src/server.vala"
		_g_option_context_free0 (ocontext);
#line 2410 "../src/server.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 2410 "../src/server.vala"
		g_clear_error (&_inner_error0_);
#line 2410 "../src/server.vala"
		return _tmp13_;
#line 25150 "server.c"
	}
#line 2418 "../src/server.vala"
	if (opt_version) {
#line 25154 "server.c"
		FILE* _tmp14_;
#line 2419 "../src/server.vala"
		_tmp14_ = stdout;
#line 2419 "../src/server.vala"
		fprintf (_tmp14_, "%s %s\n", CONFIG_PROJECT_NAME, CONFIG_PROJECT_VERSION);
#line 2420 "../src/server.vala"
		result = 1;
#line 2420 "../src/server.vala"
		_g_option_context_free0 (ocontext);
#line 2420 "../src/server.vala"
		return result;
#line 25166 "server.c"
	}
#line 2424 "../src/server.vala"
	_tmp15_ = g_main_loop_new (NULL, FALSE);
#line 2424 "../src/server.vala"
	loop = _tmp15_;
#line 2425 "../src/server.vala"
	_tmp16_ = loop;
#line 2425 "../src/server.vala"
	_tmp17_ = vls_server_new (_tmp16_);
#line 2425 "../src/server.vala"
	if (_tmp17_) {
#line 2425 "../src/server.vala"
		g_object_set_data ((GObject *) _tmp17_, "vala-creation-function", "main");
#line 25180 "server.c"
	}
#line 2425 "../src/server.vala"
	_tmp18_ = _tmp17_;
#line 2425 "../src/server.vala"
	_g_object_unref0 (_tmp18_);
#line 2426 "../src/server.vala"
	_tmp19_ = loop;
#line 2426 "../src/server.vala"
	g_main_loop_run (_tmp19_);
#line 2427 "../src/server.vala"
	result = 0;
#line 2427 "../src/server.vala"
	_g_main_loop_unref0 (loop);
#line 2427 "../src/server.vala"
	_g_option_context_free0 (ocontext);
#line 2427 "../src/server.vala"
	return result;
#line 25198 "server.c"
}

int
main (int argc,
      char ** argv)
{
#line 2404 "../src/server.vala"
	return _vala_main (argv, argc);
#line 25207 "server.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

